/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME gDialog
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS gDialog 
/*------------------------------------------------------------------------

  File: 

  Description: from cntnrdlg.w - ADM2 SmartDialog Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

DEF OUTPUT PARAMETER needRefresh AS LOGICAL INIT NO.

/* Local Variable Definitions ---                                       */

DEFINE VARIABLE selectedRoomType AS INTEGER INIT ?.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&Scoped-define DATA-FIELD-DEFS ~
   FIELD id   AS INTEGER ~
   FIELD parent_id   AS INTEGER ~
   FIELD dsc AS CHARACTER ~


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartDialog
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER DIALOG-BOX

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME gDialog

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS floor firstRoom lastRoom roomActive Btn_OK ~
Btn_Cancel 
&Scoped-Define DISPLAYED-OBJECTS floor firstRoom lastRoom roomActive 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */


/* Define a dialog box                                                  */

/* Definitions of handles for SmartObjects                              */
DEFINE VARIABLE h_roomtypedo AS HANDLE NO-UNDO.
DEFINE VARIABLE h_ftreefr0 AS HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON Btn_Cancel AUTO-END-KEY 
     LABEL "Cancel" 
     SIZE 15 BY 1.14.

DEFINE BUTTON Btn_OK AUTO-GO 
     LABEL "Add room(s)" 
     SIZE 17 BY 1.14.

DEFINE VARIABLE firstRoom AS INTEGER FORMAT ">>>>9":U INITIAL 0 
     LABEL "First Room" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE floor AS INTEGER FORMAT "->>9":U INITIAL 0 
     LABEL "Floor" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE lastRoom AS INTEGER FORMAT ">>>>9":U INITIAL 0 
     LABEL "Last Room" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE roomActive AS LOGICAL INITIAL yes 
     LABEL "" 
     VIEW-AS TOGGLE-BOX
     SIZE 6 BY .81 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME gDialog
     floor AT ROW 1.48 COL 13 COLON-ALIGNED WIDGET-ID 2
     firstRoom AT ROW 2.95 COL 13 COLON-ALIGNED WIDGET-ID 4
     lastRoom AT ROW 4.43 COL 13 COLON-ALIGNED WIDGET-ID 6
     roomActive AT ROW 5.81 COL 15 WIDGET-ID 10
     Btn_OK AT ROW 8.67 COL 2
     Btn_Cancel AT ROW 8.67 COL 21
     "Room Type:" VIEW-AS TEXT
          SIZE 12 BY .62 AT ROW 1.67 COL 32.8 WIDGET-ID 8
     "Active:" VIEW-AS TEXT
          SIZE 6.8 BY .62 AT ROW 5.86 COL 7.8 WIDGET-ID 12
     SPACE(73.59) SKIP(3.84)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         FONT 8
         TITLE "Add Rooms"
         DEFAULT-BUTTON Btn_OK CANCEL-BUTTON Btn_Cancel WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartDialog
   Allow: Basic,Browse,DB-Fields,Query,Smart
   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB gDialog 
/* ************************* Included-Libraries *********************** */

{src/adm2/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX gDialog
   FRAME-NAME                                                           */
ASSIGN 
       FRAME gDialog:SCROLLABLE       = FALSE
       FRAME gDialog:HIDDEN           = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK DIALOG-BOX gDialog
/* Query rebuild information for DIALOG-BOX gDialog
     _Options          = "SHARE-LOCK"
     _Query            is NOT OPENED
*/  /* DIALOG-BOX gDialog */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createObjects fFrameWin
PROCEDURE createObjects :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:
  Notes:
------------------------------------------------------------------------------*/
   {set RunDOOptions 'SourceSearch'}.

   RUN adm-create-objects.

  /* Code placed here will execute AFTER standard behavior.    */

   {set AcSurveyCode    'room-type'   h_ftreefr0}.
   {set AcSurveyDesc    'description' h_ftreefr0}.
   {set AcIdFieldName   'room-type'   h_ftreefr0}.
   {set AcTextFieldName 'description'   h_ftreefr0}.
   {set AcParentIdFieldName 'parent-type' h_ftreefr0}.

   {set AcTreeMode    'DEFN' h_ftreefr0}.
   {set AlAutoSelectRootNodeOnOpen no h_ftreefr0}.

END PROCEDURE.


/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME gDialog
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL gDialog gDialog
ON WINDOW-CLOSE OF FRAME gDialog /* Add Rooms */
DO:  
  /* Add Trigger to equate WINDOW-CLOSE to END-ERROR. */
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_OK
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_OK gDialog
ON CHOOSE OF Btn_OK IN FRAME gDialog /* Add room(s) */
DO:
   IF selectedRoomType = ? THEN DO:
      MESSAGE "Select Room Type!" VIEW-AS ALERT-BOX ERROR TITLE "No room type specified".
      RETURN NO-APPLY.
   END.

   DEF VAR firstVal AS INTEGER.
   DEF VAR lastVal AS INTEGER.
   DEF VAR i AS INTEGER.
   DEF VAR roomsCreated AS INTEGER.

   firstVal = firstRoom:INPUT-VALUE.
   lastVal = lastRoom:INPUT-VALUE.
   
   IF lastVal < firstVal THEN DO:
      MESSAGE "Last Room shouldn't be less than the First Room!" 
         VIEW-AS ALERT-BOX ERROR TITLE "Invalid rooms span".
      return no-apply.
   END.

   roomsCreated = 0.
   REPEAT i = firstVal TO lastVal:
      FIND FIRST room WHERE room.room-num = i NO-ERROR.   
      IF AVAIL(room) THEN DO:
         MESSAGE "Room " + STRING(i) + " already exist!" 
            VIEW-AS ALERT-BOX WARNING TITLE "Room already exist".
         NEXT.
      END.

      CREATE room.
      ASSIGN room.room-num = i
             room.floor = (floor:INPUT-VALUE in frame gDialog)
             room.room-type = selectedRoomType.
             room.active = roomActive:INPUT-VALUE.

      roomsCreated = roomsCreated + 1.
   END.

   IF roomsCreated = 0 THEN DO:
      MESSAGE "No rooms were created!" 
            VIEW-AS ALERT-BOX ERROR TITLE "No rooms were created".
      return no-apply.
   END.
   ELSE DO:
      MESSAGE STRING(roomsCreated) + " room(s) were created!" 
         VIEW-AS ALERT-BOX INFORMATION TITLE "Rooms successfully created".
      needRefresh = YES.
   END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK gDialog 


/* ***************************  Main Block  *************************** */

{src/adm2/dialogmn.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects gDialog  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/
  DEFINE VARIABLE currentPage  AS INTEGER NO-UNDO.

  ASSIGN currentPage = getCurrentPage().

  CASE currentPage: 

    WHEN 0 THEN DO:
       RUN constructObject (
             INPUT  'roomtypedo.wDB-AWARE':U ,
             INPUT  FRAME gDialog:HANDLE ,
             INPUT  'AppServiceASUsePromptASInfoForeignFieldsRowsToBatch500CheckCurrentChangedyesRebuildOnReposnoServerOperatingModeNONEDestroyStatelessnoDisconnectAppServernoObjectNamefsurvdo0':U ,
             OUTPUT h_roomtypedo ).

       RUN constructObject (
             INPUT  'ftreefr0.w':U ,
             INPUT  FRAME gDialog:HANDLE ,
             INPUT  'HideOnInitnoDisableOnInitnoObjectLayout':U ,
             OUTPUT h_ftreefr0 ).
       RUN repositionObject IN h_ftreefr0 ( 1.48 , 45.2 ) NO-ERROR.
       RUN resizeObject IN h_ftreefr0 ( 6.67 , 40.2 ) NO-ERROR.

       /* Adjust the tab order of the smart objects. */
       RUN adjustTabOrder ( h_ftreefr0 ,
             lastRoom:HANDLE , 'AFTER':U ).

       RUN addLink ( h_roomtypedo, 'Data':U, h_ftreefr0 ).
       RUN addLink ( h_ftreefr0, 'PSurveyCode':U, h_roomtypedo ).
       RUN addLink ( h_ftreefr0, 'PEVENTTreeClick':U, THIS-PROCEDURE ).
    END. /* Page 0 */

  END CASE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI gDialog  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME gDialog.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI gDialog  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY floor firstRoom lastRoom roomActive 
      WITH FRAME gDialog.
  ENABLE floor firstRoom lastRoom roomActive Btn_OK Btn_Cancel 
      WITH FRAME gDialog.
  VIEW FRAME gDialog.
  {&OPEN-BROWSERS-IN-QUERY-gDialog}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PEVENTTreeClick gDialog  _DEFAULT-ENABLE
PROCEDURE PEVENTTreeClick:
/*------------------------------------------------------------------------------
  Purpose:     Tree event handle. Receives RowObjId of the selected record.
  Parameters:  <none>
  Notes:
------------------------------------------------------------------------------*/
    DEF INPUT PARAMETER nodeKey AS CHARACTER.
    DEF VAR rtype AS INTEGER.

    DYNAMIC-FUNCTION("fetchRowIdent" IN h_roomtypedo, nodeKey, "").
    selectedRoomType = INTEGER(DYNAMIC-FUNCTION("columnValue" IN h_roomtypedo, "room-type")).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

