   DEF VAR isReservation AS LOGICAL.
   DEF VAR price AS INTEGER.
   DEF VAR err AS CHAR. 
   RUN calc-price(OUTPUT price, OUTPUT err).

   isReservation = {1}.

   IF price = ? THEN DO:
      MESSAGE err VIEW-AS ALERT-BOX ERROR TITLE "Price calculation error".
      RETURN NO-APPLY.
   END.

   DEF VAR date1 AS DATE.
   DEF VAR date2 AS DATE.
   def var num as int.
   date1 = startDate:INPUT-VALUE in frame gDialog.
   date2 = endDate:INPUT-VALUE in frame gDialog.
   num = roomNumber:INPUT-VALUE in frame gDialog.

   if isReservation then do:
      FIND FIRST xreservation NO-LOCK 
         WHERE xreservation.room-num = num AND 
         NOT (xreservation.end-date <= date1 OR date2 <= xreservation.start-date) and
         (IF recordRid <> ? THEN ROWID(xreservation) <> recordRid ELSE TRUE) NO-ERROR.

      IF AVAIL(xreservation) THEN DO:
         MESSAGE "This room is already reserved for these dates!"
          VIEW-AS ALERT-BOX ERROR TITLE "Room already reserved".
         RETURN NO-APPLY.
      END.
   end.
   else do:
      for each xreservation NO-LOCK 
        WHERE xreservation.room-num = num AND 
        NOT (xreservation.end-date <= date1 OR date2 <= xreservation.start-date):
           
           if trim(xreservation.guest) <> trim(stay-guest-name) then do:
              MESSAGE "This room is already reserved for these dates by " + xreservation.guest + "! Do you want to update accomodation anyway?" 
                VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO TITLE "Check-in confirmation" update ret as logical.
              if not ret then RETURN NO-APPLY.          
	   end.	
      end.		
   end.
   
   FIND FIRST xstay NO-LOCK 
      WHERE xstay.room-num = num AND 
      NOT (xstay.end-date <= date1 OR date2 <= xstay.start-date) and
      (IF NOT isReservation AND recordRid <> ? THEN 
         ROWID(xstay) <> recordRid ELSE TRUE)
      NO-ERROR.
   
   IF AVAIL(xstay) THEN DO:
      MESSAGE "There is already an accomodation for these dates!"
          VIEW-AS ALERT-BOX ERROR TITLE "Rooms is busy".
      RETURN NO-APPLY.
   END.
