&Scoped-define WINDOW-NAME CURRENT-WINDOW
/*

This code was donated by a customer that wrote an ADM2/SDO version of a tree control
that uses images to draw the tree. The tree model is based on an SDO.

Much of this code still may have some names that existed in the customer code, which
means that these are not very descriptive for a generic tree control.

This object must be initialised after the SDO object to which it is linked (i.e. must
be lower on the frame of the container).

*/
 
/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */
CREATE WIDGET-POOL.
/* ***************************  Definitions  ************************** */
/* Parameters Definitions ---                                           */
DEFINE NEW GLOBAL SHARED VARIABLE GoisDebug                 AS CHAR             NO-UNDO.
DEFINE NEW GLOBAL SHARED VARIABLE GhDebugWindowProc         AS HANDLE           NO-UNDO.
/* Images for nodes default to 1 and 2 - can change with {set} on AiImage/AiSelectedImage */
DEFINE VARIABLE AiImage              AS INT INIT 1      NO-UNDO.
DEFINE VARIABLE AiSelectedImage      AS INT INIT 2      NO-UNDO.
DEFINE VARIABLE AiLeafImage          AS INT INIT 3      NO-UNDO.
DEFINE VARIABLE AiLeafSelImage       AS INT INIT 4      NO-UNDO.
DEFINE VARIABLE AlSecurityCheck      AS LOGICAL         NO-UNDO.
DEFINE VARIABLE AlTreeInitialized    AS LOG    INIT FALSE  NO-UNDO.
/* Signal whether we're in 'SmartDataBrowse' mode i.e. with a data source
   object which we 'browse' using the tree */
DEFINE VARIABLE LlSDBMode              AS LOG INITIAL FALSE NO-UNDO.
DEFINE VARIABLE AcIdFieldName          AS CHAR              NO-UNDO.
DEFINE VARIABLE AcparentIdFieldName    AS CHAR              NO-UNDO.
DEFINE VARIABLE AcTextFieldName        AS CHAR              NO-UNDO.
DEFINE VARIABLE AlAutoExpandAllNodes   AS LOG INIT no       NO-UNDO.
DEFINE VARIABLE AlAutoSortAllNodes     AS LOG INIT YES      NO-UNDO.
DEFINE VARIABLE AcSurveyCode           AS CHAR              NO-UNDO.
DEFINE VARIABLE AcSurveyDesc           AS CHARACTER         NO-UNDO.
DEFINE VARIABLE AcSurveyActive         AS CHAR              NO-UNDO.
DEFINE VARIABLE AcLevelActive          AS CHAR              NO-UNDO.
DEFINE VARIABLE AcLevelLeaf            AS CHARACTER         NO-UNDO.
DEFINE VARIABLE LhLevelData            AS HANDLE            NO-UNDO.
DEFINE VARIABLE AcLevelHandle          AS HANDLE            NO-UNDO.
DEFINE VARIABLE LcIdList               AS CHARACTER         NO-UNDO.
DEFINE VARIABLE LhContainerSource      AS HANDLE            NO-UNDO.
DEFINE VARIABLE LcCurrentSet           AS CHARACTER         NO-UNDO.
DEFINE VARIABLE LcOldSet               AS CHARACTER         NO-UNDO.
DEFINE VARIABLE LcNodeKey              AS CHARACTER         NO-UNDO.
DEFINE VARIABLE LcLevelCode            AS CHARACTER         NO-UNDO.
DEFINE VARIABLE LcTreeMode             AS CHARACTER         NO-UNDO.
DEFINE VARIABLE AlAutoSelectRootNodeOnOpen  AS LOG INIT yes  NO-UNDO.
DEFINE VARIABLE LcCurrentRowIdent           AS CHAR             NO-UNDO.
DEFINE VARIABLE LlTransactionCompleted      AS LOG INIT FALSE   NO-UNDO.
DEFINE VARIABLE LcUserSecurityProfileList   AS CHARACTER        NO-UNDO.
DEFINE TEMP-TABLE ttNode
    FIELD id            AS CHAR
    FIELD parentId      AS CHAR
    FIELD nodeText      AS CHAR
    FIELD RowIdent      AS CHAR
    FIELD SecurityLevel AS CHAR
    FIELD ImageName     AS CHAR
    FIELD active        AS CHAR
    FIELD usercode      AS CHAR
    FIELD InstanceSeqNo AS INT
    
    /* For Progress Tree */
    FIELD nodeTextHandle AS HANDLE
    FIELD nodeOpenerImageHandle AS HANDLE
    FIELD nodeFrameHandle AS HANDLE
    /*
    INDEX parentIdSeqNo parentId InstanceSeqNo usercode
    INDEX parentId parentId usercode
    */
    INDEX id id
    /*INDEX rowIdent rowIdent*/
    .
/* ********************  Preprocessor Definitions  ******************** */
&Scoped-define PROCEDURE-TYPE SmartFrame
&Scoped-define DB-AWARE no
&Scoped-define ADM-CONTAINER FRAME
&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target
/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME fTreeViewParent

/* ************************  Function Prototypes ********************** */
FUNCTION FcGetRowToPositionAfterDelete RETURNS CHARACTER
  ( /* parameter-definitions */ )  FORWARD.
FUNCTION FcNodeImageName RETURNS CHARACTER
  ( BUFFER ttNode FOR ttNode )  FORWARD.
FUNCTION FlIsNodeExpanded RETURNS LOGICAL
  ( INPUT IcNodeKey         AS CHAR )  FORWARD.
FUNCTION GetAcSelectedItemKey RETURNS CHARACTER
  ( /* parameter-definitions */ )  FORWARD.
FUNCTION getTreeInitialized RETURNS CHARACTER
  ( /* parameter-definitions */ )  FORWARD.
FUNCTION SetAcIdFieldName RETURNS CHARACTER
  ( INPUT i AS CHAR )  FORWARD.
FUNCTION setAcImageListToUse RETURNS CHARACTER
  ( INPUT Ic AS CHAR )  FORWARD.
FUNCTION SetAcLevelActive RETURNS CHARACTER
  ( INPUT i AS CHAR )  FORWARD.
FUNCTION SetAcLevelHandle RETURNS HANDLE
  ( INPUT i AS HANDLE )  FORWARD.
FUNCTION SetAcLevelLeaf RETURNS CHARACTER
  ( INPUT i AS CHAR )  FORWARD.
FUNCTION SetAcparentIdFieldName RETURNS CHARACTER
  ( INPUT i AS CHAR )  FORWARD.
FUNCTION SetAcSelectedNode RETURNS CHARACTER
  ( INPUT cRowIdent AS CHAR )  FORWARD.
FUNCTION SetAcSurveyActive RETURNS CHAR
  ( INPUT i AS CHAR )  FORWARD.
FUNCTION SetAcSurveyCode RETURNS CHARACTER
  ( INPUT i AS CHAR)  FORWARD.
FUNCTION SetAcSurveyDesc RETURNS CHARACTER
  ( INPUT i AS CHAR )  FORWARD.
FUNCTION SetAcTextFieldName RETURNS CHARACTER
  ( INPUT i AS CHAR )  FORWARD.
FUNCTION SetAcTreeMode RETURNS CHARACTER
  ( INPUT i AS CHAR )  FORWARD.
FUNCTION SetAiImage RETURNS CHARACTER
  ( INPUT val AS CHAR /* parameter-definitions */ )  FORWARD.
FUNCTION setAiLeafImage RETURNS CHARACTER
  ( INPUT Ii AS INT )  FORWARD.
FUNCTION setAiLeafSelImage RETURNS CHARACTER
  ( INPUT Ii AS INT )  FORWARD.
FUNCTION setAiSelectedImage RETURNS CHARACTER
  ( INPUT Ii AS INT )  FORWARD.
FUNCTION setAlAutoExpandAllNodes RETURNS CHARACTER
  ( INPUT Il AS LOG )  FORWARD.
FUNCTION setAlAutoSelectRootNodeOnOpen RETURNS CHARACTER
  ( INPUT Il AS LOG )  FORWARD.
FUNCTION setAlAutoSortAllNodes RETURNS CHARACTER
  ( INPUT Il AS LOG /* parameter-definitions */ )  FORWARD.
FUNCTION setAlSecurityCheck RETURNS CHARACTER
  ( INPUT Il    AS LOGICAL )  FORWARD.
FUNCTION SetAlTreeInitialized RETURNS CHARACTER
  ( INPUT i AS CHAR )  FORWARD.

/* ************************  Frame Definitions  *********************** */
DEFINE FRAME fTreeViewParent
    WITH 1 DOWN KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 39.72 BY 11.27
         BGCOLOR 15 FONT 8.

/* *********************** Procedure Settings ************************ */
/* This procedure should always be RUN PERSISTENT.  Report the error,  */
/* then cleanup and return.                                            */
IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:
  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U
          VIEW-AS ALERT-BOX ERROR BUTTONS OK.
  RETURN.
END.

/* ************************* Included-Libraries *********************** */
{acontml0.i}
{atreeml0.i}

/* ***************************  Main Block  *************************** */
{amainsf1.i}

/* **********************  Internal Procedures  *********************** */
PROCEDURE applyEntry :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER pcField AS CHARACTER NO-UNDO.
  /* Code placed here will execute PRIOR to standard behavior. */
  /*RUN SUPER( INPUT pcField).*/
  /* APPLY "ENTRY" TO TreeView. */
  /* Code placed here will execute AFTER standard behavior.    */
END PROCEDURE.

PROCEDURE dataAvailable :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE INPUT PARAM pcRelative   AS CHAR NO-UNDO.
    
    DEFINE VARIABLE VhDataSource     AS HANDLE     NO-UNDO.
    DEFINE VARIABLE VcSurveyCode    AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE VcRowIdent      AS CHAR       NO-UNDO.
    
    /* Only refresh if the tree has been initialized */
    IF NOT AlTreeInitialized THEN RETURN.
    {get DataSource VhDataSource}.
    IF pcRelative = "FIRST" THEN
    DO:
        SESSION:SET-WAIT-STATE("GENERAL").
                
        RUN PBuildTree ((LcCurrentRowIdent > "")). /* Reposition pending? */
    
        IF LcCurrentRowIdent > "" THEN
          {set AcSelectedNode LcCurrentRowIdent}.
        
        SESSION:SET-WAIT-STATE("").
    
    END.
    ELSE IF pcRelative = "DIFFERENT" THEN
    DO:
        {get rowIdent VcRowIdent VhDataSource}.
    
        IF VcRowIdent <> ? THEN
        DO:
            FIND ttNode WHERE ttNode.rowIdent = VcRowIdent NO-ERROR.
            IF AVAILABLE(ttNode)
            THEN RUN PTreeSelectNode(ttNode.id).
        END. 
    END.
END PROCEDURE.

PROCEDURE deleteComplete :
/*------------------------------------------------------------------------------
  Purpose:     Run by ADM just after delete has completed
               Sets record to reposition to when query is reopened
------------------------------------------------------------------------------*/
  /* We want to reposition to a node near the one which has been deleted 
     after the query has reopened */  
     
  {get RowIdent LcCurrentRowIdent SOURCE-PROCEDURE} NO-ERROR.
  LcCurrentRowIdent = FcGetRowToPositionAfterDelete() NO-ERROR.
  {set AcRowIdentForReposition LcCurrentRowIdent SOURCE-PROCEDURE} NO-ERROR.
END PROCEDURE.

PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME fTreeViewParent.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  {&OPEN-BROWSERS-IN-QUERY-fTreeViewParent}
END PROCEDURE.

PROCEDURE ExpandNode :
/*------------------------------------------------------------------------------
  Purpose:     Expand/Collapse node given its key
  Notes:       Can pass in yes, no or ? to say whether to expand, collapse or
               toggle between expanded/collapsed
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAM i-cKey             AS CHAR     NO-UNDO.
  DEFINE INPUT PARAM i-logExpanded      AS LOG      NO-UNDO.
  
END PROCEDURE.

PROCEDURE fetchDataSet :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE INPUT PARAMETER pcState      AS CHARACTER NO-UNDO.
    
    DEFINE VARIABLE VhDataSource        AS HANDLE  NO-UNDO.
    DEFINE VARIABLE hQuery              AS HANDLE  NO-UNDO.
    DEFINE VARIABLE ViList              AS INTEGER    NO-UNDO.
    
    /* If this is the case we we last on a survey */
    ViList = LOOKUP(LcNodeKey, LcIdList).
    IF ViList NE 0 
    THEN DO:
        {get DataSource VhDataSource}.
        IF VALID-HANDLE(VhDataSource) 
        THEN DO:
        
            {get DataHandle hQuery VhDataSource}.
            IF VALID-HANDLE(hQuery) THEN
            DO:
               hQuery:QUERY-OPEN() NO-ERROR.
            END.
        END.
    END.
    ELSE DO:
        IF VALID-HANDLE(LhLevelData) 
        THEN DO:
           
            {get DataHandle hQuery LhLevelData}.
            IF VALID-HANDLE(hQuery) THEN
            DO:
               hQuery:QUERY-OPEN() NO-ERROR.
            END.
        END.
    END.
END PROCEDURE.

PROCEDURE GetHitTestNode :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER OchHandle       AS COM-HANDLE       NO-UNDO.
    
END PROCEDURE.

PROCEDURE initializeObject :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/
   DEFINE VARIABLE hDataSource AS HANDLE     NO-UNDO.
   /* Code placed here will execute PRIOR to standard behavior. */
  
   /* Check for a data source SDO */
   RUN PCheckDataSource.
   RUN SUPER.
   SUBSCRIBE TO "PEVENTRemoveNode" ANYWHERE RUN-PROCEDURE "RemoveNode"  NO-ERROR.
   /* get container source for this object */
   {get ContainerSource LhContainerSource}.
   RUN resizeObject (FRAME {&FRAME-NAME}:height,FRAME {&FRAME-NAME}:WIDTH).
   
   RUN PBuildTree (FALSE). /* FALSE = No reposisition pending */
   AlTreeInitialized = TRUE.
END PROCEDURE.

PROCEDURE PBuildTree :
/*------------------------------------------------------------------------------
  Purpose:     Build tree from data-source object's query
------------------------------------------------------------------------------*/
    DEFINE INPUT PARAM plRepositionPending AS LOG NO-UNDO.
    DEFINE VARIABLE VcSurveyCode AS CHARACTER  NO-UNDO.
    PUBLISH "PEVENTTreeBuild":U(INPUT "START").
    /* Build the temp table */
    RUN PBuildTreeTable. 
    IF RETURN-VALUE > ""
    THEN RETURN RETURN-VALUE.
        
    /* Now build the tree */
    RUN PTreeCreateNodeFrame("").
    IF NOT plRepositionPending THEN
    DO:
        /* Now select first node in tree */
        IF AlAutoSelectRootNodeOnOpen THEN
            RUN PSelectFirstNode IN THIS-PROCEDURE. 
    END.
        
    PUBLISH "PEVENTTreeBuild":U(INPUT "END").
    RETURN "".
END PROCEDURE.

PROCEDURE PBuildTreeTable :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE VARIABLE hColumn                 AS HANDLE           NO-UNDO.
    DEFINE VARIABLE VcImageName             AS CHARACTER        NO-UNDO.
    DEFINE VARIABLE cId                     AS CHARACTER        NO-UNDO.
    DEFINE VARIABLE cText                   AS CHARACTER        NO-UNDO.
    DEFINE VARIABLE cparentId               AS CHARACTER        NO-UNDO.
    DEFINE VARIABLE cRowIdent               AS CHARACTER        NO-UNDO.
    DEFINE VARIABLE cLevelActive            AS CHARACTER        NO-UNDO.
    DEFINE VARIABLE cLevelLeaf              AS CHARACTER        NO-UNDO.
    DEFINE VARIABLE VhLevelQuery            AS HANDLE           NO-UNDO.
    DEFINE VARIABLE VhRowObject             AS HANDLE           NO-UNDO.
    DEFINE BUFFER ttNode FOR ttNode.
    EMPTY TEMP-TABLE ttNode.
    {get DataSource LhLevelData}.
    IF VALID-HANDLE(LhLevelData)
    THEN DO:
        {get DataHandle VhLevelQuery LhLevelData}.
        IF VALID-HANDLE(VhLevelQuery) THEN
        DO:
            IF NOT VhLevelQuery:IS-OPEN THEN
            RETURN "Query not open".
            VhRowObject = VhLevelQuery:GET-BUFFER-HANDLE(1).
            DO WHILE VhRowObject:AVAILABLE:
                ASSIGN
                    hColumn = VhRowObject:BUFFER-FIELD(AcIdFieldName)
                    cId = TRIM(hColumn:STRING-VALUE)
                    hColumn = VhRowObject:BUFFER-FIELD(AcTextFieldName)
                    cText = TRIM(hColumn:STRING-VALUE)
                    hColumn = VhRowObject:BUFFER-FIELD(AcparentIdFieldName)
                    cparentId = TRIM(hColumn:STRING-VALUE)
                    cparentId = "" WHEN cparentId = "?".
                    
                IF cLevelLeaf = "yes"
                THEN VcImageName = "LEAF".
                ELSE VcImageName = "LEVEL".
                {get RowIdent cRowIdent LhLevelData}.
                IF LcTreeMode <> "DEFN" AND cLevelActive = "no"
                THEN VhLevelQuery:GET-NEXT(NO-LOCK) NO-ERROR.
                ELSE DO:
                   CREATE ttNode.
                   ASSIGN ttNode.id = cId  /* this is the level code field */
                          ttNode.nodeText = cText
                          ttNode.parentId = cparentId
                          ttNode.rowident = cRowIdent
                          ttNode.ImageName = VcImageName
                          ttNode.active = "yes".
                    VhLevelQuery:GET-NEXT(NO-LOCK) NO-ERROR.
                END.
            END. /* RowObj Avail */
        END. /* valid query */
    END. /* valid data */
    ELSE RETURN "No data source".
    DEFINE BUFFER xyz FOR ttNode.
    FIND xyz where xyz.id = "1" NO-ERROR.
    RETURN "".
END PROCEDURE.

PROCEDURE PCheckDataSource :
/*------------------------------------------------------------------------------
  Purpose:     Check for a data source SDO
               If its there, go into 'SDB mode' (SmartDataBrowser)
               Also ensure that the SDO will reopen the query after an add
               modify and delete
------------------------------------------------------------------------------*/
    DEFINE VARIABLE VhDataSource                AS HANDLE NO-UNDO.
    {get dataSource VhDataSource}.
    
    IF VALID-HANDLE(VhDataSource) THEN
    DO:
        LlSDBMode = yes.
   
       /* Configure dataSource so query is reopened after add,modify and delete */
       RUN modifyListProperty
            (INPUT VhDataSource,
             INPUT "ADD",
             INPUT "AcReopenQueryAfterButtons",
             INPUT 'add,modify,addchild').  /* Cannot have delete in here, otherwise 
                                               the node gets re-added, before the 
                                               batch program has had chance to delete
                                              */ 
    END. 
   
END PROCEDURE.

PROCEDURE PConvImageNameToNumber :
/*------------------------------------------------------------------------------
  Purpose:     Convert the name of an image to it's number (index) in the
               imageview OCX
------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAM IcImageName              AS CHAR             NO-UNDO.
    DEFINE OUTPUT PARAM OiImageNumber            AS INTEGER          NO-UNDO.
   CASE IcImageName:
        WHEN "SURVEY"           THEN OiImageNumber = 1.
        WHEN "LEVEL"            THEN OiImageNumber = 4.
        WHEN "LEAF"             THEN OiImageNumber = 7.
        OTHERWISE OiImageNumber = 1.  /* Survey is default */
        
    END CASE. 
END PROCEDURE.

PROCEDURE PNodeSelected :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE INPUT PARAM IcNodeId AS CHARACTER NO-UNDO.
    LcLevelCode = IcNodeId.
    
    IF LlSDBMode 
    THEN DO:
        FIND ttNode WHERE ttNode.id = IcNodeId.
        {set AcSelectedNode ttNode.rowIdent}.
    END.
END PROCEDURE.

PROCEDURE PSelectFirstNode :
/*------------------------------------------------------------------------------
  Purpose:     
------------------------------------------------------------------------------*/
    DEFINE VARIABLE ViList          AS INTEGER    NO-UNDO.
    DEFINE VARIABLE hDataSource     AS HANDLE     NO-UNDO.
    
    /* only try to reposition when in the same set otherwise problems */
    {get DataSource hDataSource}.
    
    LcCurrentSet = DYNAMIC-FUNCTION('FcCurrentSet' IN LhContainerSource).
    
    IF LcCurrentSet = LcOldSet AND LENGTH(LcNodeKey) > 0
    THEN FIND ttNode WHERE ttNode.rowIdent = LcNodeKey. /* Select the current node where possible */
    ELSE FIND FIRST ttNode WHERE ttNode.parentId = "" NO-ERROR. /* Select first one */ 
    IF AVAILABLE(ttNode) 
    THEN DO:
        RUN PTreeSelectNode(ttNode.id).
        RUN PTreeExpandNode(ttNode.id). /* Ensure it's expanded too (if it's a parent) ??? possibly take out */
    END.
    LcOldSet = LcCurrentSet.
END PROCEDURE.

PROCEDURE PSwapImageForNode :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE INPUT PARAMETER  IcNodeKey           AS CHAR     NO-UNDO.
    DEFINE INPUT PARAMETER IiNewImage           AS INTEGER  NO-UNDO.
END PROCEDURE.

PROCEDURE PSwapTextForNode :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE INPUT PARAMETER  IcNodeKey           AS CHAR     NO-UNDO.
    DEFINE INPUT PARAMETER  IcNewText           AS CHAR     NO-UNDO.
END PROCEDURE.

PROCEDURE PTransactionValid :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE INPUT PARAM lAddedRecord     AS LOG          NO-UNDO.
    DEFINE INPUT PARAM lDeletedRecord   AS LOG          NO-UNDO.
    DEFINE INPUT PARAM lModifiedRecord  AS LOG          NO-UNDO.
    LlTransactionCompleted = yes.
END PROCEDURE.

PROCEDURE PTreeCollapse :
/*------------------------------------------------------------------------------
  Purpose:     run any published tree collapse procedures
  Parameters:  handle of selected node
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE INPUT PARAM chNode AS COM-HANDLE NO-UNDO.
END PROCEDURE.

PROCEDURE PTreeDblClick :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE INPUT PARAM chNode           AS COM-HANDLE   NO-UNDO.
END PROCEDURE.

PROCEDURE PTreeExpand :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
    DEFINE INPUT PARAM chNode AS COM-HANDLE NO-UNDO.
    DEFINE VARIABLE VlOpenQuery AS LOGICAL    NO-UNDO.
END PROCEDURE.

PROCEDURE RemoveNode :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAM IcKey              AS CHAR         NO-UNDO.
  DEFINE VARIABLE chNode                AS COM-HANDLE   NO-UNDO.
  
  MESSAGE "Refresh screen to update treeview." VIEW-AS ALERT-BOX INFORMATION.
  ASSIGN LcNodeKey = ?.
 
END PROCEDURE.

PROCEDURE resizeObject :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
 DEFINE INPUT PARAMETER p-height AS DECIMAL NO-UNDO.
  DEFINE INPUT PARAMETER p-width  AS DECIMAL NO-UNDO.
  ASSIGN
      FRAME {&FRAME-NAME}:HEIGHT = p-height
      FRAME {&FRAME-NAME}:WIDTH  = p-width
      FRAME {&FRAME-NAME}:VIRTUAL-HEIGHT-PIXELS = FRAME {&FRAME-NAME}:HEIGHT-PIXELS
      FRAME {&FRAME-NAME}:VIRTUAL-WIDTH-PIXELS  = FRAME {&FRAME-NAME}:WIDTH-PIXELS
  NO-ERROR.
END PROCEDURE.

FUNCTION FcGetRowToPositionAfterDelete RETURNS CHARACTER
  ( /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  Determine which row to position to after the selected row is
            deleted (e.g. its next sibling or its parent)
            Returns the node's key
------------------------------------------------------------------------------*/
END FUNCTION.

FUNCTION FcNodeImageName RETURNS CHARACTER
  ( BUFFER ttNode FOR ttNode ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
    IF   ttNode.ACTIVE = "no"
    THEN RETURN "inactive".
    ELSE RETURN ttNode.imageName.
END FUNCTION.

FUNCTION FlIsNodeExpanded RETURNS LOGICAL
  ( INPUT IcNodeKey         AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
END FUNCTION.

FUNCTION GetAcSelectedItemKey RETURNS CHARACTER
  ( /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  Use to get key of currently selected node
    Notes:  {get AcSelectedItemKey variabletoreceivevalue h_treeview}.
------------------------------------------------------------------------------*/
   FIND ttNode WHERE ttNode.id = LhTreeSelectedText:NAME NO-ERROR.
   IF AVAILABLE(ttNode) 
   THEN RETURN ttNode.rowIdent.
   
END FUNCTION.

FUNCTION getTreeInitialized RETURNS CHARACTER
  ( /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  RETURN STRING(AlTreeInitialized,"Yes/No").   /* Function return value. */
END FUNCTION.

FUNCTION setAcIdFieldName RETURNS CHARACTER
  ( INPUT i AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  Set by Container Frame
------------------------------------------------------------------------------*/
    AcIdFieldName = i.
END FUNCTION.

FUNCTION setAcImageListToUse RETURNS CHARACTER
  ( INPUT Ic AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  Set which imagelist to use
            NORMAL - normal image list (16x16 with explorer-like folders)
            EXPRESSIONS - custom size image list with special images for expressions
    Notes:  
------------------------------------------------------------------------------*/
  RETURN "".
END FUNCTION.

FUNCTION setAcLevelActive RETURNS CHARACTER
  ( INPUT i AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  Set by Container Frame
------------------------------------------------------------------------------*/
    AcLevelActive = i.   /* Function return value. */
END FUNCTION.

FUNCTION setAcLevelHandle RETURNS HANDLE
  ( INPUT i AS HANDLE ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  AcLevelHandle = i.   /* Function return value. */
END FUNCTION.

FUNCTION SetAcLevelLeaf RETURNS CHARACTER
  ( INPUT i AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  Set by Container Frame
------------------------------------------------------------------------------*/
  AcLevelLeaf = i.   /* Function return value. */
END FUNCTION.

FUNCTION setAcparentIdFieldName RETURNS CHARACTER
  ( INPUT i AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  Set by Container Frame
------------------------------------------------------------------------------*/
    AcparentIdFieldName = i.
END FUNCTION.

FUNCTION setAcSelectedNode RETURNS CHARACTER
  ( INPUT cRowIdent AS CHAR ) :  
/*------------------------------------------------------------------------------
  Purpose:  Setting this attribute will just fire fetchRowIdent in the data
            source SDO
------------------------------------------------------------------------------*/  
  DEFINE VARIABLE hDataSource    AS HANDLE        NO-UNDO.
  DEFINE VARIABLE hQuery         AS HANDLE     NO-UNDO.
  DEFINE VARIABLE VcLeaf         AS CHARACTER  NO-UNDO.
  DEFINE VARIABLE VlOpen         AS LOGICAL    NO-UNDO.
    /* Has a survey been selected? */
    IF LOOKUP(cRowIdent, LcIdList) NE 0 /* LcIdList is built in the tree build, and is a comma separated list of the cRowidents for Surveys */
    THEN DO:
        {get DataSource hDataSource}.
        
        /* the Container sets a link to the relevant SDO */
        PUBLISH "PEVENTUpdateLink":U(INPUT hDataSource,"Survey").
        IF VALID-HANDLE(hDataSource)
        THEN DYNAMIC-FUNCTION("fetchRowIdent" IN hDataSource,cRowIdent,"RowIdent") NO-ERROR. /* repositions to the desired row in the SDO */
        
        IF LcNodeKey <> ?
        THEN LcNodeKey = cRowIdent. 
        /* otherwise On Initial build the ques hasn't a handle to 
           the panel to disable.(Could check for Valid-handle there
           but MED has locked */
        IF LENGTH(LcOldSet) > 0 THEN /* !!! Bug - OldSet only reset when reopened  */
        PUBLISH "PEVENTTreeClick"(INPUT LcNodeKey,
                                  INPUT "No"
                                  ). 
        RETURN "".  
  END.
  ELSE DO:
        /* LhLevelData is set Globally in the Build Tree for the level SDO */
        IF VALID-HANDLE(LhLevelData) THEN
        DO:
            PUBLISH "PEVENTUpdateLink":U(INPUT LhLevelData,"Level"). 
            DYNAMIC-FUNCTION('assignQuerySelection':U IN LhLevelData, INPUT "flevel_code",
                                                                      INPUT LcLevelCode,                      
                                                                      INPUT "="
                                                                      ).
            /* TODO: this causes the data to be reloaded and the tree being rebuilt
            DYNAMIC-FUNCTION('openQuery':U IN LhLevelData).
            */
            /* In this Frame it is refreshing the Browse Twice, 
               so Block it fetching it in this instance */
            IF STRING(LhContainerSource:FILE-NAME) = "fdefnfr0.w" THEN 
            DYNAMIC-FUNCTION("fetchRowIdent" IN LhLevelData,cRowIdent,"RowIdent") NO-ERROR.
            ASSIGN LcNodeKey = cRowIdent.
            /* TODO: leaf is not used
            VcLeaf = {fnarg FcColValues 'leaf' LhLevelData}.
            PUBLISH "PEVENTTreeClick"(INPUT LcNodeKey,
                                      INPUT VcLeaf
                                      ).
            */
            PUBLISH "PEVENTTreeClick"(INPUT LcNodeKey).
        END.
        RETURN "".   
  END. 
 
END FUNCTION.

FUNCTION setAcSurveyActive RETURNS CHAR
  ( INPUT i AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes: Set by Container Frame 
------------------------------------------------------------------------------*/
    AcSurveyActive = i.   /* Function return value. */
END FUNCTION.

FUNCTION setAcSurveyCode RETURNS CHARACTER
  ( INPUT i AS CHAR) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  Set by Container Frame
------------------------------------------------------------------------------*/
    AcSurveyCode = i.   /* Function return value. */
END FUNCTION.

FUNCTION setAcSurveyDesc RETURNS CHARACTER
  ( INPUT i AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  Set by Container Frame
------------------------------------------------------------------------------*/
    AcSurveyDesc = i.   /* Function return value. */
END FUNCTION.

FUNCTION setAcTextFieldName RETURNS CHARACTER
  ( INPUT i AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  Set by Container Frame
------------------------------------------------------------------------------*/
    AcTextFieldName = i.
END FUNCTION.

FUNCTION setAcTreeMode RETURNS CHARACTER
  ( INPUT i AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes: Set by Container Frame 
------------------------------------------------------------------------------*/
    LcTreeMode = i.   /* Function return value. */
END FUNCTION.

FUNCTION setAiImage RETURNS CHARACTER
  ( INPUT val AS CHAR /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  AiImage = INT(val).
END FUNCTION.

FUNCTION setAiLeafImage RETURNS CHARACTER
  ( INPUT Ii AS INT ) :
/*------------------------------------------------------------------------------
  Purpose:  Set the image number to be used for the image for leaf nodes
------------------------------------------------------------------------------*/
  AiLeafImage = Ii.
  RETURN "".   /* Function return value. */
END FUNCTION.

FUNCTION setAiLeafSelImage RETURNS CHARACTER
  ( INPUT Ii AS INT ) :
/*------------------------------------------------------------------------------
  Purpose:  Set the image number to be used for the selected image for leaf nodes
------------------------------------------------------------------------------*/
  AiLeafSelImage = Ii.
  RETURN "".   /* Function return value. */
END FUNCTION.

FUNCTION setAiSelectedImage RETURNS CHARACTER
  ( INPUT Ii AS INT ) :
/*------------------------------------------------------------------------------
  Purpose:  Sets the image index used for the "selected image" of each node
            This is the image shown for the selected node
    Notes:  
------------------------------------------------------------------------------*/
  AiSelectedImage = Ii.
  RETURN "".   /* Function return value. */
END FUNCTION.

FUNCTION setAlAutoExpandAllNodes RETURNS CHARACTER
  ( INPUT Il AS LOG ) :
/*------------------------------------------------------------------------------
  Purpose:  Set this attr to determine whether the tree will set the expanded
            property to 'yes' on every new node
    Notes:  
------------------------------------------------------------------------------*/
  AlAutoExpandAllNodes = Il.
  RETURN "".   /* Function return value. */
END FUNCTION.

FUNCTION setAlAutoSelectRootNodeOnOpen RETURNS CHARACTER
  ( INPUT Il AS LOG ) :
/*------------------------------------------------------------------------------
  Purpose:  If this is true then root node will be selected when tree opens
------------------------------------------------------------------------------*/
  AlAutoSelectRootNodeOnOpen = Il.
  RETURN "".   /* Function return value. */
END FUNCTION.

FUNCTION setAlAutoSortAllNodes RETURNS CHARACTER
  ( INPUT Il AS LOG /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  Whether to auto sort each new node added
    Notes:  
------------------------------------------------------------------------------*/
  RETURN "".   /* Function return value. */
END FUNCTION.

FUNCTION setAlSecurityCheck RETURNS CHARACTER
  ( INPUT Il    AS LOGICAL ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
    AlSecurityCheck = Il.
  RETURN "".   /* Function return value. */
END FUNCTION.

FUNCTION SetAlTreeInitialized RETURNS CHARACTER
  ( INPUT i AS CHAR ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
    AlTreeInitialized = (i = "YES").
END FUNCTION.
