/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

def new global shared var fwd-user-logout as log init false.
def new global shared var fwd-custom-apis as handle.
def new global shared var fwd-embedded-mode as log init true no-undo.

def var fwdInitialized as log init false.

procedure doLogin.
   def input param messageId as int.
   def input param username as char.
   def input param password as char.

   if setuserid(username, password)
   then do:
      fwdInitialized = true.
      P2J-REMOTE-CALL('~{ "api":"p2jInitialized" ~}').
   end.
   else do:
      P2J-REMOTE-CALL('~{ "api":"showError" , "error":"Invalid username or password" ~}').
      quit.
   end.
end.

do on quit undo, leave
   on stop undo, leave
   on error  undo, leave
   on end-key undo, leave:

   wait-for close of this-procedure.

end.

if fwdInitialized
then do:
   if not fwd-user-logout 
   then do:
      run fwdLogout.
   end.
   
   // if we reached this part, it means we have finished - send the notification signal.
   P2J-REMOTE-CALL('~{ "api":"notifyDisconnect" ~}').
end.

// if FWD embedded client was not initialized (i.e. auth failure), allow the client to terminate;
// otherwise, as the remote side will set the iframe to none, it will block the FWD client in
// a waiting mode, to receive a response from the P2J-REMOTE-CALL
