/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
/* Connected Databases 
          hotel            PROGRESS
*/
&Scoped-define WINDOW-NAME CURRENT-WINDOW
{adecomm/appserv.i}
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS fFrameWin 
/*------------------------------------------------------------------------

  File: 

  Description: from cntnrfrm.w - ADM2 SmartFrame Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartFrame
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER FRAME

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME fMain
&Scoped-define BROWSE-NAME reservationsBrowse

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES reservation room room-type

/* Definitions for BROWSE reservationsBrowse                            */
&Scoped-define FIELDS-IN-QUERY-reservationsBrowse reservation.room-num ~
reservation.guest reservation.num-guests reservation.start-date ~
reservation.end-date reservation.end-date - reservation.start-date ~
room-type.description reservation.price 
&Scoped-define ENABLED-FIELDS-IN-QUERY-reservationsBrowse 
&Scoped-define QUERY-STRING-reservationsBrowse FOR EACH reservation ~
      WHERE reservation.end-date >= today NO-LOCK, ~
      EACH room OF reservation NO-LOCK, ~
      EACH room-type OF room NO-LOCK
&Scoped-define OPEN-QUERY-reservationsBrowse OPEN QUERY reservationsBrowse FOR EACH reservation ~
      WHERE reservation.end-date >= today NO-LOCK, ~
      EACH room OF reservation NO-LOCK, ~
      EACH room-type OF room NO-LOCK.
&Scoped-define TABLES-IN-QUERY-reservationsBrowse reservation room ~
room-type
&Scoped-define FIRST-TABLE-IN-QUERY-reservationsBrowse reservation
&Scoped-define SECOND-TABLE-IN-QUERY-reservationsBrowse room
&Scoped-define THIRD-TABLE-IN-QUERY-reservationsBrowse room-type


/* Definitions for FRAME fMain                                          */
&Scoped-define OPEN-BROWSERS-IN-QUERY-fMain ~
    ~{&OPEN-QUERY-reservationsBrowse}

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS reselFilters filterRoom findGuest ~
searchButton reservationsBrowse addButton updateButton deleteButton checkIn 
&Scoped-Define DISPLAYED-OBJECTS filterRoom findGuest 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */


/* Definitions of the field level widgets                               */
DEFINE BUTTON addButton 
     LABEL "Add..." 
     SIZE 15 BY 1.14.

DEFINE BUTTON checkIn 
     LABEL "Check-In..." 
     SIZE 15 BY 1.14.

DEFINE BUTTON deleteButton 
     LABEL "Delete..." 
     SIZE 15 BY 1.14.

DEFINE BUTTON reselFilters  NO-FOCUS
     LABEL "Reset Filters" 
     SIZE 15 BY 1.

DEFINE BUTTON searchButton 
     LABEL "Search" 
     SIZE 15 BY 1.

DEFINE BUTTON updateButton 
     LABEL "Update..." 
     SIZE 15 BY 1.14.

DEFINE VARIABLE filterRoom AS INTEGER FORMAT ">>>>>":U INITIAL 0 
     LABEL "Filter by Room" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE findGuest AS CHARACTER FORMAT "X(256)":U 
     LABEL "Filter by Guest" 
     VIEW-AS FILL-IN 
     SIZE 25 BY 1 NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY reservationsBrowse FOR 
      reservation, 
      room, 
      room-type SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE reservationsBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS reservationsBrowse fFrameWin _STRUCTURED
  QUERY reservationsBrowse NO-LOCK DISPLAY
      reservation.room-num COLUMN-LABEL "Room Num" FORMAT ">>>>9":U
            WIDTH 11.2
      reservation.guest FORMAT "x(20)":U WIDTH 22.2
      reservation.num-guests COLUMN-LABEL "Num Guests" FORMAT ">9":U
      reservation.start-date COLUMN-LABEL "Check-in" FORMAT "99/99/99":U
            WIDTH 10.6
      reservation.end-date COLUMN-LABEL "Check-out" FORMAT "99/99/99":U
            WIDTH 12.2
      reservation.end-date - reservation.start-date COLUMN-LABEL "Days"
            WIDTH 5.4
      room-type.description COLUMN-LABEL "Room Type" FORMAT "x(20)":U
      reservation.price COLUMN-LABEL "Room Price" FORMAT "$ >>>,>>9.99":U
            WIDTH 15.8
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 119 BY 10.48
         FONT 8 FIT-LAST-COLUMN.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME fMain
     reselFilters AT ROW 1.48 COL 100.6 WIDGET-ID 18
     filterRoom AT ROW 1.48 COL 17.6 COLON-ALIGNED WIDGET-ID 20
     findGuest AT ROW 1.48 COL 50.6 COLON-ALIGNED WIDGET-ID 16
     searchButton AT ROW 1.48 COL 81.6 WIDGET-ID 28
     reservationsBrowse AT ROW 3.38 COL 4 WIDGET-ID 200
     addButton AT ROW 14.38 COL 4.2 WIDGET-ID 4
     updateButton AT ROW 14.38 COL 21.6 WIDGET-ID 8
     deleteButton AT ROW 14.38 COL 39 WIDGET-ID 6
     checkIn AT ROW 14.38 COL 56.2 WIDGET-ID 26
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 125.1 BY 15.38
         FONT 8 WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartFrame
   Allow: Basic,Browse,DB-Fields,Query,Smart
   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target
   Other Settings: PERSISTENT-ONLY APPSERVER
 */

/* This procedure should always be RUN PERSISTENT.  Report the error,  */
/* then cleanup and return.                                            */
IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:
  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U
          VIEW-AS ALERT-BOX ERROR BUTTONS OK.
  RETURN.
END.

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW fFrameWin ASSIGN
         HEIGHT             = 15.38
         WIDTH              = 125.2.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB fFrameWin 
/* ************************* Included-Libraries *********************** */

{src/adm2/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW fFrameWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME fMain
   NOT-VISIBLE FRAME-NAME                                               */
/* BROWSE-TAB reservationsBrowse searchButton fMain */
ASSIGN 
       FRAME fMain:HIDDEN           = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME fMain
/* Query rebuild information for FRAME fMain
     _Options          = ""
     _Query            is NOT OPENED
*/  /* FRAME fMain */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE reservationsBrowse
/* Query rebuild information for BROWSE reservationsBrowse
     _TblList          = "hotel.reservation,hotel.room OF hotel.reservation,hotel.room-type OF hotel.room"
     _Options          = "NO-LOCK"
     _Where[1]         = "reservation.end-date >= today"
     _FldNameList[1]   > hotel.reservation.room-num
"reservation.room-num" "Room Num" ? "integer" ? ? ? ? ? ? no ? no no "11.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[2]   > hotel.reservation.guest
"reservation.guest" ? ? "character" ? ? ? ? ? ? no ? no no "22.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[3]   > hotel.reservation.num-guests
"reservation.num-guests" "Num Guests" ? "integer" ? ? ? ? ? ? no ? no no ? yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[4]   > hotel.reservation.start-date
"reservation.start-date" "Check-in" ? "date" ? ? ? ? ? ? no ? no no "10.6" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[5]   > hotel.reservation.end-date
"reservation.end-date" "Check-out" ? "date" ? ? ? ? ? ? no ? no no "12.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[6]   > "_<CALC>"
"reservation.end-date - reservation.start-date" "Days" ? ? ? ? ? ? ? ? no ? no no "5.4" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[7]   > hotel.room-type.description
"room-type.description" "Room Type" ? "character" ? ? ? ? ? ? no ? no no ? yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[8]   > hotel.reservation.price
"reservation.price" "Room Price" "$ >>>,>>9.99" "decimal" ? ? ? ? ? ? no ? no no "15.8" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _Query            is OPENED
*/  /* BROWSE reservationsBrowse */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME addButton
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL addButton fFrameWin
ON CHOOSE OF addButton IN FRAME fMain /* Add... */
DO:
  DEF VAR needRefresh AS LOGICAL.
  DEF VAR rid AS ROWID.
  DEF VAR createdReservationRid AS ROWID.
  RUN update-reservation-dialog.w (INPUT rid, 
                                   OUTPUT needRefresh, 
                                   OUTPUT createdReservationRid).

  IF needRefresh THEN DO:
     RUN refresh-reservations.
     REPOSITION reservationsBrowse TO ROWID createdReservationRid NO-ERROR.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME checkIn
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL checkIn fFrameWin
ON CHOOSE OF checkIn IN FRAME fMain /* Check-In... */
DO:
  IF NOT AVAIL(reservation) THEN DO:
     {no-selected-records.i "reservations"}
  END.
   
  DEF VAR needRefresh AS LOGICAL.
  DEF VAR rid AS ROWID.
  DEF VAR createdStayRid AS ROWID.
  DO TRANSACTION:
     RUN update-stay-dialog.w (INPUT rid, 
                               OUTPUT needRefresh, 
                               OUTPUT createdStayRid,
                               INPUT FALSE,
                               reservation.room-num,
                               reservation.start-date,
                               reservation.end-date,
                               reservation.guest).

     IF needRefresh THEN DO:
        publish "refresh-stays".
     END.
     ELSE DO:
        UNDO, LEAVE.
     END.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME deleteButton
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL deleteButton fFrameWin
ON CHOOSE OF deleteButton IN FRAME fMain /* Delete... */
DO:
  IF NOT AVAIL(reservation) THEN DO:
     {no-selected-records.i "reservations"}  
  END.

  MESSAGE "Are you sure you want to delete reservation of " +
     STRING(reservation.guest) "?"
     VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO TITLE "Deletion confirmation"
        UPDATE ret AS LOGICAL.
  IF NOT ret THEN RETURN NO-APPLY.

  FIND CURRENT reservation EXCLUSIVE-LOCK.
  DELETE reservation.

  RUN refresh-reservations.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME filterRoom
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL filterRoom fFrameWin
ON ANY-KEY OF filterRoom IN FRAME fMain /* Filter by Room */
DO:
  IF LASTKEY = KEYCODE("RETURN") THEN DO:
     RUN refresh-reservations.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME findGuest
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL findGuest fFrameWin
ON ANY-KEY OF findGuest IN FRAME fMain /* Filter by Guest */
DO:
  IF LASTKEY = KEYCODE("RETURN") THEN DO:
     RUN refresh-reservations.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME reselFilters
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL reselFilters fFrameWin
ON CHOOSE OF reselFilters IN FRAME fMain /* Reset Filters */
DO:
   filterRoom = 0.
   findGuest = "".
   DISPLAY filterRoom findGuest WITH FRAME fMain.
   RUN refresh-reservations.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME searchButton
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL searchButton fFrameWin
ON CHOOSE OF searchButton IN FRAME fMain /* Search */
DO:
  RUN refresh-reservations.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME updateButton
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL updateButton fFrameWin
ON CHOOSE OF updateButton IN FRAME fMain /* Update... */
DO:
  DEF VAR needRefresh AS LOGICAL.
  DEF VAR rid AS ROWID.
  DEF VAR unk AS ROWID.

  IF NOT AVAIL(reservation) THEN DO:
     {no-selected-records.i "reservations"}
  END.

  rid = ROWID(reservation).
  RUN update-reservation-dialog.w (INPUT rid, OUTPUT needRefresh, OUTPUT unk).

  IF needRefresh THEN DO:
     RUN refresh-reservations.
     REPOSITION reservationsBrowse TO ROWID rid NO-ERROR.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME reservationsBrowse
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK fFrameWin 


/* ***************************  Main Block  *************************** */

&IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN
   /* Now enable the interface  if in test mode - otherwise this happens when
      the object is explicitly initialized from its container. */
   RUN initializeObject.
&ENDIF

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects fFrameWin  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI fFrameWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME fMain.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI fFrameWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY filterRoom findGuest 
      WITH FRAME fMain.
  ENABLE reselFilters filterRoom findGuest searchButton reservationsBrowse 
         addButton updateButton deleteButton checkIn 
      WITH FRAME fMain.
  {&OPEN-BROWSERS-IN-QUERY-fMain}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE refresh-reservations fFrameWin 
PROCEDURE refresh-reservations :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

{get-reservation-filter.i}

OPEN QUERY reservationsBrowse FOR EACH reservation
      WHERE reservation.end-date >= today 
      AND (IF roomNum <> ? THEN reservation.room-num = roomNum ELSE TRUE)
      AND (IF guest <> ? THEN reservation.guest MATCHES guest ELSE TRUE)         
   NO-LOCK,
      EACH hotel.room OF hotel.reservation NO-LOCK,
      EACH hotel.room-type OF hotel.room NO-LOCK.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

