/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
/* Connected Databases 
          hotel            PROGRESS
*/
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME gDialog
{adecomm/appserv.i}
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS gDialog 
/*------------------------------------------------------------------------

  File: 

  Description: from cntnrdlg.w - ADM2 SmartDialog Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */
     
{def-update-params.i}     
DEF INPUT PARAMETER stay-id AS INTEGER.
DEF INPUT PARAMETER doView AS LOGICAL.

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartDialog
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER DIALOG-BOX

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME gDialog

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES guest

/* Definitions for DIALOG-BOX gDialog                                   */
&Scoped-define FIELDS-IN-QUERY-gDialog guest.first-name guest.birth-date ~
guest.last-name guest.country guest.guest-id-type guest.city guest.address ~
guest.guest-id-num guest.phone 
&Scoped-define ENABLED-FIELDS-IN-QUERY-gDialog guest.first-name ~
guest.birth-date guest.last-name guest.country guest.guest-id-type ~
guest.city guest.address guest.guest-id-num guest.phone 
&Scoped-define ENABLED-TABLES-IN-QUERY-gDialog guest
&Scoped-define FIRST-ENABLED-TABLE-IN-QUERY-gDialog guest
&Scoped-define QUERY-STRING-gDialog FOR EACH guest SHARE-LOCK
&Scoped-define OPEN-QUERY-gDialog OPEN QUERY gDialog FOR EACH guest SHARE-LOCK.
&Scoped-define TABLES-IN-QUERY-gDialog guest
&Scoped-define FIRST-TABLE-IN-QUERY-gDialog guest


/* Standard List Definitions                                            */
&Scoped-Define ENABLED-FIELDS guest.first-name guest.birth-date ~
guest.last-name guest.country guest.guest-id-type guest.city guest.address ~
guest.guest-id-num guest.phone 
&Scoped-define ENABLED-TABLES guest
&Scoped-define FIRST-ENABLED-TABLE guest
&Scoped-Define ENABLED-OBJECTS datePicker Btn_OK Btn_Cancel 
&Scoped-Define DISPLAYED-FIELDS guest.first-name guest.birth-date ~
guest.last-name guest.country guest.guest-id-type guest.city guest.address ~
guest.guest-id-num guest.phone 
&Scoped-define DISPLAYED-TABLES guest
&Scoped-define FIRST-DISPLAYED-TABLE guest


/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE BUTTON Btn_Cancel AUTO-END-KEY 
     LABEL "Cancel" 
     SIZE 15 BY 1.14.

DEFINE BUTTON Btn_OK AUTO-GO 
     LABEL "OK" 
     SIZE 15 BY 1.14.

DEFINE BUTTON datePicker 
     IMAGE-UP FILE "graphics/calendar.bmp":U
     IMAGE-INSENSITIVE FILE "graphics/calendar-disabled.bmp":U NO-FOCUS
     LABEL "" 
     SIZE 6 BY 1.19.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY gDialog FOR 
      guest SCROLLING.
&ANALYZE-RESUME

/* ************************  Frame Definitions  *********************** */

DEFINE FRAME gDialog
     guest.first-name AT ROW 1.48 COL 5.2 HELP
          "" WIDGET-ID 2
          VIEW-AS FILL-IN 
          SIZE 29.6 BY 1
     datePicker AT ROW 1.38 COL 90.2 WIDGET-ID 24
     guest.birth-date AT ROW 1.48 COL 61.4 HELP
          "" WIDGET-ID 12
          VIEW-AS FILL-IN 
          SIZE 14 BY 1
     guest.last-name AT ROW 3.19 COL 5 HELP
          "" WIDGET-ID 4
          VIEW-AS FILL-IN 
          SIZE 29.6 BY 1
     guest.country AT ROW 3.19 COL 50.2 HELP
          "" WIDGET-ID 14
          VIEW-AS COMBO-BOX INNER-LINES 10
          LIST-ITEMS "Afghanistan","Albania","Algeria","American Samoa","Andorra","Angola","Anguilla","Antarctica","Antigua and Barbuda","Argentina","Armenia","Aruba","Australia","Austria","Azerbaijan","Bahamas","Bahrain","Bangladesh","Barbados","Belarus","Belgium","Belize","Benin","Bermuda","Bhutan","Bolivia","Bosnia and Herzegovina","Botswana","Bouvet Island","Brazil","British Indian Ocean Territory","Brunei Darussalam","Bulgaria","Burkina Faso","Burundi","Cambodia","Cameroon","Canada","Cape Verde","Cayman Islands","Central African Republic","Chad","Chile","China","Christmas Island","Cocos (Keeling) Islands","Colombia","Comoros","Congo","Congo","The Democratic Republic of The","Cook Islands","Costa Rica","Cote D'ivoire","Croatia","Cuba","Cyprus","Czech Republic","Denmark","Djibouti","Dominica","Dominican Republic","Ecuador","Egypt","El Salvador","Equatorial Guinea","Eritrea","Estonia","Ethiopia","Falkland Islands (Malvinas)","Faroe Islands","Fiji","Finland","France","French Guiana","French Polynesia","French Southern Territories","Gabon","Gambia","Georgia","Germany","Ghana","Gibraltar","Greece","Greenland","Grenada","Guadeloupe","Guam","Guatemala","Guinea","Guinea-bissau","Guyana","Haiti","Heard Island and Mcdonald Islands","Holy See (Vatican City State)","Honduras","Hong Kong","Hungary","Iceland","India","Indonesia","Iran","Islamic Republic of","Iraq","Ireland","Israel","Italy","Jamaica","Japan","Jordan","Kazakhstan","Kenya","Kiribati","Korea","Democratic People's Republic of","Korea","Republic of","Kuwait","Kyrgyzstan","Lao People’s Democratic Republic","Latvia","Lebanon","Lesotho","Liberia","Libyan Arab Jamahiriya","Liechtenstein","Lithuania","Luxembourg","Macao","Macedonia","The Former Yugoslav Republic of","Madagascar","Malawi","Malaysia" 
          DROP-DOWN
          SIZE 38 BY 1
     guest.guest-id-type AT ROW 4.91 COL 7.6 HELP
          "" WIDGET-ID 6
          VIEW-AS COMBO-BOX INNER-LINES 5
          LIST-ITEM-PAIRS "test",1
          DROP-DOWN-LIST
          SIZE 29.6 BY 1
     guest.city AT ROW 4.91 COL 54 HELP
          "" WIDGET-ID 16
          VIEW-AS FILL-IN 
          SIZE 38 BY 1
     guest.address AT ROW 6.48 COL 58.6 HELP
          "" NO-LABEL WIDGET-ID 20
          VIEW-AS EDITOR SCROLLBAR-VERTICAL
          SIZE 38 BY 4
     guest.guest-id-num AT ROW 6.62 COL 5 HELP
          "" WIDGET-ID 8
          VIEW-AS FILL-IN 
          SIZE 29.6 BY 1
     guest.phone AT ROW 8.33 COL 1 HELP
          "" WIDGET-ID 10
          VIEW-AS FILL-IN 
          SIZE 29.6 BY 1
     Btn_OK AT ROW 10.19 COL 3.8
     Btn_Cancel AT ROW 10.19 COL 20.8
     SPACE(62.39) SKIP(0.37)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         TITLE "Add Guest"
         DEFAULT-BUTTON Btn_OK CANCEL-BUTTON Btn_Cancel WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartDialog
   Allow: Basic,Browse,DB-Fields,Query,Smart
   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target
   Other Settings: APPSERVER
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB gDialog 
/* ************************* Included-Libraries *********************** */

{src/adm2/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX gDialog
   FRAME-NAME                                                           */
ASSIGN 
       FRAME gDialog:SCROLLABLE       = FALSE
       FRAME gDialog:HIDDEN           = TRUE.

/* SETTINGS FOR EDITOR guest.address IN FRAME gDialog
   EXP-HELP                                                             */
/* SETTINGS FOR FILL-IN guest.birth-date IN FRAME gDialog
   ALIGN-L EXP-HELP                                                     */
/* SETTINGS FOR FILL-IN guest.city IN FRAME gDialog
   ALIGN-L EXP-HELP                                                     */
/* SETTINGS FOR COMBO-BOX guest.country IN FRAME gDialog
   ALIGN-L EXP-HELP                                                     */
/* SETTINGS FOR FILL-IN guest.first-name IN FRAME gDialog
   ALIGN-L EXP-HELP                                                     */
/* SETTINGS FOR FILL-IN guest.guest-id-num IN FRAME gDialog
   ALIGN-L EXP-HELP                                                     */
/* SETTINGS FOR COMBO-BOX guest.guest-id-type IN FRAME gDialog
   ALIGN-L EXP-HELP                                                     */
/* SETTINGS FOR FILL-IN guest.last-name IN FRAME gDialog
   ALIGN-L EXP-HELP                                                     */
/* SETTINGS FOR FILL-IN guest.phone IN FRAME gDialog
   ALIGN-L EXP-HELP                                                     */
/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK DIALOG-BOX gDialog
/* Query rebuild information for DIALOG-BOX gDialog
     _TblList          = "hotel.guest"
     _Options          = "SHARE-LOCK"
     _Query            is NOT OPENED
*/  /* DIALOG-BOX gDialog */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME gDialog
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL gDialog gDialog
ON WINDOW-CLOSE OF FRAME gDialog /* Add Guest */
DO:  
  /* Add Trigger to equate WINDOW-CLOSE to END-ERROR. */
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_OK
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_OK gDialog
ON CHOOSE OF Btn_OK IN FRAME gDialog /* OK */
DO:
   IF doView THEN DO:
      LEAVE.
   END.
   
   IF first-name:INPUT-VALUE = ? OR trim(first-name:INPUT-VALUE) = "" THEN DO:
      MESSAGE "Specify First Name!" VIEW-AS ALERT-BOX ERROR title "No First Name specified".
      RETURN NO-APPLY.
   END.

   IF last-name:INPUT-VALUE = ? OR trim(last-name:INPUT-VALUE) = "" THEN DO:
      MESSAGE "Specify Last Name!" VIEW-AS ALERT-BOX ERROR title "No Last Name specified".
      RETURN NO-APPLY.
   END.
   
   ASSIGN guest.first-name 
          guest.last-name
          guest.guest-id-type
          guest.guest-id-num
          guest.phone
          guest.birth-date
          guest.country
          guest.city
          guest.address.

   ASSIGN guest.first-name = TRIM(guest.first-name)
          guest.last-name = TRIM(guest.last-name)
          guest.guest-id-num = TRIM(guest.guest-id-num)
          guest.phone = TRIM(guest.phone)
          guest.country = TRIM(guest.country)
          guest.city = TRIM(guest.city)
          guest.address = TRIM(guest.address).

   needRefresh = TRUE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME datePicker
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL datePicker gDialog
ON CHOOSE OF datePicker IN FRAME gDialog
DO:
  {pick-date.i "Date of Birth" guest.birth-date gDialog}
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK gDialog 


/* ***************************  Main Block  *************************** */

/* Populate ID types */
DEF VAR item-pairs AS CHAR INIT "".
item-pairs = "".
FOR EACH guest-id-type:
  IF item-pairs <> "" THEN DO:
     item-pairs = item-pairs + ",".
  END.

  item-pairs = item-pairs + guest-id-type.DESCRIPTION + "," + STRING(guest-id-type.id-type).
END.
guest-id-type:LIST-ITEM-PAIRS = item-pairs.

IF recordRid = ? THEN DO:
   FRAME gDialog:TITLE = "Add Guest".
   Btn_OK:LABEL = "Add".

   DEF VAR ord AS INTEGER.
   FIND LAST guest WHERE guest.stay-id = stay-id NO-ERROR.
   IF AVAIL(guest) THEN DO:
      ord = guest.order + 1.
   END.
   ELSE ord = 1.

   CREATE guest.
   guest.stay-id = stay-id.
   guest.order = ord.
   guest.guest-id-type = 1.
END.
ELSE IF doView THEN DO:
   FRAME gDialog:TITLE = "View Guest".
   Btn_OK:LABEL = "Close".
  
   FIND guest WHERE rowid(guest) = recordRid.
END.
ELSE DO:
   FRAME gDialog:TITLE = "Update Guest".
   Btn_OK:LABEL = "Update".

   FIND guest WHERE rowid(guest) = recordRid.
END.

{src/adm2/dialogmn.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects gDialog  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI gDialog  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME gDialog.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI gDialog  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  IF AVAILABLE guest THEN 
    DISPLAY guest.first-name guest.birth-date guest.last-name guest.country 
          guest.guest-id-type guest.city guest.address guest.guest-id-num 
          guest.phone 
      WITH FRAME gDialog.
  ENABLE guest.first-name datePicker guest.birth-date guest.last-name 
         guest.country guest.guest-id-type guest.city guest.address 
         guest.guest-id-num guest.phone Btn_OK Btn_Cancel 
      WITH FRAME gDialog.
  VIEW FRAME gDialog.
  {&OPEN-BROWSERS-IN-QUERY-gDialog}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject gDialog 
PROCEDURE initializeObject :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/

  /* Code placed here will execute PRIOR to standard behavior. */

  RUN SUPER.

  /* Code placed here will execute AFTER standard behavior.    */

  
  if doView then do:
    disable guest.first-name datePicker guest.last-name guest.guest-id-type 
         guest.guest-id-num guest.phone guest.birth-date guest.country 
         guest.city guest.address datePicker
      WITH FRAME gDialog.
    Btn_Cancel:visible = false. 
  end. 


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

