/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME gDialog
{adecomm/appserv.i}
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS gDialog 
/*------------------------------------------------------------------------

  File: 

  Description: from cntnrdlg.w - ADM2 SmartDialog Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

{def-update-params.i}

DEF BUFFER xrate FOR rate.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartDialog
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER DIALOG-BOX

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME gDialog

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS startDatePicker endDatePicker roomType ~
startDate endDate roomRate Btn_OK Btn_Cancel 
&Scoped-Define DISPLAYED-OBJECTS roomType startDate endDate roomRate 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE BUTTON Btn_Cancel AUTO-END-KEY 
     LABEL "Cancel" 
     SIZE 15 BY 1.14.

DEFINE BUTTON Btn_OK AUTO-GO 
     LABEL "Update" 
     SIZE 15 BY 1.14.

DEFINE BUTTON endDatePicker 
     IMAGE-UP FILE "graphics/calendar.bmp":U
     IMAGE-INSENSITIVE FILE "graphics/calendar-disabled.bmp":U NO-FOCUS
     LABEL "" 
     SIZE 6 BY 1.19.

DEFINE BUTTON startDatePicker 
     IMAGE-UP FILE "graphics/calendar.bmp":U
     IMAGE-INSENSITIVE FILE "graphics/calendar-disabled.bmp":U NO-FOCUS
     LABEL "" 
     SIZE 6 BY 1.19.

DEFINE VARIABLE roomType AS CHARACTER FORMAT "X(256)":U 
     LABEL "Room Type" 
     VIEW-AS COMBO-BOX INNER-LINES 5
     LIST-ITEM-PAIRS "Item 1","Item 1"
     DROP-DOWN-LIST
     SIZE 34 BY 1 NO-UNDO.

DEFINE VARIABLE endDate AS DATE FORMAT "99/99/99":U 
     LABEL "End Date (incl.)" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE roomRate AS DECIMAL FORMAT ">>>,>>9.99":U INITIAL 0 
     LABEL "Rate for Day" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE startDate AS DATE FORMAT "99/99/99":U 
     LABEL "Start Date" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME gDialog
     startDatePicker AT ROW 2.91 COL 32.8 WIDGET-ID 12
     endDatePicker AT ROW 4.43 COL 32.8 WIDGET-ID 14
     roomType AT ROW 1.48 COL 15.2 COLON-ALIGNED WIDGET-ID 2
     startDate AT ROW 3 COL 15.2 COLON-ALIGNED WIDGET-ID 4
     endDate AT ROW 4.52 COL 15.2 COLON-ALIGNED WIDGET-ID 6
     roomRate AT ROW 6 COL 15.2 COLON-ALIGNED WIDGET-ID 8
     Btn_OK AT ROW 8.14 COL 3
     Btn_Cancel AT ROW 8.14 COL 20
     "$" VIEW-AS TEXT
          SIZE 8 BY .62 AT ROW 6.1 COL 31 WIDGET-ID 10
     SPACE(15.79) SKIP(3.03)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         FONT 8
         TITLE "Update Rate"
         DEFAULT-BUTTON Btn_OK CANCEL-BUTTON Btn_Cancel WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartDialog
   Allow: Basic,Browse,DB-Fields,Query,Smart
   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target
   Other Settings: APPSERVER
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB gDialog 
/* ************************* Included-Libraries *********************** */

{src/adm2/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX gDialog
   FRAME-NAME                                                           */
ASSIGN 
       FRAME gDialog:SCROLLABLE       = FALSE
       FRAME gDialog:HIDDEN           = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK DIALOG-BOX gDialog
/* Query rebuild information for DIALOG-BOX gDialog
     _Options          = "SHARE-LOCK"
     _Query            is NOT OPENED
*/  /* DIALOG-BOX gDialog */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME gDialog
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL gDialog gDialog
ON WINDOW-CLOSE OF FRAME gDialog /* Update Rate */
DO:  
  /* Add Trigger to equate WINDOW-CLOSE to END-ERROR. */
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_OK
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_OK gDialog
ON CHOOSE OF Btn_OK IN FRAME gDialog /* Update */
DO:
   IF startDate:INPUT-VALUE = ? THEN DO:
      MESSAGE "Please specify Start Date!" VIEW-AS ALERT-BOX ERROR title "No Start Date specified".
      RETURN NO-APPLY.
   END.

   IF endDate:INPUT-VALUE = ? THEN DO:
      MESSAGE "Please specify End Date!" VIEW-AS ALERT-BOX ERROR title "No End Date specified".
      RETURN NO-APPLY.
   END.

   IF startDate:INPUT-VALUE > endDate:INPUT-VALUE THEN DO:
      MESSAGE "Start Date should be less or equal End Date!" VIEW-AS ALERT-BOX ERROR title "Invalid date span".
      RETURN NO-APPLY.
   END.

   def var rt as int.
   rt = roomType:INPUT-VALUE.
   
   /* check for overlapping rates */
   FIND FIRST xrate WHERE xrate.room-type = rt AND
               NOT ((xrate.end-date < startDate:INPUT-VALUE AND
                     xrate.start-date < startDate:INPUT-VALUE)  OR
                    (xrate.end-date > endDate:INPUT-VALUE AND
                     xrate.start-date > endDate:INPUT-VALUE)) AND
                     (IF recordRid <> ? THEN rowid(xrate) <> recordRid
                                           ELSE TRUE) NO-ERROR.

   IF AVAIL(xrate) THEN DO:
      MESSAGE "Overlapping rate found: " + 
              STRING(xrate.start-date) + " - " + 
              STRING(xrate.end-date) + 
              " ($" + STRING(xrate.rate) + ")!"
         VIEW-AS ALERT-BOX ERROR title "Conflicting rates".
      RETURN NO-APPLY.
   END.

   IF recordRid = ? THEN DO:
      CREATE rate.
      createdRecordRid = ROWID(rate).
   END.
   ELSE DO:
      FIND rate WHERE ROWID(rate) = recordRid.   
   END.

   ASSIGN rate.room-type = roomType:INPUT-VALUE 
          rate.start-date = (startDate:INPUT-VALUE in frame gDialog)
          rate.end-date = (endDate:INPUT-VALUE in frame gDialog)
          rate.rate = (roomRate:INPUT-VALUE in frame gDialog).

   needRefresh = YES.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME endDatePicker
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL endDatePicker gDialog
ON CHOOSE OF endDatePicker IN FRAME gDialog
DO:
  {pick-date.i "End Date" endDate gDialog}
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME startDatePicker
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL startDatePicker gDialog
ON CHOOSE OF startDatePicker IN FRAME gDialog
DO:
  {pick-date.i "Start Date" startDate gDialog}
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK gDialog 


/* ***************************  Main Block  *************************** */

/* Populate room types */
DEF VAR items AS CHAR INIT "".
FOR EACH room-type:
  IF items <> "" THEN DO:
     items = items + ",".
  END.
  ELSE DO:
      /* Select first item by default. */
     roomType:SCREEN-VALUE = STRING(room-type.room-type).
  END.

  items = items + room-type.DESCRIPTION + "," + STRING(room-type.room-type).
END.
roomType:LIST-ITEM-PAIRS = items.


IF recordRid = ? THEN DO:
   FRAME gDialog:TITLE = "Add Rate".
   Btn_OK:LABEL = "Add".
END.
ELSE DO:
   FRAME gDialog:TITLE = "Update Rate".
   Btn_OK:LABEL = "Update".

   FIND rate WHERE ROWID(rate) = recordRid.
   ASSIGN roomType:SCREEN-VALUE = string(rate.room-type)
          startDate = rate.start-date
          endDate = rate.end-date
          roomRate = rate.rate.
END.



{src/adm2/dialogmn.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects gDialog  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI gDialog  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME gDialog.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI gDialog  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY roomType startDate endDate roomRate 
      WITH FRAME gDialog.
  ENABLE startDatePicker endDatePicker roomType startDate endDate roomRate 
         Btn_OK Btn_Cancel 
      WITH FRAME gDialog.
  VIEW FRAME gDialog.
  {&OPEN-BROWSERS-IN-QUERY-gDialog}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

