/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
/* Connected Databases 
          hotel            PROGRESS
*/
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME gDialog
{adecomm/appserv.i}
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS gDialog 
/*------------------------------------------------------------------------

  File: 

  Description: from cntnrdlg.w - ADM2 SmartDialog Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */
     
{def-update-params.i}     
DEF INPUT PARAMETER stay-id AS INTEGER.     

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartDialog
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER DIALOG-BOX

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME gDialog

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES service

/* Definitions for DIALOG-BOX gDialog                                   */
&Scoped-define FIELDS-IN-QUERY-gDialog service.service-date service.amount 
&Scoped-define ENABLED-FIELDS-IN-QUERY-gDialog service.service-type ~
service.service-date service.amount 
&Scoped-define ENABLED-TABLES-IN-QUERY-gDialog service
&Scoped-define FIRST-ENABLED-TABLE-IN-QUERY-gDialog service
&Scoped-define QUERY-STRING-gDialog FOR EACH service SHARE-LOCK
&Scoped-define OPEN-QUERY-gDialog OPEN QUERY gDialog FOR EACH service SHARE-LOCK.
&Scoped-define TABLES-IN-QUERY-gDialog service
&Scoped-define FIRST-TABLE-IN-QUERY-gDialog service


/* Standard List Definitions                                            */
&Scoped-Define ENABLED-FIELDS service.service-type service.service-date ~
service.amount 
&Scoped-define ENABLED-TABLES service
&Scoped-define FIRST-ENABLED-TABLE service
&Scoped-Define ENABLED-OBJECTS datePicker Btn_OK Btn_Cancel 
&Scoped-Define DISPLAYED-FIELDS service.service-date service.amount 
&Scoped-define DISPLAYED-TABLES service
&Scoped-define FIRST-DISPLAYED-TABLE service


/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE BUTTON Btn_Cancel AUTO-END-KEY 
     LABEL "Cancel" 
     SIZE 15 BY 1.14.

DEFINE BUTTON Btn_OK AUTO-GO 
     LABEL "OK" 
     SIZE 15 BY 1.14.

DEFINE BUTTON datePicker 
     IMAGE-UP FILE "graphics/calendar.bmp":U
     IMAGE-INSENSITIVE FILE "graphics/calendar-disabled.bmp":U NO-FOCUS
     LABEL "" 
     SIZE 6 BY 1.19.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY gDialog FOR 
      service SCROLLING.
&ANALYZE-RESUME

/* ************************  Frame Definitions  *********************** */

DEFINE FRAME gDialog
     datePicker AT ROW 2.86 COL 33 WIDGET-ID 24
     service.service-type AT ROW 1.48 COL 3.6 HELP
          "" WIDGET-ID 4
          VIEW-AS COMBO-BOX INNER-LINES 5
          LIST-ITEM-PAIRS "test",1
          DROP-DOWN-LIST
          SIZE 34 BY 1
     service.service-date AT ROW 2.91 COL 15.4 COLON-ALIGNED HELP
          "" WIDGET-ID 6
          VIEW-AS FILL-IN 
          SIZE 14 BY 1
     service.amount AT ROW 4.33 COL 15.4 COLON-ALIGNED HELP
          "" WIDGET-ID 8
          VIEW-AS FILL-IN 
          SIZE 14 BY 1
     Btn_OK AT ROW 6.1 COL 3
     Btn_Cancel AT ROW 6.1 COL 20.2
     "$" VIEW-AS TEXT
          SIZE 4 BY .62 AT ROW 4.48 COL 32.8 WIDGET-ID 10
     SPACE(17.39) SKIP(2.70)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         TITLE "Add Service"
         DEFAULT-BUTTON Btn_OK CANCEL-BUTTON Btn_Cancel WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartDialog
   Allow: Basic,Browse,DB-Fields,Query,Smart
   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target
   Other Settings: APPSERVER
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB gDialog 
/* ************************* Included-Libraries *********************** */

{src/adm2/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX gDialog
   FRAME-NAME                                                           */
ASSIGN 
       FRAME gDialog:SCROLLABLE       = FALSE
       FRAME gDialog:HIDDEN           = TRUE.

/* SETTINGS FOR FILL-IN service.amount IN FRAME gDialog
   EXP-HELP                                                             */
/* SETTINGS FOR FILL-IN service.service-date IN FRAME gDialog
   EXP-HELP                                                             */
/* SETTINGS FOR COMBO-BOX service.service-type IN FRAME gDialog
   NO-DISPLAY ALIGN-L EXP-HELP                                          */
/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK DIALOG-BOX gDialog
/* Query rebuild information for DIALOG-BOX gDialog
     _TblList          = "hotel.service"
     _Options          = "SHARE-LOCK"
     _Query            is NOT OPENED
*/  /* DIALOG-BOX gDialog */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME gDialog
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL gDialog gDialog
ON WINDOW-CLOSE OF FRAME gDialog /* Add Service */
DO:  
  /* Add Trigger to equate WINDOW-CLOSE to END-ERROR. */
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_OK
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_OK gDialog
ON CHOOSE OF Btn_OK IN FRAME gDialog /* OK */
DO:
  DEF VAR st AS INTEGER.
  st = service.service-type:INPUT-VALUE.
   
  IF st = ? OR st = 0 THEN DO:
      MESSAGE "Specify Service Type!" VIEW-AS ALERT-BOX ERROR title "No Service Type specified".
      RETURN NO-APPLY.
   END.

   ASSIGN service.service-type
          service.service-date
          service.amount.

   needRefresh = TRUE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME datePicker
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL datePicker gDialog
ON CHOOSE OF datePicker IN FRAME gDialog
DO:
  {pick-date.i "Date of service" service.service-date gDialog}
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME service.service-type
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL service.service-type gDialog
ON VALUE-CHANGED OF service.service-type IN FRAME gDialog /* Service Type */
DO:
   DEF VAR val AS INTEGER.
   val = service.service-type:INPUT-VALUE IN FRAME gDialog.
   IF val <> ? THEN DO:
      FIND FIRST service-type WHERE service-type.service-type = val NO-ERROR.
      IF AVAIL(service-type) THEN DO:
         service.amount = service-type.default-amount.
         DISPLAY service.amount WITH FRAME gDialog.
      END.
   END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK gDialog 


/* ***************************  Main Block  *************************** */

/* Populate Service types */
DEF VAR item-pairs AS CHAR INIT "".
item-pairs = "".
FOR EACH service-type:
  IF item-pairs <> "" THEN DO:
     item-pairs = item-pairs + ",".
  END.

  item-pairs = item-pairs + service-type.DESCRIPTION + "," + STRING(service-type.service-type).
END.
service.service-type:LIST-ITEM-PAIRS = item-pairs.

IF recordRid = ? THEN DO:
   FRAME gDialog:TITLE = "Add Service".
   Btn_OK:LABEL = "Add".

   CREATE service.
   service.stay-id = stay-id.
   service.service-type = ?.
END.
ELSE DO:
   FRAME gDialog:TITLE = "Update Service".
   Btn_OK:LABEL = "Update".

   FIND service WHERE rowid(service) = recordRid.
END.


{src/adm2/dialogmn.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects gDialog  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI gDialog  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME gDialog.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI gDialog  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  IF AVAILABLE service THEN 
    DISPLAY service.service-date service.amount 
      WITH FRAME gDialog.
  ENABLE datePicker service.service-type service.service-date service.amount 
         Btn_OK Btn_Cancel 
      WITH FRAME gDialog.
  VIEW FRAME gDialog.
  {&OPEN-BROWSERS-IN-QUERY-gDialog}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

