/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

package com.goldencode.hotel;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.persist.trigger.DatabaseEventType;
import com.goldencode.p2j.persist.*;
import com.goldencode.hotel.dmo.hotel.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.util.character.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in rsrvdtrg.p).
 */
@SchemaTrigger(buffer = Reservation.Buf.class, event = DatabaseEventType.DELETE, field = "", overrideable = true, hasOldBuffer = false)
public class Rsrvdtrg
extends DatabaseTrigger<Reservation.Buf>
{
   Reservation.Buf reservation;

   /**
    * External procedure (converted to Java from the 4GL source code
    * in rsrvdtrg.p).
    */
   @Override
   public void delete(final Reservation.Buf reservation)
   {
      externalProcedure(Rsrvdtrg.this, new Block((Body) () -> 
      {
         RecordBuffer.openScope(reservation);
         Rsrvdtrg.this.reservation = reservation;
         NamedEventManager.publish("roomUtilization", thisProcedure(), "II", new Object[]
         {
            valueOf(reservation.getStartDate(), "99/99/9999"),
            valueOf(reservation.getEndDate(), "99/99/9999")
         });
      }));
   }

   public character fwdGetAdmversion()
   {
      return function("fwdGetADMVersion", character.class, new Block((Body) () -> 
      {
         returnNormal("ADM2.2");
      }));
   }
}
