/*------------------------------------------------------------------------

  File:  

  Description: DYNDATA.W - Dynamic SmartData object in the ADM

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Modified    : May 16, 2001 Version 9.1C
------------------------------------------------------------------------*/

package com.goldencode.hotel.common.adm2;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.p2j.persist.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;
import static com.goldencode.p2j.util.ErrorManager.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in common/adm2/dyndata.w).
 */
public class Dyndata
{
   /* Procedure Description
   "ADM dynamic SmartDataObject.
   
   This dynamic object is used as a client proxy for a SmartDataObject."
   */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /* adecomm/appserv.i checks to see if the persistent procedure adecomm/as-utils.w
                        has been started up, and if not, it starts it and then makes
                        is a SUPER procedure of the calling procedure.
                        
      Created: 11/26/97 by Ross Hunter
                                                                                    */   
   handle appSrvUtils = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "appsrvutils", true, new handle());

   /* tell smart.i that we can use the default destroyObject */   
   /* ***************************  Definitions  ************************** */   
   /* Parameters Definitions ---                                           */   
   /* Local Variable Definitions ---                                       */   
   character gcUpdatable = TypeFactory.character();

   /* These preprocessors tell at compile time which properties can
        be retrieved directly from the temp-table */   
   /* include properties from smart */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smrtprop.i
       Purpose     : Starts smart.p super procedure and defines general
                     SmartObject properties and other values.
       Syntax      : {src/adm2/smrtprop.i}
   
       Description :
   
       Modified    : February 4, 2000 - Version 9.1B
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smartdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/smartdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/smrtprop.i}
     ------------------------------------------------------------------------*/   
   /* Service Managers */   
   /*********************************************************************
   * Copyright (C) 2000-2002 by Progress Software Corporation ("PSC"),  *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*---------------------------------------------------------------------------------
     File: globals.i
   
     Description:  ICF Global Shared Variables
   
     Purpose:      ICF Global Shared Variables
                   The global shared variables available within the Dynamics environment.
                   
                   NOTE: (Dynamic Only )
                   Shared variables do not span the client / server boundary. On the
                   client these are set-up in afstartupp.p and on the server in the agent
                   as_startup.p
                   Also note if we include the guts of a procedure as an internal
                   procedure for shared client/server code, we sometime need to
                   ensure the shared variables are not redefined.
   
     Parameters:   <none>
   
     History:
     --------
   
     Modified: 11/08/2001 - Mark Davies (MIP)
               Copied code for ICF afglobals.i and added here to allow
               ICF changed adm code to compile. afglobals.i now includes
               this file for definitions.
               Any ADM code will now reference globals.i which excludes any other
               ICF specific includes.
   -----------------------------------------------------------*/   
   /*                   This .W file was created with the Progress UIB.             */   
   /*-------------------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 5.57
            WIDTH              = 64.4.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Used whereever Crystal is used and when defining the tt_datasource temp-table 
      to define the maximum columns supported when printing to crystal.
      See browsercustom.p and afcrpplip2p.p for example uses
   */   
   /* Used for filter checks */   
   /* The table delimiter used in assignlist, *ColumnsByTable props */   
   handle gshAstraAppserver = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshastraappserver", true, new handle());

   /* Handle to Astra Application Server Partition */   
   handle gshSessionManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsessionmanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshRimanager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrimanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshSecurityManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsecuritymanager", true, new handle());

   /* Handle Astra Security Manager */   
   handle gshProfileManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshprofilemanager", true, new handle());

   /* Handle Astra Profile Manager */   
   handle gshRepositoryManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrepositorymanager", true, new handle());

   /* Handle Astra Repository Manager */   
   handle gshTranslationManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshtranslationmanager", true, new handle());

   /* Handle Astra Translation Manager */   
   handle gshWebManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshwebmanager", true, new handle());

   /* Handle Astra Web Manager */   
   character gscSessionId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gscsessionid", true, new character(""));

   /* Unique session id */   
   decimal gsdSessionObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionobj", true, new decimal(0));

   /* Unique session id */   
   handle gshFinManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshfinmanager", true, new handle());

   /* Handle AstraFin Generic Manager */   
   handle gshGenManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshgenmanager", true, new handle());

   /* Handle AstraFramework Generic Manager */   
   handle gshAgnManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshagnmanager", true, new handle());

   /* Handle AstraGen Generic Manager */   
   decimal gsdTempUniqueId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdtempuniqueid", true, new decimal(0));

   /* A number for unique objects */   
   decimal gsdUserObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsduserobj", true, new decimal(0));

   /* User Object ID */   
   decimal gsdRenderTypeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdrendertypeobj", true, new decimal(0));

   /* Render Type Object ID */   
   decimal gsdSessionScopeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionscopeobj", true, new decimal(0));

   /* Render Type Object ID */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*------------------------------------------------------------------------
       File        : globalscustom.i
       Purpose     : The developer can create his own version of this to 
                     allow 'global' definitions to be added to the 
                     framework.   
       Syntax      : {src/adm2/custom/globalscustom.i}
   
       Description :
   
       Created     : 06/03/1999
       Notes       : Referenced in {src/adm2/globals.i}
     ----------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress AppBuilder.      */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* define the ADM Version and broker handle for all SmartObjects */   
   /* Note that adm-props-from-repository is documented as possible to define
        as a variable for flexible override, so it cannot be used for conditional 
        compile.  */   
   /* adm-props-from-repository is supported to be defined as a variable,
       so it is not used for conditional compile */   
   handle ghProp = TypeFactory.handle();

   /**
    * External procedure (converted to Java from the 4GL source code
    * in common/adm2/dyndata.w).
    */
   public void execute()
   {
      /* For {get/set} */
      handle ghAdmprops = TypeFactory.handle();
      /* Handle of prop t-t */
      handle ghAdmpropsBuf = TypeFactory.handle();
      /*  and its buffer    */
      logical glAdmloadFromRepos = TypeFactory.logical();
      character cObjectName = TypeFactory.character();
      integer iStart = TypeFactory.integer();
      /* Note: This ENDIF matches the adm-smart definition at the top of file.
         Do not delete it and if another procedure or function is defined which
         occurs later in the file, move it to the end of that. */
      /* _UIB-CODE-BLOCK-END */
      /* _UIB-CODE-BLOCK-END */
      /* ***************************  Main Block  *************************** */
      character cAppService = TypeFactory.character();
      character cAsdivision = TypeFactory.character();
      character cServerOperatingMode = TypeFactory.character();
      
      externalProcedure(Dyndata.this, new Block((Init) () -> 
      {
         gsdSessionObj.setPrecision(9);
         gsdTempUniqueId.setPrecision(9);
         gsdUserObj.setPrecision(9);
         gsdRenderTypeObj.setPrecision(9);
         gsdSessionScopeObj.setPrecision(9);
      }, 
      (Body) () -> 
      {
         if (_not(appSrvUtils.isValid()))
         {
            ControlFlowOps.invokePersistentSet("adecomm/as-utils.w", appSrvUtils);
         }
         
         thisProcedure().unwrapCommonProcedure().addSuperProcedure(appSrvUtils);
         /*********************************************************************
         * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
         * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
         * below.  All Rights Reserved.                                       *
         *                                                                    *
         * The Initial Developer of the Original Code is PSC.  The Original   *
         * Code is Progress IDE code released to open source December 1, 2000.*
         *                                                                    *
         * The contents of this file are subject to the Possenet Public       *
         * License Version 1.0 (the "License"); you may not use this file     *
         * except in compliance with the License.  A copy of the License is   *
         * available as of the date of this notice at                         *
         * http://www.possenet.org/license.html                               *
         *                                                                    *
         * Software distributed under the License is distributed on an "AS IS"*
         * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
         * should refer to the License for the specific language governing    *
         * rights and limitations under the License.                          *
         *                                                                    *
         * Contributors:                                                      *
         *                                                                    *
         *********************************************************************/
         /*          This .W file was created with the Progress AppBuilder.      */
         /*----------------------------------------------------------------------*/
         /* Create an unnamed pool to store all the widgets created 
              by this procedure. This is a good default which assures
              that this procedure's triggers and internal procedures 
              will execute in this procedure's storage, and that proper
              cleanup will occur on deletion of the procedure. */
         WidgetPool.create();
         
         /* _UIB-CODE-BLOCK-END */
         /* ***********************  Control Definitions  ********************** */
         /* ************************  Frame Definitions  *********************** */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: SmartDataObject
            Allow: Query
            Frames: 0
            Add Fields to: Neither
            Other Settings: PERSISTENT-ONLY COMPILE APPSERVER DB-AWARE
          */
         /* This procedure should always be RUN PERSISTENT.  Report the error,  */
         /* then cleanup and return.                                            */
         if (_not(thisProcedure().unwrapProcedure().isPersistent()))
         {
            messageBox("common/adm2/dyndata.w should only be RUN PERSISTENT.", ALERT_ERROR, BTN_OK, (String) null);
            returnNormal();
         }
         
         /* These preprocessors let the get and set methods know at compile time
             which property values are located in the temp-table and which must
             be accessed through the property functions.
          */
         /* for support of dynamic objects */
         /* physical name - no path */
         /* for support of runtime parameters passed from the menus */
         /* Properties for super procedure management */
         /* The name of the super procedure; can be a CSV list */ 
 /* STATELESS, STATEFUL; the mode that all supers for the object will be launched in */ 
 /* Runtime property storing handles to the object's super procedures, defined in SuperProcedure. */
         /* Layout support for dynamic objects */
         /* contains a layout position that allows an object to be laid out correctly. */
         /* determine if we need to create the prop fields here or from the */
         /* repository (if ICF is running ) */
         /* COMMENT THE FOLLOWING LINE TO USE THE "<class>prop.i" DEFINITIONS */
         /* This temp-table defines all the propertt fields for an object.
             This include file contributes the DEFINE statement header and
             all basic smart object properties. Each other property class include file
             adds its own fields and then the parent object ends the statement.
             Define the fields for smart objects only, not for their super procedures.
          */
         /* Note that adm-props-from-repository is intended to be replaced with
              a variable for flexible override, so it cannot be used for conditional 
              compile.  */
         if ((gshRepositoryManager.isValid()).booleanValue())
         {
            if (_not(new logical(ControlFlowOps.invokeDynamicFunctionInWithMode("prepareInstance", gshRepositoryManager, "II", valueOf(thisProcedure()), sourceProcedure()))))
            {
               stop();
            }
            
            ghAdmpropsBuf.assign(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))));
            glAdmloadFromRepos.assign(ghAdmpropsBuf.isValid());
         }
         
         /* VALID-HANDLE(gshRepositoryManager) */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
            TempTableBuilder.create(ghAdmprops);
            ghAdmprops.unwrapTempTable().setCanUndo(new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectName"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectVersion"), new character("CHAR"), new integer(0), new character(), new character("ADM2.2"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectType"), new character("CHAR"), new integer(0), new character(), new character("SmartDataObject"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerType"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("PropertyDialog"), new character("CHAR"), new integer(0), new character(), new character("adm2/support/datad.w"));
            ghAdmprops.unwrapTempTable().addNewField(new character("QueryObject"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerHandle"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("InstanceProperties"), new character("CHAR"), new integer(0), new character(), new character("AppService,ASUsePrompt,ASInfo,ForeignFields,RowsToBatch,CheckCurrentChanged,RebuildOnRepos,ServerOperatingMode,DestroyStateless,DisconnectAppServer,ObjectName,UpdateFromSource,ToggleDataTargets,OpenOnInit,PromptOnDelete,PromptColumns"));
            /* NOTE: Any need to support &User-Supported-Links?? */
            ghAdmprops.unwrapTempTable().addNewField(new character("SupportedLinks"), new character("CHAR"), new integer(0), new character(), new character("Data-Source,Data-Target,Navigation-Target,Update-Target,Commit-Target,Filter-Target"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerHidden"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectInitialized"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            /*  "hidden" is a logical concept. */
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectHidden"), new character("LOGICAL"), new integer(0), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("HideOnInit"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("UIBMode"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerSource"), new character("HANDLE"));
            /* Note that datavis adds some events that are only required for updating objects */
            /* isUpdateActive event is needed only for data, datavis and container classes,
                 but we currently define it here.. (this simplifies the logic for datavis, 
                 which may or may not inherit from container)
                 confirmOk and confirmCancel only for container ans datavis */
            ghAdmprops.unwrapTempTable().addNewField(new character("ContainerSourceEvents"), new character("CHAR"), new integer(0), new character(), new character("initializeObject,hideObject,viewObject,destroyObject,enableObject,confirmExit,confirmCancel,confirmOk,isUpdateActive"));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataSource"), new character("HANDLE"));
            /* Note that DataSourceEvents is overidden in data.i since some of these 
                 events are intended for visual targets; queryPosition, fetchDataSet, 
                 assignMaxdataguess and the most resent addition confirmUndo and 
                 confirmCommit. These two are NOT dataSourceEvents for SDOs as the message 
                 should not to be published to objects not affected by the commit/undo. */
            ghAdmprops.unwrapTempTable().addNewField(new character("DataSourceEvents"), new character("CHAR"), new integer(0), new character(), new character("dataAvailable,queryPosition,updateState,deleteComplete,fetchDataSet,confirmContinue,confirmCommit,confirmUndo,assignMaxGuess,isUpdatePending"));
            ghAdmprops.unwrapTempTable().addNewField(new character("TranslatableProperties"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ObjectPage"), new character("INT"), new integer(0), new character(), new integer(0));
            ghAdmprops.unwrapTempTable().addNewField(new character("DBAware"), new character("LOGICAL"), new integer(0), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("DesignDataObject"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataSourceNames"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("DataTarget"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataTargetEvents"), new character("CHARACTER"), new integer(0), new character(), new character("updateState,rowObjectState,fetchBatch,LinkState"));
            ghAdmprops.unwrapTempTable().addNewField(new character("LogicalObjectName"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("PhysicalObjectName"), new character("CHARACTER"), new integer(), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("LogicalVersion"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("PhysicalVersion"), new character("CHARACTER"), new integer(), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DynamicObject"), new character("LOGICAL"));
            ghAdmprops.unwrapTempTable().addNewField(new character("RunAttribute"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ChildDataKey"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ParentDataKey"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataLinksEnabled"), new character("LOGICAL"), new integer(), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("InactiveLinks"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("InstanceId"), new character("DECIMAL"));
            /* SuperProcedure management */
            ghAdmprops.unwrapTempTable().addNewField(new character("SuperProcedure"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("SuperProcedureMode"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("SuperProcedureHandle"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("LayoutPosition"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ClassName"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("RenderingProcedure"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ThinRenderingProcedure"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("Label"), new character("CHAR"), new integer(0), new character(), new unknown());
         }
         
         /* _UIB-CODE-BLOCK-END */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
            ghAdmprops.unwrapTempTable().addNewField(new character("AppService"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ASDivision"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("ASHandle"), new character("HANDLE"), new integer(0), new character(), new unknown());
            /* Set to true on the first connection */
            ghAdmprops.unwrapTempTable().addNewField(new character("ASHasStarted"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ASInfo"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ASInitializeOnRun"), new character("LOGICAL"), new integer(0), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("ASUsePrompt"), new character("LOGICAL"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("BindSignature"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("BindScope"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("ServerOperatingMode"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("ServerFileName"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("ServerFirstCall"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("NeedContext"), new character("LOGICAL"), new integer(0), new character(), new unknown());
         }
         
         /* _UIB-CODE-BLOCK-END */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
            ghAdmprops.unwrapTempTable().addNewField(new character("BaseQuery"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataColumns"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("FirstRowNum"), new character("INT"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("LastRowNum"), new character("INT"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("FirstResultRow"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("LastResultRow"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("DataColumnsByTable"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("NavigationSource"), new character("CHAR"));
            ghAdmprops.unwrapTempTable().addNewField(new character("NavigationSourceEvents"), new character("CHAR"), new integer(0), new character(), new character("fetchFirst,fetchNext,fetchPrev,fetchLast,startFilter"));
            ghAdmprops.unwrapTempTable().addNewField(new character("FilterWindow"), new character("CHAR"));
            ghAdmprops.unwrapTempTable().addNewField(new character("FilterSource"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ForeignFields"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("QueryPosition"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("BufferHandles"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("QueryHandle"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("QueryRowIdent"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("OpenOnInit"), new character("LOGICAL"), new integer(0), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("ForeignValues"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("CheckLastOnOpen"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("QueryString"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("QueryColumns"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("LastDBRowIdent"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("AssignList"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("UpdatableColumns"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("UpdatableColumnsByTable"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("Tables"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("PhysicalTables"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("TempTables"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DBNames"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("KeyFields"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("KeyTableId"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("FetchOnOpen"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("DataIsFetched"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("FilterActive"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("FilterAvailable"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("SkipTransferDBRow"), new character("LOGICAL"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("FetchHasAudit"), new character("LOGICAL"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("FetchHasComment"), new character("LOGICAL"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("FetchAutoComment"), new character("LOGICAL"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("EntityFields"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("RequiredProperties"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("TransferChildrenForAll"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("PositionForClient"), new character("CHARACTER"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("AuditEnabled"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("NewBatchInfo"), new character("CHAR"), new integer(0), new character(), new unknown());
         }
         
         /* _UIB-CODE-BLOCK-END */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
            ghAdmprops.unwrapTempTable().addNewField(new character("RowObject"), new character("HANDLE"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("RowObjUpd"), new character("HANDLE"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("RowObjectTable"), new character("HANDLE"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("RowObjUpdTable"), new character("HANDLE"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("AutoCommit"), new character("LOGICAL"), new integer(0), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataHandle"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataQueryString"), new character("CHAR"), new integer(0), new character(), new character("FOR EACH RowObject"));
            ghAdmprops.unwrapTempTable().addNewField(new character("CurrentRowid"), new character("ROWID"));
            ghAdmprops.unwrapTempTable().addNewField(new character("UpdateSource"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("CurrentUpdateSource"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("CommitSource"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("CommitSourceEvents"), new character("CHAR"), new integer(0), new character(), new character("commitTransaction,undoTransaction"));
            ghAdmprops.unwrapTempTable().addNewField(new character("CommitTarget"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("CommitTargetEvents"), new character("CHAR"), new integer(0), new character(), new character("rowObjectState"));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataModified"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("RowsToBatch"), new character("INT"), new integer(0), new character(), new integer(200));
            /* Rows per AppServer xfer */
            ghAdmprops.unwrapTempTable().addNewField(new character("CheckCurrentChanged"), new character("LOGICAL"), new integer(0), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataQueryBrowsed"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("RebuildOnRepos"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("RowObjectState"), new character("CHAR"), new integer(0), new character(), new character("NoUpdates"));
            ghAdmprops.unwrapTempTable().addNewField(new character("StatelessSavedProperties"), new character("CHAR"), new integer(0), new character(), new character("CheckCurrentChanged,RowObjectState,LastResultRow,FirstResultRow,QueryRowIdent"));
            ghAdmprops.unwrapTempTable().addNewField(new character("DestroyStateless"), new character("LOGICAL"), new integer(0), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("DisconnectAppServer"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("ServerSubmitValidation"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataFieldDefs"), new character("CHARACTER"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("QueryContainer"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("IndexInformation"), new character("CHARACTER"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("QueryContext"), new character("CHARACTER"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("FillBatchOnRepos"), new character("LOGICAL"), new integer(0), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("UpdateFromSource"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("AsynchronousSDO"), new character("LOGICAL"), new integer(), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("ToggleDataTargets"), new character("LOGICAL"), new integer(), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataLogicProcedure"), new character("CHARACTER"), new integer(), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataLogicObject"), new character("HANDLE"), new integer(), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("DataReadHandler"), new character("HANDLE"), new integer(), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("DataReadColumns"), new character("CHARACTER"), new integer(), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("DataReadBuffer"), new character("HANDLE"), new integer(), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("DataDelimiter"), new character("CHARACTER"), new integer(), new character(), new character("|"));
            ghAdmprops.unwrapTempTable().addNewField(new character("DataReadFormat"), new character("CHARACTER"), new integer(), new character(), new character("TrimNumeric"));
            ghAdmprops.unwrapTempTable().addNewField(new character("IsRowObjectExternal"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("IsRowObjUpdExternal"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            /* The following properties are used to store query manipluation strings made
               manually. If you change the query manually in code, you should set these
               properties. The filter window will retrieve these settings again when reapplying
               the filter, thus ensuring the original query is not corrupted by the Astra
               filter. Each property is chr(3) delimited to match the parameters that should
               be passed to each of the routines when reapplying them.
               
               Note that multiple entries are supported, seperated by chr(4), but this must
               be done manually - the set procedure does not do this automatically, but the
               filter will handle it when retrieving the values.
               To add multiple entries, be sure to do a get first and if a value exists, add
               a chr(4) before adding in your value and setting the new value.*/
            /* pcwhere + chr(3) + pcbuffer or empty or "?" + chr(3) + pcandor */
            ghAdmprops.unwrapTempTable().addNewField(new character("ManualAddQueryWhere"), new character("CHARACTER"));
            /* pccolumns + chr(3) + pcvalues + chr(3) + pcoperators */
            ghAdmprops.unwrapTempTable().addNewField(new character("ManualAssignQuerySelection"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("ManualSetQuerySort"), new character("CHARACTER"));
            ghAdmprops.unwrapTempTable().addNewField(new character("PromptOnDelete"), new character("LOGICAL"), new integer(0), new character(), new logical(true));
            ghAdmprops.unwrapTempTable().addNewField(new character("PromptColumns"), new character("CHAR"), new integer(0), new character(), new character(""));
            ghAdmprops.unwrapTempTable().addNewField(new character("DynamicData"), new character("LOGICAL"), new integer(0), new character(), new logical(false));
            ghAdmprops.unwrapTempTable().addNewField(new character("LastCommitErrorType"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("LastCommitErrorKeys"), new character("CHAR"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("RunDataLogicProxy"), new character("LOGICAL"), new integer(0), new character(), new unknown());
            ghAdmprops.unwrapTempTable().addNewField(new character("PrimarySDOSource"), new character("HANDLE"));
            ghAdmprops.unwrapTempTable().addNewField(new character("SchemaLocation"), new character("CHAR"), new integer(0), new character(), new character(""));
         }
         
         /* _UIB-CODE-BLOCK-END */
         /* ********************  Preprocessor Definitions  ******************** */
         /* _UIB-PREPROCESSOR-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Method-Library
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Method-Library ASSIGN
                  HEIGHT             = 8.62
                  WIDTH              = 52.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ************************* Included-Libraries *********************** */
         /* _UIB-CODE-BLOCK-END */
         /* ***************************  Main Block  *************************** */
         if (_not(glAdmloadFromRepos))
         {
            ControlFlowOps.invokeWithMode("start-super-proc", "I", new character("adm2/smart.p"));
         }
         
         /* Use the old adm definition */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
            /* Now create the one record in this property temp-table, and store its
                   handle in ADM-DATA. The CHR(1) delimiters are to set aside spots
                   for UserProperties and UserLinks. */
            ghAdmprops.unwrapTempTable().tempTablePrepare("ADMProps");
            ghAdmpropsBuf.assign(ghAdmprops.unwrapTempTable().defaultBufferHandle());
            ghAdmpropsBuf.unwrapBuffer().bufferCreate();
            /* ... and save it. This ADM object is now open for business! */
            thisProcedure().unwrapADMData().setADMData(concat(valueOf(ghAdmpropsBuf), chr(1), chr(1)));
            /* from this point  {&ADM-PROPS-DEFINED} is true for all cases */
            cObjectName.assign("AppService,ASUsePrompt,ASInfo,ForeignFields,RowsToBatch,CheckCurrentChanged,RebuildOnRepos,ServerOperatingMode,DestroyStateless,DisconnectAppServer,ObjectName,UpdateFromSource,ToggleDataTargets,OpenOnInit,PromptOnDelete,PromptColumns");
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceProperties"));
            ghProp.unwrapBufferField().changeValue(cObjectName);
            cObjectName.assign(replaceAll(thisProcedure().unwrapFile().getFileName(), "\\", "/"));
            iStart.assign(plus(lastIndexOf(cObjectName, "/"), 1));
            cObjectName.assign(substring(cObjectName, iStart, minus(lastIndexOf(thisProcedure().unwrapFile().getFileName(), "."), iStart)));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
            ghProp.unwrapBufferField().changeValue(cObjectName);
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectType"));
            ghProp.unwrapBufferField().changeValue(new character("SmartDataObject"));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerType"));
            ghProp.unwrapBufferField().changeValue(new character(""));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("PhysicalVersion"));
            ghProp.unwrapBufferField().changeValue(new character(""));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("PhysicalObjectName"));
            ghProp.unwrapBufferField().changeValue((_isNotEqual("", "") ? new character("") : thisProcedure().unwrapFile().getFileName()));
         }
         
         /* Starts super procedure */
         if (_not(glAdmloadFromRepos))
         {
            ControlFlowOps.invokeWithMode("start-super-proc", "I", new character("adm2/appserver.p"));
         }
         
         /* May have been retrieved from repository */
         /* {get Prop var [handle]} */ 
         cAppService.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAppService", targetProcedure()));
         
         /* NOTE: If REMOTE = true, we are running on an AppServer, so ignore the 
              AppService (partition) value, which is meaningful only to the client. 
              Also set the ASDivision property to Server.
              Note that AsDivision is set to 'Client' or blank in connectServer upon 
              in appserver.p */
         if ((SessionUtils.isRemote()).booleanValue())
         {
            cAppService.assign("");
            cAsdivision.assign("Server");
            cServerOperatingMode.assign(toUpperCase(SessionUtils.getServerOperatingMode()));
         }
         else
         {
            if (_isEqual(cAppService, ""))
            {
               cAppService.assign("");
            }
         }
         
         if (_isEqual(cAsdivision, ""))
         {
            cServerOperatingMode.assign("NONE");
         }
         else
         {
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setASDivision", targetProcedure(), "I", cAsdivision);
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ServerOperatingMode"));
         ghProp.unwrapBufferField().changeValue(cServerOperatingMode);
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setAppService", targetProcedure(), "I", cAppService);
         
         /* _ADM-CODE-BLOCK-START _CUSTOM _INCLUDED-LIB-CUSTOM CUSTOM */
         /*********************************************************************
         * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
         * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
         * below.  All Rights Reserved.                                       *
         *                                                                    *
         * The Initial Developer of the Original Code is PSC.  The Original   *
         * Code is Progress IDE code released to open source December 1, 2000.*
         *                                                                    *
         * The contents of this file are subject to the Possenet Public       *
         * License Version 1.0 (the "License"); you may not use this file     *
         * except in compliance with the License.  A copy of the License is   *
         * available as of the date of this notice at                         *
         * http://www.possenet.org/license.html                               *
         *                                                                    *
         * Software distributed under the License is distributed on an "AS IS"*
         * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
         * should refer to the License for the specific language governing    *
         * rights and limitations under the License.                          *
         *                                                                    *
         * Contributors:                                                      *
         *                                                                    *
         *********************************************************************/
         /*------------------------------------------------------------------------
             File        : appservercustom.i
             Purpose     : References the start of the custom super procedure.
                           Allows properties initialization.
         
             Syntax      : {src/adm2/custom/appservercustom.i}
         
             Description :
         
             Created     : 01/24/2001
             Notes       : Referenced in {src/adm2/appserver.i}
           ----------------------------------------------------------------------*/
         /*          This .W file was created with the Progress AppBuilder.      */
         /*----------------------------------------------------------------------*/
         /* ***************************  Definitions  ************************** */
         /* _UIB-CODE-BLOCK-END */
         /* ********************  Preprocessor Definitions  ******************** */
         /* _UIB-PREPROCESSOR-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Include
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Include ASSIGN
                  HEIGHT             = 15
                  WIDTH              = 60.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ***************************  Main Block  *************************** */
         /* Starts here the custom super procedure 
            Uncomment to run it */
         /*RUN start-super-proc ("adm2/custom/appservercustom.p":U).*/
         /* _UIB-CODE-BLOCK-END */
         /* _ADM-CODE-BLOCK-END */
         /* _UIB-CODE-BLOCK-END */
         /* _UIB-CODE-BLOCK-END */
         /* ***************************  Main Block  *************************** */
         if (_not(glAdmloadFromRepos))
         {
            ControlFlowOps.invokeWithMode("start-super-proc", "I", new character("adm2/query.p"));
            ControlFlowOps.invokeWithMode("start-super-proc", "I", new character("adm2/queryext.p"));
         }
         
         /* if not adm-load-from-repos */
         /* _ADM-CODE-BLOCK-START _CUSTOM _INCLUDED-LIB-CUSTOM CUSTOM */
         /*********************************************************************
         * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
         * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
         * below.  All Rights Reserved.                                       *
         *                                                                    *
         * The Initial Developer of the Original Code is PSC.  The Original   *
         * Code is Progress IDE code released to open source December 1, 2000.*
         *                                                                    *
         * The contents of this file are subject to the Possenet Public       *
         * License Version 1.0 (the "License"); you may not use this file     *
         * except in compliance with the License.  A copy of the License is   *
         * available as of the date of this notice at                         *
         * http://www.possenet.org/license.html                               *
         *                                                                    *
         * Software distributed under the License is distributed on an "AS IS"*
         * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
         * should refer to the License for the specific language governing    *
         * rights and limitations under the License.                          *
         *                                                                    *
         * Contributors:                                                      *
         *                                                                    *
         *********************************************************************/
         /*------------------------------------------------------------------------
             File        : querycustom.i
             Purpose     : References the start of the custom super procedure.
                           Allows properties initialization.
         
             Syntax      : {src/adm2/custom/querycustom.i}
         
             Description :
         
             Created     : 06/03/1999
             Notes       : Referenced in {src/adm2/query.i}
           ----------------------------------------------------------------------*/
         /*          This .W file was created with the Progress AppBuilder.      */
         /*----------------------------------------------------------------------*/
         /* ***************************  Definitions  ************************** */
         /* _UIB-CODE-BLOCK-END */
         /* ********************  Preprocessor Definitions  ******************** */
         /* _UIB-PREPROCESSOR-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Include
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Include ASSIGN
                  HEIGHT             = 15
                  WIDTH              = 60.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ***************************  Main Block  *************************** */
         /* Starts here the custom super procedure 
            Uncomment to run it */
         /*RUN start-super-proc ("adm2/custom/querycustom.p":U).*/
         /* _UIB-CODE-BLOCK-END */
         /* _ADM-CODE-BLOCK-END */
         /* _UIB-CODE-BLOCK-END */
         /* **********************  Internal Procedures  *********************** */
         /* ************************  Function Implementations ***************** */
         /* _UIB-CODE-BLOCK-END */
         /* ***************************  Main Block  *************************** */
         if (_not(glAdmloadFromRepos))
         {
            ControlFlowOps.invokeWithMode("start-super-proc", "I", new character("adm2/data.p"));
            ControlFlowOps.invokeWithMode("start-super-proc", "I", new character("adm2/dataext.p"));
            /* dataext.p is merely a simple "extension" of data.p.  This was necessary
                 because functions don't have there own action segement and data.p got
                 too big and had to be broken up.  All of the functions in dataext.p
                 are get and set property functions.  */
            ControlFlowOps.invokeWithMode("start-super-proc", "I", new character("adm2/dataextcols.p"));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceEvents"));
            ghProp.unwrapBufferField().changeValue(new character("dataAvailable,confirmContinue,isUpdatePending"));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
            ghProp.unwrapBufferField().changeValue(new logical(true));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DynamicData"));
            ghProp.unwrapBufferField().changeValue(new logical(true));
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
         ghProp.unwrapBufferField().changeValue(new logical(true));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public character getObjectType()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Type of the SmartObject, such as "SmartDataObject", etc.
                  For an ADM Super procedure, this function returns "SUPER".
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cType = TypeFactory.character();
      
      return function("getObjectType", character.class, new Block((Body) () -> 
      {
         silent(() -> 
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectType"));
            cType.assign(ghProp.unwrapBufferField().value());
         });
         returnNormal(cType);
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    * Purpose:     Procedure to start a super proc if it's not already running, <br>
    *              and to add it as a super proc in any case.<br>
    * Parameters:  Procedure name to make super.<br>
    * Notes:       NOTE: This presumes that we want only one copy of an ADM<br>
    *              super procedure running per session, meaning that they are <br>
    *              stateless and "multi-threaded". This is intended to be the case<br>
    *              for ours, but may not be true for all super procs.<br>
    *           -  The LAST-SUPER-PROCEDURE-PROP preprocessor allows classes<br>
    *              to specify a property of char or handle that stores<br>
    *              super-procedures that need to be kept at the bottom of the list <br>
    *              (defined by data.i and sbo.i if they are extended by other classes)
    */
   public void startSuperProc(final character _pcProcName)
   {
      character pcProcName = TypeFactory.initInput(_pcProcName);
      handle hProc = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         hProc.assign(ProcedureManager.firstProcedure());
         
         loopLabel0:
         while (_and(hProc.isValid(), () -> isNotEqual(hProc.unwrapFile().getFileName(), pcProcName)))
         {
            hProc.assign(hProc.unwrap().getNextSibling());
         }
         
         if (_not(hProc.isValid()))
         {
            ControlFlowOps.invokePersistentSet((pcProcName).toStringMessage(), hProc);
         }
         
         thisProcedure().unwrapCommonProcedure().addSuperProcedure(hProc, ProcedureManager.SEARCH_TARGET);
         returnNormal();
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void destroyObject()
   {
      character cDivision = TypeFactory.character();
      logical lDestroyStateless = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.runSuper("destroyObject");
         /* {get Prop var [handle]} */ 
         cDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DestroyStateless"));
         lDestroyStateless.assign(ghProp.unwrapBufferField().value());
         
         if (_or(and(isNotEqual(cDivision, "SERVER"), () -> isNotEqual(LogicalTerminal.getClientType(), "WEBSPEED")), lDestroyStateless))
         {
            /* {fn <func-name> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionIn(logical.class, "deleteProperties", targetProcedure());
         }
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    * Purpose:     DISABLE the User Interface<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       Here we clean-up the user-interface by deleting<br>
    *              dynamic widgets we have created and/or hide <br>
    *              frames.  This procedure is usually called when<br>
    *              we are ready to "clean-up" after running.
    */
   public void disableUi()
   {
      internalProcedure(new Block((Body) () -> 
      {
         /* Hide all frames. */
         if ((thisProcedure().unwrapProcedure().isPersistent()).booleanValue())
         {
            HandleOps.delete(thisProcedure());
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public void initializeObject()
   {
      handle hAppServer = TypeFactory.handle();
      character cUpdColumns = TypeFactory.character();
      character cColumnsByTable = TypeFactory.character();
      character cTables = TypeFactory.character();
      handle hContainer = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("Containersource"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         /* We need to get the table and updatablecolumns props here unless
              a data container manages the server request */
         if (_or(not(hContainer.isValid()), () -> and(hContainer.isValid(), () -> not(new logical( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(logical.class, "IsFetchPending", hContainer))))))
         {
            /* {get Prop var [handle]} */ 
            hAppServer.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getASHandle", targetProcedure()));
            
            if ((hAppServer.isValid()).booleanValue())
            {
               cUpdColumns.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdatableColumns", hAppServer));
               cTables.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getTables", hAppServer));
               cColumnsByTable.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDataColumnsByTable", hAppServer));
            }
            else
            {
               returnNormal("adm-error");
            }
            
            ControlFlowOps.invokeInWithMode("unbindServer", targetProcedure(), "I", new character("unconditional"));
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setTables", targetProcedure(), "I", cTables);
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setUpdatableColumns", targetProcedure(), "I", cUpdColumns);
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setDataColumnsByTable", targetProcedure(), "I", cColumnsByTable);
         }
         ControlFlowOps.runSuper("initializeObject");
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public character getUpdatableColumns()
   {
      return function("getUpdatableColumns", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose: Return the updatablecolumns 
             Notes: This is set from the server object in initializeServerObject.
                    Changing this does not affect which fields really are updatable, it
                    only gives an error on the client if the field are updated.
         ------------------------------------------------------------------------------*/
         returnNormal(gcUpdatable);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setRowObjectTable(final handle _phHandle_1)
   {
      handle phHandle_1 = TypeFactory.initInput(_phHandle_1);
      /*------------------------------------------------------------------------------
        Purpose: override to set Datacolumns create RowObjUpd dynamically on 
                 non-repository client 
          Notes:  
      ------------------------------------------------------------------------------*/
      logical lOk = TypeFactory.logical();
      integer i = TypeFactory.integer();
      handle hField = TypeFactory.handle();
      character cColumns = TypeFactory.character();
      handle hRowObject = TypeFactory.handle();
      
      return function("setRowObjectTable", logical.class, new Block((Body) () -> 
      {
         lOk.assign(((logical) ControlFlowOps.runSuper("setRowObjectTable", phHandle_1)));
         
         if ((lOk).booleanValue())
         {
            ControlFlowOps.invokeDynamicFunctionIn(logical.class, "createRowObjUpdTable", targetProcedure());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
            hRowObject.assign(ghProp.unwrapBufferField().value());
            
            if ((hRowObject.isValid()).booleanValue())
            {
               loopLabel1:
               for (i.assign(1); _isLessThanOrEqual(i, minus(hRowObject.unwrapBuffer().numFields(), 4)); i.increment())
               {
                  hField.assign(hRowObject.unwrapBuffer().bufferField(i));
                  cColumns.assign(concat(cColumns, (_isEqual(i, 1) ? new character("") : new character(",")), hField.unwrap().name()));
               }
            }
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataColumns"));
            ghProp.unwrapBufferField().changeValue(cColumns);
         }
         returnNormal(lOk);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setUpdatableColumns(final character _pcUpdatableColumns_1)
   {
      character pcUpdatableColumns_1 = TypeFactory.initInput(_pcUpdatableColumns_1);
      
      return function("setUpdatableColumns", logical.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose: Set updatable columns  
             Notes: Only called by non repository client  
         ------------------------------------------------------------------------------*/
         gcUpdatable.assign(pcUpdatableColumns_1);
         returnNormal(true);
      }));
   }

   public character fwdGetAdmversion()
   {
      return function("fwdGetADMVersion", character.class, new Block((Body) () -> 
      {
         returnNormal("ADM2.2");
      }));
   }
}
