package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "appsrv-tt", table = "tt1")
@LegacyIndexes(
{
   @LegacyIndex(name = "Partition", converted = "tt1_partition", primary = true, unique = true, components = 
   {
      @LegacyIndexComponent(fieldName = "partition")
   }),
   @LegacyIndex(name = "App-Service", converted = "tt1_app_service", components = 
   {
      @LegacyIndexComponent(fieldName = "app-service")
   }),
   @LegacyIndex(name = "PartitionType", converted = "tt1_partition_type", components = 
   {
      @LegacyIndexComponent(fieldName = "partitiontype")
   })
})
public class AppsrvTt_1_1Impl
implements Serializable,
           Persistable,
           AppsrvTt_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "partition", format = "X(25)", order = 0)
   private final character partition;

   /** Data member */
   @LegacyField(fieldId = 2, name = "host", format = "X(15)", order = 10)
   private final character host;

   /** Data member */
   @LegacyField(fieldId = 3, name = "service", format = "X(15)", order = 20)
   private final character service;

   /** Data member */
   @LegacyField(fieldId = 4, name = "configuration", format = "Remote/Local", initial = "false", order = 30)
   private final logical configuration;

   /** Data member */
   @LegacyField(fieldId = 5, name = "security", format = "Prompt/No", initial = "false", order = 40)
   private final logical security;

   /** AppServer Information */
   @LegacyField(fieldId = 6, name = "info", format = "X(255)", label = "AppServer Information", order = 50)
   private final character info;

   /** Data member */
   @LegacyField(fieldId = 7, name = "as-handle", initial = "?", order = 60)
   private final handle asHandle;

   /** Application Service */
   @LegacyField(fieldId = 8, name = "app-service", format = "X(25)", label = "Application Service", order = 70)
   private final character appService;

   /** Pseudo connections */
   @LegacyField(fieldId = 9, name = "conn-count", initial = "0", label = "Pseudo connections", order = 80)
   private final integer connCount;

   /** Data member */
   @LegacyField(fieldId = 10, name = "partitiontype", format = "X(10)", order = 90)
   private final character partitiontype;

   /** Data member */
   @LegacyField(fieldId = 11, name = "serverurl", format = "X(255)", order = 100)
   private final character serverurl;

   /**
    * Default constructor.
    */
   public AppsrvTt_1_1Impl()
   {
      partition = new character("");
      host = new character("");
      service = new character("");
      configuration = new logical(false);
      security = new logical(false);
      info = new character("");
      asHandle = new handle();
      appService = new character("");
      connCount = new integer(0);
      partitiontype = new character("");
      serverurl = new character("");
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public AppsrvTt_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new AppsrvTt_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      AppsrvTt_1_1Impl from = (AppsrvTt_1_1Impl) old;
      setId(from.id);
      setPartition(from.partition);
      setHost(from.host);
      setService(from.service);
      setConfiguration(from.configuration);
      setSecurity(from.security);
      setInfo(from.info);
      setAsHandle(from.asHandle);
      setAppService(from.appService);
      setConnCount(from.connCount);
      setPartitiontype(from.partitiontype);
      setServerurl(from.serverurl);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: partition
    * 
    * @return  partition
    */
   public character getPartition()
   {
      return (new character(partition));
   }

   /**
    * Setter: partition
    * 
    * @param   partition
    *          partition
    */
   public void setPartition(Text partition)
   {
      this.partition.assign(partition);
   }

   /**
    * Getter: host
    * 
    * @return  host
    */
   public character getHost()
   {
      return (new character(host));
   }

   /**
    * Setter: host
    * 
    * @param   host
    *          host
    */
   public void setHost(Text host)
   {
      this.host.assign(host);
   }

   /**
    * Getter: service
    * 
    * @return  service
    */
   public character getService()
   {
      return (new character(service));
   }

   /**
    * Setter: service
    * 
    * @param   service
    *          service
    */
   public void setService(Text service)
   {
      this.service.assign(service);
   }

   /**
    * Getter: configuration
    * 
    * @return  configuration
    */
   public logical isConfiguration()
   {
      return (new logical(configuration));
   }

   /**
    * Setter: configuration
    * 
    * @param   configuration
    *          configuration
    */
   public void setConfiguration(logical configuration)
   {
      this.configuration.assign(configuration);
   }

   /**
    * Getter: security
    * 
    * @return  security
    */
   public logical isSecurity()
   {
      return (new logical(security));
   }

   /**
    * Setter: security
    * 
    * @param   security
    *          security
    */
   public void setSecurity(logical security)
   {
      this.security.assign(security);
   }

   /**
    * Getter: AppServer Information
    * 
    * @return  AppServer Information
    */
   public character getInfo()
   {
      return (new character(info));
   }

   /**
    * Setter: AppServer Information
    * 
    * @param   info
    *          AppServer Information
    */
   public void setInfo(Text info)
   {
      this.info.assign(info);
   }

   /**
    * Getter: asHandle
    * 
    * @return  asHandle
    */
   public handle getAsHandle()
   {
      return (new handle(asHandle));
   }

   /**
    * Setter: asHandle
    * 
    * @param   asHandle
    *          asHandle
    */
   public void setAsHandle(handle asHandle)
   {
      this.asHandle.assign(asHandle);
   }

   /**
    * Getter: Application Service
    * 
    * @return  Application Service
    */
   public character getAppService()
   {
      return (new character(appService));
   }

   /**
    * Setter: Application Service
    * 
    * @param   appService
    *          Application Service
    */
   public void setAppService(Text appService)
   {
      this.appService.assign(appService);
   }

   /**
    * Getter: Pseudo connections
    * 
    * @return  Pseudo connections
    */
   public integer getConnCount()
   {
      return (new integer(connCount));
   }

   /**
    * Setter: Pseudo connections
    * 
    * @param   connCount
    *          Pseudo connections
    */
   public void setConnCount(NumberType connCount)
   {
      this.connCount.assign(connCount);
   }

   /**
    * Getter: partitiontype
    * 
    * @return  partitiontype
    */
   public character getPartitiontype()
   {
      return (new character(partitiontype));
   }

   /**
    * Setter: partitiontype
    * 
    * @param   partitiontype
    *          partitiontype
    */
   public void setPartitiontype(Text partitiontype)
   {
      this.partitiontype.assign(partitiontype);
   }

   /**
    * Getter: serverurl
    * 
    * @return  serverurl
    */
   public character getServerurl()
   {
      return (new character(serverurl));
   }

   /**
    * Setter: serverurl
    * 
    * @param   serverurl
    *          serverurl
    */
   public void setServerurl(Text serverurl)
   {
      this.serverurl.assign(serverurl);
   }
}
