package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "fwd-embedded-window", table = "tt14")
public class FwdEmbeddedWindow_1_1Impl
implements Serializable,
           Persistable,
           FwdEmbeddedWindow_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "pname", order = 0)
   private final character pname;

   /** Data member */
   @LegacyField(fieldId = 2, name = "phandle", initial = "?", order = 10)
   private final handle phandle;

   /** Data member */
   @LegacyField(fieldId = 3, name = "menubar", initial = "?", order = 20)
   private final handle menubar;

   /** Data member */
   @LegacyField(fieldId = 4, name = "toolbar", initial = "?", order = 30)
   private final handle toolbar;

   /** Data member */
   @LegacyField(fieldId = 5, name = "isadm2", initial = "false", order = 40)
   private final logical isadm2;

   /**
    * List of composite properties; 100 elements of type {@link
    * FwdEmbeddedWindow_1_1Impl.Composite100 Composite100}
    */
   private List<Composite100> composite100 = new ArrayList<>(100);

   /**
    * Default constructor.
    */
   public FwdEmbeddedWindow_1_1Impl()
   {
      pname = new character("");
      phandle = new handle();
      menubar = new handle();
      toolbar = new handle();
      isadm2 = new logical(false);
      
      // Populate Composite100 list.
      for (int i = 0; i < 100; i++)
      {
         composite100.add(new Composite100());
      }
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public FwdEmbeddedWindow_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new FwdEmbeddedWindow_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      FwdEmbeddedWindow_1_1Impl from = (FwdEmbeddedWindow_1_1Impl) old;
      setId(from.id);
      setPname(from.pname);
      setPhandle(from.phandle);
      setMenubar(from.menubar);
      setToolbar(from.toolbar);
      setIsadm2(from.isadm2);
      
      // Assign Composite100 properties.
      for (int i = 0; i < 100; i++)
      {
         setPages(i, from.composite100.get(i).pages);
         setToolbars(i, from.composite100.get(i).toolbars);
      }
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: pname
    * 
    * @return  pname
    */
   public character getPname()
   {
      return (new character(pname));
   }

   /**
    * Setter: pname
    * 
    * @param   pname
    *          pname
    */
   public void setPname(Text pname)
   {
      this.pname.assign(pname);
   }

   /**
    * Getter: phandle
    * 
    * @return  phandle
    */
   public handle getPhandle()
   {
      return (new handle(phandle));
   }

   /**
    * Setter: phandle
    * 
    * @param   phandle
    *          phandle
    */
   public void setPhandle(handle phandle)
   {
      this.phandle.assign(phandle);
   }

   /**
    * Getter: menubar
    * 
    * @return  menubar
    */
   public handle getMenubar()
   {
      return (new handle(menubar));
   }

   /**
    * Setter: menubar
    * 
    * @param   menubar
    *          menubar
    */
   public void setMenubar(handle menubar)
   {
      this.menubar.assign(menubar);
   }

   /**
    * Getter: toolbar
    * 
    * @return  toolbar
    */
   public handle getToolbar()
   {
      return (new handle(toolbar));
   }

   /**
    * Setter: toolbar
    * 
    * @param   toolbar
    *          toolbar
    */
   public void setToolbar(handle toolbar)
   {
      this.toolbar.assign(toolbar);
   }

   /**
    * Getter: isadm2
    * 
    * @return  isadm2
    */
   public logical isIsadm2()
   {
      return (new logical(isadm2));
   }

   /**
    * Setter: isadm2
    * 
    * @param   isadm2
    *          isadm2
    */
   public void setIsadm2(logical isadm2)
   {
      this.isadm2.assign(isadm2);
   }

   /**
    * Indexed Getter: pages
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 100</code>).
    * 
    * @return  pages
    */
   public logical isPages(int index)
   {
      return composite100.get(index).isPages();
   }

   /**
    * Indexed Setter: pages
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 100</code>).
    * @param   element
    *          pages
    */
   public void setPages(int index, logical element)
   {
      composite100.get(index).setPages(element);
   }

   /**
    * Indexed Getter: toolbars
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 100</code>).
    * 
    * @return  toolbars
    */
   public character getToolbars(int index)
   {
      return composite100.get(index).getToolbars();
   }

   /**
    * Indexed Setter: toolbars
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt; 100</code>).
    * @param   element
    *          toolbars
    */
   public void setToolbars(int index, Text element)
   {
      composite100.get(index).setToolbars(element);
   }

   /**
    * Inner class which composites properties of like extent. All properties migrated from the
    * legacy table <code>_temp.fwd-embedded-window</code> of extent 100 are data members of this
    * class.
    */
   static class Composite100
   implements Serializable
   {
      /** Data member */
      @LegacyField(fieldId = 6, name = "pages", initial = "false", order = 50, extent = 100)
      private final logical pages;

      /** Data member */
      @LegacyField(fieldId = 7, name = "toolbars", order = 60, extent = 100)
      private final character toolbars;

      /**
       * Default constructor.
       */
      public Composite100()
      {
         pages = new logical(false);
         toolbars = new character("");
      }

      /**
       * Getter: pages
       * 
       * @return  pages
       */
      public logical isPages()
      {
         return (new logical(pages));
      }

      /**
       * Setter: pages
       * 
       * @param   pages
       *          pages
       */
      public void setPages(logical pages)
      {
         this.pages.assign(pages);
      }

      /**
       * Getter: toolbars
       * 
       * @return  toolbars
       */
      public character getToolbars()
      {
         return (new character(toolbars));
      }

      /**
       * Setter: toolbars
       * 
       * @param   toolbars
       *          toolbars
       */
      public void setToolbars(Text toolbars)
      {
         this.toolbars.assign(toolbars);
      }
   }
}
