package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "number", table = "tt16")
public class Number_1_1Impl
implements Serializable,
           Persistable,
           Number_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "num", initial = "0", order = 0)
   private final integer num;

   /**
    * Default constructor.
    */
   public Number_1_1Impl()
   {
      num = new integer(0);
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public Number_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new Number_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      Number_1_1Impl from = (Number_1_1Impl) old;
      setId(from.id);
      setNum(from.num);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: num
    * 
    * @return  num
    */
   public integer getNum()
   {
      return (new integer(num));
   }

   /**
    * Setter: num
    * 
    * @param   num
    *          num
    */
   public void setNum(NumberType num)
   {
      this.num.assign(num);
   }
}
