package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "page-toolbar", table = "tt15")
public class PageToolbar_1_1Impl
implements Serializable,
           Persistable,
           PageToolbar_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "pname", order = 0)
   private final character pname;

   /** Data member */
   @LegacyField(fieldId = 2, name = "pnum", initial = "0", order = 10)
   private final integer pnum;

   /** Data member */
   @LegacyField(fieldId = 3, name = "button", initial = "?", order = 20)
   private final handle button;

   /**
    * Default constructor.
    */
   public PageToolbar_1_1Impl()
   {
      pname = new character("");
      pnum = new integer(0);
      button = new handle();
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public PageToolbar_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new PageToolbar_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      PageToolbar_1_1Impl from = (PageToolbar_1_1Impl) old;
      setId(from.id);
      setPname(from.pname);
      setPnum(from.pnum);
      setButton(from.button);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: pname
    * 
    * @return  pname
    */
   public character getPname()
   {
      return (new character(pname));
   }

   /**
    * Setter: pname
    * 
    * @param   pname
    *          pname
    */
   public void setPname(Text pname)
   {
      this.pname.assign(pname);
   }

   /**
    * Getter: pnum
    * 
    * @return  pnum
    */
   public integer getPnum()
   {
      return (new integer(pnum));
   }

   /**
    * Setter: pnum
    * 
    * @param   pnum
    *          pnum
    */
   public void setPnum(NumberType pnum)
   {
      this.pnum.assign(pnum);
   }

   /**
    * Getter: button
    * 
    * @return  button
    */
   public handle getButton()
   {
      return (new handle(button));
   }

   /**
    * Setter: button
    * 
    * @param   button
    *          button
    */
   public void setButton(handle button)
   {
      this.button.assign(button);
   }
}
