package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "rowobject", table = "tt17")
@LegacyIndexes(
{
   @LegacyIndex(name = "RowNum", converted = "tt17_row_num", primary = true, components = 
   {
      @LegacyIndexComponent(fieldName = "rownum")
   }),
   @LegacyIndex(name = "RowMod", converted = "tt17_row_mod", components = 
   {
      @LegacyIndexComponent(fieldName = "rowmod")
   }),
   @LegacyIndex(name = "RowIdentIdx", converted = "tt17_row_ident_idx", components = 
   {
      @LegacyIndexComponent(fieldName = "rowidentidx")
   })
})
public class Rowobject_1_1Impl
implements Serializable,
           Persistable,
           Rowobject_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "room-type", format = ">>>>>>9", initial = "0", order = 0)
   private final integer roomType;

   /** Data member */
   @LegacyField(fieldId = 2, name = "parent-type", format = ">>>>>>9", initial = "0", order = 10)
   private final integer parentType;

   /** Data member */
   @LegacyField(fieldId = 3, name = "description", format = "x(20)", order = 20)
   private final character description;

   /** Data member */
   @LegacyField(fieldId = 4, name = "rownum", initial = "0", order = 30)
   private final integer rownum;

   /** Data member */
   @LegacyField(fieldId = 5, name = "rowident", order = 40)
   private final character rowident;

   /** Data member */
   @LegacyField(fieldId = 6, name = "rowmod", order = 50)
   private final character rowmod;

   /** Data member */
   @LegacyField(fieldId = 7, name = "rowidentidx", order = 60)
   private final character rowidentidx;

   /** Data member */
   @LegacyField(fieldId = 8, name = "rowuserprop", order = 70)
   private final character rowuserprop;

   /**
    * Default constructor.
    */
   public Rowobject_1_1Impl()
   {
      roomType = new integer(0);
      parentType = new integer(0);
      description = new character("");
      rownum = new integer(0);
      rowident = new character("");
      rowmod = new character("");
      rowidentidx = new character("");
      rowuserprop = new character("");
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public Rowobject_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new Rowobject_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      Rowobject_1_1Impl from = (Rowobject_1_1Impl) old;
      setId(from.id);
      setRoomType(from.roomType);
      setParentType(from.parentType);
      setDescription(from.description);
      setRownum(from.rownum);
      setRowident(from.rowident);
      setRowmod(from.rowmod);
      setRowidentidx(from.rowidentidx);
      setRowuserprop(from.rowuserprop);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: roomType
    * 
    * @return  roomType
    */
   public integer getRoomType()
   {
      return (new integer(roomType));
   }

   /**
    * Setter: roomType
    * 
    * @param   roomType
    *          roomType
    */
   public void setRoomType(NumberType roomType)
   {
      this.roomType.assign(roomType);
   }

   /**
    * Getter: parentType
    * 
    * @return  parentType
    */
   public integer getParentType()
   {
      return (new integer(parentType));
   }

   /**
    * Setter: parentType
    * 
    * @param   parentType
    *          parentType
    */
   public void setParentType(NumberType parentType)
   {
      this.parentType.assign(parentType);
   }

   /**
    * Getter: description
    * 
    * @return  description
    */
   public character getDescription()
   {
      return (new character(description));
   }

   /**
    * Setter: description
    * 
    * @param   description
    *          description
    */
   public void setDescription(Text description)
   {
      this.description.assign(description);
   }

   /**
    * Getter: rownum
    * 
    * @return  rownum
    */
   public integer getRownum()
   {
      return (new integer(rownum));
   }

   /**
    * Setter: rownum
    * 
    * @param   rownum
    *          rownum
    */
   public void setRownum(NumberType rownum)
   {
      this.rownum.assign(rownum);
   }

   /**
    * Getter: rowident
    * 
    * @return  rowident
    */
   public character getRowident()
   {
      return (new character(rowident));
   }

   /**
    * Setter: rowident
    * 
    * @param   rowident
    *          rowident
    */
   public void setRowident(Text rowident)
   {
      this.rowident.assign(rowident);
   }

   /**
    * Getter: rowmod
    * 
    * @return  rowmod
    */
   public character getRowmod()
   {
      return (new character(rowmod));
   }

   /**
    * Setter: rowmod
    * 
    * @param   rowmod
    *          rowmod
    */
   public void setRowmod(Text rowmod)
   {
      this.rowmod.assign(rowmod);
   }

   /**
    * Getter: rowidentidx
    * 
    * @return  rowidentidx
    */
   public character getRowidentidx()
   {
      return (new character(rowidentidx));
   }

   /**
    * Setter: rowidentidx
    * 
    * @param   rowidentidx
    *          rowidentidx
    */
   public void setRowidentidx(Text rowidentidx)
   {
      this.rowidentidx.assign(rowidentidx);
   }

   /**
    * Getter: rowuserprop
    * 
    * @return  rowuserprop
    */
   public character getRowuserprop()
   {
      return (new character(rowuserprop));
   }

   /**
    * Setter: rowuserprop
    * 
    * @param   rowuserprop
    *          rowuserprop
    */
   public void setRowuserprop(Text rowuserprop)
   {
      this.rowuserprop.assign(rowuserprop);
   }
}
