package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "tt-room-type-agg", table = "tt13")
@LegacyIndexes(
{
   @LegacyIndex(name = "pi-type", converted = "tt13_pi_type", primary = true, unique = true, components = 
   {
      @LegacyIndexComponent(fieldName = "room-type")
   })
})
public class TtRoomTypeAgg_1_1Impl
implements Serializable,
           Persistable,
           TtRoomTypeAgg_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "room-type", initial = "0", order = 0)
   private final integer roomType;

   /** Data member */
   @LegacyField(fieldId = 2, name = "description", order = 10)
   private final character description;

   /** Data member */
   @LegacyField(fieldId = 3, name = "count", initial = "0", order = 20)
   private final integer count;

   /** Data member */
   @LegacyField(fieldId = 4, name = "potential-revenue", initial = "0", order = 30)
   private final decimal potentialRevenue;

   /**
    * Default constructor.
    */
   public TtRoomTypeAgg_1_1Impl()
   {
      roomType = new integer(0);
      description = new character("");
      count = new integer(0);
      potentialRevenue = new decimal(0, 2);
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public TtRoomTypeAgg_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new TtRoomTypeAgg_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      TtRoomTypeAgg_1_1Impl from = (TtRoomTypeAgg_1_1Impl) old;
      setId(from.id);
      setRoomType(from.roomType);
      setDescription(from.description);
      setCount(from.count);
      setPotentialRevenue(from.potentialRevenue);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: roomType
    * 
    * @return  roomType
    */
   public integer getRoomType()
   {
      return (new integer(roomType));
   }

   /**
    * Setter: roomType
    * 
    * @param   roomType
    *          roomType
    */
   public void setRoomType(NumberType roomType)
   {
      this.roomType.assign(roomType);
   }

   /**
    * Getter: description
    * 
    * @return  description
    */
   public character getDescription()
   {
      return (new character(description));
   }

   /**
    * Setter: description
    * 
    * @param   description
    *          description
    */
   public void setDescription(Text description)
   {
      this.description.assign(description);
   }

   /**
    * Getter: count
    * 
    * @return  count
    */
   public integer getCount()
   {
      return (new integer(count));
   }

   /**
    * Setter: count
    * 
    * @param   count
    *          count
    */
   public void setCount(NumberType count)
   {
      this.count.assign(count);
   }

   /**
    * Getter: potentialRevenue
    * 
    * @return  potentialRevenue
    */
   public decimal getPotentialRevenue()
   {
      return (new decimal(potentialRevenue));
   }

   /**
    * Setter: potentialRevenue
    * 
    * @param   potentialRevenue
    *          potentialRevenue
    */
   public void setPotentialRevenue(NumberType potentialRevenue)
   {
      this.potentialRevenue.assign(potentialRevenue);
   }
}
