package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "tt-rooms-used", table = "tt12")
@LegacyIndexes(
{
   @LegacyIndex(name = "pi-date-room", converted = "tt12_pi_date_room", primary = true, unique = true, components = 
   {
      @LegacyIndexComponent(fieldName = "use-date"),
      @LegacyIndexComponent(fieldName = "room-num")
   }),
   @LegacyIndex(name = "si-type", converted = "tt12_si_type", components = 
   {
      @LegacyIndexComponent(fieldName = "room-type")
   })
})
public class TtRoomsUsed_1_1Impl
implements Serializable,
           Persistable,
           TtRoomsUsed_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "use-date", initial = "?", order = 0)
   private final date useDate;

   /** Data member */
   @LegacyField(fieldId = 2, name = "room-num", initial = "0", order = 10)
   private final integer roomNum;

   /** Data member */
   @LegacyField(fieldId = 3, name = "room-type", initial = "0", order = 20)
   private final integer roomType;

   /** Data member */
   @LegacyField(fieldId = 4, name = "rate", initial = "0", order = 30)
   private final decimal rate;

   /**
    * Default constructor.
    */
   public TtRoomsUsed_1_1Impl()
   {
      useDate = new date();
      roomNum = new integer(0);
      roomType = new integer(0);
      rate = new decimal(0, 2);
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public TtRoomsUsed_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new TtRoomsUsed_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      TtRoomsUsed_1_1Impl from = (TtRoomsUsed_1_1Impl) old;
      setId(from.id);
      setUseDate(from.useDate);
      setRoomNum(from.roomNum);
      setRoomType(from.roomType);
      setRate(from.rate);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: useDate
    * 
    * @return  useDate
    */
   public date getUseDate()
   {
      return (new date(useDate));
   }

   /**
    * Setter: useDate
    * 
    * @param   useDate
    *          useDate
    */
   public void setUseDate(date useDate)
   {
      this.useDate.assign(useDate);
   }

   /**
    * Getter: roomNum
    * 
    * @return  roomNum
    */
   public integer getRoomNum()
   {
      return (new integer(roomNum));
   }

   /**
    * Setter: roomNum
    * 
    * @param   roomNum
    *          roomNum
    */
   public void setRoomNum(NumberType roomNum)
   {
      this.roomNum.assign(roomNum);
   }

   /**
    * Getter: roomType
    * 
    * @return  roomType
    */
   public integer getRoomType()
   {
      return (new integer(roomType));
   }

   /**
    * Setter: roomType
    * 
    * @param   roomType
    *          roomType
    */
   public void setRoomType(NumberType roomType)
   {
      this.roomType.assign(roomType);
   }

   /**
    * Getter: rate
    * 
    * @return  rate
    */
   public decimal getRate()
   {
      return (new decimal(rate));
   }

   /**
    * Setter: rate
    * 
    * @param   rate
    *          rate
    */
   public void setRate(NumberType rate)
   {
      this.rate.assign(rate);
   }
}
