package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "ttlookup", table = "tt7")
@LegacyIndexes(
{
   @LegacyIndex(name = "keyIndex", converted = "tt7_key_index", primary = true, components = 
   {
      @LegacyIndexComponent(fieldName = "hwidget"),
      @LegacyIndexComponent(fieldName = "cwidgetname")
   }),
   @LegacyIndex(name = "keyCont", converted = "tt7_key_cont", components = 
   {
      @LegacyIndexComponent(fieldName = "hviewer")
   }),
   @LegacyIndex(name = "keyDouble", converted = "tt7_key_double", components = 
   {
      @LegacyIndexComponent(fieldName = "hviewer"),
      @LegacyIndexComponent(fieldName = "lrefreshquery")
   }),
   @LegacyIndex(name = "key2", converted = "tt7_key2", components = 
   {
      @LegacyIndexComponent(fieldName = "cwidgetname"),
      @LegacyIndexComponent(fieldName = "hwidget")
   })
})
public class Ttlookup_1_1Impl
implements Serializable,
           Persistable,
           Ttlookup_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "hwidget", initial = "?", order = 0)
   private final handle hwidget;

   /** Data member */
   @LegacyField(fieldId = 2, name = "hviewer", initial = "?", order = 10)
   private final handle hviewer;

   /** Data member */
   @LegacyField(fieldId = 3, name = "cwidgetname", order = 20)
   private final character cwidgetname;

   /** Data member */
   @LegacyField(fieldId = 4, name = "cwidgettype", order = 30)
   private final character cwidgettype;

   /** Data member */
   @LegacyField(fieldId = 5, name = "cforeach", order = 40)
   private final character cforeach;

   /** Data member */
   @LegacyField(fieldId = 6, name = "cbufferlist", order = 50)
   private final character cbufferlist;

   /** Data member */
   @LegacyField(fieldId = 7, name = "cphysicaltablenames", order = 60)
   private final character cphysicaltablenames;

   /** Data member */
   @LegacyField(fieldId = 8, name = "ctemptablenames", order = 70)
   private final character ctemptablenames;

   /** Data member */
   @LegacyField(fieldId = 9, name = "cfieldlist", order = 80)
   private final character cfieldlist;

   /** Data member */
   @LegacyField(fieldId = 10, name = "cdatatypelist", order = 90)
   private final character cdatatypelist;

   /** Data member */
   @LegacyField(fieldId = 11, name = "cfounddatavalues", order = 100)
   private final character cfounddatavalues;

   /** Data member */
   @LegacyField(fieldId = 12, name = "crowident", order = 110)
   private final character crowident;

   /** Data member */
   @LegacyField(fieldId = 13, name = "lmorefound", initial = "false", order = 120)
   private final logical lmorefound;

   /** Data member */
   @LegacyField(fieldId = 14, name = "lrefreshquery", initial = "false", order = 130)
   private final logical lrefreshquery;

   /** Data member */
   @LegacyField(fieldId = 15, name = "cscreenvalue", order = 140)
   private final character cscreenvalue;

   /** Data member */
   @LegacyField(fieldId = 16, name = "lpopuponambiguous", initial = "false", order = 150)
   private final logical lpopuponambiguous;

   /** Data member */
   @LegacyField(fieldId = 17, name = "lpopuponuniqueambiguous", initial = "false", order = 160)
   private final logical lpopuponuniqueambiguous;

   /** Data member */
   @LegacyField(fieldId = 18, name = "lusecache", initial = "false", order = 170)
   private final logical lusecache;

   /**
    * Default constructor.
    */
   public Ttlookup_1_1Impl()
   {
      hwidget = new handle();
      hviewer = new handle();
      cwidgetname = new character("");
      cwidgettype = new character("");
      cforeach = new character("");
      cbufferlist = new character("");
      cphysicaltablenames = new character("");
      ctemptablenames = new character("");
      cfieldlist = new character("");
      cdatatypelist = new character("");
      cfounddatavalues = new character("");
      crowident = new character("");
      lmorefound = new logical(false);
      lrefreshquery = new logical(false);
      cscreenvalue = new character("");
      lpopuponambiguous = new logical(false);
      lpopuponuniqueambiguous = new logical(false);
      lusecache = new logical(false);
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public Ttlookup_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new Ttlookup_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      Ttlookup_1_1Impl from = (Ttlookup_1_1Impl) old;
      setId(from.id);
      setHwidget(from.hwidget);
      setHviewer(from.hviewer);
      setCwidgetname(from.cwidgetname);
      setCwidgettype(from.cwidgettype);
      setCforeach(from.cforeach);
      setCbufferlist(from.cbufferlist);
      setCphysicaltablenames(from.cphysicaltablenames);
      setCtemptablenames(from.ctemptablenames);
      setCfieldlist(from.cfieldlist);
      setCdatatypelist(from.cdatatypelist);
      setCfounddatavalues(from.cfounddatavalues);
      setCrowident(from.crowident);
      setLmorefound(from.lmorefound);
      setLrefreshquery(from.lrefreshquery);
      setCscreenvalue(from.cscreenvalue);
      setLpopuponambiguous(from.lpopuponambiguous);
      setLpopuponuniqueambiguous(from.lpopuponuniqueambiguous);
      setLusecache(from.lusecache);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: hwidget
    * 
    * @return  hwidget
    */
   public handle getHwidget()
   {
      return (new handle(hwidget));
   }

   /**
    * Setter: hwidget
    * 
    * @param   hwidget
    *          hwidget
    */
   public void setHwidget(handle hwidget)
   {
      this.hwidget.assign(hwidget);
   }

   /**
    * Getter: hviewer
    * 
    * @return  hviewer
    */
   public handle getHviewer()
   {
      return (new handle(hviewer));
   }

   /**
    * Setter: hviewer
    * 
    * @param   hviewer
    *          hviewer
    */
   public void setHviewer(handle hviewer)
   {
      this.hviewer.assign(hviewer);
   }

   /**
    * Getter: cwidgetname
    * 
    * @return  cwidgetname
    */
   public character getCwidgetname()
   {
      return (new character(cwidgetname));
   }

   /**
    * Setter: cwidgetname
    * 
    * @param   cwidgetname
    *          cwidgetname
    */
   public void setCwidgetname(Text cwidgetname)
   {
      this.cwidgetname.assign(cwidgetname);
   }

   /**
    * Getter: cwidgettype
    * 
    * @return  cwidgettype
    */
   public character getCwidgettype()
   {
      return (new character(cwidgettype));
   }

   /**
    * Setter: cwidgettype
    * 
    * @param   cwidgettype
    *          cwidgettype
    */
   public void setCwidgettype(Text cwidgettype)
   {
      this.cwidgettype.assign(cwidgettype);
   }

   /**
    * Getter: cforeach
    * 
    * @return  cforeach
    */
   public character getCforeach()
   {
      return (new character(cforeach));
   }

   /**
    * Setter: cforeach
    * 
    * @param   cforeach
    *          cforeach
    */
   public void setCforeach(Text cforeach)
   {
      this.cforeach.assign(cforeach);
   }

   /**
    * Getter: cbufferlist
    * 
    * @return  cbufferlist
    */
   public character getCbufferlist()
   {
      return (new character(cbufferlist));
   }

   /**
    * Setter: cbufferlist
    * 
    * @param   cbufferlist
    *          cbufferlist
    */
   public void setCbufferlist(Text cbufferlist)
   {
      this.cbufferlist.assign(cbufferlist);
   }

   /**
    * Getter: cphysicaltablenames
    * 
    * @return  cphysicaltablenames
    */
   public character getCphysicaltablenames()
   {
      return (new character(cphysicaltablenames));
   }

   /**
    * Setter: cphysicaltablenames
    * 
    * @param   cphysicaltablenames
    *          cphysicaltablenames
    */
   public void setCphysicaltablenames(Text cphysicaltablenames)
   {
      this.cphysicaltablenames.assign(cphysicaltablenames);
   }

   /**
    * Getter: ctemptablenames
    * 
    * @return  ctemptablenames
    */
   public character getCtemptablenames()
   {
      return (new character(ctemptablenames));
   }

   /**
    * Setter: ctemptablenames
    * 
    * @param   ctemptablenames
    *          ctemptablenames
    */
   public void setCtemptablenames(Text ctemptablenames)
   {
      this.ctemptablenames.assign(ctemptablenames);
   }

   /**
    * Getter: cfieldlist
    * 
    * @return  cfieldlist
    */
   public character getCfieldlist()
   {
      return (new character(cfieldlist));
   }

   /**
    * Setter: cfieldlist
    * 
    * @param   cfieldlist
    *          cfieldlist
    */
   public void setCfieldlist(Text cfieldlist)
   {
      this.cfieldlist.assign(cfieldlist);
   }

   /**
    * Getter: cdatatypelist
    * 
    * @return  cdatatypelist
    */
   public character getCdatatypelist()
   {
      return (new character(cdatatypelist));
   }

   /**
    * Setter: cdatatypelist
    * 
    * @param   cdatatypelist
    *          cdatatypelist
    */
   public void setCdatatypelist(Text cdatatypelist)
   {
      this.cdatatypelist.assign(cdatatypelist);
   }

   /**
    * Getter: cfounddatavalues
    * 
    * @return  cfounddatavalues
    */
   public character getCfounddatavalues()
   {
      return (new character(cfounddatavalues));
   }

   /**
    * Setter: cfounddatavalues
    * 
    * @param   cfounddatavalues
    *          cfounddatavalues
    */
   public void setCfounddatavalues(Text cfounddatavalues)
   {
      this.cfounddatavalues.assign(cfounddatavalues);
   }

   /**
    * Getter: crowident
    * 
    * @return  crowident
    */
   public character getCrowident()
   {
      return (new character(crowident));
   }

   /**
    * Setter: crowident
    * 
    * @param   crowident
    *          crowident
    */
   public void setCrowident(Text crowident)
   {
      this.crowident.assign(crowident);
   }

   /**
    * Getter: lmorefound
    * 
    * @return  lmorefound
    */
   public logical isLmorefound()
   {
      return (new logical(lmorefound));
   }

   /**
    * Setter: lmorefound
    * 
    * @param   lmorefound
    *          lmorefound
    */
   public void setLmorefound(logical lmorefound)
   {
      this.lmorefound.assign(lmorefound);
   }

   /**
    * Getter: lrefreshquery
    * 
    * @return  lrefreshquery
    */
   public logical isLrefreshquery()
   {
      return (new logical(lrefreshquery));
   }

   /**
    * Setter: lrefreshquery
    * 
    * @param   lrefreshquery
    *          lrefreshquery
    */
   public void setLrefreshquery(logical lrefreshquery)
   {
      this.lrefreshquery.assign(lrefreshquery);
   }

   /**
    * Getter: cscreenvalue
    * 
    * @return  cscreenvalue
    */
   public character getCscreenvalue()
   {
      return (new character(cscreenvalue));
   }

   /**
    * Setter: cscreenvalue
    * 
    * @param   cscreenvalue
    *          cscreenvalue
    */
   public void setCscreenvalue(Text cscreenvalue)
   {
      this.cscreenvalue.assign(cscreenvalue);
   }

   /**
    * Getter: lpopuponambiguous
    * 
    * @return  lpopuponambiguous
    */
   public logical isLpopuponambiguous()
   {
      return (new logical(lpopuponambiguous));
   }

   /**
    * Setter: lpopuponambiguous
    * 
    * @param   lpopuponambiguous
    *          lpopuponambiguous
    */
   public void setLpopuponambiguous(logical lpopuponambiguous)
   {
      this.lpopuponambiguous.assign(lpopuponambiguous);
   }

   /**
    * Getter: lpopuponuniqueambiguous
    * 
    * @return  lpopuponuniqueambiguous
    */
   public logical isLpopuponuniqueambiguous()
   {
      return (new logical(lpopuponuniqueambiguous));
   }

   /**
    * Setter: lpopuponuniqueambiguous
    * 
    * @param   lpopuponuniqueambiguous
    *          lpopuponuniqueambiguous
    */
   public void setLpopuponuniqueambiguous(logical lpopuponuniqueambiguous)
   {
      this.lpopuponuniqueambiguous.assign(lpopuponuniqueambiguous);
   }

   /**
    * Getter: lusecache
    * 
    * @return  lusecache
    */
   public logical isLusecache()
   {
      return (new logical(lusecache));
   }

   /**
    * Setter: lusecache
    * 
    * @param   lusecache
    *          lusecache
    */
   public void setLusecache(logical lusecache)
   {
      this.lusecache.assign(lusecache);
   }
}
