package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "ttnode", table = "tt11")
@LegacyIndexes(
{
   @LegacyIndex(name = "id", converted = "tt11_identifier", components = 
   {
      @LegacyIndexComponent(fieldName = "id")
   })
})
public class Ttnode_1_1Impl
implements Serializable,
           Persistable,
           Ttnode_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "id", order = 0)
   private final character identifier;

   /** Data member */
   @LegacyField(fieldId = 2, name = "parentid", order = 10)
   private final character parentid;

   /** Data member */
   @LegacyField(fieldId = 3, name = "nodetext", order = 20)
   private final character nodetext;

   /** Data member */
   @LegacyField(fieldId = 4, name = "rowident", order = 30)
   private final character rowident;

   /** Data member */
   @LegacyField(fieldId = 5, name = "securitylevel", order = 40)
   private final character securitylevel;

   /** Data member */
   @LegacyField(fieldId = 6, name = "imagename", order = 50)
   private final character imagename;

   /** Data member */
   @LegacyField(fieldId = 7, name = "active", order = 60)
   private final character active;

   /** Data member */
   @LegacyField(fieldId = 8, name = "usercode", order = 70)
   private final character usercode;

   /** Data member */
   @LegacyField(fieldId = 9, name = "instanceseqno", initial = "0", order = 80)
   private final integer instanceseqno;

   /** Data member */
   @LegacyField(fieldId = 10, name = "nodetexthandle", initial = "?", order = 90)
   private final handle nodetexthandle;

   /** Data member */
   @LegacyField(fieldId = 11, name = "nodeopenerimagehandle", initial = "?", order = 100)
   private final handle nodeopenerimagehandle;

   /** Data member */
   @LegacyField(fieldId = 12, name = "nodeframehandle", initial = "?", order = 110)
   private final handle nodeframehandle;

   /**
    * Default constructor.
    */
   public Ttnode_1_1Impl()
   {
      identifier = new character("");
      parentid = new character("");
      nodetext = new character("");
      rowident = new character("");
      securitylevel = new character("");
      imagename = new character("");
      active = new character("");
      usercode = new character("");
      instanceseqno = new integer(0);
      nodetexthandle = new handle();
      nodeopenerimagehandle = new handle();
      nodeframehandle = new handle();
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public Ttnode_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new Ttnode_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      Ttnode_1_1Impl from = (Ttnode_1_1Impl) old;
      setId(from.id);
      setIdentifier(from.identifier);
      setParentid(from.parentid);
      setNodetext(from.nodetext);
      setRowident(from.rowident);
      setSecuritylevel(from.securitylevel);
      setImagename(from.imagename);
      setActive(from.active);
      setUsercode(from.usercode);
      setInstanceseqno(from.instanceseqno);
      setNodetexthandle(from.nodetexthandle);
      setNodeopenerimagehandle(from.nodeopenerimagehandle);
      setNodeframehandle(from.nodeframehandle);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: identifier
    * 
    * @return  identifier
    */
   public character getIdentifier()
   {
      return (new character(identifier));
   }

   /**
    * Setter: identifier
    * 
    * @param   identifier
    *          identifier
    */
   public void setIdentifier(Text identifier)
   {
      this.identifier.assign(identifier);
   }

   /**
    * Getter: parentid
    * 
    * @return  parentid
    */
   public character getParentid()
   {
      return (new character(parentid));
   }

   /**
    * Setter: parentid
    * 
    * @param   parentid
    *          parentid
    */
   public void setParentid(Text parentid)
   {
      this.parentid.assign(parentid);
   }

   /**
    * Getter: nodetext
    * 
    * @return  nodetext
    */
   public character getNodetext()
   {
      return (new character(nodetext));
   }

   /**
    * Setter: nodetext
    * 
    * @param   nodetext
    *          nodetext
    */
   public void setNodetext(Text nodetext)
   {
      this.nodetext.assign(nodetext);
   }

   /**
    * Getter: rowident
    * 
    * @return  rowident
    */
   public character getRowident()
   {
      return (new character(rowident));
   }

   /**
    * Setter: rowident
    * 
    * @param   rowident
    *          rowident
    */
   public void setRowident(Text rowident)
   {
      this.rowident.assign(rowident);
   }

   /**
    * Getter: securitylevel
    * 
    * @return  securitylevel
    */
   public character getSecuritylevel()
   {
      return (new character(securitylevel));
   }

   /**
    * Setter: securitylevel
    * 
    * @param   securitylevel
    *          securitylevel
    */
   public void setSecuritylevel(Text securitylevel)
   {
      this.securitylevel.assign(securitylevel);
   }

   /**
    * Getter: imagename
    * 
    * @return  imagename
    */
   public character getImagename()
   {
      return (new character(imagename));
   }

   /**
    * Setter: imagename
    * 
    * @param   imagename
    *          imagename
    */
   public void setImagename(Text imagename)
   {
      this.imagename.assign(imagename);
   }

   /**
    * Getter: active
    * 
    * @return  active
    */
   public character getActive()
   {
      return (new character(active));
   }

   /**
    * Setter: active
    * 
    * @param   active
    *          active
    */
   public void setActive(Text active)
   {
      this.active.assign(active);
   }

   /**
    * Getter: usercode
    * 
    * @return  usercode
    */
   public character getUsercode()
   {
      return (new character(usercode));
   }

   /**
    * Setter: usercode
    * 
    * @param   usercode
    *          usercode
    */
   public void setUsercode(Text usercode)
   {
      this.usercode.assign(usercode);
   }

   /**
    * Getter: instanceseqno
    * 
    * @return  instanceseqno
    */
   public integer getInstanceseqno()
   {
      return (new integer(instanceseqno));
   }

   /**
    * Setter: instanceseqno
    * 
    * @param   instanceseqno
    *          instanceseqno
    */
   public void setInstanceseqno(NumberType instanceseqno)
   {
      this.instanceseqno.assign(instanceseqno);
   }

   /**
    * Getter: nodetexthandle
    * 
    * @return  nodetexthandle
    */
   public handle getNodetexthandle()
   {
      return (new handle(nodetexthandle));
   }

   /**
    * Setter: nodetexthandle
    * 
    * @param   nodetexthandle
    *          nodetexthandle
    */
   public void setNodetexthandle(handle nodetexthandle)
   {
      this.nodetexthandle.assign(nodetexthandle);
   }

   /**
    * Getter: nodeopenerimagehandle
    * 
    * @return  nodeopenerimagehandle
    */
   public handle getNodeopenerimagehandle()
   {
      return (new handle(nodeopenerimagehandle));
   }

   /**
    * Setter: nodeopenerimagehandle
    * 
    * @param   nodeopenerimagehandle
    *          nodeopenerimagehandle
    */
   public void setNodeopenerimagehandle(handle nodeopenerimagehandle)
   {
      this.nodeopenerimagehandle.assign(nodeopenerimagehandle);
   }

   /**
    * Getter: nodeframehandle
    * 
    * @return  nodeframehandle
    */
   public handle getNodeframehandle()
   {
      return (new handle(nodeframehandle));
   }

   /**
    * Setter: nodeframehandle
    * 
    * @param   nodeframehandle
    *          nodeframehandle
    */
   public void setNodeframehandle(handle nodeframehandle)
   {
      this.nodeframehandle.assign(nodeframehandle);
   }
}
