package com.goldencode.hotel.dmo._temp.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;
import com.goldencode.hotel.dmo._temp.*;

/** Data Model Object corresponding with a temporary table. */
@LegacyTable(name = "tttranslate", table = "tt2")
@LegacyIndexes(
{
   @LegacyIndex(name = "key1", converted = "tt2_key1", primary = true, unique = true, components = 
   {
      @LegacyIndexComponent(fieldName = "dlanguageobj"),
      @LegacyIndexComponent(fieldName = "cobjectname"),
      @LegacyIndexComponent(fieldName = "cwidgettype"),
      @LegacyIndexComponent(fieldName = "cwidgetname"),
      @LegacyIndexComponent(fieldName = "hwidgethandle"),
      @LegacyIndexComponent(fieldName = "iwidgetentry")
   }),
   @LegacyIndex(name = "key2", converted = "tt2_key2", components = 
   {
      @LegacyIndexComponent(fieldName = "clanguagename"),
      @LegacyIndexComponent(fieldName = "cobjectname"),
      @LegacyIndexComponent(fieldName = "cwidgettype"),
      @LegacyIndexComponent(fieldName = "cwidgetname"),
      @LegacyIndexComponent(fieldName = "iwidgetentry")
   }),
   @LegacyIndex(name = "key3", converted = "tt2_key3", components = 
   {
      @LegacyIndexComponent(fieldName = "cobjectname"),
      @LegacyIndexComponent(fieldName = "cwidgettype"),
      @LegacyIndexComponent(fieldName = "cwidgetname"),
      @LegacyIndexComponent(fieldName = "iwidgetentry")
   }),
   @LegacyIndex(name = "key4", converted = "tt2_key4", components = 
   {
      @LegacyIndexComponent(fieldName = "cwidgetname"),
      @LegacyIndexComponent(fieldName = "iwidgetentry"),
      @LegacyIndexComponent(fieldName = "cobjectname"),
      @LegacyIndexComponent(fieldName = "cwidgettype")
   })
})
public class Tttranslate_1_1Impl
implements Serializable,
           Persistable,
           Tttranslate_1_1
{
   /** Multiplex ID */
   private Integer _multiplex = null;

   /** Surrogate primary key */
   private Long id = null;

   /** Data member */
   @LegacyField(fieldId = 1, name = "dlanguageobj", initial = "0", order = 0)
   private final decimal dlanguageobj;

   /** Data member */
   @LegacyField(fieldId = 2, name = "dsourcelanguageobj", initial = "0", order = 10)
   private final decimal dsourcelanguageobj;

   /** Language */
   @LegacyField(fieldId = 3, name = "clanguagename", format = "X(20)", label = "Language", order = 20)
   private final character clanguagename;

   /** Object name */
   @LegacyField(fieldId = 4, name = "cobjectname", format = "X(40)", label = "Object name", order = 30)
   private final character cobjectname;

   /** Global */
   @LegacyField(fieldId = 5, name = "lglobal", format = "YES/NO", initial = "false", label = "Global", order = 40)
   private final logical lglobal;

   /** Data member */
   @LegacyField(fieldId = 6, name = "lextractedglobal", initial = "false", order = 50)
   private final logical lextractedglobal;

   /** Widget type */
   @LegacyField(fieldId = 7, name = "cwidgettype", format = "X(20)", label = "Widget type", order = 60)
   private final character cwidgettype;

   /** Widget name */
   @LegacyField(fieldId = 8, name = "cwidgetname", format = "X(40)", label = "Widget name", order = 70)
   private final character cwidgetname;

   /** Data member */
   @LegacyField(fieldId = 9, name = "hwidgethandle", initial = "?", order = 80)
   private final handle hwidgethandle;

   /** Element */
   @LegacyField(fieldId = 10, name = "iwidgetentry", format = ">9", initial = "0", label = "Element", order = 90)
   private final integer iwidgetentry;

   /** Delete */
   @LegacyField(fieldId = 11, name = "ldelete", format = "YES/NO", initial = "false", label = "Delete", order = 100)
   private final logical ldelete;

   /** Translated label */
   @LegacyField(fieldId = 12, name = "ctranslatedlabel", format = "X(60)", label = "Translated label", order = 110)
   private final character ctranslatedlabel;

   /** Original label */
   @LegacyField(fieldId = 13, name = "coriginallabel", format = "X(60)", label = "Original label", order = 120)
   private final character coriginallabel;

   /** Translated tooltip */
   @LegacyField(fieldId = 14, name = "ctranslatedtooltip", format = "X(70)", label = "Translated tooltip", order = 130)
   private final character ctranslatedtooltip;

   /** Original tooltip */
   @LegacyField(fieldId = 15, name = "coriginaltooltip", format = "X(70)", label = "Original tooltip", order = 140)
   private final character coriginaltooltip;

   /**
    * Default constructor.
    */
   public Tttranslate_1_1Impl()
   {
      dlanguageobj = new decimal(0);
      dsourcelanguageobj = new decimal(0);
      clanguagename = new character("");
      cobjectname = new character("");
      lglobal = new logical(false);
      lextractedglobal = new logical(false);
      cwidgettype = new character("");
      cwidgetname = new character("");
      hwidgethandle = new handle();
      iwidgetentry = new integer(0);
      ldelete = new logical(false);
      ctranslatedlabel = new character("");
      coriginallabel = new character("");
      ctranslatedtooltip = new character("");
      coriginaltooltip = new character("");
   }

   /**
    * Constructor which accepts a multiplex ID.
    * 
    * @param   multiplexID
    *          Multiplex ID.
    */
   public Tttranslate_1_1Impl(Integer multiplexID)
   {
      this();
      _multiplex = multiplexID;
   }

   /**
    * Make a deep copy of the current DMO instance and return it.
    * 
    * @return  A new instance of this class whose data is identical to that of this instance.
    */
   public Undoable deepCopy()
   {
      Undoable copy = new Tttranslate_1_1Impl();
      copy.assign(this);
      return copy;
   }

   /**
    * Modify the contained data of the instance to copy the instance data from the given, backup
    * instance.
    * 
    * @param   old
    *          The backup instance from which to copy data.
    */
   public void assign(Undoable old)
   {
      Tttranslate_1_1Impl from = (Tttranslate_1_1Impl) old;
      setId(from.id);
      setDlanguageobj(from.dlanguageobj);
      setDsourcelanguageobj(from.dsourcelanguageobj);
      setClanguagename(from.clanguagename);
      setCobjectname(from.cobjectname);
      setLglobal(from.lglobal);
      setLextractedglobal(from.lextractedglobal);
      setCwidgettype(from.cwidgettype);
      setCwidgetname(from.cwidgetname);
      setHwidgethandle(from.hwidgethandle);
      setIwidgetentry(from.iwidgetentry);
      setLdelete(from.ldelete);
      setCtranslatedlabel(from.ctranslatedlabel);
      setCoriginallabel(from.coriginallabel);
      setCtranslatedtooltip(from.ctranslatedtooltip);
      setCoriginaltooltip(from.coriginaltooltip);
   }

   /**
    * Getter: Surrogate primary key
    * 
    * @return  Primary key
    */
   public Long getId()
   {
      return id;
   }

   /**
    * Setter: Surrogate primary key
    * 
    * @param   id
    *          Primary key
    */
   public void setId(Long id)
   {
      this.id = id;
   }

   /**
    * Getter: dlanguageobj
    * 
    * @return  dlanguageobj
    */
   public decimal getDlanguageobj()
   {
      return (new decimal(dlanguageobj));
   }

   /**
    * Setter: dlanguageobj
    * 
    * @param   dlanguageobj
    *          dlanguageobj
    */
   public void setDlanguageobj(NumberType dlanguageobj)
   {
      this.dlanguageobj.assign(dlanguageobj);
   }

   /**
    * Getter: dsourcelanguageobj
    * 
    * @return  dsourcelanguageobj
    */
   public decimal getDsourcelanguageobj()
   {
      return (new decimal(dsourcelanguageobj));
   }

   /**
    * Setter: dsourcelanguageobj
    * 
    * @param   dsourcelanguageobj
    *          dsourcelanguageobj
    */
   public void setDsourcelanguageobj(NumberType dsourcelanguageobj)
   {
      this.dsourcelanguageobj.assign(dsourcelanguageobj);
   }

   /**
    * Getter: Language
    * 
    * @return  Language
    */
   public character getClanguagename()
   {
      return (new character(clanguagename));
   }

   /**
    * Setter: Language
    * 
    * @param   clanguagename
    *          Language
    */
   public void setClanguagename(Text clanguagename)
   {
      this.clanguagename.assign(clanguagename);
   }

   /**
    * Getter: Object name
    * 
    * @return  Object name
    */
   public character getCobjectname()
   {
      return (new character(cobjectname));
   }

   /**
    * Setter: Object name
    * 
    * @param   cobjectname
    *          Object name
    */
   public void setCobjectname(Text cobjectname)
   {
      this.cobjectname.assign(cobjectname);
   }

   /**
    * Getter: Global
    * 
    * @return  Global
    */
   public logical isLglobal()
   {
      return (new logical(lglobal));
   }

   /**
    * Setter: Global
    * 
    * @param   lglobal
    *          Global
    */
   public void setLglobal(logical lglobal)
   {
      this.lglobal.assign(lglobal);
   }

   /**
    * Getter: lextractedglobal
    * 
    * @return  lextractedglobal
    */
   public logical isLextractedglobal()
   {
      return (new logical(lextractedglobal));
   }

   /**
    * Setter: lextractedglobal
    * 
    * @param   lextractedglobal
    *          lextractedglobal
    */
   public void setLextractedglobal(logical lextractedglobal)
   {
      this.lextractedglobal.assign(lextractedglobal);
   }

   /**
    * Getter: Widget type
    * 
    * @return  Widget type
    */
   public character getCwidgettype()
   {
      return (new character(cwidgettype));
   }

   /**
    * Setter: Widget type
    * 
    * @param   cwidgettype
    *          Widget type
    */
   public void setCwidgettype(Text cwidgettype)
   {
      this.cwidgettype.assign(cwidgettype);
   }

   /**
    * Getter: Widget name
    * 
    * @return  Widget name
    */
   public character getCwidgetname()
   {
      return (new character(cwidgetname));
   }

   /**
    * Setter: Widget name
    * 
    * @param   cwidgetname
    *          Widget name
    */
   public void setCwidgetname(Text cwidgetname)
   {
      this.cwidgetname.assign(cwidgetname);
   }

   /**
    * Getter: hwidgethandle
    * 
    * @return  hwidgethandle
    */
   public handle getHwidgethandle()
   {
      return (new handle(hwidgethandle));
   }

   /**
    * Setter: hwidgethandle
    * 
    * @param   hwidgethandle
    *          hwidgethandle
    */
   public void setHwidgethandle(handle hwidgethandle)
   {
      this.hwidgethandle.assign(hwidgethandle);
   }

   /**
    * Getter: Element
    * 
    * @return  Element
    */
   public integer getIwidgetentry()
   {
      return (new integer(iwidgetentry));
   }

   /**
    * Setter: Element
    * 
    * @param   iwidgetentry
    *          Element
    */
   public void setIwidgetentry(NumberType iwidgetentry)
   {
      this.iwidgetentry.assign(iwidgetentry);
   }

   /**
    * Getter: Delete
    * 
    * @return  Delete
    */
   public logical isLdelete()
   {
      return (new logical(ldelete));
   }

   /**
    * Setter: Delete
    * 
    * @param   ldelete
    *          Delete
    */
   public void setLdelete(logical ldelete)
   {
      this.ldelete.assign(ldelete);
   }

   /**
    * Getter: Translated label
    * 
    * @return  Translated label
    */
   public character getCtranslatedlabel()
   {
      return (new character(ctranslatedlabel));
   }

   /**
    * Setter: Translated label
    * 
    * @param   ctranslatedlabel
    *          Translated label
    */
   public void setCtranslatedlabel(Text ctranslatedlabel)
   {
      this.ctranslatedlabel.assign(ctranslatedlabel);
   }

   /**
    * Getter: Original label
    * 
    * @return  Original label
    */
   public character getCoriginallabel()
   {
      return (new character(coriginallabel));
   }

   /**
    * Setter: Original label
    * 
    * @param   coriginallabel
    *          Original label
    */
   public void setCoriginallabel(Text coriginallabel)
   {
      this.coriginallabel.assign(coriginallabel);
   }

   /**
    * Getter: Translated tooltip
    * 
    * @return  Translated tooltip
    */
   public character getCtranslatedtooltip()
   {
      return (new character(ctranslatedtooltip));
   }

   /**
    * Setter: Translated tooltip
    * 
    * @param   ctranslatedtooltip
    *          Translated tooltip
    */
   public void setCtranslatedtooltip(Text ctranslatedtooltip)
   {
      this.ctranslatedtooltip.assign(ctranslatedtooltip);
   }

   /**
    * Getter: Original tooltip
    * 
    * @return  Original tooltip
    */
   public character getCoriginaltooltip()
   {
      return (new character(coriginaltooltip));
   }

   /**
    * Setter: Original tooltip
    * 
    * @param   coriginaltooltip
    *          Original tooltip
    */
   public void setCoriginaltooltip(Text coriginaltooltip)
   {
      this.coriginaltooltip.assign(coriginaltooltip);
   }
}
