package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.guest</code> (previously
 * <code>hotel.guest</code>).
 * <p>
 * Guest staying in a room
 */
public interface Guest
extends DataModelObject
{
   /**
    * Getter: Stay ID
    * 
    * @return  Stay ID
    */
   public integer getStayId();

   /**
    * Setter: Stay ID
    * 
    * @param   stayId
    *          Stay ID
    */
   public void setStayId(NumberType stayId);

   /**
    * Getter: Display Order
    * 
    * @return  Display Order
    */
   public integer getOrder();

   /**
    * Setter: Display Order
    * 
    * @param   order
    *          Display Order
    */
   public void setOrder(NumberType order);

   /**
    * Getter: First Name
    * 
    * @return  First Name
    */
   public character getFirstName();

   /**
    * Setter: First Name
    * 
    * @param   firstName
    *          First Name
    */
   public void setFirstName(Text firstName);

   /**
    * Getter: Last Name
    * 
    * @return  Last Name
    */
   public character getLastName();

   /**
    * Setter: Last Name
    * 
    * @param   lastName
    *          Last Name
    */
   public void setLastName(Text lastName);

   /**
    * Getter: ID Type
    * 
    * @return  ID Type
    */
   public integer getGuestIdType();

   /**
    * Setter: ID Type
    * 
    * @param   guestIdType
    *          ID Type
    */
   public void setGuestIdType(NumberType guestIdType);

   /**
    * Getter: ID Number
    * 
    * @return  ID Number
    */
   public character getGuestIdNum();

   /**
    * Setter: ID Number
    * 
    * @param   guestIdNum
    *          ID Number
    */
   public void setGuestIdNum(Text guestIdNum);

   /**
    * Getter: Phone Number
    * 
    * @return  Phone Number
    */
   public character getPhone();

   /**
    * Setter: Phone Number
    * 
    * @param   phone
    *          Phone Number
    */
   public void setPhone(Text phone);

   /**
    * Getter: Date of Birth
    * 
    * @return  Date of Birth
    */
   public date getBirthDate();

   /**
    * Setter: Date of Birth
    * 
    * @param   birthDate
    *          Date of Birth
    */
   public void setBirthDate(date birthDate);

   /**
    * Getter: Country
    * 
    * @return  Country
    */
   public character getCountry();

   /**
    * Setter: Country
    * 
    * @param   country
    *          Country
    */
   public void setCountry(Text country);

   /**
    * Getter: City
    * 
    * @return  City
    */
   public character getCity();

   /**
    * Setter: City
    * 
    * @param   city
    *          City
    */
   public void setCity(Text city);

   /**
    * Getter: Address
    * 
    * @return  Address
    */
   public character getAddress();

   /**
    * Setter: Address
    * 
    * @param   address
    *          Address
    */
   public void setAddress(Text address);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends Guest, Buffer
   {
   }
}
