package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.guest_id_type</code> (previously
 * <code>hotel.guest-id-type</code>).
 * <p>
 * Possible types of guests' identity documents
 */
public interface GuestIdType
extends DataModelObject
{
   /**
    * Getter: ID type
    * 
    * @return  ID type
    */
   public integer getIdType();

   /**
    * Setter: ID type
    * 
    * @param   idType
    *          ID type
    */
   public void setIdType(NumberType idType);

   /**
    * Getter: Description
    * 
    * @return  Description
    */
   public character getDescription();

   /**
    * Setter: Description
    * 
    * @param   description
    *          Description
    */
   public void setDescription(Text description);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends GuestIdType, Buffer
   {
   }
}
