package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.rate</code> (previously
 * <code>hotel.rate</code>).
 * <p>
 * Rates for rooms
 */
public interface Rate
extends DataModelObject
{
   /**
    * Getter: Room Type
    * 
    * @return  Room Type
    */
   public integer getRoomType();

   /**
    * Setter: Room Type
    * 
    * @param   roomType
    *          Room Type
    */
   public void setRoomType(NumberType roomType);

   /**
    * Getter: Date when rate starts.
    * 
    * @return  Start Date
    */
   public date getStartDate();

   /**
    * Setter: Date when rate starts.
    * 
    * @param   startDate
    *          Start Date
    */
   public void setStartDate(date startDate);

   /**
    * Getter: Date when rate ends (inclusive).
    * 
    * @return  End Date
    */
   public date getEndDate();

   /**
    * Setter: Date when rate ends (inclusive).
    * 
    * @param   endDate
    *          End Date
    */
   public void setEndDate(date endDate);

   /**
    * Getter: Rate
    * 
    * @return  Rate
    */
   public decimal getRate();

   /**
    * Setter: Rate
    * 
    * @param   rate
    *          Rate
    */
   public void setRate(NumberType rate);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends Rate, Buffer
   {
   }
}
