package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.reservation</code> (previously
 * <code>hotel.reservation</code>).
 * <p>
 * Room reservations
 */
public interface Reservation
extends DataModelObject
{
   /**
    * Getter: Room Number
    * 
    * @return  Room Number
    */
   public integer getRoomNum();

   /**
    * Setter: Room Number
    * 
    * @param   roomNum
    *          Room Number
    */
   public void setRoomNum(NumberType roomNum);

   /**
    * Getter: Check-in Date
    * 
    * @return  Check-in Date
    */
   public date getStartDate();

   /**
    * Setter: Check-in Date
    * 
    * @param   startDate
    *          Check-in Date
    */
   public void setStartDate(date startDate);

   /**
    * Getter: Check-out Date
    * 
    * @return  Check-out Date
    */
   public date getEndDate();

   /**
    * Setter: Check-out Date
    * 
    * @param   endDate
    *          Check-out Date
    */
   public void setEndDate(date endDate);

   /**
    * Getter: Guest
    * 
    * @return  Guest
    */
   public character getGuest();

   /**
    * Setter: Guest
    * 
    * @param   guest
    *          Guest
    */
   public void setGuest(Text guest);

   /**
    * Getter: Number of Guests
    * 
    * @return  Number of Guests
    */
   public integer getNumGuests();

   /**
    * Setter: Number of Guests
    * 
    * @param   numGuests
    *          Number of Guests
    */
   public void setNumGuests(NumberType numGuests);

   /**
    * Getter: Price
    * 
    * @return  Price
    */
   public decimal getPrice();

   /**
    * Setter: Price
    * 
    * @param   price
    *          Price
    */
   public void setPrice(NumberType price);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends Reservation, Buffer
   {
   }
}
