package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.room</code> (previously
 * <code>hotel.room</code>).
 * <p>
 * Hotel rooms
 */
public interface Room
extends DataModelObject
{
   /**
    * Getter: Room Number
    * 
    * @return  Room Number
    */
   public integer getRoomNum();

   /**
    * Setter: Room Number
    * 
    * @param   roomNum
    *          Room Number
    */
   public void setRoomNum(NumberType roomNum);

   /**
    * Getter: Floor
    * 
    * @return  Floor
    */
   public integer getFloor();

   /**
    * Setter: Floor
    * 
    * @param   floor
    *          Floor
    */
   public void setFloor(NumberType floor);

   /**
    * Getter: Room Type
    * 
    * @return  Room Type
    */
   public integer getRoomType();

   /**
    * Setter: Room Type
    * 
    * @param   roomType
    *          Room Type
    */
   public void setRoomType(NumberType roomType);

   /**
    * Getter: Active
    * 
    * @return  Active
    */
   public logical isActive();

   /**
    * Setter: Active
    * 
    * @param   active
    *          Active
    */
   public void setActive(logical active);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends Room, Buffer
   {
   }
}
