package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.room_type</code> (previously
 * <code>hotel.room-type</code>).
 * <p>
 * Room types, e.g. standard or luxury rooms
 */
public interface RoomType
extends DataModelObject
{
   /**
    * Getter: Room Type
    * 
    * @return  Room Type
    */
   public integer getRoomType();

   /**
    * Setter: Room Type
    * 
    * @param   roomType
    *          Room Type
    */
   public void setRoomType(NumberType roomType);

   /**
    * Getter: Parent Type
    * 
    * @return  Parent Type
    */
   public integer getParentType();

   /**
    * Setter: Parent Type
    * 
    * @param   parentType
    *          Parent Type
    */
   public void setParentType(NumberType parentType);

   /**
    * Getter: Description
    * 
    * @return  Description
    */
   public character getDescription();

   /**
    * Setter: Description
    * 
    * @param   description
    *          Description
    */
   public void setDescription(Text description);

   /**
    * Getter: Image
    * 
    * @return  Image
    */
   public character getImage();

   /**
    * Setter: Image
    * 
    * @param   image
    *          Image
    */
   public void setImage(Text image);

   /**
    * Getter: Maximum Persons
    * 
    * @return  Maximum Persons
    */
   public integer getMaxPersons();

   /**
    * Setter: Maximum Persons
    * 
    * @param   maxPersons
    *          Maximum Persons
    */
   public void setMaxPersons(NumberType maxPersons);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends RoomType, Buffer
   {
   }
}
