package com.goldencode.hotel.dmo.hotel;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>hotel.service</code> (previously
 * <code>hotel.service</code>).
 * <p>
 * Additional services
 */
public interface Service
extends DataModelObject
{
   /**
    * Getter: Stay ID
    * 
    * @return  Stay ID
    */
   public integer getStayId();

   /**
    * Setter: Stay ID
    * 
    * @param   stayId
    *          Stay ID
    */
   public void setStayId(NumberType stayId);

   /**
    * Getter: Charge Amount
    * 
    * @return  Charge Amount
    */
   public decimal getAmount();

   /**
    * Setter: Charge Amount
    * 
    * @param   amount
    *          Charge Amount
    */
   public void setAmount(NumberType amount);

   /**
    * Getter: Date
    * 
    * @return  Date
    */
   public date getServiceDate();

   /**
    * Setter: Date
    * 
    * @param   serviceDate
    *          Date
    */
   public void setServiceDate(date serviceDate);

   /**
    * Getter: Service Type
    * 
    * @return  Service Type
    */
   public integer getServiceType();

   /**
    * Setter: Service Type
    * 
    * @param   serviceType
    *          Service Type
    */
   public void setServiceType(NumberType serviceType);

   /**
    * DMO interface for use by converted business logic.
    */
   public interface Buf
   extends Service, Buffer
   {
   }
}
