/*--------------------------------------------------------------------------
    File        : Containr.java
    Purpose     : Code common to all containers, including WIndows and Frames

    Syntax      : adm2/containr.p

    Modified    : August 1, 2000 Version 9.1B
    Modified    : 10/18/2001        Mark Davies (MIP)
                  Added check in destroyObject to make sure that the
                  gshProfileManager handle is valid before attempting
                  to run something in that handle. This was to resolve
                  IssueZilla issue #2593
                  
    Modified    : 04/11/2002        mdsantos@progress.com (MJS)
                  Adapted for WebSpeed by changing SESSION:PARAM = "REMOTE" 
                  to SESSION:CLIENT-TYPE = "WEBSPEED" in procedure toolbar
                  
  ------------------------------------------------------------------------*/

package com.goldencode.hotel.common.adm2;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.hotel.dmo._temp.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.util.*;
import com.goldencode.p2j.persist.lock.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.persist.RecordBuffer.batch;
import static com.goldencode.p2j.util.ErrorManager.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in common/adm2/containr.p).
 */
public class Containr
{
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*---------------------------------------------------------------------------------
     File: tttranslate.i
   
     Description:  Multi-Translation temp-table
   
     Purpose:      Multi-Translation temp-table
   
     Parameters:   <none>
   
     History:
     --------
     Modified: 05/07/2002 - Mark Davies (MIP)
               Added field for Source Language obj
     
   -----------------------------------------------------------------*/   
   /*                   This .W file was created with the Progress UIB.             */   
   /*-------------------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* MIP-GET-OBJECT-VERSION pre-processors
      The following pre-processors are maintained automatically when the object is
      saved. They pull the object and version from Roundtable if possible so that it
      can be displayed in the about window of the container */   
   /* MIP object identifying preprocessor */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 5.62
            WIDTH              = 64.4.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   Tttranslate_1_1.Buf tttranslate = TemporaryBuffer.define(Tttranslate_1_1.Buf.class, "tttranslate", "ttTranslate", false, false);

   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* Tell cntnattr.i that this is the Super Procedure */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : containrexclcustom.i
       Purpose     : Defines EXCLUDE-xxx preprocessor variables to exclude
                     functions or internal procedures in the super procedure
                     where it is referenced.
       Syntax      : {src/adm2/custom/containrexclcustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in src/adm2/containr.p
     ------------------------------------------------------------------------*/   
   /* This variable is needed at least temporarily in 9.1B so that a called
      fn can tell who the actual source was.  */   
   handle ghTargetProcedure = TypeFactory.handle();

   character gcCurrentObjectName = TypeFactory.character();

   integer giPrevPage = TypeFactory.integer();

   /* _UIB-CODE-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Procedure
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: CODE-ONLY COMPILE
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Procedure ASSIGN
            HEIGHT             = 22.05
            WIDTH              = 55.8.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ************************* Included-Libraries *********************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : cntnprop.i
       Purpose     : Starts containr.p super procedure and defines general
                     SmartContainer properties and other values.
       Syntax      : {src/adm2/cntnprop.i}
   
       Description :
   
       Modified    : August 1, 2000 -- Version 9.1B
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : containrdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/containrdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/cntnprop.i}
     ------------------------------------------------------------------------*/   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 4.52
            WIDTH              = 66.6.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Include the file which defines prototypes for all of the super
        procedure's entry points. Also, start or attach to the super procedure.
        Skip start-super-proc if we *are* the super procedure. 
        And skip including the prototypes if we are *any* super procedure. */   
   /* Preprocs to identify to compiler which properties are in the temp-table.*/   
   /* comma delimited list of pages to construct at startup or * for all or empty for just start page and page 0 */   
   /* for support of Layout Managers */   
   /* for support Navigation as Pass-Through link */   
   /* List of pages that must be initialised together with a specific page. */   
   /* Now include the next-level-up property include file. This builds up
        the property temp-table definition, which we will then add our 
        field definitions to. If this is a non-visual ('virtual') container,
        then skip the visual properties */   
   /* visprop has the same conditional inclusion of appserver as above */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : visprop.i
       Purpose     : Starts Super procedure visual.p and defines basic properties
                     for visual SmartObjects in V9
       Syntax      : {src/adm2/visprop.i}
   
       Description :
   
       Modified    : May 19, 1999 Version 9.1A
       Modified    : 10/23/2001          Mark Davies (MIP)
                     Added two new fields for ResizeHorizontal and ResizeVertical
       Modified    : 11/02/2001          Mark Davies (MIP)
                     Replaced properties for FrameMinHeightChars and FrameMinWidthChars with MinHeight and MinWidth
       Modified    : 11/14/2001          Mark Davies (MIP)
                     Renamed property 'DisplayFieldsSecurity' to 'FieldSecurity'
       Modified    : 02/27/2003          Neil Bell (MIP)
                     Added property 'SecuredTokens'                  
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : visualdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/visualdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/visprop.i}
     ------------------------------------------------------------------------*/   
   /* This is the procedure to execute to set InstanceProperties at design time. */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 8
            WIDTH              = 60.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Include the file which defines prototypes for all of the super
        procedure's entry points. Also, start or attach to the super procedure.
        Skip start-super-proc if we *are* the super procedure. 
        And skip including the prototypes if we are *any* super procedure. */   
   /* These preprocessors tell at compile time which properties can be
        retrieved directly from the temp-table. */   
   /* This property contains the security for all objects found in the AllFieldHandles Property */    
   /* Include the next property file up the chain (in this case, the top
        of the chain); it starts the property temp-table definition and we
        add our field definitions to it. */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smrtprop.i
       Purpose     : Starts smart.p super procedure and defines general
                     SmartObject properties and other values.
       Syntax      : {src/adm2/smrtprop.i}
   
       Description :
   
       Modified    : February 4, 2000 - Version 9.1B
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smartdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/smartdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/smrtprop.i}
     ------------------------------------------------------------------------*/   
   /* Service Managers */   
   /*********************************************************************
   * Copyright (C) 2000-2002 by Progress Software Corporation ("PSC"),  *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*---------------------------------------------------------------------------------
     File: globals.i
   
     Description:  ICF Global Shared Variables
   
     Purpose:      ICF Global Shared Variables
                   The global shared variables available within the Dynamics environment.
                   
                   NOTE: (Dynamic Only )
                   Shared variables do not span the client / server boundary. On the
                   client these are set-up in afstartupp.p and on the server in the agent
                   as_startup.p
                   Also note if we include the guts of a procedure as an internal
                   procedure for shared client/server code, we sometime need to
                   ensure the shared variables are not redefined.
   
     Parameters:   <none>
   
     History:
     --------
   
     Modified: 11/08/2001 - Mark Davies (MIP)
               Copied code for ICF afglobals.i and added here to allow
               ICF changed adm code to compile. afglobals.i now includes
               this file for definitions.
               Any ADM code will now reference globals.i which excludes any other
               ICF specific includes.
   -----------------------------------------------------------*/   
   /*                   This .W file was created with the Progress UIB.             */   
   /*-------------------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 5.57
            WIDTH              = 64.4.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Used whereever Crystal is used and when defining the tt_datasource temp-table 
      to define the maximum columns supported when printing to crystal.
      See browsercustom.p and afcrpplip2p.p for example uses
   */   
   /* Used for filter checks */   
   /* The table delimiter used in assignlist, *ColumnsByTable props */   
   handle gshAstraAppserver /* quick access to all handles on object, e.g. viewer, whether enabled or not */  /* quick access to all fields on object, e.g. viewer, whether enabled or not */ = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshastraappserver", true, new handle());

   /* Handle to Astra Application Server Partition */   
   handle gshSessionManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsessionmanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshRimanager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrimanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshSecurityManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsecuritymanager", true, new handle());

   /* Handle Astra Security Manager */   
   handle gshProfileManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshprofilemanager", true, new handle());

   /* Handle Astra Profile Manager */   
   handle gshRepositoryManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrepositorymanager", true, new handle());

   /* Handle Astra Repository Manager */   
   handle gshTranslationManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshtranslationmanager", true, new handle());

   /* Handle Astra Translation Manager */   
   handle gshWebManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshwebmanager", true, new handle());

   /* Handle Astra Web Manager */   
   character gscSessionId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gscsessionid", true, new character(""));

   /* Unique session id */   
   decimal gsdSessionObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionobj", true, new decimal(0));

   /* Unique session id */   
   handle gshFinManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshfinmanager", true, new handle());

   /* Handle AstraFin Generic Manager */   
   handle gshGenManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshgenmanager", true, new handle());

   /* Handle AstraFramework Generic Manager */   
   handle gshAgnManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshagnmanager", true, new handle());

   /* Handle AstraGen Generic Manager */   
   decimal gsdTempUniqueId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdtempuniqueid", true, new decimal(0));

   /* A number for unique objects */   
   decimal gsdUserObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsduserobj", true, new decimal(0));

   /* User Object ID */   
   decimal gsdRenderTypeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdrendertypeobj", true, new decimal(0));

   /* Render Type Object ID */   
   decimal gsdSessionScopeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionscopeobj", true, new decimal(0));

   /* Render Type Object ID */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*------------------------------------------------------------------------
       File        : globalscustom.i
       Purpose     : The developer can create his own version of this to 
                     allow 'global' definitions to be added to the 
                     framework.   
       Syntax      : {src/adm2/custom/globalscustom.i}
   
       Description :
   
       Created     : 06/03/1999
       Notes       : Referenced in {src/adm2/globals.i}
     ----------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress AppBuilder.      */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* define the ADM Version and broker handle for all SmartObjects */   
   /* Note that adm-props-from-repository is documented as possible to define
        as a variable for flexible override, so it cannot be used for conditional 
        compile.  */   
   /* adm-props-from-repository is supported to be defined as a variable,
       so it is not used for conditional compile */   
   handle ghProp = TypeFactory.handle();

   /**
    * External procedure (converted to Java from the 4GL source code
    * in common/adm2/containr.p).
    */
   public void execute()
   {
      externalProcedure(Containr.this, new Block((Init) () -> 
      {
         gsdSessionObj.setPrecision(9);
         gsdTempUniqueId.setPrecision(9);
         gsdUserObj.setPrecision(9);
         gsdRenderTypeObj.setPrecision(9);
         gsdSessionScopeObj.setPrecision(9);
      }, 
      (Body) () -> 
      {
         RecordBuffer.openScope(tttranslate);
         
         /* _UIB-CODE-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Method-Library
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Method-Library ASSIGN
                  HEIGHT             = 14.86
                  WIDTH              = 57.2.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ***************************  Main Block  *************************** */
         /* Include the file which defines prototypes for all of the super
              procedure's entry points. Also, start or attach to the super procedure.
              Skip start-super-proc if we *are* the super procedure. 
              And skip including the prototypes if we are *any* super procedure. */
         /* These preprocessors let the get and set methods know at compile time
             which property values are located in the temp-table and which must
             be accessed through the property functions.
          */
         /* for support of dynamic objects */
         /* physical name - no path */
         /* for support of runtime parameters passed from the menus */
         /* Properties for super procedure management */
         /* The name of the super procedure; can be a CSV list */ 
 /* STATELESS, STATEFUL; the mode that all supers for the object will be launched in */ 
 /* Runtime property storing handles to the object's super procedures, defined in SuperProcedure. */
         /* Layout support for dynamic objects */
         /* contains a layout position that allows an object to be laid out correctly. */
         /* determine if we need to create the prop fields here or from the */
         /* repository (if ICF is running ) */
         /* COMMENT THE FOLLOWING LINE TO USE THE "<class>prop.i" DEFINITIONS */
         /* This temp-table defines all the propertt fields for an object.
             This include file contributes the DEFINE statement header and
             all basic smart object properties. Each other property class include file
             adds its own fields and then the parent object ends the statement.
             Define the fields for smart objects only, not for their super procedures.
          */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
         
         /* _UIB-CODE-BLOCK-END */
         /* else if appserver aware (adecomm/appserv.i) include appserver props */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
         
         /* _UIB-CODE-BLOCK-END */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public character getObjectType()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Type of the SmartObject, such as "SmartDataObject", etc.
                  For an ADM Super procedure, this function returns "SUPER".
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cType = TypeFactory.character();
      
      return function("getObjectType", character.class, new Block((Body) () -> 
      {
         cType.assign("SUPER");
         returnNormal(cType);
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    * Purpose:  Sets the specified property in all objects on the CurrentPage of<br>
    *           calling SmartContainer.<br>
    *  Params:  INPUT pcProp AS CHARACTER  property to set.<br>
    *           INPUT pcValue AS CHARACTER  value to assign to that property. <br>
    *               This is specified in CHARACTER form but can be used to<br>
    *               assign values to non-character properties.<br>
    *   Notes:  This variation on assignLinkProperty is necessary because <br>
    *           the notion of paging does not fit well with PUBLISH/SUBSCRIBE. <br>
    *           All objects in a Container will subscribe to initializeObject, etc., <br>
    *           but the paging performs the operation on subsets of those objects <br>
    *           at a time. That is, the container will not publish 'iniializeObject'<br>
    *           to objects on a page other than zero until that page is first <br>
    *           viewed.  So properties such as HideOnInit which are set as part <br>
    *           of initialization must be set page-by-page.
    */
   public void assignPageProperty(final character _pcProp, final character _pcValue)
   {
      character pcProp = TypeFactory.initInput(_pcProp);
      character pcValue = TypeFactory.initInput(_pcValue);
      integer iVar = TypeFactory.integer();
      character cObjects = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         iVar.assign(ghProp.unwrapBufferField().value());
         cObjects.assign(pageNtargets(targetProcedure(), iVar));
         
         IntegerExpression resExpr0 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cObjects);
            }
         };
         ToClause toClause0 = new ToClause(iVar, 1, resExpr0);
         
         doTo("loopLabel0", toClause0, new Block((Body) () -> 
         {
            silent(() -> ControlFlowOps.invokeDynamicFunctionInWithMode(concat("set", pcProp), handle.fromString(entry(iVar, cObjects)), "I", pcValue));
         }));
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     server-side procedure to prepare and open a query on all<br>
    *              SDOs (rowObject buffers).<br>
    * Parameters:  pcQueries AS CHARACTER <br>
    *              - CHR(1)-delimited-list of QueryString properties.<br>
    *                The list is in ContainedDataObject order, which also includes <br>
    *                one entry for each SDO inside an SBO.... <br>
    *                Blank entries means that the BaseQuery should be used.  <br>
    *              pcPositions AS CHARACTER <br>
    *              - reserved for future use <br>
    *   Notes:  This is the internal buffer logic used on the server side of <br>
    *           the container class fetchContainedData and is called thru one of <br>
    *           severalfetchData APIs that has output parameters for the table <br>
    *           handles.
    */
   public void bufferFetchContainedData(final character _pcQueries_1, final character _pcPositions)
   {
      character pcQueries_1 = TypeFactory.initInput(_pcQueries_1);
      character pcPositions = TypeFactory.initInput(_pcPositions);
      character cObjects = TypeFactory.character();
      integer iObject = TypeFactory.integer();
      handle hObject = TypeFactory.handle();
      character cQueryString = TypeFactory.character();
      character cTargets = TypeFactory.character();
      integer iTarget = TypeFactory.integer();
      handle hTarget = TypeFactory.handle();
      logical lQuery = TypeFactory.logical();
      handle hSource = TypeFactory.handle();
      character cSkipList = TypeFactory.character();
      handle hSkip = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cObjects.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
         cTargets.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr1 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cObjects);
            }
         };
         ToClause toClause1 = new ToClause(iObject, 1, resExpr1);
         
         doTo("loopLabel1", toClause1, new Block((Body) () -> 
         {
            hObject.assign(handle.fromString(entry(iObject, cObjects)));
            cQueryString.assign(entry(iObject, pcQueries_1, chr(1)));
            
            /* We pass SKIP in order to get the RowObject definition for dynamic SDOs 
                   that has OpenOnInit false  */
            if (_isNotEqual(cQueryString, "SKIP"))
            {
               /* Blank means use base query */
               if (_isEqual(cQueryString, ""))
               {
                  /* {get Prop var [handle]} */
                  cQueryString.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getBaseQuery", hObject));
               }
               
               /* {set Prop value [handle]} */
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryString", hObject, "I", cQueryString);
            }
            else
            {
               cSkipList.assign(concat(cSkipList, (_isEqual(cSkipList, "") ? new character("") : new character(",")), valueOf(hObject)));
            }
         }));
         
         IntegerExpression resExpr2 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cTargets);
            }
         };
         ToClause toClause2 = new ToClause(iTarget, 1, resExpr2);
         
         doTo("loopLabel2", toClause2, new Block((Body) () -> 
         {
            hTarget.assign(handle.fromString(entry(iTarget, cTargets)));
            ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
            lQuery.assign(ghProp.unwrapBufferField().value());
            
            if ((lQuery).booleanValue())
            {
               hSkip.setUnknown();
               /* If this is an SBO the 'skip' was registered against the master 
                        SDO above */
               /* {get Prop var [handle]} */
               silent(() -> hSkip.assign(ControlFlowOps.invokeDynamicFunctionIn("getMasterDataObject", hTarget)));
               
               if (_not(hSkip.isValid()))
               {
                  hSkip.assign(hTarget);
               }
               
               if (_isEqual(lookup(valueOf(hSkip), cSkipList), 0))
               {
                  /* {get Prop var [handle]} */
                  hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hTarget));
                  
                  if (_not(hSource.isValid()))
                  {
                     /* {fn <func-name> [handle] */
                     ControlFlowOps.invokeDynamicFunctionIn(logical.class, "openQuery", hTarget);
                  }
               }
            }
         }));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:    Procedure that makes a new batch of data available in the dataQuery<br>
    *             in one of the contained SDOs and all its data-link children.<br>
    * Parameters:  <br>
    *   INPUT  pcQueries     -  CHR(1)-delimited-list of QueryString properties of <br>
    *                           the SDOs. ( SKIP indicate which SDOs to skip) <br>
    *   INPUT  piStartRow    -  The RowNum value of the record to start the batch<br>
    *                           to return.  Typically piStartRow is ? as a flag to <br>
    *                           use pcRowIdent instead of piStartRow.<br>
    *   INPUT  pcRowIdent     - The RowIdent of the first record of the batch to<br>
    *                           to return.  Can also be "FIRST" or "LAST" to force<br>
    *                           the retrieval of the first (or last) batch of <br>
    *                           RowObject records.<br>
    *   INPUT  plNext         - True if serverSendRows is to start on the "next"<br>
    *                           record from what is indicated by piStartRow or<br>
    *                           piRowIdent.<br>
    *   INPUT  piRowsToReturn - The number of rows in a batch.<br>
    *   OUTPUT piRowsReturned - The actual number of rows returned. This number<br>
    *                           will either be the same as piRowsToReturn or<br>
    *                           less when there are not enough records to fill<br>
    *                           up the batch.<br>
    *   Notes:  This is the internal buffer logic used on the server side of <br>
    *           fetchContainedRows and is called thru one of several <br>
    *          fetchContainedRows APIs that has output parameters for the table <br>
    *           handles.    <br>
    *       -  (it could be changed to be called on the client, by changing the <br>
    *           call to sendRows to call fetchContainedRows and fix <br>
    *           fetchContainedRows to have logic that calls sendRows on 'server', <br>
    *           but it does not make any sense to change the query during batching)
    */
   public void bufferFetchContainedRows(final character _pcQueries_1, final character _piStartRow, final character _pcRowIdent, final character _plNext, final integer _piRowsToReturn, final integer piRowsReturned)
   {
      character pcQueries_1 = TypeFactory.initInput(_pcQueries_1);
      character piStartRow = TypeFactory.initInput(_piStartRow);
      character pcRowIdent = TypeFactory.initInput(_pcRowIdent);
      character plNext = TypeFactory.initInput(_plNext);
      integer piRowsToReturn = TypeFactory.initInput(_piRowsToReturn);
      character cTargets = TypeFactory.character();
      handle hFirstSdo = TypeFactory.handle();
      handle hTarget = TypeFactory.handle();
      integer iTarget = TypeFactory.integer();
      logical lQuery = TypeFactory.logical();
      handle hSource = TypeFactory.handle();
      character cSdos = TypeFactory.character();
      handle hMaster = TypeFactory.handle();
      character cPosition = TypeFactory.character();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(piRowsReturned);
      }, 
      (Body) () -> 
      {
         hFirstSdo /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "assignQueries", targetProcedure(), "I", pcQueries_1));
         ControlFlowOps.invokeInWithMode("sendRows", hFirstSdo, "IIIIO", piStartRow, pcRowIdent, plNext, piRowsToReturn, piRowsReturned);
         
         /* We need to position similar to the how the client will position to
              ensure that child data objects also return the right data.
              The logic here is very similar to what happens on the client in 
              clientSendRows.
              (It may be moved into a common method in the future, possibly 
               opendataQuery extended to handle positionForClient) */
         if (_isEqual(pcRowIdent, "LAST"))
         {
            /* {fnarg <func-name> <arg> [handle] */
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "openDataQuery", hFirstSdo, "I", "LAST");
         }
         else
         {
            if (_isEqual(pcRowIdent, "FIRST"))
            {
               /* {fnarg <func-name> <arg> [handle] */
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "openDataQuery", hFirstSdo, "I", "FIRST");
            }
            else
            {
               /* {get Prop var [handle]} */
               cPosition.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getPositionForClient", hFirstSdo));
               
               if (_isGreaterThan(cPosition, ""))
               {
                  /* {fnarg <func-name> <arg> [handle] */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "openDataQuery", hFirstSdo, "I", "");
                  /* {fnarg <func-name> <arg> [handle] */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowObjectUseRowident", hFirstSdo, "I", cPosition);
               }
               else
               {
                  /* {fnarg <func-name> <arg> [handle] */
                   /* What ??? hmm... better find something */ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "openDataQuery", hFirstSdo, "I", "FIRST");
               }
            }
         }
         NamedEventManager.publish("DataAvailable", hFirstSdo, "I", new Object[]
         {
            "DIFFERENT"
         });
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
         cTargets.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr3 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cTargets);
            }
         };
         ToClause toClause3 = new ToClause(iTarget, 1, resExpr3);
         
         doTo("loopLabel3", toClause3, new Block((Body) () -> 
         {
            hTarget.assign(handle.fromString(entry(iTarget, cTargets)));
            
            if (_isEqual(hTarget, hFirstSdo))
            {
               next("loopLabel3");
            }
            
            /* A master has no source so ensure that it is not opened here. 
                   It can only be batched above */
            /* {get Prop var [handle]} */ 
            silent(() -> hMaster.assign(ControlFlowOps.invokeDynamicFunctionIn("getMasterDataObject", targetProcedure())));
            
            if (_isEqual(hTarget, hMaster))
            {
               next("loopLabel3");
            }
            
            silent(() -> 
            {
               ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
               cSdos.assign(ghProp.unwrapBufferField().value());
            });
            
            if (_isGreaterThan(lookup(valueOf(hFirstSdo), cSdos), 0))
            {
               next("loopLabel3");
            }
            
            ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
            lQuery.assign(ghProp.unwrapBufferField().value());
            
            if ((lQuery).booleanValue())
            {
               /* {get Prop var [handle]} */
               hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hTarget));
               
               if (_not(hSource.isValid()))
               {
                  /* {fn <func-name> [handle] */
                  ControlFlowOps.invokeDynamicFunctionIn(logical.class, "openQuery", hTarget);
               }
            }
         }));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose: Cancel an object.                  <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:  If this is the window container or a virtual container then <br>
    *         override andnot* call SUPER.    <br>
    *         if not cancel and undo all containertargets and then destroy.             <br>
    *         Published from containerTargets or called directly    <br>
    *       - There is a slight overhead in this construct as destroyObject<br>
    *         (called from exitObject -&gt; apply 'close') does a publish <br>
    *         'confirmExit', which really is unnecessary after this has <br>
    *         published 'confirmCancel'.<br>
    *         The reason is that destroyObject may be called directly.<br>
    *       - We currently have to call exitObject as the appbuilder <br>
    *         wait-for protests if we destroy directly. <br>
    *         Even apply 'close' to target-procedure does not trigger <br>
    *         the wait-for. It seems as this has to be fired from the actual <br>
    *         instance. (exitObject shoueld be local in all container instances)<br>
    *         This may very well be a problem for application wait-for as well.
    */
   public void cancelObject()
   {
      handle hContainer = TypeFactory.handle();
      logical lError = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if (_and(hContainer.isValid(), () -> isNotEqual(hContainer.unwrapType().getResourceType(), "WINDOW")))
         {
            ControlFlowOps.runSuper("cancelObject");
         }
         else
         {
            /* Cancel and undo all Container targets  */
            NamedEventManager.publish("confirmCancel", targetProcedure(), "U", new Object[]
            {
               lError
            });
            
            if (_not(lError))
            {
               silent(() -> ControlFlowOps.invokeIn("exitObject", targetProcedure()));
               
               if ((ErrorManager.isError()).booleanValue())
               {
                  ControlFlowOps.invokeIn("destroyObject", targetProcedure());
               }
            }
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Hides and views (and creates if necessary) objects in<br>
    *              a Container when CurrentPage is reset<br>
    * Parameters:  &lt;none&gt;
    */
   public void changePage()
   {
      character cObjects = TypeFactory.character();
      integer iPageNum = TypeFactory.integer();
      logical lInitted = TypeFactory.logical();
      character cRequiredPages = TypeFactory.character();
      integer iPageLoop = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* Let folder know, if any*/
         NamedEventManager.publish("changeFolderPage", targetProcedure());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         iPageNum.assign(ghProp.unwrapBufferField().value());
         
         /* If changing to page 0, don't look for PAGE0 links (there won't be any)
              or try to re-run create-objects for it. */
         if (_isNotEqual(iPageNum, 0))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
            lInitted.assign(ghProp.unwrapBufferField().value());
            cObjects.assign(pageNtargets(targetProcedure(), iPageNum));
            
            if (_isEqual(cObjects, ""))
            {
               /* Page hasn't been created yet: */
               silent(() -> ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character("WAIT")));
               /* Get objects on the new page created. */
               ControlFlowOps.invokeIn("createObjects", targetProcedure());
               
               /* If the current container object has been initialized already,
                        then initialize the new objects. Otherwise wait to let it happen
                        when the container is init'ed. */
               if ((lInitted).booleanValue())
               {
                  /* If this is newly created object, then the initialisation of the object 
                              will take care of packing and resizing. However, if this is the
                              first time that a page is selected, the resize the window to make things pretty.
                            */
                  silent(() -> ControlFlowOps.invokeInWithMode("packWindow", targetProcedure(), "II", iPageNum, new logical(true)));
                  silent(() -> ControlFlowOps.invokeIn("resizewindow", targetProcedure()));
                  cRequiredPages /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "pageNRequiredPages", targetProcedure(), "I", iPageNum));
                  
                  if (_and(isNotEqual(cRequiredPages, ""), () -> isNotEqual(cRequiredPages, "?")))
                  {
                     IntegerExpression resExpr4 = new IntegerExpression()
                     {
                        public integer execute()
                        {
                           return numEntries(cRequiredPages);
                        }
                     };
                     ToClause toClause4 = new ToClause(iPageLoop, 1, resExpr4);
                     
                     doTo("loopLabel4", toClause4, new Block((Body) () -> 
                     {
                        ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
                        ghProp.unwrapBufferField().changeValue(new integer(entry(iPageLoop, cRequiredPages)));
                        /* Ensure that everything is nicely init'ed ... */
                        ControlFlowOps.invokeInWithMode("notifyPage", targetProcedure(), "I", new character("initializeObject"));
                        /* ... and make sure that we never see it. */
                        ControlFlowOps.invokeInWithMode("notifyPage", targetProcedure(), "I", new character("hideObject"));
                     }));
                     
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
                     ghProp.unwrapBufferField().changeValue(iPageNum);
                  }
                  
                  /* There are other pages that need init */
                  ControlFlowOps.invokeInWithMode("notifyPage", targetProcedure(), "I", new character("initializeObject"));
               }
               /* container has been initted. */
               silent(() -> ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character("")));
            }
            else
            {
               /* If the container has been init'ed, then view its contents.
                        If not, 'view' will have no effect yet, so just mark the
                        contents to be viewed when the container *is* init'ed. */
               if ((lInitted).booleanValue())
               {
                  ControlFlowOps.invokeInWithMode("notifyPage", targetProcedure(), "I", new character("viewObject"));
               }
               else
               {
                  ControlFlowOps.invokeInWithMode("assignPageProperty", targetProcedure(), "II", new character("HideOnInit"), new character("No"));
               }
            }
         }
         /* END DO if PageNum NE 0 */
         /* Hide and view Page 0 (the default frame) of the window for character
              mode if switching to/from a page which is another window in GUI. */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Make sure unsaved changes are cancelled and uncommitted data are <br>
    *              undone before allowing its container to initiate a "destroy" <br>
    *              operation.<br>
    * Parameters:  INPUT-OUTPUT plError - <br>
    *              If this is returned TRUE the destroyObject will be cancelled.<br>
    *      Notes:  The name confirm is used as it is in family with the other <br>
    *              confirm methods, but this does not ask any questions   <br>
    *              Invoked at the top by cancelObject.<br>
    *            - Only republished if we are a non-virtual and non-window container
    */
   public void confirmCancel(final logical plError)
   {
      handle hContainer = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         /* Ok and Cancel should only work within a window, so if we are a window 
              container then don't republish (we currently also ignore virtual containers) */
         if (_and(and(hContainer.isValid(), () -> isNotEqual(hContainer.unwrapType().getResourceType(), "window")), not(plError)))
         {
            NamedEventManager.publish("confirmCancel", targetProcedure(), "U", new Object[]
            {
               plError
            });
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Passes this event on to its descendents, to check whether<br>
    *              it is OK to exit (no unsaved changes, e.g.).<br>
    * Parameters:  INPUT-OUTPUT plCancel AS LOGICAL  error flag which if set by<br>
    *              any object will abort the destroy.<br>
    *      Notes:  Invoked at the top by destroyObject.
    */
   public void confirmExit(final logical plCancel)
   {
      internalProcedure(new Block((Body) () -> 
      {
         if (_not(plCancel))
         {
            NamedEventManager.publish("confirmExit", targetProcedure(), "U", new Object[]
            {
               plCancel
            });
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Make sure unsaved changes are saved and uncommitted data is committed<br>
    *              before allowing its container to initiate a "destroy" operation.<br>
    * Parameters:  INPUT-OUTPUT plError - <br>
    *              If this is returned TRUE the destroyObject will be cancelled.<br>
    *      Notes:  The name confirm is used as it is in family with the other <br>
    *              confirm methods, but this does not ask any questions   <br>
    *              Invoked at the top by okObject.<br>
    *            - Only republished if we are a non-virtual and non-window container
    */
   public void confirmOk(final logical plError)
   {
      handle hContainer = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         /* Ok and Cancel should only work within a window, so if we are a window 
              container then don't republish (we currently also ignore virtual containers)*/
         if (_and(and(hContainer.isValid(), () -> isNotEqual(hContainer.unwrapType().getResourceType(), "window")), not(plError)))
         {
            NamedEventManager.publish("confirmOk", targetProcedure(), "U", new Object[]
            {
               plError
            });
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     RUN from adm-create-objects to RUN a SmartObject,<br>
    *              and to establish its parent and initial property settings.<br>
    * Parameters:  pcProcName AS CHARACTER  the procedure name to run, <br>
    *              phParent   AS HANDLE     handle to parent its visualization to,<br>
    *              pcPropList AS CHARACTER  property list to set, <br>
    *              phObject   AS OUTPUT HANDLE  the new procedure handle.
    */
   public void constructObject(final character _pcProcName, final handle _phParent, final character _pcPropList, final handle phObject_7)
   {
      character pcProcName = TypeFactory.initInput(_pcProcName);
      handle phParent = TypeFactory.initInput(_phParent);
      character pcPropList = TypeFactory.initInput(_pcPropList);
      integer iCurrentPage = TypeFactory.integer();
      character cVersion = TypeFactory.character();
      integer iEntry = TypeFactory.integer();
      character cEntry = TypeFactory.character();
      character cProperty = TypeFactory.character();
      character cValue = TypeFactory.character();
      integer iDb = TypeFactory.integer();
      character cDblist = TypeFactory.character();
      character cDotRfile = TypeFactory.character();
      character cMemberFile = TypeFactory.character();
      character cBaseFileName = TypeFactory.character();
      character cDynamicSdo = TypeFactory.character();
      character cRunDooptions = TypeFactory.character();
      character cFirstEntry = TypeFactory.character();
      character cObjectName = TypeFactory.character();
      integer iDotPos = TypeFactory.integer();
      character cDivision = TypeFactory.character();
      logical lSbo = TypeFactory.logical();
      character cLogicalName = TypeFactory.character();
      character cProperties = TypeFactory.character();
      character cPropValues = TypeFactory.character();
      character cRenderingProcedure = TypeFactory.character();
      character cServerFileName = TypeFactory.character();
      logical lUseRepository = TypeFactory.logical();
      character cContainerName = TypeFactory.character();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(phObject_7);
      }, 
      (Body) () -> 
      {
         silent(() -> ghTargetProcedure.assign(targetProcedure()));
         /* We could do a more intelligent search for object, but this is 
              curently a hack for lookup.p so that the launched lookup container can 
              fetch data from repository 
              Warning: LogicalObjectName is used by webspoeed for lookup SDO that 
                       ALREADY has all info   */
         /*set unknown here just in case of recursive call */
         gcCurrentObjectName.setUnknown();
         cFirstEntry.assign(entry(1, pcPropList, chr(3)));
         
         if (_and(isNotEqual(cFirstEntry, ""), () -> isEqual(entry(1, cFirstEntry, chr(4)), "LaunchLogicalName")))
         {
            silent(() -> gcCurrentObjectName.assign(concat(entry(2, cFirstEntry, chr(4)), chr(1))));
            pcPropList.replaceEntry(1, chr(4), "LogicalObjectName");
         }
         
         /* Establish what the actual LogicalObjectName is, so that we can attempt */
         /* to find a running instance when on server */
         if (_notUnknown(gcCurrentObjectName))
         {
            cLogicalName.assign(gcCurrentObjectName);
         }
         else
         {
            loopLabel5:
            for (iEntry.assign(1); _isLessThanOrEqual(iEntry, numEntries(pcPropList, chr(3))); iEntry.increment())
            {
               cEntry.assign(entry(iEntry, pcPropList, chr(3)));
               
               if (_isEqual(entry(1, cEntry, chr(4)), "LogicalObjectName"))
               {
                  silent(() -> cLogicalName.assign(entry(2, cEntry, chr(4))));
                  break loopLabel5;
               }
            }
         }
         /* {get Prop var [handle]} */ 
         silent(() -> cDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure())));
         
         if (_and(and(or(isEqual(cDivision, "SERVER"), () -> isEqual(LogicalTerminal.getClientType(), "WEBSPEED")), () -> isGreaterThan(cLogicalName, "")), () -> isNotEqual(cLogicalName, "?")))
         {
            /* look for running object */
            NamedEventManager.publish(concat("searchCache", cLogicalName), thisProcedure(), "O", new Object[]
            {
               phObject_7
            });
            
            /* if found, use it */
            if ((phObject_7.isValid()).booleanValue())
            {
               ControlFlowOps.invokeIn("removeFromCache", phObject_7);
               
               if ((gshRepositoryManager.isValid()).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                  lSbo.assign(ghProp.unwrapBufferField().value());
                  
                  if ((lSbo).booleanValue())
                  {
                     cObjectName /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getCurrentLogicalName", targetProcedure()));
                     /* the first entry can be a container LogicalObjectName OR an IbstanceID*/
                     cContainerName.assign(entry(1, cObjectName, chr(1)));
                     
                     if (_isGreaterThan(numEntries(cObjectName, chr(1)), 1))
                     {
                        cObjectName.assign(entry(2, cObjectName, chr(1)));
                     }
                     else
                     {
                        cObjectName.assign("");
                     }
                     
                     /* {set Prop value [handle]} */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setAutoCommit", phObject_7, "I", false);
                     cProperties.assign("ForeignFields,RowsToBatch");
                     /* container name */
                     ControlFlowOps.invokeInWithMode("getInstanceProperties", gshRepositoryManager, "IIUO", cContainerName, cObjectName, cProperties, cPropValues);
                     
                     IntegerExpression resExpr5 = new IntegerExpression()
                     {
                        public integer execute()
                        {
                           return numEntries(cProperties);
                        }
                     };
                     ToClause toClause5 = new ToClause(iEntry, 1, resExpr5);
                     
                     doTo("loopLabel6", toClause5, new Block((Body) () -> 
                     {
                        cProperty.assign(entry(iEntry, cProperties));
                        cValue.assign(entry(iEntry, cPropValues, chr(1)));
                        silent(() -> ControlFlowOps.invokeDynamicFunctionInWithMode(concat("set", cProperty), phObject_7, "I", cValue));
                     }));
                  }
               }
            }
         }
         
         if (_not(phObject_7.isValid()))
         {
            /* start new object instance */
            /* This is a DB-AWARE object: */
            if (_isGreaterThan(numEntries(pcProcName, chr(3)), 1))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("RunDOOptions"));
               cRunDooptions.assign(ghProp.unwrapBufferField().value());
               pcProcName.assign(entry(1, pcProcName, chr(3)));
               cBaseFileName.assign(pcProcName);
                /* Save off for later */iDotPos.assign(lastIndexOf(pcProcName, "."));
               
               /* issue 9878 - dots in dir name */
               /* If DynamicOnly is not a Run Data Object option then we want to look for 
                        rcode to run */
               if (_isEqual(lookup("DynamicOnly", cRunDooptions), 0))
               {
                  /* We do not look for .r's if ClientOnly is a Run DO option */
                  if (_and(isEqual(lookup("ClientOnly", cRunDooptions), 0), () -> isEqual(lookup("StaticClientOnly", cRunDooptions), 0)))
                  {
                     FileSystemOps.initFileInfo(concat(substring(pcProcName, 1, iDotPos), "r"));
                     cDotRfile.assign(FileSystemOps.fileInfoGetFullPath());
                     /* If .r in proc lib, get the member name (ie, filename). */
                     cMemberFile.assign(FileSystemOps.member(cDotRfile));
                     
                     if (_notUnknown(cMemberFile))
                     {
                        cDotRfile.assign(cMemberFile);
                     }
                     
                     if (_notUnknown(cDotRfile))
                     {
                        RcodeInfoOps.initFileInfo(cDotRfile);
                        cDblist.assign(RcodeInfoOps.getDbReferences());
                        
                        dbCheck:
                        for (iDb.assign(1); _isLessThanOrEqual(iDb, numEntries(trim(cDblist))); iDb.increment())
                        {
                           /* Remove blank when no db */
                           if (_not(ConnectionManager.connected(entry(iDb, cDblist))))
                           {
                              cDotRfile.setUnknown();
                              /* Flag that we can't use the base file. */
                              break dbCheck;
                           }
                        }
                     }
                  }
                  
                  /* Not ClientOnly */
                  /* If the .r was not found or it was found and the databases it needs
                             are not connected OR ClientOnly is a Run DO option then we look 
                             for the proxy */
                  if (_or(or(isUnknown(cDotRfile), () -> isGreaterThan(lookup("ClientOnly", cRunDooptions), 0)), () -> isGreaterThan(lookup("StaticClientOnly", cRunDooptions), 0)))
                  {
                     pcProcName.assign(concat(substring(pcProcName, 1, minus(iDotPos, 1)), "_cl.r"));
                     FileSystemOps.initFileInfo(pcProcName);
                     cDotRfile.assign(FileSystemOps.fileInfoGetFullPath());
                     cMemberFile.assign(FileSystemOps.member(cDotRfile));
                     
                     if (_notUnknown(cMemberFile))
                     {
                        cDotRfile.assign(cMemberFile);
                     }
                  }
                  
                  /* END ELSE DO IF base .r not found. */
                  /* If SourceSearch is a Run DO option then we try to run source code */
                  if (_and(isUnknown(cDotRfile), () -> isGreaterThan(lookup("SourceSearch", cRunDooptions), 0)))
                  {
                     /* If ClientOnly is not option then we run the .w directly in an 
                                  on stop undo, leave loop so that it will try to run the _cl.w 
                                  proxy if the run of the .w fails due to databases not being
                                  connected */
                     if (_isEqual(lookup("ClientOnly", cRunDooptions), 0))
                     {
                        OnPhrase[] onPhrase0 = new OnPhrase[]
                        {
                           new OnPhrase(Condition.STOP, Action.LEAVE, "blockLabel0")
                        };
                        
                        doBlock(TransactionType.SUB, "blockLabel0", onPhrase0, new Block((Body) () -> 
                        {
                           silent(() -> ControlFlowOps.invokePersistentSet((cBaseFileName).toStringMessage(), phObject_7));
                        }));
                     }
                     
                     /* If the .w did not run due to an error (such as database not 
                                  being connected the proxy _cl.w is run */
                     if ((phObject_7.isValid()).booleanValue())
                     {
                        cDotRfile.assign(cBaseFileName);
                     }
                     else
                     {
                        if (_isGreaterThan(lookup("ClientOnly", cRunDooptions), 0))
                        {
                           OnPhrase[] onPhrase1 = new OnPhrase[]
                           {
                              new OnPhrase(Condition.STOP, Action.LEAVE, "blockLabel1")
                           };
                           
                           doBlock(TransactionType.SUB, "blockLabel1", onPhrase1, new Block((Body) () -> 
                           {
                              ControlFlowOps.invokePersistentSet((concat(entry(1, cBaseFileName, "."), "_cl.w")).toStringMessage(), phObject_7);
                           }));
                        }
                     }
                     
                     if ((phObject_7.isValid()).booleanValue())
                     {
                        cDotRfile.assign(cBaseFileName);
                     }
                  }
               }
               
               /* Not DynamicOnly */
               /* If DynamicOnly is a Run DO option then this supercedes all other Run DO
                        options (except 'StaticClientOnly') and the dynamic object is run */
               if (_or(isUnknown(cDotRfile), () -> isGreaterThan(lookup("DynamicOnly", cRunDooptions), 0)))
               {
                  /* If 'StaticClientOnly' is set then the only possibility here is that 
                             we may be running an WebClient session. The dynamnic SDO client proxy
                             (dyndata.w) will *not* be run */
                  if (_isGreaterThan(lookup("StaticClientOnly", cRunDooptions), 0))
                  {
                     if (_isEqual(LogicalTerminal.getClientType(), "WEBCLIENT"))
                     {
                        OnPhrase[] onPhrase2 = new OnPhrase[]
                        {
                           new OnPhrase(Condition.STOP, Action.LEAVE, "blockLabel2")
                        };
                        
                        doBlock(TransactionType.SUB, "blockLabel2", onPhrase2, new Block((Body) () -> 
                        {
                           ControlFlowOps.invokePersistentSet((pcProcName).toStringMessage(), phObject_7);
                        }));
                     }
                  }
                  else
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("DynamicSDOProcedure"));
                     cDynamicSdo.assign(ghProp.unwrapBufferField().value());
                     
                     OnPhrase[] onPhrase3 = new OnPhrase[]
                     {
                        new OnPhrase(Condition.STOP, Action.LEAVE, "blockLabel3")
                     };
                     
                     doBlock(TransactionType.SUB, "blockLabel3", onPhrase3, new Block((Body) () -> 
                     {
                        ControlFlowOps.invokePersistentSet((cDynamicSdo).toStringMessage(), phObject_7);
                     }));
                     
                     if (_not(phObject_7.isValid()))
                     {
                        ghTargetProcedure.setUnknown();
                        returnError();
                     }
                     
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("HasDynamicProxy"));
                     ghProp.unwrapBufferField().changeValue(new logical(true));
                  }
               }
               else
               {
                  if (_not(phObject_7.isValid()))
                  {
                     ControlFlowOps.invokePersistentSet((pcProcName).toStringMessage(), phObject_7);
                  }
               }
               
               /* Verify that the object was created successfully. */
               if (_not(phObject_7.isValid()))
               {
                  ghTargetProcedure.setUnknown();
                  returnError();
               }
               
               /* New code for 9.1B. If the logic is that we run the _cl proxy, but
                        that file is not found, then we run the dynamic SDO instead. In any case, we
                        set the ServerFileName to the base filename of the SDO, to be run
                        on the AppServer. This may not be the same as the ObjectName, which
                        can be modified. */
               cServerFileName.assign(cBaseFileName);
               /* {get Prop var [handle]} */ 
               lUseRepository.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUseRepository", targetProcedure()));
               
               if ((lUseRepository).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, phObject_7.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("RenderingProcedure"));
                  cRenderingProcedure.assign(ghProp.unwrapBufferField().value());
                  
                  if (_isGreaterThan(cRenderingProcedure, ""))
                  {
                     cServerFileName.assign(cRenderingProcedure);
                  }
               }
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setServerFileName", phObject_7, "I", cServerFileName);
               ghProp.assign(handle.fromString(entry(1, phObject_7.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
               cObjectName.assign(ghProp.unwrapBufferField().value());
               
               if (_isNotEqual(indexOf(cObjectName, "_cl"), 0))
               {
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setObjectName", phObject_7, "I", substring(cObjectName, 1, minus(indexOf(cObjectName, "_cl"), 1)));
               }
            }
            else
            {
               ControlFlowOps.invokePersistentSet((pcProcName).toStringMessage(), phObject_7);
            }
            
            /* Verify that the object was created successfully. */
            if (_not(phObject_7.isValid()))
            {
               ghTargetProcedure.setUnknown();
               returnError();
            }
            
            silent(() -> 
            {
               ghProp.assign(handle.fromString(entry(1, phObject_7.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectVersion"));
               cVersion.assign(ghProp.unwrapBufferField().value());
            });
            
            if (_or(isUnknown(cVersion), () -> isLessThan(cVersion, "ADM2.2")))
            {
               /* {fnarg <func-name> <arg> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", substitute(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 88), phObject_7.unwrapFile().getFileName(), cVersion));
               
               if (_isGreaterThanOrEqual(cVersion, "ADM2.0"))
               {
                  silent(() -> ControlFlowOps.invokeIn("destroyObject", phObject_7));
               }
               else
               {
                  silent(() -> ControlFlowOps.invokeInWithMode("dispatch", phObject_7, "I", new character("destroy")));
               }
               
               stop();
            }
            /* For character mode, don't attempt to parent a new window procedure. 
                   We also need to check if phParent is valid before checking TYPE 
                   because phParent is not valid when the container is non-visual */
            /* {set Prop value [handle]} */
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setObjectParent", phObject_7, "I", phParent);
            
            IntegerExpression resExpr6 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(pcPropList, chr(3));
               }
            };
            ToClause toClause6 = new ToClause(iEntry, 1, resExpr6);
            
            doTo("loopLabel7", toClause6, new Block((Body) () -> 
            {
               cEntry.assign(entry(iEntry, pcPropList, chr(3)));
               cProperty.assign(entry(1, cEntry, chr(4)));
               cValue.assign(entry(2, cEntry, chr(4)));
               silent(() -> ControlFlowOps.invokeDynamicFunctionInWithMode(concat("set", cProperty), phObject_7, "I", cValue));
            }));
         }
         /* Now create the default link to the containing object. */
         ControlFlowOps.invokeInWithMode("addLink", targetProcedure(), "III", targetProcedure(), new character("CONTAINER"), phObject_7);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         iCurrentPage.assign(ghProp.unwrapBufferField().value());
         
         if (_isNotEqual(iCurrentPage, 0))
         {
            ControlFlowOps.invokeInWithMode("addLink", targetProcedure(), "III", targetProcedure(), concat("PAGE", valueOf(iCurrentPage)), phObject_7);
            ghProp.assign(handle.fromString(entry(1, phObject_7.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectPage"));
            ghProp.unwrapBufferField().changeValue(iCurrentPage);
         }
         
         gcCurrentObjectName.setUnknown();
         ghTargetProcedure.setUnknown();
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    *    Purpose: Standard code for running the objects in a Container. It runs<br>
    *             the AppBuilder-generated procedure named adm-create-objects. <br>
    * Parameters: &lt;none&gt;<br>
    *      Notes: The ObjectsCreated flag protects agains multiple starts of page 0.<br>
    *             Other pages are protected in changePage.
    */
   public void createObjects()
   {
      integer iPage_1 = TypeFactory.integer();
      logical lObjectsCreated = TypeFactory.logical();
      integer iStartPage = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         iPage_1.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(iPage_1, 0))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectsCreated"));
            lObjectsCreated.assign(ghProp.unwrapBufferField().value());
         }
         /* {get Prop var [handle]} */ 
         
         if (_or(isNotEqual(iPage_1, 0), not(lObjectsCreated)))
         {
            silent(() -> ControlFlowOps.invokeIn("adm-create-objects", targetProcedure()));
            /* new for 9.1B: run an additional optional procedure in the container,
                   which can do any work that must be done after all the contained objects
                   have been created and the links established, but before initializeObject.*/
            silent(() -> ControlFlowOps.invokeIn("postCreateObjects", targetProcedure()));
            
            /* if page 0 then this is the start up so ensure that we run the startpage */
            if (_isEqual(iPage_1, 0))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("StartPage"));
               iStartPage.assign(ghProp.unwrapBufferField().value());
               
               if (_and(notUnknown(iStartPage), () -> isNotEqual(iStartPage, 0)))
               {
                  ControlFlowOps.invokeInWithMode("selectPage", targetProcedure(), "I", iStartPage);
               }
               
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectsCreated"));
               ghProp.unwrapBufferField().changeValue(new logical(true));
            }
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Deletes all the objects on the specified page.<br>
    *  Params:  piPageNum AS INTEGER
    */
   public void deletePage(final integer _piPageNum_2)
   {
      integer piPageNum_2 = TypeFactory.initInput(_piPageNum_2);
      integer iCurrentPage = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         iCurrentPage.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         ghProp.unwrapBufferField().changeValue(piPageNum_2);
         /* Also tell the folder or other paging visualization, if any. */
         NamedEventManager.publish("deleteFolderPage", targetProcedure());
         ControlFlowOps.invokeInWithMode("notifyPage", targetProcedure(), "I", new character("destroyObject"));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         ghProp.unwrapBufferField().changeValue(iCurrentPage);
         returnNormal();
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public void destroyObject()
   {
      character cObjectname = TypeFactory.character();
      logical lSaveWindowPos = TypeFactory.logical();
      character cProfileData = TypeFactory.character();
      handle hContainer = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         lSaveWindowPos.assign(false);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if (_and(and(hContainer.isValid(), () -> HandleOps.canQuery(hContainer, "window-state")), () -> or(isEqual(hContainer.unwrapWindow().getWindowState(), CommonWindow.WINDOW_STATE_NORMAL), () -> isEqual(hContainer.unwrapWindow().getWindowState(), CommonWindow.WINDOW_STATE_MAXIMIZED))))
         {
            silent(() -> lSaveWindowPos.assign(new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "getUserProperty", targetProcedure(), "I", "SaveWindowPos"))));
         }
         /* THis property is set by the container window super procedure rydyncontp.p in updateWindowSizes */
         
         /* Only position and size if asked to */
         if ((lSaveWindowPos).booleanValue())
         {
            if (_isEqual(hContainer.unwrapWindow().getWindowState(), CommonWindow.WINDOW_STATE_MAXIMIZED))
            {
               cProfileData.assign("WINDOW-MAXIMIZED");
            }
            else
            {
               cProfileData.assign(concat(replaceAll(valueOf(hContainer.unwrapWidget().getColumn()), NumberType.getNumericDecimalPoint(), "."), chr(3), replaceAll(valueOf(hContainer.unwrapWidget().getRow()), NumberType.getNumericDecimalPoint(), "."), chr(3), replaceAll(valueOf(hContainer.unwrapSizeable().getWidthChars()), NumberType.getNumericDecimalPoint(), "."), chr(3), replaceAll(valueOf(hContainer.unwrapSizeable().getHeightChars()), NumberType.getNumericDecimalPoint(), ".")));
            }
            /* Always store decimal values as if they were in American numeric format.
                      * When retrieving decimal values, we need to convert to the current
                      * SESSION:NUMERIC-DECIMAL-POINT.                                         */
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
            cObjectname.assign(ghProp.unwrapBufferField().value());
            
            if (_isGreaterThan(length(cObjectname), 0))
            {
               /* We have to check if this handle is valid since it might 
                       have been killed if a developer was running something
                       and closed the AppBuilder and it then attempts to close
                       down any running containers. */
               if ((gshProfileManager.isValid()).booleanValue())
               {
                  ControlFlowOps.invokeInWithMode("setProfileData", gshProfileManager, "IIIIIII", new character("Window"), new character("SizePos"), cObjectname, new unknown(), cProfileData, new logical(false), new character("PER"));
               }
            }
         }
         /* save window positions/size */
         silent(() -> ControlFlowOps.runSuper("destroyObject"));
         
         if (_or(ErrorManager.isError(), () -> isEqual(ControlFlowOps.getReturnValue(), "ADM-ERROR")))
         {
            returnError("ADM-ERROR");
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    *    Purpose: Client side procedure to get a set of data back from the server.<br>
    * Parameters: pcObject AS CHARACTER <br>
    *                    - if unknown, then fetch data sets for all QueryObjects<br>
    *                      in this container as well as all QueryObjects in all <br>
    *                      contained containers (in unlimited levels).                         <br>
    *                    - if specified, then fetch data sets from that Object <br>
    *                      down only following the data link.<br>
    *      Notes: The Data links is followed also when preparing and retrieving data <br>
    *             for all objects in containers. <br>
    *          -  The datalinks can go across containers, but it will not go into<br>
    *             a container that not is a descendant of this container.
    */
   public void fetchContainedData(final character _pcObject_2)
   {
      character pcObject_2 = TypeFactory.initInput(_pcObject_2);
      character cContext = TypeFactory.character();
      character cError = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      handle hRowObjectTt = TypeFactory.handle();
      handle hRowObject1 = TypeFactory.handle();
      handle hRowObject2 = TypeFactory.handle();
      handle hRowObject3 = TypeFactory.handle();
      handle hRowObject4 = TypeFactory.handle();
      handle hRowObject5 = TypeFactory.handle();
      handle hRowObject6 = TypeFactory.handle();
      handle hRowObject7 = TypeFactory.handle();
      handle hRowObject8 = TypeFactory.handle();
      handle hRowObject9 = TypeFactory.handle();
      handle hRowObject10 = TypeFactory.handle();
      handle hRowObject11 = TypeFactory.handle();
      handle hRowObject12 = TypeFactory.handle();
      handle hRowObject13 = TypeFactory.handle();
      handle hRowObject14 = TypeFactory.handle();
      handle hRowObject15 = TypeFactory.handle();
      handle hRowObject16 = TypeFactory.handle();
      handle hRowObject17 = TypeFactory.handle();
      handle hRowObject18 = TypeFactory.handle();
      handle hRowObject19 = TypeFactory.handle();
      handle hRowObject20 = TypeFactory.handle();
      handle hRowObject21 = TypeFactory.handle();
      handle hRowObject22 = TypeFactory.handle();
      handle hRowObject23 = TypeFactory.handle();
      handle hRowObject24 = TypeFactory.handle();
      handle hRowObject25 = TypeFactory.handle();
      handle hRowObject26 = TypeFactory.handle();
      handle hRowObject27 = TypeFactory.handle();
      handle hRowObject28 = TypeFactory.handle();
      handle hRowObject29 = TypeFactory.handle();
      handle hRowObject30 = TypeFactory.handle();
      handle hRowObject31 = TypeFactory.handle();
      handle hRowObject32 = TypeFactory.handle();
      integer iObject = TypeFactory.integer();
      character pcPhysicalNames = TypeFactory.character();
      character pcQualnames = TypeFactory.character();
      character pcQueryFields = TypeFactory.character();
      character pcQueries_1 = TypeFactory.character();
      character cTtlist = TypeFactory.character();
      character pcHandles = TypeFactory.character();
      character cServerFileName = TypeFactory.character();
      handle hAppServer = TypeFactory.handle();
      character cContainedAppServices = TypeFactory.character();
      integer iService = TypeFactory.integer();
      character cAppService = TypeFactory.character();
      character cQueryString = TypeFactory.character();
      character cServerOperatingMode = TypeFactory.character();
      handle hContainerSource = TypeFactory.handle();
      logical lSbo = TypeFactory.logical();
      logical lAsBound = TypeFactory.logical();
      handle hAsHandle = TypeFactory.handle();
      logical lInitialized = TypeFactory.logical();
      character cInstanceNames = TypeFactory.character();
      character cTargets = TypeFactory.character();
      handle hMasterObject = TypeFactory.handle();
      logical lAsHasStarted = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character("WAIT"));
         
         if (_isUnknown(pcObject_2))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedAppServices"));
            cContainedAppServices.assign(ghProp.unwrapBufferField().value());
         }
         /* {get Prop var [handle]} */ 
         
         IntegerExpression resExpr7 = new IntegerExpression()
         {
            public integer execute()
            {
               return _isUnknown(pcObject_2) ? numEntries(cContainedAppServices) : new integer(1);
            }
         };
         ToClause toClause7 = new ToClause(iService, 1, resExpr7);
         
         doTo("loopLabel8", toClause7, new Block((Body) () -> 
         {
            /* If we loop through all services, check connection and that it is remote */
            if (_or(isUnknown(pcObject_2), () -> isEqual(pcObject_2, "")))
            {
               cAppService.assign(entry(iService, cContainedAppServices));
               /* {get Prop var [handle]} */ 
               lAsBound.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAsBound", targetProcedure()));
               
               if (_not(lAsBound))
               {
                  /* {set Prop value [handle]} */ 
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setAppservice", targetProcedure(), "I", cAppService);
                  ControlFlowOps.invokeInWithMode("connectServer", targetProcedure(), "O", hAppServer);
                  
                  /* if session the object have opened them selves  */
                  if (_isEqual(hAppServer, SessionUtils.asHandle()))
                  {
                     next("loopLabel8");
                  }
                  
                  if (_isUnknown(hAppServer))
                  {
                     ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character(""));
                     returnNormal("ADM-ERROR");
                  }
               }
            }
            else
            {
                /* We connect for object requests further down  */cAppService.setUnknown();
            }
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
            lInitialized.assign(ghProp.unwrapBufferField().value());
            ControlFlowOps.invokeInWithMode("prepareDataForFetch", targetProcedure(), "IIIIUUUUUU", targetProcedure(), cAppService, pcObject_2, _and(not(lInitialized), () -> isUnknown(pcObject_2)) ? new character("INIT") : new character(""), pcHandles, pcPhysicalNames /* CHARACTER */, pcQualnames /* CHARACTER */, pcQueryFields /* CHARACTER */, pcQueries_1 /* CHARACTER */, cTtlist);
            
            if (_isNotEqual(pcPhysicalNames, ""))
            {
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 1))
               {
                  hRowObject1.assign(handle.fromString(entry(1, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 2))
               {
                  hRowObject2.assign(handle.fromString(entry(2, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 3))
               {
                  hRowObject3.assign(handle.fromString(entry(3, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 4))
               {
                  hRowObject4.assign(handle.fromString(entry(4, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 5))
               {
                  hRowObject5.assign(handle.fromString(entry(5, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 6))
               {
                  hRowObject6.assign(handle.fromString(entry(6, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 7))
               {
                  hRowObject7.assign(handle.fromString(entry(7, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 8))
               {
                  hRowObject8.assign(handle.fromString(entry(8, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 9))
               {
                  hRowObject9.assign(handle.fromString(entry(9, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 10))
               {
                  hRowObject10.assign(handle.fromString(entry(10, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 11))
               {
                  hRowObject11.assign(handle.fromString(entry(11, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 12))
               {
                  hRowObject12.assign(handle.fromString(entry(12, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 13))
               {
                  hRowObject13.assign(handle.fromString(entry(13, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 14))
               {
                  hRowObject14.assign(handle.fromString(entry(14, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 15))
               {
                  hRowObject15.assign(handle.fromString(entry(15, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 16))
               {
                  hRowObject16.assign(handle.fromString(entry(16, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 17))
               {
                  hRowObject17.assign(handle.fromString(entry(17, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 18))
               {
                  hRowObject18.assign(handle.fromString(entry(18, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 19))
               {
                  hRowObject19.assign(handle.fromString(entry(19, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 20))
               {
                  hRowObject20.assign(handle.fromString(entry(20, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 21))
               {
                  hRowObject21.assign(handle.fromString(entry(21, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 22))
               {
                  hRowObject22.assign(handle.fromString(entry(22, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 23))
               {
                  hRowObject23.assign(handle.fromString(entry(23, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 24))
               {
                  hRowObject24.assign(handle.fromString(entry(24, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 25))
               {
                  hRowObject25.assign(handle.fromString(entry(25, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 26))
               {
                  hRowObject26.assign(handle.fromString(entry(26, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 27))
               {
                  hRowObject27.assign(handle.fromString(entry(27, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 28))
               {
                  hRowObject28.assign(handle.fromString(entry(28, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 29))
               {
                  hRowObject29.assign(handle.fromString(entry(29, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 30))
               {
                  hRowObject30.assign(handle.fromString(entry(30, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 31))
               {
                  hRowObject31.assign(handle.fromString(entry(31, cTtlist)));
               }
               
               if (_isGreaterThanOrEqual(numEntries(cTtlist), 32))
               {
                  hRowObject32.assign(handle.fromString(entry(32, cTtlist)));
               }
               
               if (_and(notUnknown(pcObject_2), () -> isNotEqual(pcObject_2, "")))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceNames"));
                  cInstanceNames.assign(ghProp.unwrapBufferField().value());
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
                  cTargets.assign(ghProp.unwrapBufferField().value());
                  hObject.assign(handle.fromString(entry(lookup(pcObject_2, cInstanceNames), cTargets)));
                  
                  if (_not(hObject.isValid()))
                  {
                     returnNormal("ADM-ERROR");
                  }
                  
                  /* {get Prop var [handle]} */
                  cAppService.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAppService", hObject));
                  /* {get Prop var [handle]} */
                  lAsHasStarted.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAsHasStarted", hObject));
                  /* {set Prop value [handle]} */ 
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setAppService", targetProcedure(), "I", cAppService);
                  ControlFlowOps.invokeInWithMode("connectServer", targetProcedure(), "O", hAppServer);
                  
                  if (_isUnknown(hAppServer))
                  {
                     returnNormal("ADM-ERROR");
                  }
                  
                  /* if not asHasstarted we must ensure that obtainContextForServer sets
                         the 'first-time' context   */
                  if (_not(lAsHasStarted))
                  {
                     /* {set Prop value [handle]} */ 
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setAsHasStarted", targetProcedure(), "I", false);
                  }
               }
               cContext /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForServer", targetProcedure()));
               
               if ((hAppServer.isValid()).booleanValue())
               {
                  /* {get Prop var [handle]} */ 
                  cServerFileName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getServerfileName", targetProcedure()));
                  ControlFlowOps.invokeRemoteWithMode("adm2/fetchdata.p", (handle) null, hAppServer, false, "IUIIIIIOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO", cServerFileName, cContext, pcPhysicalNames, pcQualnames, pcQueryFields, pcQueries_1, new character(""), new TableParameter(hRowObject1), new TableParameter(hRowObject2), new TableParameter(hRowObject3), new TableParameter(hRowObject4), new TableParameter(hRowObject5), new TableParameter(hRowObject6), new TableParameter(hRowObject7), new TableParameter(hRowObject8), new TableParameter(hRowObject9), new TableParameter(hRowObject10), new TableParameter(hRowObject11), new TableParameter(hRowObject12), new TableParameter(hRowObject13), new TableParameter(hRowObject14), new TableParameter(hRowObject15), new TableParameter(hRowObject16), new TableParameter(hRowObject17), new TableParameter(hRowObject18), new TableParameter(hRowObject19), new TableParameter(hRowObject20), new TableParameter(hRowObject21), new TableParameter(hRowObject22), new TableParameter(hRowObject23), new TableParameter(hRowObject24), new TableParameter(hRowObject25), new TableParameter(hRowObject26), new TableParameter(hRowObject27), new TableParameter(hRowObject28), new TableParameter(hRowObject29), new TableParameter(hRowObject30), new TableParameter(hRowObject31), new TableParameter(hRowObject32), cError);
               }
               else
               {
                  /* we cannot get here */
                  /* {get Prop var [handle]} */ 
                  hAsHandle.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getAsHandle", targetProcedure()));
                  
                  if ((hAsHandle.isValid()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("remoteFetchData", hAsHandle, "UIIIIIOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO", cContext, pcPhysicalNames, pcQualnames, pcQueryFields, pcQueries_1, new character(""), new TableParameter(hRowObject1), new TableParameter(hRowObject2), new TableParameter(hRowObject3), new TableParameter(hRowObject4), new TableParameter(hRowObject5), new TableParameter(hRowObject6), new TableParameter(hRowObject7), new TableParameter(hRowObject8), new TableParameter(hRowObject9), new TableParameter(hRowObject10), new TableParameter(hRowObject11), new TableParameter(hRowObject12), new TableParameter(hRowObject13), new TableParameter(hRowObject14), new TableParameter(hRowObject15), new TableParameter(hRowObject16), new TableParameter(hRowObject17), new TableParameter(hRowObject18), new TableParameter(hRowObject19), new TableParameter(hRowObject20), new TableParameter(hRowObject21), new TableParameter(hRowObject22), new TableParameter(hRowObject23), new TableParameter(hRowObject24), new TableParameter(hRowObject25), new TableParameter(hRowObject26), new TableParameter(hRowObject27), new TableParameter(hRowObject28), new TableParameter(hRowObject29), new TableParameter(hRowObject30), new TableParameter(hRowObject31), new TableParameter(hRowObject32), cError);
                  }
                  
                  /* not used yet */
                  ControlFlowOps.invokeIn("endClientDataRequest", targetProcedure());
               }
               
               IntegerExpression resExpr8 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(pcHandles);
                  }
               };
               ToClause toClause8 = new ToClause(iObject, 1, resExpr8);
               
               doTo("loopLabel9", toClause8, new Block((Body) () -> 
               {
                  /* no physicalname means child sdo inside sbo */
                  /* no physicalname means child sdo inside sbo */
                  if (_or(isNotEqual(entry(1, entry(iObject, pcQueryFields, chr(1)), chr(2)), ""), () -> isEqual(entry(iObject, pcPhysicalNames), "")))
                  {
                     hObject.assign(handle.fromString(entry(iObject, pcHandles)));
                     /* {get Prop var [handle]} */
                     cQueryString.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryString", hObject));
                     
                     if (_isEqual(cQueryString, ""))
                     {
                        /* QueryWhere should normally be ? at this stage, but it might
                                   have been set from an external call */
                        /* {get Prop var [handle]} */
                        cQueryString.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryWhere", hObject));
                        
                        if (_and(notUnknown(cQueryString), () -> isNotEqual(cQueryString, "")))
                        {
                           /* {set Prop value [handle]} */
                           ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryString", hObject, "I", cQueryString);
                        }
                     }
                  }
               }));
               
               /* Do iObject = 1 to num-entries(cContainedObjects) */
               /* {fnarg <func-name> <arg> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "applyContextFromServer", targetProcedure(), "I", cContext);
               /* {get Prop var [handle]} */ 
               cServerOperatingMode.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getServerOperatingMode", targetProcedure()));
               
               IntegerExpression resExpr9 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(pcHandles);
                  }
               };
               ToClause toClause9 = new ToClause(iObject, 1, resExpr9);
               
               doTo("loopLabel10", toClause9, new Block((Body) () -> 
               {
                  hObject.assign(handle.fromString(entry(iObject, pcHandles)));
                  /* {set Prop value [handle]} */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setAsHasStarted", hObject, "I", true);
                  /* {set Prop value [handle]} */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setServerOperatingMode", hObject, "I", cServerOperatingMode);
                  
                  /* A dynamic dataobject may have gotten its table def here */
                  if (_isEqual(entry(iObject, cTtlist), "?"))
                  {
                     switch (StringHelper.safeTrimTrailing((iObject).toStringMessage()))
                     {
                        case "1":
                           {
                              hRowObjectTt.assign(hRowObject1);
                           }
                           break;
                        case "2":
                           {
                              hRowObjectTt.assign(hRowObject2);
                           }
                           break;
                        case "3":
                           {
                              hRowObjectTt.assign(hRowObject3);
                           }
                           break;
                        case "4":
                           {
                              hRowObjectTt.assign(hRowObject4);
                           }
                           break;
                        case "5":
                           {
                              hRowObjectTt.assign(hRowObject5);
                           }
                           break;
                        case "6":
                           {
                              hRowObjectTt.assign(hRowObject6);
                           }
                           break;
                        case "7":
                           {
                              hRowObjectTt.assign(hRowObject7);
                           }
                           break;
                        case "8":
                           {
                              hRowObjectTt.assign(hRowObject8);
                           }
                           break;
                        case "9":
                           {
                              hRowObjectTt.assign(hRowObject9);
                           }
                           break;
                        case "10":
                           {
                              hRowObjectTt.assign(hRowObject10);
                           }
                           break;
                        case "11":
                           {
                              hRowObjectTt.assign(hRowObject11);
                           }
                           break;
                        case "12":
                           {
                              hRowObjectTt.assign(hRowObject12);
                           }
                           break;
                        case "13":
                           {
                              hRowObjectTt.assign(hRowObject13);
                           }
                           break;
                        case "14":
                           {
                              hRowObjectTt.assign(hRowObject14);
                           }
                           break;
                        case "15":
                           {
                              hRowObjectTt.assign(hRowObject15);
                           }
                           break;
                        case "16":
                           {
                              hRowObjectTt.assign(hRowObject16);
                           }
                           break;
                        case "17":
                           {
                              hRowObjectTt.assign(hRowObject17);
                           }
                           break;
                        case "18":
                           {
                              hRowObjectTt.assign(hRowObject18);
                           }
                           break;
                        case "19":
                           {
                              hRowObjectTt.assign(hRowObject19);
                           }
                           break;
                        case "20":
                           {
                              hRowObjectTt.assign(hRowObject20);
                           }
                           break;
                        case "21":
                           {
                              hRowObjectTt.assign(hRowObject21);
                           }
                           break;
                        case "22":
                           {
                              hRowObjectTt.assign(hRowObject22);
                           }
                           break;
                        case "23":
                           {
                              hRowObjectTt.assign(hRowObject23);
                           }
                           break;
                        case "24":
                           {
                              hRowObjectTt.assign(hRowObject24);
                           }
                           break;
                        case "25":
                           {
                              hRowObjectTt.assign(hRowObject25);
                           }
                           break;
                        case "26":
                           {
                              hRowObjectTt.assign(hRowObject26);
                           }
                           break;
                        case "27":
                           {
                              hRowObjectTt.assign(hRowObject27);
                           }
                           break;
                        case "28":
                           {
                              hRowObjectTt.assign(hRowObject28);
                           }
                           break;
                        case "29":
                           {
                              hRowObjectTt.assign(hRowObject29);
                           }
                           break;
                        case "30":
                           {
                              hRowObjectTt.assign(hRowObject30);
                           }
                           break;
                        case "31":
                           {
                              hRowObjectTt.assign(hRowObject31);
                           }
                           break;
                        case "32":
                           {
                              hRowObjectTt.assign(hRowObject32);
                           }
                           break;
                     }
                     
                     /* {set Prop value [handle]} */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectTable", hObject, "I", hRowObjectTt);
                  }
                  
                  if (_isNotEqual(entry(iObject, pcQueries_1, chr(1)), "SKIP"))
                  {
                     /* {fnarg <func-name> <arg> [handle] */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "openDataQuery", hObject, "I", "FIRST");
                  }
                  
                  /* foreign fields in query from server may not be registered on client
                         so set QueryString from BaseQuery if it was not set above  */
                  /* no physicalname means child sdo inside sbo */
                  /* no physicalname means child sdo inside sbo */
                  if (_or(isNotEqual(entry(1, entry(iObject, pcQueryFields, chr(1)), chr(2)), ""), () -> isEqual(entry(iObject, pcPhysicalNames), "")))
                  {
                     ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                     hContainerSource.assign(ghProp.unwrapBufferField().value());
                     ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                     lSbo.assign(ghProp.unwrapBufferField().value());
                     
                     /* if this is the top SDO in an SBO and we have ForeignFields then 
                              the SBO will receive a dataAvailable so we need to set the 
                              DataIsFetched to avoid a reopen (SBOs does not currently get 
                              Foreign values from the server, so we can't rely on 
                              dataAvailble('reset') */
                     if (_and(lSbo, () -> isNotEqual(entry(iObject, pcPhysicalNames), "")))
                     {
                        /* {set Prop value [handle]} */
                        ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setDataIsFetched", hContainerSource, "I", true);
                     }
                     
                     /* {get Prop var [handle]} */
                     cQueryString.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryString", hObject));
                     
                     if (_isEqual(cQueryString, ""))
                     {
                        /* {get Prop var [handle]} */
                        cQueryString.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getBaseQuery", hObject));
                        /* {set Prop value [handle]} */
                        ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryString", hObject, "I", cQueryString);
                     }
                  }
               }));
               
               IntegerExpression resExpr10 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(pcHandles);
                  }
               };
               ToClause toClause10 = new ToClause(iObject, 1, resExpr10);
               
               doTo("loopLabel11", toClause10, new Block((Body) () -> 
               {
                  hObject.assign(handle.fromString(entry(iObject, pcHandles)));
                  
                  if (_isEqual(entry(1, entry(iObject, pcQueryFields, chr(1)), chr(2)), ""))
                  {
                     /* no physicalname means child sdo inside sbo */
                     if (_and(isNotEqual(entry(iObject, pcPhysicalNames), ""), () -> isNotEqual(entry(iObject, pcQueries_1, chr(1)), "SKIP")))
                     {
                        ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                        hContainerSource.assign(ghProp.unwrapBufferField().value());
                        ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                        lSbo.assign(ghProp.unwrapBufferField().value());
                        
                        if ((lSbo).booleanValue())
                        {
                           /* {get Prop var [handle]} */
                           hMasterObject.assign(ControlFlowOps.invokeDynamicFunctionIn("getMasterDataObject", hContainerSource));
                           
                           if (_isEqual(hObject, hMasterObject))
                           {
                              NamedEventManager.publish("DataAvailable", hMasterObject, "I", new Object[]
                              {
                                 "VALUE-CHANGED"
                              });
                           }
                           
                           NamedEventManager.publish("DataAvailable", hContainerSource, "I", new Object[]
                           {
                              "RESET"
                           });
                        }
                        else
                        {
                           NamedEventManager.publish("DataAvailable", hObject, "I", new Object[]
                           {
                              "RESET"
                           });
                        }
                     }
                  }
               }));
            }
         }));
         
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setappservice", targetProcedure(), "I", "");
         ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character(""));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    *    Purpose: Client side procedure to get a set of data back from the server.<br>
    * Parameters: pcObject AS CHARACTER <br>
    *                    - if unknown, then fetch data sets for all QueryObjects<br>
    *                      in this container as well as all QueryObjects in all <br>
    *                      contained containers (in unlimited levels).                         <br>
    *                    - if specified, then fetch data sets from that Object <br>
    *                      down only following the data link.<br>
    *      Notes: The Data links is followed also when preparing and retrieving data <br>
    *             for all objects in containers. <br>
    *          -  The datalinks can go across containers, but it will not go into<br>
    *             a container that not is a descendant of this container.
    */
   public void fetchContainedRows(final character _pcObject_2, final integer _piStartRow, final character _pcRowIdent, final logical _plNext, final integer _piRowsToReturn, final integer piRowsReturned)
   {
      character pcObject_2 = TypeFactory.initInput(_pcObject_2);
      integer piStartRow = TypeFactory.initInput(_piStartRow);
      character pcRowIdent = TypeFactory.initInput(_pcRowIdent);
      logical plNext = TypeFactory.initInput(_plNext);
      integer piRowsToReturn = TypeFactory.initInput(_piRowsToReturn);
      handle hRowObject1 = TypeFactory.handle();
      handle hRowObject2 = TypeFactory.handle();
      handle hRowObject3 = TypeFactory.handle();
      handle hRowObject4 = TypeFactory.handle();
      handle hRowObject5 = TypeFactory.handle();
      handle hRowObject6 = TypeFactory.handle();
      handle hRowObject7 = TypeFactory.handle();
      handle hRowObject8 = TypeFactory.handle();
      handle hRowObject9 = TypeFactory.handle();
      handle hRowObject10 = TypeFactory.handle();
      handle hRowObject11 = TypeFactory.handle();
      handle hRowObject12 = TypeFactory.handle();
      handle hRowObject13 = TypeFactory.handle();
      handle hRowObject14 = TypeFactory.handle();
      handle hRowObject15 = TypeFactory.handle();
      handle hRowObject16 = TypeFactory.handle();
      handle hRowObject17 = TypeFactory.handle();
      handle hRowObject18 = TypeFactory.handle();
      handle hRowObject19 = TypeFactory.handle();
      handle hRowObject20 = TypeFactory.handle();
      handle hRowObject21 = TypeFactory.handle();
      handle hRowObject22 = TypeFactory.handle();
      handle hRowObject23 = TypeFactory.handle();
      handle hRowObject24 = TypeFactory.handle();
      handle hRowObject25 = TypeFactory.handle();
      handle hRowObject26 = TypeFactory.handle();
      handle hRowObject27 = TypeFactory.handle();
      handle hRowObject28 = TypeFactory.handle();
      handle hRowObject29 = TypeFactory.handle();
      handle hRowObject30 = TypeFactory.handle();
      handle hRowObject31 = TypeFactory.handle();
      handle hRowObject32 = TypeFactory.handle();
      integer iObject = TypeFactory.integer();
      handle hAsHandle = TypeFactory.handle();
      character cContext = TypeFactory.character();
      character cError = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      character pcPhysicalNames = TypeFactory.character();
      character pcQualnames = TypeFactory.character();
      character pcQueryFields = TypeFactory.character();
      character pcQueries_1 = TypeFactory.character();
      character cTtlist = TypeFactory.character();
      character pcHandles = TypeFactory.character();
      character cServerFileName = TypeFactory.character();
      handle hAppServer = TypeFactory.handle();
      character cContainedAppServices = TypeFactory.character();
      integer iService = TypeFactory.integer();
      character cAppService = TypeFactory.character();
      character cQueryString = TypeFactory.character();
      character cServerOperatingMode = TypeFactory.character();
      handle hContainerSource = TypeFactory.handle();
      logical lSbo = TypeFactory.logical();
      logical lAsBound = TypeFactory.logical();
      character cTargets = TypeFactory.character();
      character cInstanceNames = TypeFactory.character();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(piRowsReturned);
      }, 
      (Body) () -> 
      {
         ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character("WAIT"));
         
         if (_isUnknown(pcObject_2))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedAppServices"));
            cContainedAppServices.assign(ghProp.unwrapBufferField().value());
         }
         /* {get Prop var [handle]} */ 
         
         IntegerExpression resExpr11 = new IntegerExpression()
         {
            public integer execute()
            {
               return _isUnknown(pcObject_2) ? numEntries(cContainedAppServices) : new integer(1);
            }
         };
         ToClause toClause11 = new ToClause(iService, 1, resExpr11);
         
         doTo("loopLabel12", toClause11, new Block((Body) () -> 
         {
            if (_isUnknown(pcObject_2))
            {
               cAppService.assign(entry(iService, cContainedAppServices));
            }
            else
            {
               cAppService.setUnknown();
            }
            
            ControlFlowOps.invokeInWithMode("prepareDataForFetch", targetProcedure(), "IIIIUUUUUU", targetProcedure(), cAppService, pcObject_2, new character("Batch"), pcHandles, pcPhysicalNames /* CHARACTER */, pcQualnames /* CHARACTER */, pcQueryFields /* CHARACTER */, pcQueries_1 /* CHARACTER */, cTtlist);
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 1))
            {
               hRowObject1.assign(handle.fromString(entry(1, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 2))
            {
               hRowObject2.assign(handle.fromString(entry(2, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 3))
            {
               hRowObject3.assign(handle.fromString(entry(3, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 4))
            {
               hRowObject4.assign(handle.fromString(entry(4, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 5))
            {
               hRowObject5.assign(handle.fromString(entry(5, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 6))
            {
               hRowObject6.assign(handle.fromString(entry(6, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 7))
            {
               hRowObject7.assign(handle.fromString(entry(7, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 8))
            {
               hRowObject8.assign(handle.fromString(entry(8, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 9))
            {
               hRowObject9.assign(handle.fromString(entry(9, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 10))
            {
               hRowObject10.assign(handle.fromString(entry(10, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 11))
            {
               hRowObject11.assign(handle.fromString(entry(11, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 12))
            {
               hRowObject12.assign(handle.fromString(entry(12, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 13))
            {
               hRowObject13.assign(handle.fromString(entry(13, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 14))
            {
               hRowObject14.assign(handle.fromString(entry(14, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 15))
            {
               hRowObject15.assign(handle.fromString(entry(15, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 16))
            {
               hRowObject16.assign(handle.fromString(entry(16, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 17))
            {
               hRowObject17.assign(handle.fromString(entry(17, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 18))
            {
               hRowObject18.assign(handle.fromString(entry(18, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 19))
            {
               hRowObject19.assign(handle.fromString(entry(19, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 20))
            {
               hRowObject20.assign(handle.fromString(entry(20, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 21))
            {
               hRowObject21.assign(handle.fromString(entry(21, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 22))
            {
               hRowObject22.assign(handle.fromString(entry(22, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 23))
            {
               hRowObject23.assign(handle.fromString(entry(23, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 24))
            {
               hRowObject24.assign(handle.fromString(entry(24, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 25))
            {
               hRowObject25.assign(handle.fromString(entry(25, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 26))
            {
               hRowObject26.assign(handle.fromString(entry(26, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 27))
            {
               hRowObject27.assign(handle.fromString(entry(27, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 28))
            {
               hRowObject28.assign(handle.fromString(entry(28, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 29))
            {
               hRowObject29.assign(handle.fromString(entry(29, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 30))
            {
               hRowObject30.assign(handle.fromString(entry(30, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 31))
            {
               hRowObject31.assign(handle.fromString(entry(31, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 32))
            {
               hRowObject32.assign(handle.fromString(entry(32, cTtlist)));
            }
            
            cContext /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForServer", targetProcedure()));
            
            if (_and(notUnknown(pcObject_2), () -> isNotEqual(pcObject_2, "")))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceNames"));
               cInstanceNames.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
               cTargets.assign(ghProp.unwrapBufferField().value());
               hObject.assign(handle.fromString(entry(lookup(pcObject_2, cInstanceNames), cTargets)));
               
               if (_not(hObject.isValid()))
               {
                  returnError("ADM-ERROR");
               }
               
               /* {get Prop var [handle]} */
               cAppService.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAppService", hObject));
            }
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setAppservice", targetProcedure(), "I", cAppService);
            /* {get Prop var [handle]} */ 
            lAsBound.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAsBound", targetProcedure()));
            /* {get Prop var [handle]} */ 
            cServerFileName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getServerfileName", targetProcedure()));
            
            if (_not(lAsBound))
            {
               ControlFlowOps.invokeInWithMode("connectServer", targetProcedure(), "O", hAppServer);
               
               if (_isUnknown(hAppServer))
               {
                  returnError("ADM-ERROR");
               }
               
               ControlFlowOps.invokeRemoteWithMode("adm2/fetchrows.p", (handle) null, hAppServer, false, "IUIIIIIIIIOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO", cServerFileName, cContext, pcPhysicalNames, pcQualnames, pcQueryFields, pcQueries_1, piStartRow, pcRowIdent, plNext, piRowsToReturn, piRowsReturned, new TableParameter(hRowObject1, true), new TableParameter(hRowObject2, true), new TableParameter(hRowObject3, true), new TableParameter(hRowObject4, true), new TableParameter(hRowObject5, true), new TableParameter(hRowObject6, true), new TableParameter(hRowObject7, true), new TableParameter(hRowObject8, true), new TableParameter(hRowObject9, true), new TableParameter(hRowObject10, true), new TableParameter(hRowObject11, true), new TableParameter(hRowObject12, true), new TableParameter(hRowObject13, true), new TableParameter(hRowObject14, true), new TableParameter(hRowObject15, true), new TableParameter(hRowObject16, true), new TableParameter(hRowObject17, true), new TableParameter(hRowObject18, true), new TableParameter(hRowObject19, true), new TableParameter(hRowObject20, true), new TableParameter(hRowObject21, true), new TableParameter(hRowObject22, true), new TableParameter(hRowObject23, true), new TableParameter(hRowObject24, true), new TableParameter(hRowObject25, true), new TableParameter(hRowObject26, true), new TableParameter(hRowObject27, true), new TableParameter(hRowObject28, true), new TableParameter(hRowObject29, true), new TableParameter(hRowObject30, true), new TableParameter(hRowObject31, true), new TableParameter(hRowObject32, true), cError);
            }
            else
            {
               /* {get Prop var [handle]} */ 
               hAsHandle.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getAsHandle", targetProcedure()));
               ControlFlowOps.invokeInWithMode("remoteFetchRows", hAsHandle, "UIIIIIIIIOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO", cContext, pcPhysicalNames, pcQualnames, pcQueryFields, pcQueries_1, piStartRow, pcRowIdent, plNext, piRowsToReturn, piRowsReturned, new TableParameter(hRowObject1, true), new TableParameter(hRowObject2, true), new TableParameter(hRowObject3, true), new TableParameter(hRowObject4, true), new TableParameter(hRowObject5, true), new TableParameter(hRowObject6, true), new TableParameter(hRowObject7, true), new TableParameter(hRowObject8, true), new TableParameter(hRowObject9, true), new TableParameter(hRowObject10, true), new TableParameter(hRowObject11, true), new TableParameter(hRowObject12, true), new TableParameter(hRowObject13, true), new TableParameter(hRowObject14, true), new TableParameter(hRowObject15, true), new TableParameter(hRowObject16, true), new TableParameter(hRowObject17, true), new TableParameter(hRowObject18, true), new TableParameter(hRowObject19, true), new TableParameter(hRowObject20, true), new TableParameter(hRowObject21, true), new TableParameter(hRowObject22, true), new TableParameter(hRowObject23, true), new TableParameter(hRowObject24, true), new TableParameter(hRowObject25, true), new TableParameter(hRowObject26, true), new TableParameter(hRowObject27, true), new TableParameter(hRowObject28, true), new TableParameter(hRowObject29, true), new TableParameter(hRowObject30, true), new TableParameter(hRowObject31, true), new TableParameter(hRowObject32, true), cError);
               /* not used yet */
               ControlFlowOps.invokeIn("endClientDataRequest", targetProcedure());
            }
            
            IntegerExpression resExpr12 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(pcHandles);
               }
            };
            ToClause toClause12 = new ToClause(iObject, 1, resExpr12);
            
            doTo("loopLabel13", toClause12, new Block((Body) () -> 
            {
               /* no physicalname means child sdo inside sbo */
               /* no physicalname means child sdo inside sbo */
               if (_or(isNotEqual(entry(1, entry(iObject, pcQueryFields, chr(1)), chr(2)), ""), () -> isEqual(entry(iObject, pcPhysicalNames), "")))
               {
                  hObject.assign(handle.fromString(entry(iObject, pcHandles)));
                  /* {get Prop var [handle]} */
                  cQueryString.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryString", hObject));
                  
                  if (_isEqual(cQueryString, ""))
                  {
                     /* QueryWhere should normally be ? at this stage, but it might
                                have been set from an external call */
                     /* {get Prop var [handle]} */
                     cQueryString.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryWhere", hObject));
                     
                     if (_and(notUnknown(cQueryString), () -> isNotEqual(cQueryString, "")))
                     {
                        /* {set Prop value [handle]} */
                        ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryString", hObject, "I", cQueryString);
                     }
                  }
               }
            }));
            
            /* Do iObject = 1 to num-entries(cContainedObjects) */
            /* {fnarg <func-name> <arg> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "applyContextFromServer", targetProcedure(), "I", cContext);
            /* {get Prop var [handle]} */ 
            cServerOperatingMode.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getServerOperatingMode", targetProcedure()));
            
            IntegerExpression resExpr13 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(pcHandles);
               }
            };
            ToClause toClause13 = new ToClause(iObject, 1, resExpr13);
            
            doTo("loopLabel14", toClause13, new Block((Body) () -> 
            {
               hObject.assign(handle.fromString(entry(iObject, pcHandles)));
               /* {set Prop value [handle]} */
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setServerOperatingMode", hObject, "I", cServerOperatingMode);
               
               /* The caller opens the batched dataset */
               if (_isGreaterThan(iObject, 1))
               {
                  /* {fnarg <func-name> <arg> [handle] */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "openDataQuery", hObject, "I", "FIRST");
                  /* {set Prop value [handle]} */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setDataIsFetched", hObject, "I", true);
               }
               
               /* no physicalname means child sdo inside sbo */
               /* no physicalname means child sdo inside sbo */
               if (_or(isNotEqual(entry(1, entry(iObject, pcQueryFields, chr(1)), chr(2)), ""), () -> isEqual(entry(iObject, pcPhysicalNames), "")))
               {
                  ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                  hContainerSource.assign(ghProp.unwrapBufferField().value());
                  ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                  lSbo.assign(ghProp.unwrapBufferField().value());
                  
                  /* if this is the top SDO in an SBO and we have ForeignFields then 
                           the SBO will receive a dataAvailable so we need to set the 
                           DataIsFetched to avoid a reopen (SBOs does not currently get 
                           Foreign values from the server, so we can't rely on 
                           dastaAvailble('reset') */
                  if (_and(lSbo, () -> isNotEqual(entry(iObject, pcPhysicalNames), "")))
                  {
                     /* {set Prop value [handle]} */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setDataIsFetched", hContainerSource, "I", true);
                  }
                  
                  /* {get Prop var [handle]} */
                  cQueryString.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryString", hObject));
                  
                  if (_isEqual(cQueryString, ""))
                  {
                     /* {get Prop var [handle]} */
                     cQueryString.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getBaseQuery", hObject));
                     /* {set Prop value [handle]} */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryString", hObject, "I", cQueryString);
                  }
               }
            }));
         }));
         
         ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character(""));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Server-side procedure run after new data has been requested by <br>
    *              the client.<br>
    * Parameters:  OUTPUT pcContaineProps - Properties of the Contained SDOs<br>
    * Notes:
    */
   public void getContextAndDestroy(final character pcContainedProps)
   {
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcContainedProps);
      }, 
      (Body) () -> 
      {
         pcContainedProps /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForClient", targetProcedure()));
         ControlFlowOps.invokeIn("destroyObject", targetProcedure());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: Override to support removal of menus on hide    <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void hideObject()
   {
      logical lRemoveMenu = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RemoveMenuOnhide"));
         lRemoveMenu.assign(ghProp.unwrapBufferField().value());
         
         if ((lRemoveMenu).booleanValue())
         {
            NamedEventManager.publish("removeMenu", targetProcedure());
         }
         
         ControlFlowOps.runSuper("hideObject");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void hidePage(final integer _piPageNum_2)
   {
      integer piPageNum_2 = TypeFactory.initInput(_piPageNum_2);
      character cPageLinkHandles = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      integer iEntry = TypeFactory.integer();
      character cLink = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         cLink.assign(concat("Page", valueOf(piPageNum_2), "-target"));
         cPageLinkHandles.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "pageNTargets", targetProcedure(), "II", targetProcedure(), piPageNum_2));
         
         IntegerExpression resExpr14 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cPageLinkHandles);
            }
         };
         ToClause toClause14 = new ToClause(iEntry, 1, resExpr14);
         
         doTo("loopLabel15", toClause14, new Block((Body) () -> 
         {
            hObject.assign(handle.fromString(entry(iEntry, cPageLinkHandles)));
            silent(() -> ControlFlowOps.invokeIn("hideObject", hObject));
         }));
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    *  Purpose: initialize data objects separate (before) other objects.<br>
    *       <br>
    *  Parameters: plDeep <br>
    *              Yes - Publish to child containers to open their dataobjects<br>
    *              <br>
    *  Notes:  - This will call createObjects and create all objects in the <br>
    *            container includoing visual objects.  <br>
    *            The createObjects is called from the main block for some <br>
    *            containers different places in <br>
    *            containers, so  will only run once for page 0.<br>
    *          - This is currenty only used by an AppServer Aware container or<br>
    *            published from one.<br>
    * Note date: 2002/04/10
    */
   public void initializeDataObjects(final logical _plDeep_1)
   {
      logical plDeep_1 = TypeFactory.initInput(_plDeep_1);
      character cTargets = TypeFactory.character();
      logical lQuery = TypeFactory.logical();
      handle hSdo = TypeFactory.handle();
      integer iTarget = TypeFactory.integer();
      logical lQueryObject = TypeFactory.logical();
      logical lDataContainer = TypeFactory.logical();
      handle hContainersource = TypeFactory.handle();
      logical lFetchPending = TypeFactory.logical();
      logical lObjectsCreated = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
         lQuery.assign(ghProp.unwrapBufferField().value());
         
         if ((lQuery).booleanValue())
         {
            returnNormal();
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectsCreated"));
         lObjectsCreated.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
         lQueryObject.assign(ghProp.unwrapBufferField().value());
         
         /* createObjects is protected against double run, but we still want to 
              avoid calling it alltogether  */
         if (_not(lObjectsCreated))
         {
            ControlFlowOps.invokeIn("createObjects", targetProcedure());
         }
         
         if ((plDeep_1).booleanValue())
         {
            NamedEventManager.publish("initializeDataObjects", targetProcedure(), "I", new Object[]
            {
               plDeep_1
            });
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
         cTargets.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr15 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cTargets);
            }
         };
         ToClause toClause15 = new ToClause(iTarget, 1, resExpr15);
         
         doTo("loopLabel16", toClause15, new Block((Body) () -> 
         {
            hSdo.assign(handle.fromString(entry(iTarget, cTargets)));
            ghProp.assign(handle.fromString(entry(1, hSdo.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
            lQuery.assign(ghProp.unwrapBufferField().value());
            
            if ((lQuery).booleanValue())
            {
               ControlFlowOps.invokeIn("initializeObject", hSdo);
               NamedEventManager.unsubscribe(hSdo, "initializeObject", targetProcedure());
            }
         }));
         
         /* The sbo initializeObject has its own fetch logic, so only do this if 
              not a query object */
         if (_not(lQueryObject))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataContainer"));
            lDataContainer.assign(ghProp.unwrapBufferField().value());
            
            if ((lDataContainer).booleanValue())
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
               hContainersource.assign(ghProp.unwrapBufferField().value());
               
               if ((hContainersource.isValid()).booleanValue())
               {
                  lFetchPending /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "IsFetchPending", hContainersource));
               }
               
               if (_not(lFetchPending))
               {
                  ControlFlowOps.invokeInWithMode("fetchContainedData", targetProcedure(), "I", new unknown());
               }
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Does container-specific initialization.<br>
    * Parameters:  &lt;none&gt;
    */
   public void initializeObject()
   {
      logical lHideOnInit = TypeFactory.logical();
      logical lDisableOnInit = TypeFactory.logical();
      character cType = TypeFactory.character();
      integer iStartPage = TypeFactory.integer();
      handle hWaitForObject = TypeFactory.handle();
      logical lDataContainer = TypeFactory.logical();
      logical lQueryObject = TypeFactory.logical();
      logical lUseRepository = TypeFactory.logical();
      handle hWidget = TypeFactory.handle();
      logical lObjectsCreated = TypeFactory.logical();
      handle hContainingWindow = TypeFactory.handle();
      logical lParentInitted = TypeFactory.logical();
      /* set current MultiInstanceActivate property  */
      rowid rRowid = TypeFactory.rowid();
      character cProfileData = TypeFactory.character();
      logical lOneWindow = TypeFactory.logical();
      character cObjectMapping = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerType"));
         cType.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("StartPage"));
         iStartPage.assign(ghProp.unwrapBufferField().value());
         
         if (_isNotEqual(cType, "VIRTUAL"))
         {
            ControlFlowOps.invokeIn("initializeVisualContainer", targetProcedure());
         }
         
         if (_or(isEqual(cType, "FRAME"), () -> isEqual(cType, "VIRTUAL")))
         {
            /* A non-visual container (Simple SmartContainer) needs to run 
                   destroyObject on close of the procedure, for example, when it has 
                   been run from the AppBuilder for testing purposes */
            if (_isEqual(cType, "VIRTUAL"))
            {
               registerTriggerPersistentIn(new EventList("CLOSE", targetProcedure()), "destroyObject", targetProcedure());
            }
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectsCreated"));
            lObjectsCreated.assign(ghProp.unwrapBufferField().value());
            
            if (_not(lObjectsCreated))
            {
               silent(() -> ControlFlowOps.invokeIn("createObjects", targetProcedure()));
               
               if (_or(ErrorManager.isError(), () -> isNotEqual(ControlFlowOps.getReturnValue(), "")))
               {
                  returnNormal("ADM-ERROR");
               }
            }
         }
         
         /* END DO IF cType */
         if (_isNotEqual(cType, "VIRTUAL"))
         {
            silent(() -> 
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("HideOnInit"));
               lHideOnInit.assign(ghProp.unwrapBufferField().value());
            });
            silent(() -> 
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DisableOnInit"));
               lDisableOnInit.assign(ghProp.unwrapBufferField().value());
            });
         }
 /* Skip for non-visual contaioners. */;
         
         /* For containers, we need to propogate the HideOnInit and
              DisableOnInit attributes to children before initializing them. */
         if (_or(lHideOnInit, lDisableOnInit))
         {
            /* Tell all the objects on the page to come up hidden,
                    so the page doesn't flash on the screen. */
            if ((lHideOnInit).booleanValue())
            {
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignLinkProperty", targetProcedure(), "III", "CONTAINER-TARGET", "HideOnInit", "yes");
            }
            
            if ((lDisableOnInit).booleanValue())
            {
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignLinkProperty", targetProcedure(), "III", "CONTAINER-TARGET", "DisableOnInit", "yes");
            }
            
            /* For containers, whether DISABLE is explicitly set or not, we
                    need to set it for the container itself if HideOnInit is true,
                    because otherwise the 'enable' below will force the container
                    to be viewed if it contains any simple objects. */
            lDisableOnInit.assign(true);
         }
         
         if (_isEqual(cType, "WINDOW"))
         {
            if ((gshProfileManager.isValid()).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("getProfileData", gshProfileManager, "IIIIUO", new character("Window"), new character("OneWindow"), new character("OneWindow"), new logical(false), rRowid, cProfileData);
            }
            
            if (_isEqual(cProfileData, "YES"))
            {
               lOneWindow.assign(false);
            }
            else
            {
               lOneWindow.assign(true);
            }
            
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setMultiInstanceActivated", targetProcedure(), "I", lOneWindow);
         }
         /* For some reason the SBO propery gets unknown here   */
         /* {get Prop var [handle]} */ 
         silent(() -> cObjectMapping.assign(ControlFlowOps.invokeDynamicFunctionIn("getObjectMapping", targetProcedure())));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
         lQueryObject.assign(ghProp.unwrapBufferField().value());
         
         if (_not(lQueryObject))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataContainer"));
            lDataContainer.assign(ghProp.unwrapBufferField().value());
            
            if ((lDataContainer).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("initializeDataObjects", targetProcedure(), "I", new logical(true));
            }
         }
         
         /* Do our own visualization last, after all contents are initialized. */
         if (_isNotEqual(lookup("manualInitializeObjects", targetProcedure().unwrapProcedure().internalEntries()), 0))
         {
            ControlFlowOps.invokeIn("manualInitializeObjects", targetProcedure());
         }
         else
         {
            NamedEventManager.publish("initializeObject", targetProcedure());
         }
         
         /* {set Prop value [handle]} */ 
         silent(() -> ControlFlowOps.invokeDynamicFunctionInWithMode("setObjectMapping", targetProcedure(), "I", cObjectMapping));
         
         /* Set StartPage to 0 so selectPage() will do the right thing. */
         if (_isUnknown(iStartPage))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("StartPage"));
            ghProp.unwrapBufferField().changeValue(new integer(0));
         }
         /* {set Prop value [handle]} */ 
         
         if (_and(isEqual(cType, "VIRTUAL"), () -> EnvironmentOps.isBatchMode()))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("WaitForObject"));
            hWaitForObject.assign(ghProp.unwrapBufferField().value());
            
            if ((hWaitForObject.isValid()).booleanValue())
            {
               silent(() -> ControlFlowOps.invokeIn("startWaitFor", hWaitForObject));
            }
         }
         /* if non-visual container and running in batch */
         ControlFlowOps.runSuper("initializeObject");
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hWidget.assign(ghProp.unwrapBufferField().value());
         
         /* Pack and layout this container. */
         if (_and(hWidget.isValid(), () -> matchesList("WINDOW,FRAME", hWidget.unwrapType().getResourceType())))
         {
            /* If this is a Repository object, then make sure everything fits nicely.
                 */
            /* {get Prop var [handle]} */ 
            lUseRepository.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUseRepository", targetProcedure()));
            
            if ((lUseRepository).booleanValue())
            {
               silent(() -> hContainingWindow /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn("getContainingWindow", targetProcedure())));
               
               /* Don't pack a child DynFrame if the parent window has not yet
                          completed its initialisation, since the parent window's initialisaion
                          will perform the pack and resize. There should only be one pack/resize 
                          when a window is launched.
                        */
               if (_and(hContainingWindow.isValid(), () -> isNotEqual(hContainingWindow, targetProcedure())))
               {
                  ghProp.assign(handle.fromString(entry(1, hContainingWindow.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
                  lParentInitted.assign(ghProp.unwrapBufferField().value());
               }
               else
               {
                  lParentInitted.assign(true);
               }
               /* {get Prop var [handle]} */ 
               
               if ((hContainingWindow.isValid()).booleanValue())
               {
                  /* Make sure that we have enough space for the menu items.
                                 This should only be run in the containing window.
                               */
                  /* {fn <func-name> [handle] */
                  silent(() -> ControlFlowOps.invokeDynamicFunctionIn("updateMenuWidth", hContainingWindow));
                  
                  /* Even though Dynamics is running, run these no error
                                 since there may be static windows that don't have the resizing
                                 or packing managed by the Layout Manager.
                                 
                                 Determine the smallest size. Passing in ? will result in
                                 the current page being packed.
                               */
                  if (_not(lParentInitted))
                  {
                     silent(() -> ControlFlowOps.invokeInWithMode("packWindow", targetProcedure(), "II", new unknown(), new logical(false)));
                  }
                  else
                  {
                     silent(() -> ControlFlowOps.invokeInWithMode("packWindow", hContainingWindow, "II", new unknown(), new logical(true)));
                     /* Lay it out. */
                     silent(() -> ControlFlowOps.invokeIn("resizeWindow", hContainingWindow));
                  }
               }
            }
         }
         
         /* window & frame packing and layout. */
         if (_and(hWidget.isValid(), () -> isEqual(hWidget.unwrapType().getResourceType(), "WINDOW")))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DisableOnInit"));
            lDisableOnInit.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("HideOnInit"));
            lHideOnInit.assign(ghProp.unwrapBufferField().value());
            
            if (_not(lDisableOnInit))
            {
               ControlFlowOps.invokeIn("enableObject", targetProcedure());
            }
            
            if (_not(lHideOnInit))
            {
               ControlFlowOps.invokeIn("viewObject", targetProcedure());
            }
            else
            {
               NamedEventManager.publish("LinkState", targetProcedure(), "I", new Object[]
               {
                  "inactive"
               });
            }
         }
         
         if (_isEqual(ControlFlowOps.getReturnValue(), "ADM-ERROR"))
         {
            returnNormal("ADM-ERROR");
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: Translate window title and tab folder page labels plus check security<br>
    *          for page labels <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void initializeVisualContainer()
   {
      handle hWindow = TypeFactory.handle();
      character cTitle = TypeFactory.character();
      character cContainerName = TypeFactory.character();
      character cRunAttribute = TypeFactory.character();
      character cSecuredTokens = TypeFactory.character();
      character cDisabledPages = TypeFactory.character();
      integer iLoop = TypeFactory.integer();
      handle hObject = TypeFactory.handle();
      character cFolderLabels = TypeFactory.character();
      character cLabel = TypeFactory.character();
      logical lObjectSecured = TypeFactory.logical();
      logical lObjectTranslated = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_isNotEqual(lookup("getWindowName", targetProcedure().unwrapProcedure().internalEntries()), 0))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
            hWindow.assign(ghProp.unwrapBufferField().value());
            /* {get Prop var [handle]} */ 
            cTitle.assign(ControlFlowOps.invokeDynamicFunctionIn("getWindowName", targetProcedure()));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectSecured"));
            lObjectSecured.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectTranslated"));
            lObjectTranslated.assign(ghProp.unwrapBufferField().value());
            cContainerName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getLogicalObjectName", targetProcedure()));
            cRunAttribute.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRunAttribute", targetProcedure()));
            
            /* Set default values. */
            if (_isUnknown(lObjectSecured))
            {
               lObjectSecured.assign(false);
            }
            
            if (_isUnknown(lObjectTranslated))
            {
               lObjectTranslated.assign(false);
            }
            
            /* If both object security and translation have been performed, then there is nothing
                 * to do here. Both of these values are usually set at the same time, but there may be
                 * cases where only one of these values is set. We need to cater for this.  */
            if (_and(lObjectSecured, lObjectTranslated))
            {
               returnNormal();
            }
            
            /* 1st empty current temp-table contents */
            tttranslate.deleteAll();
            /* Add entry for window title */
            tttranslate.create();
            batch(() -> 
            {
               tttranslate.setDlanguageobj(new integer(0));
               tttranslate.setCobjectname(cContainerName);
               tttranslate.setLglobal(new logical(false));
               tttranslate.setLdelete(new logical(false));
               tttranslate.setCwidgettype(new character("TITLE"));
               tttranslate.setCwidgetname(new character("TITLE"));
               tttranslate.setHwidgethandle(hWindow);
               tttranslate.setIwidgetentry(new integer(0));
               tttranslate.setCoriginallabel(hWindow.unwrapWidget().getTitle());
               tttranslate.setCtranslatedlabel(new character(""));
               tttranslate.setCoriginaltooltip(new character(""));
               tttranslate.setCtranslatedtooltip(new character(""));
            });
            tttranslate.release();
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("PageSource"));
            hObject.assign(ghProp.unwrapBufferField().value());
            
            if ((hObject.isValid()).booleanValue())
            {
               /* {get Prop var [handle]} */
               cFolderLabels.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getFolderLabels", hObject));
            }
            
            /* check security for folder labels */
            if (_and(isNotEqual(lObjectSecured, true), () -> gshSecurityManager.isValid()))
            {
               ControlFlowOps.invokeInWithMode("tokenSecurityGet", gshSecurityManager, "IIIO", targetProcedure(), cContainerName, cRunAttribute, cSecuredTokens);
            }
            
            cSecuredTokens.assign(replaceAll(cSecuredTokens, "&", ""));
            
            labelLoop:
            for (iLoop.assign(1); _isLessThanOrEqual(iLoop, numEntries(cFolderLabels, "|")); iLoop.increment())
            {
               cLabel.assign(entry(iLoop, cFolderLabels, "|"));
               
               if (_and(isNotEqual(cSecuredTokens, ""), () -> isNotEqual(lookup(replaceAll(cLabel, "&", ""), cSecuredTokens), 0)))
               {
                  cDisabledPages.assign(concat(cDisabledPages, (_isNotEqual(cDisabledPages, "") ? new character(",") : new character("")), valueOf(iLoop)));
               }
               
               tttranslate.create();
               batch(() -> 
               {
                  tttranslate.setDlanguageobj(new integer(0));
                  tttranslate.setCobjectname(cContainerName);
                  tttranslate.setLglobal(new logical(false));
                  tttranslate.setLdelete(new logical(false));
                  tttranslate.setCwidgettype(new character("TAB"));
                  tttranslate.setCwidgetname(new character("TAB"));
                  tttranslate.setHwidgethandle(hObject);
                  tttranslate.setIwidgetentry(iLoop);
                  tttranslate.setCoriginallabel(cLabel);
                  tttranslate.setCtranslatedlabel(new character(""));
                  tttranslate.setCoriginaltooltip(new character(""));
                  tttranslate.setCtranslatedtooltip(new character(""));
               });
               tttranslate.release();
            }
            
            /* label-loop */
            /* Now got all translation widgets - get translations */
            if (_isNotEqual(lObjectTranslated, true))
            {
               if ((gshTranslationManager.isValid()).booleanValue())
               {
                  ControlFlowOps.invokeInWithMode("multiTranslation", gshTranslationManager, "IU", new logical(false), new TableParameter(tttranslate));
               }
               
               AdaptiveQuery query0 = new AdaptiveQuery();
               
               forEach("translateLoop", new Block((Init) () -> 
               {
                  query0.initialize(tttranslate, ((String) null), null, "tttranslate.dlanguageobj asc, tttranslate.cobjectname asc, tttranslate.cwidgettype asc, tttranslate.cwidgetname asc, tttranslate.hwidgethandle asc, tttranslate.iwidgetentry asc");
               }, 
               (Body) () -> 
               {
                  /* now action the translations */
                  query0.next();
                  
                  if (_and(isEqual(tttranslate.getCtranslatedlabel(), ""), () -> isEqual(tttranslate.getCtranslatedtooltip(), "")))
                  {
                     next("translateLoop");
                  }
                  
                  if (_and(isEqual(tttranslate.getCwidgettype(), "title"), () -> isNotEqual(tttranslate.getCtranslatedlabel(), "")))
                  {
                     hWindow.unwrapWidget().setTitle(tttranslate.getCtranslatedlabel());
                     /* {set Prop value [handle]} */ 
                     ControlFlowOps.invokeDynamicFunctionInWithMode("setwindowName", targetProcedure(), "I", hWindow.unwrapWidget().getTitle());
                  }
                  
                  if (_isEqual(tttranslate.getCwidgettype(), "tab"))
                  {
                     iLoop.assign(lookup(tttranslate.getCoriginallabel(), cFolderLabels, "|"));
                     
                     if (_isGreaterThan(iLoop, 0))
                     {
                        cFolderLabels.replaceEntry(iLoop, "|", tttranslate.getCtranslatedlabel());
                     }
                  }
               }));
               
               /* translate pages */
               if (_isNotEqual(cFolderLabels, ""))
               {
                  /* {set Prop value [handle]} */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setFolderLabels", hObject, "I", cFolderLabels);
               }
            }
            
            /* object translated */
            /* secure pages */
            if (_and(isNotEqual(lObjectSecured, true), () -> isNotEqual(cDisabledPages, "")))
            {
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "disablePagesInFolder", targetProcedure(), "I", concat("security,", cDisabledPages));
            }
         }
         ErrorManager.setError(new logical(false));
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Initializes one or more pages which are not yet being viewed, in<br>
    *           order to establish links or to prepare for the pages being viewed.<br>
    *  Params:  pcPageList AS CHARACTER  comma-separated list of page numbers
    */
   public void initPages(final character _pcPageList_1)
   {
      character pcPageList_1 = TypeFactory.initInput(_pcPageList_1);
      integer iPage_1 = TypeFactory.integer();
      integer iCurrentPage = TypeFactory.integer();
      character cPageObjects = TypeFactory.character();
      integer iCnt = TypeFactory.integer();
      logical lInitted = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         iCurrentPage.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitted.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr16 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(pcPageList_1);
            }
         };
         ToClause toClause16 = new ToClause(iCnt, 1, resExpr16);
         
         doTo("loopLabel17", toClause16, new Block((Body) () -> 
         {
            iPage_1.assign(new integer(entry(iCnt, pcPageList_1)));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
            ghProp.unwrapBufferField().changeValue(iPage_1);
            
            if (_isNotEqual(iPage_1, 0))
            {
               /* Shouldn't be called for page 0 */
               cPageObjects.assign(pageNtargets(targetProcedure(), iPage_1));
               
               if (_isEqual(cPageObjects, ""))
               {
                  /* Page hasn't been created yet:
                                     Get all objects on page init'd*/
                  ControlFlowOps.invokeIn("createObjects", targetProcedure());
                  /* Tell the objects not to view themselves when they
                                     are init'ed; wait until that page is actually selected.*/
                  ControlFlowOps.invokeInWithMode("assignPageProperty", targetProcedure(), "II", new character("HideOnInit"), new character("Yes"));
                  
                  /* If the current container object has been initialized already,
                                     then initialize the new objects. Otherwise wait to let it 
                                     happen when the container is init'ed. */
                  if ((lInitted).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("notifyPage", targetProcedure(), "I", new character("initializeObject"));
                  }
               }
            }
         }));
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         ghProp.unwrapBufferField().changeValue(iCurrentPage);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: Received from container source to check if contained objects have <br>
    *          unsaved or uncommitted changes (including addMode).           <br>
    *   Notes: This is published thru the container link and are used mainly to <br>
    *          validate that a false value received in updateActive cna be used to <br>
    *          set UpdateActive.<br>
    *          This is NOT intended to be called directly, but part of the logic<br>
    *          that updates UpdateActive.  <br>
    *          These are the steps:<br>
    *        - 1. Updating objects publishes updateActive (true or false) to their <br>
    *             container targets. <br>
    *          2. If the value is FALSE the container turns around and publishes <br>
    *             this to ALL ContainerTargets before it is stored in UpdateActive.<br>
    *             This way the value is only stored as false if ALL contained objects are <br>
    *             inactive.
    */
   public void isUpdateActive(final logical plActive_1)
   {
      handle hContainer = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         /* Ok and Cancel should only hide/view within a window, so if we are a window 
              container then don't republish (we currently also ignore virtual containers)*/
         if (_and(and(hContainer.isValid(), () -> isNotEqual(hContainer.unwrapType().getResourceType(), "window")), not(plActive_1)))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateActive"));
            plActive_1.assign(ghProp.unwrapBufferField().value());
         }
         /* {get Prop var [handle]} */ 
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:   Override in order to maintain a unique list of InstanceNames on <br>
    *            add and remove of ContainerTarget link    <br>
    * Parameters: pcState <br>
    *               - 'add','remove','inactive' or 'active' <br>
    *             phObject <br>
    *               - Handle of object to be linked to                                <br>
    *             pcLink<br>
    *               - Link name of link to the other object                                                                 <br>
    * Notes:
    */
   public void linkStateHandler(final character _pcState, final handle _phObject_7, final character _pcLink)
   {
      character pcState = TypeFactory.initInput(_pcState);
      handle phObject_7 = TypeFactory.initInput(_phObject_7);
      character pcLink = TypeFactory.initInput(_pcLink);
      character cInstanceNames = TypeFactory.character();
      character cObjectName = TypeFactory.character();
      character cNewName = TypeFactory.character();
      integer iSeq = TypeFactory.integer();
      character cTargets = TypeFactory.character();
      integer iTarget = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.runSuper("linkStateHandler", pcState, phObject_7, pcLink);
         
         if (_and(isEqual(pcState, "remove"), () -> isEqual(pcLink, "ContainerTarget")))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
            cTargets.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceNames"));
            cInstanceNames.assign(ghProp.unwrapBufferField().value());
            iTarget.assign(lookup(valueOf(phObject_7), cTargets));
            silent(() -> cInstanceNames.replaceEntry(iTarget, ""));
            cInstanceNames.assign(trim(replaceAll(concat(",", cInstanceNames, ","), ",,", ","), ","));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceNames"));
            ghProp.unwrapBufferField().changeValue(cInstanceNames);
         }
         
         if (_and(isEqual(pcState, "add"), () -> isEqual(pcLink, "ContainerTarget")))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceNames"));
            cInstanceNames.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, phObject_7.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
            cObjectName.assign(ghProp.unwrapBufferField().value());
            
            if (_or(isEqual(cObjectName, ""), () -> isUnknown(cObjectName)))
            {
               ghProp.assign(handle.fromString(entry(1, phObject_7.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
               cObjectName.assign(ghProp.unwrapBufferField().value());
            }
            /* {get Prop var [handle]} */ 
            
            iSeq.assign(1);
             /* Start newname on 2 */cNewName.assign(cObjectName);
            
            loopLabel18:
            while ((matchesList(cInstanceNames, cNewName)).booleanValue())
            {
               iSeq.assign(plus(iSeq, 1));
               cNewName.assign(concat(cObjectName, "(", valueOf(iSeq), ")"));
            }
            
            cInstanceNames.assign(concat(cInstanceNames, (_isEqual(cInstanceNames, "") ? new character("") : new character(",")), cNewName));
            ghProp.assign(handle.fromString(entry(1, phObject_7.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
            ghProp.unwrapBufferField().changeValue(cNewName);
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceNames"));
            ghProp.unwrapBufferField().changeValue(cInstanceNames);
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Locates a widget and retuns its handle and the handle of its<br>
    *              TARGET-PROCEDURE<br>
    * Parameters:  pcWidget AS CHARACTER<br>
    *              phWidget AS HANDLE<br>
    *              phTarget AS HANDLE<br>
    * Notes:       Container logic does not support unqualified references and <br>
    *              does not support 'Self' and 'Browser' qualifiers
    */
   public void locateWidget(final character _pcWidget, final handle phWidget, final handle phTarget_2)
   {
      character pcWidget = TypeFactory.initInput(_pcWidget);
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(phWidget);
         TypeFactory.initOutput(phTarget_2);
      }, 
      (Body) () -> 
      {
         if (_or(or(isEqual(numEntries(pcWidget, "."), 1), () -> isEqual(entry(1, pcWidget, ".") /* no qualifier */, "Self")), () -> isEqual(entry(1, pcWidget, "."), "Browse")))
         {
            returnNormal();
         }
         
         ControlFlowOps.runSuper("locateWidget", pcWidget, phWidget, phTarget_2);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Invokes the specified procedure in all objects on the CurrentPage of<br>
    *           Container TARGET-PROCEDURE.<br>
    *  Params:  pcProc AS CHARACTER  internal procedure to run<br>
    *   Notes:  This vestige of "notify" is necessary because the notion of paging<br>
    *           does not fit well with PUBLISH/SUBSCRIBE. All objects in a Container<br>
    *           will subscribe to initialize, etc., but the paging performs the<br>
    *           operation on subsets of those objects at a time.<br>
    *         - This method has special logic for "initializeObject" to ensure <br>
    *           that data objects are initialized first
    */
   public void notifyPage(final character _pcProc_1)
   {
      character pcProc_1 = TypeFactory.initInput(_pcProc_1);
      integer iVar = TypeFactory.integer();
      character cObjects = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      logical lQuery = TypeFactory.logical();
      logical lInitted = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         iVar.assign(ghProp.unwrapBufferField().value());
         cObjects.assign(pageNtargets(targetProcedure(), iVar));
         
         /* If intitializing ensure that SDOs are initialized first. This is important 
              since dynamic SDOs create the TT during initialization and visual objects 
              traditionally assume that their datasource's rowobject is valid */
         if (_isEqual(pcProc_1, "initializeObject"))
         {
            IntegerExpression resExpr17 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cObjects);
               }
            };
            ToClause toClause17 = new ToClause(iVar, 1, resExpr17);
            
            doTo("loopLabel19", toClause17, new Block((Body) () -> 
            {
               hObject.assign(handle.fromString(entry(iVar, cObjects)));
               
               if ((hObject.isValid()).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
                  lInitted.assign(ghProp.unwrapBufferField().value());
                  ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                  lQuery.assign(ghProp.unwrapBufferField().value());
                  
                  if (_and(lQuery, not(lInitted)))
                  {
                     silent(() -> ControlFlowOps.invokeIn("initializeObject", hObject));
                  }
               }
            }));
         }
         
         IntegerExpression resExpr18 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cObjects);
            }
         };
         ToClause toClause18 = new ToClause(iVar, 1, resExpr18);
         
         doTo("loopLabel20", toClause18, new Block((Body) () -> 
         {
            hObject.assign(handle.fromString(entry(iVar, cObjects)));
            lQuery.assign(false);
            lInitted.assign(false);
            
            if ((hObject.isValid()).booleanValue())
            {
               /* if initialize then query objects were initialized in the loop above */
               if (_isEqual(pcProc_1, "initializeObject"))
               {
                  ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
                  lInitted.assign(ghProp.unwrapBufferField().value());
               }
               /* {get Prop var [handle]} */ 
               
               ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
               lQuery.assign(ghProp.unwrapBufferField().value());
               
               if (_and(not(lQuery), not(lInitted)))
               {
                  silent(() -> ControlFlowOps.invokeIn((pcProc_1).toStringMessage(), handle.fromString(entry(iVar, cObjects))));
               }
            }
         }));
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * <p>
    * Purpose: Save and close an object (Ok action)    <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:  If this is the window container or a virtual container then <br>
    *         override andnot* call SUPER.    <br>
    *         if not then save and commit all containertargets and destroy if <br>
    *         no errors occured.<br>
    *         Published from containerTargets or called directly.<br>
    *       - There is a slight overhead in this construct as destroyObject<br>
    *         (called from exitObject -&gt; apply 'close') does a publish <br>
    *         'confirmExit', which really is unnecessary after this has <br>
    *         published 'confirmOk'.<br>
    *         The reason is that destroyObject may be called directly.<br>
    *       - We currently have to call exitObject as the appbuilder <br>
    *         wait-for protests if we destroy directly. <br>
    *         Even apply 'close' to target-procedure does not trigger <br>
    *         the wait-for. It seems as this has to be fired from the actual <br>
    *         instance. (exitObject shoueld be local in all container instances)<br>
    *         This may very well be a problem for application wait-for as well.
    */
   public void okObject()
   {
      handle hContainer = TypeFactory.handle();
      logical lError = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if (_and(hContainer.isValid(), () -> isNotEqual(hContainer.unwrapType().getResourceType(), "WINDOW")))
         {
            ControlFlowOps.runSuper("okObject");
         }
         else
         {
            /* Save and commit all Container targets  */
            NamedEventManager.publish("confirmOk", targetProcedure(), "U", new Object[]
            {
               lError
            });
            
            if (_not(lError))
            {
               silent(() -> ControlFlowOps.invokeIn("exitObject", targetProcedure()));
               
               if ((ErrorManager.isError()).booleanValue())
               {
                  ControlFlowOps.invokeIn("destroyObject", targetProcedure());
               }
            }
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Acts as an intermediary for dynamic links which need the<br>
    *              pass-through mechanism, to get an event from an object outside<br>
    *              a container to one inside it, or vice-versa.<br>
    * Parameters:  pcLinkName AS CHARACTER  the link (event) name to be passed on;<br>
    *              pcArgument AS CHARACTER  a single character string argument.<br>
    * Notes:       To use this for single pass-through events, define a PassThrough<br>
    *              link from the Source to the intermediate container, and define<br>
    *              the actual dynamic link from the container to the Target. <br>
    *              Then PUBLISH 'PassThrough' (LinkName, Argument) to send the event.
    */
   public void passThrough(final character _pcLinkName, final character _pcArgument)
   {
      character pcLinkName = TypeFactory.initInput(_pcLinkName);
      character pcArgument = TypeFactory.initInput(_pcArgument);
      
      internalProcedure(new Block((Body) () -> 
      {
         NamedEventManager.publish(pcLinkName, targetProcedure(), "I", new Object[]
         {
            pcArgument
         });
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:   prepare Data objects for fetch    <br>
    * Parameters: phTopContainer - Container that originated the request from<br>
    *                              fetchContainedData or fetchContainedRows<br>
    *             pcAppservice   - passed on to data objects (see data.p)  <br>
    *             pcObject       - if PcOptions is 'POSITION' then this <br>
    *                              is the data source.<br>
    *             pcOptions <br>
    *               POSITION - Special request to find all SmartDataFields in this<br>
    *                          cointainer and retrieve position information about <br>
    *                          their sources.  <br>
    *                          <br>
    * Notes:
    */
   public void prepareDataForFetch(final handle _phTopContainer_1, final character _pcAppService_1, final character _pcObject_2, final character _pcOptions_1, final character pcHandles, final character pcPhysicalNames, final character pcQualNames, final character pcForeignFields, final character pcQueries_1, final character pcTables)
   {
      handle phTopContainer_1 = TypeFactory.initInput(_phTopContainer_1);
      character pcAppService_1 = TypeFactory.initInput(_pcAppService_1);
      character pcObject_2 = TypeFactory.initInput(_pcObject_2);
      character pcOptions_1 = TypeFactory.initInput(_pcOptions_1);
      character cTargets = TypeFactory.character();
      character cInstanceNames = TypeFactory.character();
      integer iTarget = TypeFactory.integer();
      handle hTarget = TypeFactory.handle();
      logical lQuery = TypeFactory.logical();
      character cContainerType = TypeFactory.character();
      handle hDataSource = TypeFactory.handle();
      logical lPosition = TypeFactory.logical();
      character cFieldName = TypeFactory.character();
      character cKeyField = TypeFactory.character();
      character cInactiveLinks = TypeFactory.character();
      logical lInit = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
         cTargets.assign(ghProp.unwrapBufferField().value());
         lPosition.assign(isGreaterThan(lookup("POSITION", pcOptions_1), 0));
         lInit.assign(isGreaterThan(lookup("INIT", pcOptions_1), 0));
         
         /* Skip this container if the DataSource link is inactive 
            and this is a position request*/
         if ((lPosition).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("Inactivelinks"));
            cInactiveLinks.assign(ghProp.unwrapBufferField().value());
            
            if (_isGreaterThan(lookup("DataSource", cInactiveLinks), 0))
            {
               returnNormal();
            }
         }
         
         if (_and(isGreaterThan(pcObject_2, ""), not(lPosition)))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceNames"));
            cInstanceNames.assign(ghProp.unwrapBufferField().value());
            hTarget.assign(handle.fromString(entry(lookup(pcObject_2, cInstanceNames), cTargets)));
            
            if ((hTarget.isValid()).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("prepareDataForFetch", hTarget, "IIIIUUUUUU", phTopContainer_1, pcAppService_1, new unknown(), pcOptions_1, pcHandles, pcPhysicalNames, pcQualNames, pcForeignFields, pcQueries_1, pcTables);
               /* Second pass, visualtargets - pass position option to visual targets
                      and prepare position information */
               ControlFlowOps.invokeInWithMode("prepareDataForFetch", hTarget, "IIIIUUUUUU", phTopContainer_1, pcAppService_1, new unknown(), concat("VISUALTARGETS", (lInit).booleanValue() ? new character(",INIT") : new character("")), pcHandles, pcPhysicalNames, pcQualNames, pcForeignFields, pcQueries_1, pcTables);
            }
         }
         else
         {
            IntegerExpression resExpr19 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cTargets);
               }
            };
            ToClause toClause19 = new ToClause(iTarget, 1, resExpr19);
            
            doTo("loopLabel21", toClause19, new Block((Body) () -> 
            {
               hTarget.assign(handle.fromString(entry(iTarget, cTargets)));
               
               if (_not(lPosition))
               {
                  lQuery.assign(false);
                  cContainerType.assign("");
                  ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                  lQuery.assign(ghProp.unwrapBufferField().value());
                  ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerType"));
                  cContainerType.assign(ghProp.unwrapBufferField().value());
                  
                  if (_or(isRequestTreeRoot(phTopContainer_1, hTarget), () -> and(and(not(lQuery), () -> isNotEqual(cContainerType, "")), () -> notUnknown(cContainerType))))
                  {
                     ControlFlowOps.invokeInWithMode("prepareDataForFetch", hTarget, "IIIIUUUUUU", phTopContainer_1, pcAppService_1, new unknown(), pcOptions_1, pcHandles, pcPhysicalNames, pcQualNames, pcForeignFields, pcQueries_1, pcTables);
                  }
               }
               else
               {
                  cFieldName.assign("");
                  /* {get Prop var [handle]} */
                  silent(() -> cFieldName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getFieldName", hTarget)));
                  
                  /* If a SmartDataField then prepare position info for its DataSource */
                  if (_isGreaterThan(cFieldName, ""))
                  {
                     /* {get Prop var [handle]} */
                     hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hTarget));
                     
                     if ((hDataSource.isValid()).booleanValue())
                     {
                        /* {get Prop var [handle]} */
                        cKeyField.assign(ControlFlowOps.invokeDynamicFunctionIn("getKeyField", hTarget));
                        ControlFlowOps.invokeInWithMode("prepareDataForFetch", hDataSource, "IIIIUUUUUU", phTopContainer_1, pcAppService_1, concat(pcObject_2, ",", cKeyField, ",", cFieldName), pcOptions_1, pcHandles, pcPhysicalNames, pcQualNames, pcForeignFields, pcQueries_1, pcTables);
                     }
                  }
               }
            }));
            
            /* Second pass  - pass position option to visual targets */
            if (_not(lPosition))
            {
               IntegerExpression resExpr20 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(cTargets);
                  }
               };
               ToClause toClause20 = new ToClause(iTarget, 1, resExpr20);
               
               doTo("loopLabel22", toClause20, new Block((Body) () -> 
               {
                  hTarget.assign(handle.fromString(entry(iTarget, cTargets)));
                  
                  if ((isRequestTreeRoot(phTopContainer_1, hTarget)).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("prepareDataForFetch", hTarget, "IIIIUUUUUU", phTopContainer_1, pcAppService_1, new unknown(), concat("VISUALTARGETS", (lInit).booleanValue() ? new character(",INIT") : new character("")), pcHandles, pcPhysicalNames, pcQualNames, pcForeignFields, pcQueries_1, pcTables);
                  }
               }));
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Removes an object from the list of Targets on a page.<br>
    * Parameters:  phTarget AS HANDLE  handle of the object being removed;<br>
    *              piPage   AS INTEGER  page number the object is on.<br>
    * Notes:       Run from removeAllLinks for objects not on Page 0.
    */
   public void removePageNtarget(final handle _phTarget_2, final integer _piPage)
   {
      handle phTarget_2 = TypeFactory.initInput(_phTarget_2);
      integer piPage = TypeFactory.initInput(_piPage);
      
      internalProcedure(new Block((Body) () -> 
      {
         /* The format of the PageNTargets list is <handle>|<page>[,...] */
         ControlFlowOps.invokeInWithMode("modifyListProperty", targetProcedure(), "IIII", targetProcedure(), new character("REMOVE"), new character("PageNTarget"), concat(valueOf(phTarget_2), "|", valueOf(piPage)));
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:    Respond to a resize event from user event or container targets.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:      The current functionality just resizes the frame according to the<br>
    *             window size. This was added to make the call from the toolbar's <br>
    *             resizeObject after it expands a window have some default <br>
    *             functionality also outside ICF, but this is mostly a placeholder <br>
    *             for logic to resize all contained objects, currently implemented <br>
    *             in ICF ry/uib/rydyncontw.w.
    */
   public void resizeWindow()
   {
      handle hContainerHandle = TypeFactory.handle();
      handle hContainerSource = TypeFactory.handle();
      handle hFrame = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainerHandle.assign(ghProp.unwrapBufferField().value());
         
         if (_and(hContainerHandle.isValid(), () -> isEqual(hContainerHandle.unwrapType().getResourceType(), "Window")))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("WindowFrameHandle"));
            hFrame.assign(ghProp.unwrapBufferField().value());
            
            if ((hFrame.isValid()).booleanValue())
            {
               /* Intentionally separate statments with no-error to always shrink if 
                        possible. We could have used max(frame,window) to ensure that the 
                        frames only were increased, but we want to shrink unless some widget 
                        inside the frame prevents it.  */
               silent(() -> hFrame.unwrapSizeable().setWidthChars(hContainerHandle.unwrapSizeable().getWidthChars()));
               silent(() -> hFrame.unwrapSizeable().setHeightChars(hContainerHandle.unwrapSizeable().getHeightChars()));
            }
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
            hContainerSource.assign(ghProp.unwrapBufferField().value());
            silent(() -> ControlFlowOps.invokeIn("resizeWindow", hContainerSource));
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Changes the currently selected page. If the previous current page<br>
    *           is not page 0 (the background page which is always visible), then <br>
    *           hideObject is run in all the objects on the CurrentPage. Then<br>
    *           the CurrentPage is changed to the new page number of piPageNum, and<br>
    *           the changePage procedure is run to view, and if necessary, create<br>
    *           the objects on the new page.<br>
    *  Params:  INPUT piPageNum AS INTEGER
    */
   public void selectPage(final integer _piPageNum_2)
   {
      integer piPageNum_2 = TypeFactory.initInput(_piPageNum_2);
      integer iCurrentPage = TypeFactory.integer();
      character cPageList = TypeFactory.character();
      integer iStartPage = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("StartPage"));
         iStartPage.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         iCurrentPage.assign(ghProp.unwrapBufferField().value());
         
         /* If this property has its initial value of unknown, then we are
              in the middle of createObjects and want to postpone this selectPage
              until that is done. */
         if (_isUnknown(iStartPage))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("StartPage"));
            ghProp.unwrapBufferField().changeValue(piPageNum_2);
            returnNormal();
         }
         
         /* END DO IF iStartPage = ? */
         if (_isEqual(iCurrentPage, piPageNum_2))
         {
            cPageList.assign(pageNtargets(targetProcedure(), iCurrentPage));
            
            if (_isNotEqual(cPageList, ""))
            {
               returnNormal();
            }
         }
         /* Don't reselect the same page unless the object(s) on that page
              have since been destroyed (a SmartWindow that was closed, e.g.). */
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PendingPage"));
         ghProp.unwrapBufferField().changeValue(piPageNum_2);
         
         if (_isNotEqual(iCurrentPage, 0))
         {
            ControlFlowOps.invokeInWithMode("notifyPage", targetProcedure(), "I", new character("hideObject"));
         }
         
         /* Save old page for TTY change-page */
         giPrevPage.assign(iCurrentPage);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         ghProp.unwrapBufferField().changeValue(piPageNum_2);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PendingPage"));
         ghProp.unwrapBufferField().changeValue(new unknown());
         ControlFlowOps.invokeIn("changePage", targetProcedure());
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Reset context and initialize this server side object   <br>
    * Parameters:  pcContext <br>
    *              Properties in the format returned from <br>
    *              containedProperties to be passed to assignContainedProperties <br>
    * Notes:    Called from a stateless client before a request.<br>
    *           The format used in this subject to change.  <br>
    *           The container does not currently have an OpenOnInit property <br>
    *           so the caller would need to set openOnInit in all dataobjects<br>
    *        -  The sbo overrides in order to do this.
    */
   public void setContextAndInitialize(final character _pcContext_2)
   {
      character pcContext_2 = TypeFactory.initInput(_pcContext_2);
      
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.invokeIn("createObjects", targetProcedure());
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignContainedProperties", targetProcedure(), "II", pcContext_2, "");
         ControlFlowOps.invokeIn("initializeObject", targetProcedure());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Generic event handler for toolbar events<br>
    * Parameters:  pcValue (Character) - the name of the toolbar action<br>
    * Notes:
    */
   public void toolbar(final character _pcValue)
   {
      character pcValue = UndoableFactory.initInput(_pcValue);
      character cResult = TypeFactory.character();
      handle hRunContainer = TypeFactory.handle();
      character cRunContainerType = TypeFactory.character();
      handle hContainingWindow = TypeFactory.handle();
      handle hFrame = TypeFactory.handle();
      character cObjects = TypeFactory.character();
      integer i = TypeFactory.integer();
      handle hObject = TypeFactory.handle();
      handle hObjectFrame = TypeFactory.handle();
      logical lSame = TypeFactory.logical();
      integer iCurrentPage = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         switch (StringHelper.safeTrimTrailing((pcValue).toStringMessage()).toUpperCase())
         {
            case "ENABLEDATA":
               {
                  /* cause data links to be activated */
                  NamedEventManager.publish("ToggleData", targetProcedure(), "I", new Object[]
                  {
                     true
                  });
               }
               break;
            case "DISABLEDATA":
               {
                  /* cause data links to be de-activated */
                  NamedEventManager.publish("ToggleData", targetProcedure(), "I", new Object[]
                  {
                     false
                  });
               }
               break;
            case "NOTEPAD":
               {
                  if ((gshSessionManager.isValid()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("launchExternalProcess", gshSessionManager, "IIIO", new character("notepad"), new character(""), new integer(1), cResult);
                  }
               }
               break;
            case "WORDPAD":
               {
                  if ((gshSessionManager.isValid()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("launchExternalProcess", gshSessionManager, "IIIO", new character("write"), new character(""), new integer(1), cResult);
                  }
               }
               break;
            case "CALCULATOR":
               {
                  if ((gshSessionManager.isValid()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("launchExternalProcess", gshSessionManager, "IIIO", new character("calc"), new character(""), new integer(1), cResult);
                  }
               }
               break;
            case "INTERNET":
               {
                  if ((gshSessionManager.isValid()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("launchExternalProcess", gshSessionManager, "IIIO", new character("c:\\program files\\plus!\\microsoft internet\\iexplore.exe www.mip-holdings.com"), new character(""), new integer(1), cResult);
                  }
               }
               break;
            case "EMAIL":
               {
                  if ((gshSessionManager.isValid()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("sendEmail", gshSessionManager, "IIIIIIIIIIIIO", new character(""), new character(""), new character(""), new character(""), new character(""), new character(""), new character(""), not(or(SessionUtils.isRemote(), () -> isEqual(LogicalTerminal.getClientType(), "WEBSPEED"))), new integer(0), new logical(false), new logical(false), new character(""), cResult);
                  }
               }
               break;
 /* If failed - the reason why, blank = it worked */            case "WORD":
               {
                  break;
               }
            case "EXCEL":
               {
                  break;
               }
            case "PRINTSETUP":
               {
                  PrintingService.createSetupDialog()
                        .execute();
               }
               break;
            case "SUSPEND":
               {
                  ControlFlowOps.invoke("af/cod2/aftemsuspd.w");
               }
               break;
            case "RE-LOGON":
               {
                  if ((gshSessionManager.isValid()).booleanValue())
                  {
                     ControlFlowOps.invokeIn("relogon", gshSessionManager);
                  }
               }
               break;
            case "PREFERENCES":
               {
                  if ((gshSessionManager.isValid()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("launchContainer", gshSessionManager, "IIIIIIIIIIIOO", new character("rydynprefw"), new character(""), new character(""), new logical(true), new character(""), new character(""), new character(""), new character(""), new unknown(), targetProcedure(), new unknown(), hRunContainer, cRunContainerType);
                  }
               }
               break;
            case "TRANSLATE":
               {
                  /* We only allow translations of the entire container window, which will
                             automatically include any viewers, browses, toolbars and other objects
                             contained by it. 
                             If we allow translations for other container types, such as FRAME (which
                             if what a viewer is), translation does not work properly, particulary 
                             since the translation relies on translating an entire container.
                          */
                  /* Check if all pages should be initialized for translation and if so,
                             ensure they all are initialized */
                  /* {fn <func-name> [handle] */ 
                  ControlFlowOps.invokeDynamicFunctionIn(logical.class, "initPagesForTranslation", targetProcedure());
                  silent(() -> hContainingWindow /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn("getContainingWindow", targetProcedure())));
                  
                  if (_isUnknown(hContainingWindow))
                  {
                     hContainingWindow.assign(targetProcedure());
                  }
                  
                  if (_isNotEqual(hContainingWindow, targetProcedure()))
                  {
                     /* {fn <func-name> [handle] */
                     ControlFlowOps.invokeDynamicFunctionIn(logical.class, "initPagesForTranslation", hContainingWindow);
                  }
                  
                  ControlFlowOps.invokeInWithMode("launchContainer", gshSessionManager, "IIIIIIIIIIIOO", new character("rydyntranw"), new character(""), new character(""), new logical(true), new character(""), new character(""), new character(""), new character(""), new unknown(), hContainingWindow, new unknown(), hRunContainer, cRunContainerType);
               }
               break;
            case "HELP":
               {
                  /* Check whether the focus widget is on the current page. If
                           yes, then one can apply the help of the frame. If no, we
                           must apply the help of the window object */
                  if (_and(focus().isValid(), () -> HandleOps.canQuery(focus(), "frame")))
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
                     iCurrentPage.assign(ghProp.unwrapBufferField().value());
                     hFrame.assign(focus().unwrapWidget().getFrameHandle());
                     
                     if (_isEqual(hFrame.unwrapType().getResourceType(), "FRAME"))
                     {
                        cObjects.assign(pageNtargets(targetProcedure(), iCurrentPage));
                        
                        loopLabel23:
                        for (i.assign(1); _isLessThanOrEqual(i, numEntries(cObjects)); i.increment())
                        {
                           silent(() -> hObject.assign(handle.fromString(entry(i, cObjects))));
                           silent(() -> 
                           {
                              ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                              ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
                              hObjectFrame.assign(ghProp.unwrapBufferField().value());
                           });
                           
                           if (_isEqual(hFrame, hObjectFrame))
                           {
                              lSame.assign(true);
                              break loopLabel23;
                           }
                        }
                     }
                     
                     if ((lSame).booleanValue())
                     {
                        apply(hFrame, "HELP");
                     }
                     else
                     {
                        ControlFlowOps.invokeInWithMode("contextHelp", gshSessionManager, "II", targetProcedure(), new unknown());
                     }
                  }
                  else
                  {
                     if ((gshSessionManager.isValid()).booleanValue())
                     {
                        ControlFlowOps.invokeInWithMode("contextHelp", gshSessionManager, "II", targetProcedure(), new unknown());
                     }
                  }
               }
               break;
            case "HELPABOUT":
               {
                  if ((gshSessionManager.isValid()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("helpabout", gshSessionManager, "I", targetProcedure());
                  }
               }
               break;
            case "HELPTOPICS":
               {
                  if ((gshSessionManager.isValid()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("helptopics", gshSessionManager, "I", targetProcedure());
                  }
               }
               break;
            case "HELPCONTENTS":
               {
                  if ((gshSessionManager.isValid()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("helpcontents", gshSessionManager, "I", targetProcedure());
                  }
               }
               break;
            case "HELPHELP":
               {
                  if ((gshSessionManager.isValid()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("helphelp", gshSessionManager, "I", targetProcedure());
                  }
               }
               break;
            case "SPELL":
               {
                  break;
               }
            case "AUDIT":
               {
                  break;
               }
            case "COMMENTS":
               {
                  break;
               }
            case "HISTORY":
               {
                  break;
               }
            case "STATUS":
               {
                  break;
               }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Published from containertargets when they change state.<br>
    *              (setDataModified, setNewRecord and setRowObjectState) <br>
    * Parameters:  plActive <br>
    *                 TRUE or FALSE <br>
    *     Notes:  This is part of the logic to make the UpdateActive property reflect <br>
    *             the containers state.     <br>
    *             These are the steps:<br>
    *             - 1. Updating objects publishes updateActive (true or false) to <br>
    *                  their container targets. <br>
    *             - 2. If the value is FALSE the container turns around and publishes<br>
    *                  this to ALL ContainerTargets before it is stored in <br>
    *                  UpdateActive.<br>
    *             This way the value is only stored as false if ALL contained <br>
    *             objects are inactive. <br>
    *           - All participating events including okObject and okCancel is bound<br>
    *             within a window container.
    */
   public void updateActive(final logical _plActive_1)
   {
      logical plActive_1 = TypeFactory.initInput(_plActive_1);
      handle hContainer = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_not(plActive_1))
         {
            NamedEventManager.publish("isUpdateActive", targetProcedure(), "U", new Object[]
            {
               plActive_1
            });
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateActive"));
         ghProp.unwrapBufferField().changeValue(plActive_1);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         /* Tell containerSource unless we already are at the window level */
         if (_and(hContainer.isValid(), () -> isNotEqual(hContainer.unwrapType().getResourceType(), "window")))
         {
            NamedEventManager.publish("UpdateActive", targetProcedure(), "I", new Object[]
            {
               plActive_1
            });
         }
         
         /* Tell the toolbar source, which has the ok, cancel and exit actions */
         NamedEventManager.publish("resetContainerToolbar", targetProcedure());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     (Visual) Container-specific code for viewObject. If the<br>
    *               HideOnInit property has been set during initialization,<br>
    *               to allow this object and its contents to be initialized<br>
    *               without being viewed, turn that off here and explicitly<br>
    *               view all contents.<br>
    * Parameters:  &lt;none&gt;
    */
   public void viewObject()
   {
      logical lHide = TypeFactory.logical();
      handle hContainer = TypeFactory.handle();
      character cUibmode = TypeFactory.character();
      character cType = TypeFactory.character();
      handle hFrame = TypeFactory.handle();
      logical lRemoveMenu = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerType"));
         cType.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RemoveMenuOnhide"));
         lRemoveMenu.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("WindowFrameHandle"));
         hFrame.assign(ghProp.unwrapBufferField().value());
         
         if (_isNotEqual(cType, "VIRTUAL"))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UIBMode"));
            cUibmode.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("HideOnInit"));
            lHide.assign(ghProp.unwrapBufferField().value());
            
            if ((lHide).booleanValue())
            {
               if (_isEqual(cUibmode, ""))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("HideOnInit"));
                  ghProp.unwrapBufferField().changeValue(new logical(false));
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignLinkProperty", targetProcedure(), "III", "Container-Target", "HideOnInit", "no");
               }
               
               /* END DO IF UIBMODE = "" */
               NamedEventManager.publish("viewObject", targetProcedure());
            }
         }
 /* Non-visual container; nothing to view. */;
         
         /* END OF NOT virtual container */
         if ((lRemoveMenu).booleanValue())
         {
            NamedEventManager.publish("rebuildMenu", targetProcedure());
         }
         
         ControlFlowOps.runSuper("viewObject");
         
         /* If this need to be before super, then just move it. The current order
             is arbitrary  */
         if ((hFrame.isValid()).booleanValue())
         {
            hFrame.unwrapWidget().setHidden(new logical(false));
         }
         
         if (_and(hContainer.isValid(), () -> isEqual(hContainer.unwrapType().getResourceType(), "WINDOW")))
         {
            apply(hContainer, "ENTRY");
            hContainer.unwrapWidget().moveToTop();
            
            if (_isEqual(hContainer.unwrapWindow().getWindowState(), CommonWindow.WINDOW_STATE_MINIMIZED))
            {
               hContainer.unwrapWindow().setWindowState(CommonWindow.WINDOW_STATE_NORMAL);
            }
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Views a new page without hiding the current page. This is<br>
    *           intended to be run from application code which wants to view<br>
    *           a new page which is a separate SmartWindow. viewPage will run<br>
    *           changePage to view (and if necessary create) the new SmartWindow,<br>
    *           but will not hide the objects on the current page, since they<br>
    *           are in a separate window which can be viewed at the same time.<br>
    *          <br>
    *  Params:  INPUT piPageNum AS INTEGER<br>
    *   Notes:  because the previous page is not hidden, the CurrentPage property<br>
    *           is reset only temporarily so that changePage knows the new<br>
    *           page number; then it is reset to its previous value.
    */
   public void viewPage(final integer _piPageNum_2)
   {
      integer piPageNum_2 = TypeFactory.initInput(_piPageNum_2);
      integer iCurrentPage = TypeFactory.integer();
      character cPageList = TypeFactory.character();
      integer iPrevPage = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         iCurrentPage.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(iCurrentPage, piPageNum_2))
         {
            cPageList.assign(pageNtargets(targetProcedure(), iCurrentPage));
            
            if (_isNotEqual(cPageList, ""))
            {
               returnNormal();
            }
         }
         /* Don't reselect the same page unless the object(s) on that page
              have since been destroyed (a SmartWindow that was closed, e.g.). */
         iPrevPage.assign(iCurrentPage);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         ghProp.unwrapBufferField().changeValue(piPageNum_2);
         ControlFlowOps.invokeIn("changePage", targetProcedure());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         ghProp.unwrapBufferField().changeValue(iPrevPage);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public logical addPageNrequiredPages(final integer _piPageNumber_1, final character _pcPageLinkedList_1)
   {
      integer piPageNumber_1 = TypeFactory.initInput(_piPageNumber_1);
      character pcPageLinkedList_1 = TypeFactory.initInput(_pcPageLinkedList_1);
      /*------------------------------------------------------------------------------
        Purpose:  Adds an entry to the value of the RequiredPages property.
          Notes:  * There is an offset of one because of the fact that we also store the 
                     linked pages for page zero. This is in the first position.
      ------------------------------------------------------------------------------*/
      character cAllRequiredPages = TypeFactory.character();
      
      return function("addPageNRequiredPages", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RequiredPages"));
         cAllRequiredPages.assign(ghProp.unwrapBufferField().value());
         silent(() -> cAllRequiredPages.replaceEntry(plus(piPageNumber_1, 1), "|", pcPageLinkedList_1));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RequiredPages"));
         ghProp.unwrapBufferField().changeValue(cAllRequiredPages);
         returnNormal(true);
      }));
   }

   /** addPageNRequiredPages */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical applyContextFromServer(final character _pcContext_2)
   {
      character pcContext_2 = TypeFactory.initInput(_pcContext_2);
      
      return function("applyContextFromServer", logical.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose: Apply context returned from server after a server call
             Notes: 
                Typical usage:    
                    cContext = obtainContextForServer()
                    run <statelesscall>.p (object,
                                           input-output cContext). 
                    applyContextFromServer(cContext)               
         ------------------------------------------------------------------------------*/
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignContainedProperties", targetProcedure(), "II", pcContext_2, "QueryWhere,QueryContext,OpenQuery,BaseQuery");
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setAsHasStarted", targetProcedure(), "I", true);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical assignContainedProperties(final character _pcPropValues_1, final character _pcReplace_1)
   {
      character pcPropValues_1 = TypeFactory.initInput(_pcPropValues_1);
      character pcReplace_1 = TypeFactory.initInput(_pcReplace_1);
      /*------------------------------------------------------------------------------
         Purpose: Set properties in contained objects using the returned value of
                  containedProperties().  
      Parameters: 
         pcPropValues - char
              - Matches the value that is returned from containedProperties.   
              - A CHR(3)-delimited list where;
                - The first entry is a 'header' that defines which properties the rest 
                  of the entries in the list applies to. 
                  The header have two possible formats:
                  - Comma separated list of properties (when all objects are SDOs).
                  - A paired semicolon lists with object type and a comma delimited
                    list of properties. 'THIS' is used instead of ObjectType for 
                    this container instance.  
                    Example: 
                    - SmartBusinessObject;Prop1;SmartDataObject;propA,propB,propC                 
                  
                - The rest of the CHR(3) entries is a paired list of objectNames and 
                  a CHR(4)-delimited list of property values, where each chr(4).
                  entry corresponds to the comma separated property list for the 
                  object's Object type  
                  - A blank objectname indicates this container instance.
                  - ObjectNames is qualified with ':' to specify container relationship. 
         pcReplace - char
              - Comma separated pair of properties to replace  
                 Example:  
                    'QueryWhere,QueryContext' 
                     - Specifies that 'QueryWhere' values in the list should 
                       be used to setQueryContext                                
           Notes: Passes properties recursively to an 'unlimited' level of child 
                  containers in order to be support the 'deep' option of the 
                  containedProperties function.         
               -  If the ClientNames property is defined, the ObjectName entry in the 
                  passed list will be identified with this instead of InstanceNames.
                  This is used to enable communication with clients with a different 
                  container structure.
       Note date: 2002/02/07     
      ------------------------------------------------------------------------------*/
      character cPropHeader = TypeFactory.character();
      integer iProp = TypeFactory.integer();
      character cProp = TypeFactory.character();
      integer iReplace = TypeFactory.integer();
      integer iObject = TypeFactory.integer();
      handle hObject = TypeFactory.handle();
      character cObjectType = TypeFactory.character();
      character cObjectName = TypeFactory.character();
      character cPropList = TypeFactory.character();
      character cValueList = TypeFactory.character();
      logical lMultiTypes = TypeFactory.logical();
      character cValue = TypeFactory.character();
      character cPassedProp = TypeFactory.character();
      character cUseProp = TypeFactory.character();
      character cTargetNames = TypeFactory.character();
      character cTargets = TypeFactory.character();
      character cChildName = TypeFactory.character();
      character cChildProps = TypeFactory.character();
      handle hChild = TypeFactory.handle();
      integer iTarget = TypeFactory.integer();
      
      return function("assignContainedProperties", logical.class, new Block((Body) () -> 
      {
                  /* The first entry is the property 'header' that defines which
                      properties we get for each objectype */cPropHeader.assign(entry(1, pcPropValues_1, chr(3)));
         lMultiTypes.assign(isGreaterThan(numEntries(cPropHeader, ";"), 1));
         
         /* Replace propertyname(s) if replace specified */
         if (_and(isNotEqual(pcReplace_1, ""), () -> notUnknown(pcReplace_1)))
         {
            loopLabel24:
            for (iProp.assign(1); _isLessThanOrEqual(iProp, numEntries(cPropHeader, ";")); iProp.assign(plus(iProp, 2)))
            {
               /* Currently no objecttype qualifier support */
               /* cObjectType  = ENTRY(iProp,cPropHeader,'':U)  */
               cPropList.assign(_not(lMultiTypes) ? cPropHeader : entry(plus(iProp, 1), cPropHeader, ";"));
               
               loopLabel25:
               for (iReplace.assign(1); _isLessThanOrEqual(iReplace, numEntries(pcReplace_1)); iReplace.assign(plus(iReplace, 2)))
               {
                  cPassedProp.assign(entry(iReplace, pcReplace_1));
                  cUseProp.assign(entry(plus(iReplace, 1), pcReplace_1));
                  cPropList.assign(replaceAll(cPropList, cPassedProp, cUseProp));
               }
               
               if (_not(lMultiTypes))
               {
                  cPropHeader.assign(cPropList);
               }
               else
               {
                  cPropHeader.replaceEntry(plus(iProp, 1), ";", cPropList);
               }
            }
         }
         /* IF pcReplace <> '':U */
         /* If one type set proplist once and for all here */
         cPropList.assign(_not(lMultiTypes) ? cPropHeader : new character(""));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
         cTargets.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ClientNames"));
         cTargetNames.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(cTargetNames, ""))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceNames"));
            cTargetNames.assign(ghProp.unwrapBufferField().value());
         }
         /* {get Prop var [handle]} */ 
         
         Int64Expression resExpr21 = new Int64Expression()
         {
            public int64 execute()
            {
               return plus(numEntries(pcPropValues_1, chr(3)), 2);
            }
         };
         ToClause toClause21 = new ToClause(iObject, 2, resExpr21, new integer(2));
         
         doTo("loopLabel26", toClause21, new Block((Body) () -> 
         {
            if (_isLessThanOrEqual(iObject, numEntries(pcPropValues_1, chr(3))))
            {
               cObjectName.assign(entry(iObject, pcPropValues_1, chr(3)));
               cValueList.assign(entry(plus(iObject, 1), pcPropValues_1, chr(3)));
               hObject.setUnknown();
               iTarget.assign(0);
               
               if (_isEqual(cObjectName, ""))
               {
                  hObject.assign(targetProcedure());
               }
               else
               {
                  iTarget.assign(lookup(cObjectName, cTargetNames));
                  
                  if (_isGreaterThan(iTarget, 0))
                  {
                     hObject.assign(handle.fromString(entry(iTarget, cTargets)));
                  }
               }
            }
            else
            {
               /* Extra loop was not needed if no valid Child */
               if (_not(hChild.isValid()))
               {
                  leave("loopLabel26");
               }
               
               cObjectName.setUnknown();
            }
            
            /* If we have a childname and the objectName not begins with childname then 
                   we need to pass the list of objects and properties to the current child */
            if (_and(hChild.isValid(), () -> or(not(begins(cObjectName, cChildName)), () -> isUnknown(cObjectName))))
            {
               silent(() -> ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignContainedProperties", hChild, "II", concat(cPropHeader, cChildProps), pcReplace_1));
               
               /* cObjectname is ? if this is an extra loop to assign the collected 
                        values to pass on to the child containers */
               if (_isUnknown(cObjectName))
               {
                  leave("loopLabel26");
               }
               
               cChildName.assign("");
               cChildProps.assign("");
               hChild.setUnknown();
            }
            
            if ((hObject.isValid()).booleanValue())
            {
               if ((lMultiTypes).booleanValue())
               {
                  cObjectType.assign(_isNotEqual(cObjectName, "") ? ControlFlowOps.invokeDynamicFunctionIn(character.class, "getObjectType", hObject) : new character("THIS"));
                  cPropList.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "MappedEntry", targetProcedure(), "IIII", cObjectType, cPropHeader, true, ";"));
               }
               
               IntegerExpression resExpr22 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(cPropList);
                  }
               };
               ToClause toClause22 = new ToClause(iProp, 1, resExpr22);
               
               doTo("loopLabel27", toClause22, new Block((Body) () -> 
               {
                  cProp.assign(entry(iProp, cPropList));
                  cValue.assign(entry(iProp, cValueList, chr(4)));
                  silent(() -> ControlFlowOps.invokeDynamicFunctionInWithMode(concat("set", cProp), hObject, "I", cValue));
               }));
            }
            else
            {
               if (_not(hChild.isValid()))
               {
                  iTarget.assign(0);
                  cChildName.assign(cObjectName);
                  
                  loopLabel28:
                  while (_and(isEqual(iTarget, 0), () -> isGreaterThan(numEntries(cChildName, ":"), 1)))
                  {
                     cChildName.replaceEntry(numEntries(cChildName, ":"), ":", "");
                     cChildName.assign(rightTrim(cChildName, ":"));
                     iTarget.assign(lookup(cChildName, cTargetNames));
                     
                     if (_isGreaterThan(iTarget, 0))
                     {
                        hChild.assign(handle.fromString(entry(iTarget, cTargets)));
                     }
                  }
               }
               
               if ((hChild.isValid()).booleanValue())
               {
                  cChildProps.assign(concat(cChildProps, chr(3), replaceAll(concat(" ", cObjectName), concat(" ", cChildName, ":"), ""), chr(3), cValueList));
               }
            }
         }));
         
         /* do iObject = 2 to num-entries(pcPropValues) */
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle assignQueries(final character _pcQueries_1)
   {
      character pcQueries_1 = TypeFactory.initInput(_pcQueries_1);
      /*------------------------------------------------------------------------------
        Purpose: Assign queries to all or some of the contained SDOs and returns the 
                 handle of the first SDO that got a new query. 
      Parameter: pcQueries 
                    - CHR(1)-separated string where SKIP is used to indicate which 
                      SDOs to skip.   
                    - Blank indicates that the default query should be used.                                      
          Notes: Used to reset the queries from the client     
      ------------------------------------------------------------------------------*/
      character cSdos = TypeFactory.character();
      handle hSdo = TypeFactory.handle();
      handle hFirstSdo = TypeFactory.handle();
      integer iSdo = TypeFactory.integer();
      character cQueryString = TypeFactory.character();
      
      return function("assignQueries", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cSdos.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr23 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cSdos);
            }
         };
         ToClause toClause23 = new ToClause(iSdo, 1, resExpr23);
         
         doTo("loopLabel29", toClause23, new Block((Body) () -> 
         {
            cQueryString.assign(entry(iSdo, pcQueries_1, chr(1)));
            
            if (_isNotEqual(cQueryString, "SKIP"))
            {
               hSdo.assign(handle.fromString(entry(iSdo, cSdos)));
               
               if (_isUnknown(hFirstSdo))
               {
                  hFirstSdo.assign(hSdo);
               }
               
               /* If no data is passed from the client we must use the default query            
                        otherwise Foreign Fields will be appended to the current query,
                        which may have conflicting Foreign Fields from initialization */
               if (_isEqual(cQueryString, ""))
               {
                  /* {get Prop var [handle]} */
                  cQueryString.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getOpenQuery", hSdo));
               }
               
               /* {set Prop value [handle]} */
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryWhere", hSdo, "I", cQueryString);
            }
         }));
         
         /* END DO iSDO */
         returnNormal(hFirstSdo);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character containedProperties(final character _pcQueryProps_1, final logical _plDeep_1)
   {
      character pcQueryProps_1 = TypeFactory.initInput(_pcQueryProps_1);
      logical plDeep_1 = TypeFactory.initInput(_plDeep_1);
      /*------------------------------------------------------------------------------
         Purpose: Returns a CHR(3)-delimited list where the first entry is the 
                  passed query parameter. The rest of the entries consists of paired 
                  objectNames and CHR(4)-delimited properties.
                   
                  For 'plDeep' queries the ObjectName will be colon separated to 
                  uniquely identify levels in the tree. 
                  
                  The second in each pair is a chr(4) separated list of values
                  where each entry corresponds to the Propertlist for that object.   
                  
                  <pcQueryProps>
                  CHR(3)
                  <ObjectName1>CHR(3)<PropAvalue>CHR(4)<PropBvalue>
                  CHR(3)      
                  <ObjectName2>CHR(3)<PropAvalue>CHR(4)<PropBvalue>
                  
      Parameters: pcProperties 
                    - Comma separated list(s) of properties to retrieve from SDOs.
                    - Optionally use paired semicolom lists to query different 
                      Object types.   
                      Example: 
                       - SmartBusinessObject;Prop1;SmartDataObject where AppService=aaaa;propA,propB,propC
                       
                    'THIS' indicates properties for this object instance.   
                      
                  plDeep  (NOT SUPPORTED YET!)  
                    - True  - Retrieve properties also from children of children.    
                    - False - Only in Container targets.        
                                                  
           Notes: The FORMAT of the returned string is INTERNAL and intended to 
                  be transported as is (across servers) to be passed into  
                  assignContainedProperties.   
               -  The format and delimiters may change completely in the 
                  future.     
               -  When we implement support for plDeep and enforce unique objectnames
                  this may be moved up to the container class.  
               -  If the ClientNames property is defined, the ObjectName entry in the 
                  retunred list will be replaced with the corresponding entry in 
                  the ClientNames list. This is used to enable communcation with 
                  clients with a different container structure.
      Note date: 2002/02/16            
      ------------------------------------------------------------------------------*/
      integer iProp = TypeFactory.integer();
      character cProp = TypeFactory.character();
      integer iObject = TypeFactory.integer();
      handle hObject = TypeFactory.handle();
      character cObjectType = TypeFactory.character();
      character cObjectName = TypeFactory.character();
      character cPropList = TypeFactory.character();
      logical lMultiTypes = TypeFactory.logical();
      character cValue = TypeFactory.character();
      character cValueList = TypeFactory.character();
      character cGrandChildren = TypeFactory.character();
      character cGrandChildProps = TypeFactory.character();
      integer iGrandChild = TypeFactory.integer();
      character cDeepProps = TypeFactory.character();
      integer iThis = TypeFactory.integer();
      character cTargets = TypeFactory.character();
      character cTargetNames = TypeFactory.character();
      
      return function("containedProperties", character.class, new Block((Body) () -> 
      {
         lMultiTypes.assign(isGreaterThan(numEntries(pcQueryProps_1, ";"), 1));
         cPropList.assign(_not(lMultiTypes) ? pcQueryProps_1 : new character(""));
         
         /* If deep then set properties to pass to children */
         if ((plDeep_1).booleanValue())
         {
            cDeepProps.assign(pcQueryProps_1);
            
            /* If multiTypes check for THIS and remove it as it cannot be passed to 
                   children (properties from child containers will need to be retrieved
                   with the child containers type) */
            if ((lMultiTypes).booleanValue())
            {
               iThis.assign(lookup("THIS", cDeepProps, ";"));
               
               if (_isGreaterThan(iThis, 0))
               {
                  cDeepProps.replaceEntry(iThis, ";", "");
                  cDeepProps.replaceEntry(plus(iThis, 1), ";", "");
               }
            }
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
         cTargets.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ClientNames"));
         cTargetNames.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(cTargetNames, ""))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceNames"));
            cTargetNames.assign(ghProp.unwrapBufferField().value());
         }
         /* {get Prop var [handle]} */ 
         
         IntegerExpression resExpr24 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cTargets);
            }
         };
         ToClause toClause24 = new ToClause(iObject, ((lMultiTypes).booleanValue() ? new integer(0) : new integer(1)), resExpr24);
         
         doTo("loopLabel30", toClause24, new Block((Body) () -> 
         {
            if (_isGreaterThan(iObject, 0))
            {
               cObjectName.assign(entry(iObject, cTargetNames));
               hObject.assign(handle.fromString(entry(iObject, cTargets)));
               ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectType"));
               cObjectType.assign(ghProp.unwrapBufferField().value());
            }
            else
            {
               cObjectName.assign("");
               hObject.assign(targetProcedure());
               cObjectType.assign("THIS");
            }
            
            if ((lMultiTypes).booleanValue())
            {
               cPropList.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "MappedEntry", targetProcedure(), "IIII", cObjectType, pcQueryProps_1, true, ";"));
            }
            
            if (_or(and(lMultiTypes, () -> notUnknown(cPropList)), () -> and(not(lMultiTypes), () -> isEqual(cObjectType, "SmartDataObject"))))
            {
               cValueList.assign(concat(cValueList, chr(3), cObjectName, chr(3)));
               
               IntegerExpression resExpr25 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(cPropList);
                  }
               };
               ToClause toClause25 = new ToClause(iProp, 1, resExpr25);
               
               doTo("loopLabel31", toClause25, new Block((Body) () -> 
               {
                  silent(() -> 
                  {
                     cProp.assign(entry(iProp, cPropList));
                     cValue.assign(ControlFlowOps.invokeDynamicFunctionIn(concat("get", cProp), hObject));
                  });
                  cValueList.assign(concat(cValueList, (_isEqual(iProp, 1) ? new character("") : chr(4)), _isUnknown(cValue) ? new character("?") : cValue));
               }));
            }
            
            /* If cProplist <> ? */
            /* If Deep then retrieve properties from containers containertargets */
            if (_and(plDeep_1, () -> isNotEqual(iObject, 0)))
            {
               cGrandChildren.assign("");
               silent(() -> 
               {
                  ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
                  cGrandChildren.assign(ghProp.unwrapBufferField().value());
               });
               
               if (_and(isNotEqual(cGrandChildren, ""), () -> notUnknown(cGrandChildren)))
               {
                  cGrandChildProps.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "containedProperties", hObject, "II", cDeepProps, plDeep_1));
                  /* remove the Propertylist that is returned at the start */
                  cGrandChildProps.replaceEntry(1, chr(3), "");
                  cGrandChildProps.assign(substring(cGrandChildProps, 2));
                  
                  loopLabel32:
                  for (iGrandChild.assign(1); _isLessThanOrEqual(iGrandChild, numEntries(cGrandChildProps, chr(3))); iGrandChild.assign(plus(iGrandChild, 2)))
                  {
                     cGrandChildProps.replaceEntry(iGrandChild, chr(3), concat(cObjectName, ":", entry(iGrandChild, cGrandChildProps, chr(3))));
                  }
                  
                  if (_isNotEqual(cGrandChildProps, ""))
                  {
                     cValueList.assign(concat(cValueList, chr(3), cGrandChildProps));
                  }
               }
            }
         }));
         
         /* do iObject = 1 to num-entries(cTargets) */
         /* Return the input Query list as the first entry 
             (the list already starts with chr(3)) */
         returnNormal(concat(pcQueryProps_1, cValueList));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical disablePagesInFolder(final character _pcPageInformation_2)
   {
      character pcPageInformation_2 = TypeFactory.initInput(_pcPageInformation_2);
      /*------------------------------------------------------------------------------
        Purpose:  Disables the specified folder pages
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hFolderHandle = TypeFactory.handle();
      logical lHasPendingValues = TypeFactory.logical();
      
      return function("disablePagesInFolder", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PageSource"));
         hFolderHandle.assign(ghProp.unwrapBufferField().value());
         
         if (_and(hFolderHandle.isValid(), () -> isNotEqual(lookup("disablePages", hFolderHandle.unwrapProcedure().internalEntries()), 0)))
         {
            ControlFlowOps.invokeInWithMode("disablePages", hFolderHandle, "IO", pcPageInformation_2, lHasPendingValues);
            returnNormal(true);
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical enablePagesInFolder(final character _pcPageInformation_2)
   {
      character pcPageInformation_2 = TypeFactory.initInput(_pcPageInformation_2);
      /*------------------------------------------------------------------------------
        Purpose:  Enables the specified folder pages
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hFolderHandle = TypeFactory.handle();
      logical lHasPendingValues = TypeFactory.logical();
      
      return function("enablePagesInFolder", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PageSource"));
         hFolderHandle.assign(ghProp.unwrapBufferField().value());
         
         if (_and(hFolderHandle.isValid(), () -> isNotEqual(lookup("enablePages", hFolderHandle.unwrapProcedure().internalEntries()), 0)))
         {
            ControlFlowOps.invokeInWithMode("enablePages", hFolderHandle, "IO", pcPageInformation_2, lHasPendingValues);
            returnNormal(true);
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getCallerObject()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hCaller = TypeFactory.handle();
      
      return function("getCallerObject", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CallerObject"));
         hCaller.assign(ghProp.unwrapBufferField().value());
         returnNormal(hCaller);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getCallerProcedure()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hCaller = TypeFactory.handle();
      
      return function("getCallerProcedure", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CallerProcedure"));
         hCaller.assign(ghProp.unwrapBufferField().value());
         returnNormal(hCaller);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getCallerWindow()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hCaller = TypeFactory.handle();
      
      return function("getCallerWindow", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CallerWindow"));
         hCaller.assign(ghProp.unwrapBufferField().value());
         returnNormal(hCaller);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getClientNames()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the list of ClientNames, which is a list that corresponds 
                  to InstanceNames, with the proxy's ObjectName on the client.
          Notes:  This is set in a server side container, so that containedProperties 
                  and assignContainedProperties can receive and return properties to 
                  and from a client with a different container structure.
                - This is required in the dynamic server container, which constructs 
                  server side objects for all data objects in the caller container 
                  tree, without recreating the child-containers that are not 
                  QueryObjects. (SBOs are the only containers constructed on the 
                  server)                             
      Note date: 2002/02/16                        
      -----------------------------------------------------------------------------*/
      character cNames = TypeFactory.character();
      
      return function("getClientNames", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ClientNames"));
         cNames.assign(ghProp.unwrapBufferField().value());
         returnNormal(cNames);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getCommitSource()
   {
      /*------------------------------------------------------------------------------
         Purpose: Return the CommitSource. Used for pass-thru for regular 
                  containers, but also inherited by the SBO that uses it for 'real'. 
         Params:  <none>
         Note:    xp not defined because the sbo needs logic in set override. 
                  (set AutoCommit) 
      ------------------------------------------------------------------------------*/
      handle hCommitSource = TypeFactory.handle();
      
      return function("getCommitSource", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CommitSource"));
         hCommitSource.assign(ghProp.unwrapBufferField().value());
         returnNormal(hCommitSource);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getCommitSourceEvents()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the list of events to be subscribed to in the
                  Commit Panel or other Commit-Source.  
         Params:  <none>
          Notes:  Commit is a pass-thru link, but the sbo uses it for real, this 
                  property is here because we currently keep the link and event 
                  properties together..          
      ------------------------------------------------------------------------------*/
      character cEvents = TypeFactory.character();
      
      return function("getCommitSourceEvents", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CommitSourceEvents"));
         cEvents.assign(ghProp.unwrapBufferField().value());
         returnNormal(cEvents);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getCommitTarget()
   {
      /*------------------------------------------------------------------------------
         Purpose: Return the CommitTarget(s). Defined for pass-thru purposes. 
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cCommitTarget = TypeFactory.character();
      
      return function("getCommitTarget", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CommitTarget"));
         cCommitTarget.assign(ghProp.unwrapBufferField().value());
         returnNormal(cCommitTarget);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getCommitTargetEvents()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the list of events to be subscribed to in the
                  Commit Panel or other Commit-Target.  
         Params:  <none>
          Notes:  Commit is a pass-thru link, this property is here because we 
                  currently keep the link and event properties together..          
      ------------------------------------------------------------------------------*/
      character cEvents = TypeFactory.character();
      
      return function("getCommitTargetEvents", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CommitTargetEvents"));
         cEvents.assign(ghProp.unwrapBufferField().value());
         returnNormal(cEvents);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getContainedAppServices()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Retunrs the list of the Appservices of the Data Objects contained
                  in this container.
          Notes:  The container class uses this to manage dataobjects in 
                  the stateless server side APIs. 
      ------------------------------------------------------------------------------*/
      character cAppServices = TypeFactory.character();
      
      return function("getContainedAppServices", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedAppServices"));
         cAppServices.assign(ghProp.unwrapBufferField().value());
         returnNormal(cAppServices);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getContainedDataObjects()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a list of the handles of the Data Objects contained
                  in this object.
          Params: <none>
          Notes:  The container class uses this to keep track of the dataobjects in 
                  the stateless server side APIs. 
                  The sbo class uses it on both client and server in almost all logic
                  also at design time to get names and column lists from the 
                  individual Data Objects.
      ------------------------------------------------------------------------------*/
      character cObjects = TypeFactory.character();
      
      return function("getContainedDataObjects", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cObjects.assign(ghProp.unwrapBufferField().value());
         returnNormal(cObjects);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getContainerMode()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns the containermode of the window container  
          Notes: The 'primary' viewer is identifed 
                 1 - WindowTitleViewer  - set here in a previous call or 
                                          in a viewer with windowTitlefield
                 2 - Viewer linked to this container's containertoolbarsource as tableioSource  
                     Page 0 will be preferred for page 1. 
                 3 - Upper SDO on page 0 or page 1 
                     First Viewer that are not a groupAssignTarget linked to this 
                     SDO as an UpdateSource. Page 0 will be preferred for page 1. 
              -  Certainly room for improvement, but this is really intended for 
                 backwards compatibility with Dynamics v1, which has one object 
                 of one type per page and uses container toolbar and primarySDO links
              -  An SDO on page 0 with an UpdateSource on page 2 may cause no object
                 to be found.
      ------------------------------------------------------------------------------*/
      character cContainerMode_1 = TypeFactory.character();
      handle hVisual = TypeFactory.handle();
      handle hTarget = TypeFactory.handle();
      integer iLoop = TypeFactory.integer();
      logical lQuery = TypeFactory.logical();
      character cTargets = TypeFactory.character();
      handle hDataSource = TypeFactory.handle();
      handle hContainer = TypeFactory.handle();
      handle hContainerSource = TypeFactory.handle();
      handle hSdo = TypeFactory.handle();
      integer iPage_1 = TypeFactory.integer();
      character cContainerToolbars = TypeFactory.character();
      handle hTableioSource = TypeFactory.handle();
      handle hSdocandidate = TypeFactory.handle();
      handle hVisualCandidate = TypeFactory.handle();
      handle hGroupAssignSource = TypeFactory.handle();
      character cObjectMode = TypeFactory.character();
      character cNewRecord = TypeFactory.character();
      logical lInitialized = TypeFactory.logical();
      
      return function("getContainerMode", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitialized.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if (_not(lInitialized))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerMode"));
            cContainerMode_1.assign(ghProp.unwrapBufferField().value());
            returnNormal(cContainerMode_1);
         }
         
         /* Ask containerSource unless we already are a window container */
         if (_and(hContainer.isValid(), () -> isNotEqual(hContainer.unwrapType().getResourceType(), "window")))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
            hContainerSource.assign(ghProp.unwrapBufferField().value());
            
            if ((hContainerSource.isValid()).booleanValue())
            {
               returnNormal( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(character.class, "getContainerMode", hContainerSource));
            }
            else
            {
               returnNormal(new character());
            }
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("WindowTitleViewer"));
         hVisual.assign(ghProp.unwrapBufferField().value());
         
         if (_not(hVisual.isValid()))
         {
            hSdo.assign(handle.fromString(entry(1, ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "linkHandles", targetProcedure(), "I", "PrimarySdo-Target"))));
            
            if (_not(hSdo.isValid()))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerToolbarSource"));
               cContainerToolbars.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
               cTargets.assign(ghProp.unwrapBufferField().value());
               
               IntegerExpression resExpr26 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(cTargets);
                  }
               };
               ToClause toClause26 = new ToClause(iLoop, 1, resExpr26);
               
               doTo("targetLoop", toClause26, new Block((Body) () -> 
               {
                  hTarget.assign(handle.fromString(entry(iLoop, cTargets)));
                  ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectPage"));
                  iPage_1.assign(ghProp.unwrapBufferField().value());
                  
                  if (_isGreaterThan(iPage_1, 2))
                  {
                     next("targetLoop");
                  }
                  
                  /* {get Prop var [handle]} */
                  silent(() -> hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hTarget)));
                  ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                  lQuery.assign(ghProp.unwrapBufferField().value());
                  
                  if ((lQuery).booleanValue())
                  {
                     if (_and(hDataSource.isValid(), () -> matchesList(cTargets, valueOf(hDataSource))))
                     {
                        next("targetLoop");
                     }
                     
                     if (_isEqual(iPage_1, 0))
                     {
                        hSdo.assign(hTarget);
                        leave("targetLoop");
                     }
                     else
                     {
                        hSdocandidate.assign(hTarget);
                     }
                  }
                  else
                  {
                     if ((hDataSource.isValid()).booleanValue())
                     {
                        /* {get Prop var [handle]} */
                        silent(() -> hTableioSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getTableioSource", hTarget)));
                        
                        if (_isGreaterThan(lookup(valueOf(hTableioSource), cContainerToolbars), 0))
                        {
                           /* {get Prop var [handle]} */
                           silent(() -> hGroupAssignSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getGroupAssignSource", hTarget)));
                           
                           if ((hGroupAssignSource.isValid()).booleanValue())
                           {
                              next("targetLoop");
                           }
                           
                           if (_isEqual(iPage_1, 0))
                           {
                              hVisual.assign(hTarget);
                              leave("targetLoop");
                           }
                           else
                           {
                              hVisualCandidate.assign(hTarget);
                           }
                        }
                     }
                  }
               }));
            }
            
            if (_and(not(hVisual.isValid()), () -> not(hVisualCandidate.isValid())))
            {
               if (_and(hSdocandidate.isValid(), () -> not(hSdo.isValid())))
               {
                  hSdo.assign(hSdocandidate);
               }
               
               if ((hSdo.isValid()).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, hSdo.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateSource"));
                  cTargets.assign(ghProp.unwrapBufferField().value());
                  
                  updateSourceLoop:
                  for (iLoop.assign(1); _isLessThanOrEqual(iLoop, numEntries(cTargets)); iLoop.increment())
                  {
                     hTarget.assign(handle.fromString(entry(iLoop, cTargets)));
                     ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectPage"));
                     iPage_1.assign(ghProp.unwrapBufferField().value());
                     
                     if (_isGreaterThan(iPage_1, 2))
                     {
                        continue updateSourceLoop;
                     }
                     
                     if (_isEqual(iPage_1, 0))
                     {
                        hVisual.assign(hTarget);
                        break updateSourceLoop;
                     }
                     else
                     {
                        hVisualCandidate.assign(hTarget);
                     }
                  }
                  
                  /* Ok, let's also search non-updatable */
                  if (_and(not(hVisualCandidate.isValid()), () -> not(hVisual.isValid())))
                  {
                     ghProp.assign(handle.fromString(entry(1, hSdo.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
                     cTargets.assign(ghProp.unwrapBufferField().value());
                     
                     IntegerExpression resExpr27 = new IntegerExpression()
                     {
                        public integer execute()
                        {
                           return numEntries(cTargets);
                        }
                     };
                     ToClause toClause27 = new ToClause(iLoop, 1, resExpr27);
                     
                     doTo("dataTargetLoop", toClause27, new Block((Body) () -> 
                     {
                        hTarget.assign(handle.fromString(entry(iLoop, cTargets)));
                        ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectPage"));
                        iPage_1.assign(ghProp.unwrapBufferField().value());
                        
                        if (_isGreaterThan(iPage_1, 2))
                        {
                           next("dataTargetLoop");
                        }
                        
                        /* {get Prop var [handle]} */
                        silent(() -> hGroupAssignSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getGroupAssignSource", hTarget)));
                        
                        if ((hGroupAssignSource.isValid()).booleanValue())
                        {
                           next("dataTargetLoop");
                        }
                        
                        if (_isEqual(iPage_1, 0))
                        {
                           hVisual.assign(hTarget);
                           leave("dataTargetLoop");
                        }
                        else
                        {
                           hVisualCandidate.assign(hTarget);
                        }
                     }));
                  }
               }
            }
         }
         
         /* not valid hVisual (windowTitleViewer) */
         if (_and(hVisualCandidate.isValid(), () -> not(hVisual.isValid())))
         {
            hVisual.assign(hVisualCandidate);
         }
         
         if ((hVisual.isValid()).booleanValue())
         {
            /* {get Prop var [handle]} */
            silent(() -> cNewRecord.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getNewRecord", hVisual)));
            
            if (_isEqual(cNewRecord, "NO"))
            {
               /* {get Prop var [handle]} */
               cObjectMode.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getObjectMode", hVisual));
               cContainerMode_1.assign((matchesList("update,modify", cObjectMode)).booleanValue() ? new character("Modify") : new character("View"));
            }
            else
            {
               if (_isGreaterThan(cNewRecord, ""))
               {
                  cContainerMode_1.assign(cNewRecord);
               }
            }
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("WindowTitleViewer"));
            ghProp.unwrapBufferField().changeValue(hVisual);
         }
         returnNormal(cContainerMode_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getContainerTarget()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a list of the handles of the object's contained objects.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cTarget_1 = TypeFactory.character();
      
      return function("getContainerTarget", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
         cTarget_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(cTarget_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getContainerTargetEvents()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a comma-separated list of the events this object 
                  wants to subscribe to in its ContainerTarget.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cEvents = TypeFactory.character();
      
      return function("getContainerTargetEvents", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTargetEvents"));
         cEvents.assign(ghProp.unwrapBufferField().value());
         returnNormal(cEvents);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getContainerToolbarSource()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the handle(s) of the object's containertoolbar-source.
         Params:  <none>
          Notes:   
      ------------------------------------------------------------------------------*/
      character cTarget_1 = TypeFactory.character();
      
      return function("getContainerToolbarSource", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerToolbarSource"));
         cTarget_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(cTarget_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getContainerToolbarSourceEvents()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the list of events to be subscribed to in the
                  ContainerToolbar-Source.  
         Params:  <none>
          Notes:             
      ------------------------------------------------------------------------------*/
      character cEvents = TypeFactory.character();
      
      return function("getContainerToolbarSourceEvents", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerToolbarSourceEvents"));
         cEvents.assign(ghProp.unwrapBufferField().value());
         returnNormal(cEvents);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getCurrentLogicalName()
   {
      return function("getCurrentLogicalName", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  This is set in constructObject if LogicalObjectname
                     is passed in as (currently the first) property to be used by 
                     callee to fetch its data in repository
             Notes:  
         ------------------------------------------------------------------------------*/
         returnNormal(gcCurrentObjectName);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public integer getCurrentPage()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the current page number of the Container
         Params:  <none>
      ------------------------------------------------------------------------------*/
      integer iPage_1 = TypeFactory.integer();
      
      return function("getCurrentPage", integer.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         iPage_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(iPage_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getDataContainer()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------  ------------------------------------------------------------*/
      logical lDataContainer = TypeFactory.logical();
      
      return function("getDataContainer", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataContainer"));
         lDataContainer.assign(ghProp.unwrapBufferField().value());
         returnNormal(lDataContainer);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getDisabledAddModeTabs()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      character cDisabledAddModeTabs_1 = TypeFactory.character();
      
      return function("getDisabledAddModeTabs", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DisabledAddModeTabs"));
         cDisabledAddModeTabs_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(cDisabledAddModeTabs_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getDynamicSdoprocedure()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the name of the dynamic SDO procedure, 'adm/dyndata.w'
                  by default (can be modified if the dynamic SDO is customized).
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cProc = TypeFactory.character();
      
      return function("getDynamicSDOProcedure", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DynamicSDOProcedure"));
         cProc.assign(ghProp.unwrapBufferField().value());
         returnNormal(cProc);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getFilterSource()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Filter Source for Pass-through support.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      handle hSource = TypeFactory.handle();
      
      return function("getFilterSource", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FilterSource"));
         hSource.assign(ghProp.unwrapBufferField().value());
         returnNormal(hSource);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getHasDynamicProxy()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns if the Container has a dynamic client proxy. 
          Notes:  
      ------------------------------------------------------------------------------*/
      logical lProxy = TypeFactory.logical();
      
      return function("getHasDynamicProxy", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("HasDynamicProxy"));
         lProxy.assign(ghProp.unwrapBufferField().value());
         returnNormal(lProxy);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getHasObjectMenu()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns whether menus have been linked to a container. 
          Notes:  
      ------------------------------------------------------------------------------*/
      logical lHasMenus = TypeFactory.logical();
      
      return function("getHasObjectMenu", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("HasObjectMenu"));
         lHasMenus.assign(ghProp.unwrapBufferField().value());
         returnNormal(lHasMenus);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getHideChildContainersOnClose()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns if the Container's child containers should be hidden 
                 when closed. Used mostly for containers launched in a Dynamic TreeView
                 Object.
          Notes:  
      ------------------------------------------------------------------------------*/
      logical lHideChildContainersOnClose = TypeFactory.logical();
      
      return function("getHideChildContainersOnClose", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("HideChildContainersOnClose"));
         lHideChildContainersOnClose.assign(ghProp.unwrapBufferField().value());
         returnNormal(lHideChildContainersOnClose);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getHideOnClose()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns if the Container should be hidden when closed 
          Notes:  
      ------------------------------------------------------------------------------*/
      logical lHideOnClose = TypeFactory.logical();
      
      return function("getHideOnClose", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("HideOnClose"));
         lHideOnClose.assign(ghProp.unwrapBufferField().value());
         returnNormal(lHideOnClose);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getInitialPageList()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns the comma delimited list of pages to construct at startup. A 
                 special value of * will indicate all pages must be initialised at
                 startup.
          Notes: None
      ------------------------------------------------------------------------------*/
      character cPageList = TypeFactory.character();
      
      return function("getInitialPageList", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InitialPageList"));
         cPageList.assign(ghProp.unwrapBufferField().value());
         returnNormal(cPageList);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getInstanceNames()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the ordered list of ObjectNames of ContainerTargets.
          Notes:  This is used to enforce unique instance names in the container and
                  is updated in constructObject and destroyObject together with 
                  the container link.
                - This is needed in order for containedProperties and 
                  assignContainedProperties to work together. 
                - The list is in ContainerTarget order and each name is currently 
                  also stored in each object's ObjectName property. The name 
                  InstanceNames were still chosen instead of basing the name of any 
                  of these properties as this is more true to the nature of this 
                  property. 
      Note date: 2002/02/08                        
      -----------------------------------------------------------------------------*/
      character cNames = TypeFactory.character();
      
      return function("getInstanceNames", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceNames"));
         cNames.assign(ghProp.unwrapBufferField().value());
         returnNormal(cNames);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getMultiInstanceActivated()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      logical lMultiInstanceActivated_1 = TypeFactory.logical();
      
      return function("getMultiInstanceActivated", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("MultiInstanceActivated"));
         lMultiInstanceActivated_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(lMultiInstanceActivated_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getMultiInstanceSupported()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      logical lMultiInstanceSupported_1 = TypeFactory.logical();
      
      return function("getMultiInstanceSupported", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("MultiInstanceSupported"));
         lMultiInstanceSupported_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(lMultiInstanceSupported_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getNavigationSource()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Return the NavigationSource. Used for pass-thru for regular 
                  containers, but also inherited by the SBO that uses it for 'real'.  
          Notes:  Because multiple Navigation-Sources are supported, this is a 
                  comma-separated list of strings.
      ------------------------------------------------------------------------------*/
      character cNavigationSource = TypeFactory.character();
      
      return function("getNavigationSource", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NavigationSource"));
         cNavigationSource.assign(ghProp.unwrapBufferField().value());
         returnNormal(cNavigationSource);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getNavigationSourceEvents()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the list of events to be subscribed to in the
                  Navigation Panel or other Navigation-Source.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cEvents = TypeFactory.character();
      
      return function("getNavigationSourceEvents", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NavigationSourceEvents"));
         cEvents.assign(ghProp.unwrapBufferField().value());
         returnNormal(cEvents);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getNavigationTarget()
   {
      /*------------------------------------------------------------------------------
        Purpose: Supported for pass-thru 
          Notes:  
      ------------------------------------------------------------------------------*/
      character cNavigationTarget = TypeFactory.character();
      
      return function("getNavigationTarget", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NavigationTarget"));
         cNavigationTarget.assign(ghProp.unwrapBufferField().value());
         returnNormal(cNavigationTarget);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getObjectsCreated()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns whether this object has run createObjects for page 0.
         Params:  <none>
          Notes:  This is used in createObjects to avoid double create. Some 
                  containers run createObjects from the main block while others
                  start them from initializeObject. The create initializeObject is 
                  often too late so this flag was introduced to allow us to have more
                  control over when the objects are created and run createObjects 
                  before initializeObject for all objects without risking a double 
                  create.            
      ----------------------------------------------------------------------------*/
      logical lCreated = TypeFactory.logical();
      
      return function("getObjectsCreated", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectsCreated"));
         lCreated.assign(ghProp.unwrapBufferField().value());
         returnNormal(lCreated);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getOutMessageTarget()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the OutMessage Target for Pass-through support.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      handle hTarget = TypeFactory.handle();
      
      return function("getOutMessageTarget", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("OutMessageTarget"));
         hTarget.assign(ghProp.unwrapBufferField().value());
         returnNormal(hTarget);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getPage0LayoutManager()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
              Notes:
      ------------------------------------------------------------------------------*/
      character cPage0LayoutManager = TypeFactory.character();
      
      return function("getPage0LayoutManager", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("Page0LayoutManager"));
         cPage0LayoutManager.assign(ghProp.unwrapBufferField().value());
         returnNormal(cPage0LayoutManager);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getPageLayoutInfo()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
              Notes:
      ------------------------------------------------------------------------------*/
      character cPageLayoutInfo = TypeFactory.character();
      
      return function("getPageLayoutInfo", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PageLayoutInfo"));
         cPageLayoutInfo.assign(ghProp.unwrapBufferField().value());
         returnNormal(cPageLayoutInfo);
      }));
   }

   /** getPageLayoutInfo */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getPageNtarget()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the list of objects which are on some page other than 0.
         Params:  <none>
          Notes:  This property has a special format of "handle|page#' for each entry,
                  and should not be manipulated directly. Use addLink.
      ------------------------------------------------------------------------------*/
      character cTarget_1 = TypeFactory.character();
      
      return function("getPageNTarget", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PageNTarget"));
         cTarget_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(cTarget_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getPageSource()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the handle of the object's Page Source (folder), if any.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      handle hSource = TypeFactory.handle();
      
      return function("getPageSource", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PageSource"));
         hSource.assign(ghProp.unwrapBufferField().value());
         returnNormal(hSource);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public integer getPendingPage()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Pending page number of the Container. This is set 
                  immediately in SelectPage so that objects on hide can check 
                  what will become the new page before CurrentPage is set. 
                  This was specifically implemented so that hideObject -> linkState 
                  could avoid disabling links for objects that are going to become 
                  viewed.
          Notes:  Returns ? when no page selection is pending.                   
      ------------------------------------------------------------------------------*/
      integer iPage_1 = TypeFactory.integer();
      
      return function("getPendingPage", integer.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PendingPage"));
         iPage_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(iPage_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getPrimarySdoTarget()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hPrimarySdoTarget_1 = TypeFactory.handle();
      
      return function("getPrimarySdoTarget", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PrimarySdoTarget"));
         hPrimarySdoTarget_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(hPrimarySdoTarget_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getReEnableDataLinks()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      character cReEnableDataLinks_1 = TypeFactory.character();
      
      return function("getReEnableDataLinks", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ReEnableDataLinks"));
         cReEnableDataLinks_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(cReEnableDataLinks_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getRemoveMenuOnHide()
   {
      /*------------------------------------------------------------------------------
       Purpose: Decides whether the the menus should be removed from the menubar 
                on hide of the container.  
       Parameters: INPUT plRemove 
           Notes:
      ------------------------------------------------------------------------------*/
      logical lRemoveMenu = TypeFactory.logical();
      
      return function("getRemoveMenuOnHide", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RemoveMenuOnhide"));
         lRemoveMenu.assign(ghProp.unwrapBufferField().value());
         returnNormal(lRemoveMenu);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getRequiredPages()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:
      ------------------------------------------------------------------------------*/
      character cRequiredPages = TypeFactory.character();
      
      return function("getRequiredPages", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RequiredPages"));
         cRequiredPages.assign(ghProp.unwrapBufferField().value());
         returnNormal(cRequiredPages);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getRunDooptions()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns a comma-separated list with options that determine how 
                  Data Objects are run from constructObject
                  The options available are:
                    dynamicOnly - this runs dynamic data objects only and supercedes
                                  all other options
                    sourceSearch - this searches for source code if rcode is not found
                    clientOnly - this runs proxy (_cl) code only (for both rcode and 
                                 source code)
                  
                  If dynamicOnly and/or clientOnly options are used the container
                  assumes that the Data Object has an AppServer partition defined.
                  If an AppServer partition is not defined and dynamicOnly and/or
                  clientOnly options are used, errors will occur as if the Data 
                  Object was being run on an AppServer that hadn't been started.
                  
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cOptions = TypeFactory.character();
      
      return function("getRunDOOptions", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RunDOOptions"));
         cOptions.assign(ghProp.unwrapBufferField().value());
         returnNormal(cOptions);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getRunMultiple()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      logical plMultiple_1 = TypeFactory.logical();
      
      return function("getRunMultiple", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RunMultiple"));
         plMultiple_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(plMultiple_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getSavedContainerMode()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      character cSavedContainerMode_1 = TypeFactory.character();
      
      return function("getSavedContainerMode", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SavedContainerMode"));
         cSavedContainerMode_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(cSavedContainerMode_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getSdoForeignFields()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      character cSdoForeignFields_1 = UndoableFactory.character();
      
      return function("getSdoForeignFields", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SdoForeignFields"));
         cSdoForeignFields_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(cSdoForeignFields_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getStatusArea()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns whether the container has a status area or not
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hContainer = TypeFactory.handle();
      
      return function("getStatusArea", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if (_and(hContainer.isValid(), () -> HandleOps.canQuery(hContainer, "status-area")))
         {
            returnNormal(hContainer.unwrapWindow().isStatusArea());
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getTargetProcedure()
   {
      return function("getTargetProcedure", handle.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  
             Notes:  
         ------------------------------------------------------------------------------*/
         returnNormal(ghTargetProcedure);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getTopOnly()
   {
      /*------------------------------------------------------------------------------
        Purpose:     Get window top only (toggle)
        Parameters:  input logical of yes / no for what to set it to.
        Notes:       
      ------------------------------------------------------------------------------*/
      handle hContainer = TypeFactory.handle();
      
      return function("getTopOnly", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if (_and(hContainer.isValid(), () -> HandleOps.canQuery(hContainer, "top-only")))
         {
            returnNormal(hContainer.unwrapTopOnly().isTopOnly());
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getUpdateActive()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns true if ANY of the contained object's have active updates  
          Notes:  See setUpdateactive                
                - All participating events including okObject and okCancel is bound
                  within a window container.  
      ------------------------------------------------------------------------------*/
      logical lActive = TypeFactory.logical();
      
      return function("getUpdateActive", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateActive"));
         lActive.assign(ghProp.unwrapBufferField().value());
         returnNormal(lActive);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getUpdateSource()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the handle of the object's Update-Source.
         Params:  <none>
          Notes:  This is used for pass-through links, to connect an object
                  inside the container with an object outside the container.
                  It is CHARACTER because at least one type of container (SBO)
                  supports multiple update sources.
      ------------------------------------------------------------------------------*/
      character cSource = TypeFactory.character();
      
      return function("getUpdateSource", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateSource"));
         cSource.assign(ghProp.unwrapBufferField().value());
         returnNormal(cSource);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getUpdateTarget()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the handle of the object's Update-Target.
         Params:  <none>
          Notes:  This is used for pass-through links, to connect an object
                  inside the container with an object outside the container.
      ------------------------------------------------------------------------------*/
      character cTarget_1 = TypeFactory.character();
      
      return function("getUpdateTarget", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
         cTarget_1.assign(ghProp.unwrapBufferField().value());
         returnNormal(cTarget_1);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getWaitForObject()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the handle of the object (most likely a SmartConsumer) 
                  in the container that contains a wait-for that needs to be started 
                  with startWaitFor 
         Params:  <none>
      ------------------------------------------------------------------------------*/
      handle hObject = TypeFactory.handle();
      
      return function("getWaitForObject", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("WaitForObject"));
         hObject.assign(ghProp.unwrapBufferField().value());
         returnNormal(hObject);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getWindowFrameHandle()
   {
      /*------------------------------------------------------------------------------
        Purpose: Stores the optional frame of a Window container 
          Notes: The somewhat strange name is used because this property ONLY  
                 identifies the frame of a window container and must not be 
                 confused with the important ContainerHandle, which is the
                 widget handle of the container in all object and in most cases 
                 stores the frame handle also for a SmartContainer.  
               - Even if Window containers does not need a frame they often has one
                 and in that case we must include it in for example resizing or 
                 widget-tree logic etc...                                   
      ------------------------------------------------------------------------------*/
      handle hFrame = TypeFactory.handle();
      
      return function("getWindowFrameHandle", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("WindowFrameHandle"));
         hFrame.assign(ghProp.unwrapBufferField().value());
         returnNormal(hFrame);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getWindowTitleViewer()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hHandle = TypeFactory.handle();
      
      return function("getWindowTitleViewer", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("WindowTitleViewer"));
         hHandle.assign(ghProp.unwrapBufferField().value());
         returnNormal(hHandle);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical initPagesForTranslation()
   {
      /*------------------------------------------------------------------------------
        Purpose:  To check if profile data exists indicating whether all pages on a
                  container needs to be initialized before the translation window
                  opens up. That way, all widgets on the container will be listed in
                  the translation Browse.
          
          Notes:  a) If no profile data exists, a default value of true will be assumed,
                     forcing all pages to initialize for translation
                  b) The code was placed here instead of the Translation viewer. The
                     reason was that if all pages were initialized from the Translation
                     viewer and the Translation window was closed, all toolbars
                     initialized by the call from the Translation viewer were destroyed
                     with the Translation window. It seems that the toolbars were
                     parented to the wrong container. This way, the initialization forces
                     all objects to be parented to the correct container.
                  c) Seeing that Translation will not be called that often - and that
                     the value of the preference could be set at any time, the value
                     of the profile code will be read whenever the translation window
                     is to be launched.
      ------------------------------------------------------------------------------*/
      character cFolderLabels = TypeFactory.character();
      character cProfileData = TypeFactory.character();
      character cPageString = TypeFactory.character();
      integer iCurrentPage = TypeFactory.integer();
      integer iPage_1 = TypeFactory.integer();
      logical lSuccess = TypeFactory.logical();
      logical lExists = TypeFactory.logical();
      handle hPageSource = TypeFactory.handle();
      rowid rRowid = TypeFactory.rowid();
      handle hContainingWindow = TypeFactory.handle();
      character cTabEnabled = TypeFactory.character();
      
      return function("initPagesForTranslation", logical.class, new Block((Body) () -> 
      {
         if ((gshProfileManager.isValid()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("PageSource"));
            hPageSource.assign(ghProp.unwrapBufferField().value());
            
            /* If we don't have a valid page source, it means we won't have multiple pages */
            if ((hPageSource.isValid()).booleanValue())
            {
               /* Check if profile data exists for the preference */
               ControlFlowOps.invokeInWithMode("checkProfileDataExists", gshProfileManager, "IIIIIO", new character("Window"), new character("InitForTrn"), new character("InitForTrn"), new logical(true), new logical(false), lExists);
               
               /* If the preference does exist, find the value for it */
               if ((lExists).booleanValue())
               {
                  ControlFlowOps.invokeInWithMode("getProfileData", gshProfileManager, "IIIIUO", new character("Window"), new character("InitForTrn"), new character("InitForTrn"), new logical(false), rRowid, cProfileData);
               }
               
               /* If profile data does not exist OR if the profile data says that all pages should be initialized, continue */
               if (_or(not(lExists), () -> isEqual(cProfileData, "yes")))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
                  iCurrentPage.assign(ghProp.unwrapBufferField().value());
                  /* Get the current page as this will be needed after the initialization */
                  /* {get Prop var [handle]} */
                  cFolderLabels.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getFolderLabels", hPageSource));
                  /* Get the page labels to determine the number of pages (needed to build the string of page numbers) */
                  /* {get Prop var [handle]} */
                  cTabEnabled.assign(ControlFlowOps.invokeDynamicFunctionIn("getTabEnabled", hPageSource));
                  
                  loopLabel33:
                  for (iPage_1.assign(1); _isLessThanOrEqual(iPage_1, numEntries(cFolderLabels, "|")); iPage_1.increment())
                  {
                     /* Build a string that will build a comma seperated list of 
                                  page numbers, i.e. 1,2,3,4,5,6 - if the container had 6 pages 
                                  
                                  However, if the tab is disabled, then don't init it - it may
                                  be that a particular page is initially disabled, or that the page
                                  is secured. If so, let the UI/developer enable it when required.
                                */
                     if (_and(and(notUnknown(cTabEnabled), () -> isGreaterThanOrEqual(numEntries(cTabEnabled, "|"), iPage_1)), () -> isEqual(new logical(entry(iPage_1, cTabEnabled, "|")), false)))
                     {
                        continue loopLabel33;
                     }
                     
                     cPageString.assign(concat(cPageString, (_isEqual(cPageString, "") ? new character("") : new character(",")), valueOf(iPage_1)));
                  }
                  
                  /* loop through pages */
                  /* Run initPages passing in the string of page numbers - this will initialize all non-initialized pages */
                  ControlFlowOps.invokeInWithMode("initPages", targetProcedure(), "I", cPageString);
                  silent(() -> hContainingWindow /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn("getContainingWindow", targetProcedure())));
                  
                  if (_not(hContainingWindow.isValid()))
                  {
                     hContainingWindow.assign(targetProcedure());
                  }
                  
                  cPageString.assign(concat("0,", cPageString));
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("InitialPageList"));
                  ghProp.unwrapBufferField().changeValue(cPageString);
                  silent(() -> ControlFlowOps.invokeInWithMode("packWindow", hContainingWindow, "II", new integer(0), new logical(true)));
                  silent(() -> ControlFlowOps.invokeIn("resizeWindow", hContainingWindow));
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
                  ghProp.unwrapBufferField().changeValue(new integer(0));
                  ControlFlowOps.invokeInWithMode("selectPage", targetProcedure(), "I", iCurrentPage);
               }
            }
            lSuccess.assign(true);
         }
         else
         {
            lSuccess.assign(false);
         }
         returnNormal(lSuccess);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical isFetchPending()
   {
      /*------------------------------------------------------------------------------
        Purpose: Check if this or any container outside of this is going to fetch data
          Notes: Data object checks this during initialization in order to decide
                 whether they need to open the query them selves or not   
      ------------------------------------------------------------------------------*/
      logical lDataContainer = TypeFactory.logical();
      handle hSource = TypeFactory.handle();
      logical lInitialized = TypeFactory.logical();
      
      return function("isFetchPending", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataContainer"));
         lDataContainer.assign(ghProp.unwrapBufferField().value());
         
         if ((lDataContainer).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
            lInitialized.assign(ghProp.unwrapBufferField().value());
            
            if (_not(lInitialized))
            {
               returnNormal(true);
            }
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
         hSource.assign(ghProp.unwrapBufferField().value());
         
         if ((hSource.isValid()).booleanValue())
         {
            returnNormal( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(logical.class, "IsFetchPending", hSource));
         }
         
         returnNormal(false);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical isRequestTreeRoot(final handle _phTopContainer_1, final handle _phTargetObject_1)
   {
      handle phTopContainer_1 = TypeFactory.initInput(_phTopContainer_1);
      handle phTargetObject_1 = TypeFactory.initInput(_phTargetObject_1);
      /*------------------------------------------------------------------------------
        Purpose:  To determine if we should prepareDataForFetch for the TargetObject.
          Notes:  If the target to fetch for is a QueryObject and it has a valid Data Source, 
                  we need to determine if the DataSource's container is in the same container 
                  hierarchy as that of the target. If so, and the DataSource is already 
                  initialized, we need to proceed with the 'prepareData' call for the target
      ------------------------------------------------------------------------------*/
      handle hTargetContainer = TypeFactory.handle();
      handle hDscontainer = TypeFactory.handle();
      logical lOkToFetchForTarget = TypeFactory.logical();
      handle hDataSource = TypeFactory.handle();
      logical lDataSourceInitialized = TypeFactory.logical();
      logical lQuery = TypeFactory.logical();
      
      return function("IsRequestTreeRoot", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, phTargetObject_1.unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
         lQuery.assign(ghProp.unwrapBufferField().value());
         
         /* if this is not a QueryObject return FALSE */
         if ((lQuery).booleanValue())
         {
            /* {get Prop var [handle]} */
            hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", phTargetObject_1));
            lOkToFetchForTarget.assign(isUnknown(hDataSource));
            
            if (_and(not(lOkToFetchForTarget), () -> hDataSource.isValid()))
            {
               lOkToFetchForTarget.assign(true);
               ghProp.assign(handle.fromString(entry(1, hDataSource.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
               lDataSourceInitialized.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, hDataSource.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
               hDscontainer.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, phTargetObject_1.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
               hTargetContainer.assign(ghProp.unwrapBufferField().value());
               
               if (_or(isEqual(hTargetContainer, hDscontainer), not(lDataSourceInitialized)))
               {
                  lOkToFetchForTarget.assign(false);
               }
               else
               {
                  loopLabel34:
                  while (_isNotEqual(hTargetContainer, phTopContainer_1))
                  {
                     ghProp.assign(handle.fromString(entry(1, hTargetContainer.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                     hTargetContainer.assign(ghProp.unwrapBufferField().value());
                     
                     if (_isEqual(hTargetContainer, hDscontainer))
                     {
                        lOkToFetchForTarget.assign(false);
                        break loopLabel34;
                     }
                  }
               }
            }
         }
         /* if lQuery */
         returnNormal(lOkToFetchForTarget);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical lockContainingWindow(final logical _plLockWindow_1)
   {
      logical plLockWindow_1 = TypeFactory.initInput(_plLockWindow_1);
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      integer iReturnCode = TypeFactory.integer();
      integer iLockWindow = TypeFactory.integer();
      handle hWindow = TypeFactory.handle();
      
      return function("lockContainingWindow", logical.class, new Block((Body) () -> 
      {
         silent(() -> iLockWindow.assign(new integer(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "getUserProperty", targetProcedure(), "I", "LockWindow"))));
         iLockWindow.assign(plus(iLockWindow, ((plLockWindow_1).booleanValue() ? new integer(1) : new integer(-1))));
         /* make sure that we are dealing with a non-zero value here. */
         iLockWindow.assign(int64.maximum(iLockWindow, new int64(0)));
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setUserProperty", targetProcedure(), "II", "LockWindow", valueOf(iLockWindow));
         
         if (_and(plLockWindow_1, () -> isGreaterThan(iLockWindow, 1)))
         {
            returnNormal(false);
         }
         
         if (_and(not(plLockWindow_1), () -> isGreaterThan(iLockWindow, 0)))
         {
            returnNormal(false);
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hWindow.assign(ghProp.unwrapBufferField().value());
         
         if ((plLockWindow_1).booleanValue())
         {
            ControlFlowOps.invokeInWithMode("lockWindowUpdate", gshSessionManager, "IO", hWindow.unwrapWidget().getHWND(), iReturnCode);
         }
         else
         {
            ControlFlowOps.invokeInWithMode("lockWindowUpdate", gshSessionManager, "IO", new integer(0), iReturnCode);
         }
         
         returnNormal(true);
      }));
   }

   /** lockContainingWindow */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public character obtainContextForClient()
   {
      /*------------------------------------------------------------------------------
        Purpose: Obtain context properties to return to the client after or as part 
                 of a server request.   
          Notes: The returned data depends on if this is the first call from the 
                 client or not. If this is the first call we still return the regular
                 context if this is also is a data request, which is the only request 
                 that really may change context. A data request is identified with 
                 an open query.
               - The serverside object's serverFirstCall defaults to false so that a 
                 normal request does not need to have any special information. 
                 It is the client's responsibility to signal a first call by passing 
                 serverFirstCall=yes as part of the context.  
              -  See also notes in obtainContextForServer about AsHasStarted and 
                 ServerFirstCall
              -  Overridden in sbo.p mostly because a Data request also could
                 be a save/commit. 
      Note date: 2002/02/12                   
      ------------------------------------------------------------------------------*/
      logical lFirst = TypeFactory.logical();
      logical lData = TypeFactory.logical();
      character cPropRequest = TypeFactory.character();
      handle hSdo = TypeFactory.handle();
      integer iSdo = TypeFactory.integer();
      character cContained = TypeFactory.character();
      handle hMaster = TypeFactory.handle();
      logical lHasDynamicProxy = TypeFactory.logical();
      
      return function("obtainContextForClient", character.class, new Block((Body) () -> 
      {
         /* This is passed from the client to identify the first call */
         /* {get Prop var [handle]} */ 
         lFirst.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getServerFirstCall", targetProcedure()));
         
         if ((lFirst).booleanValue())
         {
            /*  serverFirstCall need to be false if state-aware 
                   (We also return it to the client as a handshake that the first call has 
                    completed) */
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setServerFirstCall", targetProcedure(), "I", false);
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("HasDynamicProxy"));
            lHasDynamicProxy.assign(ghProp.unwrapBufferField().value());
            /* Property from this SBO instance */
            /* Props for the dynamic SDO */
            /* Props for the dynamic SDO */
            cPropRequest.assign(concat("THIS;ServerOperatingMode,ServerFirstCall;SmartDataObject;OpenQuery,DBNames,IndexInformation,KeyFields,KeyTableID,EntityFields,AuditEnabled", (lHasDynamicProxy).booleanValue() ? new character(",UpdatableColumns,Tables,DataColumnsByTable") : new character("")));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
            cContained.assign(ghProp.unwrapBufferField().value());
            
            IntegerExpression resExpr28 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cContained);
               }
            };
            ToClause toClause28 = new ToClause(iSdo, 1, resExpr28);
            
            doTo("loopLabel35", toClause28, new Block((Body) () -> 
            {
               hSdo.assign(handle.fromString(entry(iSdo, cContained)));
               /* {get Prop var [handle]} */
               silent(() -> lData.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getQueryOpen", hSdo)));
               
               if ((lData).booleanValue())
               {
                  leave("loopLabel35");
               }
               
               /* if this is an SBO check the master's query open */
               /* {get Prop var [handle]} */
               silent(() -> hMaster.assign(ControlFlowOps.invokeDynamicFunctionIn("getMasterDataObject", hSdo)));
               
               if ((hMaster.isValid()).booleanValue())
               {
                  /* {get Prop var [handle]} */
                  lData.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getQueryOpen", hMaster));
                  
                  if ((lData).booleanValue())
                  {
                     leave("loopLabel35");
                  }
               }
            }));
         }
         
         /* First */
         if (_or(not(lFirst), lData))
         {
            cPropRequest.assign(concat(((lData).booleanValue() ? concat(cPropRequest, ",") : new character("")), "FirstResultRow,LastResultRow,FirstRowNum,LastRowNum,QueryWhere,QueryRowident,ForeignValues,PositionForClient"));
         }
         
         returnNormal(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "containedProperties", targetProcedure(), "II", cPropRequest, true));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character obtainContextForServer()
   {
      character cRequest = TypeFactory.character();
      logical lStarted = TypeFactory.logical();
      character cObjectType = TypeFactory.character();
      logical lUseRepository = TypeFactory.logical();
      
      return function("obtainContextForServer", character.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         lUseRepository.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUseRepository", targetProcedure()));
         /* {get Prop var [handle]} */ 
         lStarted.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAsHasStarted", targetProcedure()));
         /* SDO property list 
              WARNING!!  
              Make sure there are commas between all entries in this list !!!!!! 
                
             */
         cRequest.assign(concat("LogicalObjectName,DestroyStateless,CheckCurrentChanged,FirstResultRow,LastResultRow,RebuildOnRepos,RowsToBatch,ServerSubmitValidation,UpdateFromSource,FirstRowNum,LastRowNum,ForeignValues,Tables,PhysicalTables,BaseQuery,DataColumns,DataColumnsByTable,AssignList,UpdatableColumnsByTable,DataLogicProcedure,SchemaLocation,QueryWhere", (lUseRepository).booleanValue() ? new character(",FetchHasAudit,FetchHasComment,FetchAutoComment") : new character("")));
         
         if (_not(lStarted))
         {
            /* Add request for SBO property with semi colon separator and 
                   add in SmartDataObject as the type for the propert list already added*/
            cRequest.assign(concat("THIS;LogicalObjectName,ServerFirstCall,HasDynamicProxy;SmartBusinessObject;LogicalObjectName;SmartDataObject;", cRequest));
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setServerFirstCall", targetProcedure(), "I", true);
         }
         else
         {
            if ((lUseRepository).booleanValue())
            {
               cRequest.assign(concat("THIS;LogicalObjectName;SmartBusinessObject;LogicalObjectName;SmartDataObject;", cRequest, ",EntityFields"));
            }
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectType"));
         cObjectType.assign(ghProp.unwrapBufferField().value());
         returnNormal(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "containedProperties", targetProcedure(), "II", cRequest, _isEqual(cObjectType, "SmartBusinessObject") ? new logical(false) : new logical(true)));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character obtainPropertyFromContext(final character _pcObjectType_1, final character _pcInstance_1, final character _pcProperty_1, final character _pcContext_2)
   {
      character pcObjectType_1 = TypeFactory.initInput(_pcObjectType_1);
      character pcInstance_1 = TypeFactory.initInput(_pcInstance_1);
      character pcProperty_1 = TypeFactory.initInput(_pcProperty_1);
      character pcContext_2 = TypeFactory.initInput(_pcContext_2);
      /*------------------------------------------------------------------------------
        Purpose:  Returns the value of a specific property from a context string
          Notes:  This function works for multi-instance lists *only*
      ------------------------------------------------------------------------------*/
      character cPropList = TypeFactory.character();
      integer iTypePos = TypeFactory.integer();
      integer iInstPos = TypeFactory.integer();
      integer iPropPos = TypeFactory.integer();
      
      return function("obtainPropertyFromContext", character.class, new Block((Body) () -> 
      {
         cPropList.assign(entry(1, pcContext_2, chr(3)));
         iTypePos.assign(lookup(pcObjectType_1, cPropList, ";"));
         
         if (_isGreaterThan(iTypePos, 0))
         {
            iInstPos.assign(lookup(pcInstance_1, pcContext_2, chr(3)));
            iPropPos.assign(lookup(pcProperty_1, entry(plus(iTypePos, 1), cPropList, ";")));
            
            if (_and(isGreaterThan(iPropPos, 0), () -> isGreaterThan(iInstPos, 0)))
            {
               returnNormal(entry(iPropPos, entry(plus(iInstPos, 1), pcContext_2, chr(3)), chr(4)));
            }
         }
         /* coould not locate the instance and/or property */
         returnNormal(new character());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character pageNrequiredPages(final integer _piPageNum_2)
   {
      integer piPageNum_2 = TypeFactory.initInput(_piPageNum_2);
      /*------------------------------------------------------------------------------
        Purpose:  Returns a comma-separated list of the pages linked to the             
                  specified page for this container.
         Params:  <none>
          Notes:  * The RequiredPages attribute is stored as a series of pipe-delimiter
                    lists of page numbers, including one for page zero. 
                  * There will always be one more entry in the property than there are 
                    pages on the container.
      ------------------------------------------------------------------------------*/
      character cAllRequiredPages = TypeFactory.character();
      character cRequiredPages = TypeFactory.character();
      
      return function("pageNRequiredPages", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RequiredPages"));
         cAllRequiredPages.assign(ghProp.unwrapBufferField().value());
         silent(() -> cRequiredPages.assign(entry(plus(piPageNum_2, 1), cAllRequiredPages, "|")));
         returnNormal(cRequiredPages);
      }));
   }

   /** pageNRequiredPages */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public character pageNtargets(final handle _phTarget_2, final integer _piPageNum_2)
   {
      handle phTarget_2 = TypeFactory.initInput(_phTarget_2);
      integer piPageNum_2 = TypeFactory.initInput(_piPageNum_2);
      /*------------------------------------------------------------------------------
        Purpose:  Returns a comma-separated list of the objects on the 
                  specified page for this container.
         Params:  <none>
          Notes:  This attribute is stored as a comma-separated list of entries, where
                  each entry consists of an object handle (in string form) and its
                  page number, separated by a vertical bar.
                  The Target-Procedure is passed as a parameter because this function
                  is only invoked locally, not IN the Target-procedure.
                  This function is intended to be used only internally by the ADM
                  paging code. 
      ------------------------------------------------------------------------------*/
      character cPageN = TypeFactory.character();
      integer iObj = TypeFactory.integer();
      character cTargets = TypeFactory.character("");
      character cEntry = TypeFactory.character();
      
      return function("pageNTargets", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, phTarget_2.unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PageNTarget"));
         cPageN.assign(ghProp.unwrapBufferField().value());
         
         loopLabel36:
         for (iObj.assign(1); _isLessThanOrEqual(iObj, numEntries(cPageN)); iObj.increment())
         {
            cEntry.assign(entry(iObj, cPageN));
            
            if (_isEqual(new integer(entry(2, cEntry, "|")), piPageNum_2))
            {
               cTargets.assign(concat(cTargets, (_isEqual(cTargets, "") ? new character("") : new character(",")), entry(1, cEntry, "|")));
            }
         }
         
         returnNormal(cTargets);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical registerAppService(final character _pcAppService_1)
   {
      character pcAppService_1 = TypeFactory.initInput(_pcAppService_1);
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      logical lDataContainer = TypeFactory.logical();
      character cContainedAppservices = TypeFactory.character();
      handle hSource = TypeFactory.handle();
      logical lOk = TypeFactory.logical();
      logical lSourceOk = TypeFactory.logical();
      
      return function("registerAppService", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataContainer"));
         lDataContainer.assign(ghProp.unwrapBufferField().value());
         
         if ((lDataContainer).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedAppservices"));
            cContainedAppservices.assign(ghProp.unwrapBufferField().value());
            
            if (_not(matchesList(cContainedAppservices, pcAppService_1)))
            {
               cContainedAppservices.assign(concat(cContainedAppservices, (_isEqual(cContainedAppservices, "") ? new character("") : new character(",")), pcAppService_1));
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedAppservices"));
               ghProp.unwrapBufferField().changeValue(cContainedAppservices);
            }
            
            lOk.assign(true);
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
         hSource.assign(ghProp.unwrapBufferField().value());
         
         if ((hSource.isValid()).booleanValue())
         {
            lSourceOk /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "registerAppService", hSource, "I", pcAppService_1));
         }
         
         returnNormal(or(lOk, lSourceOk));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setCallerObject(final handle _h_3)
   {
      handle h_3 = TypeFactory.initInput(_h_3);
      
      return function("setCallerObject", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CallerObject"));
         ghProp.unwrapBufferField().changeValue(h_3);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setCallerProcedure(final handle _h_3)
   {
      handle h_3 = TypeFactory.initInput(_h_3);
      
      return function("setCallerProcedure", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CallerProcedure"));
         ghProp.unwrapBufferField().changeValue(h_3);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setCallerWindow(final handle _h_3)
   {
      handle h_3 = TypeFactory.initInput(_h_3);
      
      return function("setCallerWindow", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CallerWindow"));
         ghProp.unwrapBufferField().changeValue(h_3);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setClientNames(final character _pcClientNames_1)
   {
      character pcClientNames_1 = TypeFactory.initInput(_pcClientNames_1);
      
      return function("setClientNames", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ClientNames"));
         ghProp.unwrapBufferField().changeValue(pcClientNames_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setCommitSource(final handle _phSource_1)
   {
      handle phSource_1 = TypeFactory.initInput(_phSource_1);
      
      return function("setCommitSource", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CommitSource"));
         ghProp.unwrapBufferField().changeValue(phSource_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setCommitSourceEvents(final character _pcSourceEvents_1)
   {
      character pcSourceEvents_1 = TypeFactory.initInput(_pcSourceEvents_1);
      
      return function("setCommitSourceEvents", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CommitSourceEvents"));
         ghProp.unwrapBufferField().changeValue(pcSourceEvents_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setCommitTarget(final handle _phTarget_2)
   {
      handle phTarget_2 = TypeFactory.initInput(_phTarget_2);
      
      return function("setCommitTarget", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CommitTarget"));
         ghProp.unwrapBufferField().changeValue(phTarget_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setCommitTargetEvents(final character _pcTargetEvents_1)
   {
      character pcTargetEvents_1 = TypeFactory.initInput(_pcTargetEvents_1);
      
      return function("setCommitTargetEvents", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CommitTargetEvents"));
         ghProp.unwrapBufferField().changeValue(pcTargetEvents_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setContainedAppServices(final character _pcAppServices_1)
   {
      character pcAppServices_1 = TypeFactory.initInput(_pcAppServices_1);
      
      return function("setContainedAppServices", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedAppServices"));
         ghProp.unwrapBufferField().changeValue(pcAppServices_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setContainedDataObjects(final character _pcObjects_1)
   {
      character pcObjects_1 = TypeFactory.initInput(_pcObjects_1);
      
      return function("setContainedDataObjects", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         ghProp.unwrapBufferField().changeValue(pcObjects_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setContainerMode(final character _cContainerMode_1)
   {
      character cContainerMode_1 = TypeFactory.initInput(_cContainerMode_1);
      
      return function("setContainerMode", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerMode"));
         ghProp.unwrapBufferField().changeValue(cContainerMode_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setContainerTarget(final character _pcObject_2)
   {
      character pcObject_2 = TypeFactory.initInput(_pcObject_2);
      
      return function("setContainerTarget", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
         ghProp.unwrapBufferField().changeValue(pcObject_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setContainerToolbarSource(final character _pcTarget_2)
   {
      character pcTarget_2 = TypeFactory.initInput(_pcTarget_2);
      
      return function("setContainerToolbarSource", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerToolbarSource"));
         ghProp.unwrapBufferField().changeValue(pcTarget_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setContainerToolbarSourceEvents(final character _pcEvents_2)
   {
      character pcEvents_2 = TypeFactory.initInput(_pcEvents_2);
      
      return function("setContainerToolbarSourceEvents", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerToolbarSourceEvents"));
         ghProp.unwrapBufferField().changeValue(pcEvents_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setCurrentPage(final integer _iPage_1)
   {
      integer iPage_1 = TypeFactory.initInput(_iPage_1);
      
      return function("setCurrentPage", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentPage"));
         ghProp.unwrapBufferField().changeValue(iPage_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setDataContainer(final logical _plDataContainer_1)
   {
      logical plDataContainer_1 = TypeFactory.initInput(_plDataContainer_1);
      
      return function("setDataContainer", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataContainer"));
         ghProp.unwrapBufferField().changeValue(plDataContainer_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setDisabledAddModeTabs(final character _cDisabledAddModeTabs_1)
   {
      character cDisabledAddModeTabs_1 = TypeFactory.initInput(_cDisabledAddModeTabs_1);
      
      return function("setDisabledAddModeTabs", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DisabledAddModeTabs"));
         ghProp.unwrapBufferField().changeValue(cDisabledAddModeTabs_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setDynamicSdoprocedure(final character _pcProc_1)
   {
      character pcProc_1 = TypeFactory.initInput(_pcProc_1);
      
      return function("setDynamicSDOProcedure", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DynamicSDOProcedure"));
         ghProp.unwrapBufferField().changeValue(pcProc_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setFilterSource(final handle _phObject_7)
   {
      handle phObject_7 = TypeFactory.initInput(_phObject_7);
      
      return function("setFilterSource", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FilterSource"));
         ghProp.unwrapBufferField().changeValue(phObject_7);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setHasDynamicProxy(final logical _plProxy_1)
   {
      logical plProxy_1 = TypeFactory.initInput(_plProxy_1);
      
      return function("setHasDynamicProxy", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("HasDynamicProxy"));
         ghProp.unwrapBufferField().changeValue(plProxy_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setHasObjectMenu(final logical _plObjectHasMenus_1)
   {
      logical plObjectHasMenus_1 = TypeFactory.initInput(_plObjectHasMenus_1);
      
      return function("setHasObjectMenu", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("HasObjectMenu"));
         ghProp.unwrapBufferField().changeValue(plObjectHasMenus_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setHideChildContainersOnClose(final logical _plHideChildContainersOnClose_1)
   {
      logical plHideChildContainersOnClose_1 = TypeFactory.initInput(_plHideChildContainersOnClose_1);
      
      return function("setHideChildContainersOnClose", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("HideChildContainersOnClose"));
         ghProp.unwrapBufferField().changeValue(plHideChildContainersOnClose_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setHideOnClose(final logical _plHideOnClose_1)
   {
      logical plHideOnClose_1 = TypeFactory.initInput(_plHideOnClose_1);
      
      return function("setHideOnClose", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("HideOnClose"));
         ghProp.unwrapBufferField().changeValue(plHideOnClose_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setInitialPageList(final character _pcPageList_1)
   {
      character pcPageList_1 = TypeFactory.initInput(_pcPageList_1);
      
      return function("setInitialPageList", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InitialPageList"));
         ghProp.unwrapBufferField().changeValue(pcPageList_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setInMessageTarget(final handle _phObject_7)
   {
      handle phObject_7 = TypeFactory.initInput(_phObject_7);
      
      return function("setInMessageTarget", logical.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Sets the InMessageTarget link value.
            Params:  phObject AS HANDLE
         ------------------------------------------------------------------------------*/
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setInMessageTarget", targetProcedure(), "I", phObject_7);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setInstanceNames(final character _pcNames_1)
   {
      character pcNames_1 = TypeFactory.initInput(_pcNames_1);
      
      return function("setInstanceNames", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("InstanceNames"));
         ghProp.unwrapBufferField().changeValue(pcNames_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setMultiInstanceActivated(final logical _lMultiInstanceActivated_1)
   {
      logical lMultiInstanceActivated_1 = TypeFactory.initInput(_lMultiInstanceActivated_1);
      
      return function("setMultiInstanceActivated", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("MultiInstanceActivated"));
         ghProp.unwrapBufferField().changeValue(lMultiInstanceActivated_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setMultiInstanceSupported(final logical _lMultiInstanceSupported_1)
   {
      logical lMultiInstanceSupported_1 = TypeFactory.initInput(_lMultiInstanceSupported_1);
      
      return function("setMultiInstanceSupported", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("MultiInstanceSupported"));
         ghProp.unwrapBufferField().changeValue(lMultiInstanceSupported_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setNavigationSource(final character _pcSource_2)
   {
      character pcSource_2 = TypeFactory.initInput(_pcSource_2);
      
      return function("setNavigationSource", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NavigationSource"));
         ghProp.unwrapBufferField().changeValue(pcSource_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setNavigationSourceEvents(final character _pcEvents_2)
   {
      character pcEvents_2 = TypeFactory.initInput(_pcEvents_2);
      
      return function("setNavigationSourceEvents", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NavigationSourceEvents"));
         ghProp.unwrapBufferField().changeValue(pcEvents_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setNavigationTarget(final character _cTarget_1)
   {
      character cTarget_1 = TypeFactory.initInput(_cTarget_1);
      
      return function("setNavigationTarget", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NavigationTarget"));
         ghProp.unwrapBufferField().changeValue(cTarget_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setObjectsCreated(final logical _plCreated_1)
   {
      logical plCreated_1 = TypeFactory.initInput(_plCreated_1);
      
      return function("setObjectsCreated", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectsCreated"));
         ghProp.unwrapBufferField().changeValue(plCreated_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setOutMessageTarget(final handle _phObject_7)
   {
      handle phObject_7 = TypeFactory.initInput(_phObject_7);
      
      return function("setOutMessageTarget", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("OutMessageTarget"));
         ghProp.unwrapBufferField().changeValue(phObject_7);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setPage0LayoutManager(final character _pcPage0LayoutManager_1)
   {
      character pcPage0LayoutManager_1 = TypeFactory.initInput(_pcPage0LayoutManager_1);
      
      return function("setPage0LayoutManager", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("Page0LayoutManager"));
         ghProp.unwrapBufferField().changeValue(pcPage0LayoutManager_1);
         returnNormal(true);
      }));
   }

   /** setPage0LayoutManager */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setPageLayoutInfo(final character _pcPageLayoutInfo_1)
   {
      character pcPageLayoutInfo_1 = TypeFactory.initInput(_pcPageLayoutInfo_1);
      
      return function("setPageLayoutInfo", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PageLayoutInfo"));
         ghProp.unwrapBufferField().changeValue(pcPageLayoutInfo_1);
         returnNormal(true);
      }));
   }

   /** setPageLayoutInfo */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setPageNtarget(final character _pcObject_2)
   {
      character pcObject_2 = TypeFactory.initInput(_pcObject_2);
      
      return function("setPageNTarget", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PageNTarget"));
         ghProp.unwrapBufferField().changeValue(pcObject_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setPageSource(final handle _phObject_7)
   {
      handle phObject_7 = TypeFactory.initInput(_phObject_7);
      
      return function("setPageSource", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PageSource"));
         ghProp.unwrapBufferField().changeValue(phObject_7);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setPendingPage(final integer _piPendingPage_1)
   {
      integer piPendingPage_1 = TypeFactory.initInput(_piPendingPage_1);
      
      return function("setPendingPage", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PendingPage"));
         ghProp.unwrapBufferField().changeValue(piPendingPage_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setPrimarySdoTarget(final handle _hPrimarySdoTarget_1)
   {
      handle hPrimarySdoTarget_1 = TypeFactory.initInput(_hPrimarySdoTarget_1);
      
      return function("setPrimarySdoTarget", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PrimarySdoTarget"));
         ghProp.unwrapBufferField().changeValue(hPrimarySdoTarget_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setReEnableDataLinks(final character _cReEnableDataLinks_1)
   {
      character cReEnableDataLinks_1 = TypeFactory.initInput(_cReEnableDataLinks_1);
      
      return function("setReEnableDataLinks", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ReEnableDataLinks"));
         ghProp.unwrapBufferField().changeValue(cReEnableDataLinks_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setRemoveMenuOnHide(final logical _plRemoveMenu_1)
   {
      logical plRemoveMenu_1 = TypeFactory.initInput(_plRemoveMenu_1);
      
      return function("setRemoveMenuOnHide", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RemoveMenuOnhide"));
         ghProp.unwrapBufferField().changeValue(plRemoveMenu_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setRequiredPages(final character _pcRequiredPages_1)
   {
      character pcRequiredPages_1 = TypeFactory.initInput(_pcRequiredPages_1);
      
      return function("setRequiredPages", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RequiredPages"));
         ghProp.unwrapBufferField().changeValue(pcRequiredPages_1);
         returnNormal(true);
      }));
   }

   /** setRequiredPages */
   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setRouterTarget(final handle _phObject_7)
   {
      handle phObject_7 = TypeFactory.initInput(_phObject_7);
      
      return function("setRouterTarget", logical.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Sets the RouterTarget link value.
            Params:  phObject AS HANDLE
         ------------------------------------------------------------------------------*/
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRouterTarget", targetProcedure(), "I", phObject_7);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setRunDooptions(final character _pcOptions_1)
   {
      character pcOptions_1 = TypeFactory.initInput(_pcOptions_1);
      
      return function("setRunDOOptions", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RunDOOptions"));
         ghProp.unwrapBufferField().changeValue(pcOptions_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setRunMultiple(final logical _plMultiple_1)
   {
      logical plMultiple_1 = TypeFactory.initInput(_plMultiple_1);
      
      return function("setRunMultiple", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RunMultiple"));
         ghProp.unwrapBufferField().changeValue(plMultiple_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setSavedContainerMode(final character _cSavedContainerMode_1)
   {
      character cSavedContainerMode_1 = TypeFactory.initInput(_cSavedContainerMode_1);
      
      return function("setSavedContainerMode", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SavedContainerMode"));
         ghProp.unwrapBufferField().changeValue(cSavedContainerMode_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setSdoForeignFields(final character _cSdoForeignFields_1)
   {
      character cSdoForeignFields_1 = TypeFactory.initInput(_cSdoForeignFields_1);
      
      return function("setSdoForeignFields", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SdoForeignFields"));
         ghProp.unwrapBufferField().changeValue(cSdoForeignFields_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setStatusArea(final logical _plStatusArea_1)
   {
      logical plStatusArea_1 = TypeFactory.initInput(_plStatusArea_1);
      /*------------------------------------------------------------------------------
        Purpose:  Allows for the setting of the status area for a container
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hContainer = TypeFactory.handle();
      
      return function("setStatusArea", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if (_and(and(hContainer.isValid(), () -> HandleOps.canQuery(hContainer, "status-area")), () -> isEqual(plStatusArea_1, true)))
         {
            hContainer.unwrapWindow().setStatusArea(plStatusArea_1);
         }
         
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setStatusDefault(final character _pcStatusDefault_1)
   {
      character pcStatusDefault_1 = TypeFactory.initInput(_pcStatusDefault_1);
      /*------------------------------------------------------------------------------
        Purpose:  Allows the user to sets the STATUS DEFAULT for the window's
                  STATUS-AREA
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hContainer = TypeFactory.handle();
      
      return function("setStatusDefault", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if ((hContainer.isValid()).booleanValue())
         {
            statusDefault(pcStatusDefault_1, hContainer);
         }
         else
         {
            returnNormal(false);
         }
         
         /* Function return value. */
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setStatusInput(final character _pcStatusInput_1)
   {
      character pcStatusInput_1 = TypeFactory.initInput(_pcStatusInput_1);
      /*------------------------------------------------------------------------------
        Purpose:  Allows the user to sets the STATUS INPUT for the window's
                  STATUS-AREA
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hContainer = TypeFactory.handle();
      
      return function("setStatusInput", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if ((hContainer.isValid()).booleanValue())
         {
            statusDefault(pcStatusInput_1, hContainer);
         }
         else
         {
            returnNormal(false);
         }
         
         /* Function return value. */
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setStatusInputOff()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Allows the user to sets the STATUS INPUT off for the window's
                  STATUS-AREA
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hContainer = TypeFactory.handle();
      
      return function("setStatusInputOff", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if ((hContainer.isValid()).booleanValue())
         {
            statusInputOff(hContainer);
         }
         else
         {
            returnNormal(false);
         }
         
         /* Function return value. */
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setTopOnly(final logical _plTopOnly_1)
   {
      logical plTopOnly_1 = TypeFactory.initInput(_plTopOnly_1);
      /*------------------------------------------------------------------------------
        Purpose:     Set window to top only (toggle)
        Parameters:  input logical of yes / no for what to set it to.
        Notes:       
      ------------------------------------------------------------------------------*/
      handle hContainer = TypeFactory.handle();
      
      return function("setTopOnly", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if (_and(hContainer.isValid(), () -> HandleOps.canQuery(hContainer, "top-only")))
         {
            hContainer.unwrapTopOnly().setTopOnly(plTopOnly_1);
         }
         
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setUpdateActive(final logical _plActive_1)
   {
      logical plActive_1 = TypeFactory.initInput(_plActive_1);
      
      return function("setUpdateActive", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateActive"));
         ghProp.unwrapBufferField().changeValue(plActive_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setUpdateSource(final character _pcSource_2)
   {
      character pcSource_2 = TypeFactory.initInput(_pcSource_2);
      
      return function("setUpdateSource", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateSource"));
         ghProp.unwrapBufferField().changeValue(pcSource_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setUpdateTarget(final character _pcTarget_2)
   {
      character pcTarget_2 = TypeFactory.initInput(_pcTarget_2);
      
      return function("setUpdateTarget", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
         ghProp.unwrapBufferField().changeValue(pcTarget_2);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setWaitForObject(final handle _phObject_7)
   {
      handle phObject_7 = TypeFactory.initInput(_phObject_7);
      
      return function("setWaitForObject", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("WaitForObject"));
         ghProp.unwrapBufferField().changeValue(phObject_7);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setWindowFrameHandle(final handle _phFrame_1)
   {
      handle phFrame_1 = TypeFactory.initInput(_phFrame_1);
      
      return function("setWindowFrameHandle", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("WindowFrameHandle"));
         ghProp.unwrapBufferField().changeValue(phFrame_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical setWindowTitleViewer(final handle _phViewer_1)
   {
      handle phViewer_1 = TypeFactory.initInput(_phViewer_1);
      
      return function("setWindowTitleViewer", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("WindowTitleViewer"));
         ghProp.unwrapBufferField().changeValue(phViewer_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public integer targetPage(final handle _phObject_7)
   {
      handle phObject_7 = TypeFactory.initInput(_phObject_7);
      /*------------------------------------------------------------------------------
        Purpose:  Returns the page number of an object
          Notes:    
      ------------------------------------------------------------------------------*/
      character cTargets = TypeFactory.character();
      integer iObj = TypeFactory.integer();
      character cEntry = TypeFactory.character();
      
      return function("targetPage", integer.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PageNTarget"));
         cTargets.assign(ghProp.unwrapBufferField().value());
         
         loopLabel37:
         for (iObj.assign(1); _isLessThanOrEqual(iObj, numEntries(cTargets)); iObj.increment())
         {
            cEntry.assign(entry(iObj, cTargets));
            
            /* return the page immediately when found */
            if (_isEqual(entry(1, cEntry, "|"), valueOf(phObject_7)))
            {
               returnNormal(new integer(entry(2, cEntry, "|")));
            }
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
         cTargets.assign(ghProp.unwrapBufferField().value());
         returnNormal((matchesList(cTargets, valueOf(phObject_7))).booleanValue() ? new integer(0) : new integer());
      }));
   }

   public character fwdGetAdmversion()
   {
      return function("fwdGetADMVersion", character.class, new Block((Body) () -> 
      {
         returnNormal("ADM2.2");
      }));
   }
}
