/*--------------------------------------------------------------------------
    File        : Data.java
    Purpose     : Super Procedure for all SmartDataObjects
    Syntax      : adm2/data.p
  ------------------------------------------------------------------------*/

package com.goldencode.hotel.common.adm2;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.hotel.dmo._temp.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.util.*;
import com.goldencode.p2j.persist.lock.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.util.ArrayAssigner.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.persist.RecordBuffer.batch;
import static com.goldencode.p2j.ui.LogicalTerminal.*;
import static com.goldencode.p2j.util.ErrorManager.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in common/adm2/data.p).
 */
public class Data
{
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*---------------------------------------------------------------------------------
     File: ttsdoout.i
   
     Description:  SDO output temp-table
   
     Purpose:      SDO output temp-table - used to pass out contents of rowobject table in
                   standard format
   
     Parameters:   <none>
   
     History:
     --------
     (v:010000)    Task:        7934   UserRef:    
                   Date:   14/02/2001  Author:     Anthony Swindells
   
     Update Notes: Created from Template ryteminclu.i
   
   ---------------------------------------------------------------------------------*/   
   /*                   This .W file was created with the Progress UIB.             */   
   /*-------------------------------------------------------------------------------*/   
   /* Astra 2 object identifying preprocessor */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 7.91
            WIDTH              = 44.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   Tttable_1_1.Buf tttable = TemporaryBuffer.define(Tttable_1_1.Buf.class, "tttable", "ttTable", false, false);

   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   Ttschema_1_1.Buf ttschema = TemporaryBuffer.define(Ttschema_1_1.Buf.class, "ttschema", "ttSchema", false);

   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* Tell dataattr.i that this is the Super procedure. */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : dataexclcustom.i
       Purpose     : Defines EXCLUDE-xxx preprocessor variables to exclude
                     functions or internal procedures in the super procedure
                     where it is referenced.
       Syntax      : {src/adm2/custom/dataexclcustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in src/adm2/data.p
     ------------------------------------------------------------------------*/   
   logical glShowMessageAnswer = TypeFactory.logical();

   /* used in showMessage */   
   /* This variable is needed at least temporarily so that a called
       fn can tell who the actual source was. */   
   handle ghTargetProcedure = TypeFactory.handle();

   /* This AddStartRow number, is used as a global sequence for new records, 
      This may very well change in a future release. */   
   /* high # for new rows*/    
   integer giAddRowNum = TypeFactory.integer((long) 9000000);

   /* tmp row num for add */   
   /* Include the file which defines AppServerConnect procedures. */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /* adecomm/appserv.i checks to see if the persistent procedure adecomm/as-utils.w
                        has been started up, and if not, it starts it and then makes
                        is a SUPER procedure of the calling procedure.
                        
      Created: 11/26/97 by Ross Hunter
                                                                                    */   
   handle appSrvUtils = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "appsrvutils", true, new handle());

   /* _UIB-CODE-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Procedure
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: CODE-ONLY COMPILE
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Procedure ASSIGN
            HEIGHT             = 18.24
            WIDTH              = 55.8.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ************************* Included-Libraries *********************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : dataprop.i
       Purpose     : Starts data.p Super procedure and defines Basic DataObject
                     properties.
       Syntax      : {src/adm2/dataprop.i}
   
       Description :
   
       Modified    : June 26, 2000 Version 9.1B
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : datadefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/datadefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/dataprop.i}
     ------------------------------------------------------------------------*/   
   /* This is the procedure to execute to set InstanceProperties at design time. */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 4.29
            WIDTH              = 60.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Include the file which defines prototypes for all of the super
        procedure's entry points. Also, start or attach to the super procedure.
        Skip start-super-proc if we *are* the super procedure. 
        And skip including the prototypes if we are *any* super procedure. */   
   /* Preprocessor definitions which tell at compile time which
       properties can be retrieved directly from the property temp-table. */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : qryprop.i
       Purpose     : Starts query.p Super procedure and defines Basic Query Object
                     properties.
       Syntax      : {src/adm2/qryprop.i}
   
       Description :
   
       Modified    : May 15, 2000 -- Version 9.1B
       Modified    : 10/24/2001            Mark Davies (MIP0
                     Added new property FilterAvailable.
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : querydefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/querydefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/qryprop.i}
     ------------------------------------------------------------------------*/   
   /* This variable designates the maximal length of any database 
      table index within the Rocket. If the total length of index 
      fields exceeds this limit, PROGRESS raises a run-time error. */   
   integer xiRocketIndexLimit = TypeFactory.integer((long) 188);

   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 4.57
            WIDTH              = 42.4.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Include the file which defines prototypes for all of the super
        procedure's entry points. Also, start or attach to the super procedure.
        Skip start-super-proc if we *are* the super procedure. 
        And skip including the prototypes if we are *any* super procedure. */   
   /* Preprocessors to define properties that can be retrieved
       directly from the property temp-table. */   
   /* if appserver aware add appserver properties */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : appsprop.i
       Purpose     : Defines basic properties.
       Syntax      : {src/adm2/appsprop.i}
   
       Description :
   
       Modified    : 01/24/2001
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* Custom instance definition file */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : appserverdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/appserverdefscustom.i}
   
       Modified    : 01/24/2001
       
       Notes       : Referenced in {src/adm2/appsprop.i}
     ------------------------------------------------------------------------*/   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 7.86
            WIDTH              = 60.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Include the file which defines prototypes for all of the super
      procedure's entry points. 
      And skip including the prototypes if we are *any* super procedure. */   
   /* These preprocessors tell at compile time which properties can
        be retrieved directly from the temp-table */   
   /* include properties from smart */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smrtprop.i
       Purpose     : Starts smart.p super procedure and defines general
                     SmartObject properties and other values.
       Syntax      : {src/adm2/smrtprop.i}
   
       Description :
   
       Modified    : February 4, 2000 - Version 9.1B
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smartdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/smartdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/smrtprop.i}
     ------------------------------------------------------------------------*/   
   /* Service Managers */   
   /*********************************************************************
   * Copyright (C) 2000-2002 by Progress Software Corporation ("PSC"),  *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*---------------------------------------------------------------------------------
     File: globals.i
   
     Description:  ICF Global Shared Variables
   
     Purpose:      ICF Global Shared Variables
                   The global shared variables available within the Dynamics environment.
                   
                   NOTE: (Dynamic Only )
                   Shared variables do not span the client / server boundary. On the
                   client these are set-up in afstartupp.p and on the server in the agent
                   as_startup.p
                   Also note if we include the guts of a procedure as an internal
                   procedure for shared client/server code, we sometime need to
                   ensure the shared variables are not redefined.
   
     Parameters:   <none>
   
     History:
     --------
   
     Modified: 11/08/2001 - Mark Davies (MIP)
               Copied code for ICF afglobals.i and added here to allow
               ICF changed adm code to compile. afglobals.i now includes
               this file for definitions.
               Any ADM code will now reference globals.i which excludes any other
               ICF specific includes.
   -----------------------------------------------------------*/   
   /*                   This .W file was created with the Progress UIB.             */   
   /*-------------------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 5.57
            WIDTH              = 64.4.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Used whereever Crystal is used and when defining the tt_datasource temp-table 
      to define the maximum columns supported when printing to crystal.
      See browsercustom.p and afcrpplip2p.p for example uses
   */   
   /* Used for filter checks */   
   /* The table delimiter used in assignlist, *ColumnsByTable props */   
   handle gshAstraAppserver = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshastraappserver", true, new handle());

   /* Handle to Astra Application Server Partition */   
   handle gshSessionManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsessionmanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshRimanager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrimanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshSecurityManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsecuritymanager", true, new handle());

   /* Handle Astra Security Manager */   
   handle gshProfileManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshprofilemanager", true, new handle());

   /* Handle Astra Profile Manager */   
   handle gshRepositoryManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrepositorymanager", true, new handle());

   /* Handle Astra Repository Manager */   
   handle gshTranslationManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshtranslationmanager", true, new handle());

   /* Handle Astra Translation Manager */   
   handle gshWebManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshwebmanager", true, new handle());

   /* Handle Astra Web Manager */   
   character gscSessionId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gscsessionid", true, new character(""));

   /* Unique session id */   
   decimal gsdSessionObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionobj", true, new decimal(0));

   /* Unique session id */   
   handle gshFinManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshfinmanager", true, new handle());

   /* Handle AstraFin Generic Manager */   
   handle gshGenManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshgenmanager", true, new handle());

   /* Handle AstraFramework Generic Manager */   
   handle gshAgnManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshagnmanager", true, new handle());

   /* Handle AstraGen Generic Manager */   
   decimal gsdTempUniqueId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdtempuniqueid", true, new decimal(0));

   /* A number for unique objects */   
   decimal gsdUserObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsduserobj", true, new decimal(0));

   /* User Object ID */   
   decimal gsdRenderTypeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdrendertypeobj", true, new decimal(0));

   /* Render Type Object ID */   
   decimal gsdSessionScopeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionscopeobj", true, new decimal(0));

   /* Render Type Object ID */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*------------------------------------------------------------------------
       File        : globalscustom.i
       Purpose     : The developer can create his own version of this to 
                     allow 'global' definitions to be added to the 
                     framework.   
       Syntax      : {src/adm2/custom/globalscustom.i}
   
       Description :
   
       Created     : 06/03/1999
       Notes       : Referenced in {src/adm2/globals.i}
     ----------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress AppBuilder.      */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* define the ADM Version and broker handle for all SmartObjects */   
   /* Note that adm-props-from-repository is documented as possible to define
        as a variable for flexible override, so it cannot be used for conditional 
        compile.  */   
   /* adm-props-from-repository is supported to be defined as a variable,
       so it is not used for conditional compile */   
   handle ghProp = TypeFactory.handle();

   /**
    * External procedure (converted to Java from the 4GL source code
    * in common/adm2/data.p).
    */
   public void execute()
   {
      externalProcedure(Data.this, new Block((Init) () -> 
      {
         gsdSessionObj.setPrecision(9);
         gsdTempUniqueId.setPrecision(9);
         gsdUserObj.setPrecision(9);
         gsdRenderTypeObj.setPrecision(9);
         gsdSessionScopeObj.setPrecision(9);
      }, 
      (Body) () -> 
      {
         RecordBuffer.openScope(ttschema, tttable);
         
         if (_not(appSrvUtils.isValid()))
         {
            ControlFlowOps.invokePersistentSet("adecomm/as-utils.w", appSrvUtils);
         }
         
         thisProcedure().unwrapCommonProcedure().addSuperProcedure(appSrvUtils);
         
         /* _UIB-CODE-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Method-Library
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Method-Library ASSIGN
                  HEIGHT             = 14.86
                  WIDTH              = 57.2.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ***************************  Main Block  *************************** */
         /* Include the file which defines prototypes for all of the super
              procedure's entry points. Also, start or attach to the super procedure.
              Skip start-super-proc if we *are* the super procedure. 
              And skip including the prototypes if we are *any* super procedure. */
         /* These preprocessors let the get and set methods know at compile time
             which property values are located in the temp-table and which must
             be accessed through the property functions.
          */
         /* for support of dynamic objects */
         /* physical name - no path */
         /* for support of runtime parameters passed from the menus */
         /* Properties for super procedure management */
         /* The name of the super procedure; can be a CSV list */ 
 /* STATELESS, STATEFUL; the mode that all supers for the object will be launched in */ 
 /* Runtime property storing handles to the object's super procedures, defined in SuperProcedure. */
         /* Layout support for dynamic objects */
         /* contains a layout position that allows an object to be laid out correctly. */
         /* determine if we need to create the prop fields here or from the */
         /* repository (if ICF is running ) */
         /* COMMENT THE FOLLOWING LINE TO USE THE "<class>prop.i" DEFINITIONS */
         /* This temp-table defines all the propertt fields for an object.
             This include file contributes the DEFINE statement header and
             all basic smart object properties. Each other property class include file
             adds its own fields and then the parent object ends the statement.
             Define the fields for smart objects only, not for their super procedures.
          */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
         
         /* _UIB-CODE-BLOCK-END */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
         
         /* _UIB-CODE-BLOCK-END */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
         
         /* _UIB-CODE-BLOCK-END */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public character getObjectType()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Type of the SmartObject, such as "SmartDataObject", etc.
                  For an ADM Super procedure, this function returns "SUPER".
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cType = TypeFactory.character();
      
      return function("getObjectType", character.class, new Block((Body) () -> 
      {
         cType.assign("SUPER");
         returnNormal(cType);
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    * Purpose: Validation hook for code to be executed immediately after the <br>
    *          transaction has started before the updates is done. <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void beginTransactionValidate()
   {
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.invokeInWithMode("bufferTransactionValidate", targetProcedure(), "I", new character("begin"));
         returnNormal(ControlFlowOps.getReturnValue());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Construct the changed value list. This list is actually stored in the <br>
    *              before version of the record for an update.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void bufferCollectChanges()
   {
      handle hRowObject = TypeFactory.handle();
      handle hRowObjUpd = TypeFactory.handle();
      handle hRowObjUpd2 = TypeFactory.handle();
      handle hQuery = TypeFactory.handle();
      character cChangedFlds = TypeFactory.character("");
      character cUpdatable = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cUpdatable.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdatableColumns", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObjUpd"));
         hRowObjUpd.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         RecordBuffer.create(hRowObject, hRowObject);
         RecordBuffer.create(hRowObjUpd, hRowObjUpd);
         RecordBuffer.create(hRowObjUpd2, hRowObjUpd);
         /* set up RowObjUpd query */
         QueryWrapper.createQuery(hQuery);
         hQuery.unwrapQuery().setBuffers(hRowObjUpd);
         hQuery.unwrapQuery().prepare(concat("FOR EACH ", hRowObjUpd.unwrap().name(), " WHERE RowMod = \"A\" OR RowMod = \"C\" OR RowMod = \"U\""));
         hQuery.unwrapQuery().queryOpen();
         hQuery.unwrapQuery().getFirst();
         
         LogicalOp whileClause0 = () -> hRowObjUpd.unwrapBuffer().available();
         
         doWhile("loopLabel0", whileClause0, new Block((Body) () -> 
         {
            cChangedFlds.assign("");
            
            if (_isEqual(hRowObjUpd.unwrapBuffer().bufferField("RowMod").unwrapBufferField().value(), "U"))
            {
               hRowObjUpd2.unwrapBuffer().findFirst(concat("WHERE RowMod = \"\" AND RowNum = ", valueOf(hRowObjUpd.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value())));
               /* As of 9.1A, we no longer rely on ChangedFields being set
                           before this point. Calculate it here so it includes any
                           application-generated values. */
               cChangedFlds.assign(bufferCompareFields(hRowObjUpd, hRowObjUpd2, new character("ChangedFields,RowMod,RowIdent,RowIdentIdx,RowNum"), new character("CASE-SENSITIVE")));
            }
            else
            {
               if (_isEqual(hRowObjUpd.unwrapBuffer().bufferField("RowMod").unwrapBufferField().value(), "A"))
               {
                  /* For an Add, set ChangedFields to all fields no longer
                             equal to their defined INITIAL value. Determine this by
                             creating a RowObject record to compare against. */
                  hRowObject.unwrapBuffer().bufferCreate();
                  cChangedFlds.assign(bufferCompareFields(hRowObjUpd, hRowObject, new character("ChangedFields,RowMod,RowIdent,RowIdentIdx,RowNum"), new character("CASE-SENSITIVE")));
               }
               else
               {
                   /* use all enabled fields for copy */cChangedFlds.assign(cUpdatable);
               }
            }
            
            /* Now assign the list of fields into the ROU record. 
                       (Put it in the before record as well for an Update.) 
                       This list will be used by query.p code to ASSIGN changes
                       back to the database. */
            if (_isEqual(hRowObjUpd.unwrapBuffer().bufferField("RowMod").unwrapBufferField().value(), "U"))
            {
               hRowObjUpd2.unwrapBuffer().bufferField("ChangedFields").unwrapBufferField().changeValue(cChangedFlds);
            }
            
            hRowObjUpd.unwrapBuffer().bufferField("ChangedFields").unwrapBufferField().changeValue(cChangedFlds);
            
            /* if a row was temporarily created to supply initial values for the
                    Add operation BUFFER-COMPARE, delete it now. */
            if (_and(isEqual(hRowObjUpd.unwrapBuffer().bufferField("RowMod").unwrapBufferField().value(), "A"), () -> hRowObject.unwrapBuffer().available()))
            {
               hRowObject.unwrapBuffer().deleteRecord();
            }
            
            hQuery.unwrapQuery().getNext();
         }));
         
         /* END FOR EACH */
         HandleOps.delete(hQuery);
         HandleOps.delete(hRowObject);
         HandleOps.delete(hRowObjUpd);
         HandleOps.delete(hRowObjUpd2);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    *  Purpose:     Update procedure executed on the server side of a split <br>
    *               SmartDataObject, called from the client Commit function.<br>
    *               Commit passes a set up RowObjUpdate records both have changes to<br>
    *               be committed and their pre-change copies (before-images).  <br>
    *               commitRows verifies that the records have not been changed <br>
    *               since they were read, and then commits the changes to the <br>
    *               database.<br>
    *  Parameters:<br>
    *    OUTPUT cMessages - a CHR(3) delimited string of accumulated messages from<br>
    *                       server.<br>
    *    OUTPUT cUndoIds  - list of any RowObject ROWIDs whose changes need to be <br>
    *                       undone as the result of errors in the form of:<br>
    *               "RowNumCHR(3)ADM-ERROR-STRING,RowNumCHR(3)ADM-ERROR-STRING,..."<br>
    * <p>
    * Notes:        If another user has modified the database records since the <br>
    *               original was read, the new database values are copied into the <br>
    *               RowObjUpd record and returned to Commit so the UI object can <br>
    *               diaply them.<br>
    *           -   We need to identify where the hooks are because if a hook is <br>
    *               ONLY in the Logical Object then the TT need to be transfered <br>
    *               back and forth. If the hook is local then we cannot transfer <br>
    *               here asa the local then would change a different TT. <br>
    *               It there for some reason should be hooks both locally and in <br>
    *               the logic procedure the local hook would be a complete <br>
    *               overrride or it would need to do the transfer itself
    */
   public void bufferCommit(final character pocMessages, final character pocUndoIds)
   {
      handle hRowObject = TypeFactory.handle();
      handle hRowObjUpd = TypeFactory.handle();
      handle hRowObjUpd1 = TypeFactory.handle();
      handle hRowObjUpd2 = TypeFactory.handle();
      character cAsdivision = TypeFactory.character();
      logical lSubmitVal = TypeFactory.logical();
      integer iChange = TypeFactory.integer();
      character cChanged = TypeFactory.character();
      character cChangedFlds = TypeFactory.character();
      character cChangedVals = TypeFactory.character();
      character cUpdatable = TypeFactory.character();
      logical lQueryContainer = TypeFactory.logical();
      handle hQuery1 = TypeFactory.handle();
      handle hQuery2 = TypeFactory.handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pocMessages);
         TypeFactory.initOutput(pocUndoIds, new character(""));
      }, 
      (Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryContainer"));
         lQueryContainer.assign(ghProp.unwrapBufferField().value());
         
         /* TransactionValidate is maintained for backward (pre 9.1A) compatibility; 
              the new procedure for this slot before the transaction is 
              preTransactionValidate. ChangedFields is calculated further down and will 
              picked up fields changed in these hooks.  
              NOTE: The principle is (as with fieldValidate and rowobjectValidate) that 
              this application object returns an error message if there is one;     
              trigger errors get captured below. */
         if (_not(lQueryContainer))
         {
            silent(() -> ControlFlowOps.invokeIn("TransactionValidate", targetProcedure()));
            
            if (_and(not(ErrorManager.isError()), () -> isNotEqual(ControlFlowOps.getReturnValue(), "")))
            {
               ControlFlowOps.invokeInWithMode("prepareErrorsForReturn", targetProcedure(), "IIU", ControlFlowOps.getReturnValue(), cAsdivision, pocMessages);
               returnNormal();
            }
            
            /* END DO IF RETURN-VALUE NE "" */
            ControlFlowOps.invokeInWithMode("bufferValidate", targetProcedure(), "I", new character("pre"));
            
            if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
            {
               ControlFlowOps.invokeInWithMode("prepareErrorsForReturn", targetProcedure(), "IIU", ControlFlowOps.getReturnValue(), cAsdivision, pocMessages);
               returnNormal();
            }
         }
         /* END DO IF Container (SBO) is not doing the Commit. */
         ControlFlowOps.invokeIn("bufferCollectChanges", targetProcedure());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObjUpd"));
         hRowObjUpd.assign(ghProp.unwrapBufferField().value());
         
         /* If this is the server side and the ServerSubmitValidation property
              has been set to *yes*, then we execute that normally client side 
              validation here to make sure that it has been done. */
         if (_isEqual(cAsdivision, "Server"))
         {
            /* {get Prop var [handle]} */ 
            lSubmitVal.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getServerSubmitValidation", targetProcedure()));
            
            if ((lSubmitVal).booleanValue())
            {
               /* {get Prop var [handle]} */ 
               cUpdatable.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdatableColumns", targetProcedure()));
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
               hRowObject.assign(ghProp.unwrapBufferField().value());
               RecordBuffer.create(hRowObjUpd1, hRowObjUpd);
               /* set up RowObjUpd query */
               QueryWrapper.createQuery(hQuery1);
               hQuery1.unwrapQuery().setBuffers(hRowObjUpd1);
               hQuery1.unwrapQuery().prepare(concat("FOR EACH ", hRowObjUpd1.unwrap().name(), " WHERE RowMod = \"A\" OR RowMod = \"C\" OR RowMod = \"U\""));
               hQuery1.unwrapQuery().queryOpen();
               hQuery1.unwrapQuery().getFirst();
               
               LogicalOp whileClause1 = () -> hRowObjUpd1.unwrapBuffer().available();
               
               doWhile("loopLabel1", whileClause1, new Block((Body) () -> 
               {
                  doBlock(TransactionType.FULL, "blockLabel0", new Block((Body) () -> 
                  {
                     hRowObject.unwrapBuffer().bufferCreate();
                     hRowObject.unwrapBuffer().bufferCopy(hRowObjUpd1);
                  }));
                  
                  cChangedFlds.assign(hRowObjUpd1.unwrapBuffer().bufferField("ChangedFields").unwrapBufferField().value());
                  cChangedVals.assign("");
                  
                  loopLabel2:
                  for (iChange.assign(1); _isLessThanOrEqual(iChange, numEntries(cChangedFlds)); iChange.increment())
                  {
                     cChanged.assign(entry(iChange, cChangedFlds));
                     cChangedVals.assign(concat(cChangedVals, (_isNotEqual(cChangedVals, "") ? chr(1) : new character("")), cChanged, chr(1), valueOf(hRowObjUpd1.unwrapBuffer().bufferField(cChanged).unwrapBufferField().value())));
                  }
                  
                  /* END DO iChange */
                  /* Now pass the values and column list to the client validation. */
                  ControlFlowOps.invokeInWithMode("submitValidation", targetProcedure(), "II", cChangedVals, cUpdatable);
                  
                  doBlock(TransactionType.FULL, "blockLabel1", new Block((Body) () -> 
                  {
                     hRowObject.unwrapBuffer().deleteRecord();
                  }));
                  
                  hQuery1.unwrapQuery().getNext();
               }));
               
               /* END FOR EACH RowObjUpd */
               HandleOps.delete(hRowObjUpd1);
               HandleOps.delete(hQuery1);
               
               /* Exit if any error messages were generated. This means that
                        all messages associated with the "client" SubmitValidation will
                        be accumulated, but the update transaction will not be attempted
                        if there are any prior errors. */
               if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
               {
                  ControlFlowOps.invokeInWithMode("prepareErrorsForReturn", targetProcedure(), "IIU", new character(""), cAsdivision, pocMessages);
                  returnNormal();
               }
            }
         }
         
         OnPhrase[] onPhrase0 = new OnPhrase[]
         {
            new OnPhrase(Condition.ERROR, Action.LEAVE, "transBlk")
         };
         
         doBlock(TransactionType.FULL, "transBlk", onPhrase0, new Block((Body) () -> 
         {
            /* This user-defined validation hook is for code to be executed
                   inside the transaction, but before any updates occur. */
            ControlFlowOps.invokeInWithMode("bufferValidate", targetProcedure(), "I", new character("begin"));
            
            if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
            {
               ControlFlowOps.invokeInWithMode("prepareErrorsForReturn", targetProcedure(), "IIU", ControlFlowOps.getReturnValue(), cAsdivision, pocMessages);
               undoReturnNormal("transBlk");
            }
            
            /* END DO IF RETURN-VALUE NE "" */
            ControlFlowOps.invokeInWithMode("bufferProcessUpdate", targetProcedure(), "UU", pocMessages, pocUndoIds);
            ControlFlowOps.invokeInWithMode("bufferProcessDelete", targetProcedure(), "UU", pocMessages, pocUndoIds);
            ControlFlowOps.invokeInWithMode("bufferProcessNew", targetProcedure(), "UU", pocMessages, pocUndoIds);
            
            if (_isNotEqual(pocUndoIds, ""))
            {
               undoLeave("transBlk");
            }
            
            ControlFlowOps.invokeInWithMode("bufferValidate", targetProcedure(), "I", new character("end"));
            
            if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
            {
               ControlFlowOps.invokeInWithMode("prepareErrorsForReturn", targetProcedure(), "IIU", ControlFlowOps.getReturnValue(), cAsdivision, pocMessages);
               undoReturnNormal("transBlk");
            }
            
            /* END DO IF RETURN-VALUE NE "" */
            /* return the latest version of the record to the client */
            RecordBuffer.create(hRowObjUpd2, hRowObjUpd);
            QueryWrapper.createQuery(hQuery2);
            hQuery2.unwrapQuery().setBuffers(hRowObjUpd2);
            hQuery2.unwrapQuery().prepare(concat("FOR EACH ", hRowObjUpd2.unwrap().name(), " WHERE RowMod = \"A\" OR RowMod = \"C\" OR RowMod = \"U\""));
            hQuery2.unwrapQuery().queryOpen();
            hQuery2.unwrapQuery().getFirst();
            
            LogicalOp whileClause2 = () -> hRowObjUpd2.unwrapBuffer().available();
            
            doWhile("loopLabel3", whileClause2, new Block((Body) () -> 
            {
               silent(() -> ControlFlowOps.invokeInWithMode("refetchDBRow", targetProcedure(), "I", hRowObjUpd2));
               
               /* Support return-value from triggers (from RefetchDbRow)*/
               if ((ErrorManager.isError()).booleanValue())
               {
                  ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", _isNotEqual(ControlFlowOps.getReturnValue(), "") ? ControlFlowOps.getReturnValue() : new character(), new unknown(), new unknown());
               }
               
               hQuery2.unwrapQuery().getNext();
            }));
            
            HandleOps.delete(hRowObjUpd2);
            HandleOps.delete(hQuery2);
         }));
         
         /* END transaction block. */
         /* RELEASE the database record(s). */
         ControlFlowOps.invokeIn("releaseDBRow", targetProcedure());
         
         /* Add a message to indicate the update has been cancelled. */
         if (_isNotEqual(pocUndoIds, ""))
         {
            ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III",  /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 15), new unknown(), new unknown());
         }
         
         /* This user-defined validation hook is for code to be executed
              outside the transaction, after all updates occur. */
         if (_not(lQueryContainer))
         {
            ControlFlowOps.invokeInWithMode("bufferValidate", targetProcedure(), "I", new character("post"));
            
            if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
            {
               ControlFlowOps.invokeInWithMode("prepareErrorsForReturn", targetProcedure(), "IIU", ControlFlowOps.getReturnValue(), cAsdivision, pocMessages);
               returnNormal();
            }
         }
         /* END DO IF Container (SBO) is not doing the commit for us. */
         /* If we're not on an AppServer, the messages will be available to the
              caller, so don't "fetch" them (which would also delete them). */
         ControlFlowOps.invokeInWithMode("prepareErrorsForReturn", targetProcedure(), "IIU", ControlFlowOps.getReturnValue(), cAsdivision, pocMessages);
         returnNormal();
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   private void bufferProcessDelete(final character pocMessages, final character pocUndoIds)
   {
      handle hRowObjUpd = TypeFactory.handle();
      handle hQuery = TypeFactory.handle();
      character cDeleteMsg = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObjUpd"));
         hRowObjUpd.assign(ghProp.unwrapBufferField().value());
         /* set up RowObjUpd query */
         QueryWrapper.createQuery(hQuery);
         hQuery.unwrapQuery().setBuffers(hRowObjUpd);
         hQuery.unwrapQuery().prepare(concat("FOR EACH ", hRowObjUpd.unwrap().name(), " WHERE RowMod = \"D\""));
         hQuery.unwrapQuery().queryOpen();
         hQuery.unwrapQuery().getFirst();
         
         LogicalOp whileClause3 = () -> hRowObjUpd.unwrapBuffer().available();
         
         doWhile("loopLabel4", whileClause3, new Block((Body) () -> 
         {
            /* This will procedure will do the Delete (looking at RowMod) */
            ControlFlowOps.invokeIn("fetchDBRowForUpdate", targetProcedure());
            
            if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
            {
               /* fetchDbRowForUpdate will return "Delete" as LAST element of the 
                          return-value if the Delete and not the FIND EXCLUSIVE-LOCK failed. */
               if (_isEqual(entry(numEntries(ControlFlowOps.getReturnValue()), ControlFlowOps.getReturnValue()), "Delete"))
               {
                  if (_isEqual(numEntries(ControlFlowOps.getReturnValue()), 2))
                  {
                     cDeleteMsg /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 23));
                  }
                  else
                  {
                     cDeleteMsg.assign(ControlFlowOps.getReturnValue());
                     cDeleteMsg.replaceEntry(numEntries(cDeleteMsg), "");
                     cDeleteMsg.replaceEntry(1, "");
                     cDeleteMsg.assign(trim(cDeleteMsg, ","));
                  }
 /* support return-value from triggers */;
               }
               else
               {
                   /* locked record */cDeleteMsg /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 18));
               }
               ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", cDeleteMsg, new unknown(), entry(1, ControlFlowOps.getReturnValue()));
               pocUndoIds.assign(concat(pocUndoIds, valueOf(hRowObjUpd.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value()), chr(3), ","));
            }
            /* END DO IF RETURN-VALUE NE "" */
            hQuery.unwrapQuery().getNext();
         }));
         
         /* END FOR EACH block */
         HandleOps.delete(hQuery);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   private void bufferProcessNew(final character pocMessages, final character pocUndoIds)
   {
      handle hRowObjUpd = TypeFactory.handle();
      handle hQuery = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObjUpd"));
         hRowObjUpd.assign(ghProp.unwrapBufferField().value());
         /*     CREATE BUFFER hRowObjUpd FOR TABLE hRowObjUpd.  */
         /* set up RowObjUpd query */
         QueryWrapper.createQuery(hQuery);
         hQuery.unwrapQuery().setBuffers(hRowObjUpd);
         hQuery.unwrapQuery().prepare(concat("FOR EACH ", hRowObjUpd.unwrap().name(), " WHERE RowMod = \"A\" OR RowMod = \"C\""));
         hQuery.unwrapQuery().queryOpen();
         
         repeat("loopLabel5", new Block((Body) () -> 
         {
            hQuery.unwrapQuery().getNext();
            
            if ((hQuery.unwrapQuery().isOffEnd()).booleanValue())
            {
               leave("loopLabel5");
            }
            
            /* This procedure will do the record Create (looking at RowMod) */
            ControlFlowOps.invokeInWithMode("assignDBRow", targetProcedure(), "I", hRowObjUpd);
            
            if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
            {
               hRowObjUpd.unwrapBuffer().bufferField("RowIdent").unwrapBufferField().changeValue(new character(""));
               hRowObjUpd.unwrapBuffer().bufferField("RowIdentIdx").unwrapBufferField().changeValue(new character(""));
               /* If BUFFER-CREATE faile because of a CREATE trigger we add return-value
                          before the table name, otherwise set the first parameter of addMessage
                          to ? to retrieve errors from error-status */
               ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", _isGreaterThan(numEntries(ControlFlowOps.getReturnValue(), chr(3)), 1) ? entry(1, ControlFlowOps.getReturnValue(), chr(3)) : new character(), new unknown(), entry(numEntries(ControlFlowOps.getReturnValue(), chr(3)), ControlFlowOps.getReturnValue(), chr(3)));
               pocUndoIds.assign(concat(pocUndoIds, valueOf(hRowObjUpd.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value()), chr(3), ","));
               undoNext("loopLabel5");
            }
 /* returns table name in error. */;
            
            /* END DO IF ERROR-STATUS:ERROR OR cErrorMsgs NE "":U */
            /* Pass back the final values to the client. Note - because we
                     want to get values changed by the db trigger, we copy *all*
                     fields, not just the ones that are enabled in the Data Object. */
            silent(() -> ControlFlowOps.invokeInWithMode("refetchDBRow", targetProcedure(), "I", hRowObjUpd));
            
            /* if a database trigger returns error it will be catched here */
            if ((ErrorManager.isError()).booleanValue())
            {
               pocUndoIds.assign(concat(pocUndoIds, valueOf(hRowObjUpd.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value()), chr(3), ","));
               ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", _isNotEqual(ControlFlowOps.getReturnValue(), "") ? ControlFlowOps.getReturnValue() : new character(), new unknown(), new unknown());
               /* Support return-value from triggers (from RefetchDbRow)*/
               undoNext("loopLabel5");
            }
         }));
         
         /* END REPEAT for Adds. */
         HandleOps.delete(hQuery);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   private void bufferProcessUpdate(final character pocMessages, final character pocUndoIds)
   {
      handle hRowObjUpd = TypeFactory.handle();
      handle hRowObjUpd2 = TypeFactory.handle();
      handle hQuery = TypeFactory.handle();
      logical lCheck = TypeFactory.logical();
      character cAsdivision = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObjUpd"));
         hRowObjUpd.assign(ghProp.unwrapBufferField().value());
         RecordBuffer.create(hRowObjUpd2, hRowObjUpd);
         /* set up RowObjUpd query */
         QueryWrapper.createQuery(hQuery);
         hQuery.unwrapQuery().setBuffers(hRowObjUpd);
         hQuery.unwrapQuery().prepare(concat("FOR EACH ", hRowObjUpd.unwrap().name(), " WHERE RowMod = \"\""));
         hQuery.unwrapQuery().queryOpen();
         
         repeat("processUpdateRecordsBlk", new Block((Body) () -> 
         {
            hQuery.unwrapQuery().getNext();
            
            if ((hQuery.unwrapQuery().isOffEnd()).booleanValue())
            {
               leave("processUpdateRecordsBlk");
            }
            
            /* For each table in the join, update its fields if on the enabled list.
                     NOTE: at present at least we don't check whether fields in this table
                     have actually been modified in this record. */
            ControlFlowOps.invokeIn("fetchDBRowForUpdate", targetProcedure());
            
            if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
            {
               ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III",  /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 18), new unknown(), ControlFlowOps.getReturnValue());
               pocUndoIds.assign(concat(pocUndoIds, valueOf(hRowObjUpd.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value()), chr(3), ","));
               undoNext("processUpdateRecordsBlk");
            }
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("CheckCurrentChanged"));
            lCheck.assign(ghProp.unwrapBufferField().value());
            
            if ((lCheck).booleanValue())
            {
               ControlFlowOps.invokeIn("compareDBRow", targetProcedure());
               
               if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
               {
                  /* {fnarg <func-name> <arg> [handle] */ 
                  ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", substitute(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 8), "" /* No field names available. */), new unknown(), ControlFlowOps.getReturnValue() /* Table name that didn't compare */);
                  pocUndoIds.assign(concat(pocUndoIds, valueOf(hRowObjUpd.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value()), chr(3), "ADM-FIELDS-CHANGED", ","));
                  /* Get the changed version of the record in order to copy
                                 the new database values into it to pass back to the client.*/
                  hRowObjUpd2.unwrapBuffer().findFirst(concat("WHERE RowMod = \"U\" AND RowNum = ", valueOf(hRowObjUpd.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value())));
                  silent(() -> ControlFlowOps.invokeInWithMode("refetchDBRow", targetProcedure(), "I", hRowObjUpd2));
                  
                  if ((ErrorManager.isError()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", _isNotEqual(ControlFlowOps.getReturnValue(), "") ? ControlFlowOps.getReturnValue() : new character(), new unknown(), new unknown());
                     /* Support return-value from triggers (from RefetchDbRow)*/
                     pocUndoIds.assign(concat(pocUndoIds, valueOf(hRowObjUpd2.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value()), chr(3), ","));
                  }
                  
                  /* If ERROR */
                  if (_isEqual(cAsdivision, "Server"))
                  {
                     pocMessages.assign(leftTrim(concat(pocMessages, chr(3), ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure())), chr(3)));
                  }
                  
                  /* Don't try to write values to db. Just process next update record. */
                  next("processUpdateRecordsBlk");
               }
 /* Table name that didn't compare is returned. */;
            }
            
            blockLabel2:
            {
               /* If we haven't 'next'ed because of an error, do the update. */
               /* Now find the changed version of the record, move its fields to the
                            database record(s) which were found above, and report any errors
                            (which would be database triggers at this point). */
               hRowObjUpd2.unwrapBuffer().findFirst(concat("WHERE RowMod = \"U\" AND RowNum = ", valueOf(hRowObjUpd.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value())));
               hRowObjUpd2.unwrapBuffer().bufferField("ChangedFields").unwrapBufferField().changeValue(hRowObjUpd.unwrapBuffer().bufferField("ChangedFields").unwrapBufferField().value());
               ControlFlowOps.invokeInWithMode("assignDBRow", targetProcedure(), "I", hRowObjUpd2);
               
               if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
               {
                  ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", new unknown(), new unknown(), ControlFlowOps.getReturnValue());
                  pocUndoIds.assign(concat(pocUndoIds, valueOf(hRowObjUpd.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value()), chr(3), ","));
                  undoNext("processUpdateRecordsBlk");
               }
 /* returns table name in error. */;
               
               /* END DO IF RETURN-VALUE NE "" */
               /* Pass back the final values to the client. Note - because we
                            want to get values changed by the db trigger, we copy *all*
                            fields, not just the ones that are enabled in the Data Object. */
               silent(() -> ControlFlowOps.invokeInWithMode("refetchDBRow", targetProcedure(), "I", hRowObjUpd2));
               
               if ((ErrorManager.isError()).booleanValue())
               {
                  ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", _isNotEqual(ControlFlowOps.getReturnValue(), "") ? ControlFlowOps.getReturnValue() : new character(), new unknown(), new unknown());
                  /* Support return-value from triggers (from RefetchDbRow)*/
                  pocUndoIds.assign(concat(pocUndoIds, valueOf(hRowObjUpd2.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value()), chr(3), ","));
               }
            }
         }));
         
         /* END FOR EACH RowObjUpd */
         HandleOps.delete(hQuery);
         HandleOps.delete(hRowObjUpd2);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: General logic for the commit/transaction hooks that does a dynmaic<br>
    *          'for each' and fires the relevant low level record hooks.<br>
    * Parameters:  pcLevel - The level/place from which this hook is fired, used to fire the <br>
    *                        correct low level hook.<br>
    *                            <br>
    *                        Pre   - Before the transaction is started<br>
    *                        Begin - At the beginning/top of transaction<br>
    *                        End   - At end of transaction<br>
    *                        Post  - After the transaction is started<br>
    * Notes:
    */
   public void bufferTransactionValidate(final character _pcLevel)
   {
      character pcLevel = TypeFactory.initInput(_pcLevel);
      handle hQuery = TypeFactory.handle();
      handle hRowObjUpd = TypeFactory.handle();
      handle hRowObjUpdBi = TypeFactory.handle();
      character cMessageList = TypeFactory.character();
      handle hReturnBuffer = TypeFactory.handle();
      character xcFixedName = TypeFactory.character("TransValidate");
      handle hLogicObject = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObjUpd"));
         hRowObjUpd.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLogicObject"));
         hLogicObject.assign(ghProp.unwrapBufferField().value());
         
         if (_not(hLogicObject.isValid()))
         {
            returnNormal();
         }
         
         RecordBuffer.create(hRowObjUpd, hRowObjUpd);
         RecordBuffer.create(hRowObjUpdBi, hRowObjUpd);
         /* set up RowObjUpd query */
         QueryWrapper.createQuery(hQuery);
         hQuery.unwrapQuery().setBuffers(hRowObjUpd);
         hQuery.unwrapQuery().prepare(concat("FOR EACH ", hRowObjUpd.unwrap().name(), " WHERE RowMod <> \"\""));
         hQuery.unwrapQuery().queryOpen();
         hQuery.unwrapQuery().getFirst();
         
         LogicalOp whileClause4 = () -> hRowObjUpd.unwrapBuffer().available();
         
         doWhile("loopLabel6", whileClause4, new Block((Body) () -> 
         {
            /* Fetch the before image of the current record if this is an update */
            if (_isEqual(hRowObjUpd.unwrapBuffer().bufferField("RowMod").unwrapBufferField().value(), "U"))
            {
               hRowObjUpdBi.unwrapBuffer().findFirst(concat("WHERE RowMod = \"\" AND RowNum = ", valueOf(hRowObjUpd.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value())));
            }
            else
            {
               hRowObjUpdBi.unwrapBuffer().bufferRelease();
            }
            
            ControlFlowOps.invokeInWithMode("setLogicBuffer", targetProcedure(), "II", hRowObjUpd, (hRowObjUpdBi.unwrapBuffer().available()).booleanValue() ? hRowObjUpdBi : new handle());
            
            if ((matchesList("A,C,U", new character(hRowObjUpd.unwrapBuffer().bufferField("RowMod").unwrapBufferField().value()))).booleanValue())
            {
               if ((matchesList("A,C", new character(hRowObjUpd.unwrapBuffer().bufferField("RowMod").unwrapBufferField().value()))).booleanValue())
               {
                  silent(() -> ControlFlowOps.invokeIn((concat("create", pcLevel, xcFixedName)).toStringMessage(), targetProcedure()));
                  
                  if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
                  {
                     cMessageList.assign(concat(cMessageList, (_isGreaterThan(numEntries(cMessageList, chr(3)), 0) ? chr(3) : new character("")), ControlFlowOps.getReturnValue()));
                  }
               }
               silent(() -> ControlFlowOps.invokeIn((concat("write", pcLevel, xcFixedName)).toStringMessage(), targetProcedure()));
               
               if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
               {
                  cMessageList.assign(concat(cMessageList, (_isGreaterThan(numEntries(cMessageList, chr(3)), 0) ? chr(3) : new character("")), ControlFlowOps.getReturnValue()));
               }
            }
            else
            {
               if (_isEqual(hRowObjUpd.unwrapBuffer().bufferField("RowMod").unwrapBufferField().value(), "D"))
               {
                  silent(() -> ControlFlowOps.invokeIn((concat("delete", pcLevel, xcFixedName)).toStringMessage(), targetProcedure()));
                  
                  if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
                  {
                     cMessageList.assign(concat(cMessageList, (_isGreaterThan(numEntries(cMessageList, chr(3)), 0) ? chr(3) : new character("")), ControlFlowOps.getReturnValue()));
                  }
               }
            }
            /* Delete */
            ControlFlowOps.invokeInWithMode("getLogicBuffer", targetProcedure(), "O", hReturnBuffer);
            hRowObjUpd.unwrapBuffer().bufferCopy(hReturnBuffer);
            ControlFlowOps.invokeIn("clearLogicRows", targetProcedure());
            hQuery.unwrapQuery().getNext();
         }));
         
         HandleOps.delete(hRowObjUpd);
         HandleOps.delete(hRowObjUpdBi);
         HandleOps.delete(hQuery);
         ErrorManager.setError(new logical(false));
         returnNormal(cMessageList);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  INPUT pcValType AS CHARACTER  "Pre", "Begin", "End", "Post"<br>
    * Notes:
    */
   public void bufferValidate(final character _pcValType)
   {
      character pcValType = TypeFactory.initInput(_pcValType);
      logical lLogicHook = TypeFactory.logical();
      logical lLocalHook = TypeFactory.logical();
      character cHook = TypeFactory.character();
      handle hLogicObject = TypeFactory.handle();
      handle hRowObjUpdTable = TypeFactory.handle();
      character cReturn = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         hRowObjUpdTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjUpdTable", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLogicObject"));
         hLogicObject.assign(ghProp.unwrapBufferField().value());
         cHook.assign(concat(pcValType, "TransactionValidate"));
         lLocalHook.assign(isGreaterThan(lookup(cHook, targetProcedure().unwrapProcedure().internalEntries()), 0));
         lLogicHook.assign(and(hLogicObject.isValid(), () -> isGreaterThan(lookup(cHook, hLogicObject.unwrapProcedure().internalEntries()), 0)));
         
         if (_and(not(lLocalHook), lLogicHook))
         {
            ControlFlowOps.invokeInWithMode("setLogicRows", targetProcedure(), "I", new TableParameter(hRowObjUpdTable));
         }
         
         ControlFlowOps.invokeIn((cHook).toStringMessage(), targetProcedure());
         cReturn.assign(ControlFlowOps.getReturnValue());
         
         if (_and(not(lLocalHook), lLogicHook))
         {
            ControlFlowOps.invokeInWithMode("getLogicRows", targetProcedure(), "O", new TableParameter(hRowObjUpdTable));
         }
         
         returnNormal(cReturn);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Calls across the AppServer boundary to serverSendRows to fetch<br>
    *              a batch of RowObject temp-table records.  When the <br>
    *              SmartDataObject is split between client and AppServer, <br>
    *              this client-side procedure is run from the generic sendRows <br>
    *              procedure.  It simply turns around and runs a server-side <br>
    *              version which returns the RowObject temp-table records.<br>
    * <p>
    * Parameters:  <br>
    *   INPUT  piStartRow     - The RowNum value of the record to start the batch<br>
    *                           to return.  Typically piStartRow is ? as a flag to <br>
    *                           use pcRowIdent instead of piStartRow.<br>
    *   INPUT  pcRowIdent     - The RowIdent of the first record of the batch to<br>
    *                           to return.  Can also be "FIRST" or "LAST" to force<br>
    *                           the retrieval of the first (or last) batch of <br>
    *                           RowObject records.<br>
    *   INPUT  plNext         - True if serverSendRows is to start on the "next"<br>
    *                           record from what is indicated by piStartRow or<br>
    *                           piRowIdent.<br>
    *   INPUT  piRowsToReturn - The number of rows in a batch.<br>
    *   OUTPUT piRowsReturned - The actual number of rows returned. This number<br>
    *                           will either be the same as piRowsToReturn or<br>
    *                           less when there are not enough records to fill<br>
    *                           up the batch.<br>
    * <p>
    * Notes:       All of the parameters are simply received from the caller and<br>
    *              passed through to serverSendRows on the AppServer.<br>
    *              If piStartRow is not 0 or ? then pcRowIdent is ignored.<br>
    *              plNext is ignored if pcRowIdent is "FIRST" or "LAST".<br>
    *              The most common use of piRowsReturned is to indicate that the<br>
    *              entire result list has been returned when it is less than <br>
    *              piRowToReturn.<br>
    *              In 9.1B, we are prepared to run in our Container's ASHandle<br>
    *              if we are in an SBO.
    */
   public void clientSendRows(final integer _piStartRow, final character _pcRowIdent_4, final logical _plNext, final integer _piRowsToReturn, final integer piRowsReturned)
   {
      integer piStartRow = TypeFactory.initInput(_piStartRow);
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      logical plNext = TypeFactory.initInput(_plNext);
      integer piRowsToReturn = TypeFactory.initInput(_piRowsToReturn);
      handle hAppServer = TypeFactory.handle();
      handle hDataQuery = TypeFactory.handle();
      handle hRowNum = TypeFactory.handle();
      handle hRowIdent = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      logical lAdded = TypeFactory.logical(true);
      rowid nextPosition = TypeFactory.rowid();
      character cLastResult = TypeFactory.character();
      character cOperatingMode = TypeFactory.character();
      logical lInitRowObject = TypeFactory.logical();
      handle hDataContainer = TypeFactory.handle();
      character cObjectName = TypeFactory.character();
      handle hRowObjectTbl = TypeFactory.handle();
      handle hAppService = TypeFactory.handle();
      character cServerFileName = TypeFactory.character();
      character cContext = TypeFactory.character();
      character cError = TypeFactory.character();
      character cPositionForClient = TypeFactory.character();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(piRowsReturned);
      }, 
      (Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         
         if ((hDataQuery.isValid()).booleanValue())
         {
            hRowObject.assign(hDataQuery.unwrapQuery().bufferHandle(1));
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("serverOperatingMode"));
         cOperatingMode.assign(ghProp.unwrapBufferField().value());
         
         if (_or(isUnknown(piStartRow), () -> isEqual(piStartRow, 0)))
         {
            /* If the query is already open then we need to get last in order to 
                   save the rowid of the last RowObject in the batch so that we can 
                   reposition appropriately after retrieving another batch below. */
            if (_and(hDataQuery.isValid(), () -> hDataQuery.unwrapQuery().isOpen()))
            {
               hDataQuery.unwrapQuery().getLast();
               
               if ((hRowObject.unwrapBuffer().available()).booleanValue())
               {
                  hRowNum.assign(hRowObject.unwrapBuffer().bufferField("RowNum"));
                  
                  loopLabel7:
                  while ((lAdded).booleanValue())
                  {
                     /* The xiAddStartRow preprocessor is used to set the row number 
                                  for newly added records, 
                                - we don't want to make this a property because using row number
                                  like this will likely change in a future release */
                     if (_isGreaterThan(hRowNum.unwrapBufferField().value(), 9000000))
                     {
                        hDataQuery.unwrapQuery().getPrevious();
                        
                        /* If only new rows, we might end up at the top.  */
                        if (_isEqual(hRowObject.unwrapBuffer().available(), false))
                        {
                           break loopLabel7;
                        }
                     }
                     else
                     {
                        lAdded.assign(false);
                     }
                  }
                  
                  /* Do while lAdded */
                  nextPosition.assign(hRowObject.unwrapBuffer().rowID());
                  
                  /* If we are running stateless we need to re-assign the LastResultRow
                             to be the RowNum and RowIdent of the RowObject record which is the 
                             last record of the batch (excluding newly added records).  This is
                             to handle cases where the last row in the batch may have been 
                             deleted.  LastResultRow is used in sendRows (when fetchNext is done) 
                             to determine which record to start at when retrieving records for 
                             the next batch.  */
                  if (_and(isEqual(cOperatingMode, "STATELESS"), () -> hRowObject.unwrapBuffer().available()))
                  {
                     hRowIdent.assign(hRowObject.unwrapBuffer().bufferField("RowIdent"));
                     cLastResult.assign(concat(hRowNum.unwrapBufferField().value(), ";", hRowIdent.unwrapBufferField().value()));
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("LastResultRow"));
                     ghProp.unwrapBufferField().changeValue(cLastResult);
                  }
               }
            }
         }
         /* If piStartRow = ? or 0 */
         /* Check if the TT is undefined (dynamically defined objects on a client will 
              get the defs from server) */
         /* {get Prop var [handle]} */ 
         hRowObjectTbl.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", targetProcedure()));
         /* get handle to pass to server call */
         lInitRowObject.assign(not(hRowObjectTbl.isValid()));
         
         /* fetchContainedRows does not handle first-time dynamic calls, so don't 
              check datacontainerhandle if the temp-table is not defined 
             (This would happen if findRowWhere or fetchRowident is called from 
              initializeObject in a dynamic SDO) */
         if (_not(lInitRowObject))
         {
            hDataContainer /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "dataContainerHandle", targetProcedure()));
         }
         
         /* If this object is in a container with its own AppServer Handle,
              then we run fetchContainedRows in that in order to retrieve this objects
              data together with all child objects data. */
         if ((hDataContainer.isValid()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
            cObjectName.assign(ghProp.unwrapBufferField().value());
            ControlFlowOps.invokeInWithMode("fetchContainedRows", hDataContainer, "IIIIIO", cObjectName, piStartRow, pcRowIdent_4, plNext, piRowsToReturn, piRowsReturned);
         }
         else
         {
            /* Checks AppServer properties to see if the object has no current or future 
                   server bindings and is using a stateless operating mode.*/
            if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasNoServerBinding", targetProcedure()))).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("connectServer", targetProcedure(), "O", hAppService);
               
               if (_isUnknown(hAppService))
               {
                  returnError("ADM-ERROR");
               }
               
               /* {get Prop var [handle]} */ 
               cServerFileName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getServerFileName", targetProcedure()));
               cContext /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForServer", targetProcedure()));
               ControlFlowOps.invokeRemoteWithMode("adm2/sendrows.p", (handle) null, hAppService, false, "IUIIIIOOO", cServerFileName, cContext, piStartRow, pcRowIdent_4, plNext, piRowsToReturn, piRowsReturned, new TableParameter(hRowObjectTbl, true), cError);
               /* Errors not used yet */
               /* {fnarg <func-name> <arg> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "applyContextFromServer", targetProcedure(), "I", cContext);
            }
            else
            {
               /* {get Prop var [handle]} */ 
               hAppServer.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getASHandle", targetProcedure()));
               
               /* use our own ASHandle. */
               if ((hAppServer.isValid()).booleanValue())
               {
                  /* New to 9.1B: get the handle of the RowObject table itself to receive
                           the temp-table from the server. If this is already defined, then
                           either this is a static SDO, or it is a dynamic one which has already
                           been initialized by going through this code. If not, then simply
                           receive the temp-table into the handle, and set the corresponding
                           SDO properties now. */
                  cContext /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForServer", targetProcedure()));
                  ControlFlowOps.invokeInWithMode("remoteSendRows", hAppServer, "UIIIIOOO", cContext, piStartRow, pcRowIdent_4, plNext, piRowsToReturn, piRowsReturned, new TableParameter(hRowObjectTbl, true), cError);
                  /* {fnarg <func-name> <arg> [handle] */ 
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "applyContextFromServer", targetProcedure(), "I", cContext);
               }
               
               /* if valid-handle(happserver)*/
               ControlFlowOps.invokeIn("endClientDataRequest", targetProcedure());
            }
            
            /* else (AsBound or stataware etc... )*/
            /* If the RowObject table handle wasn't init'd yet, we set its property 
                   to the table handle we got back and also create the RowObjUpdTable,
                   if it is undefined  */
            if ((lInitRowObject).booleanValue())
            {
               /* {set Prop value [handle]} */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectTable", targetProcedure(), "I", hRowObjectTbl);
            }
         }
         /* not client sbo  */
         /* {fnarg <func-name> <arg> [handle] */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "openDataQuery", targetProcedure(), "I", "");
         
         if (_isEqual(pcRowIdent_4, "FIRST"))
         {
            hDataQuery.unwrapQuery().getFirst();
         }
         else
         {
            if (_isEqual(pcRowIdent_4, "LAST"))
            {
               hDataQuery.unwrapQuery().getLast();
            }
            else
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("PositionForClient"));
               cPositionForClient.assign(ghProp.unwrapBufferField().value());
               
               if (_isGreaterThan(cPositionForClient, ""))
               {
                  /* {fnarg <func-name> <arg> [handle] */ 
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowObjectUseRowident", targetProcedure(), "I", cPositionForClient);
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("PositionForClient"));
                  ghProp.unwrapBufferField().changeValue(new unknown());
               }
            }
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To commit multiple DB updates<br>
    * Parameters:  pcError: Possible commit Erros<br>
    * Notes:       This is the Open Client API version of commitTransaction
    */
   public void commitData(final character pcError)
   {
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcError);
      }, 
      (Body) () -> 
      {
         /* {fn <func-name> [handle] */ 
         ControlFlowOps.invokeDynamicFunctionIn(logical.class, "Commit", targetProcedure());
         
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
         {
            pcError /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()));
            ControlFlowOps.invokeIn("undoTransaction", targetProcedure());
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     This event procedure receives the Commit "command" from a<br>
    *              Commit panel or other Commit-Source. It then invokes the Commit<br>
    *              function to actually commit the changes.  After the commit<br>
    *              function finishes, commitTransaction handles any error messages <br>
    *              by calling showDataMessages.<br>
    * <p>
    * Parameters:  &lt;none&gt;<br>
    * <p>
    * Notes:       A transaction block is opened in serverCommit (called by the<br>
    *              commit function) only if the SDO is running C/S.  That is no<br>
    *              transaction block occurs occurs on the client side of a split<br>
    *              SDO.
    */
   public void commitTransaction()
   {
      logical lSuccess = TypeFactory.logical();
      handle hSource = TypeFactory.handle();
      logical lCancel = TypeFactory.logical();
      character cSource = TypeFactory.character();
      character cDummy = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CommitSource"));
         hSource.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(hSource, sourceProcedure()))
         {
            /* Visual dataTargets subscribes to this */
            NamedEventManager.publish("confirmCommit", targetProcedure(), "U", new Object[]
            {
               lCancel
            });
            
            if ((lCancel).booleanValue())
            {
               returnNormal("ADM-ERROR");
            }
         }
         /* END IF hSource  */
         /* Continue only if no unsaved changes. */
         lSuccess /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "Commit", targetProcedure()));
         
         /* IF no errors, signal to Commit Panel to disable itself again. */
         if ((lSuccess).booleanValue())
         {
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectState", targetProcedure(), "I", "NoUpdates");
         }
         else
         {
            if (_isEqual(hSource, sourceProcedure()))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateSource"));
               cSource.assign(ghProp.unwrapBufferField().value());
               hSource.assign(handle.fromString(entry(1, cSource)));
               
               if ((hSource.isValid()).booleanValue())
               {
                  ControlFlowOps.invokeInWithMode("showDataMessagesProcedure", hSource, "O", cDummy);
               }
            }
 /* coming from commit panel */;
            returnNormal("ADM-ERROR");
         }
         /* END ELSE DO IF Not lSuccess */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Override to show potential error message   <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void connectServer(final handle phAppService)
   {
      character cMsg = TypeFactory.character();
      integer i = TypeFactory.integer();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(phAppService);
      }, 
      (Body) () -> 
      {
         silent(() -> ControlFlowOps.runSuper("connectServer", phAppService));
         
         /* Handles only one message, which is sufficent with the current appserver 
              class */
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
         {
            loopLabel8:
            for (i.assign(1); _isLessThanOrEqual(i, 5); i.increment())
            {
               if (_begins(EnvironmentOps.getSourceName(i), "commit "))
               {
                  returnError("ADM-ERROR");
               }
            }
            
            cMsg.assign(entry(1, ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()), chr(4)));
            /*{fnarg showMessage cMsg}. */
            ControlFlowOps.invokeInWithMode("showMessageProcedure", targetProcedure(), "IO", cMsg, cMsg);
            returnError("ADM-ERROR");
         }
         else
         {
            if ((ErrorManager.isError()).booleanValue())
            {
               returnError(ControlFlowOps.getReturnValue());
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Called from copyRow to move column values to the new row.<br>
    * <p>
    * Parameters:<br>
    *   INPUT pcViewColList - Comma delimited list of column names<br>
    *   INPUT phDataQuery   - Handle to the RowObject query.<br>
    * <p>
    * Notes:       copyColumns exists primarily to remove code from the function<br>
    *              copyRow, to reduce the size of the r-code action segment.
    */
   public void copyColumns(final character _pcViewColList_4, final handle _phDataQuery)
   {
      character pcViewColList_4 = TypeFactory.initInput(_pcViewColList_4);
      handle phDataQuery = TypeFactory.initInput(_phDataQuery);
      character cVals = TypeFactory.character("");
      integer iCol = TypeFactory.integer();
      handle hCol = TypeFactory.handle();
      integer iValue = TypeFactory.integer();
      character cArrayVal = TypeFactory.character();
      handle hRowObject = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         hRowObject.assign(phDataQuery.unwrapQuery().bufferHandle(1));
         
         if ((phDataQuery.unwrapQuery().isOpen()).booleanValue())
         {
            loopLabel9:
            for (iCol.assign(1); _isLessThanOrEqual(iCol, hRowObject.unwrapBuffer().numFields()); iCol.increment())
            {
               hCol.assign(hRowObject.unwrapBuffer().bufferField(iCol));
               
               /* Copy arrays a value at a time, into a CHR(1) - delimited list,
                      with array elements separated by CHR(2). */
               if (_isNotEqual(hCol.unwrapBufferField().extent(), 0))
               {
                  cArrayVal.assign("");
                  
                  loopLabel10:
                  for (iValue.assign(1); _isLessThanOrEqual(iValue, hCol.unwrapBufferField().extent()); iValue.increment())
                  {
                     cArrayVal.assign(concat(cArrayVal, (_isGreaterThan(iValue, 1) ? chr(2) : new character("")), _isUnknown(hCol.unwrapBufferField().value(iValue)) ? new character("") : hCol.unwrapBufferField().value(iValue)));
                  }
                  
                  /* END DO iValue */
                  cVals.assign(concat(cVals, (_isGreaterThan(iCol, 1) ? chr(1) : new character("")), cArrayVal));
               }
               else
               {
                  cVals.assign(concat(cVals, (_isGreaterThan(iCol, 1) ? chr(1) : new character("")), _isUnknown(hCol.unwrapBufferField().value()) ? new character("") : hCol.unwrapBufferField().value()));
               }
            }
         }
 /* Don't copy from RowObject if not used.*/         else
         {
             /* DO IF NOT IS-OPEN - get current vals from db rec */cVals /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", targetProcedure(), "I", pcViewColList_4));
         }
         /* Now create the new record */
         hRowObject.unwrapBuffer().bufferCreate();
         
         /* Move all the copied values into it. */
         if ((phDataQuery.unwrapQuery().isOpen()).booleanValue())
         {
            loopLabel11:
            for (iCol.assign(1); _isLessThanOrEqual(iCol, hRowObject.unwrapBuffer().numFields()); iCol.increment())
            {
               hCol.assign(hRowObject.unwrapBuffer().bufferField(iCol));
               
               if (_isNotEqual(hCol.unwrapBufferField().extent(), 0))
               {
                  cArrayVal.assign(entry(iCol, cVals, chr(1)));
                  
                  loopLabel12:
                  for (iValue.assign(1); _isLessThanOrEqual(iValue, hCol.unwrapBufferField().extent()); iValue.increment())
                  {
                     hCol.unwrapBufferField().changeValue(iValue, entry(iValue, cArrayVal, chr(2)));
                  }
               }
               else
               {
                  silent(() -> hCol.unwrapBufferField().changeValue(entry(iCol, cVals, chr(1))));
               }
            }
         }
         /* END DO iCol   */
         /* set RowNum, RowIdent and navigation Properties etc*/
         /* {fnarg <func-name> <arg> [handle] */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "newRowObject", targetProcedure(), "I", "Copy");
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void createData(final character _pcColumnNames, final character pcNewValues, final character pcError)
   {
      character pcColumnNames = TypeFactory.initInput(_pcColumnNames);
      character cNewValueList = TypeFactory.character();
      integer iLoop = TypeFactory.integer();
      character cDataDelimiter = TypeFactory.character();
      handle hRowObject = TypeFactory.handle();
      handle hCol = TypeFactory.handle();
      logical lSave = TypeFactory.logical();
      character cUpdatableColumns = TypeFactory.character();
      character cColumn = TypeFactory.character();
      integer iColumn = TypeFactory.integer();
      character cNewValue = TypeFactory.character();
      character cDataReadFormat = TypeFactory.character();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcError);
      }, 
      (Body) () -> 
      {
         ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "addRow", targetProcedure(), "I", "");
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataReadFormat"));
         cDataReadFormat.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataDelimiter"));
         cDataDelimiter.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         cUpdatableColumns.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdatableColumns", targetProcedure()));
         
         loopLabel13:
         for (iLoop.assign(1); _isLessThanOrEqual(iLoop, numEntries(cUpdatableColumns)); iLoop.increment())
         {
            silent(() -> 
            {
               hCol.setUnknown();
               cColumn.assign(entry(iLoop, cUpdatableColumns));
               iColumn.assign(lookup(cColumn, pcColumnNames));
               hCol.assign(hRowObject.unwrapBuffer().bufferField(cColumn));
            });
            
            if (_and(hCol.isValid(), () -> isGreaterThan(iColumn, 0)))
            {
               cNewValue.assign(entry(iColumn, pcNewValues, cDataDelimiter));
               cNewValueList.assign(concat(cNewValueList, (_isEqual(cNewValueList, "") ? new character("") : chr(1)), cColumn, chr(1), (_notUnknown(cNewValue) ? cNewValue : new character("?"))));
            }
         }
         
         lSave.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "submitRow", targetProcedure(), "II", valueOf(hRowObject.unwrapBuffer().rowID()), cNewValueList));
         
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
         {
            pcError /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()));
         }
         
         pcNewValues.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colStringValues", targetProcedure(), "III", pcColumnNames, cDataReadFormat, cDataDelimiter));
         
         if (_not(lSave))
         {
            ControlFlowOps.invokeDynamicFunctionIn(character.class, "cancelRow", targetProcedure());
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:    Define the temp-tables for a dynamic SDO   <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:      This is in createObjects because this is the common API that<br>
    *             should be used to realize objects for design time use.
    */
   public void createObjects()
   {
      character cBindScope = TypeFactory.character();
      handle hContainer = TypeFactory.handle();
      character cAsdivision = TypeFactory.character();
      character cCalculatedColumns = TypeFactory.character();
      handle hLogicObject = TypeFactory.handle();
      logical lDefined = TypeFactory.logical();
      logical lDynamicData = TypeFactory.logical();
      logical lOpenOnInit = TypeFactory.logical();
      logical lInitialized = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAsDivision", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DynamicData"));
         lDynamicData.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitialized.assign(ghProp.unwrapBufferField().value());
         
         if ((lInitialized).booleanValue())
         {
            returnNormal();
         }
         
         /* If client and OpenOnInit then we will get the table from the server */
         if (_isEqual(cAsdivision, "CLIENT"))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("OpenOnInit"));
            lOpenOnInit.assign(ghProp.unwrapBufferField().value());
            
            /* No need to do more here it will be done on the server */
            if ((lOpenOnInit).booleanValue())
            {
               returnNormal();
            }
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLogicObject"));
            hLogicObject.assign(ghProp.unwrapBufferField().value());
            
            if (_and(not(hLogicObject.isValid()), () -> not(gshRepositoryManager.isValid())))
            {
               /* {get Prop var [handle]} */ 
               cCalculatedColumns.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getCalculatedColumns", targetProcedure()));
               
               if (_isGreaterThan(cCalculatedColumns, ""))
               {
                  /* In design mode where the SDO is running standalone we need to 
                            get the definitions here. We use BindScope <> 'data' to identify 
                            that createobjects is called directly and not from initializeObject. 
                            If we are in a container we the SBO's createObjects handles this.
                           (initializeObject will call fetchDefinitions for non-container runtime 
                            cases) */
                  /* {get Prop var [handle]} */ 
                  cBindScope.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getBindScope", targetProcedure()));
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                  hContainer.assign(ghProp.unwrapBufferField().value());
                  
                  if (_and(isNotEqual(cBindScope, "Data"), () -> not(hContainer.isValid())))
                  {
                     silent(() -> ControlFlowOps.invokeIn("fetchDefinitions", targetProcedure()));
                     
                     if (_or(ErrorManager.isError(), () -> isNotEqual(ControlFlowOps.getReturnValue(), "")))
                     {
                        returnError((_isEqual(ControlFlowOps.getReturnValue(), "") ? ErrorManager.getErrorText(1) : ControlFlowOps.getReturnValue()));
                     }
                  }
                  else
                  {
                     returnNormal();
                  }
               }
            }
         }
         else
         {
 /* db connected, create buffers queries etc..*/
            ControlFlowOps.runSuper("createObjects");
         }
         
         /* Dynamic */
         if ((lDynamicData).booleanValue())
         {
            lDefined /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "createRowObjectTable", targetProcedure()));
         }
         else
         {
            if ((gshRepositoryManager.isValid()).booleanValue())
            {
               lDefined /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "prepareColumnsFromRepos", targetProcedure()));
            }
            else
            {
               lDefined.assign(true);
            }
         }
         
         if (_not(lDefined))
         {
            returnError("ADM-ERROR");
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Event procedure that handles change of dataSource data or record <br>
    *           position or change of this object's data or record position by <br>
    *           assigning new ForeignFields values and reopen the query, resetting <br>
    *           QueryPosition and republish the event.   <br>
    * Parameters:<br>
    *   INPUT pcRelative - A flag to indicate something about the "new" or "changed"<br>
    *                      current record.                                       <br>
    *     SAME          - do nothing .. simply RETURN, because the new record is the <br>
    *                     same as the current record.                            <br>
    *     RESET         - Request to reset statuses and foreignfields and refresh<br>
    *                     visual objects and panels in all objects in the data-link <br>
    *                     chain. This was introduced in 9.1C because in some cases <br>
    *                     'same' does too little and 'different' too much. <br>
    *                     It achieves the same as 'different' except that queries <br>
    *                     will NOT be reopened.   <br>
    *     VALUE-CHANGED - dataTarget changed position, <br>
    *                     Ensure that the query is not reopened here, but publish <br>
    *                     as 'different' from here, so this objects data targets  <br>
    *                     will be opened.<br>
    *     DIFFERENT     - Request to reapply foreign Fields.  <br>
    *                    (except if called from a dataTarget where it is treated as <br>
    *                    'VALUE-CHANGED')   <br>
    *     ?             - Workaround used to apply Foreign Fields when caller not <br>
    *                     was dataSource. This is kept for backwards compatibility <br>
    *                     as 'DIFFERENT' now does the same.        <br>
    *                      <br>
    *     FIRST         - as 'different'<br>
    *     NEXT          - as 'different'<br>
    *     PREV          - as 'different'<br>
    *     LAST          - as 'different'<br>
    *     REPOSITIONED  - as 'different'<br>
    *                                       <br>
    * Notes: - From 9.1C the dataTarget will pass 'VALUE-CHANGED' to indicate<br>
    *          a change that don't need to reapply foreign fields. <br>
    *             <br>
    *        - This makes dataAvailable self-contained as there is no longer a <br>
    *          need to check who the source is. This was done to add support for <br>
    *          SBOs as dataSources.  <br>
    *          <br>
    *       -  However, we still check the source to support backwards compatibility,<br>
    *          and deal with data-targets passing 'different' and treat this case <br>
    *          as 'VALUE-CHANGED'.
    */
   public void dataAvailable(final character _pcRelative)
   {
      character pcRelative = TypeFactory.initInput(_pcRelative);
      character cForeignFields = TypeFactory.character();
      character cDataTarget = TypeFactory.character();
      logical lInitted = TypeFactory.logical();
      character cRowObjectState = TypeFactory.character();
      handle hContainer = TypeFactory.handle();
      logical lOpen = TypeFactory.logical();
      character cSourceFields = TypeFactory.character();
      character cLocalFields = TypeFactory.character();
      character cValues = TypeFactory.character();
      handle hDataSource = TypeFactory.handle();
      integer iField = TypeFactory.integer();
      handle hRowObject = TypeFactory.handle();
      character cAsdivision = TypeFactory.character();
      logical lFound = TypeFactory.logical();
      character cNewBatchInfo = TypeFactory.character();
      logical lOneToOne = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitted.assign(ghProp.unwrapBufferField().value());
         
         /* Ignore if we haven't been initialized yet; also, 
              if for some reason this object is in addmode.
             (Called from cancelRow in the first of two SDOs in SBOs for example) 
              updated row (pcRelative = 'SAME') requires no reset.*/
         if (_or(not(lInitted), () -> isEqual(pcRelative, "SAME")))
         {
            returnNormal();
         }
         
         /* {get Prop var [handle]} */ 
         cForeignFields.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getForeignFields", targetProcedure()));
         
         /* For backwards Compatibility we still deal with 'different' calls 
              from DataTargets as a request to NOT reapply ForeignFields. */
         if (_isEqual(pcRelative, "DIFFERENT"))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
            cDataTarget.assign(ghProp.unwrapBufferField().value());
            
            if ((matchesList(cDataTarget, valueOf(sourceProcedure()))).booleanValue())
            {
               pcRelative.assign("VALUE-CHANGED");
            }
         }
         else
         {
            if (_isUnknown(pcRelative))
            {
               pcRelative.assign("DIFFERENT");
            }
            else
            {
               if (_isEqual(pcRelative, "RESET"))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("OpenOnInit"));
                  lOpen.assign(ghProp.unwrapBufferField().value());
                  
                  if (_not(lOpen))
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                     hContainer.assign(ghProp.unwrapBufferField().value());
                     
                     if ((hContainer.isValid()).booleanValue())
                     {
                        lOpen.assign(not(new logical( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(logical.class, "isFetchPending", hContainer))));
                     }
                     else
                     {
                        lOpen.assign(true);
                     }
                  }
                  
                  if ((lOpen).booleanValue())
                  {
                     /* {get Prop var [handle]} */ 
                     cRowObjectState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", targetProcedure()));
                     
                     /* there are logic in query.p that makes this into 'reset' again 
                              if the source is in newMode or not available */
                     if (_and(isEqual(cRowObjectState, "NoUpdates"), () -> new logical(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasForeignKeyChanged", targetProcedure()))) /* {fn <func-name> [handle] */)
                     {
                        pcRelative.assign("DIFFERENT");
                     }
                  }
               }
            }
         }
         /* reset */
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateFromSource"));
         lOneToOne.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         
         if (_and(lOneToOne, () -> isNotEqual(cAsdivision, "SERVER")))
         {
            /* {get Prop var [handle]} */ 
            hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
            
            loopLabel14:
            for (iField.assign(1); _isLessThanOrEqual(iField, numEntries(cForeignFields)); iField.assign(plus(iField, 2)))
            {
               cLocalFields.assign(concat(cLocalFields, (_isNotEqual(cLocalFields, "") ? new character(",") : new character("")), entry(iField, cForeignFields)));
               cSourceFields.assign(concat(cSourceFields, (_isNotEqual(cSourceFields, "") ? new character(",") : new character("")), entry(plus(iField, 1), cForeignFields)));
            }
            
            ghTargetProcedure.assign(targetProcedure());
            silent(() -> cValues /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", hDataSource, "I", cSourceFields)));
            ghTargetProcedure.setUnknown();
            
            /* Throw away the RowIdent entry returned by colValues*/
            if (_notUnknown(cValues))
            {
               cValues.assign(substring(cValues, plus(indexOf(cValues, chr(1)), 1)));
            }
            
            lFound.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowObjectWhere", targetProcedure(), "IIII", cLocalFields, cValues, "", "FIRST"));
            
            /* ? is treated as FALSE */
            if (_not(isEqual(lFound, true)))
            {
               /* if the 1-to-1 child is not found, release the current RowObject */
               if ((hRowObject.isValid()).booleanValue())
               {
                  hRowObject.unwrapBuffer().bufferRelease();
               }
               
               if (_isEqual(cAsdivision, "CLIENT"))
               {
                  pcRelative.assign("VALUE-CHANGED");
               }
               else
               {
                  ghProp.assign(handle.fromString(entry(1, hDataSource.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
                  cNewBatchInfo.assign(ghProp.unwrapBufferField().value());
                  
                  if (_isEqual(cNewBatchInfo, ""))
                  {
                     pcRelative.assign("VALUE-CHANGED");
                  }
               }
            }
            else
            {
               pcRelative.assign("VALUE-CHANGED");
            }
         }
         
         if (_and(isNotEqual(cForeignFields, ""), () -> isNotEqual(pcRelative, "VALUE-CHANGED")))
         {
            ControlFlowOps.runSuper("dataAvailable", pcRelative);
            
            if (_and(lOneToOne, () -> isNotEqual(cAsdivision, "SERVER")))
            {
               lFound.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowObjectWhere", targetProcedure(), "IIII", cLocalFields, cValues, "", "FIRST"));
               
               /* ? is treated as FALSE */
               if (_not(isEqual(lFound, true)))
               {
                  /* if the 1-to-1 child is not found, release the current RowObject */
                  if ((hRowObject.isValid()).booleanValue())
                  {
                     hRowObject.unwrapBuffer().bufferRelease();
                  }
               }
            }
         }
         else
         {
            ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
            
            /* 'Value-changed' from a data target has told us not to reapply Foreign 
                    Fields, but we need to pass this as 'DIFFERENT' to our targets.
                   (We could probably always have passed 'DIFFERENT') */
            if (_isEqual(pcRelative, "VALUE-CHANGED"))
            {
               pcRelative.assign("DIFFERENT");
            }
            
            NamedEventManager.publish("DataAvailable", targetProcedure(), "I", new Object[]
            {
               pcRelative
            });
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
            ghProp.unwrapBufferField().changeValue(new character(""));
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void deleteData(final character _pcColumnNames, final character _pcOldValues, final character pcError)
   {
      character pcColumnNames = TypeFactory.initInput(_pcColumnNames);
      character pcOldValues = TypeFactory.initInput(_pcOldValues);
      character cKeyFields = TypeFactory.character();
      character cKeyValues = TypeFactory.character();
      integer iLoop = TypeFactory.integer();
      integer iField = TypeFactory.integer();
      character cKey = TypeFactory.character();
      character cValue = TypeFactory.character();
      character cDataDelimiter = TypeFactory.character();
      handle hRowObject = TypeFactory.handle();
      logical lNoKeyFields = TypeFactory.logical();
      logical lFound = TypeFactory.logical();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcError);
      }, 
      (Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cKeyFields.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getKeyFields", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataDelimiter"));
         cDataDelimiter.assign(ghProp.unwrapBufferField().value());
         
         loopLabel15:
         for (iLoop.assign(1); _isLessThanOrEqual(iLoop, numEntries(cKeyFields)); iLoop.increment())
         {
            cKey.assign(entry(iLoop, cKeyFields));
            iField.assign(lookup(cKey, pcColumnNames));
            
            if (_isEqual(iField, 0))
            {
               lNoKeyFields.assign(true);
               break loopLabel15;
            }
            
            cValue.assign(entry(iField, pcOldValues, cDataDelimiter));
            cKeyValues.assign(concat(cKeyValues, (_isEqual(iLoop, 1) ? new character("") : chr(1)), cValue));
         }
         
         if ((lNoKeyFields).booleanValue())
         {
            iField.assign(lookup("RowIdent", pcColumnNames));
            
            if (_isEqual(iField, 0))
            {
               pcError.assign(concat("Missing one or some of the '", replaceAll(cKeyFields, ",", " "), "' or RowIdent in list of columnns."));
               returnNormal();
            }
            
            cValue.assign(entry(iField, pcOldValues, cDataDelimiter));
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         
         /* Currently we need the RowObject with all fields from the db */
         if ((lNoKeyFields).booleanValue())
         {
            ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "fetchRowident", targetProcedure(), "II", cValue, "");
            silent(() -> lFound.assign(isEqual(cValue, hRowObject.unwrapBuffer().bufferField("Rowident").unwrapBufferField().value())));
         }
         else
         {
            lFound.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowWhere", targetProcedure(), "III", cKeyFields, cKeyValues, "="));
         }
         
         if ((lFound).booleanValue())
         {
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "deleteRow", targetProcedure(), "I", valueOf(hRowObject.unwrapBuffer().rowID()));
         }
         else
         {
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "addNotFoundMessage", targetProcedure(), "III", (lNoKeyFields).booleanValue() ? new character("ROWIDENT") : cKeyFields, (lNoKeyFields).booleanValue() ? cValue : cKeyValues, "=");
         }
         
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
         {
            pcError /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()));
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void describeSchema(final character _pcIndexFieldList, final TableParameter _hTtSchema)
   {
      character pcIndexFieldList = TypeFactory.initInput(_pcIndexFieldList);
      handle hTtSchema = new handle();
      integer iCol = TypeFactory.integer();
      handle hRowObject = TypeFactory.handle();
      handle hColumn = TypeFactory.handle();
      character cUpdatableColumnList = TypeFactory.character();
      character cColumnsByTable = TypeFactory.character();
      character cTableList = TypeFactory.character();
      integer iTable = UndoableFactory.integer();
      integer iColumn = UndoableFactory.integer();
      integer iColumnSequence = UndoableFactory.integer();
      integer iIndexSequence = TypeFactory.integer();
      integer iIdxFldSeq = TypeFactory.integer();
      character cColumnsForThisTable = UndoableFactory.character();
      character cCalculatedColumns = TypeFactory.character();
      character cDbnames = TypeFactory.character();
      character cWordIndexedFields = TypeFactory.character();
      character cIndexInformation = TypeFactory.character();
      character cTableIndex = TypeFactory.character();
      character cThisIndex = TypeFactory.character();
      character cLogicalSdoname = TypeFactory.character();
      character cFieldName = TypeFactory.character();
      integer iSdoOrder = TypeFactory.integer();
      handle hContainer = TypeFactory.handle();
      character cDataObjectHandles = TypeFactory.character();
      character cSdoOrder = TypeFactory.character();
      
      internalProcedure(new Block((Init) () -> 
      {
         UndoableFactory.initOutput(hTtSchema);
      }, 
      (Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_hTtSchema, hTtSchema, false, true);
         ttschema.deleteAll();
         hTtSchema.assign(TempTableBuilder.asHandle(ttschema));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("Tables"));
         cTableList.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
         cLogicalSdoname.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         cUpdatableColumnList.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdatableColumns", targetProcedure()));
         /* {get Prop var [handle]} */ 
         cDbnames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDBNames", targetProcedure()));
         /* {get Prop var [handle]} */ 
         cCalculatedColumns.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getCalculatedColumns", targetProcedure()));
         /* {get Prop var [handle]} */ 
         cWordIndexedFields.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getWordIndexedFields", targetProcedure()));
         /* {get Prop var [handle]} */ 
         cIndexInformation.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getIndexInformation", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataColumnsByTable"));
         cColumnsByTable.assign(ghProp.unwrapBufferField().value());
         
         if (_or(isEqual(cLogicalSdoname, ""), () -> isUnknown(cLogicalSdoname)))
         {
            cLogicalSdoname.assign(targetProcedure().unwrapFile().getFileName());
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         
         if (_and(hContainer.isValid(), () -> new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "instanceOf", hContainer, "I", "SmartBusinessObject"))) /* {fnarg <func-name> <arg> [handle] */)
         {
            /* {get Prop var [handle]} */
            cDataObjectHandles.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getContainedDataObjects", hContainer));
            /* {get Prop var [handle]} */
            cSdoOrder.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectOrdering", hContainer));
            iSdoOrder.assign(new integer(entry(lookup(valueOf(targetProcedure()), cDataObjectHandles), cSdoOrder)));
         }
         else
         {
            iSdoOrder.assign(1);
         }
         
         loopLabel16:
         for (iCol.assign(1); _isLessThanOrEqual(iCol, hRowObject.unwrapBuffer().numFields()); iCol.increment())
         {
            hColumn.assign(hRowObject.unwrapBuffer().bufferField(iCol));
            
            /* If the buffer-field is not in the list of fields we want, */
            /* or if it is a calculated field, then skip it */
            if (_or(not(matchesList(pcIndexFieldList, hColumn.unwrap().name())), () -> matchesList(cCalculatedColumns, hColumn.unwrap().name())))
            {
               continue loopLabel16;
            }
            
            ttschema.create();
            batch(() -> 
            {
               ttschema.setSdoName(cLogicalSdoname);
               ttschema.setColumnSequence(iCol);
               ttschema.setColumnCaseSensitive(hColumn.unwrapBufferField().caseSensitive());
               ttschema.setColumnDatatype(hColumn.unwrapCommonField().getDataType());
               ttschema.setColumnFormat(hColumn.unwrapCommonField().getFormat());
               ttschema.setColumnLabel(hColumn.unwrapCommonField().getColumnLabel());
               ttschema.setColumnMandatory(hColumn.unwrapBufferField().mandatory());
               ttschema.setColumnName(hColumn.unwrap().name());
               ttschema.setColumnWidthChars(hColumn.unwrapSizeable().getWidthChars());
               ttschema.setColumnUpdatable(isGreaterThan(lookup(hColumn.unwrap().name(), cUpdatableColumnList), 0));
               ttschema.setAdmColumn(isGreaterThan(lookup(hColumn.unwrap().name(), "RowIdent,RowMod,RowNum"), 0));
               ttschema.setCalculatedField(isGreaterThan(lookup(hColumn.unwrap().name(), cCalculatedColumns), 0));
               ttschema.setWordIndex(isGreaterThan(lookup(hColumn.unwrap().name(), cWordIndexedFields), 0));
               ttschema.setColumnIndexed(ttschema.isWordIndex());
               ttschema.setSdoOrder(iSdoOrder);
               ttschema.setSdoHandle(new handle(targetProcedure()));
            });
         }
         
         iIndexSequence.assign(1);
         iColumnSequence.assign(0);
         
         loopLabel17:
         for (iTable.assign(1); _isLessThanOrEqual(iTable, numEntries(cTableList)); iTable.increment())
         {
            cTableIndex.assign("");
            cColumnsForThisTable.assign(entry(iTable, cColumnsByTable, ";"));
            
            if (_isGreaterThanOrEqual(numEntries(cIndexInformation, chr(2)), iTable))
            {
               cTableIndex.assign(entry(iTable, cIndexInformation, chr(2)));
            }
            
            IntegerExpression resExpr0 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cColumnsForThisTable);
               }
            };
            ToClause toClause0 = new ToClause(iColumn, 1, resExpr0);
            
            doTo("loopLabel18", toClause0, new Block((Body) () -> 
            {
               silent(() -> new FindQuery(ttschema, "upper(ttschema.columnName) = ?", null, "ttschema.columnName asc", new Object[]
               {
                  (P2JQuery.Parameter) () -> toUpperCase(entry(iColumn, cColumnsForThisTable))
               }).first());
               
               if (ttschema._available())
               {
                  cFieldName /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnDBColumn", targetProcedure(), "I", ttschema.getColumnName()));
                  cFieldName.assign(entry(numEntries(cFieldName, "."), cFieldName, "."));
                  batch(() -> 
                  {
                     iColumnSequence.assign(plus(iColumnSequence, 1));
                     ttschema.setDatabaseName(entry(iTable, cDbnames));
                     ttschema.setTableName(entry(iTable, cTableList));
                     ttschema.setTableLabel(entry(iTable, cTableList));
                     ttschema.setFieldName(cFieldName);
                     ttschema.setTableSequence(iTable);
                  });
               }
            }));
            
            /* Now go through the indexes by table, find the TT record and assign index related info  */
            if (_isNotEqual(cTableIndex, ""))
            {
               loopLabel19:
               for (iCol.assign(1); _isLessThanOrEqual(iCol, numEntries(cTableIndex, chr(1))); iCol.increment())
               {
                  cThisIndex.assign(entry(iCol, cTableIndex, chr(1)));
                  iIdxFldSeq.assign(0);
                  
                  loopLabel20:
                  for (iColumn.assign(5); _isLessThanOrEqual(iColumn, numEntries(cThisIndex)); iColumn.increment())
                  {
                     silent(() -> new FindQuery(ttschema, "upper(ttschema.columnName) = ?", null, "ttschema.columnName asc", new Object[]
                     {
                        (P2JQuery.Parameter) () -> toUpperCase(entry(iColumn, cThisIndex))
                     }).first());
                     
                     if (ttschema._available())
                     {
                        batch(() -> 
                        {
                           iIdxFldSeq.assign(plus(iIdxFldSeq, 1));
                           ttschema.setColumnIndexed(new logical(true));
                           ttschema.setIndexPosition(concat(ttschema.getIndexPosition(), (_isEqual(ttschema.getIndexPosition(), "") ? new character("") : new character(",")), valueOf(iIndexSequence), ".", valueOf(iIdxFldSeq)));
                        });
                     }
                  }
                  
                  iIndexSequence.assign(plus(iIndexSequence, 1));
               }
            }
         }
         
         AdaptiveQuery query0 = new AdaptiveQuery();
         
         forEach("loopLabel21", new Block((Init) () -> 
         {
            query0.initialize(ttschema, "upper(ttschema.indexPosition) = ''", null, "ttschema.sdoName asc, ttschema.columnSequence asc");
         }, 
         (Body) () -> 
         {
            /* Lastly, mark all with no index as "None" */
            query0.next();
            ttschema.setIndexPosition(new character("None"));
         }));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void destroyCache()
   {
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DestroyStateless"));
         ghProp.unwrapBufferField().changeValue(new logical(true));
         ControlFlowOps.invokeIn("destroyObject", targetProcedure());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  override to get rid of the datalogicobject    <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void destroyObject()
   {
      handle hObject = TypeFactory.handle();
      handle hRowObjectTable = TypeFactory.handle();
      handle hRowObjUpdTable = TypeFactory.handle();
      logical lExternal = TypeFactory.logical();
      character cDivision = TypeFactory.character();
      logical lInitialized = TypeFactory.logical();
      handle hDataHandle = TypeFactory.handle();
      logical lDestroyStateless = TypeFactory.logical();
      character cName = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         NamedEventManager.publish("unRegisterObject", targetProcedure());
         /* {get Prop var [handle]} */ 
         cDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitialized.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataHandle.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLogicObject"));
         hObject.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("IsRowObjectExternal"));
         lExternal.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DestroyStateless"));
         lDestroyStateless.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
         cName.assign(ghProp.unwrapBufferField().value());
         
         /* if this object is remotely run (ie RUN... ON <AppserverHandle>) */
         /* we must *not* keep it alive because it will lock the Appserver agent */
         if (_and(and(or(isEqual(cDivision, "SERVER"), () -> isEqual(LogicalTerminal.getClientType(), "WEBSPEED")), not(lDestroyStateless)), () -> not(targetProcedure().unwrapProcedure().isRemote())))
         {
            /* reset and go to sleep */
            ControlFlowOps.invokeIn("removeAllLinks", targetProcedure());
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setObjectHidden", targetProcedure(), "I", true);
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectState", targetProcedure(), "I", "NoUpdates");
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setForeignFields", targetProcedure(), "I", "");
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
            ghProp.unwrapBufferField().changeValue(new unknown());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataReadHandler"));
            ghProp.unwrapBufferField().changeValue(new unknown());
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryWhere", targetProcedure(), "I", "");
            
            /* In a WEBSPEED session we need to empty the RowObject TT *and* reset */
            /* the batch control properties. In all other session types resetting  */
            /* the batch control properties is enough */
            if (_isEqual(LogicalTerminal.getClientType(), "WEBSPEED"))
            {
               /* {fnarg <func-name> <arg> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "emptyRowObject", targetProcedure(), "I", "Reset");
            }
            else
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
               ghProp.unwrapBufferField().changeValue(new unknown());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
               ghProp.unwrapBufferField().changeValue(new unknown());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstResultRow"));
               ghProp.unwrapBufferField().changeValue(new unknown());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("LastResultRow"));
               ghProp.unwrapBufferField().changeValue(new unknown());
            }
            
            /* set wake-up event */
            NamedEventManager.subscribeAnywhere(targetProcedure(), concat("searchCache", cName), "returnObjectHandle");
            /* set cache shutdown event */
            NamedEventManager.subscribeAnywhere(targetProcedure(), "destroyCache");
            returnNormal();
         }
         else
         {
            if ((hObject.isValid()).booleanValue())
            {
               HandleOps.delete(hObject);
            }
            
            /* Only delete the RowObjUpd if it's the Client version. 
                   The server-side RowObjUpd is returned back to the client 
                   AFTER destroyObject is run so it cannot be deleted explicitly here 
                   if not initialized then then this is a master started with startdataObject */
            if (_or(isNotEqual(cDivision, "Server"), not(lInitialized)))
            {
               /* {get Prop var [handle]} */ 
               hRowObjUpdTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjUpdTable", targetProcedure()));
               silent(() -> HandleOps.delete(hRowObjUpdTable));
            }
            
            if (_not(lExternal))
            {
               /* {get Prop var [handle]} */ 
               hRowObjectTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", targetProcedure()));
               silent(() -> HandleOps.delete(hRowObjectTable));
            }
            
            /* delete the RowObject Query (in case it is dynamic) */
            silent(() -> HandleOps.delete(hDataHandle));
            ControlFlowOps.runSuper("destroyObject");
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: Validation hook for code to be executed in the transaction after the <br>
    *          updates have been done. <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void endTransactionValidate()
   {
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.invokeInWithMode("bufferTransactionValidate", targetProcedure(), "I", new character("end"));
         returnNormal(ControlFlowOps.getReturnValue());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Eports the contents of the SDO to an external source/tool <br>
    * Parameters:  input 'Excel' or 'Crystal'.<br>
    *              input field list or leave blank for all (no table prefix)<br>
    *              input include object fields yes/no<br>
    *              input use existing running excel yes/no<br>
    *              input maximum records to process<br>
    * Notes:    -  The external tool's exportData will do a call back to the SDO's<br>
    *              tableout procedure for the actual retrieval of the data.    <br>
    *           -  Always excludes rowobject specific fields,<br>
    *              e.g. RowNum,RowIdent,RowMod
    */
   public void exportData(final character _pcExportType, final character _pcFieldList, final logical _plIncludeObj, final logical _plUseExisting, final integer _piMaxRecords)
   {
      character pcExportType = TypeFactory.initInput(_pcExportType);
      character pcFieldList = TypeFactory.initInput(_pcFieldList);
      logical plIncludeObj = TypeFactory.initInput(_plIncludeObj);
      logical plUseExisting = TypeFactory.initInput(_plUseExisting);
      integer piMaxRecords = TypeFactory.initInput(_piMaxRecords);
      handle hObject = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         OnPhrase[] onPhrase1 = new OnPhrase[]
         {
            new OnPhrase(Condition.STOP, Action.LEAVE, "blockLabel3")
         };
         
         doBlock(TransactionType.SUB, "blockLabel3", onPhrase1, new Block((Body) () -> 
         {
            ControlFlowOps.invokePersistentSet("adm2/exportdata.p", hObject);
         }));
         
         if ((hObject.isValid()).booleanValue())
         {
            ControlFlowOps.invokeInWithMode("exportData", hObject, "IIIIII", targetProcedure(), pcExportType, pcFieldList, plIncludeObj, plUseExisting, piMaxRecords);
            ControlFlowOps.invokeIn("destroyObject", hObject);
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To transfer another "batch" of rows from the database query to <br>
    *              the RowObject Temp-Table query, without changing the current <br>
    *              record position.<br>
    * Parameters:<br>
    *   INPUT plForwards - TRUE if we should retrieve a batch of rows after the current rows,<br>
    *                      FALSE if before.<br>
    * Notes:       Run from a Browser to get another batch of rows from the database<br>
    *              query appended to the RowObject temp-table query (when the <br>
    *              browser scrolls to the end).<br>
    *              fetchBatch does some checking and sets up the proper parameters<br>
    *              to sendRows, but sendRows is called to do the actual work.
    */
   public void fetchBatch(final logical _plForwards)
   {
      logical plForwards = TypeFactory.initInput(_plForwards);
      handle hDataQuery = TypeFactory.handle();
      integer iRowsReturned = TypeFactory.integer();
      integer iLastRow = TypeFactory.integer();
      integer iFirstRow = TypeFactory.integer();
      integer iRowsToBatch = TypeFactory.integer();
      character cRowState = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
         iLastRow.assign(ghProp.unwrapBufferField().value());
         
         if (_and(notUnknown(iLastRow), plForwards))
         {
            /* In case not already set, set it.*/
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryPosition", targetProcedure(), "I", "LastRecord");
            returnNormal();
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
         iFirstRow.assign(ghProp.unwrapBufferField().value());
         
         if (_and(notUnknown(iFirstRow), not(plForwards)))
         {
            /* In case not already set, set it.*/
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryPosition", targetProcedure(), "I", "FirstRecord");
            returnNormal();
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         
         if (_not(hDataQuery.unwrapQuery().isOpen()) /* sanity check. */)
         {
            returnNormal();
         }
         
         /* {get Prop var [handle]} */ 
         cRowState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", targetProcedure()));
         
         if (_isEqual(cRowState, "RowUpdated"))
         {
            /* if updates are in progress, can not continue */
            /*DYNAMIC-FUNCTION("showMessage":U IN TARGET-PROCEDURE, "17":U).*/
            ControlFlowOps.invokeInWithMode("showmessageprocedure", targetProcedure(), "IO", new character("17"), glShowMessageAnswer);
            returnNormal();
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowsToBatch"));
         iRowsToBatch.assign(ghProp.unwrapBufferField().value());
         /* Don't repos., just get more rows. */
         /* no RowIdent specified to repos to */
         /* Do a Next before getting more rows */
         /* Signal whether to move forward or back */
         ControlFlowOps.invokeInWithMode("sendRows", targetProcedure(), "IIIIO", new unknown(), new unknown(), new logical(true), (plForwards).booleanValue() ? new int64(iRowsToBatch) : negate(iRowsToBatch), iRowsReturned);
         
         if (_isNotEqual(iRowsReturned, 0))
         {
            NamedEventManager.publish("assignMaxGuess", targetProcedure(), "I", new Object[]
            {
               iRowsReturned
            });
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:   Fetch definitions from server  <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:     Retrieves the rowobject for dynamic objects when openOnInit <br>
    *            is false. It also retrieves other definitional properties like <br>
    *            Tables, DbNames, IndexInformation and BaseQuery<br>
    *          - Dynamics will call this also for static objects when openOninit <br>
    *            is false to ensure that Repository field definitions are applied<br>
    *            to the rowobject table.<br>
    *          - This should not be called when IsFetchPending as the DataContainer<br>
    *            will handle data objects with openOnInit.  <br>
    *          - The SBO has its own version, which is used when the SBO's <br>
    *            OpenOnInit is false.
    */
   public void fetchDefinitions()
   {
      handle hAppservice = TypeFactory.handle();
      character cServerFileName = TypeFactory.character();
      character cContext = TypeFactory.character();
      handle hRowObjectTable = TypeFactory.handle();
      handle hFetchTable = TypeFactory.handle();
      character cErrors = TypeFactory.character();
      handle hAsHandle = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         hRowObjectTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", targetProcedure()));
         
         if (_not(hRowObjectTable.isValid()))
         {
            if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasNoServerBinding", targetProcedure()))).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("connectServer", targetProcedure(), "O", hAppservice);
               
               if (_isUnknown(hAppservice))
               {
                  returnError("ADM-ERROR");
               }
               
               /* {get Prop var [handle]} */ 
               cServerFileName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getServerFileName", targetProcedure()));
               cContext /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForServer", targetProcedure()));
               ControlFlowOps.invokeRemoteWithMode("adm2/fetchdefs.p", (handle) null, hAppservice, false, "IUOO", cServerFileName, cContext, new TableParameter(hFetchTable), cErrors);
            }
            else
            {
               /* {get Prop var [handle]} */ 
               hAsHandle.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getAsHandle", targetProcedure()));
               /* a remoteFetchDefinitions with input-output context and output errors
                       may be added to the data object if we want errors  */
               ControlFlowOps.invokeInWithMode("fetchRowObjectTable", hAsHandle, "O", new TableParameter(hFetchTable));
               cContext /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForClient", hAsHandle));
            }
            /* {fnarg <func-name> <arg> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "applyContextFromserver", targetProcedure(), "I", cContext);
            
            if ((hFetchTable.isValid()).booleanValue())
            {
               /* {set Prop value [handle]} */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectTable", targetProcedure(), "I", hFetchTable);
            }
            else
            {
               returnError("ADM-ERROR");
            }
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To reposition the RowObject temp-table to the first record, or<br>
    *              to the row matching the QueryRowIdent property (if it has been<br>
    *              set.)  If the first record has not been fetched (from the db) <br>
    *              yet, then calls sendRows to get the first batch of RowObject <br>
    *              records of the SDO and then reposition the RowObject Temp-Table<br>
    *              to the first row.<br>
    * <p>
    * Parameters:  &lt;none&gt;
    */
   public void fetchFirst()
   {
      integer iReturnRows = TypeFactory.integer();
      handle hDataQuery = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      handle hColumn = TypeFactory.handle();
      integer iRowsToBatch = TypeFactory.integer();
      character cRowIdent = TypeFactory.character();
      integer iRowNum = TypeFactory.integer();
      logical lRowIdent = TypeFactory.logical();
      logical lRebuild = TypeFactory.logical();
      integer iFirstRow = TypeFactory.integer();
      character cRowState = TypeFactory.character();
      logical lReposAvail = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
         iRowNum.assign(ghProp.unwrapBufferField().value());
         
         /* Rebuild On Reposition is set */
         if (_isUnknown(iRowNum))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("RowsToBatch"));
            iRowsToBatch.assign(ghProp.unwrapBufferField().value());
            
            /* If there are already rows in the temp-table, then
                     the query has already been opened and repositioned. In that case,
                     pass the special value of "First" to sendRows to get it to flush
                     the temp-table and restart from the beginning. Otherwise if
                     QueryRowIdent is set, then start at that row. Otherwise just
                     start at the beginning. */
            if (_or(not(hRowObject.isValid()), () -> not(hRowObject.unwrapBuffer().available())))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryRowIdent"));
               cRowIdent.assign(ghProp.unwrapBufferField().value());
               
               /* See if there's a special start row.*/
               if (_and(notUnknown(cRowIdent), () -> isNotEqual(cRowIdent, "")))
               {
                  lRowIdent.assign(true);
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryRowIdent"));
                  ghProp.unwrapBufferField().changeValue(new unknown());
               }
            }
            else
            {
               cRowIdent.assign("First");
            }
            /* Else signal restart at beginning. */
            ControlFlowOps.invokeInWithMode("sendRows", targetProcedure(), "IIIIO", new unknown() /* Start at the first row if RowIdent is not set */, cRowIdent /* or use this RowIdent key if its set. */, new logical(false /* Don't next initially (unless skipRowident)  */), iRowsToBatch /* how many rows to retrieve */, iReturnRows /* how many rows were actually returned */);
            
            /* New to 9.1B: If the temp-table is dynamic and wasn't already 
                     initialized, the handle variables set above will be unknown,
                     so reset them here -- clientSendRows has set the properties for them.*/
            /* if avail after sendrows avoid passing 'home' to avoid problems 
                     since value-changed not will fire */
            if (_not(hDataQuery.isValid()))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
               hDataQuery.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
               hRowObject.assign(ghProp.unwrapBufferField().value());
            }
            
            if (_not(hDataQuery.unwrapQuery().isOpen()))
            {
               hDataQuery.unwrapQuery().queryOpen();
            }
            
            hColumn.assign(hRowObject.unwrapBuffer().bufferField("RowNum"));
            
            if (_isNotEqual(iReturnRows, 0))
            {
               hDataQuery.unwrapQuery().getFirst();
               lReposAvail.assign(hRowObject.unwrapBuffer().available());
               
               if (_not(lRowIdent))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
                  ghProp.unwrapBufferField().changeValue(hColumn.unwrapBufferField().value());
               }
 /* If there was no QueryRowIdent prop then we */;
               /* {set Prop value [handle]} */ 
            }
            else
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("RebuildOnRepos"));
               lRebuild.assign(ghProp.unwrapBufferField().value());
               
               if ((lRebuild).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
                  iFirstRow.assign(ghProp.unwrapBufferField().value());
                  /* {get Prop var [handle]} */ 
                  cRowState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", targetProcedure()));
                  
                  if (_and(isEqual(cRowState, "RowUpdated"), () -> isUnknown(iFirstRow)))
                  {
                     /*DYNAMIC-FUNCTION("showMessage":U IN TARGET-PROCEDURE, "17":U).*/
                     ControlFlowOps.invokeInWithMode("showMessageProcedure", targetProcedure(), "IO", new character("17"), glShowMessageAnswer);
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
                     ghProp.unwrapBufferField().changeValue(new unknown());
                     returnNormal();
                  }
               }
               hRowObject.unwrapBuffer().bufferRelease();
            }
         }
 /* First row hasn't been retrieved yet. */         else
         {
            if (_not(hDataQuery.unwrapQuery().isOpen()))
            {
               hDataQuery.unwrapQuery().queryOpen();
            }
            
            hDataQuery.unwrapQuery().getFirst();
         }
         /* set QueryPosition from FirstRowNum, LastRowNum */
         ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
         /* Send dataAvail whether's a record or not; if not, the recipients
                will close queries or clear frames. */
         NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
         {
            (lReposAvail).booleanValue() ? new character("REPOSITIONED") : new character("FIRST")
         });
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
         ghProp.unwrapBufferField().changeValue(new character(""));
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To reposition the RowObject query to the last row of the dataset.<br>
    *              If the last row has not yet been retrieved from the DB, then<br>
    *              fetchLast gets the last batch of RowObject records for the SDO <br>
    *              and then repositions the RowObject query to the last row.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       IF the SDO property RebuildOnReposition is false and the last row<br>
    *              from the db query has not been fetch yet, fetchLast keeps asking<br>
    *              for batches of rows till the last batch is recieved. This is <br>
    *              required, because otherwise there would be a discontinuous set of<br>
    *              rows in the RowObject temp-table, and also, the RowNum of the last<br>
    *              record, which is the key value, can be known by the db query only<br>
    *              by walking all the way to the end.<br>
    *              If RebuildOnReposition is true and the last row from the db query<br>
    *              has not been fetch yet, all RowObject records are discarded and<br>
    *              just the last batch is fetched. In this case the RowNum of the<br>
    *              last row becomes 2000000 and all other records have smaller numbers<br>
    *              (except for additions.)
    */
   public void fetchLast()
   {
      handle hDataQuery = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      handle hRowNum = TypeFactory.handle();
      handle hRowIdent = TypeFactory.handle();
      integer iRowsReturned = TypeFactory.integer();
      integer iLastRow = TypeFactory.integer();
      integer iRowsToBatch = TypeFactory.integer();
      logical lRebuild = TypeFactory.logical();
      logical lReposAvail = TypeFactory.logical();
      character cRowState = TypeFactory.character();
      character cAsDivision = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
         iLastRow.assign(ghProp.unwrapBufferField().value());
         hRowNum.assign(hRowObject.unwrapBuffer().bufferField("RowNum"));
         
         if (_isUnknown(iLastRow))
         {
            ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character("WAIT"));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("RowsToBatch"));
            iRowsToBatch.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("RebuildOnRepos"));
            lRebuild.assign(ghProp.unwrapBufferField().value());
            
            if ((lRebuild).booleanValue())
            {
               /* Jump direct to Last and rebuilt temp-table */
               /* Set the cursor first in case this takes a while. */
               NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
               {
                  "LastStart"
               });
               /* No particular rownum to start at */
               /* special value for pcRowIdent */
               /* No need to "next" after repositioning */
               ControlFlowOps.invokeInWithMode("sendRows", targetProcedure(), "IIIIO", new unknown(), new character("Last"), new logical(false), iRowsToBatch, iRowsReturned);
               NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
               {
                  "LastEnd"
               });
            }
            else
            {
               /* No Rebuild on Reposition */
               /* Set the cursor first in case this takes a while. */
               NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
               {
                  "LastStart"
               });
               ControlFlowOps.invokeInWithMode("sendRows", targetProcedure(), "IIIIO", new unknown(), new character("Last"), new logical(true), new integer(0), iRowsReturned);
               NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
               {
                  "LastEnd"
               });
            }
            
            /* END ELSE DO IF NOT lRebuild */
            /* {get Prop var [handle]} */ 
            cAsDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAsDivision", targetProcedure()));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
            iLastRow.assign(ghProp.unwrapBufferField().value());
            
            if (_and(isEqual(cAsDivision, ""), lRebuild))
            {
               lReposAvail.assign(hRowObject.unwrapBuffer().available());
            }
            
            if (_not(hDataQuery.unwrapQuery().isOpen()))
            {
               hDataQuery.unwrapQuery().queryOpen();
            }
            
            /* Query on the Temp-Table. */
            if (_isEqual(iRowsReturned, 0))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
               iLastRow.assign(ghProp.unwrapBufferField().value());
               /* {get Prop var [handle]} */ 
               cRowState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", targetProcedure()));
               
               if (_and(isEqual(cRowState, "RowUpdated"), () -> isUnknown(iLastRow)))
               {
                  /*DYNAMIC-FUNCTION("showMessage":U IN TARGET-PROCEDURE, "17":U).*/
                  ControlFlowOps.invokeInWithMode("showmessageprocedure", targetProcedure(), "IO", new character("17"), glShowMessageAnswer);
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
                  ghProp.unwrapBufferField().changeValue(new unknown());
                  returnNormal();
               }
            }
            /* iRowsReturned = 0 */
            ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character(""));
         }
 /* Last row not been retrieved yet.*/;
         hDataQuery.unwrapQuery().getLast();
         
         if ((hRowObject.unwrapBuffer().available()).booleanValue())
         {
            hRowIdent.assign(hRowObject.unwrapBuffer().bufferField("RowIdent"));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
            ghProp.unwrapBufferField().changeValue(hRowNum.unwrapBufferField().value());
         }
         
         /* set QueryPosition from FirstRowNum, LastRowNum  */
         ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
         /* Signal row change in any case. */
         NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
         {
            (lReposAvail).booleanValue() ? new character("Repositioned") : new character("LAST")
         });
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
         ghProp.unwrapBufferField().changeValue(new character(""));
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To reposition the RowObject query to the next row.  If a new <br>
    *              batch is required to do so, then sendRows is called to get the<br>
    *              new batch.<br>
    * <p>
    * Parameters:  &lt;none&gt;
    */
   public void fetchNext()
   {
      integer iRowNum = TypeFactory.integer();
      integer iReturnRows = TypeFactory.integer();
      handle hDataQuery = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      handle hRowNum = TypeFactory.handle();
      handle hRowIdent = TypeFactory.handle();
      integer iRow = TypeFactory.integer();
      integer iRowsToBatch = TypeFactory.integer();
      character cQueryPos = TypeFactory.character();
      integer iLastRow = TypeFactory.integer();
      character cRowState = TypeFactory.character();
      logical lReposAvail = TypeFactory.logical();
      logical lFirstDeleted = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         
         if (_not(hDataQuery.unwrapQuery().isOpen()))
         {
            returnNormal();
         }
         
         hRowObject.assign(hDataQuery.unwrapQuery().bufferHandle(1));
         hRowNum.assign(hRowObject.unwrapBuffer().bufferField("RowNum"));
         hRowIdent.assign(hRowObject.unwrapBuffer().bufferField("RowIdent"));
         
         if ((hRowObject.unwrapBuffer().available()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
            iRow.assign(ghProp.unwrapBufferField().value());
            
            /* Already on the last row. */
            if (_isEqual(iRow, hRowNum.unwrapBufferField().value()))
            {
               returnNormal();
            }
         }
 /* Make sure we're positioned to some row. */         else
         {
            /* if no record is avail, but queryposition is first we 
                             must have deleted it */
            /* {get Prop var [handle]} */ 
            cQueryPos.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryPosition", targetProcedure()));
            
            /* This seems to be  handled in updateQueryPos ..
                  IF cQueryPos = 'LastRecord':U THEN
                     lLastDeleted = TRUE. */
            if (_isEqual(cQueryPos, "FirstRecord"))
            {
               lFirstDeleted.assign(true);
            }
         }
         hDataQuery.unwrapQuery().getNext();
         
         if (_not(hRowObject.unwrapBuffer().available()))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("RowsToBatch"));
            iRowsToBatch.assign(ghProp.unwrapBufferField().value());
            NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
            {
               "NextStart"
            });
            /* sendRows will know what row to start at */
            /* No pcRowIdent */
            ControlFlowOps.invokeInWithMode("sendRows", targetProcedure(), "IIIIO", new unknown(), new unknown(), new logical(true /* start with next row */), iRowsToBatch, iReturnRows);
            NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
            {
               "NextEnd"
            });
            
            if (_isNotEqual(iReturnRows, 0))
            {
               NamedEventManager.publish("assignMaxGuess", targetProcedure(), "I", new Object[]
               {
                  iReturnRows
               });
               /* Set ReposAvail flag if avail after reposition above or in sendRows
                          (will be avail if we browse) so we can pass right parameter to the
                          browser when we publish dataAvailable further down */
               lReposAvail.assign(hRowObject.unwrapBuffer().available());
               
               if (_not(lReposAvail))
               {
                  hDataQuery.unwrapQuery().getNext();
               }
            }
            else
            {
               hDataQuery.unwrapQuery().getPrevious();
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
               iLastRow.assign(ghProp.unwrapBufferField().value());
               /* See if fetch failed due to an update in progress */
               /* {get Prop var [handle]} */ 
               cRowState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", targetProcedure()));
               
               /* Don't return, but publish dataavailable further down */
               if (_and(isEqual(cRowState, "RowUpdated"), () -> isUnknown(iLastRow)))
               {
                  /* DYNAMIC-FUNCTION("showMessage":U IN TARGET-PROCEDURE, "17":U).*/
                  ControlFlowOps.invokeInWithMode("showMessageProcedure", targetProcedure(), "IO", new character("17"), glShowMessageAnswer);
               }
               else
               {
                  if (_not(hRowObject.unwrapBuffer().available()))
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
                     ghProp.unwrapBufferField().changeValue(new unknown());
                     ControlFlowOps.invokeIn("fetchLast", targetProcedure());
                  }
                  else
                  {
                     iRowNum.assign(hRowNum.unwrapBufferField().value());
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
                     ghProp.unwrapBufferField().changeValue(iRowNum);
                  }
               }
            }
         }
         
         /* END DO IF no next record AVAILABLE  */
         if (_and(lFirstDeleted, () -> hRowObject.unwrapBuffer().available()))
         {
            silent(() -> iRowNum.assign(hRowNum.unwrapBufferField().value()));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
            ghProp.unwrapBufferField().changeValue(iRowNum);
         }
         
         /* Set QueryPosition from FirstRowNum, LastRowNum  */
         ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
         /* Signal row change in any case, even if NoRecordAvail. 
                If REPOSITION-TO-ROWID made the record available it must be browsed 
                so we pass 'REPOSITIONED' to make sure dataAvailable doesn't select-next- */
         NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
         {
            (lReposAvail).booleanValue() ? new character("REPOSITIONED") : new character("NEXT")
         });
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
         ghProp.unwrapBufferField().changeValue(new character(""));
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To reposition the RowObject query to the previous row.  If a new<br>
    *              batch is needed to do so, then sendRows is called to get the new<br>
    *              batch.  (Getting a new batch will only be necessary when the <br>
    *              RebuildOnReposition property is set to true.)<br>
    * <p>
    * Parameters:  &lt;none&gt;
    */
   public void fetchPrev()
   {
      integer iReturnRows = TypeFactory.integer();
      handle hDataQuery = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      handle hRowNum = TypeFactory.handle();
      integer iRow = TypeFactory.integer();
      integer iRowsToBatch = TypeFactory.integer();
      logical lRebuild = TypeFactory.logical();
      character cRowState = TypeFactory.character();
      logical lReposAvail = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         
         if (_not(hDataQuery.unwrapQuery().isOpen()))
         {
            returnNormal();
         }
         
         hRowObject.assign(hDataQuery.unwrapQuery().bufferHandle(1));
         hRowNum.assign(hRowObject.unwrapBuffer().bufferField("RowNum"));
         
         if ((hRowObject.unwrapBuffer().available()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
            iRow.assign(ghProp.unwrapBufferField().value());
            
            if (_isEqual(iRow, hRowNum.unwrapBufferField().value()))
            {
               returnNormal();
            }
         }
 /* Make sure we're positioned to some row. */;
         hDataQuery.unwrapQuery().getPrevious();
         
         if (_not(hRowObject.unwrapBuffer().available()))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("RebuildOnRepos"));
            lRebuild.assign(ghProp.unwrapBufferField().value());
            
            if ((lRebuild).booleanValue())
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("RowsToBatch"));
               iRowsToBatch.assign(ghProp.unwrapBufferField().value());
               NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
               {
                  "PrevStart"
               });
               /* sendRows will know what row to start at */
               /* No pcRowIdent */
               /* start with previous row */
               ControlFlowOps.invokeInWithMode("sendRows", targetProcedure(), "IIIIO", new unknown(), new unknown(), new logical(true), negate(iRowsToBatch), iReturnRows);
               NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
               {
                  "PrevEnd"
               });
               
               if (_isNotEqual(iReturnRows, 0))
               {
                  NamedEventManager.publish("assignMaxGuess", targetProcedure(), "I", new Object[]
                  {
                     iReturnRows
                  });
                  /* Set ReposAvail flag if avail after reposition above or in sendRows
                               (will be avail if we browse) so we can pass right parameter to the
                               browser when we publish dataAvailable further down */
                  lReposAvail.assign(hRowObject.unwrapBuffer().available());
                  /* Reposition to the record we were on before this was called and 
                               then get the now previous record */
                  NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
                  {
                     "PrevStart"
                  });
                  
                  if (_not(lReposAvail))
                  {
                      /* get the row that we have repositioned to */hDataQuery.unwrapQuery().getNext();
                  }
                  
                  NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
                  {
                     "PrevEnd"
                  });
               }
            }
            
            /* if lRebuild */
            /* ReturnsRow = 0 indicates either 
                     NOT RebuildOnRepos OR RebuildonRepos, but no more records */
            if (_isEqual(iReturnRows, 0))
            {
               hDataQuery.unwrapQuery().getFirst();
               
               /* See if fetch failed due to an update in progress */
               if ((lRebuild).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
                  iRow.assign(ghProp.unwrapBufferField().value());
                  /* {get Prop var [handle]} */ 
                  cRowState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", targetProcedure()));
                  
                  if (_and(isEqual(cRowState, "RowUpdated"), () -> isUnknown(iRow)))
                  {
                     /* DYNAMIC-FUNCTION("showMessage":U IN TARGET-PROCEDURE, "17":U). */
                     ControlFlowOps.invokeInWithMode("showmessageprocedure", targetProcedure(), "IO", new character("17"), glShowMessageAnswer);
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
                     ghProp.unwrapBufferField().changeValue(new unknown());
                     returnNormal();
                  }
               }
               
               /* lRebuild */
               if ((hRowObject.unwrapBuffer().available()).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
                  ghProp.unwrapBufferField().changeValue(hRowNum.unwrapBufferField().value());
               }
               else
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
                  ghProp.unwrapBufferField().changeValue(new unknown());
               }
               /* {set Prop value [handle]} */ 
               /* {set Prop value [handle]} */ 
            }
         }
         /* IF not hRowObject:available */
         /* set QueryPosition from FirstRowNum, LastRowNum */
         ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
         /* Signal row change in any case, even if NoRecordAvail. 
                If REPOSITION-TO-ROWID made the record available it must be browsed 
                so we pass 'REPSOTIONED' to make sure dataAvailable doesn't select-prev- */
         NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
         {
            (lReposAvail).booleanValue() ? new character("REPOSITIONED") : new character("PREV")
         });
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
         ghProp.unwrapBufferField().changeValue(new character(""));
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Fetch the RowObject table    <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void fetchRowObjectTable(final TableParameter _phRowObjectTable)
   {
      handle phRowObjectTable = new handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         UndoableFactory.initOutput(phRowObjectTable);
      }, 
      (Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_phRowObjectTable, phRowObjectTable, false, true);
         /* {get Prop var [handle]} */ 
         phRowObjectTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", targetProcedure()));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To generate a list of properties and their values needed to save<br>
    *              (and restore) the context of a stateless SDO between invocations. <br>
    *  <br>
    * Parameters:<br>
    *   OUTPUT pcContext - The context string to be returned. pcContext is a CHR(3) <br>
    *                      delimited list of propertyCHR(4)Value pairs.<br>
    * <p>
    * Notes:       Currently there are only 5 properties needed to restore the<br>
    *              context: CheckCurrentChanged, RowObjectState, FirstResultRow,<br>
    *              LastResultRow and QueryRowIdent.
    */
   public void genContextList(final character pcContext_1)
   {
      logical lCheckCurrentChanged = TypeFactory.logical();
      character cRowObjectState = TypeFactory.character();
      character cFirstResultRow = TypeFactory.character();
      character cLastResultRow = TypeFactory.character();
      character cQueryRowIdent = TypeFactory.character();
      integer iLastRowNum = TypeFactory.integer();
      integer iFirstRowNum = TypeFactory.integer();
      character cQueryWhere = TypeFactory.character();
      character cQueryString = TypeFactory.character();
      character cQueryColumns = TypeFactory.character();
      /* Dynamic SDO on server  */
      character cDefs = TypeFactory.character();
      character cTables = TypeFactory.character();
      character cPhysicalTables = TypeFactory.character();
      character cBaseQuery = TypeFactory.character();
      character cDataColumns = TypeFactory.character();
      character cDataColumnsByTable = TypeFactory.character();
      character cAssignList = TypeFactory.character();
      character cUpdatableColumnsByTable = TypeFactory.character();
      character cDataLogicProcedure = TypeFactory.character();
      character cPositionForClient = TypeFactory.character();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcContext_1);
      }, 
      (Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CheckCurrentChanged"));
         lCheckCurrentChanged.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         cRowObjectState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstResultRow"));
         cFirstResultRow.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LastResultRow"));
         cLastResultRow.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryRowIdent"));
         cQueryRowIdent.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
         iLastRowNum.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
         iFirstRowNum.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("PositionForClient"));
         cPositionForClient.assign(ghProp.unwrapBufferField().value());
         /* Rebuild the context string to look like: 
                       prop1 CHR(4) val1 CHR(3) prop2 CHR(4) val2 CHR(3) ...                  */
         /* only needed if not unknown */
         pcContext_1.assign(concat("CheckCurrentChanged", chr(4), ((lCheckCurrentChanged).booleanValue() ? new character("Yes") : new character("No")), chr(3), "RowObjectState", chr(4), (_isUnknown(cRowObjectState) ? new character("?") : cRowObjectState), chr(3), "FirstResultRow", chr(4), (_isUnknown(cFirstResultRow) ? new character("?") : cFirstResultRow), chr(3), "LastResultRow", chr(4), (_isUnknown(cLastResultRow) ? new character("?") : cLastResultRow), chr(3), "LastRowNum", chr(4), (_isUnknown(iLastRowNum) ? new character("?") : valueOf(iLastRowNum)), chr(3), "FirstRowNum", chr(4), (_isUnknown(iFirstRowNum) ? new character("?") : valueOf(iFirstRowNum)), chr(3), "QueryRowIdent", chr(4), (_isUnknown(cQueryRowIdent) ? new character("?") : cQueryRowIdent), (_notUnknown(cPositionForClient) ? concat(chr(3), "PositionForClient", chr(4), cPositionForClient) : new character(""))));
         
         if (_isEqual(LogicalTerminal.getClientType(), "WEBSPEED"))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataFieldDefs"));
            cDefs.assign(ghProp.unwrapBufferField().value());
            /* {get Prop var [handle]} */ 
            cQueryWhere.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryWhere", targetProcedure()));
            
            if (_isEqual(cDefs, ""))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("Tables"));
               cTables.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("PhysicalTables"));
               cPhysicalTables.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DataColumns"));
               cDataColumns.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DataColumnsByTable"));
               cDataColumnsByTable.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdatableColumnsByTable"));
               cUpdatableColumnsByTable.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("AssignList"));
               cAssignList.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("BaseQuery"));
               cBaseQuery.assign(ghProp.unwrapBufferField().value());
               /* {get Prop var [handle]} */ 
               cDataLogicProcedure.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDataLogicProcedure", targetProcedure()));
               pcContext_1.assign(concat(pcContext_1, chr(3), "Tables", chr(4), cTables, chr(3), "PhysicalTables", chr(4), cPhysicalTables, chr(3), "BaseQuery", chr(4), cBaseQuery, chr(3), "DataColumns", chr(4), cDataColumns, chr(3), "DataColumnsByTable", chr(4), cDataColumnsByTable, chr(3), "UpdatableColumnsByTable", chr(4), cUpdatableColumnsByTable, chr(3), "AssignList", chr(4), cAssignList, chr(3), "DataLogicProcedure", chr(4), cDataLogicProcedure));
            }
            
            if (_isUnknown(cQueryWhere))
            {
               cQueryWhere.assign("");
            }
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryString"));
            cQueryString.assign(ghProp.unwrapBufferField().value());
            
            if (_and(isGreaterThan(cQueryString, ""), () -> isNotEqual(cQueryString, cQueryWhere)))
            {
               cQueryWhere.assign("");
            }
            
            /* The Qcolumns is in synch with QString, so do not return it if it 
                   is not in synch, indicated by queryWhere blank  see above   */
            if (_isGreaterThan(cQueryWhere, ""))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("Querycolumns"));
               cQueryColumns.assign(ghProp.unwrapBufferField().value());
            }
            else
            {
               cQueryColumns.setUnknown();
            }
            /* {get Prop var [handle]} */ 
            
            pcContext_1.assign(concat(pcContext_1, (_notUnknown(cQueryWhere) ? concat(chr(3), "QueryWhere", chr(4), cQueryWhere) : new character("")), (_notUnknown(cQueryColumns) ? concat(chr(3), "QueryColumns", chr(4), cQueryColumns) : new character(""))));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Server-side procedure run after new data has been requested by <br>
    *              the client.<br>
    * Parameters:  OUTPUT pcContaineProps - Properties of the Contained SDOs<br>
    * Notes:       getContextAndDestroy is invoked from the client side of the<br>
    *              SmartDataObject and executed on the server side.
    */
   public void getContextAndDestroy(final character pcContext_1)
   {
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcContext_1);
      }, 
      (Body) () -> 
      {
         pcContext_1 /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForClient", targetProcedure()));
         ControlFlowOps.invokeIn("destroyObject", targetProcedure());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Start the logic procedure for the data object<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       The Logic Procedure is an optional object that can contain <br>
    *              validation and business logic for a particular table.  <br>
    *              Rules: <br>
    *              - The RUN is ALWAYS executed with (or without) the extension that <br>
    *                is defined in DataLogicProcedure property <br>
    *                ( this ensures that program-name and :file-name behave as expected)<br>
    *              - follows Progress core run rules:       <br>
    *               1. ANY extention will run r-code if found <br>
    *               2. will run .r if NO period in run name
    */
   public void initializeLogicObject()
   {
      character cLogicProc = TypeFactory.character();
      character cDummy = TypeFactory.character();
      character cDotRfile = TypeFactory.character();
      character cMemberFile = TypeFactory.character();
      character cDbList = TypeFactory.character();
      integer iDb = TypeFactory.integer();
      logical lUseProxy = TypeFactory.logical();
      integer iExt = TypeFactory.integer();
      character cProxyName = TypeFactory.character();
      character cProxyDotR = TypeFactory.character();
      character cExtension = TypeFactory.character();
      character cFile = TypeFactory.character();
      character cRunName = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      logical lWebClient = TypeFactory.logical();
      logical lRunProxy = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cLogicProc.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDataLogicProcedure", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLogicObject"));
         hObject.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(cLogicProc, ""))
         {
            returnNormal();
         }
         
         if ((hObject.isValid()).booleanValue())
         {
            returnNormal();
         }
         
         iExt.assign(lastIndexOf(cLogicProc, "."));
         
         if (_isGreaterThan(iExt, 1))
         {
            cFile.assign(substring(cLogicProc, 1, minus(iExt, 1)));
            cExtension.assign(substring(cLogicProc, iExt));
         }
         else
         {
            cFile.assign(cLogicProc);
         }
         
         lWebClient.assign(isEqual(LogicalTerminal.getClientType(), "WEBCLIENT"));
         
         /* If not web client and any db connections find r-code for inspection */
         if (_and(not(lWebClient), () -> isGreaterThan(ConnectionManager.numDBs(), 0)))
         {
            FileSystemOps.initFileInfo(concat(cFile, ".r"));
            cDotRfile.assign(FileSystemOps.fileInfoGetFullPath());
            /* If .r in proc lib, get the member name (ie, filename). */
            cMemberFile.assign(FileSystemOps.member(cDotRfile));
            
            if (_notUnknown(cMemberFile))
            {
               cDotRfile.assign(cMemberFile);
            }
         }
         else
         {
            lUseProxy.assign(true);
         }
         
         /* We have found the base .r */
         if (_notUnknown(cDotRfile))
         {
            RcodeInfoOps.initFileInfo(cDotRfile);
            cDbList.assign(RcodeInfoOps.getDbReferences());
            
            loopLabel22:
            for (iDb.assign(1); _isLessThanOrEqual(iDb, numEntries(trim(cDbList))); iDb.increment())
            {
               /* Remove blank when no db */
               if (_not(ConnectionManager.connected(entry(iDb, cDbList))))
               {
                  lUseProxy.assign(true);
                  /* Flag that we can't use the base file. */
                  break loopLabel22;
               }
            }
            
            /* Do for each required DB */
            if (_not(lUseProxy))
            {
               cRunName.assign(concat(cFile, cExtension));
            }
         }
         
         /* if not connected or no r-code found check if there is proxy r-code */
         if (_isEqual(cRunName, ""))
         {
            cProxyName.assign(concat(cFile, "_cl"));
            cProxyDotR.assign(concat(cProxyName, ".r"));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("RunDataLogicProxy"));
            lRunProxy.assign(ghProp.unwrapBufferField().value());
            
            /* if no proxy r-code, check if we have source code */
            if (_isNotEqual(lRunProxy, false))
            {
               if (_isUnknown(FileSystemOps.searchPath(cProxyDotR)))
               {
                  if ((lRunProxy).booleanValue())
                  {
                      /* if TRUE, force a 'RUN' of the proxy */cRunName.assign(concat(cProxyName, cExtension));
                  }
                  else
                  {
                     if (_isGreaterThan(cExtension, ""))
                     {
                        if ((lUseProxy).booleanValue())
                        {
                           cRunName.assign(concat(cProxyName, cExtension));
                        }
                        else
                        {
                           cRunName.assign(concat(cFile, cExtension));
                        }
                        
                        if (_isUnknown(FileSystemOps.searchPath(cRunName)))
                        {
                           cRunName.assign("");
                        }
                     }
                  }
               }
               else
               {
                  cRunName.assign(concat(cProxyName, cExtension));
               }
            }
 /* include 'unknown' */;
         }
         
         if (_isGreaterThan(cRunName, ""))
         {
            OnPhrase[] onPhrase2 = new OnPhrase[]
            {
               new OnPhrase(Condition.STOP, Action.LEAVE, "blockLabel4")
            };
            
            doBlock(TransactionType.SUB, "blockLabel4", onPhrase2, new Block((Body) () -> 
            {
               ControlFlowOps.invokePersistentSet((cRunName).toStringMessage(), hObject);
               targetProcedure().unwrapCommonProcedure().addSuperProcedure(hObject, ProcedureManager.SEARCH_TARGET);
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLogicObject"));
               ghProp.unwrapBufferField().changeValue(hObject);
            }));
            
            /* The SDO cannot run without the specified data logic */
            if (_not(hObject.isValid()))
            {
               ControlFlowOps.invokeIn("destroyObject", targetProcedure());
            }
         }
         else
         {
            if (_or(not(lUseProxy), lRunProxy))
            {
               ControlFlowOps.invokeInWithMode("showMessageProcedure", targetProcedure(), "IO", concat("33,", cLogicProc), cDummy);
               ControlFlowOps.invokeIn("destroyObject", targetProcedure());
            }
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Performs SmartDataObject-specific initialization. <br>
    * Parameters:  &lt;none&gt;<br>
    *       Note:  Connects to the Appserver, but from version 9.1D the<br>
    *              Server side object is no longer started at initialization.  <br>
    *  Note date: 2002/02/02
    */
   public void initializeObject()
   {
      character cAppService = TypeFactory.character();
      character cSvrFileName = TypeFactory.character();
      character cUibmode = TypeFactory.character();
      handle hSource = TypeFactory.handle();
      handle hContainer = TypeFactory.handle();
      logical lQueryContainer = TypeFactory.logical();
      character cDynamicSdo = TypeFactory.character();
      logical lOpenOnInit = TypeFactory.logical();
      handle hAppService = TypeFactory.handle();
      logical lWait = TypeFactory.logical();
      logical lInitialized = TypeFactory.logical();
      handle hDataSource = TypeFactory.handle();
      logical lQuerySource = TypeFactory.logical();
      character cContAppservice = TypeFactory.character();
      handle hRowObjectTable = TypeFactory.handle();
      character cAsDivision = TypeFactory.character();
      character cReturn = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UIBMode"));
         cUibmode.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(cUibmode, ""))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
            lInitialized.assign(ghProp.unwrapBufferField().value());
            
            if ((lInitialized).booleanValue())
            {
               returnNormal();
            }
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
            hContainer.assign(ghProp.unwrapBufferField().value());
            
            if ((hContainer.isValid()).booleanValue())
            {
               silent(() -> 
               {
                  ghProp.assign(handle.fromString(entry(1, hContainer.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                  lQueryContainer.assign(ghProp.unwrapBufferField().value());
               });
            }
            /* {get Prop var [handle]} */ 
            
            if (_isEqual(lQueryContainer, true))
            {
               /* {get Prop var [handle]} */
               cAsDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", hContainer));
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryContainer"));
               ghProp.unwrapBufferField().changeValue(new logical(true));
               /* by default it's NO */
               /* {set Prop value [handle]} */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setASDivision", targetProcedure(), "I", cAsDivision);
            }
            
            /* {get Prop var [handle]} */ 
            hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
            silent(() -> 
            {
               ghProp.assign(handle.fromString(entry(1, hDataSource.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
               lQuerySource.assign(ghProp.unwrapBufferField().value());
            });
            /* The sbo subscribes to this event in order to update ObjectMapping
                   (This is needed in the case the dataSource is an SBO)*/
            NamedEventManager.publish("registerObject", targetProcedure());
            /* {get Prop var [handle]} */ 
            cAppService.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAppService", targetProcedure()));
            
            if (_isNotEqual(cAppService, ""))
            {
               /* We have moved the actual server start until later, so it can 
                        be done with one request. The connection should ideally also have 
                        waited until really required, but it's only the first object of 
                        specifc object that actually connects. 
                        One reason that the connection happens here is that it may require 
                        a login, which fails if it happens from the getAsHandle function 
                        (cannot have wait-for in function call ...), 
                        but we could of course have checked these properties, but the main 
                        reason is that there are some dependencies of the different AS 
                        properties that also would need to be resolved .. 
                        AsDivison = 'client', asHasStarted etc....  */
               ControlFlowOps.invokeInWithMode("connectServer", targetProcedure(), "O", hAppService);
               
               if (_isUnknown(hAppService))
               {
                  returnError("ADM-ERROR");
               }
               
               if ((hContainer.isValid()).booleanValue())
               {
                  /* {fnarg <func-name> <arg> [handle] */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "registerAppService", hContainer, "I", cAppService);
               }
            }
            else
            {
               /* If no AppService defined, check if the user is running the client
                        proxy, or the dynamic SDO. If so, there can't be any required databases 
                        connected for the object to show data. Probably an AppServer setup 
                        problem. If there's no container handle, then we are running on
                        the AppServer, so there's nothing to check. */
               if ((hContainer.isValid()).booleanValue())
               {
                  /* This new property in 9.1B holds the file name to run on the
                                AppServer. If it's a dynamic SDO, the file name being run won't
                                be usable (it will be dyndata). */
                  /* {get Prop var [handle]} */ 
                  cSvrFileName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getServerFileName", targetProcedure()));
                  /* {get Prop var [handle]} */
                  silent(() -> cDynamicSdo.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDynamicSDOProcedure", hContainer)));
                  cDynamicSdo.assign(entry(1, cDynamicSdo, "."));
                  
                  /* Remove .r or .w */
                  if (_or(matches(targetProcedure().unwrapFile().getFileName(), ".*_cl..*"), () -> matches(targetProcedure().unwrapFile().getFileName(), concat("*", cDynamicSdo, ".*"), true)))
                  {
                     if ((lQueryContainer).booleanValue())
                     {
                        /* if part of SBO make sure we have AppService */
                        /* {get Prop var [handle]} */
                        cContAppservice.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAppService", hContainer));
                        
                        if (_isEqual(cContAppservice, ""))
                        {
                           /* {fnarg <func-name> <arg> [handle] */ 
                           ControlFlowOps.invokeInWithMode("showMessageProcedure", targetProcedure(), "IO", substitute(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 46), cSvrFileName, hContainer.unwrapFile().getFileName()), glShowMessageAnswer);
                           /* This is necessary to inform the SBO of the problem. */
                           /* The RETURN value is not enough as 'initializeObject' has */
                           /* been PUBLISHED and not RUN */
                           ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", new character("ADM-ERROR"), new unknown(), new unknown());
                           returnNormal("ADM-ERROR");
                        }
                     }
                     else
                     {
                        /*DYNAMIC-FUNCTION("showMessage":U IN TARGET-PROCEDURE,*/
                        ControlFlowOps.invokeInWithMode("showMessageProcedure", targetProcedure(), "IO", concat(cSvrFileName, " ", ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 47)) /* {fnarg <func-name> <arg> [handle] */, glShowMessageAnswer);
                        returnNormal("ADM-ERROR");
                     }
                  }
               }
            }
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("CommitSource"));
            hSource.assign(ghProp.unwrapBufferField().value());
            
            if (_notUnknown(hSource))
            {
               /* {set Prop value [handle]} */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setAutoCommit", targetProcedure(), "I", false);
            }
         }
         /* END IF not UIBMode   */
         /* {get Prop var [handle]} */ 
         cAsDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAsDivision", targetProcedure()));
         
         /* Create temptables if dynamic, unless we are inside an SBO in which case
              the SBO will run createObjects from its createObjects. */
         if (_or(not(lQueryContainer), () -> isEqual(cAsDivision, "SERVER")))
         {
            silent(() -> ControlFlowOps.invokeIn("createObjects", targetProcedure()));
            
            if (_or(ErrorManager.isError(), () -> isNotEqual(ControlFlowOps.getReturnValue(), "")))
            {
               returnNormal("ADM-ERROR");
            }
         }
         
         /* Retrieve stored filter information */
         if (_and(isNotEqual(cAsDivision, "SERVER"), () -> hContainer.isValid()))
         {
            ControlFlowOps.invokeIn("retrieveFilter", targetProcedure());
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("OpenOnInit"));
         lOpenOnInit.assign(ghProp.unwrapBufferField().value());
         
         /* Set openOnInit false if a datacontainer can handle the server request*/
         if (_and(and(hContainer.isValid(), () -> hAppService.isValid()), () -> isNotEqual(hAppService, SessionUtils.asHandle())))
         {
            /* Check AppServer properties to see if the object has no current or future 
                   server bindings and is using a stateless operating mode. */
            /* check if the container is an unitialized dataContainer */
            if (_and(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasNoServerBinding", targetProcedure())), () -> new logical(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "isFetchPending", hContainer))) /* {fn <func-name> [handle] */)
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("openOnInit"));
               ghProp.unwrapBufferField().changeValue(new logical(false));
               lWait.assign(true);
            }
         }
         
         /* If not managed by a DataContainer or an SBO ensure that any ad-hoc 
              appserver request from this object keeps the connection until the data 
              request has completed */
         if (_and(not(lWait), not(lQueryContainer)))
         {
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setBindScope", targetProcedure(), "I", "data");
         }
         
         ControlFlowOps.runSuper("initializeObject");
         cReturn.assign(ControlFlowOps.getReturnValue());
         
         if ((lQueryContainer).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, hContainer.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("OpenOnInit"));
            lOpenOnInit.assign(ghProp.unwrapBufferField().value());
         }
         /* {get Prop var [handle]} */ 
         
         /* If the query is not opened at initialize, we must ensure that 
              queryposition is correct. This is managed from the container if 
              queryContainer (SBO). */
         if (_not(lOpenOnInit))
         {
            ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("OpenOnInit"));
         ghProp.unwrapBufferField().changeValue(lOpenOnInit);
         
         /* If no query container and no fetch pending in datacontainer and still 
              no TT defined then we will go to the server and get it. 
              This will typically be the case in dynamic data objects when OpenOnInit 
              is false either in this object or in a datasource object */
         if (_and(and(isEqual(cAsDivision, "CLIENT"), not(lQueryContainer)), not(lWait)))
         {
            /* {get Prop var [handle]} */ 
            hRowObjectTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", targetProcedure()));
            
            if (_not(hRowObjectTable.isValid()))
            {
               silent(() -> ControlFlowOps.invokeIn("fetchDefinitions", targetProcedure()));
               
               if (_or(ErrorManager.isError(), () -> isNotEqual(ControlFlowOps.getReturnValue(), "")))
               {
                  cReturn.assign("ADM-ERROR");
               }
            }
         }
         ControlFlowOps.invokeInWithMode("unbindServer", targetProcedure(), "I", new character("unconditional"));
         
         if (_isEqual(cReturn, "ADM-ERROR"))
         {
            returnNormal("ADM-ERROR");
         }
         else
         {
            returnNormal();
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: Received from container source to check if contained objects have <br>
    *          unsaved or uncommitted changes, including addMode.           <br>
    *   Notes: This is published thru the container link from canExit for <br>
    *          close logic ( ok, cancel, exit).<br>
    *         (It is very similar to canNavigate -&gt; isUpdatePending which is <br>
    *          published thru the data link)<br>
    *        - WE currently ONLY check rowObjectState as the other states are <br>
    *          checked in the visual objects.
    */
   public void isUpdateActive(final logical plActive)
   {
      character cRowObjectState = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_not(plActive))
         {
            /* {get Prop var [handle]} */ 
            cRowObjectState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", targetProcedure()));
            plActive.assign(isEqual(cRowObjectState, "RowUpdated"));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Published through data-targets to check if any updates are pending.   <br>
    * Parameters: input-output plUpdate <br>
    *             Returns TRUE and stops the publishing if update is pending. <br>
    * Notes:      New is included as a pending update. <br>
    *             Called from canNavigate, which is used by navigating objects to <br>
    *             check if they can trust an updateState('updatecomplete') message<br>
    *         NB! This check is only valid from a DataSource point of view. <br>
    *             Use canNavigate to check an actual object.
    */
   public void isUpdatePending(final logical plUpdate)
   {
      character cRowObjectState = TypeFactory.character();
      logical lNew = TypeFactory.logical();
      logical lDataModified = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* No need to check a pending update was found somewhere else or */
         /* this SDO is a 1-to-1 child */
         if (_and(not(plUpdate), () -> not(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUpdateFromSource", targetProcedure())))))
         {
            /* {get Prop var [handle]} */ 
            cRowObjectState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", targetProcedure()));
            /* {get Prop var [handle]} */ 
            lDataModified.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataModified", targetProcedure()));
            /* We can use NewRow and not newMode, as RowObjectstate 'RowUpdated' also 
                    is included.  */
            /* {get Prop var [handle]} */ 
            lNew.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getNewRow", targetProcedure()));
            /* unknown is no (NewRow is sometimes ?) */
            plUpdate.assign(or(or(isEqual(cRowObjectState, "RowUpdated"), () -> isEqual(lNew, true)), () -> isEqual(lDataModified, true)));
            
            if (_not(plUpdate))
            {
               NamedEventManager.publish("isUpdatePending", targetProcedure(), "U", new Object[]
               {
                  plUpdate
               });
            }
         }
         /* not plUpdate */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Run LinkStatHandler in source(pcState) if ToggleDataTargets<br>
    *              And publish the state with a potential appended 'Target' <br>
    *              Recieved from DataTargets.                                <br>
    * Parameters:  pcState AS CHARACTER  'active'/'inactive'<br>
    *              The event is republished up the groupAssignSource and<br>
    *              the DataSource, which will run LinkstateHandler if they <br>
    *              found that they can deactivate the link
    */
   public void linkState(final character _pcState)
   {
      character pcState = TypeFactory.initInput(_pcState);
      character cTargets = TypeFactory.character();
      integer iTarget = TypeFactory.integer();
      handle hTarget = TypeFactory.handle();
      character cObjectType = TypeFactory.character();
      handle hContainer = TypeFactory.handle();
      handle hGasource = TypeFactory.handle();
      logical lHidden = TypeFactory.logical();
      logical lVisualSource = TypeFactory.logical();
      logical lToggleTargets = TypeFactory.logical();
      logical lActiveTarget = TypeFactory.logical();
      logical lInitialized = TypeFactory.logical();
      handle hSourceProcedure = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitialized.assign(ghProp.unwrapBufferField().value());
         
         if (_not(lInitialized))
         {
            returnNormal();
         }
         
         /* Ignore 'activeTarget' and 'inactiveTarget' published from child SDOs/SBOs 
              to only reach the navigationSource */
         if (_not(matchesList("active,inactive", pcState)))
         {
            returnNormal();
         }
         
         hSourceProcedure.assign(sourceProcedure());
         ghProp.assign(handle.fromString(entry(1, sourceProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectType"));
         cObjectType.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(cObjectType, "SUPER"))
         {
            hSourceProcedure /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getTargetProcedure", sourceProcedure()));
         }
         
         ghProp.assign(handle.fromString(entry(1, hSourceProcedure.unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
         hContainer.assign(ghProp.unwrapBufferField().value());
         lVisualSource.assign(hContainer.isValid());
         
         if ((lVisualSource).booleanValue())
         {
            /* Ignore this if it's from a GA Target. 
                  (it is published up through the GA-link and will reach us from the source)*/
            /* {get Prop var [handle]} */
            silent(() -> hGasource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getGroupAssignSource", hSourceProcedure)));
            
            if ((hGasource.isValid()).booleanValue())
            {
               returnNormal();
            }
            
            /* Ignore an 'inactive' message from a visual object if it or any of the 
                   GAtargets are visible (or will become visible) */
            if (_isEqual(pcState, "inactive"))
            {
               /* {get Prop var [handle]} */
               silent(() -> lHidden.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getGroupAssignHidden", hSourceProcedure)));
               
               if (_not(lHidden))
               {
                  returnNormal();
               }
            }
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ToggleDataTargets"));
         lToggleTargets.assign(ghProp.unwrapBufferField().value());
         
         /* If toggle and state is 'inactive' set to NOT toggle if cannavigate false*/
         if (_and(lToggleTargets, () -> isEqual(pcState, "inactive")))
         {
            silent(() -> lToggleTargets /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "canNavigate", hSourceProcedure)));
            
            if (_isUnknown(lToggleTargets))
            {
               lToggleTargets.assign(true);
            }
         }
         
         if ((lToggleTargets).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, hSourceProcedure.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectType"));
            cObjectType.assign(ghProp.unwrapBufferField().value());
            
            if (_isNotEqual(cObjectType, "SmartDataBrowser"))
            {
               ControlFlowOps.invokeInWithMode("linkStateHandler", hSourceProcedure, "III", pcState, targetProcedure(), new character("DataSource"));
            }
         }
         
         /* If 'inactive' we must verify that all the targets also are 'inactive' */
         if (_and(isEqual(pcState, "inactive"), lToggleTargets))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
            cTargets.assign(ghProp.unwrapBufferField().value());
            
            IntegerExpression resExpr1 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cTargets);
               }
            };
            ToClause toClause1 = new ToClause(iTarget, 1, resExpr1);
            
            doTo("loopLabel23", toClause1, new Block((Body) () -> 
            {
               hTarget.assign(handle.fromString(entry(iTarget, cTargets)));
               
               /* skip the publisher */
               if (_isEqual(hTarget, hSourceProcedure))
               {
                  next("loopLabel23");
               }
               
               ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
               hContainer.assign(ghProp.unwrapBufferField().value());
               
               if ((hContainer.isValid()).booleanValue())
               {
                  /* Don't check GATargets */
                  /* {get Prop var [handle]} */
                  silent(() -> hGasource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getGroupAssignSource", hTarget)));
                  
                  if (_not(hGasource.isValid()))
                  {
                     /* {get Prop var [handle]} */
                     silent(() -> lHidden.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getGroupAssignHidden", hTarget)));
                  }
               }
               else
               {
                  lHidden.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "isLinkInactive", hTarget, "II", "DataSource", targetProcedure()));
               }
               
               if (_not(lHidden))
               {
                  /* If an active target and the message is from a non-visual object 
                             just get out as there is no need to republish */
                  if (_not(lVisualSource))
                  {
                     returnNormal();
                  }
                  
                  lActiveTarget.assign(true);
                  leave("loopLabel23");
               }
            }));
         }
         else
         {
            if (_and(isEqual(pcState, "active"), not(lVisualSource)))
            {
               /* No need to republish an active message from a non-visual target if the 
                      link already is active */
               if (_not(new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "isLinkInactive", targetProcedure(), "II", "DataSource", new unknown()))))
               {
                  returnNormal();
               }
            }
         }
         
         /* If not toggleDataTargets or any active target found for an 'inactive' 
              state then append 'target' so the DataSource ignores it, but the 
              Navigationsource reacts to it */
         if (_or(not(lToggleTargets), lActiveTarget))
         {
            pcState.assign(concat(pcState, "Target"));
         }
         
         NamedEventManager.publish("linkState", targetProcedure(), "I", new Object[]
         {
            pcState
         });
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: Override inorder to run dataAvailable when a dataSource link <br>
    *          is made active      <br>
    * Parameters: Yes there are parameters.  <br>
    * Notes:
    */
   public void linkStateHandler(final character _pcState, final handle _phObject_1, final character _pcLink)
   {
      character pcState = TypeFactory.initInput(_pcState);
      handle phObject_1 = TypeFactory.initInput(_phObject_1);
      character pcLink = TypeFactory.initInput(_pcLink);
      logical lDataInactive = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_and(isEqual(pcState, "active"), () -> isEqual(pcLink, "DataSource")))
         {
            /* if the source is inactive then just wait for the dataavailable
                   that it will publish when it becomes active */
            if (_not(new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "isLinkInactive", phObject_1, "II", "DataSource", new unknown()))))
            {
               lDataInactive.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "isLinkInactive", targetProcedure(), "II", "DataSource", phObject_1));
            }
         }
         ControlFlowOps.runSuper("linkStateHandler", pcState, phObject_1, pcLink);
         
         if ((lDataInactive).booleanValue())
         {
            ControlFlowOps.invokeInWithMode("dataAvailable", targetProcedure(), "I", new character("RESET"));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: Validation hook for code to be executed immediately after the <br>
    *          transaction. <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void postTransactionValidate()
   {
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.invokeInWithMode("bufferTransactionValidate", targetProcedure(), "I", new character("post"));
         returnNormal(ControlFlowOps.getReturnValue());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    *   Purpose:    Prepare the object and retrieve all info for a stateless server<br>
    *               request.<br>
    *   Parameters: <br>
    *     phTopContainer Handle of the container that manages the request <br>
    *     pcAppService   AppService of this request      <br>
    *     pcSourceName   Qualified DataSource name<br>
    *                    Unknown if this is the top level in this request.<br>
    *                    For a 'POSITION' request the position information is <br>
    *                    appended (cKeyField + ",":U + cFieldName)  <br>
    *                    <br>
    *     pcOptions      Options for this request          <br>
    *                    - 'INIT', initialization, used to skip DataObjects where <br>
    *                       OpenOnInit is false.<br>
    *                    - 'BATCH', request for another batch, tells prepareForFetch<br>
    *                      to keep the temp-table.        <br>
    *                    - 'POSITION', prepare position info. If the object already <br>
    *                      is prepared then this just adds another chr(2) entry to <br>
    *                      the QueryFields, otherwise we also need to prepare. <br>
    *                                         <br>
    * i-o pcHandles      Data object handle, comma-separated <br>
    * i-o pcRunNames     Name that the server can use to start the object, comma-separated. Currently the physical name only.<br>
    * i-o pcQualNames    [ContainerName: [Containername:].. InstanceName, comma-separated<br>
    *                    Passed to server to be able to set context in correct objects<br>
    * i-o pcQueryFields  Contains ForeignField information and position information<br>
    * i-o pcQueries      QueryString, chr(1)-separated.<br>
    * i-o pcTempTables   Temp-table handles. comma-separated                     <br>
    *   <br>
    *   Notes:           Returns SKIP for SDOs with openOnInit true if they need to <br>
    *                    get the table definition from the server.
    */
   public void prepareDataForFetch(final handle _phTopContainer, final character _pcAppService, final character _pcSourceName, final character _pcOptions_1, final character pcHandles, final character pcRunNames, final character pcQualNames, final character pcQueryFields, final character pcQueries, final character pcTempTables)
   {
      handle phTopContainer = TypeFactory.initInput(_phTopContainer);
      character pcAppService = TypeFactory.initInput(_pcAppService);
      character pcSourceName = TypeFactory.initInput(_pcSourceName);
      character pcOptions_1 = TypeFactory.initInput(_pcOptions_1);
      logical lPosition = TypeFactory.logical();
      logical lVisualTargets = TypeFactory.logical();
      character cQualName = TypeFactory.character();
      handle hContainerSource = TypeFactory.handle();
      character cContainerName = TypeFactory.character();
      integer iPrepare = TypeFactory.integer();
      character cTargets = TypeFactory.character();
      handle hTarget = TypeFactory.handle();
      integer iTarget = TypeFactory.integer();
      logical lQuery = TypeFactory.logical();
      character cForeignFields = TypeFactory.character();
      character cRunName = TypeFactory.character();
      logical lFirst = TypeFactory.logical();
      handle hRowObjectTable = TypeFactory.handle();
      character cObjectName = TypeFactory.character();
      character cMode = TypeFactory.character();
      character cQuery = TypeFactory.character();
      character cAppService = TypeFactory.character();
      logical lOpenOnInit = TypeFactory.logical();
      character cContainerType = TypeFactory.character();
      logical lRebuild = TypeFactory.logical();
      integer iLastRowNum = TypeFactory.integer();
      integer iFirstRowNum = TypeFactory.integer();
      logical lInit = TypeFactory.logical();
      logical lSkip = TypeFactory.logical();
      handle hRowObject = TypeFactory.handle();
      logical lQueryOpen = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cAppService.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAppService", targetProcedure()));
         
         if (_and(notUnknown(pcAppService), () -> isNotEqual(cAppService, pcAppService)))
         {
            returnNormal();
         }
         
         lPosition.assign(isGreaterThan(lookup("POSITION", pcOptions_1), 0));
         lVisualTargets.assign(isGreaterThan(lookup("VISUALTARGETS", pcOptions_1), 0));
         lInit.assign(isGreaterThan(lookup("INIT", pcOptions_1), 0));
         
         /* return or set Skip flag if this is initialization and OpenOnInit is false
            (the skip falg is set if we need to get the rowObject definition from server)*/
         if ((lInit).booleanValue())
         {
            /* If the query is open then it must have been opened in initializeObject,
                  so just return */
            /* {get Prop var [handle]} */ 
            lQueryOpen.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getQueryOpen", targetProcedure()));
            
            if ((lQueryOpen).booleanValue())
            {
               returnNormal();
            }
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("OpenOnInit"));
            lOpenOnInit.assign(ghProp.unwrapBufferField().value());
            
            if (_not(lOpenOnInit))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
               hRowObject.assign(ghProp.unwrapBufferField().value());
               
               /* Return if the rowobject is defined */
               if ((hRowObject.isValid()).booleanValue())
               {
                  returnNormal();
               }
               
               /* If this is a dynamic object not yet defined then we pass 'SKIP' 
                       to the server to retrieve the definitions */
               lSkip.assign(true);
            }
         }
         
         /* Skip this data object if the DataSource link is inactive unless this 
             is a position prepare OR we are the top requesting object
            (If a container uses initPages to start this page it (need to) set 
             hideOnInit to true in all objects before notifyPage(initializeObject). 
             The hideOnInit make the SDO link to a potential DataSource inactive, 
             which again made initializeObject -> dataAvailable - openQuery 
              - fetchContainedData -> fail as it bailed out here)  */
         if (_and(and(not(lPosition), () -> isGreaterThan(pcSourceName, "")), not(lSkip)))
         {
            if ((new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "isLinkInactive", targetProcedure(), "II", "DataSource", new unknown()))).booleanValue())
            {
               returnNormal();
            }
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
         hContainerSource.assign(ghProp.unwrapBufferField().value());
         
         loopLabel24:
         while (_isNotEqual(hContainerSource, phTopContainer))
         {
            ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
            cContainerName.assign(ghProp.unwrapBufferField().value());
            cQualName.assign(concat(cContainerName, (_isEqual(cQualName, "") ? new character("") : new character(":")), cQualName, (_isEqual(cQualName, "") ? new character(":") : new character(""))));
            ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
            hContainerSource.assign(ghProp.unwrapBufferField().value());
            
            if (_isUnknown(hContainerSource))
            {
               returnNormal();
            }
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
         cObjectName.assign(ghProp.unwrapBufferField().value());
         cQualName.assign(concat(cQualName, cObjectName));
         iPrepare.assign(lookup(cQualName, pcQualNames));
         
         if (_and(and(not(lPosition), not(lVisualTargets)), not(lSkip)))
         {
            if (_and(notUnknown(pcSourceName), () -> isNotEqual(pcSourceName, "")))
            {
               /* {get Prop var [handle]} */ 
               cForeignFields.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getForeignFields", targetProcedure()));
               cForeignFields.assign(concat(pcSourceName, ",", cForeignFields));
               cMode.assign("Child");
            }
            else
            {
               if ((matchesList(pcOptions_1, "Batch")).booleanValue())
               {
                  cMode.assign("Batch");
               }
            }
         }
         
         /***********  Not yet 
          IF lUseRepository THEN
           {get LogicalObjectName cRunName}.
          _* If logicalObjectname is blank use serverfilename. This is the case if 
             we do not use the Repository OR if the file isn't in the Repository
           *_  
          IF cRunName = '':U THEN
           ***************/
         if (_isEqual(iPrepare, 0))
         {
            if (_and(lPosition, not(lSkip)))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
               iFirstRowNum.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
               iLastRowNum.assign(ghProp.unwrapBufferField().value());
               
               /* If we have all data on the client, just return */
               if (_and(notUnknown(iFirstRowNum), () -> notUnknown(iLastRowNum)))
               {
                  returnNormal();
               }
               
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("RebuildOnRepos"));
               lRebuild.assign(ghProp.unwrapBufferField().value());
               
               if (_not(lRebuild))
               {
                  returnNormal();
               }
            }
            
            if (_not(lSkip))
            {
               cQuery /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "prepareForFetch", targetProcedure(), "I", cMode));
            }
            else
            {
               cQuery.assign("SKIP");
            }
            
            /* {get Prop var [handle]} */ 
            hRowObjectTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", targetProcedure()));
            /* {get Prop var [handle]} */ 
            cRunName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getServerFileName", targetProcedure()));
            lFirst.assign(isEqual(pcHandles, ""));
            pcHandles.assign(concat(pcHandles, ((lFirst).booleanValue() ? new character("") : new character(",")), valueOf(targetProcedure())));
            pcQueries.assign(concat(pcQueries, ((lFirst).booleanValue() ? new character("") : chr(1)), cQuery));
            pcTempTables.assign(concat(pcTempTables, ((lFirst).booleanValue() ? new character("") : new character(",")), ((hRowObjectTable.isValid()).booleanValue() ? valueOf(hRowObjectTable) : new character("?"))));
            pcQualNames.assign(concat(pcQualNames, ((lFirst).booleanValue() ? new character("") : new character(",")), cQualName));
            pcRunNames.assign(concat(pcRunNames, ((lFirst).booleanValue() ? new character("") : new character(",")), cRunName));
            pcQueryFields.assign(concat(pcQueryFields, ((lFirst).booleanValue() ? new character("") : chr(1)), _notUnknown(cForeignFields) ? cForeignFields : new character("")));
         }
         
         /* not prepared */
         if ((lPosition).booleanValue())
         {
            if (_isGreaterThan(iPrepare, 0))
            {
               pcQueryFields.replaceEntry(iPrepare, chr(1), concat(entry(iPrepare, pcQueryFields, chr(1)), chr(2), pcSourceName));
            }
            else
            {
               pcQueryFields.assign(concat(pcQueryFields, chr(2), pcSourceName));
            }
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
            cTargets.assign(ghProp.unwrapBufferField().value());
            
            IntegerExpression resExpr2 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cTargets);
               }
            };
            ToClause toClause2 = new ToClause(iTarget, 1, resExpr2);
            
            doTo("targetLoop", toClause2, new Block((Body) () -> 
            {
               lQuery.assign(false);
               hTarget.assign(handle.fromString(entry(iTarget, cTargets)));
               ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
               lQuery.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerType"));
               cContainerType.assign(ghProp.unwrapBufferField().value());
               
               if ((lQuery).booleanValue())
               {
                  /* prepare data object data targets */
                  ControlFlowOps.invokeInWithMode("prepareDataForFetch", hTarget, "IIIIUUUUUU", phTopContainer, _isUnknown(pcAppService) ? cAppService : pcAppService, cQualName, pcOptions_1, pcHandles, pcRunNames, pcQualNames, pcQueryFields, pcQueries, pcTempTables);
               }
               else
               {
                  if (_and(lVisualTargets, () -> isGreaterThan(cContainerType, "")))
                  {
                     /* prepare Visual container targets 
                                -> prepare position info for their SDF data Sources    */
                     ControlFlowOps.invokeInWithMode("prepareDataForFetch", hTarget, "IIIIUUUUUU", phTopContainer, _isUnknown(pcAppService) ? cAppService : pcAppService, cQualName, concat("POSITION", (lInit).booleanValue() ? new character(",INIT") : new character("")), pcHandles, pcRunNames, pcQualNames, pcQueryFields, pcQueries, pcTempTables);
                  }
               }
            }));
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  This appends the RETURN-VALUE from the user-defined transaction<br>
    *           validation procedure or other update-related error to the list<br>
    *           of any errors already in the log, and formats this string to<br>
    *           prepare for returning it to the client.<br>
    *   Notes:  invoked internally from serverCommit.
    */
   public void prepareErrorsForReturn(final character _pcReturnValue, final character _pcAsdivision, final character pcMessages)
   {
      character pcReturnValue = TypeFactory.initInput(_pcReturnValue);
      character pcAsdivision = TypeFactory.initInput(_pcAsdivision);
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_isNotEqual(pcReturnValue, ""))
         {
            ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", pcReturnValue, new unknown(), new unknown());
         }
         
         if (_isEqual(pcAsdivision, "Server"))
         {
            pcMessages.assign(leftTrim(concat(pcMessages, chr(3), ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure())) /* {fn <func-name> [handle] */, chr(3)));
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: Validation hook for code to be executed immediately before the <br>
    *          transaction. <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void preTransactionValidate()
   {
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.invokeInWithMode("bufferTransactionValidate", targetProcedure(), "I", new character("pre"));
         returnNormal(ControlFlowOps.getReturnValue());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Transfers the contents of the SDO to Crystal<br>
    * Parameters:  input field list or leave blank for all (no table prefix)<br>
    *              input include object fields yes/no<br>
    *              input maximum records to process<br>
    * Notes:
    */
   public void printToCrystal(final character _pcFieldList, final logical _plIncludeObj, final integer _piMaxRecords)
   {
      character pcFieldList = TypeFactory.initInput(_pcFieldList);
      logical plIncludeObj = TypeFactory.initInput(_plIncludeObj);
      integer piMaxRecords = TypeFactory.initInput(_piMaxRecords);
      
      internalProcedure(new Block((Body) () -> 
      {
         /* use existing currently ignored for Crystal*/
         ControlFlowOps.invokeInWithMode("exportData", targetProcedure(), "IIIII", new character("Crystal"), pcFieldList, plIncludeObj, new unknown(), piMaxRecords);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Transfer RowObjUpd table <br>
    * Parameters:  INPUT pcValType AS CHARACTER  "Pre" or "Post",<br>
    *              INPUT-OUTPUT TABLE FOR RowObjUpd.<br>
    * Notes:       The static override is used for sbo server side updates<br>
    *              in commitTransaction.p. This dynamic version is not used.
    */
   public void pushRowObjUpdTable(final TableParameter _phRowObjUpd_1)
   {
      handle phRowObjUpd_1 = new handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_phRowObjUpd_1, phRowObjUpd_1, true, false);
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjUpdTable", targetProcedure(), "I", phRowObjUpd_1);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     wrapper for pre and postTransactionValidate procedures when<br>
    *              run from SBO.<br>
    * Parameters:  INPUT pcValType AS CHARACTER  "Pre" or "Post",<br>
    *              INPUT-OUTPUT TABLE FOR RowObjUpd.<br>
    * Notes:
    */
   public void pushTableAndValidate(final character _pcValType, final TableParameter _phRowObjUpd_1)
   {
      character pcValType = TypeFactory.initInput(_pcValType);
      handle phRowObjUpd_1 = new handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         UndoableFactory.initInputOutput(phRowObjUpd_1);
      }, 
      (Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_phRowObjUpd_1, phRowObjUpd_1, true, true);
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjUpdTable", targetProcedure(), "I", phRowObjUpd_1);
         /* Split into two to accomodate the DynSBO which shares buffers instead of */
         /* transfering tables */
         ControlFlowOps.invokeInWithMode("bufferValidate", targetProcedure(), "I", pcValType);
         silent(() -> HandleOps.delete(phRowObjUpd_1));
         returnNormal(ControlFlowOps.getReturnValue());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To retrieve the current database values for a row already<br>
    *              in the RowObject table.<br>
    * <p>
    * Parameters:  &lt;none&gt;<br>
    * <p>
    * Notes:       PUBLISHes dataAvailable ('SAME') to cause a SDViewer or<br>
    *              Browser to display the latest values. Since the database <br>
    *              records are never locked on read, this procedure can fetch the<br>
    *              latest values but cannot guarantee that they will not change<br>
    *              before an update is done.
    */
   public void refreshRow()
   {
      handle hDataQuery = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      integer iRows = TypeFactory.integer();
      character cRowIdent = TypeFactory.character();
      character cRowState = TypeFactory.character();
      integer iRowNum = TypeFactory.integer();
      logical lNewRow = TypeFactory.logical();
      rowid rRowid = TypeFactory.rowid();
      logical lDeleted = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* Nothing to refresh ..  */
         /* {get Prop var [handle]} */ 
         lNewRow.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getNewRow", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         cRowState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", targetProcedure()));
         
         if (_isEqual(cRowState, "RowUpdated"))
         {
            /* if updates are in progress, can not continue */
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", "24");
            ControlFlowOps.invokeInWithMode("showMessageProcedure", targetProcedure(), "IO", new character("24"), glShowMessageAnswer);
            returnNormal();
         }
         
         /* if cRowState = rowupdated */
         if ((lNewRow).booleanValue())
         {
            returnNormal();
         }
         
         if (_not(hRowObject.unwrapBuffer().available()))
         {
            returnNormal();
         }
         
         cRowIdent.assign(hRowObject.unwrapBuffer().bufferField("RowIdent").unwrapBufferField().value());
         iRowNum.assign(hRowObject.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value());
         hRowObject.unwrapBuffer().deleteRecord();
         /* remove the old copy of the row. */
         /** find the prev rec as we want to position to it in case the refresh is
               gone */
         hDataQuery.unwrapQuery().getPrevious();
         
         if (_not(hRowObject.unwrapBuffer().available()))
         {
            hDataQuery.unwrapQuery().getFirst();
         }
         
         rRowid.assign(hRowObject.unwrapBuffer().rowID());
         /* This special calling sequence tells sendRows to retrieve a new copy
              of the record pointed to by cRowIdent, give it the number iRowNum,
              and add it to the existing RowObject table. */
         ControlFlowOps.invokeInWithMode("sendRows", targetProcedure(), "IIIIO", iRowNum, cRowIdent, new logical(false /* no Next */), new integer(1 /* Get just 1 row */), iRows);
         
         /* If nothing to refresh resort to plan B */
         if (_isEqual(iRows, 0))
         {
            /* get rid of the non existing row from the browse */
            NamedEventManager.publish("DeleteComplete", targetProcedure());
            lDeleted.assign(true);
            
            if (_notUnknown(rRowid))
            {
               hDataQuery.unwrapQuery().queryRepositionByID(rRowid);
            }
         }
         
         /* We check whether the record is available in order NOT to do this on a 
             browser, which fetches the record when the query is repositioned.  */
         if (_not(hRowObject.unwrapBuffer().available()))
         {
            hDataQuery.unwrapQuery().getNext();
         }
         
         /* Tell everyone we have a new copy of the same row. */
         NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
         {
            (lDeleted).booleanValue() ? new character("DIFFERENT") : new character("SAME")
         });
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
         ghProp.unwrapBufferField().changeValue(new character(""));
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    *  Purpose:     Procedure executed on a server side SmartDataObject.   <br>
    *               This is the equivalent of serverCommit, but can be run in <br>
    *               a not intialized object as it has input-ouput parameters for <br>
    *               context.  <br>
    *  Parameters: <br>
    *   INPUT-OUTPUT  pcContext  - in Contextfrom client <br>
    *                              out new context<br>
    *   INPUT-OUTPUT TABLE RowObjUpd - The Update version of the RowObject <br>
    *                                  Temp-Table<br>
    * <p>
    *   OUTPUT cMessages - a CHR(3) delimited string of accumulated messages from<br>
    *                      server.<br>
    *   OUTPUT cUndoIds  - list of any RowObject ROWIDs whose changes need to be <br>
    *                       undone as the result of errors in the form of:<br>
    *               "RowNumCHR(3)ADM-ERROR-STRING,RowNumCHR(3)ADM-ERROR-STRING,..."<br>
    * <p>
    * Notes:        If another user has modified the database records since the <br>
    *               original was read, the new database values are copied into the <br>
    *               RowObjUpd record and returned to Commit so the UI object can <br>
    *               display them.
    */
   public void remoteCommit(final character pcContext_1, final TableParameter _phRowObjUpd_1, final character pcMessages, final character pcUndoIds)
   {
      handle phRowObjUpd_1 = new handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         UndoableFactory.initInputOutput(phRowObjUpd_1);
         TypeFactory.initOutput(pcMessages);
         TypeFactory.initOutput(pcUndoIds);
      }, 
      (Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_phRowObjUpd_1, phRowObjUpd_1, true, true);
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjUpdTable", targetProcedure(), "I", phRowObjUpd_1);
         ControlFlowOps.invokeInWithMode("setContextAndInitialize", targetProcedure(), "I", pcContext_1);
         ControlFlowOps.invokeInWithMode("bufferCommit", targetProcedure(), "OO", pcMessages, pcUndoIds);
         pcContext_1 /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForClient", targetProcedure()));
         silent(() -> HandleOps.delete(phRowObjUpd_1));
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Stateless version of sendRows. <br>
    *              It does no processing but simply runs sendRows passing all <br>
    *              parameters, except the context to it and returning the RowObject <br>
    *              table as an output parameter back to the caller which now has the <br>
    *              new batch of records created in sendRows.   <br>
    * Parameters:  <br>
    * <p>
    *  INPUT-OUTPUT pcContext - in current Context - out new context <br>
    *                           in and out (may) have completely different properties                           <br>
    *                           CHR(3) delimitted list of "propCHR(4)value" pairs.           <br>
    *                           See synchronizeProperties and genContext for details. <br>
    *   INPUT  piStartRow     - The RowNum value of the record to start the batch<br>
    *                           to return.  Typically piStartRow is ? as a flag to <br>
    *                           use pcRowIdent instead of piStartRow.<br>
    *   INPUT  pcRowIdent     - The RowIdent of the first record of the batch <br>
    *                           to return.  Can also be "FIRST" or "LAST" to force<br>
    *                           the retrieval of the first (or last) batch of <br>
    *                           RowObject records.<br>
    *   INPUT  plNext         - True if serverSendRows is to start on the "next"<br>
    *                           record from what is indicated by piStartRow or<br>
    *                           piRowIdent.<br>
    *   INPUT  piRowsToReturn - The number of rows in a batch.<br>
    *   OUTPUT piRowsReturned - The actual number of rows returned. This number<br>
    *                           will either be the same as piRowsToReturn or<br>
    *                           less when there are not enough records to fill<br>
    *                           up the batch.<br>
    *   <br>
    *   OUTPUT pcMessages       - errors <br>
    *                            (just to have a consistent stateless API<br>
    *                             not in use)   <br>
    *  <br>
    * Notes:       If piStartRow is not 0 or ? then pcRowIdent is ignored.<br>
    *              plNext is ignored if pcRowIdent is "FIRST" or "LAST".<br>
    *              The most common use of piRowsReturned is to indicate that the<br>
    *              entire result list has been returned when it is less than <br>
    *              piRowToReturn.<br>
    *           -  The object should ONLY be started persistently before this is <br>
    *              called and NOT initialized as initializeObject is run AFTER the <br>
    *              context has been set.<br>
    *           -  The caller is also responsible for destroying the object
    */
   public void remoteSendRows(final character piocContext, final integer _piStartRow, final character _pcRowIdent_4, final logical _plNext, final integer _piRowsToReturn, final integer pioRowsReturned, final TableParameter _phRowObject_1, final character pocMessages)
   {
      integer piStartRow = TypeFactory.initInput(_piStartRow);
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      logical plNext = TypeFactory.initInput(_plNext);
      integer piRowsToReturn = TypeFactory.initInput(_piRowsToReturn);
      handle phRowObject_1 = new handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pioRowsReturned);
         UndoableFactory.initOutput(phRowObject_1);
         TypeFactory.initOutput(pocMessages);
      }, 
      (Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_phRowObject_1, phRowObject_1, false, true);
         ControlFlowOps.invokeInWithMode("setContextAndInitialize", targetProcedure(), "I", piocContext);
         ControlFlowOps.invokeInWithMode("sendRows", targetProcedure(), "IIIIO", piStartRow, pcRowIdent_4, plNext, piRowsToReturn, pioRowsReturned);
         /* {get Prop var [handle]} */ 
         phRowObject_1.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", targetProcedure()));
         piocContext /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForClient", targetProcedure()));
         
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
         {
            pocMessages /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()));
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void removeFromCache()
   {
      character cLogicalName = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
         cLogicalName.assign(ghProp.unwrapBufferField().value());
         /* get off the cache */
         NamedEventManager.unsubscribe(targetProcedure(), concat("searchCache", cLogicalName));
         NamedEventManager.unsubscribe(targetProcedure(), "destroyCache");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose   : reopen the SDO's DataQuery to a specific rowid     <br>
    * Parameters: &lt;none&gt;<br>
    * Notes     : Used after a new record has been added or the Dataquery is <br>
    *             resorted.
    */
   public void reopenToRowid(final rowid _prRowObject)
   {
      rowid prRowObject = TypeFactory.initInput(_prRowObject);
      handle hDataQuery = TypeFactory.handle();
      handle hRowNum = TypeFactory.handle();
      integer iLastRow = TypeFactory.integer();
      integer iFirstRow = TypeFactory.integer();
      handle hRowObject = TypeFactory.handle();
      character cQueryPosition = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
         iFirstRow.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
         iLastRow.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         cQueryPosition.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryPosition", targetProcedure()));
         
         if (_isUnknown(prRowObject))
         {
            prRowObject.assign(hRowObject.unwrapBuffer().rowID());
         }
         
         /* {fnarg <func-name> <arg> [handle] */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "openDataQuery", targetProcedure(), "I", "");
         
         /* if we have the first record of the batch reset first 
               (or if the Queryposition indicates that it was empty )  */
         if (_or(notUnknown(iFirstRow), () -> begins(cQueryPosition, "NoRecord")))
         {
            hRowNum.assign(hRowObject.unwrapBuffer().bufferField("RowNum"));
            hDataQuery.unwrapQuery().getFirst();
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
            ghProp.unwrapBufferField().changeValue(hRowNum.unwrapBufferField().value());
         }
         
         /* if we have the last record of the batch reset last 
               (or if the Queryposition indicates that it was empty )  */
         if (_or(notUnknown(iLastRow), () -> begins(cQueryPosition, "NoRecord")))
         {
            if (_not(hRowNum.isValid()))
            {
               hRowNum.assign(hRowObject.unwrapBuffer().bufferField("RowNum"));
            }
            
            hDataQuery.unwrapQuery().getLast();
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
            ghProp.unwrapBufferField().changeValue(hRowNum.unwrapBufferField().value());
         }
         
         if (_notUnknown(prRowObject))
         {
            silent(() -> hDataQuery.unwrapQuery().queryRepositionByID(prRowObject));
            
            /* Make this RowObject available if reposition didn't (not browsed) */
            if (_and(not(hRowObject.unwrapBuffer().available()), () -> isEqual(ErrorManager.getErrorText(1), "")))
            {
               hDataQuery.unwrapQuery().getNext();
            }
         }
         /* Tell everybody about a potential change of QueryPosition. */
         ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:    When a SmartDataObject is split and running Statelessly on an<br>
    *             AppServer, it is shutdown after each use and then restarted for<br>
    *             the next.  restartServerObject is run on the client to restart<br>
    *             the SmartDataObject on the server.<br>
    * <p>
    * Parameters:  &lt;none&gt;<br>
    * Notes:      This override is for error handling to show error message and<br>
    *             return 'adm-error'.
    */
   public void restartServerObject()
   {
      character cMsg = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         silent(() -> ControlFlowOps.runSuper("restartServerObject"));
         
         /* Handles only one message, which is sufficent with the current appserver 
             class */
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
         {
            cMsg.assign(entry(1, ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()), chr(4)));
            /*{fnarg showMessage cMsg}.*/
            ControlFlowOps.invokeInWithMode("showMessageProcedure", targetProcedure(), "IO", cMsg, glShowMessageAnswer);
            returnError("ADM-ERROR");
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void retrieveFilter()
   {
      handle hContainerSource = TypeFactory.handle();
      character cContainerName = TypeFactory.character();
      character cSdoName = TypeFactory.character();
      character cSdoSignature = TypeFactory.character();
      rowid rRowid = TypeFactory.rowid();
      character cFilterSettings = TypeFactory.character();
      character cRunAttribute = TypeFactory.character();
      character cFieldNames = TypeFactory.character();
      character cFieldValues = TypeFactory.character();
      character cFieldOperators = TypeFactory.character();
      character cEmptyString = TypeFactory.character();
      logical lSuccess = TypeFactory.logical();
      character cQuerySort = TypeFactory.character();
      character cManualAddQueryWhere = TypeFactory.character();
      integer iLoop = TypeFactory.integer();
      character cEntry = TypeFactory.character();
      character cBuffer = TypeFactory.character();
      character cSdosettings = TypeFactory.character();
      integer iRowsToBatch = TypeFactory.integer();
      logical lRebuildOnRepos = TypeFactory.logical();
      character cDataContainerName = TypeFactory.character();
      logical lQueryObject = TypeFactory.logical();
      handle hSboContainer = TypeFactory.handle();
      integer iCnt = TypeFactory.integer();
      character cTableName = TypeFactory.character();
      character cQualifiedFieldList = TypeFactory.character();
      character cQualifiedField = TypeFactory.character();
      character cField = TypeFactory.character();
      character cQueryString = TypeFactory.character();
      character cNewQueryString = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* RETRIEVAL OF FILTER IS DEPENDANT UPON LINKS WHICH ONLY EXIST CLIENT-SIDE */
         if (_or(SessionUtils.isRemote(), () -> isEqual(LogicalTerminal.getClientType(), "WEBSPEED")))
         {
            returnNormal();
         }
         
         if ((gshProfileManager.isValid()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
            cSdoName.assign(ghProp.unwrapBufferField().value());
            
            if (_or(isEqual(cSdoName, ""), () -> isUnknown(cSdoName)))
            {
               cSdoName.assign(targetProcedure().unwrapFile().getFileName());
            }
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
            hContainerSource.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
            cContainerName.assign(ghProp.unwrapBufferField().value());
            
            if (_or(isEqual(cContainerName, ""), () -> isUnknown(cContainerName)))
            {
               cContainerName.assign(hContainerSource.unwrapFile().getFileName());
            }
            
            ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
            lQueryObject.assign(ghProp.unwrapBufferField().value());
            
            if ((lQueryObject).booleanValue())
            {
               cDataContainerName.assign(cContainerName);
               ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
               hSboContainer.assign(ghProp.unwrapBufferField().value());
               
               if ((hSboContainer.isValid()).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, hSboContainer.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
                  cContainerName.assign(ghProp.unwrapBufferField().value());
                  
                  if (_or(isEqual(cContainerName, ""), () -> isUnknown(cContainerName)))
                  {
                     cContainerName.assign(hSboContainer.unwrapFile().getFileName());
                  }
               }
            }
            else
            {
               cDataContainerName.assign("");
            }
            cSdoSignature.assign(concat(cSdoName, ",", cDataContainerName, ",", cContainerName, ",", cRunAttribute));
            rRowid.setUnknown();
            ControlFlowOps.invokeInWithMode("getProfileData", gshProfileManager, "IIIIUO", new character("BrwFilters"), new character("FilterSet"), cSdoSignature, new logical(false), rRowid, cFilterSettings);
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ManualAddQueryWhere"));
            cManualAddQueryWhere.assign(ghProp.unwrapBufferField().value());
            
            if (_and(isNotEqual(cFilterSettings, ""), () -> isEqual(numEntries(cFilterSettings, chr(3)), 3)))
            {
               cFieldNames.assign(entry(1, cFilterSettings, chr(3)));
               cFieldValues.assign(entry(2, cFilterSettings, chr(3)));
               cFieldOperators.assign(entry(3, cFilterSettings, chr(3)));
               /* clear the existing selection, get the sort first  */
               /* {get Prop var [handle]} */ 
               cQuerySort.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQuerySort", targetProcedure()));
               /* {set Prop value [handle]} */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryWhere", targetProcedure(), "I", cEmptyString);
               
               if (_isGreaterThan(cQuerySort, ""))
               {
                  /* {set Prop value [handle]} */ 
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQuerySort", targetProcedure(), "I", cQuerySort);
               }
               
               IntegerExpression resExpr3 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(cManualAddQueryWhere, chr(4));
                  }
               };
               ToClause toClause3 = new ToClause(iLoop, 1, resExpr3);
               
               doTo("loop1", toClause3, new Block((Body) () -> 
               {
                  cEntry.assign(entry(iLoop, cManualAddQueryWhere, chr(4)));
                  
                  if (_isNotEqual(numEntries(cEntry, chr(3)), 3))
                  {
                     next("loop1");
                  }
                  
                  cBuffer.assign(entry(2, cEntry, chr(3)));
                  
                  if (_isEqual(cBuffer, "?"))
                  {
                     cBuffer.assign("");
                  }
                  
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "addQueryWhere", targetProcedure(), "III", entry(1, cEntry, chr(3)), cBuffer, entry(3, cEntry, chr(3)));
               }));
               
               /* Set FilterActive property true if filter was applied */
               if (_isNotEqual(cFieldNames, ""))
               {
                  /* {set Prop value [handle]} */ 
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setFilterActive", targetProcedure(), "I", true);
               }
               
               /* assign the retrieved criteria */
               lSuccess.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignQuerySelection", targetProcedure(), "III", cFieldNames, cFieldValues, cFieldOperators));
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryString"));
               cQueryString.assign(ghProp.unwrapBufferField().value());
               
               if (_and(and(isGreaterThan(indexOf(cQueryString, "OUTER-JOIN"), 0), () -> isGreaterThan(numEntries(cFieldNames), 0)), () -> gshSessionManager.isValid()))
               {
                  IntegerExpression resExpr4 = new IntegerExpression()
                  {
                     public integer execute()
                     {
                        return numEntries(cFieldNames);
                     }
                  };
                  ToClause toClause4 = new ToClause(iCnt, 1, resExpr4);
                  
                  doTo("loopLabel25", toClause4, new Block((Body) () -> 
                  {
                     cField.assign(entry(iCnt, cFieldNames));
                     
                     if (_isEqual(numEntries(cField, "."), 1))
                     {
                        cTableName /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnTable", targetProcedure(), "I", cField));
                        cTableName.assign(_isEqual(numEntries(cTableName, "."), 2) ? entry(2, cTableName, ".") /* Remove db qualifier if one has been returned */ : cTableName);
                        cQualifiedField.assign(concat(cTableName, ".", cField));
                     }
                     else
                     {
                        cQualifiedField.assign(cField);
                     }
                     
                     cQualifiedFieldList.assign(concat(cQualifiedFieldList, cQualifiedField, ","));
                  }));
                  
                  cQualifiedFieldList.assign(rightTrim(cQualifiedFieldList, ","));
                  cNewQueryString.assign(ControlFlowOps.invokeDynamicFunctionInWithMode("filterEvaluateOuterJoins", gshSessionManager, "II", cQueryString, cQualifiedFieldList));
                  
                  /* The OUTER-JOIN keyword has now been removed.  Update the query if necessary. */
                  if (_isNotEqual(cNewQueryString, cQueryString))
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("queryString"));
                     ghProp.unwrapBufferField().changeValue(cNewQueryString);
                  }
                  /* {set Prop value [handle]} */ 
               }
            }
            else
            {
               if (_isGreaterThan(cManualAddQueryWhere, ""))
               {
                  /* Ensure any manualaddquerywhere statements are actioned set-up in 
                               initializeobject of an sdo clear the existing selection */
                  /* {get Prop var [handle]} */ 
                  cQuerySort.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQuerySort", targetProcedure()));
                  /* {set Prop value [handle]} */ 
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryWhere", targetProcedure(), "I", cEmptyString);
                  
                  if (_isGreaterThan(cQuerySort, ""))
                  {
                     /* {set Prop value [handle]} */ 
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQuerySort", targetProcedure(), "I", cQuerySort);
                  }
                  
                  IntegerExpression resExpr5 = new IntegerExpression()
                  {
                     public integer execute()
                     {
                        return numEntries(cManualAddQueryWhere, chr(4));
                     }
                  };
                  ToClause toClause5 = new ToClause(iLoop, 1, resExpr5);
                  
                  doTo("loop2", toClause5, new Block((Body) () -> 
                  {
                     cEntry.assign(entry(iLoop, cManualAddQueryWhere, chr(4)));
                     
                     if (_isNotEqual(numEntries(cEntry, chr(3)), 3))
                     {
                        next("loop2");
                     }
                     
                     cBuffer.assign(entry(2, cEntry, chr(3)));
                     
                     if (_isEqual(cBuffer, "?"))
                     {
                        cBuffer.assign("");
                     }
                     
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "addQueryWhere", targetProcedure(), "III", entry(1, cEntry, chr(3)), cBuffer, entry(3, cEntry, chr(3)));
                  }));
               }
            }
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("rowsToBatch"));
            iRowsToBatch.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("rebuildOnRepos"));
            lRebuildOnRepos.assign(ghProp.unwrapBufferField().value());
            ControlFlowOps.invokeInWithMode("setProfileData", gshProfileManager, "IIIIIII", new character("SDO"), new character("Attributes"), concat(cSdoSignature, ",defAttrs"), new unknown(), concat(valueOf(iRowsToBatch), chr(3), valueOf(lRebuildOnRepos)), new logical(false), new character("SES"));
            rRowid.setUnknown();
            ControlFlowOps.invokeInWithMode("getProfileData", gshProfileManager, "IIIIUO", new character("SDO"), new character("Attributes"), cSdoSignature, new logical(false), rRowid, cSdosettings);
            
            if (_isEqual(numEntries(cSdosettings, chr(3)), 2))
            {
               silent(() -> 
               {
                  iRowsToBatch.assign(new integer(entry(1, cSdosettings, chr(3))));
                  lRebuildOnRepos.assign(isEqual(entry(2, cSdosettings, chr(3)), "YES"));
               });
               
               if (_isGreaterThan(iRowsToBatch, 0))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("rowstobatch"));
                  ghProp.unwrapBufferField().changeValue(iRowsToBatch);
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("rebuildonrepos"));
                  ghProp.unwrapBufferField().changeValue(lRebuildOnRepos);
               }
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void returnObjectHandle(final handle phObject_1)
   {
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(phObject_1);
      }, 
      (Body) () -> 
      {
         phObject_1.assign(targetProcedure());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To pass on the flag which indicates when a SmartDataObject row <br>
    *              has been changed locally but not committed. This gets passed on <br>
    *              until it reaches the Commit Panel or other first Commit-Source.<br>
    * <p>
    * Parameters:<br>
    *   INPUT pcState - the new state<br>
    * <p>
    * Notes:       This SmartDataObject version doesn't do anything itself with <br>
    *              the state setting, but simply passes it on up the chain
    */
   public void rowObjectState(final character _pcState)
   {
      character pcState = TypeFactory.initInput(_pcState);
      
      internalProcedure(new Block((Body) () -> 
      {
         NamedEventManager.publish("rowObjectState", targetProcedure(), "I", new Object[]
         {
            pcState
         });
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  See and use getContextAndDestroy.   <br>
    *   Notes:  kept for backwards compatibility.<br>
    *        -  A more consistent and balanced set of functions and methods for <br>
    *           context management has been implemented.
    */
   public void saveContextAndDestroy(final character pcContext_1)
   {
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcContext_1);
      }, 
      (Body) () -> 
      {
         ControlFlowOps.invokeInWithMode("getContextAndDestroy", targetProcedure(), "O", pcContext_1);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To fetch the requested number of rows (views) from the DB Query<br>
    *              and to create corresponding records in the Row Object Temp-Table.<br>
    *              The batch will typically start at row indicated by the pcRowIdent<br>
    *              parameter, but may start on the row indicated by the piStartRow<br>
    *              parameter.<br>
    * Parameters:<br>
    *    INPUT piStartRow      - RowNum to start on. (? indicates that pcRowIdent<br>
    *                           will determine the start of the batcvh to be <br>
    *                            returned.) <br>
    *    INPUT pcRowIdent      - An alternative to StartRow. pcRowIdent is either<br>
    *                            "FIRST", "LAST" or a comma delimited list of DB<br>
    *                            ROWIDs.  If it is "FIRST" (or "LAST") then the <br>
    *                            first (or last) batch of records in the data set<br>
    *                            are retrieved and piStartRow is forced to ?. If<br>
    *                            pcRowIdent is a comma delimited list of DB ROWIDs<br>
    *                            then the batch will start with a RowObject<br>
    *                            comprised of those records.<br>
    *                         - Can also contain a query expression for reposition. <br>
    *                           The expression must have at least one space. <br>
    *                         - Special signals <br>
    *                           Appended with +   <br>
    *                                                                             <br>
    *    INPUT plNext          - TRUE if query should perform NEXT/PREV (depending<br>
    *                            on the direction of navigation) before starting<br>
    *                            to return more rows.  In otherwords, "SKIP" to <br>
    *                            the next record at the start of the batch. <br>
    *    INPUT piRowsToReturn  - Maximum number of rows to be returned (negative<br>
    *                            to move backwards in the result set)<br>
    *                            0 to retrieve ALL rows in the dataset (forward) .<br>
    *    OUTPUT piRowsReturned - Actual number of rows returned.<br>
    *     <br>
    *   Notes:       Before returning, sendRows repositions the RowObject query to<br>
    *                what was the current row when it started. The pcRowIdent<br>
    *                argument is used by fetchRowIdent to allow query repositioning<br>
    *                to a specific db query row.
    */
   public void sendRows(final integer _piStartRow, final character _pcRowIdent_4, final logical _plNext, final integer _piRowsToReturn, final integer piRowsReturned)
   {
      integer piStartRow = TypeFactory.initInput(_piStartRow);
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      logical plNext = TypeFactory.initInput(_plNext);
      integer piRowsToReturn = TypeFactory.initInput(_piRowsToReturn);
      handle hQuery = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      handle hDataQuery = TypeFactory.handle();
      character cAsdivision = TypeFactory.character();
      character cRowObjectstate = TypeFactory.character();
      logical lNexting = TypeFactory.logical();
      character cFetchOnOpen = TypeFactory.character();
      logical lOpened = TypeFactory.logical();
      logical lAppend = TypeFactory.logical();
      logical lFill = TypeFactory.logical();
      integer iLength = TypeFactory.integer();
      character cMode = TypeFactory.character();
      character cLastResultRow = TypeFactory.character();
      character cFirstResultRow = TypeFactory.character();
      character cQueryString = TypeFactory.character();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(piRowsReturned, new integer(0));
      }, 
      (Body) () -> 
      {
         /* The RowObjectState property signals whether there are uncommitted
              changes. If so, we cannot get more rows from the database until
              changes are committed. */
         /* {get Prop var [handle]} */ 
         cRowObjectstate.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", targetProcedure()));
         
         if (_isEqual(cRowObjectstate, "RowUpdated"))
         {
            returnNormal();
         }
         
         /* Filter out invalid input parameters */
         if (_isEqual(piStartRow, 0))
         {
            piStartRow.setUnknown();
         }
         
         if (_isGreaterThan(lookup(pcRowIdent_4, "FIRST,LAST"), 0))
         {
            piStartRow.setUnknown();
            plNext.assign(false);
         }
         
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         
         /* Remove client sort (can only be applied if isDataQueryComplete */
         if (_and(isNotEqual(cAsdivision, "Server"), () -> new logical(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "isDataQueryComplete", targetProcedure()))) /* {fn <func-name> [handle] */)
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataQueryString"));
            cQueryString.assign(ghProp.unwrapBufferField().value());
            cQueryString.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "newQuerySort", targetProcedure(), "III", cQueryString, "", false));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataQueryString"));
            ghProp.unwrapBufferField().changeValue(cQueryString);
         }
         
         /* Find out whether we're running with a query on an AppServer.
              If so then run a special client-to-server version of sendRows.*/
         if (_isEqual(cAsdivision, "Client"))
         {
            ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character("WAIT"));
            
            /* piRowsToReturn = 0 tells that this is an append (RebuildOnRepos=false) */
            if (_or(isEqual(pcRowIdent_4, "FIRST"), () -> and(isEqual(pcRowIdent_4, "LAST"), () -> isNotEqual(piRowsToReturn, 0))))
            {
               /* {fnarg <func-name> <arg> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "emptyRowObject", targetProcedure(), "I", "reset");
            }
            
            ControlFlowOps.invokeInWithMode("clientSendRows", targetProcedure(), "IIIIO", piStartRow, pcRowIdent_4, plNext, piRowsToReturn, piRowsReturned);
            ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character(""));
            returnNormal();
         }
         else
         {
            if (_isEqual(cAsdivision, "Server"))
            {
               /* {fnarg <func-name> <arg> [handle] */ 
                /* Always empty RowObject on Server */ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "emptyRowObject", targetProcedure(), "I", "");
            }
         }
         
         /* Unknown or 0 means get all, the code below checks for the 0. 
              We do not change this on the client as it used to indicate LAST */
         if (_isUnknown(piRowsToReturn))
         {
            piRowsToReturn.assign(0);
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LastResultRow"));
         cLastResultRow.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstResultRow"));
         cFirstResultRow.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryHandle"));
         hQuery.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         
         if (_not(hQuery.unwrapQuery().isOpen()))
         {
            /* {get Prop var [handle]} */ 
            cFetchOnOpen.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getFetchOnOpen", targetProcedure()));
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setFetchOnOpen", targetProcedure(), "I", "");
            hDataQuery.unwrapQuery().queryClose();
            /* just avoid closeQuery */
            /* {fn <func-name> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionIn(logical.class, "openQuery", targetProcedure());
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setFetchOnOpen", targetProcedure(), "I", cFetchOnOpen);
            lOpened.assign(true);
         }
         
         if ((hQuery.unwrapQuery().isOpen()).booleanValue())
         {
            ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character("WAIT"));
            lNexting.assign(isGreaterThanOrEqual(piRowsToReturn, 0));
            
            if (_and(isEqual(pcRowIdent_4, "LAST"), () -> isEqual(piRowsToReturn, 0)))
            {
               cMode.assign("LAST");
               lAppend.assign(true);
            }
            else
            {
               if (_isGreaterThan(pcRowIdent_4, ""))
               {
                  /* First close the RowObject query and empty the current temp-table. 
                           Reset all the associated properties and variables.
                           Special case: If RowNum is also specified, then
                           the caller wants to *refresh* one or more rows starting with
                           pcRowIdent, and to give them numbers starting with
                           piStartRow, so in that case, don't empty the current temp-table. */
                  if (_isUnknown(piStartRow))
                  {
                     /* IF Local (NOT Server and we don't get here if Client) */
                     if (_isNotEqual(cAsdivision, "Server"))
                     {
                        hDataQuery.unwrapQuery().queryClose();
                     }
                     
                     if ((matchesList("LAST,FIRST", pcRowIdent_4)).booleanValue())
                     {
                        lAppend.assign(false);
                        cMode.assign(pcRowIdent_4);
                     }
                     else
                     {
                        lAppend.assign(isEqual(piRowsToReturn, 0));
                         /* 0 indicates appending search */iLength.assign(length(pcRowIdent_4));
                        
                        /* Special trick-1 appended '+' means start from as rebuild is false */
                        if (_isEqual(substring(pcRowIdent_4, iLength, 1), "+"))
                        {
                           lAppend.assign(true);
                        }
                        else
                        {
                           if (_isEqual(substring(pcRowIdent_4, iLength, 1), "-"))
                           {
                              lFill.assign(true);
                           }
                        }
                        
                        if (_or(lFill, lAppend))
                        {
                           pcRowIdent_4.assign(substring(pcRowIdent_4, 1, minus(iLength, 1)));
                        }
                        
                        if ((lNexting).booleanValue())
                        {
                           cMode.assign("REPOSITION");
                           
                           if (_isEqual(plNext, true))
                           {
                              cMode.assign("REPOSITION-AFTER");
                           }
                        }
                        else
                        {
                           cMode.assign("REPOSITION-TO");
                           
                           if (_isEqual(plNext, true))
                           {
                              cMode.assign("REPOSITION-BEFORE");
                           }
                        }
                     }
                     
                     if (_not(lAppend))
                     {
                        /* {fnarg <func-name> <arg> [handle] */ 
                        ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "emptyRowObject", targetProcedure(), "I", "reset");
                     }
                  }
                  else
                  {
                     cMode.assign("REFRESH");
                     pcRowIdent_4.assign(concat(valueOf(piStartRow), ";", pcRowIdent_4));
                     
                     if (_not(lOpened))
                     {
                        hQuery.unwrapQuery().queryOpen();
                     }
                  }
               }
               else
               {
                  cMode.assign(_isGreaterThanOrEqual(piRowsToReturn, 0) ? new character("NEXT") : new character("PREV"));
                  lAppend.assign(true);
               }
               /* If no rowident is passed then we are batching (or reading the first 
                        batch), so set append flag to pass to transferRows. */
            }
            ControlFlowOps.invokeInWithMode("transferRows", targetProcedure(), "IIIIIO", lAppend, cMode, _or(begins(cMode, "REPOSITION"), () -> isEqual(cMode, "REFRESH")) ? pcRowIdent_4 : new character(""), lFill, abs(piRowsToReturn), piRowsReturned);
            
            /* if failure return current batch */
            if (_and(and(not(lAppend), () -> isEqual(piRowsReturned, 0)), () -> isEqual(cMode, "REPOSITION")))
            {
               /* Avoid this if we do not have info about what was current */
               if (_and(notUnknown(cFirstResultRow), () -> notUnknown(cLastResultRow)))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("LastResultRow"));
                  ghProp.unwrapBufferField().changeValue(cLastResultRow);
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstResultRow"));
                  ghProp.unwrapBufferField().changeValue(cFirstResultRow);
                  ControlFlowOps.invokeInWithMode("transferRows", targetProcedure(), "IIIIIO", lAppend, new character("CURRENT"), new character(""), new logical(false), new integer(0), piRowsReturned);
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryRowident"));
                  ghProp.unwrapBufferField().changeValue(new unknown());
                  /* Tell locally that we have no position */
                  hRowObject.unwrapBuffer().bufferRelease();
               }
            }
            ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character(""));
         }
         /* END IF query IS-OPEN */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    *  Purpose:     Update procedure executed on the server side of a split <br>
    *               SmartDataObject, called from the client Commit function.<br>
    *               Commit passes a set of RowObjUpdate records both have changes to<br>
    *               be committed and their pre-change copies (before-images).  <br>
    *               commitRows verifies that the records have not been changed <br>
    *               since they were read, and then commits the changes to the <br>
    *               database.<br>
    *  Parameters:<br>
    *   INPUT-OUTPUT TABLE RowObjUpd - The Update version of the RowObject <br>
    *                                  Temp-Table<br>
    * <p>
    *   OUTPUT cMessages - a CHR(3) delimited string of accumulated messages from<br>
    *                       server.<br>
    *    OUTPUT cUndoIds  - list of any RowObject ROWIDs whose changes need to be <br>
    *                       undone as the result of errors in the form of:<br>
    *               "RowNumCHR(3)ADM-ERROR-STRING,RowNumCHR(3)ADM-ERROR-STRING,..."<br>
    * <p>
    * Notes:        If another user has modified the database records since the <br>
    *               original was read, the new database values are copied into the <br>
    *               RowObjUpd record and returned to Commit so the UI object can <br>
    *               display them.
    */
   public void serverCommit(final TableParameter _phRowObjUpd_1, final character pcMessages, final character pcUndoIds)
   {
      handle phRowObjUpd_1 = new handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         UndoableFactory.initInputOutput(phRowObjUpd_1);
         TypeFactory.initOutput(pcMessages);
         TypeFactory.initOutput(pcUndoIds);
      }, 
      (Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_phRowObjUpd_1, phRowObjUpd_1, true, true);
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjUpdTable", targetProcedure(), "I", phRowObjUpd_1);
         ControlFlowOps.invokeInWithMode("bufferCommit", targetProcedure(), "OO", pcMessages, pcUndoIds);
         silent(() -> HandleOps.delete(phRowObjUpd_1));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Returns the table-handle of the  Update table<br>
    *              from the server to a dynamic client Data Object.<br>
    * Parameters:  OUTPUT TABLE-HANDLE phRowObjUpd.<br>
    * Notes:       We can't use the getRowObjUpdTable function <br>
    *              because that only returns the HANDLE, to be used by an object <br>
    *              on the same side of the AppServer connection. <br>
    *              This procedure returns the TABLE-HANDLE,<br>
    *              so the entire table definition comes along with it.
    */
   public void serverFetchRowObjUpdTable(final TableParameter _phRowObjUpd_1)
   {
      handle phRowObjUpd_1 = new handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         UndoableFactory.initOutput(phRowObjUpd_1);
      }, 
      (Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_phRowObjUpd_1, phRowObjUpd_1, false, true);
         /* {get Prop var [handle]} */ 
         phRowObjUpd_1.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjUpdTable", targetProcedure()));
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     server-side intermediary for sendRows. serverSendRows is only<br>
    *              called by clientSendRows and only if the SmartDataObject is <br>
    *              split across an AppServer boundary.  It does no processing<br>
    *              but simply runs sendRows passing all parameters on to it and<br>
    *              returning the RowObject table as an output parameter back to<br>
    *              the client which now has the new batch of records created in<br>
    *              sendRows.<br>
    * <p>
    * Parameters:  <br>
    *   INPUT  piStartRow     - The RowNum value of the record to start the batch<br>
    *                           to return.  Typically piStartRow is ? as a flag to <br>
    *                           use pcRowIdent instead of piStartRow.<br>
    *   INPUT  pcRowIdent     - The RowIdent of the first record of the batch to<br>
    *                           to return.  Can also be "FIRST" or "LAST" to force<br>
    *                           the retrieval of the first (or last) batch of <br>
    *                           RowObject records.<br>
    *   INPUT  plNext         - True if serverSendRows is to start on the "next"<br>
    *                           record from what is indicated by piStartRow or<br>
    *                           piRowIdent.<br>
    *   INPUT  piRowsToReturn - The number of rows in a batch.<br>
    *   OUTPUT piRowsReturned - The actual number of rows returned. This number<br>
    *                           will either be the same as piRowsToReturn or<br>
    *                           less when there are not enough records to fill<br>
    *                           up the batch.<br>
    * <p>
    * Notes:       If piStartRow is not 0 or ? then pcRowIdent is ignored.<br>
    *              plNext is ignored if pcRowIdent is "FIRST" or "LAST".<br>
    *              The most common use of piRowsReturned is to indicate that the<br>
    *              entire result list has been returned when it is less than <br>
    *              piRowToReturn.
    */
   public void serverSendRows(final integer _piStartRow, final character _pcRowIdent_4, final logical _plNext, final integer _piRowsToReturn, final integer piRowsReturned, final TableParameter _phRowObject_1)
   {
      integer piStartRow = TypeFactory.initInput(_piStartRow);
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      logical plNext = TypeFactory.initInput(_plNext);
      integer piRowsToReturn = TypeFactory.initInput(_piRowsToReturn);
      handle phRowObject_1 = new handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(piRowsReturned);
         UndoableFactory.initOutput(phRowObject_1);
      }, 
      (Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_phRowObject_1, phRowObject_1, false, true);
         ControlFlowOps.invokeInWithMode("sendRows", targetProcedure(), "IIIIO", piStartRow, pcRowIdent_4, plNext, piRowsToReturn, piRowsReturned);
         /* {get Prop var [handle]} */ 
         phRowObject_1.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", targetProcedure()));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  (Re)set context and initialize this server side object   <br>
    * Parameters: pcContainedProps<br>
    *   Notes: The client now passes serverFirstCall yes to indicate if this <br>
    *          is the first call, but we still support the old trick of passing<br>
    *          ObjectInitialized no as the first entry.
    */
   public void setContextAndInitialize(final character _pcContext_1)
   {
      character pcContext_1 = TypeFactory.initInput(_pcContext_1);
      logical lInitFlag = TypeFactory.logical();
      logical lInitialized = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* Backwards support to identify the first call relying on the 
              client passing ObjectInitialized AS THE FIRST ENTRY.  */
         lInitFlag.assign(begins(pcContext_1, concat("ObjectInitialized", chr(4))));
         
         /* There is no set function and although it's a correct value let's just 
              remove it..  */
         if ((lInitFlag).booleanValue())
         {
            lInitFlag.assign(matchesList("false,no", entry(2, entry(1, pcContext_1, chr(3)), chr(4))));
 /* Let's pay respect the value of Objectinitialized */
            pcContext_1.replaceEntry(1, chr(3), "");
            pcContext_1.assign(trim(pcContext_1, chr(3)));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ServerFirstCall"));
            ghProp.unwrapBufferField().changeValue(new logical(true));
         }
         
         ControlFlowOps.invokeInWithMode("setPropertyList", targetProcedure(), "I", pcContext_1);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitialized.assign(ghProp.unwrapBufferField().value());
         
         if (_not(lInitialized))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("OpenOninit"));
            ghProp.unwrapBufferField().changeValue(new logical(false));
            ControlFlowOps.invokeIn("initializeObject", targetProcedure());
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To set a list of properties taken from a CHR(3) delimitted list<br>
    *              of "propCHR(4)value" pairs.<br>
    * <p>
    * Parameters:  <br>
    *   INPUT pcProperties - the CHR(3) delimitted list of "propCHR(4)value" pairs<br>
    *                        to be set.<br>
    * <p>
    * Notes:
    */
   public void setPropertyList(final character _pcProperties)
   {
      character pcProperties = TypeFactory.initInput(_pcProperties);
      integer iProp = TypeFactory.integer();
      character cProp = TypeFactory.character();
      character cValue = TypeFactory.character();
      integer iCnt = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         iCnt.assign(numEntries(pcProperties, chr(3)));
         
         ToClause toClause6 = new ToClause(iProp, 1, iCnt);
         
         doTo("loopLabel26", toClause6, new Block((Body) () -> 
         {
            cProp.assign(entry(iProp, pcProperties, chr(3)));
            cValue.assign(entry(2, cProp, chr(4)));
            cValue.assign(_isEqual(cValue, "?") ? new character() : cValue);
            cProp.assign(entry(1, cProp, chr(4)));
            /** The call to the signature function has been removed to improve performance
                  and because it was unnecessary as character values will be converted to the 
                  correct data-type implicitly. (Issuezilla #11489)
                
                  Message code removed to avoid issues with attributes being set which are not 
                  available as properties in the object. Objects may conditionally 
                  inherit from classes (Issuezilla # 11481) 
              **/
            silent(() -> ControlFlowOps.invokeDynamicFunctionInWithMode(concat("set", cProp), targetProcedure(), "I", cValue));
         }));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:    When a SmartDataObject is split and running Statelessly on an<br>
    *             AppServer, startServerObject is run on the client to start<br>
    *             the SmartDataObject on the server.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:      This override is for error handling to show error message and<br>
    *             return 'adm-error'.
    */
   public void startServerObject()
   {
      character cMsg = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         silent(() -> ControlFlowOps.runSuper("startServerObject"));
         
         /* Handles only one message, which is sufficent with the current appserver 
              class */
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
         {
            cMsg.assign(entry(1, ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()), chr(4)));
            /*{fnarg showMessage cMsg}. */
            ControlFlowOps.invokeInWithMode("showMessageProcedure", targetProcedure(), "IO", cMsg, glShowMessageAnswer);
            returnError("ADM-ERROR");
         }
         else
         {
            if ((ErrorManager.isError()).booleanValue())
            {
               returnError(ControlFlowOps.getReturnValue());
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Called by submitRow to commit changes to the database.<br>
    * <p>
    * Parameters:  <br>
    *   INPUT pcRowIdent - Identifier of the row to commit.  It is a comma delimited<br>
    *                      list of ROWIDS.  The first entry is the ROWID of the <br>
    *                      RowObject Temp-Table containing the record to commit.<br>
    *                      Subsequent entries (of the comma delimited list) are the<br>
    *                      DB ROWIDs of the records to be modified.<br>
    *   INPUT plReopen   - TRUE if the RowObject query is to be reopened and<br>
    *                      repositioned to the RowObject record identified by <br>
    *                      pcRowIdent.<br>
    * Notes:
    */
   public void submitCommit(final character _pcRowIdent_4, final logical _plReopen)
   {
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      logical plReopen = TypeFactory.initInput(_plReopen);
      logical lAutoCommit = TypeFactory.logical();
      character cReturn = TypeFactory.character();
      rowid rRowObject = TypeFactory.rowid();
      handle hRowObject = TypeFactory.handle();
      character cState = TypeFactory.character();
      logical lQueryContainer = TypeFactory.logical();
      handle hSbo = TypeFactory.handle();
      logical lAutoCommitSbo = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         if ((new logical(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
         {
            /* Add the update cancelled message */
            ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III",  /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 15), new unknown(), new unknown());
            ControlFlowOps.invokeIn("doReturnToAddMode", targetProcedure());
            returnNormal("ADM-ERROR");
         }
         else
         {
            /* Tell others the update is done and to redisplay the rec if appropriate */
            ControlFlowOps.invokeInWithMode("dataAvailable", targetProcedure(), "I", new character("SAME"));
            /* not a different row. */
            /* {get Prop var [handle]} */ 
            lAutoCommit.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAutoCommit", targetProcedure()));
            
            if ((lAutoCommit).booleanValue())
            {
               /* Go ahead with the DB transaction now. */
               ControlFlowOps.invokeIn("commitTransaction", targetProcedure());
               cReturn.assign(ControlFlowOps.getReturnValue());
            }
            else
            {
               cReturn.assign("");
               /* success pending final Commit */
               /* {set Prop value [handle]} */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectState", targetProcedure(), "I", "RowUpdated");
            }
            
            /* END ELSE DO IF Not AutoCommit */
            rRowObject.assign(new rowid(entry(1, pcRowIdent_4)));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
            hRowObject.assign(ghProp.unwrapBufferField().value());
            
            if (_isEqual(cReturn, ""))
            {
               /* {set Prop value [handle]} */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setDataModified", targetProcedure(), "I", false);
               
               /* Check if we are inside an SBO with AutoCommit as the SBO 
                        handles most of the post commit logic in that case */
               if (_not(lAutoCommit))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryContainer"));
                  lQueryContainer.assign(ghProp.unwrapBufferField().value());
                  
                  if ((lQueryContainer).booleanValue())
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                     hSbo.assign(ghProp.unwrapBufferField().value());
                     /* {get Prop var [handle]} */
                     lAutoCommitSbo.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAutoCommit", hSbo));
                  }
               }
               
               /* Avoid calling reopenToRowid and publish dataAvailable if Autocommit SBO*/
               if (_not(lAutoCommitSbo))
               {
                  /* If doCreateUpdate told us to reopen (because a new record was added 
                             to the RowObject table), re-open the RowObject Query and reposition 
                             to the newly added row. */
                  if ((plReopen).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("reopenToRowid", targetProcedure(), "I", rRowObject);
                  }
                  
                  /* From 9.1B+ we also publish uncommitted changes. */
                  /* From 9.1B+ we also publish uncommitted changes. */
                  /* we use 'RESET' for uncommitted new records, as this 
                                       will reset panels and only reopen if child has 
                                       no changes */
                  cState.assign((_not(plReopen) ? new character("SAME") : (lAutoCommit).booleanValue() ? new character("DIFFERENT") : new character("RESET")));
                  /* Note that submitForeignKey currently still is getting
                             the ForeignFields from the parent instead of from the ForeignValues 
                             if the source is NewRow and RowObjectState is 'RowUpdated'.
                             This is probably not necessary now as 'reset' sets Foreignvalues.*/
                  NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
                  {
                     cState
                  });
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
                  ghProp.unwrapBufferField().changeValue(new character(""));
               }
            }
            else
            {
               if (_or(not(hRowObject.unwrapBuffer().available()), () -> isNotEqual(rRowObject, hRowObject.unwrapBuffer().rowID())))
               {
                  /* A failed record is not in the query so we cannot reposition */
                  hRowObject.unwrapBuffer().findByRowID(rRowObject);
               }
            }
         }
         /* END DO IF no validation errors */
         returnNormal(cReturn);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Called from submitRow to define Foreign Key values for a new row.<br>
    * <p>
    * Parameters:<br>
    *   INPUT pcRowIdent          - The RowIdent (a comma delimited list of ROWIDs<br>
    *                               that uniquely identify the RowObject record) of<br>
    *                               the new RowObject record to be stored in the<br>
    *                               database.  Since this is a new record, only the<br>
    *                               first ROWID (that of the RowObject itself) is<br>
    *                               valid.  There are no DB ROWIDs because they<br>
    *                               have not yet been created.                                <br>
    *   INPUT-OUTPUT pcValueList  - A CHR(1) delimited list of ForeignField column<br>
    *                               and value pairs to be set in the RowObject <br>
    *                               record identified by pcRowIdent.  On input it is<br>
    *                               a list that has been set before submitForeignKey<br>
    *                               was called.  On output it is the now current list<br>
    *                               of foreign fields that have been set.<br>
    *   INPUT-OUTPUT pcUpdColumns - A comma delimited list of column names that are<br>
    *                               updatable in the SDO.<br>
    *                               <br>
    *   Notes:     The list of udpdatable fields (pcUpdColumns - derived from the<br>
    *              UpdatableColumns property in submitRow) usually doesn't<br>
    *              contain key fields. However, because submitForiegnKey is called<br>
    *              when creating a new RowObject record, key fields need to be <br>
    *              populated so pcUpdColumns is expanded to allow for this.  <br>
    *              However, only the variable pcUpdColumns is expanded, the <br>
    *              UpdatableColumns property remains unchanged.
    */
   public void submitForeignKey(final character _pcRowIdent_4, final character pcValueList_3, final character pcUpdColumns)
   {
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      character cForFields = TypeFactory.character();
      character cForValues = TypeFactory.character();
      character cDataColumns = TypeFactory.character();
      integer iCol = TypeFactory.integer();
      character cField = TypeFactory.character();
      character cCurrField = TypeFactory.character();
      handle hSource = TypeFactory.handle();
      character cValue = TypeFactory.character();
      character cRowObjectState = TypeFactory.character();
      logical lNewSource = TypeFactory.logical();
      logical lLookupParent = TypeFactory.logical();
      logical lQueryContainer = TypeFactory.logical();
      integer iPass = TypeFactory.integer();
      logical lNew = TypeFactory.logical();
      character cForName = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* If this is a newly Added row, and there are Foreign Fields, 
              assign those values to the RowObject columns. */
         /* {get Prop var [handle]} */ 
         lNew.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getNewRow", targetProcedure()));
         
         if ((lNew).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryContainer"));
            lQueryContainer.assign(ghProp.unwrapBufferField().value());
            
            IntegerExpression resExpr6 = new IntegerExpression()
            {
               public integer execute()
               {
                  return ((lQueryContainer).booleanValue() ? new integer(2) : new integer(1));
               }
            };
            ToClause toClause7 = new ToClause(iPass, 1, resExpr6);
            
            doTo("loopLabel27", toClause7, new Block((Body) () -> 
            {
               switch (StringHelper.safeTrimTrailing((iPass).toStringMessage()))
               {
                  case "1":
                     {
                        /* {get Prop var [handle]} */ 
                        cForFields.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getForeignFields", targetProcedure()));
                     }
                     break;
                  case "2":
                     {
                        cForFields /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getForeignFieldsContainer", targetProcedure()));
                     }
                     break;
               }
               
               if (_isNotEqual(cForFields, ""))
               {
                  if (_isEqual(iPass, 1))
                  {
                     /* {get Prop var [handle]} */ 
                     hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
                  }
                  else
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                     hSource.assign(ghProp.unwrapBufferField().value());
                     /* {get Prop var [handle]} */
                     hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hSource));
                  }
                  
                  /* if child runs stand-alone foreign fields don't matter */
                  if ((hSource.isValid()).booleanValue())
                  {
                     /* {get Prop var [handle]} */
                     cRowObjectState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", hSource));
                     /* {get Prop var [handle]} */
                     lNewSource.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getNewRow", hSource));
                     
                     /* if multiple add for one-to-one or otherwise uncommitted new parent
                                  get the foreignkey from the source, becasue submitcommit does not 
                                  publish DataAvailable under these circumstances (new/autocommit off) 
                                 NOTE: This is no longer true, but was changed too late to mess with it*/
                     if (_and(isEqual(cRowObjectState, "RowUpdated"), lNewSource))
                     {
                        lLookupParent.assign(true);
                     }
                     else
                     {
                        ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
                        cForValues.assign(ghProp.unwrapBufferField().value());
                     }
                     /* {get Prop var [handle]} */ 
                     
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("DataColumns"));
                     cDataColumns.assign(ghProp.unwrapBufferField().value());
                     
                     IntegerExpression resExpr7 = new IntegerExpression()
                     {
                        public integer execute()
                        {
                           return numEntries(cForFields);
                        }
                     };
                     ToClause toClause8 = new ToClause(iCol, 1, resExpr7, new integer(2));
                     
                     doTo("loopLabel28", toClause8, new Block((Body) () -> 
                     {
                        /* Make sure this works with unqualified field */
                        cCurrField.assign(entry(iCol, cForFields));
                        cField.assign(entry(numEntries(cCurrField, "."), cCurrField, "."));
                        
                        if (_and(isNotEqual(lookup(cField, cDataColumns), 0), () -> isEqual(lookup(cField, pcValueList_3, chr(1)) /* It's in the SDO, and */, 0)))
                        {
                           cForName.assign(entry(plus(iCol, 1), cForFields));
                           cValue.assign(_not(lLookupParent) ? entry(new integer(divide(plus(iCol, 1), 2)), cForValues, chr(1)) : ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnValue", hSource, "I", cForName));
                           pcValueList_3.assign(concat(cField, chr(1), cValue, (_isEqual(pcValueList_3, "") ? new character("") : chr(1)), pcValueList_3));
                           /* Make it updatable for Add if not already */
                           pcUpdColumns.assign(concat(cField, ",", pcUpdColumns));
                        }
 /* not already assigned */;
                     }));
                  }
               }
            }));
         }
         /* END DO IF "New"     */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To do validation on each of the columns of the a new RowObject <br>
    *              record, and on the record as a whole,  before committing it <br>
    *              to the database.<br>
    * <p>
    * Parameters:<br>
    *   INPUT pcValueList  - A CHR(1) delimited list of Column Name&lt;-&gt;value pairs<br>
    *                        that need validation before committing a transaction.<br>
    *   INPUT pcUpdColumns - A comma delimited list of the SmartDataObject columns<br>
    *                        that are updatable.<br>
    * <p>
    * Notes:       There are three types of validation performed:<br>
    *                1) Newly entered data meets the format criteria.<br>
    *                2) Newly entered data is in an updatable field.<br>
    *                3) Any developer defined validation in the form of a<br>
    *                   (FieldName)Validation procedure.<br>
    *                4) Any developer defined validation in the form of a<br>
    *                   RowObjectValidation procedure for the whole row.<br>
    *        - Developer defined validation in the form (FieldName)Validation  <br>
    *          must be either in the Logic Procedure or in the static SDO. <br>
    *          If any field validation procedure is found in the static SDO<br>
    *          the rest is also assumed to be there.
    */
   public void submitValidation(final character _pcValueList_3, final character _pcUpdColumns)
   {
      character pcValueList_3 = TypeFactory.initInput(_pcValueList_3);
      character pcUpdColumns = TypeFactory.initInput(_pcUpdColumns);
      integer iColNum = TypeFactory.integer();
      character cColName = TypeFactory.character();
      handle hCol = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      character cValue = TypeFactory.character();
      handle hLogicObject = TypeFactory.handle();
      handle hValRowObject = TypeFactory.handle();
      logical lLocalVal = TypeFactory.logical();
      logical lLocalFieldVal = TypeFactory.logical();
      logical lAnyFieldVal = TypeFactory.logical();
      character cDataFieldDefs = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLogicObject"));
         hLogicObject.assign(ghProp.unwrapBufferField().value());
         
         if ((hLogicObject.isValid()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataFieldDefs"));
            cDataFieldDefs.assign(ghProp.unwrapBufferField().value());
            /* Set the buffer in the logic procedure and also return the handle
                   so that it is the Logic procedure buffer values that are passed 
                   as input to the field validation procedures */
            ControlFlowOps.invokeInWithMode("setLogicBuffer", targetProcedure(), "II", hRowObject, new unknown());
            ControlFlowOps.invokeInWithMode("getLogicBuffer", targetProcedure(), "O", hValRowObject);
         }
         else
         {
            hValRowObject.assign(hRowObject);
            lLocalFieldVal.assign(true);
         }
         
         IntegerExpression resExpr8 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(pcValueList_3, chr(1));
            }
         };
         ToClause toClause9 = new ToClause(iColNum, 1, resExpr8, new integer(2));
         
         doTo("loopLabel29", toClause9, new Block((Body) () -> 
         {
            cColName.assign(entry(iColNum, pcValueList_3, chr(1)));
            silent(() -> hCol.assign(hValRowObject.unwrapBuffer().bufferField(cColName)));
            
            if (_isUnknown(hCol))
            {
               /* {fnarg <func-name> <arg> [handle] */ 
               ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", substitute(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 53), cColName), cColName, new unknown());
            }
            else
            {
               /* Verify that they're not trying to update a non-enabled field. */
               if (_isEqual(lookup(cColName, pcUpdColumns), 0))
               {
                  /* {fnarg <func-name> <arg> [handle] */ 
                  ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", substitute(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 54), cColName), cColName, new unknown());
               }
               else
               {
                  cValue.assign(entry(plus(iColNum, 1), pcValueList_3, chr(1)));
                  /* Check for unknown values in the list of changes. */
                  silent(() -> hCol.unwrapBufferField().changeValue(_isEqual(cValue, "?") ? new character() : cValue));
                  
                  /* Allow for the possibility that the value they entered in the 
                             View object may be completely invalid for the format associated 
                             with the Frame field. */
                  if ((ErrorManager.isError()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", new unknown() /* Use GET-MESSAGE */, cColName, new unknown());
                  }
                  else
                  {
                     /* If there's a field validation procedure, run it. */
                     silent(() -> ControlFlowOps.invokeInWithMode((concat(hCol.unwrap().name(), "Validate")).toStringMessage(), targetProcedure(), "I", hCol.unwrapBufferField().value()));
                     
                     if (_not(isEqual(ErrorManager.getErrorNumber(1), 6456)))
                     {
                        if (_not(lAnyFieldVal))
                        {
                           lAnyFieldVal.assign(true);
                        }
                        
                        /* The expectation is that such a procedure will return an error 
                                       message if there is one; we will log it for the column. 
                                       Otherwise the code assumes that an error-status simply means 
                                       there wasn't a validate procedure for this column. 
                                       We keep going even if there's a field error. */
                        if (_or(ErrorManager.isError(), () -> isNotEqual(ControlFlowOps.getReturnValue(), "")))
                        {
                           ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", _isNotEqual(ControlFlowOps.getReturnValue(), "") ? ControlFlowOps.getReturnValue() : ErrorManager.getErrorText(1), hCol.unwrap().name(), new unknown());
                        }
                        
                        /* if we are using a logic procedure check if the FieldVal is local
                                       also ensure that we use the SDO's buffer from now on  */
                        if (_and(and(isGreaterThan(cDataFieldDefs, ""), not(lLocalFieldVal)), () -> isGreaterThan(lookup(concat(hCol.unwrap().name(), "Validate"), targetProcedure().unwrapProcedure().internalEntries()), 0)))
                        {
                           lLocalFieldVal.assign(true);
                           hValRowObject.assign(hRowObject);
                        }
                     }
                  }
               }
            }
         }));
         
         /* END DO for each updated column */
         lLocalVal.assign(or(not(hLogicObject.isValid()), () -> isGreaterThan(lookup("RowObjectValidate", targetProcedure().unwrapProcedure().internalEntries()), 0)));
         
         /* If we have a logic procedure we may need to copy the data from where 
              the field validation is to where the rowObjectValidate is before we call it.
              If no field validation there's no need as the copy was done above */
         if (_and(hLogicObject.isValid(), lAnyFieldVal))
         {
            if (_and(not(lLocalFieldVal), lLocalVal))
            {
               hRowObject.unwrapBuffer().bufferCopy(hValRowObject);
            }
            else
            {
               if (_and(lLocalFieldVal, not(lLocalVal)))
               {
                  ControlFlowOps.invokeInWithMode("setLogicBuffer", targetProcedure(), "II", hRowObject, new unknown());
               }
            }
         }
         silent(() -> ControlFlowOps.invokeIn("RowObjectValidate", targetProcedure()));
         
         /* Procedure was found and executed. */
         if (_and(not(ErrorManager.isError()), () /* Procedure was found and executed. */ -> isNotEqual(ControlFlowOps.getReturnValue(), "")))
         {
            ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", ControlFlowOps.getReturnValue(), new unknown(), new unknown());
         }
         
         if ((hLogicObject.isValid()).booleanValue())
         {
            /* if RowObjectValidation is local we got the values back before we called 
                   it (if we needed to) */
            if (_not(lLocalVal))
            {
               hRowObject.unwrapBuffer().bufferCopy(hValRowObject);
            }
            
            ControlFlowOps.invokeIn("clearLogicRows", targetProcedure());
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Output requested fields of SDO in standard temp-table<br>
    * Parameters:  input field list<br>
    *              input include object fields yes/no<br>
    *              input maximum records to process<br>
    *              output temp-table of data from sdo<br>
    *              output number of records extracted<br>
    * <p>
    * Notes:       Temp table is defined in afttsdoout.i<br>
    *              Fields passed in are checked with a can-do so supportfor all<br>
    *              or !field to exclude a field, e.g.<br>
    *              "!RowNum,!RowIdent,!RowMod," would use all non SDO specific<br>
    *              fields.<br>
    *              For fields passed in - do NOT use a table prefix<br>
    *              The temp table contains a record per record/field combination
    */
   public void tableOut(final character _pcFieldList, final logical _plIncludeObj, final integer _piMaxRecords, final TableParameter tttableBuf2, final integer iExtractedRecs)
   {
      character pcFieldList = TypeFactory.initInput(_pcFieldList);
      logical plIncludeObj = TypeFactory.initInput(_plIncludeObj);
      integer piMaxRecords = TypeFactory.initInput(_piMaxRecords);
      integer iRowNum = TypeFactory.integer();
      integer iColNum = TypeFactory.integer();
      integer iPosn = TypeFactory.integer();
      integer iField = TypeFactory.integer();
      logical lAvailable = TypeFactory.logical();
      handle hQuery = TypeFactory.handle();
      handle hBuffer = TypeFactory.handle();
      handle hBufferField = TypeFactory.handle();
      integer iRowsToBatch = TypeFactory.integer();
      integer iNumRecords = TypeFactory.integer();
      character cRowIdent = TypeFactory.character();
      /* Variables for Security Check of Fields */
      character cQueryPosition = TypeFactory.character();
      handle hContainerHandle = TypeFactory.handle();
      character cRunAttribute = TypeFactory.character();
      character cContainerName = TypeFactory.character();
      character cSecuredFields = TypeFactory.character();
      character cHiddenFields = TypeFactory.character();
      integer iLoop = TypeFactory.integer();
      character cFieldName = TypeFactory.character();
      character cNewFieldList = TypeFactory.character();
      character cWantedFieldHandles = TypeFactory.character();
      handle hBrowser = TypeFactory.handle();
      handle hBrowseColumn = TypeFactory.handle();
      handle hDataTarget = TypeFactory.handle();
      character cDataTargets = TypeFactory.character();
      character cColumnNames = TypeFactory.character();
      character cColumnHandles = TypeFactory.character();
      handle hNavSource = TypeFactory.handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(iExtractedRecs);
      }, 
      (Body) () -> 
      {
         RecordBuffer.openScope(tttable);
         TemporaryBuffer.associate(tttableBuf2, tttable, false, true);
         hContainerHandle.assign(targetProcedure());
         
         if ((gshSecurityManager.isValid()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
            hContainerHandle.assign(ghProp.unwrapBufferField().value());
            
            if ((hContainerHandle.isValid()).booleanValue())
            {
               silent(() -> 
               {
                  ghProp.assign(handle.fromString(entry(1, hContainerHandle.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
                  cContainerName.assign(ghProp.unwrapBufferField().value());
               });
               silent(() -> cRunAttribute.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRunAttribute", hContainerHandle)));
               
               if (_isEqual(cContainerName, ""))
               {
                  cContainerName.assign(hContainerHandle.unwrapFile().getFileName());
               }
            }
            else
            {
               cContainerName.assign("");
            }
            
            if (_isNotEqual(cContainerName, ""))
            {
               cContainerName.assign(replaceAll(cContainerName, "\\", "/"));
               cContainerName.assign(substring(cContainerName, plus(lastIndexOf(cContainerName, "/"), 1), length(cContainerName)));
            }
            
            ControlFlowOps.invokeInWithMode("fieldSecurityGet", gshSecurityManager, "IIIO", hContainerHandle, cContainerName, cRunAttribute, cSecuredFields);
         }
         cHiddenFields.assign("");
         cNewFieldList.assign("");
         
         /* Check if security on fields have been set */
         if (_isGreaterThan(indexOf(cSecuredFields, "Hidden"), 0))
         {
            loopLabel30:
            for (iLoop.assign(1); _isLessThanOrEqual(iLoop, numEntries(cSecuredFields)); iLoop.increment())
            {
               if (_isEqual(entry(plus(iLoop, 1), cSecuredFields), "Hidden"))
               {
                  cHiddenFields.assign(_isEqual(cHiddenFields, "") ? entry(iLoop, cSecuredFields) : concat(cHiddenFields, ",", entry(iLoop, cSecuredFields)));
               }
               
               iLoop.assign(plus(iLoop, 1));
            }
         }
         
         /* Now Remove the hidden fields from pcFieldList */
         if (_isGreaterThan(indexOf(pcFieldList, "*"), 0))
         {
            loopLabel31:
            for (iLoop.assign(1); _isLessThanOrEqual(iLoop, numEntries(cHiddenFields)); iLoop.increment())
            {
               cHiddenFields.replaceEntry(iLoop, concat("!", entry(iLoop, cHiddenFields)));
            }
            
            pcFieldList.assign(concat(rightTrim(pcFieldList, ",*"), cHiddenFields, ",*"));
         }
         else
         {
            loopLabel32:
            for (iLoop.assign(1); _isLessThanOrEqual(iLoop, numEntries(pcFieldList)); iLoop.increment())
            {
               cFieldName.assign(entry(iLoop, pcFieldList));
               
               if (_isGreaterThan(lookup(cFieldName, cHiddenFields), 0))
               {
                  continue loopLabel32;
               }
               
               cNewFieldList.assign(_isEqual(cNewFieldList, "") ? cFieldName : concat(cNewFieldList, ",", cFieldName));
            }
            
            pcFieldList.assign(cNewFieldList);
         }
         piMaxRecords.assign((_isGreaterThan(piMaxRecords, 0) ? piMaxRecords : new integer(99999999)));
         iNumRecords.assign(0);
         /* Store current position in query */
         silent(() -> cRowIdent.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowIdent", targetProcedure())));
         /* We need to do all this to ensure we don't pick up dataAvailable messages, queryPosition subscribes etc. */
         NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
         {
            "BatchStart"
         });
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NavigationSource"));
         hNavSource.assign(ghProp.unwrapBufferField().value());
         ControlFlowOps.invokeInWithMode("linkStateHandler", targetProcedure(), "III", new character("Inactive"), hNavSource, new character("NavigationSource"));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
         cDataTargets.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr9 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cDataTargets);
            }
         };
         ToClause toClause10 = new ToClause(iLoop, 1, resExpr9);
         
         doTo("dataTargetLoop", toClause10, new Block((Body) () -> 
         {
            silent(() -> hDataTarget.assign(handle.fromString(entry(iLoop, cDataTargets))));
            
            if ((hDataTarget.isValid()).booleanValue())
            {
               if (_and(not(hBrowser.isValid()), () -> new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "instanceOf", hDataTarget, "I", "Browser"))) /* {fnarg <func-name> <arg> [handle] */)
               {
                  /* {get Prop var [handle]} */
                  hBrowser.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getBrowseHandle", hDataTarget));
               }
               
               /* While we're here, disable the data link to improve performance */
               ControlFlowOps.invokeInWithMode("linkStateHandler", hDataTarget, "III", new character("inactive"), targetProcedure(), new character("dataSource"));
            }
         }));
         
         /* Once we have found the browser, build a list of the browse column names and their handles. This is because
          * the only way to retrieve the browser column handle is to use the GET-BROWSE-COLUMN() method, and this uses
          * an ordinal value. We can not depend on the order of the browser columns being the same as the prder of the 
          * fields in the DataObject, so we need to determine the browser column handle from our pre-built lists.    */
         if ((hBrowser.isValid()).booleanValue())
         {
            loopLabel33:
            for (iLoop.assign(1); _isLessThanOrEqual(iLoop, hBrowser.unwrapWidget().getNumColumns()); iLoop.increment())
            {
               hBrowseColumn.assign(hBrowser.unwrapBrowse().getBrowseColumn(iLoop));
               cColumnNames.assign(concat(cColumnNames, hBrowseColumn.unwrap().name(), ","));
               cColumnHandles.assign(concat(cColumnHandles, valueOf(hBrowseColumn), ","));
            }
            
            cColumnNames.assign(rightTrim(cColumnNames, ","));
            cColumnHandles.assign(rightTrim(cColumnHandles, ","));
         }
         
         /* valid browser. */
         /* Ensure temp-table is empty to start */
         tttable.deleteAll();
         iRowNum.assign(0);
         iColNum.assign(0);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("rowsToBatch"));
         iRowsToBatch.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("rowsToBatch"));
         ghProp.unwrapBufferField().changeValue(piMaxRecords);
         /* start at the beginning */
         ControlFlowOps.invokeIn("fetchFirst", targetProcedure());
         /* check if any records */
         lAvailable.assign(isNotEqual(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryPosition", targetProcedure()), "NoRecordAvailable"));
         
         if ((lAvailable).booleanValue())
         {
            iNumRecords.assign(1);
            hQuery.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataHandle", targetProcedure()));
            hBuffer.assign(hQuery.unwrapQuery().bufferHandle(1));
            
            fieldLoop:
            for (iField.assign(1); _isLessThanOrEqual(iField, hBuffer.unwrapBuffer().numFields()); iField.increment())
            {
               hBufferField.assign(hBuffer.unwrapBuffer().bufferField(iField));
               
               if (_and(isEqual(plIncludeObj, false), () -> isGreaterThan(indexOf(hBufferField.unwrap().name(), "_obj"), 0)))
               {
                  continue fieldLoop;
               }
               
               if ((matchesList(pcFieldList, hBufferField.unwrap().name())).booleanValue())
               {
                  iColNum.assign(plus(iColNum, 1));
                  iPosn.assign(lookup(hBufferField.unwrap().name(), pcFieldList));
                  hBrowseColumn.setUnknown();
                  
                  if ((hBrowser.isValid()).booleanValue())
                  {
                     silent(() -> hBrowseColumn.assign(handle.fromString(entry(lookup(hBufferField.unwrap().name(), cColumnNames), cColumnHandles))));
                  }
                  
                  cWantedFieldHandles.assign(concat(cWantedFieldHandles, valueOf(hBufferField), chr(3)));
                  /* Store labels in row 0 */
                  tttable.create();
                  batch(() -> 
                  {
                     tttable.setIrow(new integer(0));
                     tttable.setIcol((_isEqual(iPosn, 0) ? iColNum : iPosn));
                     tttable.setCcell((hBrowseColumn.isValid()).booleanValue() ? trim(hBrowseColumn.unwrapCommonField().getLabel()) : trim(hBufferField.unwrapCommonField().getColumnLabel()));
                  });
                  /* Store field names in row 1 */
                  tttable.create();
                  batch(() -> 
                  {
                     tttable.setIrow(new integer(1));
                     tttable.setIcol((_isEqual(iPosn, 0) ? iColNum : iPosn));
                     tttable.setCcell(trim(hBufferField.unwrap().name()));
                  });
                  /* Store datatypes in row 2 */
                  tttable.create();
                  batch(() -> 
                  {
                     tttable.setIrow(new integer(2));
                     tttable.setIcol((_isEqual(iPosn, 0) ? iColNum : iPosn));
                     tttable.setCcell(trim(hBufferField.unwrapCommonField().getDataType()));
                  });
                  /* Store widths in row 3 */
                  tttable.create();
                  batch(() -> 
                  {
                     tttable.setIrow(new integer(3));
                     tttable.setIcol((_isEqual(iPosn, 0) ? iColNum : iPosn));
                     tttable.setCcell(trim(valueOf(hBufferField.unwrapSizeable().getWidthChars())));
                  });
               }
            }
            
            cWantedFieldHandles.assign(rightTrim(cWantedFieldHandles, chr(3)));
            iRowNum.assign(9);
            
            repeatWhile("loopLabel34", () -> lAvailable, new Block((Body) () -> 
            {
               if (_not(hBuffer.unwrapBuffer().available()))
               {
                  leave("loopLabel34");
               }
               
               iRowNum.assign(plus(iRowNum, 1));
               
               fieldLoop2:
               for (iField.assign(1); _isLessThanOrEqual(iField, numEntries(cWantedFieldHandles, chr(3))); iField.increment())
               {
                  tttable.create();
                  batch(() -> 
                  {
                     hBufferField.assign(handle.fromString(entry(iField, cWantedFieldHandles, chr(3))));
                     iPosn.assign(lookup(hBufferField.unwrap().name(), pcFieldList));
                     tttable.setIrow(iRowNum);
                     tttable.setIcol((_isEqual(iPosn, 0) ? iField : iPosn));
                     tttable.setCcell(trim(hBufferField.unwrapBufferField().stringValue()));
                  });
               }
               
               cQueryPosition.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryPosition", targetProcedure()));
               lAvailable.assign(not(matchesList("LastRecord,OnlyRecord", cQueryPosition)));
               iNumRecords.assign(plus(iNumRecords, 1));
               
               if (_and(lAvailable, () -> isLessThanOrEqual(iNumRecords, piMaxRecords)))
               {
                  ControlFlowOps.invokeIn("fetchNext", targetProcedure());
               }
               else
               {
                  lAvailable.assign(false);
               }
            }));
         }
         
         /* lAvailable = true */
         /* to here */
         /* reposition back to previously selected record */
         if (_and(notUnknown(cRowIdent), () -> isNotEqual(cRowIdent, "")))
         {
            silent(() -> ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "fetchRowIdent", targetProcedure(), "II", cRowIdent, ""));
         }
         
         hQuery.setUnknown();
         hBuffer.setUnknown();
         iExtractedRecs.assign(minus(iNumRecords, 1));
         
         IntegerExpression resExpr10 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cDataTargets);
            }
         };
         ToClause toClause11 = new ToClause(iLoop, 1, resExpr10);
         
         doTo("dataTargetLoop", toClause11, new Block((Body) () -> 
         {
            silent(() -> hDataTarget.assign(handle.fromString(entry(iLoop, cDataTargets))));
            
            if ((hDataTarget.isValid()).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("linkStateHandler", hDataTarget, "III", new character("active"), targetProcedure(), new character("dataSource"));
            }
         }));
         
         ControlFlowOps.invokeInWithMode("linkStateHandler", targetProcedure(), "III", new character("active"), hNavSource, new character("NavigationSource"));
         NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
         {
            "BatchEnd"
         });
         ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("rowsToBatch"));
         ghProp.unwrapBufferField().changeValue(iRowsToBatch);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Transfers the contents of the SDO to Excel<br>
    * Parameters:  input field list or leave blank for all (no table prefix)<br>
    *              input include object fields yes/no<br>
    *              input use existing running excel yes/no<br>
    *              input maximum records to process<br>
    * Notes:       Always excludes rowobject specific fields,<br>
    *              e.g. RowNum,RowIdent,RowMod<br>
    *              Uses tableout procedure defined in here also.
    */
   public void transferToExcel(final character _pcFieldList, final logical _plIncludeObj, final logical _plUseExisting, final integer _piMaxRecords)
   {
      character pcFieldList = TypeFactory.initInput(_pcFieldList);
      logical plIncludeObj = TypeFactory.initInput(_plIncludeObj);
      logical plUseExisting = TypeFactory.initInput(_plUseExisting);
      integer piMaxRecords = TypeFactory.initInput(_piMaxRecords);
      
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.invokeInWithMode("exportData", targetProcedure(), "IIIII", new character("Excel"), pcFieldList, plIncludeObj, plUseExisting, piMaxRecords);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To undo any uncommitted changes to the RowObject table when the<br>
    *              "Undo" button is pressed in the commit panel.<br>
    * <p>
    * Parameters:  &lt;none&gt;<br>
    * <p>
    * Notes:       undoTransaction calls doUndoTrans to restore the RowObject <br>
    *              Temp-Table and empty the RowObjUpd Temp-Table.
    */
   public void undoTransaction()
   {
      rowid rRowObject = TypeFactory.rowid();
      handle hDataQuery = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      logical lQueryContainer = TypeFactory.logical();
      logical lHasOneToOneTarget = TypeFactory.logical();
      handle hSource = TypeFactory.handle();
      logical lCancel = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CommitSource"));
         hSource.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(hSource, sourceProcedure()))
         {
            /* Visual dataTargets subscribes to this */
            NamedEventManager.publish("confirmUndo", targetProcedure(), "U", new Object[]
            {
               lCancel
            });
            
            if ((lCancel).booleanValue())
            {
               returnNormal("ADM-ERROR");
            }
         }
         /* END IF hSource  */
         /* Restore the RowObject Temp-Table and empty the RowObjUpd Temp-Table.*/
         ControlFlowOps.invokeIn("doUndoTrans", targetProcedure());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         hRowObject.assign(hDataQuery.unwrapQuery().bufferHandle(1));
         rRowObject.assign(hRowObject.unwrapBuffer().rowID());
         hDataQuery.unwrapQuery().queryClose();
         hDataQuery.unwrapQuery().queryOpen();
         silent(() -> hDataQuery.unwrapQuery().queryRepositionByID(rRowObject));
         
         if (_not(hRowObject.unwrapBuffer().available()))
         {
            hDataQuery.unwrapQuery().getNext();
         }
         
         /* next if needed (for Viewer, not Browser target)*/
         /* if we have other targets in update then avoid all publisity..  */
         lHasOneToOneTarget /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasOneTOOneTarget", targetProcedure()));
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectState", targetProcedure(), "I", "NoUpdates");
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryContainer"));
         lQueryContainer.assign(ghProp.unwrapBufferField().value());
         
         /* If we are inside a container with autocommit turned OFF, the container 
              should manage the undo and also has the responsibility to publish 
              dataAvailable. This is necessary because the container's undoTransaction
              calls undoTransaction in all SDOs and publising dataAvailble during this
              makes no sense, amongst other this avoids problems when the dataSources 
              still have rowObjectState 'RowUpdated' when receiving 'dataAvailable' */
         if (_and(not(lHasOneToOneTarget), not(lQueryContainer)))
         {
            NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
            {
               "DIFFERENT"
            });
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
            ghProp.unwrapBufferField().changeValue(new character(""));
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To rebuild query back to design time query, re-add the filters, <br>
    *              then add the new where clause and save the new where clause.<br>
    * Parameters:  input new where clause (for addquerywhere in correct format)<br>
    *              input field to search and replace in existing saved manualaddquerywhere<br>
    * Notes:       Ensures where clause added is not cleared by filters, and is not duplicated<br>
    *              in saved manualaddquerywhere.<br>
    *              Where clause must be in correct format for an addquerywhere.<br>
    *              If where clause is blank but the field is passed in, then any<br>
    *              manual query for that field will be removed, therefore defaulting<br>
    *              back to all.<br>
    *              Only supports adding a single where clause, but may be called<br>
    *              many times.<br>
    *              Used when putting a manual filter viewer above a browser !
    */
   public void updateAddQueryWhere(final character _pcWhere, final character _pcField)
   {
      character pcWhere = TypeFactory.initInput(_pcWhere);
      character pcField = TypeFactory.initInput(_pcField);
      handle hContainerSource = TypeFactory.handle();
      character cContainerName = TypeFactory.character();
      character cSdoName = TypeFactory.character();
      character cSdoSignature = TypeFactory.character();
      rowid rRowid = TypeFactory.rowid();
      character cFilterSettings = TypeFactory.character();
      character cFieldNames = TypeFactory.character();
      character cFieldValues = TypeFactory.character();
      character cFieldOperators = TypeFactory.character();
      character cEmptyString = TypeFactory.character();
      character cManualAddQueryWhere = TypeFactory.character();
      character cNewManualAddQueryWhere = TypeFactory.character();
      character cEntry = TypeFactory.character();
      character cBuffer = TypeFactory.character();
      integer iLoop = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("logicalObjectName"));
         cSdoName.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(cSdoName, ""))
         {
            cSdoName.assign(targetProcedure().unwrapFile().getFileName());
         }
         
         hContainerSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getContainerSource", targetProcedure()));
         
         if ((hContainerSource.isValid()).booleanValue())
         {
            cContainerName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getLogicalObjectName", hContainerSource));
         }
         
         cSdoSignature.assign(concat(cSdoName, ",,", cContainerName, ","));
         rRowid.setUnknown();
         
         if ((hContainerSource.isValid()).booleanValue())
         {
            ControlFlowOps.invokeInWithMode("getProfileData", gshProfileManager, "IIIIUO", new character("BrwFilters"), new character("FilterSet"), cSdoSignature, new logical(false), rRowid, cFilterSettings);
         }
         
         if (_and(isNotEqual(cFilterSettings, ""), () -> isEqual(numEntries(cFilterSettings, chr(3)), 3)))
         {
            cFieldNames.assign(entry(1, cFilterSettings, chr(3)));
            cFieldValues.assign(entry(2, cFilterSettings, chr(3)));
            cFieldOperators.assign(entry(3, cFilterSettings, chr(3)));
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryColumns"));
         ghProp.unwrapBufferField().changeValue(cEmptyString);
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryWhere", targetProcedure(), "I", cEmptyString);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ManualAddQueryWhere"));
         cManualAddQueryWhere.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr11 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cManualAddQueryWhere, chr(4));
            }
         };
         ToClause toClause12 = new ToClause(iLoop, 1, resExpr11);
         
         doTo("manualLoop", toClause12, new Block((Body) () -> 
         {
            cEntry.assign(entry(iLoop, cManualAddQueryWhere, chr(4)));
            
            if (_isGreaterThan(indexOf(cEntry, pcField), 0))
            {
               next("manualLoop");
            }
            
            /* Ignore passed in field */
            if (_isNotEqual(numEntries(cEntry, chr(3)), 3))
            {
               next("manualLoop");
            }
            
            cBuffer.assign(entry(2, cEntry, chr(3)));
            
            if (_isEqual(cBuffer, "?"))
            {
               cBuffer.assign("");
            }
            
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "addQueryWhere", targetProcedure(), "III", entry(1, cEntry, chr(3)), cBuffer, entry(3, cEntry, chr(3)));
            cNewManualAddQueryWhere.assign(concat(cNewManualAddQueryWhere, (_isNotEqual(cNewManualAddQueryWhere, "") ? chr(4) : new character("")), cEntry));
         }));
         
         if (_isNotEqual(cFieldNames, ""))
         {
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignQuerySelection", targetProcedure(), "III", cFieldNames, cFieldValues, cFieldOperators);
         }
         
         if (_isNotEqual(pcWhere, ""))
         {
            cNewManualAddQueryWhere.assign(concat(cNewManualAddQueryWhere, (_isNotEqual(cNewManualAddQueryWhere, "") ? chr(4) : new character("")), pcWhere, chr(3), chr(3), "AND"));
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ManualAddQueryWhere"));
         ghProp.unwrapBufferField().changeValue(cNewManualAddQueryWhere);
         
         if (_isNotEqual(pcWhere, ""))
         {
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "addQueryWhere", targetProcedure(), "III", pcWhere, "", "AND");
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void updateData(final character _pcUpdateColumnNames, final character _pcOldValues, final character pcNewValues, final character pcError)
   {
      character pcUpdateColumnNames = TypeFactory.initInput(_pcUpdateColumnNames);
      character pcOldValues = TypeFactory.initInput(_pcOldValues);
      character cKeyFields = TypeFactory.character();
      character cKeyValues = TypeFactory.character();
      character cNewValueList = TypeFactory.character();
      integer iLoop = TypeFactory.integer();
      integer iField = TypeFactory.integer();
      character cKey = TypeFactory.character();
      character cValue = TypeFactory.character();
      character cNewValue = TypeFactory.character();
      character cOldValue = TypeFactory.character();
      character cDataDelimiter = TypeFactory.character();
      handle hRowObject = TypeFactory.handle();
      handle hCol = TypeFactory.handle();
      logical lCreated = TypeFactory.logical();
      logical lSave = TypeFactory.logical();
      logical lNoKeyFields = TypeFactory.logical();
      character cColumn = TypeFactory.character();
      character cDataReadFormat = TypeFactory.character();
      logical lFound = TypeFactory.logical();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcError);
      }, 
      (Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cKeyFields.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getKeyFields", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataDelimiter"));
         cDataDelimiter.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataReadFormat"));
         cDataReadFormat.assign(ghProp.unwrapBufferField().value());
         
         loopLabel35:
         for (iLoop.assign(1); _isLessThanOrEqual(iLoop, numEntries(cKeyFields)); iLoop.increment())
         {
            cKey.assign(entry(iLoop, cKeyFields));
            iField.assign(lookup(cKey, pcUpdateColumnNames));
            
            if (_isEqual(iField, 0))
            {
               lNoKeyFields.assign(true);
               break loopLabel35;
            }
            
            cValue.assign(entry(iField, pcOldValues, cDataDelimiter));
            cKeyValues.assign(concat(cKeyValues, (_isEqual(iLoop, 1) ? new character("") : chr(1)), cValue));
         }
         
         if ((lNoKeyFields).booleanValue())
         {
            iField.assign(lookup("RowIdent", pcUpdateColumnNames));
            
            if (_isEqual(iField, 0))
            {
               pcError.assign(concat("'", replaceAll(cKeyFields, ",", " "), "' or 'RowIdent' need to be in column list passed to UpdateData to be able to find a record."));
               returnNormal();
            }
            
            cValue.assign(entry(iField, pcOldValues, cDataDelimiter));
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         
         /* Currently we need the RowObject with all fields from the db */
         if ((lNoKeyFields).booleanValue())
         {
            ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "fetchRowident", targetProcedure(), "II", cValue, "");
            silent(() -> lFound.assign(isEqual(cValue, hRowObject.unwrapBuffer().bufferField("Rowident").unwrapBufferField().value())));
         }
         else
         {
            lFound.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowWhere", targetProcedure(), "III", cKeyFields, cKeyValues, "="));
         }
         
         if ((lFound).booleanValue())
         {
            loopLabel36:
            for (iLoop.assign(1); _isLessThanOrEqual(iLoop, numEntries(pcUpdateColumnNames)); iLoop.increment())
            {
               silent(() -> 
               {
                  hCol.setUnknown();
                  cColumn.assign(entry(iLoop, pcUpdateColumnNames));
                  hCol.assign(hRowObject.unwrapBuffer().bufferField(cColumn));
               });
               
               if ((hCol.isValid()).booleanValue())
               {
                  cOldValue.assign(entry(iLoop, pcOldValues, cDataDelimiter));
                  cNewValue.assign(entry(iLoop, pcNewValues, cDataDelimiter));
                  
                  /* We do not assign the before image value to the RowObject if 
                            the b-i value is similar to the formatted value, but the buffer-value 
                            is not. This avoids error from the optimistic lock check in cases where 
                            formatting has sent a different value out than really stored */
                  if (_or(isEqual(hCol.unwrapBufferField().stringValue(), hCol.unwrapBufferField().value()), () -> isNotEqual(cOldValue, hCol.unwrapBufferField().stringValue())))
                  {
                     hCol.unwrapBufferField().changeValue(cOldValue);
                  }
                  
                  if ((compare(cOldValue, "NE", cNewValue, "case-sensitive")).booleanValue())
                  {
                     cNewValueList.assign(concat(cNewValueList, (_isEqual(cNewValueList, "") ? new character("") : chr(1)), cColumn, chr(1), (_notUnknown(cNewValue) ? cNewValue : new character("?"))));
                  }
               }
            }
            
            lSave.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "submitRow", targetProcedure(), "II", valueOf(hRowObject.unwrapBuffer().rowID()), cNewValueList));
         }
         else
         {
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "addNotFoundMessage", targetProcedure(), "III", (lNoKeyFields).booleanValue() ? new character("ROWIDENT") : cKeyFields, (lNoKeyFields).booleanValue() ? cValue : cKeyValues, "=");
         }
         
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
         {
            pcError /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()));
         }
         
         if (_and(lFound, () -> hRowObject.unwrapBuffer().available()))
         {
            pcNewValues.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colStringValues", targetProcedure(), "III", pcUpdateColumnNames, cDataReadFormat, cDataDelimiter));
         }
         
         /* Future .. not yet used.. 
             If not present on the client remove any trace of the update*/
         if ((lCreated).booleanValue())
         {
            hRowObject.unwrapBuffer().deleteRecord();
         }
         
         /* If unsuccessful save the before-image record is still here, so get rid of it */
         if (_not(lSave))
         {
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "resetRow", targetProcedure(), "I", valueOf(hRowObject.unwrapBuffer().rowID()));
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:   Get foreign fields and values and setManualAssignQuerySelection <br>
    *            so that filter does not lose info  <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void updateManualForeignFields()
   {
      internalProcedure(new Block((Body) () -> 
      {
         /* This has been commented out for the following reasons:
             1. It's no longer necessary as 'setQueryWhere' now re-applies foreign field values
             2. It may override previously saved values in 'ManualAssignQuerySelection'
         */
         /*   DEFINE VARIABLE cForeignFields      AS CHARACTER    NO-UNDO.                                   */
         /*   DEFINE VARIABLE cLocalFields        AS CHARACTER    NO-UNDO.                                   */
         /*   DEFINE VARIABLE cSourceFields       AS CHARACTER    NO-UNDO.                                   */
         /*   DEFINE VARIABLE iField              AS INTEGER      NO-UNDO.                                   */
         /*   DEFINE VARIABLE cValues             AS CHARACTER    NO-UNDO.                                   */
         /*   DEFINE VARIABLE cField              AS CHARACTER    NO-UNDO.                                   */
         /*                                                                                                  */
         /*     DEBUGGER:INITIATE().                                                                         */
         /*     DEBUGGER:SET-BREAK().                                                                        */
         /*   {get ForeignFields cForeignFields}.                                                            */
         /*   IF cForeignFields <> "" THEN                                                                   */
         /*   DO:                                                                                            */
         /*      DO iField = 1 TO NUM-ENTRIES(cForeignFields) BY 2:                                          */
         /*             cLocalFields = cLocalFields +  _* 1st of each pair is local db query fld  *_         */
         /*                 (IF cLocalFields NE "":U THEN ",":U ELSE "":U) + ENTRY(iField, cForeignFields).  */
         /*      END.                                                                                        */
         /*                                                                                                  */
         /*                                                                                                  */
         /*      ASSIGN                                                                                      */
         /*        cField = IF NUM-ENTRIES(cLocalFields, ".") > 1 THEN                                       */
         /*             ENTRY(2, cLocalFields, ".") ELSE cLocalFields.                                       */
         /*                                                                                                  */
         /*        cValues = {fnarg colValues cField} NO-ERROR.                                              */
         /*         _* Throw away the RowIdent entry returned by colValues*_                                 */
         /*      IF cValues NE ? THEN                                                                        */
         /*          cValues = SUBSTR(cValues, INDEX(cValues, CHR(1)) + 1).                                  */
         /*                                                                                                  */
         /*      DYNAMIC-FUNCTION("setManualAssignQuerySelection":U IN TARGET-PROCEDURE,                     */
         /*                       cLocalFields + CHR(3) + cValues + CHR(3) + '':U).                          */
         /*   END.                                                                                           */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: Reset the QueryPosition property after a record navigation.  <br>
    *          The main purpose of this function is to eliminate duplication, <br>
    *          errors and minimize messaging (setQueryPosition PUBLISHes)<br>
    *          in fetchFirst, fetchPrev, fetchNext and fetchLast.   <br>
    *   Notes: data.p should update LastRowNum, FirstRowNum properties and call this. <br>
    *        - The properties LastRowNum and FirstRowNum stores the <br>
    *          RowObject.RowNum of the first and last record in the database query.
    */
   public void updateQueryPosition()
   {
      handle hRowObject = TypeFactory.handle();
      integer iLastRowNum = TypeFactory.integer();
      integer iFirstRowNum = TypeFactory.integer();
      handle hRowNum = TypeFactory.handle();
      logical lLast = TypeFactory.logical();
      character cQueryPos = TypeFactory.character();
      character cFfields = TypeFactory.character();
      character cFvalues = TypeFactory.character();
      logical lNew = TypeFactory.logical();
      handle hDataSource = TypeFactory.handle();
      handle hDataTarget = TypeFactory.handle();
      logical lQuery = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         
         if (_and(hRowObject.isValid(), () -> hRowObject.unwrapBuffer().available()))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
            iFirstRowNum.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
            iLastRowNum.assign(ghProp.unwrapBufferField().value());
            hRowNum.assign(hRowObject.unwrapBuffer().bufferField("RowNum"));
            /* Are we on the last record?  */
            lLast.assign(isEqual(hRowNum.unwrapBufferField().value(), iLastRowNum));
            cQueryPos.assign(_isEqual(hRowNum.unwrapBufferField().value(), iFirstRowNum) ? (_not(lLast) ? new character("FirstRecord") : new character("OnlyRecord")) : (_not(lLast) ? new character("NotFirstOrLast") : new character("LastRecord")));
         }
 /* not first and not last */         else
         {
            /* Check for a DataSource.  If there is a data source then we test
                    foreign key values, we could also have checked queryPosition..
                    but this is what Add uses, and this QueryPos is used to disable Add 
                    in toolbar .. */
            /* {get Prop var [handle]} */ 
            hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
            
            /* Check to see if we're in an sbo and, if so, use that to get the 
                    ForeignFields */
            if (_not(hDataSource.isValid()))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
               hDataTarget.assign(ghProp.unwrapBufferField().value());
               
               /* Determine if the appropriate data-target to use is the container
                         or the target-procedure (i.e. the sdo) */
               if ((hDataTarget.isValid()).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, hDataTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                  lQuery.assign(ghProp.unwrapBufferField().value());
                  
                  if ((lQuery).booleanValue())
                  {
                     /* {get Prop var [handle]} */
                     hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hDataTarget));
                  }
                  else
                  {
                     hDataTarget.assign(targetProcedure());
                  }
               }
            }
            else
            {
               hDataTarget.assign(targetProcedure());
            }
            
            if ((hDataSource.isValid()).booleanValue())
            {
               /* Check and see if any foreign fields are used */
               /* {get Prop var [handle]} */
               cFfields.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getForeignFields", hDataTarget));
               
               if (_notUnknown(cFfields))
               {
                  ghProp.assign(handle.fromString(entry(1, hDataTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
                  cFvalues.assign(ghProp.unwrapBufferField().value());
                  
                  if (_isUnknown(cFvalues))
                  {
                     /* No Foreign values */
                     cQueryPos.assign("NoRecordAvailableExt");
                  }
               }
               
               /* cFFields <> ? */
               if (_isEqual(cQueryPos, ""))
               {
                  /* Check if dataSource has an unsaved new record 
                              Use no-error in case the datasource is a container with 
                              ExternalForegnKey  */
                  /* {get Prop var [handle]} */
                  silent(() -> lNew.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getNewMode", hDataSource)));
                  
                  if ((lNew).booleanValue())
                  {
                     cQueryPos.assign("NoRecordAvailableExt");
                  }
               }
            }
            
            /* valid DataSource */
            /* If not set above set the cQueryPos variable to NoRecordAvailable */
            if (_isEqual(cQueryPos, ""))
            {
               cQueryPos.assign("NoRecordAvailable");
            }
         }
         /* else (not avail)*/
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryPosition", targetProcedure(), "I", cQueryPos);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To passes along update-related messages (to its <br>
    *              Navigation-Source, e.g) and to adjust the DataModified property.<br>
    *              <br>
    * Parameters:  <br>
    *   INPUT pcState - A indicator of the state of a an updatable record. Valid<br>
    *                   values are:<br>
    *                     'UpdateBegin'    -  The user has indicated that an update<br>
    *                                         will take place (either by pressing<br>
    *                                         the Update button in a panel, or by<br>
    *                                         entering an updatable field in a<br>
    *                                         browser.)<br>
    *                     'Update'         -  An update is in progress in another<br>
    *                                         object (a viewer or browser.)<br>
    *                     'UpdateEnd'      -  A save has completed (same as<br>
    *                                         'UpdateComplete'.)<br>
    *                     'UpdateComplete' -  Any changes to the RowObject<br>
    *                                         Temp-Table have either been <br>
    *                                         committed or backed out.<br>
    *                     'Reset'          -  Changes to the roewObject has been<br>
    *                                         reset, passed on as 'UpdateComplete'  <br>
    *                     'Delete'         -  An uncommitted delete, which we <br>
    *                                         pass on as 'update'.  <br>
    *                     'Updatable'      - called from UpdateMode when switching modes                      <br>
    *                       <br>
    *  Notes:   -  The SmartDataObject also saves its own "copy" of the <br>
    *              DataModified property, set true when updateState is 'Update' <br>
    *              and false when updateState is 'UpdateComplete', so that it <br>
    *              can be queried by other objects (such as other dataTargets).  <br>
    *           -  For visual objects the updateState is both a DataSourceEvent <br>
    *              and DataTargetEvent. In order to not bounce messages back to the <br>
    *              dataTargets that are both subscribers and publishers, we <br>
    *              set the CurrentUpdateSource so the DataTarget can avoid <br>
    *              republishing the event.                <br>
    *              Note that even if we did send the message back to the visual<br>
    *              object it would not get back to us as visual object only does <br>
    *              publish updatestate from internal events, including GAtargets
    */
   public void updateState(final character _pcState)
   {
      character pcState = TypeFactory.initInput(_pcState);
      logical lModified = TypeFactory.logical((Boolean) null);
      character cUpdateSource = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* Ensure that the browse is updated. This needs to be done even if Asynch. 
              Refresh will make the current record in the browse available, so although 
              it is possible to do this very late in submitRow  (after submitCommit 
              publish of data available) we really don't want to change position during 
              the update, so we wait until the update-source does setDataModified(false), 
              which will publish this. */
         if (_isEqual(pcState, "UpdateComplete"))
         {
            NamedEventManager.publish("refreshBrowse", targetProcedure());
         }
         
         /* If a row is deleted when autoCommit is off it publishes 'delete' in order     
              NOT to disable its nav-source or browse data-target, but still get the 
              message to its data-source, (which in this case will be us). 
              Note: Navsources does not really need this anymore as they use 
                    canNavigate  to check the validity of the message, but browsers still 
                    disables on 'update' and does nothing on 'delete' and only use
                    canNavigate to validate 'updateComplete'.
                   (they could be changed to use canNavigate for all states)           
              The data source republishes this as 'update', so that all nav-source and 
              data-target browsers ABOVE the uncommitted delete is disabled. */
         if (_isEqual(pcState, "Delete"))
         {
            pcState.assign("Update");
         }
         
         /* Reset is passed as a workaround from visual objects to avoid that a 
              tableio with updatemode publishes updatemode('updateend'). */
         if (_isEqual(pcState, "Reset"))
         {
            pcState.assign("UpdateComplete");
         }
         
         /* The setting of DataModified can probably be removed ....
              The sdo sets it to no in submitCommit and getDataModified always checks
              updateSources, canNavigate is used to check all children, so we don't need 
              to set this based on children (which would be wrong anyways with many 
              children in tree branches ) */
         if (_isEqual(pcState, "Update"))
         {
            lModified.assign(true);
         }
         else
         {
            if (_isEqual(pcState, "UpdateComplete"))
            {
               lModified.assign(false);
            }
         }
         
         /* Ensure that Modified State is only set when valid state is sent. */
         if (_notUnknown(lModified))
         {
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setDataModified", targetProcedure(), "I", lModified);
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateSource"));
         cUpdateSource.assign(ghProp.unwrapBufferField().value());
         
         if ((matchesList(cUpdateSource, valueOf(sourceProcedure()))).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentUpdateSource"));
            ghProp.unwrapBufferField().changeValue(sourceProcedure());
         }
         /* {set Prop value [handle]} */ 
         
         NamedEventManager.publish("updateState", targetProcedure(), "I", new Object[]
         {
            pcState
         });
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentUpdateSource"));
         ghProp.unwrapBufferField().changeValue(new unknown());
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public character addRow(final character _pcViewColList_4)
   {
      character pcViewColList_4 = TypeFactory.initInput(_pcViewColList_4);
      /*------------------------------------------------------------------------------
        Purpose:     Creates a new RowObject temp-table record, initializes it, and
                     returns CHR(1) delimited list of values for the requested 
                     columns (in pcViewColList) of the new RowObject row.
                     The first entry in the list is the RowObect ROWID and db RowIds
                     separated with commas. (The db Rowids are blank as the record 
                     has not been created)    
        Parameters:
          INPUT pcViewColList - comma-separated list of columns names that are to
                                be displayed in the SmartDataViewer that called
                                addRow.
      ------------------------------------------------------------------------------*/
      integer iCol = TypeFactory.integer();
      handle hColumn = TypeFactory.handle();
      integer iColCount = TypeFactory.integer();
      handle hRowObject = TypeFactory.handle();
      character cColList = TypeFactory.character();
      character cRowid = TypeFactory.character();
      character cForFields = TypeFactory.character();
      character cForValues = TypeFactory.character();
      character cField = TypeFactory.character();
      logical lQueryContainer = TypeFactory.logical();
      
      return function("addRow", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         cForFields.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getForeignFields", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataColumns"));
         cColList.assign(ghProp.unwrapBufferField().value());
         
         /* Save off the "current" rowid in case the add is cancelled. 
                If there's no RowObject record available, it's because we're
                being browsed from outside, so use the Browser's RowIdent. */
         if ((hRowObject.unwrapBuffer().available()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentRowid"));
            ghProp.unwrapBufferField().changeValue(hRowObject.unwrapBuffer().rowID());
         }
         else
         {
            /* ... or it might just be because we're adding multiple new
                     rows at a time or for some other reason, so SOURCE-PROC may not be
                     a SmartObject. In that case RowIdent will come back Unknown. 
                     Use dynamic-function in case the object has no such property. */
            silent(() -> cRowid.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowIdent", sourceProcedure())));
            cRowid.assign(entry(1, cRowid));
            
            if (_isUnknown(cRowid))
            {
               cRowid.assign("");
            }
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentRowid"));
            ghProp.unwrapBufferField().changeValue(new rowid(cRowid));
         }
         /* {set Prop value [handle]} */ 
         /* END No RowObject Available */
         hRowObject.unwrapBuffer().bufferCreate();
         iColCount.assign(numEntries(cColList));
         
         loopLabel37:
         for (iCol.assign(1); _isLessThanOrEqual(iCol, iColCount); iCol.increment())
         {
            hColumn.assign(hRowObject.unwrapBuffer().bufferField(iCol));
            silent(() -> hColumn.unwrapBufferField().changeValue(_and(isEqual(hColumn.unwrapCommonField().getDataType(), "DATE"), () -> isEqual(hColumn.unwrapBufferField().initial(), "TODAY")) ? valueOf(date.today()) : hColumn.unwrapBufferField().initial()));
         }
         
         /* If there are Foreign Fields, assign their values as initial
                values for those columns. */
         if (_isEqual(cForFields, ""))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryContainer"));
            lQueryContainer.assign(ghProp.unwrapBufferField().value());
            
            if ((lQueryContainer).booleanValue())
            {
               cForFields /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getForeignFieldsContainer", targetProcedure()));
            }
         }
         
         if (_isNotEqual(cForFields, ""))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
            cForValues.assign(ghProp.unwrapBufferField().value());
            
            loopLabel38:
            for (iCol.assign(1); _isLessThanOrEqual(iCol, numEntries(cForFields)); iCol.assign(plus(iCol, 2)))
            {
               cField.assign(entry(iCol, cForFields));
               hColumn.assign(hRowObject.unwrapBuffer().bufferField(entry(numEntries(cField, "."), cField, ".")));
               
               if ((hColumn.isValid()).booleanValue())
               {
                   /* might not be in SDO */hColumn.unwrapBufferField().changeValue(entry(new integer(divide(plus(iCol, 1), 2)), cForValues, chr(1)));
               }
            }
         }
         /* END DO IF cForFields NE "" */
         /* set RowNum and first last status */
         /* {fnarg <func-name> <arg> [handle] */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "newRowObject", targetProcedure(), "I", "Add");
         returnNormal( /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", targetProcedure(), "I", pcViewColList_4));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical applyContextFromServer(final character _pcContext_1)
   {
      character pcContext_1 = TypeFactory.initInput(_pcContext_1);
      /*------------------------------------------------------------------------------
        Purpose: Apply context returned from server after a server call
          Notes: Mostly to be consistent with sbo and also to have specific 
                 entry for override ( setPropertyList can be used anywhere)
             Typical usage:    
                 cContext = obtainContextForServer()
                 run <remotecall> (input-output cContext). 
                 applyContextFromServer(ccontext)               
      ------------------------------------------------------------------------------*/
      character cServerOperatingMode = TypeFactory.character();
      logical lAsHasStarted = TypeFactory.logical();
      
      return function("applyContextFromServer", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("AsHasStarted"));
         lAsHasStarted.assign(ghProp.unwrapBufferField().value());
         
         if (_not(lAsHasStarted))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ServerOperatingMode"));
            cServerOperatingMode.assign(ghProp.unwrapBufferField().value());
         }
         /* {get Prop var [handle]} */ 
         
         ControlFlowOps.invokeInWithMode("setPropertyList", targetProcedure(), "I", pcContext_1);
         
         if (_not(lAsHasStarted))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("AsHasStarted"));
            ghProp.unwrapBufferField().changeValue(new logical(true));
            
            /* Override the actual state if the instance property is force stateful */
            if (_isEqual(cServerOperatingMode, "STATE-RESET"))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ServerOperatingMode"));
               ghProp.unwrapBufferField().changeValue(cServerOperatingMode);
            }
            /* {set Prop value [handle]} */ 
         }
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical batchRowAvailable(final character _pcMode_4)
   {
      character pcMode_4 = TypeFactory.initInput(_pcMode_4);
      /*------------------------------------------------------------------------------
        Purpose: Check if there are more records available in the current batch 
      Parameters: pcMode - Specifies direction to look  
                         - 'Next' 
                         - 'Prev'
                         - 'current'  
          Notes: Check this before navigating with the normal fetch* navigation 
                 methods to avoid an implicit read of a new batch in cases where 
                 the intention is to just navigate through one batch of data.    
      ------------------------------------------------------------------------------*/
      character cLastResultRow = TypeFactory.character();
      character cFirstResultRow = TypeFactory.character();
      handle hRowObject = TypeFactory.handle();
      handle hRowNum = TypeFactory.handle();
      integer iLastRowInBatch = TypeFactory.integer();
      integer iFirstRowInBatch = TypeFactory.integer();
      handle hDataQuery = TypeFactory.handle();
      
      return function("batchRowAvailable", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         
         if ((hRowObject.unwrapBuffer().available()).booleanValue())
         {
            hRowNum.assign(hRowObject.unwrapBuffer().bufferField("RowNum"));
            
            switch (StringHelper.safeTrimTrailing((pcMode_4).toStringMessage()).toUpperCase())
            {
               case "NEXT":
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("LastResultRow"));
                     cLastResultRow.assign(ghProp.unwrapBufferField().value());
                     iLastRowInBatch.assign(new integer(entry(1, cLastResultRow, ";")));
                     
                     if (_isLessThan(hRowNum.unwrapBufferField().value(), iLastRowInBatch))
                     {
                        returnNormal(true);
                     }
                     
                     if (_isEqual(hRowNum.unwrapBufferField().value(), iLastRowInBatch))
                     {
                        returnNormal(false);
                     }
                  }
                  break;
               case "FIRST":
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstResultRow"));
                     cFirstResultRow.assign(ghProp.unwrapBufferField().value());
                     iFirstRowInBatch.assign(new integer(entry(1, cFirstResultRow, ";")));
                     
                     if (_isGreaterThan(hRowNum.unwrapBufferField().value(), iFirstRowInBatch))
                     {
                        returnNormal(true);
                     }
                     
                     if (_isEqual(hRowNum.unwrapBufferField().value(), iFirstRowInBatch))
                     {
                        returnNormal(false);
                     }
                  }
                  break;
               default:
                  {
                     returnNormal(true);
                  }
            }
         }
         else
         {
            if (_isEqual(pcMode_4, "current"))
            {
               returnNormal(false);
            }
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
            hDataQuery.assign(ghProp.unwrapBufferField().value());
            
            if (_isEqual(hDataQuery.unwrapQuery().currentRow(), 1))
            {
               returnNormal(isEqual(pcMode_4, "NEXT"));
            }
         }
         returnNormal(false);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character bufferCompareFields(final handle _phBuffer1_1, final handle _phBuffer2_1, final character _pcExclude_1, final character _pcOption_1)
   {
      handle phBuffer1_1 = TypeFactory.initInput(_phBuffer1_1);
      handle phBuffer2_1 = TypeFactory.initInput(_phBuffer2_1);
      character pcExclude_1 = TypeFactory.initInput(_pcExclude_1);
      character pcOption_1 = TypeFactory.initInput(_pcOption_1);
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      integer iVar = TypeFactory.integer();
      character cChangedFlds = TypeFactory.character();
      character cName = TypeFactory.character();
      
      return function("bufferCompareFields", character.class, new Block((Body) () -> 
      {
         loopLabel39:
         for (iVar.assign(1); _isLessThanOrEqual(iVar, phBuffer1_1.unwrapBuffer().numFields()); iVar.increment())
         {
            cName.assign(phBuffer1_1.unwrapBuffer().bufferField(iVar).unwrap().name());
            
            if (_isGreaterThan(lookup(cName, pcExclude_1), 0))
            {
               continue loopLabel39;
            }
            
            if (_isEqual(phBuffer1_1.unwrapBuffer().bufferField(iVar).unwrapCommonField().getDataType(), "CHARACTER"))
            {
               if (_not(isGreaterThan(lookup(pcOption_1, "RAW,CASE-SENSITIVE,CASE-INSENSITIVE"), 0)))
               {
                  pcOption_1.assign("CASE-INSENSITIVE");
               }
               
               if ((compare(new character(phBuffer1_1.unwrapBuffer().bufferField(iVar).unwrapBufferField().value()), "<>", new character(phBuffer2_1.unwrapBuffer().bufferField(cName).unwrapBufferField().value()), pcOption_1)).booleanValue())
               {
                  cChangedFlds.assign(concat(cChangedFlds, (_isGreaterThan(cChangedFlds, "") ? new character(",") : new character("")), cName));
               }
            }
            else
            {
               if (_isNotEqual(phBuffer1_1.unwrapBuffer().bufferField(iVar).unwrapBufferField().value(), phBuffer2_1.unwrapBuffer().bufferField(cName).unwrapBufferField().value()))
               {
                  cChangedFlds.assign(concat(cChangedFlds, (_isGreaterThan(cChangedFlds, "") ? new character(",") : new character("")), cName));
               }
            }
         }
         
         returnNormal(cChangedFlds);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character cancelRow()
   {
      /*------------------------------------------------------------------------------
        Purpose:     Cancels an Add, Copy, or Save operation.  
        Parameters:  <none>  
        Notes:       cancelRow calls doUndoUpdate which restores the original values
                     of a modified row from the RowObjUpd record then deletes the
                     RowObjUdp record.  In the case of newMode, the new 
                     RowObject is deleted and doUndoUpdate repositions the 
                     RowObject temp-table to what was previously the current row.
      Note date: 2002/04/11               
      ------------------------------------------------------------------------------*/
      logical lNew = TypeFactory.logical();
      
      return function("cancelRow", character.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         lNew.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getNewMode", targetProcedure()));
         ControlFlowOps.invokeIn("doUndoUpdate", targetProcedure());
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setDataModified", targetProcedure(), "I", false);
         
         /* Tell the data-targets that we're back in business, if we're NOT in a SBO */
         if (_and(not(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getQueryContainer", targetProcedure()))), lNew))
         {
            NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
            {
               "DIFFERENT"
            });
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
            ghProp.unwrapBufferField().changeValue(new character(""));
         }
         
         returnNormal("");
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical canNavigate()
   {
      /*------------------------------------------------------------------------------
        Purpose: Check if this object or its children has any updates   
          Notes: You can navigate an object that has uncommiited changes, but not 
                 if the children has uncommitted changes, so this publishes 
                 IsUpdatePending to check children as this includes rowObjectState 
                 in the check.
               - Navigating objects will typically call this to check if the object
                 that they are navigating can be navigated. Nav objects receives
                 updateState from the objects they navigate and will perform this 
                 check in the source of any 'updateComplete' message. This is required
                 because an 'updateComplete' may come from a branch of a data-link 
                 tree while publish isUpdatePending will check the whole tree to 
                 ensure that no branches has pending updates. 
               - This returns true if we can navigate while isUpdatePending is the 
                 opposite and returns true if update is pending. 
                (The real reason: It's easier to have default false for i-o params)   
      ------------------------------------------------------------------------------*/
      logical lDataModified = TypeFactory.logical();
      logical lUpdate = TypeFactory.logical();
      logical lNewMode = TypeFactory.logical();
      
      return function("canNavigate", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         lDataModified.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataModified", targetProcedure()));
         /* Use NewMode refers to the current Object's state, NOT newRow */
         /* {get Prop var [handle]} */ 
         lNewMode.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getNewMode", targetProcedure()));
         /* Use = TRUE to ensure that unknown is treated similar to false */
         lUpdate.assign(or(isEqual(lDataModified, true), () -> isEqual(lNewMode, true)));
         
         /* This object does not block navigation, check all targets, 
               updatePending does the same check, but it always checks rowObjectstate 
               also to see if there are any pending uncommitted changes */
         if (_not(lUpdate))
         {
            NamedEventManager.publish("isUpdatePending", targetProcedure(), "U", new Object[]
            {
               lUpdate
            });
         }
         
         returnNormal(not(lUpdate));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical closeQuery()
   {
      handle hDataQuery = TypeFactory.handle();
      handle hAppServer = TypeFactory.handle();
      character cAsdivision = TypeFactory.character();
      character cOperatingMode = TypeFactory.character();
      logical lQueryContainer = TypeFactory.logical();
      logical lAsBound = TypeFactory.logical();
      
      return function("closeQuery", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         
         /* Close the RowObject query. */
         if ((hDataQuery.isValid()).booleanValue())
         {
            /* only do this if we are not a 1-to-1 child */
            if (_not(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUpdateFromSource", targetProcedure()))))
            {
               /* {fnarg <func-name> <arg> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "emptyRowObject", targetProcedure(), "I", "reset");
            }
            
            hDataQuery.unwrapQuery().queryClose();
            
            /* Don't do QueryPosition and dataAvailable if we're just closing
                   a query to re-open it, because these cause unnecessary flashing. */
            if (_and(isNotEqual(entry(1, EnvironmentOps.getSourceName(2), " "), "openQuery"), () -> isNotEqual(entry(1, EnvironmentOps.getSourceName(3), " "), "openQuery")))
            {
               ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
               NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
               {
                  "DIFFERENT"
               });
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
               ghProp.unwrapBufferField().changeValue(new character(""));
            }
         }
         
         /* If valid-handle */
         if (_isEqual(cAsdivision, "Client"))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryContainer"));
            lQueryContainer.assign(ghProp.unwrapBufferField().value());
            
            if (_not(lQueryContainer))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ServerOperatingMode"));
               cOperatingMode.assign(ghProp.unwrapBufferField().value());
               /* {get Prop var [handle]} */ 
               lAsBound.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAsbound", targetProcedure()));
               
               /* We don't connect just to close the query in stateless mode. */
               if (_and(isNotEqual(cOperatingMode, "STATELESS"), lAsBound))
               {
                  /* {get Prop var [handle]} */ 
                  hAppServer.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getASHandle", targetProcedure()));
                  
                  if ((hAppServer.isValid()).booleanValue())
                  {
                     returnNormal( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(logical.class, "closeQuery", hAppServer));
                  }
                  else
                  {
                     returnNormal(false);
                  }
               }
            }
            /* not QueryContainer */
            returnNormal(true);
         }
         else
         {
            returnNormal((logical) ControlFlowOps.runSuper("closeQuery"));
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical commit()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Client-side part of the Commit function. Copies changed records
                  into an update temp-table and sends it to the serverCommit (the
                  server-side commit procedure.)
          
        Notes:    The code in submitRow (which calls commitTransaction, which calls
                  Commit) has already created a pre-change copy of each changed 
                  record in the update temp-table.
                  This function invokes procedures in the SmartDataObject itself to 
                  manipulate the RowObject Temp-Tables.
      ------------------------------------------------------------------------------*/
      character cUndoIds = TypeFactory.character();
      handle hAppServer = TypeFactory.handle();
      character cMessages = TypeFactory.character();
      character cAsdivision = TypeFactory.character();
      handle hAppservice = TypeFactory.handle();
      character cServerFileName = TypeFactory.character();
      character cContext = TypeFactory.character();
      handle hRowObjUpd = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      rowid rRowid = TypeFactory.rowid();
      logical lSuccess = TypeFactory.logical();
      
      return function("commit", logical.class, new Block((Body) () -> 
      {
         /* Transfer modified and added rows to the update table. */
         ControlFlowOps.invokeIn("doBuildUpd", targetProcedure());
         /* If we're running across an AppServer connection, run serverCommit
              in that other object. Otherwise just run it in ourself. */
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         
         if (_isEqual(cAsdivision, "Client"))
         {
            /* Check AppServer properties to see if the object has no current or future 
                   server bindings and is using a stateless operating mode.*/
            if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasNoServerBinding", targetProcedure()))).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("connectServer", targetProcedure(), "O", hAppservice);
               
               if (_isUnknown(hAppservice))
               {
                  returnNormal(false);
               }
            }
            else
            {
               /* {get Prop var [handle]} */ 
               hAppServer.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getASHandle", targetProcedure()));
            }
            cContext /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForServer", targetProcedure()));
         }
         
         /* client */
         if ((hAppServer.isValid()).booleanValue())
         {
            /* {get Prop var [handle]} */ 
            hRowObjUpd.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjUpdTable", targetProcedure()));
            ControlFlowOps.invokeInWithMode("remoteCommit", hAppServer, "UUOO", cContext, new TableParameter(hRowObjUpd), cMessages, cUndoIds);
            /* {fnarg <func-name> <arg> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "applyContextFromServer", targetProcedure(), "I", cContext);
            /* unbind if stateless */
            ControlFlowOps.invokeIn("endClientDataRequest", targetProcedure());
         }
         else
         {
            if ((hAppservice.isValid()).booleanValue())
            {
               /* {get Prop var [handle]} */ 
               cServerFileName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getServerFileName", targetProcedure()));
               /* {get Prop var [handle]} */ 
               hRowObjUpd.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjUpdTable", targetProcedure()));
               ControlFlowOps.invokeRemoteWithMode("adm2/commit.p", (handle) null, hAppservice, false, "IUUOO", cServerFileName, cContext, new TableParameter(hRowObjUpd), cMessages, cUndoIds);
               /* {fnarg <func-name> <arg> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "applyContextFromServer", targetProcedure(), "I", cContext);
            }
            else
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
               hRowObject.assign(ghProp.unwrapBufferField().value());
               rRowid.assign(hRowObject.unwrapBuffer().rowID());
               ControlFlowOps.invokeInWithMode("bufferCommit", targetProcedure(), "OO", cMessages, cUndoIds);
               
               if (_and(notUnknown(rRowid), () -> isNotEqual(rRowid, hRowObject.unwrapBuffer().rowID())))
               {
                  hRowObject.unwrapBuffer().findByRowID(rRowid);
               }
            }
         }
         
         /* If we're running with a separate AppServer DataObject, then we must
              append any error messages returned to the message log. Otherwise they
              are already there. */
         if (_and(isEqual(cAsdivision, "Client"), () -> isNotEqual(cMessages, "")))
         {
            ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", cMessages, new unknown(), new unknown());
         }
         
         /* determine the success of the commit operation before anything else */
         /* in case the error buffer is emptied... */
         lSuccess.assign(not(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))));
         /* Return any rows to the client that have been changed by the server. */
         ControlFlowOps.invokeInWithMode("doReturnUpd", targetProcedure(), "I", cUndoIds);
         returnNormal(lSuccess);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character copyRow(final character _pcViewColList_4)
   {
      character pcViewColList_4 = TypeFactory.initInput(_pcViewColList_4);
      /*------------------------------------------------------------------------------
        Purpose:     Creates a new RowObject temp-table record, copies all of the 
                     current row values to it.  The return value of this function is 
                     a CHR(1) delimited list of the values of the current row as 
                     specified in the input parameter pcViewColList.  The first value 
                     of this return value is the RowIdent of the newly created row.
                     
        Parameters:  
          INPUT pcViewColList - comma-separated list of columns whose values are to
                                be returned for the newly created row.
       ------------------------------------------------------------------------------*/
      handle hRowObject = TypeFactory.handle();
      character cRowid = TypeFactory.character();
      rowid rRowObject = TypeFactory.rowid();
      handle hDataQuery = TypeFactory.handle();
      logical lBrowsed = TypeFactory.logical();
      
      return function("copyRow", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         
         /* Save off the "current" rowid in case the add is cancelled. 
                If there's no RowObject record available, it's because we're
                being browsed from outside, so use the Browser's RowIdent. */
         /* NOTE: Here and in addRow just checking AVAILABLE is not really a reliable
                way to tell whether the record that happens to be current in the DO is the
                one the client wants to COpy. */
         if ((hRowObject.unwrapBuffer().available()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentRowid"));
            ghProp.unwrapBufferField().changeValue(hRowObject.unwrapBuffer().rowID());
         }
         else
         {
            if ((hDataQuery.unwrapQuery().isOpen()).booleanValue())
            {
               /* {get Prop var [handle]} */
               cRowid.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowIdent", sourceProcedure()));
               cRowid.assign(entry(1, cRowid));
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentRowid"));
               ghProp.unwrapBufferField().changeValue(new rowid(cRowid));
               rRowObject.assign(new rowid(cRowid));
               /* {get Prop var [handle]} */ 
               lBrowsed.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataQueryBrowsed", targetProcedure()));
               
               if ((lBrowsed).booleanValue())
               {
                  hRowObject.unwrapBuffer().findByRowID(rRowObject);
               }
               else
               {
                  hDataQuery.unwrapQuery().queryRepositionByID(rRowObject);
                  
                  if (_not(hRowObject.unwrapBuffer().available()))
                  {
                     hDataQuery.unwrapQuery().getNext();
                  }
               }
            }
 /* not open means not using temp-table */;
         }
         /* {set Prop value [handle]} */ 
         /* END No RowObject Available */
         ControlFlowOps.invokeInWithMode("copyColumns", targetProcedure(), "II", pcViewColList_4, hDataQuery);
         returnNormal( /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", targetProcedure(), "I", pcViewColList_4));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical createRow(final character _pcValueList_3)
   {
      character pcValueList_3 = TypeFactory.initInput(_pcValueList_3);
      /*------------------------------------------------------------------------------
        Purpose:     Accepts a list of values for a new row to CREATE, returning FALSE
                     if any errors occur. This is done only to the RowObject 
                     Temp-Table; committing the changes back to the database is 
                     a separate step, which will be invoked from here if AutoCommit 
                     is set on.
       
        Parameters:
          INPUT pcValueList - CHR(1) delimited list of alternating column names 
                              and values to be assigned.
      ------------------------------------------------------------------------------*/
      character cRowObjId = TypeFactory.character();
      logical lOk = TypeFactory.logical();
      
      return function("createRow", logical.class, new Block((Body) () -> 
      {
         /* get the RowObject ROWID from the new row */
         cRowObjId.assign(entry(1, ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "addRow", targetProcedure(), "I", ""), chr(1)));
         lOk.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "submitRow", targetProcedure(), "II", cRowObjId, pcValueList_3));
         
         if (_not(lOk))
         {
            ControlFlowOps.invokeDynamicFunctionIn(character.class, "cancelRow", targetProcedure());
         }
         
         returnNormal(lOk);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical createRowObjectTable()
   {
      /*------------------------------------------------------------------------------
        Purpose:   Creates the RowObjectTable for a dynamic SDO    
        Parameters:  <none>
        Notes:     It normally creates the RowObjectTable, but if there is an 
                   unprepared RowObjectTable it will use this in support of the 
                   external create required for non-persistent procedures that
                   starts this object and need to output the TT.               
                -  The SchemaLocation decides where to get the field defintions from
                   If the Repository Entity Cache is used hen all fields must exist 
                   in it. The same of course applies to the buffer, while if 
                   the DataLogicProcedure is used any missing field will also be 
                   searched for in the buffer (in support of tables too big to define
                   statically.    
      ------------------------------------------------------------------------------*/
      handle hLogicObject = TypeFactory.handle();
      handle hLogicBuffer = TypeFactory.handle();
      handle hRowObjectTable = TypeFactory.handle();
      character cDataColumns = TypeFactory.character();
      character cDataColumnsByTable = TypeFactory.character();
      character cAssignList = TypeFactory.character();
      character cPhysicalTables = TypeFactory.character();
      character cColumn = TypeFactory.character();
      handle hColumn = TypeFactory.handle();
      integer iLoop = TypeFactory.integer();
      character cDbcolumnName = TypeFactory.character();
      handle hRowObject = TypeFactory.handle();
      character cAsDivision = TypeFactory.character();
      logical lExternal = TypeFactory.logical();
      logical lDbExtent = TypeFactory.logical();
      logical lFieldAdded = TypeFactory.logical();
      logical lReposOk = TypeFactory.logical();
      character cSchemaLocation = TypeFactory.character();
      logical lUseEntity = TypeFactory.logical();
      logical lUseDlp = TypeFactory.logical();
      logical lUseBuffer = TypeFactory.logical();
      
      return function("createRowObjectTable", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("IsRowObjectExternal"));
         lExternal.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataColumns"));
         cDataColumns.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("SchemaLocation"));
         cSchemaLocation.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(cDataColumns, ""))
         {
            returnNormal(false);
         }
         
         /* {get Prop var [handle]} */ 
         hRowObjectTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", targetProcedure()));
         
         if (_not(lExternal))
         {
            silent(() -> HandleOps.delete(hRowObjectTable));
            TempTableBuilder.create(hRowObjectTable);
         }
         
                  /* deal with all variations here, imcluding the fact that Entities 
                      only exists for repository */lUseBuffer.assign(isEqual(cSchemaLocation, "BUF"));
         lUseDlp.assign(or(and(not(gshRepositoryManager.isValid()), () -> not(isEqual(lUseBuffer, true))), () -> isEqual(cSchemaLocation, "DLP")));
         /* use entity in any case including unknown and blank, except DLP and 'BUF'  */
         lUseEntity.assign(and(and(gshRepositoryManager.isValid(), () -> not(isEqual(lUseDlp, true))), () -> not(isEqual(lUseBuffer, true))));
         
         /* If no repository or DLP explicitly specified as schema location
               the field definition will be copied from the logic object 
               NOTE (we may still use buffer for fields not in DLP)  
               The no-error is needed as this api does not exist if there is no 
               valid Data Logic Procdure */
         if ((lUseDlp).booleanValue())
         {
            silent(() -> ControlFlowOps.invokeInWithMode("getLogicBuffer", targetProcedure(), "O", hLogicBuffer));
         }
         
         silent(() -> HandleOps.delete(hRowObject));
         
         if ((lUseEntity).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("PhysicalTables"));
            cPhysicalTables.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataColumnsByTable"));
            cDataColumnsByTable.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("AssignList"));
            cAssignList.assign(ghProp.unwrapBufferField().value());
            lReposOk.assign(ControlFlowOps.invokeDynamicFunctionInWithMode("prepareRowObjectColumns", gshRepositoryManager, "IIIII", hRowObjectTable, cPhysicalTables, cDataColumns, cDataColumnsByTable, cAssignList));
            
            if (_not(lReposOk))
            {
               returnNormal(false);
            }
         }
         else
         {
            /* {get Prop var [handle]} */ 
            cAsDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAsDivision", targetProcedure()));
            
            IntegerExpression resExpr12 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cDataColumns);
               }
            };
            ToClause toClause13 = new ToClause(iLoop, 1, resExpr12);
            
            doTo("loopLabel40", toClause13, new Block((Body) () -> 
            {
               cColumn.assign(entry(iLoop, cDataColumns));
               hColumn.setUnknown();
               
               if ((hLogicBuffer.isValid()).booleanValue())
               {
                  hColumn.assign(hLogicBuffer.unwrapBuffer().bufferField(cColumn));
               }
               
               /* Don't use ELSE as dynamic data objects may have more columns than 
                         defined in the logic procedure */
               if (_not(hColumn.isValid()))
               {
                  cDbcolumnName /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnDbColumn", targetProcedure(), "I", cColumn));
                  
                  if (_and(isGreaterThan(cDbcolumnName, ""), () -> isNotEqual(cAsDivision, "CLIENT")))
                  {
                     hColumn /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dbColumnHandle", targetProcedure(), "I", cDbcolumnName));
                  }
                  
                  if (_not(hColumn.isValid()))
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLogicObject"));
                     hLogicObject.assign(ghProp.unwrapBufferField().value());
                     message(new Object[]
                     {
                        "Could not add column '",
                        cColumn,
                        "' to the dataobject's temp-table.",
                        new SkipEntity(true),
                        (hLogicBuffer.isValid()).booleanValue() ? concat(" The column is not defined in DataLogicProcedure: ", hLogicObject.unwrapFile().getFileName()) : new character(""),
                        _and(isGreaterThan(cDbcolumnName, ""), () -> isNotEqual(cAsDivision, "CLIENT")) ? concat("The physical name '", cDbcolumnName, "' is not a valid reference.") : new character(" Calculated columns require a running Data Logic Procedure.")
                     });
                     returnNormal(false);
                  }
               }
               hColumn.unwrapBufferField().changeValidateExpression(new character(""));
               lDbExtent.assign(isGreaterThan(hColumn.unwrapBufferField().extent(), 0));
               
               /* Don't copy extents if we copy from a db field */
               if (_not(lDbExtent))
               {
                  lFieldAdded.assign(hRowObjectTable.unwrapTempTable().addFieldLike(cColumn, hColumn));
               }
               else
               {
                  /* Extent  */
                  lFieldAdded.assign(hRowObjectTable.unwrapTempTable().addNewField(cColumn, hColumn.unwrapCommonField().getDataType(), new integer(0), hColumn.unwrapCommonField().getFormat(), hColumn.unwrapBufferField().initial(), hColumn.unwrapCommonField().getLabel(), hColumn.unwrapCommonField().getColumnLabel()));
               }
            }));
         }
         /*  Else (non-repos) */
         hRowObjectTable.unwrapTempTable().addNewField(new character("RowNum"), new character("INTEGER"));
         hRowObjectTable.unwrapTempTable().addNewField(new character("RowIdent"), new character("CHARACTER"));
         hRowObjectTable.unwrapTempTable().addNewField(new character("RowMod"), new character("CHARACTER"));
         hRowObjectTable.unwrapTempTable().addNewField(new character("RowIdentIdx"), new character("CHARACTER"));
         hRowObjectTable.unwrapTempTable().addNewField(new character("RowUserProp"), new character("CHARACTER"));
         hRowObjectTable.unwrapTempTable().addNewIndex(new character("RowNum"), new logical(false), new logical(true));
         hRowObjectTable.unwrapTempTable().addFieldToIndex("RowNum", "RowNum");
         hRowObjectTable.unwrapTempTable().addNewIndex(new character("RowMod"), new logical(false), new logical(false));
         hRowObjectTable.unwrapTempTable().addFieldToIndex("RowMod", "RowMod");
         hRowObjectTable.unwrapTempTable().addNewIndex(new character("RowIdentIdx"), new logical(false), new logical(false));
         hRowObjectTable.unwrapTempTable().addFieldToIndex("RowIdentIdx", "RowIdentIdx");
         hRowObjectTable.unwrapTempTable().tempTablePrepare("RowObject");
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectTable", targetProcedure(), "I", hRowObjectTable);
         returnNormal(hRowObjectTable.isValid());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical createRowObjUpdTable()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Creates the RowObjUpd table from the RowObject table. 
          Notes:  
      ------------------------------------------------------------------------------*/
      handle hRowObjUpdTable = TypeFactory.handle();
      handle hFromBuffer = TypeFactory.handle();
      handle hRowObjUpd = TypeFactory.handle();
      
      return function("createRowObjUpdTable", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hFromBuffer.assign(ghProp.unwrapBufferField().value());
         
         if (_not(hFromBuffer.isValid()))
         {
            returnNormal(false);
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObjUpd"));
         hRowObjUpd.assign(ghProp.unwrapBufferField().value());
         silent(() -> HandleOps.delete(hRowObjUpd));
         TempTableBuilder.create(hRowObjUpdTable);
         hRowObjUpdTable.unwrapTempTable().createTableLike(hFromBuffer);
         hRowObjUpdTable.unwrapTempTable().addNewField(new character("Changedfields"), new character("CHARACTER"));
         hRowObjUpdTable.unwrapTempTable().tempTablePrepare("RowObjUpd");
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjUpdTable", targetProcedure(), "I", hRowObjUpdTable);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle dataContainerHandle()
   {
      /*------------------------------------------------------------------------------
        Purpose: The DataContainer handle is an appserver aware container that can 
                 handle data requests and also is the container of this object. 
                 This can be a standard container or an sbo. This function also 
                 encapsulates the required checks of this object's AppServer properties
                 and only returns the handle if the current or permanent state allows 
                 it to be part of a stateless request handled by another object. 
          Notes: It is rather likely that the DataContainer role and client container
                 role will be in separate objects in the future.      
               - Currently duplicated in sbo.p.  
      ------------------------------------------------------------------------------*/
      character cAsdivision = TypeFactory.character();
      handle hSource = TypeFactory.handle();
      logical lDataContainer = TypeFactory.logical();
      logical lSbo = TypeFactory.logical();
      
      return function("dataContainerHandle", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
         hSource.assign(ghProp.unwrapBufferField().value());
         
         if ((hSource.isValid()).booleanValue())
         {
            /* The DataContainer flag identifies an Appserver Container */
            /* {get Prop var [handle]} */
            lDataContainer.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataContainer", hSource));
            ghProp.assign(handle.fromString(entry(1, hSource.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
            lSbo.assign(ghProp.unwrapBufferField().value());
            
            if (_and(lDataContainer, not(lSbo)))
            {
               /* Check AppServer properties to see if the object has no current or future 
                       server bindings and is using a stateless operating mode.*/
               if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasNoServerBinding", targetProcedure()))).booleanValue())
               {
                  returnNormal(hSource);
               }
            }
            else
            {
               /* {get Prop var [handle]} */
               silent(() -> cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", hSource)));
               
               if (_isEqual(cAsdivision, "Client"))
               {
                  returnNormal(hSource);
               }
            }
         }
         returnNormal(new handle());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical defineTempTables()
   {
      /*------------------------------------------------------------------------------
        Purpose: Define temp tables for a dynamic dataobject 
                 Returns true if a RowObjectTable is valid on exit.
                 I.e it was created here or the TT is static.   
          Notes: Called from createObjects.     
      ------------------------------------------------------------------------------*/
      handle hRowObjectTable = TypeFactory.handle();
      character cDefs = TypeFactory.character();
      character cAsDivision = TypeFactory.character();
      
      return function("defineTempTables", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataFieldDefs"));
         cDefs.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         cAsDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAsDivision", targetProcedure()));
         
         if (_isEqual(cDefs, ""))
         {
            /* {fnarg <func-name> <arg> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "emptyRowObject", targetProcedure(), "I", "");
            /* {fn <func-name> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionIn(logical.class, "createRowObjectTable", targetProcedure());
         }
         else
         {
            if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUseRepository", targetProcedure()))).booleanValue())
            {
               /* {fn <func-name> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionIn(logical.class, "prepareColumnsFromRepos", targetProcedure());
            }
         }
         /* {get Prop var [handle]} */ 
         hRowObjectTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", targetProcedure()));
         returnNormal(hRowObjectTable.isValid());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical deleteRow(final character _pcRowIdent_4)
   {
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      character cQueryPos = TypeFactory.character();
      handle hRowObject = TypeFactory.handle();
      handle hRowNum = TypeFactory.handle();
      handle hRowObjUpd = TypeFactory.handle();
      handle hRowUpdField = TypeFactory.handle();
      handle hUpdRowMod = TypeFactory.handle();
      handle hDataQuery = TypeFactory.handle();
      logical lAutoCommit = TypeFactory.logical();
      logical lBrowsed = TypeFactory.logical();
      logical lNextNeeded = TypeFactory.logical(false);
      logical lSuccess = TypeFactory.logical(true);
      rowid rDataQuery = TypeFactory.rowid();
      logical lUpdFromSource = TypeFactory.logical();
      logical lRepos = TypeFactory.logical();
      character cMsg = TypeFactory.character();
      logical lNewDeleted = TypeFactory.logical();
      character cFirstResult = TypeFactory.character();
      character cLastResult = TypeFactory.character();
      integer iFirstResult = TypeFactory.integer();
      integer iLastResult = TypeFactory.integer();
      handle hRowIdent = TypeFactory.handle();
      handle hContainer = TypeFactory.handle();
      logical lQueryContainer = TypeFactory.logical();
      
      return function("deleteRow", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObjUpd"));
         hRowObjUpd.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         lBrowsed.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataQueryBrowsed", targetProcedure()));
         
         /* Extract the RowObject ROWID from the RowIdent passed. If it's
              a valid ROWID and found in the Temp-Table, delete that row.
              If that entry isn't defined, then we're doing a delete for
              a query this object isn't managing. Create a RowObjUpd record
              for it (no data needed, just the RowIdent field) and delete it. */
         /* This includes ? which means delete current from 9.1B */
         if (_isNotEqual(entry(1, pcRowIdent_4), ""))
         {
            doBlock(TransactionType.FULL, "blockLabel5", new Block((Body) () -> 
            {
               if (_notUnknown(pcRowIdent_4))
               {
                  silent(() -> rDataQuery.assign(new rowid(entry(1, pcRowIdent_4))));
                  
                  if (_or(not(hRowObject.unwrapBuffer().available()), () -> isNotEqual(hRowObject.unwrapBuffer().rowID(), rDataQuery)))
                  {
                     hRowObject.unwrapBuffer().bufferRelease();
                     lRepos.assign(hDataQuery.unwrapQuery().queryRepositionByID(rDataQuery));
                     
                     if (_isEqual(lRepos, false))
                     {
                        cMsg.assign(concat(valueOf(29), ",", "RowObject", ",", "ROWID ", pcRowIdent_4, ""));
                        /* {fnarg <func-name> <arg> [handle] */ 
                        ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", cMsg);
                        returnNormal(false);
                     }
                  }
                  
                  /* If a Viewer is handling the delete, then we must Next on the query
                           to make the row available. If the query's being browsed this is 
                           implicit */
                  if (_and(not(hRowObject.unwrapBuffer().available()), lRepos))
                  {
                     hDataQuery.unwrapQuery().getNext();
                  }
               }
               
               /* pcRowIdent <> ?  */
               /* We postpone RowObjUpd table creation for dynamic SDOs until really needed, 
                      which will be now... */
               if (_not(hRowObjUpd.isValid()))
               {
                  /* {fn <func-name> [handle] */ 
                  ControlFlowOps.invokeDynamicFunctionIn(logical.class, "createRowObjUpdTable", targetProcedure());
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObjUpd"));
                  hRowObjUpd.assign(ghProp.unwrapBufferField().value());
               }
               
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowObjUpd", targetProcedure(), "II", hRowObject, hRowObjUpd);
               
               if (_not(hRowObjUpd.unwrapBuffer().available()))
               {
                  /* Copy the record to the Update table to be able to restore it 
                           if UNDOne. */
                  hRowObjUpd.unwrapBuffer().bufferCreate();
                  hRowObjUpd.unwrapBuffer().bufferCopy(hRowObject);
               }
               
               /* if RowObjUpd not avail */
               hUpdRowMod.assign(hRowObjUpd.unwrapBuffer().bufferField("RowMod"));
               
               /* If we deleted a new record then just get rid of the rowobjupd */
               if ((matchesList("A,C", new character(hUpdRowMod.unwrapBufferField().value()))).booleanValue())
               {
                  /*  future..need to change data rowObjectstate to dynamically use 
                                    the existance of rowObjUpd.rowmod <> '' and sbo 
                                    rowObjectState to only look in SDOs to make this work.                     
                        hRowObjUpd:BUFFER-DELETE().
                        */
                  lNewDeleted.assign(true);
               }
               
               hUpdRowMod.unwrapBufferField().changeValue(new character("D"));
            }));
         }
         else
         {
            /* We need to try to find a RowObjUpd record for this row before 
                   creating a new one.  findRowObjUpd takes the RowObject and RowObjUpd
                   buffers and returns RowObjUpd buffer. */
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowObjUpd", targetProcedure(), "II", hRowObject, hRowObjUpd);
            
            if ((hRowObjUpd.unwrapBuffer().available()).booleanValue())
            {
               hUpdRowMod.assign(hRowObjUpd.unwrapBuffer().bufferField("RowMod"));
               
               /* If we deleted a new record then just get rid of the rowobjupd */
               if ((matchesList("A,C", new character(hUpdRowMod.unwrapBufferField().value()))).booleanValue())
               {
                  /*  future..need to change data rowObjectstate to dynamically use 
                                     the existance of rowObjUpd.rowmod <> '' and sbo 
                                     rowObjectState to only look in SDOs to make this work.                     
                             hRowObjUpd:BUFFER-DELETE(). */
                  lNewDeleted.assign(true);
               }
               
               hUpdRowMod.unwrapBufferField().changeValue(new character("D"));
            }
            else
            {
               /* IF first entry in RowIdent is blank, use the rest to create
                          a row to delete on behalf of a query managed elsewhere. */
               hRowObjUpd.unwrapBuffer().bufferCreate();
               hRowUpdField.assign(hRowObjUpd.unwrapBuffer().bufferField("RowIdent"));
               hRowUpdField.unwrapBufferField().changeValue(substring(pcRowIdent_4, plus(indexOf(pcRowIdent_4, ","), 1)));
               hRowUpdField.assign(hRowObjUpd.unwrapBuffer().bufferField("RowIdentIdx"));
               hRowUpdField.unwrapBufferField().changeValue(substring(substring(pcRowIdent_4, plus(indexOf(pcRowIdent_4, ","), 1)), 1, xiRocketIndexLimit));
               hRowUpdField.assign(hRowObjUpd.unwrapBuffer().bufferField("RowMod"));
               hRowUpdField.unwrapBufferField().changeValue(new character("D"));
            }
         }
         /* END DO IF no ENTRY(1) */
         /* {get Prop var [handle]} */ 
         lAutoCommit.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAutoCommit", targetProcedure()));
         
         if ((lAutoCommit).booleanValue())
         {
            /* Go ahead with the DB transaction now. */
            ControlFlowOps.invokeIn("commitTransaction", targetProcedure());
            lSuccess.assign(isNotEqual(ControlFlowOps.getReturnValue(), "ADM-ERROR"));
         }
         
         /* END DO IF AutoCommit */
         /* If we returned successfully from the Delete, or we have a Commit Panel
              so the delete has been done only locally for now, delete the RowObject. */
         if (_or(not(lAutoCommit), lSuccess))
         {
            /* {get Prop var [handle]} */ 
            cQueryPos.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryPosition", targetProcedure()));
            
            /* Were we on the first/last record? */
            if (_isNotEqual(entry(1, pcRowIdent_4), ""))
            {
               if (_not(hRowObject.unwrapBuffer().available()))
               {
                  hDataQuery.unwrapQuery().queryRepositionByID(rDataQuery);
                  
                  /* It's available already if repositioned in a browse */
                  if (_not(hRowObject.unwrapBuffer().available()))
                  {
                     hDataQuery.unwrapQuery().getNext();
                  }
               }
               
               /* If browsed we check whether the next record will be available 
                        after deleteComplete. (implicit delete-current-row) */
               /* Back to Current */
               if ((lBrowsed).booleanValue())
               {
                  hDataQuery.unwrapQuery().getNext();
                  lNextNeeded.assign(hDataQuery.unwrapQuery().isOffEnd());
                  hDataQuery.unwrapQuery().getPrevious();
               }
               else
               {
                  lNextNeeded.assign(true);
               }
               
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("LastResultRow"));
               cLastResult.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstResultRow"));
               cFirstResult.assign(ghProp.unwrapBufferField().value());
               hRowIdent.assign(hRowObject.unwrapBuffer().bufferField("RowIdent"));
               hRowNum.assign(hRowObject.unwrapBuffer().bufferField("RowNum"));
               iFirstResult.assign(new integer(entry(1, cFirstResult, ";")));
               iLastResult.assign(new integer(entry(1, cLastResult, ";")));
               
               /* Set to unknown as signal to set new values after the delete */
               if (_isEqual(iFirstResult, hRowNum.unwrapBufferField().value()))
               {
                  cFirstResult.setUnknown();
               }
               
               if (_isEqual(iLastResult, hRowNum.unwrapBufferField().value()))
               {
                  cLastResult.setUnknown();
               }
               
               hRowObject.unwrapBuffer().deleteRecord();
            }
            /* if the object has its own query, there's no temp-table rec to delete.*/
            /* END DO IF pcRowIdent */
            /* This will result in a delete-current-row in the browser */
            NamedEventManager.publish("deleteComplete", targetProcedure());
            
            /* Tell Browser, e.g */
            /* We deleted the first of the batch */
            if (_isUnknown(cFirstResult))
            {
               if (_not(hRowObject.unwrapBuffer().available()))
               {
                  hDataQuery.unwrapQuery().getFirst();
               }
               
               /* This must now be the first record, unless it is new */
               if (_and(hRowObject.unwrapBuffer().available(), () -> isGreaterThan(hRowIdent.unwrapBufferField().value(), "")))
               {
                  cFirstResult.assign(concat(hRowNum.unwrapBufferField().value(), ";", hRowIdent.unwrapBufferField().value()));
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstResultRow"));
                  ghProp.unwrapBufferField().changeValue(cFirstResult);
               }
            }
            
            if (_isUnknown(cLastResult))
            {
               /* If we deleted the last (including a new which is last of the batch )
                        position to the prev */
               if (_not(hRowObject.unwrapBuffer().available()))
               {
                  hDataQuery.unwrapQuery().getPrevious();
               }
               
               /* This must be the last record of the current batch, unless it is new */
               if (_and(hRowObject.unwrapBuffer().available(), () -> isGreaterThan(hRowIdent.unwrapBufferField().value(), "")))
               {
                  cLastResult.assign(concat(hRowNum.unwrapBufferField().value(), ";", hRowIdent.unwrapBufferField().value()));
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("LastResultRow"));
                  ghProp.unwrapBufferField().changeValue(cLastResult);
               }
            }
            
            /* if new deleted then it may not yet be in the browse and thus not
                   become available on the deletecomplete */
            if (_and(lNewDeleted, () -> not(hRowObject.unwrapBuffer().available())))
            {
               hDataQuery.unwrapQuery().getNext();
            }
            
            if (_not(hRowObject.unwrapBuffer().available()))
            {
               hDataQuery.unwrapQuery().getPrevious();
            }
            
            /* If we deleted the first then this must now be the first record */
            if ((hRowObject.unwrapBuffer().available()).booleanValue())
            {
               if (_isEqual(cQueryPos, "FirstRecord"))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
                  ghProp.unwrapBufferField().changeValue(hRowNum.unwrapBufferField().value());
               }
               /* {set Prop value [handle]} */ 
               
               /* If we deleted the last then this must now be the last record */
               if (_isEqual(cQueryPos, "LastRecord"))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
                  ghProp.unwrapBufferField().changeValue(hRowNum.unwrapBufferField().value());
               }
               /* {set Prop value [handle]} */ 
            }
            else
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
               ghProp.unwrapBufferField().changeValue(new integer(0));
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
               ghProp.unwrapBufferField().changeValue(new integer(0));
            }
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateFromSource"));
            lUpdFromSource.assign(ghProp.unwrapBufferField().value());
            
            if (_not(lUpdFromSource))
            {
               /* If there is a Commit-Source, signal that a row has been changed. */
               if (_not(lAutoCommit))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryContainer"));
                  lQueryContainer.assign(ghProp.unwrapBufferField().value());
                  
                  if ((lQueryContainer).booleanValue())
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                     hContainer.assign(ghProp.unwrapBufferField().value());
                     /* {get Prop var [handle]} */
                     lAutoCommit.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAutoCommit", hContainer));
                  }
                  
                  if (_not(lAutoCommit))
                  {
                     NamedEventManager.publish("updateState", targetProcedure(), "I", new Object[]
                     {
                        "delete"
                     });
                     /* {set Prop value [handle]} */ 
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectState", targetProcedure(), "I", "RowUpdated");
                     lNextNeeded.assign(false);
                  }
               }
               
               /* NextNeeded = false if the browse 'autopositioned', also if we deleted 
                        the only or last record don't try to fetch another batch. */
               if (_and(and(lNextNeeded, () -> new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "rowAvailable", targetProcedure(), "I", "NEXT"))) /* {fnarg <func-name> <arg> [handle] */, not(lNewDeleted)))
               {
                  ControlFlowOps.invokeIn("fetchNext", targetProcedure());
               }
               else
               {
                  ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
                  NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
                  {
                     "different"
                  });
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
                  ghProp.unwrapBufferField().changeValue(new character(""));
               }
            }
         }
         /* END DO IF NOT AutoCommit OR Success from Commit */
         /* In the event of a failed delete, doreturnUpd has deleted the
              Update temp-table row. */
         /* Return false if there were any error messages returned. */
         returnNormal(lSuccess);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical emptyRowObject(final character _pcMode_4)
   {
      character pcMode_4 = TypeFactory.initInput(_pcMode_4);
      /*------------------------------------------------------------------------------
         Purpose: empty the RowObject temp-table
      Parameters: pcMode                
                   reset - reset batch properties 
                                 
           Notes:  This is for internal use, ROwObject and DataQuery properties 
                   must be defined.   
      ------------------------------------------------------------------------------*/
      handle hDataQuery = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      logical lOpen = TypeFactory.logical();
      character cTargets = TypeFactory.character();
      integer iVar = TypeFactory.integer();
      handle hSdo = TypeFactory.handle();
      logical lOneToOne = TypeFactory.logical();
      
      return function("emptyRowObject", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         
         if (_and(hRowObject.isValid(), () -> TransactionManager.isTransactionActive()))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
            hDataQuery.assign(ghProp.unwrapBufferField().value());
            
            if ((hDataQuery.isValid()).booleanValue())
            {
               lOpen.assign(hDataQuery.unwrapQuery().isOpen());
               
               if (_not(lOpen))
               {
                  hDataQuery.unwrapQuery().queryOpen();
               }
               
               hDataQuery.unwrapQuery().getFirst();
               
               loopLabel41:
               while ((hRowObject.unwrapBuffer().available()).booleanValue())
               {
                  hRowObject.unwrapBuffer().deleteRecord();
                  /* get next query is ok even if the record is deleted  */
                  hDataQuery.unwrapQuery().getNext();
               }
               
               /* Ensure that the query is closed  */
               if ((hDataQuery.unwrapQuery().isOpen()).booleanValue())
               {
                  hDataQuery.unwrapQuery().queryClose();
               }
            }
         }
         else
         {
            if ((hRowObject.isValid()).booleanValue())
            {
               hRowObject.unwrapBuffer().deleteAll();
            }
         }
         
         /* Reset batch properties */
         if (_isEqual(pcMode_4, "reset"))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
            ghProp.unwrapBufferField().changeValue(new unknown());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
            ghProp.unwrapBufferField().changeValue(new unknown());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstResultRow"));
            ghProp.unwrapBufferField().changeValue(new unknown());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LastResultRow"));
            ghProp.unwrapBufferField().changeValue(new unknown());
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
         cTargets.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr13 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cTargets);
            }
         };
         ToClause toClause14 = new ToClause(iVar, 1, resExpr13);
         
         doTo("loopLabel42", toClause14, new Block((Body) () -> 
         {
            hSdo.assign(handle.fromString(entry(iVar, cTargets)));
            silent(() -> lOneToOne.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUpdateFromSource", hSdo)));
            
            if ((lOneToOne).booleanValue())
            {
               /* {fnarg <func-name> <arg> [handle] */
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "emptyRowObject", hSdo, "I", "reset");
            }
         }));
         
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character fetchRow(final integer _piRow_1, final character _pcViewColList_4)
   {
      integer piRow_1 = TypeFactory.initInput(_piRow_1);
      character pcViewColList_4 = TypeFactory.initInput(_pcViewColList_4);
      /*------------------------------------------------------------------------------
        Purpose:     Repositions the Row Object's query to the desired row (indicated
                     by piRow) and returns that row's values (as specified in 
                     pcViewColList).  The return value is CHR(1) delimited list of
                     values (formatted according to each columns FORMAT expression.)
                     The first value in the list is the RowIdent of the fetched row.
       
        Parameters:
          INPUT piRow         - desired row number within the result set
          INPUT pcViewColList - comma-separated list of names of columns to be 
                                returned.
      ------------------------------------------------------------------------------*/
      integer iRowNum = TypeFactory.integer((Long) null);
      rowid rRowId = TypeFactory.rowid();
      handle hDataQuery = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      handle hRowNum = TypeFactory.handle();
      handle hRowQuery = TypeFactory.handle();
      integer iRow = TypeFactory.integer();
      logical lOk = TypeFactory.logical();
      character cRow = TypeFactory.character(null);
      logical lBrowsed = TypeFactory.logical();
      
      return function("fetchRow", character.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         lBrowsed.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataQueryBrowsed", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         
         if (_not(hDataQuery.unwrapQuery().isOpen()))
         {
            hDataQuery.unwrapQuery().queryOpen();
         }
         
         hRowObject.assign(hDataQuery.unwrapQuery().bufferHandle(1));
         
         if ((hRowObject.unwrapBuffer().available()).booleanValue())
         {
            hRowNum.assign(hRowObject.unwrapBuffer().bufferField("RowNum"));
            iRowNum.assign(hRowNum.unwrapBufferField().value());
         }
         
         /* Save off for comparison.*/
         QueryWrapper.createQuery(hRowQuery);
         /* Get a query to do the "FIND" */
         lOk.assign(hRowQuery.unwrapQuery().setBuffers(hRowObject));
         
         if ((lOk).booleanValue())
         {
            lOk.assign(hRowQuery.unwrapQuery().prepare(concat("FOR EACH RowObject WHERE RowObject.RowNum = ", valueOf(piRow_1))));
         }
         
         if ((lOk).booleanValue())
         {
            lOk.assign(hRowQuery.unwrapQuery().queryOpen());
         }
         
         if ((lOk).booleanValue())
         {
            lOk.assign(hRowQuery.unwrapQuery().getFirst());
         }
         
         if ((hRowObject.unwrapBuffer().available()).booleanValue())
         {
            rRowId.assign(hRowObject.unwrapBuffer().rowID());
            lOk.assign(hDataQuery.unwrapQuery().queryRepositionByID(rRowId));
            
            if (_and(lOk, () -> not(lBrowsed)))
            {
               hDataQuery.unwrapQuery().getNext();
            }
            
            if ((lOk).booleanValue())
            {
               if ((hRowNum.isValid()).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
                  iRow.assign(ghProp.unwrapBufferField().value());
                  
                  if (_isEqual(iRow, hRowNum.unwrapBufferField().value()))
                  {
                     /* {set Prop value [handle]} */ 
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryPosition", targetProcedure(), "I", "LastRecord");
                  }
                  else
                  {
                     if (_isEqual(hRowNum.unwrapBufferField().value(), 1))
                     {
                        /* {set Prop value [handle]} */ 
                        ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryPosition", targetProcedure(), "I", "FirstRecord");
                     }
                     else
                     {
                        if (_or(isEqual(iRowNum, 1), () -> isEqual(iRowNum, iRow)))
                        {
                           /* {set Prop value [handle]} */ 
                           ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryPosition", targetProcedure(), "I", "NotFirstOrLast");
                        }
                     }
                  }
               }
               /* END DO IF VALID-HANDLE */
               /* Signal row change in any case. */
               NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
               {
                  "DIFFERENT"
               });
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
               ghProp.unwrapBufferField().changeValue(new character(""));
               /* This will return ? if not AVAILABLE. */
               cRow /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", targetProcedure(), "I", pcViewColList_4));
            }
         }
         /* if hRowObject:availabel */
         HandleOps.delete(hRowQuery);
         returnNormal(cRow);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character fetchRowIdent(final character _pcRowIdent_4, final character _pcViewColList_4)
   {
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      character pcViewColList_4 = TypeFactory.initInput(_pcViewColList_4);
      /*------------------------------------------------------------------------------
        Purpose:  Repositions the RowObject's query to the desired row, based on
                  the corresponding database record rowid(s) (specified by 
                  pcRowIdent), and returns that row's values (as specified in 
                  pcViewColList).  The return value is CHR(1) delimited list of
                  values (formatted according to each columns FORMAT expression.)
                  The first value in the list is the RowIdent of the fetched row.
                  If that row is not in the RowObject table, it repositions the 
                  database query to that row and resets the RowObject table.
       
        Parameters:
          INPUT pcRowIdent    - desired rowid(s) within the result set, expressed 
                                as a comma-separated list of db rowids;
          INPUT pcViewColList - comma-separated list of names of columns to be 
                                returned.
                                
             Note: If called with unknown or non-existing rowid the query is closed
                   and the SDO will be in a bad state.(fetchNext and -Prev don't work) 
                   The application need to call fetchRowident with a valid value 
                   or fetchFirst, fetchLast or openQuery to get back to normal.                    
      ------------------------------------------------------------------------------*/
      logical lOnClient = TypeFactory.logical();
      logical lFromServer = TypeFactory.logical();
      character cRows = TypeFactory.character(null);
      handle hDataReadHandler = TypeFactory.handle();
      character cAsDivision = TypeFactory.character();
      logical lQueryOpen = TypeFactory.logical();
      
      return function("fetchRowIdent", character.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cAsDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAsDivision", targetProcedure()));
         /* {get Prop var [handle]} */ 
         lQueryOpen.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getQueryOpen", targetProcedure()));
         
         /* We do not support calling this on server before the query is opened 
            (This is to protect the client against bad batch properties, since 
             this call opens the query and obtainContextforCclient will return
             data properties) */
         if (_and(isEqual(cAsDivision, "SERVER"), not(lQueryOpen)))
         {
            returnNormal(new character());
         }
         
         lOnClient /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowObjectUseRowident", targetProcedure(), "I", pcRowIdent_4));
         
         if (_not(lOnClient))
         {
            lFromServer /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "fetchRowWhere", targetProcedure(), "I", pcRowIdent_4));
         }
         
         if (_or(lOnClient, lFromServer))
         {
            cRows /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", targetProcedure(), "I", pcViewColList_4));
            ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataReadHandler"));
            hDataReadHandler.assign(ghProp.unwrapBufferField().value());
            
            if (_not(hDataReadHandler.isValid()))
            {
               NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
               {
                  "DIFFERENT"
               });
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
               ghProp.unwrapBufferField().changeValue(new character(""));
            }
         }
         returnNormal(cRows);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical fetchRowWhere(final character _pcQueryString_2)
   {
      character pcQueryString_2 = TypeFactory.initInput(_pcQueryString_2);
      /*------------------------------------------------------------------------------
         Purpose: fetch or append rows positioned according to input query data. 
      Parameters: pcQueryData 
                    - A complete database query string. 
                    - Rowident - semi colon separated list of rowids for each table. 
           Notes: This is the wrapper for the call to the server and should be called 
                  from code that first checks if the record is on the client.            Called from fetchRowident and findRowWhere. 
                - Used by fetchRowident and findRowWhere  
      ------------------------------------------------------------------------------*/
      character cRowObjectState = TypeFactory.character();
      logical lRebuild = TypeFactory.logical();
      integer iRowsToBatch = TypeFactory.integer();
      integer iRowsReturned = TypeFactory.integer();
      logical lBrowsed = TypeFactory.logical();
      logical lFillBatch = TypeFactory.logical();
      character cSpecial = TypeFactory.character();
      character cRowIdent = TypeFactory.character();
      handle hRowObject = TypeFactory.handle();
      handle hDataQuery = TypeFactory.handle();
      
      return function("fetchRowWhere", logical.class, new Block((Body) () -> 
      {
         if (_isEqual(pcQueryString_2, ""))
         {
            returnNormal(false);
         }
         
         /* {get Prop var [handle]} */ 
         cRowObjectState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", targetProcedure()));
         
         if (_isEqual(cRowObjectState, "RowUpdated"))
         {
            ControlFlowOps.invokeInWithMode("showMessageProcedure", targetProcedure(), "IO", new character("16"), glShowMessageAnswer);
            returnNormal(false);
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RebuildOnRepos"));
         lRebuild.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         /* Determines if this SDO is being browsed by a SmartDataBrowser */
         /* {get Prop var [handle]} */ 
         lBrowsed.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataQueryBrowsed", targetProcedure()));
         /* We log rowident since the TTs may be recreated (could have used rowid when 
             not rebuild...) */
         silent(() -> cRowIdent.assign(hRowObject.unwrapBuffer().bufferField("Rowident").unwrapBufferField().value()));
         
         /* If RebuildOnReposition, flush out the current set of RowObject records 
              and reset the associated flags. */
         if ((lRebuild).booleanValue())
         {
            /* {fnarg <func-name> <arg> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "emptyRowObject", targetProcedure(), "I", "");
         }
         
         /* Set browser refreshable = false */
         if ((lBrowsed).booleanValue())
         {
            NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
            {
               "BatchStart"
            });
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RebuildOnRepos"));
         lRebuild.assign(ghProp.unwrapBufferField().value());
         
         /* We use special signals appended to the passed query to tell whether this 
              is an appending search or a rebuild with fillbatch.  */
         if (_not(lRebuild))
         {
            cSpecial.assign("+");
         }
         else
         {
            if ((lBrowsed).booleanValue())
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("fillBatchOnRepos"));
               lFillBatch.assign(ghProp.unwrapBufferField().value());
               
               /* append '-' to indicate go back from found position to fill batch, 
                      (almost makes sense doesn't it?) */
               if ((lFillBatch).booleanValue())
               {
                  cSpecial.assign("-");
               }
            }
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowsTobatch"));
         iRowsToBatch.assign(ghProp.unwrapBufferField().value());
         /* RowNum is only for refresh  */
         ControlFlowOps.invokeInWithMode("sendRows", targetProcedure(), "IIIIO", new unknown(), concat(pcQueryString_2, cSpecial), new logical(false), iRowsToBatch, iRowsReturned);
         
         if (_and(isEqual(iRowsReturned, 0), not(lRebuild)))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
            hDataQuery.assign(ghProp.unwrapBufferField().value());
            hDataQuery.unwrapQuery().queryOpen();
            
            /* We could have used rowid directly when not Rebuild 
                  (If we logged it above that is) */
            if (_isGreaterThan(cRowIdent, ""))
            {
               /* {fnarg <func-name> <arg> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowObjectUseRowident", targetProcedure(), "I", cRowIdent);
            }
            
            iRowsReturned.assign(0);
         }
         else
         {
            if (_and(hRowObject.isValid(), () -> not(hRowObject.unwrapBuffer().available())))
            {
               if (_isGreaterThan(cRowIdent, ""))
               {
                  /* {fnarg <func-name> <arg> [handle] */ 
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowObjectUseRowident", targetProcedure(), "I", cRowIdent);
               }
               
               iRowsReturned.assign(0);
            }
         }
         
         if ((lBrowsed).booleanValue())
         {
            NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
            {
               "BatchEnd"
            });
         }
         
         returnNormal(isGreaterThan(iRowsReturned, 0));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical findRow(final character _pcKeyValues_2)
   {
      character pcKeyValues_2 = TypeFactory.initInput(_pcKeyValues_2);
      /*------------------------------------------------------------------------------
        Purpose: Find and reposition to a row using the key.
      Parameter: pcKeyFields - Comma or chr(1) separated list of keyfields. 
          Notes:  
      ------------------------------------------------------------------------------*/
      character cKeyFields = TypeFactory.character();
      
      return function("findRow", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cKeyFields.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getKeyFields", targetProcedure()));
         
         /* If comma separated list replace with chr(1) */
         if (_and(isGreaterThan(numEntries(cKeyFields), 1), () -> isEqual(indexOf(pcKeyValues_2, chr(1)), 0)))
         {
            pcKeyValues_2.assign(replaceAll(pcKeyValues_2, ",", chr(1)));
         }
         
         returnNormal(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowWhere", targetProcedure(), "III", cKeyFields, pcKeyValues_2, "="));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical findRowFromObject(final character _pcColumns_6, final character _pcValColumns_1, final handle _phObject_1)
   {
      character pcColumns_6 = TypeFactory.initInput(_pcColumns_6);
      character pcValColumns_1 = TypeFactory.initInput(_pcValColumns_1);
      handle phObject_1 = TypeFactory.initInput(_phObject_1);
      /*------------------------------------------------------------------------------
        Purpose: Find a row using values from another object 
          Notes:  
      ------------------------------------------------------------------------------*/
      character cValues = TypeFactory.character();
      
      return function("findRowFromObject", logical.class, new Block((Body) () -> 
      {
         cValues /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", phObject_1, "I", pcValColumns_1));
         cValues.replaceEntry(1, chr(1), "");
         cValues.assign(leftTrim(cValues, chr(1)));
         
         if (_notUnknown(cValues))
         {
            returnNormal(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowWhere", targetProcedure(), "III", pcColumns_6, cValues, ""));
         }
         
         returnNormal(false);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical findRowInCurrentBatch(final character _pcColumns_6, final character _pcValues_4, final character _pcOperators_4)
   {
      character pcColumns_6 = TypeFactory.initInput(_pcColumns_6);
      character pcValues_4 = TypeFactory.initInput(_pcValues_4);
      character pcOperators_4 = TypeFactory.initInput(_pcOperators_4);
      /*------------------------------------------------------------------------------   
      Purpose: Find and reposition to a row within the current batch where the 
               current batch is on a separate client and NOT in this SDO.
               The major difference between this function and findRowWhere and 
               fetchRowIdent is that the batch information (context) is not changed.            
      Parameters: 
             pcColumns   - Column names (Comma separated)                    
                           Fieldname of a table in the query in the form of 
                           TBL.FLDNM or DB.TBL.FLDNM (only if qualified with db),
                           (RowObject.FLDNM should be used for SDO's)  
                           If the fieldname isn't qualified it checks the tables in 
                           the TABLES property and assumes the first with a match.
             pcValues    - corresponding Values (CHR(1) separated)
             pcOperators - Operator - one for all columns
                                      - blank - defaults to (EQ)  
                                      - Use slash to define alternative string operator
                                        EQ/BEGINS etc..
                                    - comma separated for each column/value                              
        Notes: This API assumes that the requested record is within the current 
               batch and that the batc properties is is set as part of context before 
               this is called.
            -  The API is dedicated for open client calls, for instance when a 
               reposition requires new child data, but the current batch of data not 
               is going to be changed on the client. 
            -  The batch properties will NOT be in synch with the actual data after 
               this request.             
            -  Supports passing 'RowObject.Rowident' as the column name for 
               repositioning to a specific list of ROWIDs (call fetchRowident).  
               (the operator is assumed to be EQ in that case)  
      ------------------------------------------------------------------------------*/
      character cFirstResultRow = TypeFactory.character();
      character cLastResutlRow = TypeFactory.character();
      integer iFirstRowNum = TypeFactory.integer();
      integer iLastRowNum = TypeFactory.integer();
      character cRows = TypeFactory.character(null);
      logical lFound = TypeFactory.logical();
      logical lQueryOpen = TypeFactory.logical();
      logical lRebuild = TypeFactory.logical();
      integer iRowsToBatch = TypeFactory.integer();
      
      return function("findRowInCurrentBatch", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         lQueryOpen.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getQueryOpen", targetProcedure()));
         
         if ((lQueryOpen).booleanValue())
         {
            messageBox("The findRowInCurrentBatch() function can not be called with data in the object", ALERT_WARNING, BTN_OK, (String) null);
            returnNormal(new logical());
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstResultrow"));
         cFirstResultRow.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LastResultrow"));
         cLastResutlRow.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
         iFirstRowNum.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
         iLastRowNum.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowsToBatch"));
         iRowsToBatch.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RebuildOnRepos"));
         lRebuild.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowsToBatch"));
         ghProp.unwrapBufferField().changeValue(new integer(1));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RebuildOnRepos"));
         ghProp.unwrapBufferField().changeValue(new logical(true));
         
         /* Special case to find the row using the fetch row ident */
         if (_isEqual(pcColumns_6, "RowObject.RowIdent"))
         {
            cRows.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "fetchRowident", targetProcedure(), "II", pcValues_4, ""));
            lFound.assign(notUnknown(cRows));
         }
         else
         {
            lFound.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowWhere", targetProcedure(), "III", pcColumns_6, pcValues_4, pcOperators_4));
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstResultrow"));
         ghProp.unwrapBufferField().changeValue(cFirstResultRow);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LastResultrow"));
         ghProp.unwrapBufferField().changeValue(cLastResutlRow);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
         ghProp.unwrapBufferField().changeValue(iFirstRowNum);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
         ghProp.unwrapBufferField().changeValue(iLastRowNum);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowsToBatch"));
         ghProp.unwrapBufferField().changeValue(iRowsToBatch);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RebuildOnRepos"));
         ghProp.unwrapBufferField().changeValue(lRebuild);
         returnNormal(lFound);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical findRowObjectUseRowIdent(final character _pcRowident_2)
   {
      character pcRowident_2 = TypeFactory.initInput(_pcRowident_2);
      /*------------------------------------------------------------------------------
        Purpose:  Repositions the RowObject's query to the desired row, based on
                  the corresponding database record rowid(s) (specified by 
                  pcRowIdent),            
                  If that row is found in the RowObject table, it repositions the 
                  RowObject query to that row.
       
        Parameters:
          INPUT pcRowIdent    - desired rowid(s) within the result set, expressed 
                                as a comma-separated list of db rowids;
          Notes:  operates on RowObject only and does not publish the change 
      ------------------------------------------------------------------------------*/
      handle hRowObject = TypeFactory.handle();
      handle hDataQuery = TypeFactory.handle();
      handle hRowQuery = TypeFactory.handle();
      rowid rRowid = TypeFactory.rowid();
      logical lOk = TypeFactory.logical();
      rowid rCurrent = TypeFactory.rowid();
      
      return function("findRowObjectUseRowIdent", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         
         if (_or(not(hRowObject.isValid()), () -> not(hDataQuery.isValid())))
         {
            returnNormal(false);
         }
         
         rCurrent.assign(hRowObject.unwrapBuffer().rowID());
         QueryWrapper.createQuery(hRowQuery);
         /* Get a query to do the "FIND" */
         hRowQuery.unwrapQuery().setBuffers(hRowObject);
         /* Note that the where clause uses 'BEGINS' on Rowident because the caller
              may have specified a partial RowIdent (first table of a join). 
              (The RowidentIdx of course has to use BEGINS. It is the indexed version
              of the RowidentIdx */
         hRowQuery.unwrapQuery().prepare(concat("FOR EACH ", hRowObject.unwrap().name(), " WHERE RowIdentIdx BEGINS \"", substring(pcRowident_2, 1, xiRocketIndexLimit), "\" AND ", "RowIdent BEGINS \"", pcRowident_2, "\""));
         hRowQuery.unwrapQuery().queryOpen();
         hRowQuery.unwrapQuery().getFirst();
         rRowid.assign(hRowObject.unwrapBuffer().rowID());
         
         if (_notUnknown(rRowid))
         {
            lOk.assign(hDataQuery.unwrapQuery().queryRepositionByID(rRowid));
            
            if (_and(lOk, () -> not(hRowObject.unwrapBuffer().available())))
            {
               hDataQuery.unwrapQuery().getNext();
            }
         }
         else
         {
            if (_notUnknown(rCurrent))
            {
               silent(() -> hRowObject.unwrapBuffer().findByRowID(rCurrent));
            }
         }
         HandleOps.delete(hRowQuery);
         returnNormal(lOk);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical findRowObjectWhere(final character _pcColumns_6, final character _pcValues_4, final character _pcOperators_4, final character _pcMode_4)
   {
      character pcColumns_6 = TypeFactory.initInput(_pcColumns_6);
      character pcValues_4 = TypeFactory.initInput(_pcValues_4);
      character pcOperators_4 = TypeFactory.initInput(_pcOperators_4);
      character pcMode_4 = TypeFactory.initInput(_pcMode_4);
      /*------------------------------------------------------------------------------   
           Purpose: check if a record is in the current Rowobject table
        Parameters: 
             pcColumns   - Column names (Comma separated)                    
                           Fieldname of a table in the query in the form of 
                           TBL.FLDNM or DB.TBL.FLDNM (only if qualified with db is specified),
                           (RowObject.FLDNM should be used for SDO's)  
                           If the fieldname isn't qualified it checks the tables in 
                           the TABLES property and assumes the first with a match.
      
             pcValues    - corresponding Values (CHR(1) separated)
             pcOperators - Operator - one for all columns
                                      - blank - defaults to (EQ)  
                                      - Use slash to define alternative string operator
                                        EQ/BEGINS etc..
                                    - comma separated for each column/value
             pcMode       - FIRST
                          - LAST        
           Notes: Returns ? if batching properties combined with seach criteria
                  cannot be resolved on the client                     
      ---------------------------------------------------------------------------*/
      integer iColumn = TypeFactory.integer();
      character cColumn = TypeFactory.character();
      character cOperator = TypeFactory.character();
      character cValue = TypeFactory.character();
      character cWhere = TypeFactory.character();
      character cQueryString = TypeFactory.character();
      logical lOk = TypeFactory.logical();
      handle hRowQuery = TypeFactory.handle();
      logical lBrowsed = TypeFactory.logical();
      handle hRowObject = TypeFactory.handle();
      handle hRowObjectBuf = TypeFactory.handle();
      handle hDataQuery = TypeFactory.handle();
      rowid rRowid = TypeFactory.rowid();
      logical lRange = TypeFactory.logical();
      integer iFirstRowNum = TypeFactory.integer();
      integer iLastRowNum = TypeFactory.integer();
      character cKeyFields = TypeFactory.character();
      character cField = TypeFactory.character();
      integer iField = TypeFactory.integer();
      character cUniqueIndexes = TypeFactory.character();
      logical lIndexUsed = TypeFactory.logical();
      character cIndexInfo = TypeFactory.character();
      character cTableIndexes = TypeFactory.character();
      character cIndex = TypeFactory.character();
      integer iIndex = TypeFactory.integer();
      logical lDefinite = TypeFactory.logical();
      rowid rCurrent = TypeFactory.rowid();
      
      return function("findRowObjectWhere", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         
         if (_not(hDataQuery.isValid()))
         {
            returnNormal(new logical());
         }
         else
         {
            if (_isEqual(hDataQuery.unwrapQuery().isOpen(), false))
            {
               returnNormal(new logical());
            }
         }
         
         if (_or(isEqual(pcColumns_6, ""), () -> isUnknown(pcColumns_6)))
         {
            returnNormal(false);
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
         iFirstRowNum.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
         iLastRowNum.assign(ghProp.unwrapBufferField().value());
         
         if (_isNotEqual(pcMode_4, "FIRST"))
         {
            /* {fnarg <func-name> <arg> [handle] */ 
            messageBox(new Object[]
            {
               substitute(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 58), new character("findRowObjectWhere()"), pcMode_4),
               new SkipEntity(true)
            }, ALERT_ERROR, BTN_OK, (String) null);
            returnNormal(new logical());
         }
         
         IntegerExpression resExpr14 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(pcColumns_6);
            }
         };
         ToClause toClause15 = new ToClause(iColumn, 1, resExpr14);
         
         doTo("loopLabel43", toClause15, new Block((Body) () -> 
         {
            ControlFlowOps.invokeInWithMode("obtainExpressionEntries", targetProcedure(), "IIIIIOOO", new character("RowObject"), iColumn, pcColumns_6, pcValues_4, pcOperators_4, cColumn, cOperator, cValue);
            
            if (_isGreaterThan(cColumn, ""))
            {
               cWhere.assign(concat(cWhere, (_isEqual(cWhere, "") ? new character("") : new character(" AND ")), cColumn, " ", cOperator, " ", cValue));
               lRange.assign(_not(lRange) ? not((matchesList("=,EQ", cOperator))) : lRange);
            }
            
            /* If range is used and we don't have the first record we 
                  don't know and have to go to the server  
                  We could actually detect a FOUND condition if the OTHER fields used 
                  equality on a unique index... but for now this will have to do   */
            if (_and(lRange, () -> isUnknown(iFirstRowNum)))
            {
               returnNormal(new logical());
            }
            
            /* If operator EQ contains, send the request straight to the server because
                  RowObject does not inherit indices */
            if (_isEqual(cOperator, "Contains"))
            {
               returnNormal(new logical());
            }
         }));
         
         cQueryString /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDataQueryString", targetProcedure()));
         cQueryString.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "insertExpression", targetProcedure(), "III", cQueryString, cWhere, "AND"));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         rCurrent.assign(hRowObject.unwrapBuffer().rowID());
         /* Create local buffer */
         RecordBuffer.create(hRowObjectBuf, hRowObject, hRowObject.unwrap().name());
         QueryWrapper.createQuery(hRowQuery);
         /* Get a query to do the "FIND" */
         lOk.assign(hRowQuery.unwrapQuery().setBuffers(hRowObjectBuf));
         
         if ((lOk).booleanValue())
         {
            lOk.assign(hRowQuery.unwrapQuery().prepare(cQueryString));
         }
         
         if ((lOk).booleanValue())
         {
            lOk.assign(hRowQuery.unwrapQuery().queryOpen());
         }
         
         if ((lOk).booleanValue())
         {
            if (_or(isEqual(pcMode_4, ""), () -> isEqual(pcMode_4, "FIRST")))
            {
               silent(() -> hRowQuery.unwrapQuery().getFirst());
            }
            else
            {
               if (_isEqual(pcMode_4, "LAST"))
               {
                  hRowQuery.unwrapQuery().getLast();
               }
            }
         }
         lOk.assign(hRowObjectBuf.unwrapBuffer().available());
         
         /* If this is a 1-to-1 child there's no need for further determination of */
         /* having found the correct record. */
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUpdateFromSource", targetProcedure()))).booleanValue())
         {
            lDefinite.assign(true);
         }
         else
         {
            if (_and(notUnknown(iFirstRowNum), () -> notUnknown(iLastRowNum)))
            {
               lDefinite.assign(true);
            }
            else
            {
               if (_and(lOk, () -> notUnknown(iFirstRowNum)))
               {
                  lDefinite.assign(true);
               }
               else
               {
                  if (_and(lOk, not(lRange)))
                  {
                     /* {get Prop var [handle]} */ 
                     cKeyFields.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getKeyFields", targetProcedure()));
                     
                     if (_isNotEqual(cKeyFields, ""))
                     {
                        lIndexUsed.assign(true);
                        
                        keyLoop:
                        for (iField.assign(1); _isLessThanOrEqual(iField, numEntries(cKeyFields)); iField.increment())
                        {
                           cField.assign(entry(iField, cKeyFields));
                           
                           if (_not(matchesList(pcColumns_6, cField)))
                           {
                              lIndexUsed.assign(false);
                              break keyLoop;
                           }
                        }
                        
                        if ((lIndexUsed).booleanValue())
                        {
                           lDefinite.assign(true);
                        }
                     }
                     
                     if (_not(lDefinite))
                     {
                        /* {get Prop var [handle]} */ 
                        cIndexInfo.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getIndexInformation", targetProcedure()));
                        cUniqueIndexes.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "indexInformation", targetProcedure(), "III", "unique", true, cIndexInfo));
                        cTableIndexes.assign(entry(1, cIndexInfo, chr(2)));
                        
                        indexLoop:
                        for (iIndex.assign(1); _isLessThanOrEqual(iIndex, numEntries(cTableIndexes, chr(1))); iIndex.increment())
                        {
                           cIndex.assign(entry(iIndex, cTableIndexes, chr(1)));
                           lIndexUsed.assign(true);
                           
                           indexKeyLoop:
                           for (iField.assign(1); _isLessThanOrEqual(iField, numEntries(cIndex)); iField.increment())
                           {
                              cField.assign(entry(iField, cIndex));
                              
                              if (_not(matchesList(pcColumns_6, cField)))
                              {
                                 lIndexUsed.assign(false);
                                 break indexKeyLoop;
                              }
                           }
                           
                           if ((lIndexUsed).booleanValue())
                           {
                              lDefinite.assign(true);
                              break indexLoop;
                           }
                        }
                     }
                  }
               }
            }
         }
         
         if (_and(lDefinite, lOk))
         {
            /* Determines if this SDO is being browsed by a SmartDataBrowser */
            /* {get Prop var [handle]} */ 
            lBrowsed.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataQueryBrowsed", targetProcedure()));
            rRowid.assign(hRowObjectBuf.unwrapBuffer().rowID());
            silent(() -> lOk.assign(hDataQuery.unwrapQuery().queryRepositionByID(rRowid)));
            
            if (_and(lOk, () -> not(lBrowsed)))
            {
               lOk.assign(hDataQuery.unwrapQuery().getNext());
            }
            
            /* Signal row change */
            ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
            NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
            {
               "DIFFERENT"
            });
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
            ghProp.unwrapBufferField().changeValue(new character(""));
         }
         else
         {
            silent(() -> hRowObject.unwrapBuffer().findByRowID(rCurrent));
         }
 /* keep current record avail if not found */;
         /* delete local widget handles */
         HandleOps.delete(hRowObjectBuf);
         HandleOps.delete(hRowQuery);
         /* If we get here we do not know enough whether we have a record or not */
         returnNormal((lDefinite).booleanValue() ? lOk : new logical());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical findRowObjUpd(final handle _phRowObject_1, final handle _phRowObjUpd_1)
   {
      handle phRowObject_1 = TypeFactory.initInput(_phRowObject_1);
      handle phRowObjUpd_1 = TypeFactory.initInput(_phRowObjUpd_1);
      
      return function("findRowObjUpd", logical.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose: REturns true if it finds the passed RowObjUpd that corresponds to 
                    the current record in the passed RowObject buffer
         Parameter: phRowObject AS HANDLE
                    phRowObjUpd AS HANDLE  
             Notes: Called from deleteRow to check for a RowObjUpd for a row being deleted
                    before creating a new one. 
         Note date: 2002/05/31          
         ------------------------------------------------------------------------------*/
         silent(() -> phRowObjUpd_1.unwrapBuffer().findUnique(concat("WHERE RowObjUpd.RowNum = ", valueOf(phRowObject_1.unwrapBuffer().bufferField("RowNum").unwrapBufferField().value()))));
         returnNormal(phRowObjUpd_1.unwrapBuffer().available());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical findRowWhere(final character _pcColumns_6, final character _pcValues_4, final character _pcOperators_4)
   {
      character pcColumns_6 = TypeFactory.initInput(_pcColumns_6);
      character pcValues_4 = TypeFactory.initInput(_pcValues_4);
      character pcOperators_4 = TypeFactory.initInput(_pcOperators_4);
      logical lOnClient = TypeFactory.logical();
      character cAsDivision = TypeFactory.character();
      character cQueryString = TypeFactory.character();
      handle hDataReadHandler = TypeFactory.handle();
      logical lQueryOpen = TypeFactory.logical();
      
      return function("findRowWhere", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cAsDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAsDivision", targetProcedure()));
         /* {get Prop var [handle]} */ 
         lQueryOpen.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getQueryOpen", targetProcedure()));
         
         /* We do not support calling this on server before the query is opened 
              (This is to protect the client against bad batch properties, since 
               this call opens the query and obtainContextforCclient will return
               data properties) */
         if (_and(isEqual(cAsDivision, "SERVER"), not(lQueryOpen)))
         {
            returnNormal(new logical());
         }
         
         /* don't search onclient if QueryOpen is false; stateless web requests
               may call this after context has been set and findRowObjectWhere will 
               think it has enough info to return no */
         if (_and(isNotEqual(cAsDivision, "Server"), lQueryOpen))
         {
            /* Check if the record already is on the client */
            lOnClient.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowObjectWhere", targetProcedure(), "IIII", pcColumns_6, pcValues_4, pcOperators_4, "First"));
            
            /* findRowObjectWhere returns ? if its not able to resolve the query */
            if (_notUnknown(lOnClient))
            {
               returnNormal(lOnClient);
            }
         }
         /* not on server */
         cQueryString.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "newQueryString", targetProcedure(), "IIIII", pcColumns_6, pcValues_4, pcOperators_4, new unknown(), new unknown()));
         
         if ((new logical( /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "fetchRowWhere", targetProcedure(), "I", cQueryString))).booleanValue())
         {
            ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataReadHandler"));
            hDataReadHandler.assign(ghProp.unwrapBufferField().value());
            
            if (_not(hDataReadHandler.isValid()))
            {
               NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
               {
                  "DIFFERENT"
               });
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
               ghProp.unwrapBufferField().changeValue(new character(""));
            }
            
            returnNormal(true);
         }
         returnNormal(false);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character firstRowIds(final character _pcQueryString_2)
   {
      character pcQueryString_2 = TypeFactory.initInput(_pcQueryString_2);
      /*------------------------------------------------------------------------------
         Purpose:   Returns the ROWID (converted to a character string) of the first 
                    database query row satisfying the passed query prepare string.   
      Parameters:
          pcWhere - A complete query where clause that matches the database query's 
                    buffers.
           Notes:   Used by rowidwhere, findRow and findRowWhere    
      ------------------------------------------------------------------------------*/
      character cAsdivision = TypeFactory.character();
      handle hAppServer = TypeFactory.handle();
      character cRowid = TypeFactory.character();
      logical lAsbound = TypeFactory.logical();
      
      return function("firstRowIds", character.class, new Block((Body) () -> 
      {
         /* Determine where to direct the request - client or server.
              The actual code for the function is in query.p. */
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         
         if (_isEqual(cAsdivision, "Client"))
         {
            /* If we're just the client then do this on the AppServer.
                    We must ensure context is set also  */
            /* {get Prop var [handle]} */ 
            lAsbound.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAsBound", targetProcedure()));
            /* {get Prop var [handle]} */ 
            hAppServer.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getASHandle", targetProcedure()));
            
            if (_and(hAppServer.isValid(), () -> isNotEqual(hAppServer, targetProcedure())))
            {
               cRowid.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "firstRowIds", hAppServer, "I", pcQueryString_2));
               /* unbind if getASHandle above did the binding */
               ControlFlowOps.invokeInWithMode("unbindServer", targetProcedure(), "I", new unknown());
            }
            else
            {
               cRowid.setUnknown();
            }
            
            returnNormal(cRowid);
         }
         else
         {
            returnNormal((character) ControlFlowOps.runSuper("firstRowIds", pcQueryString_2));
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getTargetProcedure()
   {
      return function("getTargetProcedure", handle.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Temporary fn to return the source-procedure's target-procedure
                     to a function such as addRow in an SBO who needs to know who
                     the *real* caller object is.
             Notes:  
         ------------------------------------------------------------------------------*/
         returnNormal(ghTargetProcedure);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical hasActiveAudit()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      character cRowUserProp = TypeFactory.character();
      
      return function("hasActiveAudit", logical.class, new Block((Body) () -> 
      {
         silent(() -> cRowUserProp /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnValue", targetProcedure(), "I", "RowUserProp")));
         returnNormal(isGreaterThan(lookup(concat("gstad", chr(3), "yes"), cRowUserProp, chr(4)), 0));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical hasActiveComments()
   {
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      character cRowUserProp = TypeFactory.character();
      
      return function("hasActiveComments", logical.class, new Block((Body) () -> 
      {
         silent(() -> cRowUserProp /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnValue", targetProcedure(), "I", "RowUserProp")));
         returnNormal(isGreaterThan(lookup(concat("gsmcm", chr(3), "yes"), cRowUserProp, chr(4)), 0));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical hasForeignKeyChanged()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns true if the dataSource Foreignfields are different 
                 from the current ForeignValues  
          Notes: DataAvailable has a 'RESET' mode that indicates that the query only 
                 should be opened if necessary. This function is an imporetant part of 
                 that logic. If it returns TRUE the query need to be reopened.  
              -  Uncommitted values are currently not considered to be a change, so 
                 the DataSource's before-image values is checked if 
                 RowObjectState = 'ROwUpdated'.
      Note date: 2002/02/01            
      -----------------------------------------------------------------------------*/
      character cForeignFields = TypeFactory.character();
      character cCurrentValues = TypeFactory.character();
      character cParentValues = TypeFactory.character();
      character cSourceFields = TypeFactory.character();
      integer iField = TypeFactory.integer();
      handle hField = TypeFactory.handle();
      handle hDataSource = TypeFactory.handle();
      character cRowObjectState = TypeFactory.character();
      handle hRowObjUpd = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      logical lNew = TypeFactory.logical();
      
      return function("hasForeignKeyChanged", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cForeignFields.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getForeignFields", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
         cCurrentValues.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         
         if (_not(hDataSource.isValid()))
         {
            returnNormal(false);
         }
         
         loopLabel44:
         for (iField.assign(1); _isLessThanOrEqual(iField, numEntries(cForeignFields)); iField.assign(plus(iField, 2)))
         {
            /* 2nd of pair is source RowObject fld */
            cSourceFields.assign(concat(cSourceFields, (_isEqual(iField, 1) ? new character("") : new character(",")), entry(plus(iField, 1), cForeignFields)));
         }
         
         /* If the DataSource has uncommitted changes, check the before image of the 
             data source (This is admittedly somewhat dirty, but we do not want an API 
             yet...) 
             The intention here is to ensure that this function returns true
             if the parent really is pointing to a different record, but returns 
             false if we still are on the original parent, disregarding changed 
             keyvalues, we also want to disregard uncommitted new records */
         /* {get Prop var [handle]} */
         cRowObjectState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", hDataSource));
         
         if (_isEqual(cRowObjectState, "RowUpdated"))
         {
            /* New uncommitted does not constitute a change, but would fail the check 
                  below */
            /* {get Prop var [handle]} */ 
            lNew.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getNewRow", targetProcedure()));
            
            if ((lNew).booleanValue())
            {
               returnNormal(false);
            }
            
            silent(() -> 
            {
               ghProp.assign(handle.fromString(entry(1, hDataSource.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
               hRowObject.assign(ghProp.unwrapBufferField().value());
            });
            silent(() -> 
            {
               ghProp.assign(handle.fromString(entry(1, hDataSource.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObjUpd"));
               hRowObjUpd.assign(ghProp.unwrapBufferField().value());
            });
            
            /* find the corresponding rowObjUpd -- (really synchronize the buffers) 
                  Check the before image values and RETURN this finding. 
                 if no RowObjUpd record is available then the current parent has not 
                 changed and we will use the general logic below   */
            if (_and(hRowObject.isValid(), () -> hRowObjUpd.isValid()))
            {
               if ((new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowObjUpd", hDataSource, "II", hRowObject, hRowObjUpd))).booleanValue())
               {
                  loopLabel45:
                  for (iField.assign(1); _isLessThanOrEqual(iField, numEntries(cSourceFields)); iField.increment())
                  {
                     hField.assign(hRowObjUpd.unwrapBuffer().bufferField(entry(iField, cSourceFields)));
                     cParentValues.assign(concat(cParentValues, ",", hField.unwrapBufferField().value()));
                  }
                  
                  cParentValues.assign(leftTrim(cParentValues, ","));
                  /* Return immediately */
                  returnNormal(isNotEqual(cParentValues, cCurrentValues));
               }
            }
         }
         silent(() -> cParentValues /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", hDataSource, "I", cSourceFields)));
         /* Throw away the RowIdent entry returned by colValues*/
         cParentValues.replaceEntry(1, chr(1), "");
         /* Remove the chr(1).. DON'T TRIM it may cause a problem if the first 
               value(s) in the list is blank */
         cParentValues.assign(substring(cParentValues, 2));
         returnNormal(isNotEqual(cParentValues, cCurrentValues));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical hasOneToOneTarget()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns true if this DataObject has DataTargets that are updated
                  as part of this.
          Notes:  
      ------------------------------------------------------------------------------*/
      character cDataTargets = TypeFactory.character();
      integer i = TypeFactory.integer();
      handle hTarget = TypeFactory.handle();
      logical lOneToOne = TypeFactory.logical();
      
      return function("hasOneToOneTarget", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
         cDataTargets.assign(ghProp.unwrapBufferField().value());
         
         loopLabel46:
         for (i.assign(1); _isLessThanOrEqual(i, numEntries(cDataTargets)); i.increment())
         {
            hTarget.assign(handle.fromString(entry(i, cDataTargets)));
            
            if ((hTarget.isValid()).booleanValue())
            {
               silent(() -> 
               {
                  ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateFromSource"));
                  lOneToOne.assign(ghProp.unwrapBufferField().value());
               });
               
               if ((lOneToOne).booleanValue())
               {
                  returnNormal(true);
               }
            }
         }
         
         returnNormal(false);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical isDataQueryComplete()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns true if the RowObject temp-table has all records in the 
                 currently defined query.    
          Notes: Currently resolved by checking that the First- and LastRowNum is 
                 defined.  
      ------------------------------------------------------------------------------*/
      integer iLastRowNum = TypeFactory.integer();
      integer iFirstRowNum = TypeFactory.integer();
      
      return function("isDataQueryComplete", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FirstRowNum"));
         iFirstRowNum.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
         iLastRowNum.assign(ghProp.unwrapBufferField().value());
         returnNormal(and(notUnknown(iLastRowNum), () -> notUnknown(iFirstRowNum)));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character newDataQueryString(final character _pcColumns_6, final character _pcValues_4, final character _pcOperators_4)
   {
      character pcColumns_6 = TypeFactory.initInput(_pcColumns_6);
      character pcValues_4 = TypeFactory.initInput(_pcValues_4);
      character pcOperators_4 = TypeFactory.initInput(_pcOperators_4);
      /*------------------------------------------------------------------------------   
           Purpose: Returns a Rowobject querystring  if all columns are defined
                    in the rowobject table.       
           Parameters: 
             pcColumns   - Column names (Comma separated)                    
                           Fieldname of a table in the query in the form of 
                           TBL.FLDNM or DB.TBL.FLDNM (only if qualified with db is specified),
                           (RowObject.FLDNM should be used for SDO's)  
                           If the fieldname isn't qualified it checks the tables in 
                           the TABLES property and assumes the first with a match.
      
             pcValues    - corresponding Values (CHR(1) separated)
             pcOperators - Operator - one for all columns
                                      - blank - defaults to (EQ)  
                                      - Use slash to define alternative string operator
                                        EQ/BEGINS etc..
                                    - comma separated for each column/value
      ---------------------------------------------------------------------------*/
      integer iColumn = TypeFactory.integer();
      character cColumn = TypeFactory.character();
      character cOperator = TypeFactory.character();
      character cStringOp = TypeFactory.character();
      character cDataType = TypeFactory.character();
      character cQuote = TypeFactory.character();
      character cValue = TypeFactory.character();
      character cWhere = TypeFactory.character();
      character cQueryString = TypeFactory.character();
      
      return function("newDataQueryString", character.class, new Block((Body) () -> 
      {
         IntegerExpression resExpr15 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(pcColumns_6);
            }
         };
         ToClause toClause16 = new ToClause(iColumn, 1, resExpr15);
         
         doTo("loopLabel47", toClause16, new Block((Body) () -> 
         {
            cColumn.assign(entry(iColumn, pcColumns_6));
            
            /* Convert dbReference to rowObject reference */
            if (_not(begins(cColumn, "RowObject.")))
            {
               silent(() -> cColumn.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "dbColumnDataName", targetProcedure(), "I", cColumn)));
            }
            
            /* Get the operator for this valuelist. 
                    Be forgiving and make sure we handle '',? and '/begins' as default */
            cOperator.assign(_or(or(isEqual(pcOperators_4, ""), () -> begins(pcOperators_4, "/")), () -> isUnknown(pcOperators_4)) ? new character("=") : _isEqual(numEntries(pcOperators_4), 1) ? entry(1, pcOperators_4, "/") : entry(iColumn, pcOperators_4));
            /* Look for optional string operator if only one entry in operator */
            cStringOp.assign(_and(isEqual(numEntries(pcOperators_4), 1), () -> isEqual(numEntries(pcOperators_4, "/"), 2)) ? entry(2, pcOperators_4, "/") : cOperator);
            cDataType /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnDataType", targetProcedure(), "I", cColumn));
            
            if (_isUnknown(cDataType))
            {
               returnNormal(new character());
            }
            
            cValue.assign(entry(iColumn, pcValues_4, chr(1)));
            cValue.assign(_and(matchesList("INTEGER,DECIMAL", cDataType), () -> isEqual(cValue, "")) ? new character("0") : _and(isEqual(cDataType, "DATE"), () -> isEqual(cValue, "")) ? new character("?") : _isUnknown(cValue) ? new character( /*This could happen if only one value*/"?") : cValue);
            cValue.assign((_isNotEqual(cValue, "") ? replaceAll(cValue, "'", "~'") : new character(" ")));
            cQuote.assign((_and(isEqual(cDataType, "CHARACTER"), () -> isEqual(cValue, "?")) ? new character("") : new character("'")));
            cWhere.assign(concat(cWhere, (_isEqual(cWhere, "") ? new character("") : new character(" AND ")), cColumn, " ", (_isEqual(cDataType, "CHARACTER") ? cStringOp : cOperator), " ", cQuote, cValue, cQuote));
         }));
         
         cQueryString /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDataQueryString", targetProcedure()));
         cQueryString.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "insertExpression", targetProcedure(), "III", cQueryString, cWhere, "AND"));
         returnNormal(cQueryString);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   private logical newRowObject(final character _pcMode_4)
   {
      character pcMode_4 = TypeFactory.initInput(_pcMode_4);
      handle hColumn = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      handle hLogicObject = TypeFactory.handle();
      handle hNewRowObject = TypeFactory.handle();
      rowid rRowid = TypeFactory.rowid();
      logical lBrowsed = TypeFactory.logical();
      character cDtlist = TypeFactory.character();
      character cUslist = TypeFactory.character();
      handle hDtarget = TypeFactory.handle();
      handle hUsource = TypeFactory.handle();
      character cType = TypeFactory.character();
      character cNew = TypeFactory.character();
      integer iVar = TypeFactory.integer();
      
      return function("newRowObject", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
         hRowObject.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         lBrowsed.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDataQueryBrowsed", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLogicObject"));
         hLogicObject.assign(ghProp.unwrapBufferField().value());
         hColumn.assign(hRowObject.unwrapBuffer().bufferField("RowIdent"));
         hColumn.unwrapBufferField().changeValue(new character(""));
         hColumn.assign(hRowObject.unwrapBuffer().bufferField("RowIdentIdx"));
         hColumn.unwrapBufferField().changeValue(new character(""));
         giAddRowNum.assign(plus(giAddRowNum, 1));
          /* Assign high temp row number */hColumn.assign(hRowObject.unwrapBuffer().bufferField("RowNum"));
         hColumn.unwrapBufferField().changeValue(giAddRowNum);
         hColumn.assign(hRowObject.unwrapBuffer().bufferField("RowMod"));
         hColumn.unwrapBufferField().changeValue(substring(pcMode_4, 1, 1));
         
         /* logic hook */
         if ((hLogicObject.isValid()).booleanValue())
         {
            ControlFlowOps.invokeInWithMode("setLogicBuffer", targetProcedure(), "II", hRowObject, new unknown());
         }
         
         silent(() -> ControlFlowOps.invokeIn("modifyNewRecord", targetProcedure()));
         
         if ((hLogicObject.isValid()).booleanValue())
         {
            ControlFlowOps.invokeInWithMode("getLogicBuffer", targetProcedure(), "O", hNewRowObject);
            hRowObject.unwrapBuffer().bufferCopy(hNewRowObject);
            ControlFlowOps.invokeIn("clearLogicRows", targetProcedure());
         }
         
         rRowid.assign(hRowObject.unwrapBuffer().rowID());
         
         /* Fix for issue 5931. ************************************************/
         /* When a browser is a DataTarget we need to make sure that it gets an */
         /* 'updateState' message before the SDO publishes 'dataAvailable'. */
         /* Otherwise, the browser may respond to 'dataAvailable' for the new */
         /* record when it gets re-enabled causing a RecordState of */
         /* 'NoRecordAvailable' (which would cause state problems with child objects). */
         /* The following solution is a temporary, targeted approach to the source of */
         /* the problem (browse widget) so that system stability is maintained. */
         /* A more thorough implementation should be considered */
         /* where 'UpdateState' is generally published before 'dataAvailable' so */
         /* that visual objects can correctly respond (or refuse to respond) to */
         /* dataAvailable from their DataSource */
         /* If we don't have a browse attached to the query then don't do anything */
         if ((lBrowsed).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateSource"));
            cUslist.assign(ghProp.unwrapBufferField().value());
            
            IntegerExpression resExpr16 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cUslist);
               }
            };
            ToClause toClause17 = new ToClause(iVar, 1, resExpr16);
            
            doTo("loopLabel48", toClause17, new Block((Body) () -> 
            {
               hUsource.assign(handle.fromString(entry(iVar, cUslist)));
               
               if ((hUsource.isValid()).booleanValue())
               {
                  /* {get Prop var [handle]} */
                  cNew.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getNewRecord", hUsource));
                  
                  if (_isGreaterThan(lookup(cNew, "ADD,COPY"), 0))
                  {
                     leave("loopLabel48");
                  }
                  else
                  {
                     hUsource.setUnknown();
                  }
               }
               else
               {
                  hUsource.setUnknown();
               }
            }));
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
            cDtlist.assign(ghProp.unwrapBufferField().value());
            
            IntegerExpression resExpr17 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cDtlist);
               }
            };
            ToClause toClause18 = new ToClause(iVar, 1, resExpr17);
            
            doTo("loopLabel49", toClause18, new Block((Body) () -> 
            {
               hDtarget.assign(handle.fromString(entry(iVar, cDtlist)));
               
               if ((hDtarget.isValid()).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, hDtarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectType"));
                  cType.assign(ghProp.unwrapBufferField().value());
                  
                  if (_and(isEqual(cType, "SmartDataBrowser"), () -> isNotEqual(hDtarget, hUsource)))
                  {
                     ControlFlowOps.invokeInWithMode("updateState", hDtarget, "I", new character("Update"));
                  }
               }
            }));
         }
         /* End fix for issue 5931 **************************************/
         /* Notify dataSources. They will check NewRow and close the query */
         NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
         {
            "DIFFERENT"
         });
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
         ghProp.unwrapBufferField().changeValue(new character(""));
         
         /* Under certain circumstances (when focus between windows has been switched 
             by JUST clicking the browses and these windows are recently initialized) 
             the publish above causes a reposition of the query. 
             The browse is the suspect as this is implicit behavior when a browse is 
             refreshed/viewed. This event cannot be trapped and overridden in the browse.
             (It could have been prevented by disabling the browse before this for
             example by an earlier updateState though) */
         if (_isNotEqual(rRowid, hRowObject.unwrapBuffer().rowID()))
         {
            hRowObject.unwrapBuffer().findByRowID(rRowid);
         }
         
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character obtainContextForClient()
   {
      /*------------------------------------------------------------------------------
        Purpose: Obtain context properties to return to the client after or as part 
                 of a server request.   
          Notes: The returned data depends on if this is the first call from the 
                 client or not. If this is the first call we still return the regular
                 context if this is after a data request, which is the request that 
                 may change context. It is considered a data request if the query
                 has been opened or RowObjUpd has records
               - The serverside object's serverFirstCall defaults to false so that a 
                 normal request does not need to have any special information. 
                 It is the client's responsibility to signal a first call by passing 
                 serverFirstCall=yes as part of the context.  
                (We also support the 9.1B trick of setting the FIRST entry in the 
                 context to ObjectInitialized=no as a way to set ServerFirstCall to 
                 true on the server) 
      ------------------------------------------------------------------------------*/
      logical lFirstCall = TypeFactory.logical();
      character cContext = TypeFactory.character();
      character cDataContext = TypeFactory.character();
      character cOperatingMode = TypeFactory.character();
      character cQueryWhere = TypeFactory.character(null);
      character cOpenQuery = TypeFactory.character();
      character cDbnames = TypeFactory.character();
      character cIndexInfo = TypeFactory.character();
      character cKeyFields = TypeFactory.character();
      logical lData = TypeFactory.logical();
      handle hRowObjUpdTable = TypeFactory.handle();
      character cKeyTableId = TypeFactory.character();
      character cEntityFields = TypeFactory.character();
      logical lAuditEnabled = TypeFactory.logical();
      character cAuditEnabled = TypeFactory.character();
      
      return function("obtainContextForClient", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ServerFirstCall"));
         lFirstCall.assign(ghProp.unwrapBufferField().value());
         
         if ((lFirstCall).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ServerOperatingMode"));
            cOperatingMode.assign(ghProp.unwrapBufferField().value());
            
            if (_isEqual(cOperatingMode, "STATELESS"))
            {
               /* {get Prop var [handle]} */ 
               cQueryWhere.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryWhere", targetProcedure()));
            }
            
            /* {get Prop var [handle]} */ 
            cIndexInfo.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getIndexInformation", targetProcedure()));
            /* {get Prop var [handle]} */ 
            cOpenQuery.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getOpenQuery", targetProcedure()));
            /* {get Prop var [handle]} */ 
            cDbnames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDBNames", targetProcedure()));
            /* {get Prop var [handle]} */ 
            cKeyFields.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getKeyFields", targetProcedure()));
            /* {get Prop var [handle]} */ 
            cKeyTableId.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getKeyTableId", targetProcedure()));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("EntityFields"));
            cEntityFields.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("AuditEnabled"));
            lAuditEnabled.assign(ghProp.unwrapBufferField().value());
            /* Is this before or after a data request */
            /* {get Prop var [handle]} */ 
            lData.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getQueryOpen", targetProcedure()));
            
            if (_not(lData))
            {
               /* If not a query, existance of rowObjUpd indicates a commit, which is a data request*/
               /* {get Prop var [handle]} */ 
               hRowObjUpdTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjUpdTable", targetProcedure()));
               lData.assign(hRowObjUpdTable.unwrapTempTable().hasRecords());
            }
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ServerFirstCall"));
            ghProp.unwrapBufferField().changeValue(new logical(false));
            cOperatingMode.assign((_isUnknown(cOperatingMode) ? new character("?") : cOperatingMode));
            cIndexInfo.assign((_isUnknown(cIndexInfo) ? new character("?") : cIndexInfo));
            cOpenQuery.assign((_isUnknown(cOpenQuery) ? new character("?") : cOpenQuery));
            cDbnames.assign((_isUnknown(cDbnames) ? new character("?") : cDbnames));
            cKeyFields.assign((_isUnknown(cKeyFields) ? new character("?") : cKeyFields));
            cKeyTableId.assign((_isUnknown(cKeyTableId) ? new character("?") : cKeyTableId));
            cEntityFields.assign((_isUnknown(cEntityFields) ? new character("?") : cEntityFields));
            cAuditEnabled.assign((_isUnknown(lAuditEnabled) ? new character("?") : valueOf(lAuditEnabled)));
            /* if NOT WebSpeed pass queryWhere as QueryContext 
                                   genContextList deals with this for webspeed .. */
            /* if NOT WebSpeed pass queryWhere as QueryContext 
                                   genContextList deals with this for webspeed .. */
            cContext.assign(concat("IndexInformation", chr(4), cIndexInfo, chr(3), "ServerOperatingMode", chr(4), cOperatingMode, chr(3), "BaseQuery", chr(4), cOpenQuery, chr(3), "DBNames", chr(4), cDbnames, chr(3), "KeyFields", chr(4), cKeyFields, chr(3), "KeyTableId", chr(4), cKeyTableId, chr(3), "EntityFields", chr(4), cEntityFields, chr(3), "ServerFirstCall", chr(4), "NO", chr(3), "AuditEnabled", chr(4), cAuditEnabled, (_and(isNotEqual(LogicalTerminal.getClientType(), "WEBSPEED"), () -> notUnknown(cQueryWhere)) ? concat(chr(3), "QueryContext", chr(4), cQueryWhere) : new character(""))));
         }
         
         /* firstCall */
         if (_or(not(lFirstCall), lData))
         {
            ControlFlowOps.invokeInWithMode("genContextList", targetProcedure(), "O", cDataContext);
         }
         
         returnNormal(concat(cContext, (_and(isNotEqual(cContext, ""), () -> isNotEqual(cDataContext, "")) ? chr(3) : new character("")), cDataContext));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character obtainContextForServer()
   {
      /*------------------------------------------------------------------------------
        Purpose: return a list of properties and set required client query context 
                 properties.  
          Notes: Called from initializeServerObject and directly when the 
                 'one-hit' stateless procedures are called 
      ------------------------------------------------------------------------------*/
      logical lAshasStarted = TypeFactory.logical();
      logical lCheck = TypeFactory.logical();
      logical lRebuild = TypeFactory.logical();
      logical lSubmitVal = TypeFactory.logical();
      logical lFetchHasAudit = TypeFactory.logical();
      logical lFetchHasComment = TypeFactory.logical();
      logical lFetchAutoComment = TypeFactory.logical();
      character cFetchHasAudit = TypeFactory.character();
      character cFetchHasComment = TypeFactory.character();
      character cFetchAutoComment = TypeFactory.character();
      character cEntityFields = TypeFactory.character();
      character cQueryWhere = TypeFactory.character();
      character cPropertiesForServer = TypeFactory.character();
      logical lUseRepository = TypeFactory.logical();
      character cDefs = TypeFactory.character();
      character cLogicalName = TypeFactory.character();
      logical lDestroyStateless = TypeFactory.logical();
      /* Dynamic SDO on server  */
      character cTables = TypeFactory.character();
      character cPhysicalTables = TypeFactory.character();
      character cBaseQuery = TypeFactory.character();
      character cDataColumns = TypeFactory.character();
      character cDataColumnsByTable = TypeFactory.character();
      character cAssignList = TypeFactory.character();
      character cUpdatableColumnsByTable = TypeFactory.character();
      character cDataLogicProcedure = TypeFactory.character();
      character cSchemaLocation = TypeFactory.character();
      
      return function("obtainContextForServer", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ASHasStarted"));
         lAshasStarted.assign(ghProp.unwrapBufferField().value());
         
         if (_not(lAshasStarted))
         {
            /* AsHasStarted is sent to the server to tell if this is the first call 
                        will return the properties we need to retrieve at start up.
                        We may come up with something better later...  */
            /* We don't run Initialize on the server object from the client anymore 
                  (9.1B05) This has been moved to synchronizeProperties instead to reduce 
                  the number of AppServer calls  
                  RUN initializeObject IN hAppServer. */
            cPropertiesForServer.assign(concat("ServerFirstCall", chr(4), "YES"));
         }
         else
         {
            ControlFlowOps.invokeInWithMode("genContextList", targetProcedure(), "O", cPropertiesForServer);
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RebuildOnRepos"));
         lRebuild.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         lSubmitVal.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getServerSubmitValidation", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("CheckCurrentChanged"));
         lCheck.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         lUseRepository.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUseRepository", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataFieldDefs"));
         cDefs.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
         cLogicalName.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DestroyStateless"));
         lDestroyStateless.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(cDefs, ""))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("Tables"));
            cTables.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("PhysicalTables"));
            cPhysicalTables.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataColumns"));
            cDataColumns.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataColumnsByTable"));
            cDataColumnsByTable.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdatableColumnsByTable"));
            cUpdatableColumnsByTable.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("AssignList"));
            cAssignList.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("BaseQuery"));
            cBaseQuery.assign(ghProp.unwrapBufferField().value());
            /* {get Prop var [handle]} */ 
            cDataLogicProcedure.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDataLogicProcedure", targetProcedure()));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("SchemaLocation"));
            cSchemaLocation.assign(ghProp.unwrapBufferField().value());
            cPropertiesForServer.assign(concat((_isGreaterThan(cPropertiesForServer, "") ? concat(cPropertiesForServer, chr(3)) : new character("")), "Tables", chr(4), cTables, chr(3), "PhysicalTables", chr(4), cPhysicalTables, chr(3), "BaseQuery", chr(4), cBaseQuery, chr(3), "DataColumns", chr(4), cDataColumns, chr(3), "DataColumnsByTable", chr(4), cDataColumnsByTable, chr(3), "UpdatableColumnsByTable", chr(4), cUpdatableColumnsByTable, chr(3), "AssignList", chr(4), cAssignList, chr(3), "DataLogicProcedure", chr(4), cDataLogicProcedure, chr(3), "SchemaLocation", chr(4), cSchemaLocation));
         }
         
         if ((lUseRepository).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("FetchHasAudit"));
            lFetchHasAudit.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("FetchHasComment"));
            lFetchHasComment.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("FetchAutoComment"));
            lFetchAutoComment.assign(ghProp.unwrapBufferField().value());
            cFetchHasAudit.assign(_isUnknown(lFetchHasAudit) ? new character("?") : valueOf(lFetchHasAudit));
            cFetchHasComment.assign(_isUnknown(lFetchHasComment) ? new character("?") : valueOf(lFetchHasComment));
            cFetchAutoComment.assign(_isUnknown(lFetchAutoComment) ? new character("?") : valueOf(lFetchAutoComment));
            
            if ((lAshasStarted).booleanValue())
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("EntityFields"));
               cEntityFields.assign(ghProp.unwrapBufferField().value());
               cEntityFields.assign((_isUnknown(cEntityFields) ? new character("?") : cEntityFields));
            }
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryString"));
         cQueryWhere.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(cQueryWhere, ""))
         {
            /* {get Prop var [handle]} */ 
            cQueryWhere.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryWhere", targetProcedure()));
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryContext"));
            ghProp.unwrapBufferField().changeValue(cQueryWhere);
         }
         /* This is hereby the client context and can be used by openQuery to
                   avoid sending QueryString in an extra call */;
         /* {set Prop value [handle]} */ 
         
         if (_isUnknown(cQueryWhere))
         {
            cQueryWhere.assign("");
         }
         
         cPropertiesForServer.assign(concat((_and(notUnknown(cPropertiesForServer), () -> isNotEqual(cPropertiesForServer, "")) ? concat(cPropertiesForServer, chr(3)) : new character("")), "LogicalObjectName", chr(4), (_isUnknown(cLogicalName) ? new character("?") : cLogicalName), chr(3), "DestroyStateless", chr(4), ((lDestroyStateless).booleanValue() ? new character("YES") : new character("NO")), chr(3), "QueryWhere", chr(4), cQueryWhere, chr(3), "RebuildOnRepos", chr(4), valueOf(lRebuild), chr(3), "ServerSubmitValidation", chr(4), valueOf(lSubmitVal), chr(3), "CheckCurrentChanged", chr(4), valueOf(lCheck)));
         
         if ((lUseRepository).booleanValue())
         {
            cPropertiesForServer.assign(concat(cPropertiesForServer, chr(3), "FetchHasAudit", chr(4), cFetchHasAudit, chr(3), "FetchHasComment", chr(4), cFetchHasComment, chr(3), "FetchAutoComment", chr(4), cFetchAutoComment));
            
            if ((lAshasStarted).booleanValue())
            {
               cPropertiesForServer.assign(concat(cPropertiesForServer, chr(3), "EntityFields", chr(4), cEntityFields));
            }
         }
         returnNormal(cPropertiesForServer);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical openDataQuery(final character _pcPosition_1)
   {
      character pcPosition_1 = TypeFactory.initInput(_pcPosition_1);
      /*------------------------------------------------------------------------------
         Purpose: Open the DataQuery  
      Parameters: pcPosition - 'first' or last' 
                               Expected to be extended with Rowid support.  
           Notes: Currently used by SBOs after new temp-tables have been fetched.  
      ------------------------------------------------------------------------------*/
      handle hDataQuery = TypeFactory.handle();
      character cQuery = TypeFactory.character();
      character cAsDivision = TypeFactory.character();
      
      return function("openDataQuery", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataQueryString"));
         cQuery.assign(ghProp.unwrapBufferField().value());
         
         if ((hDataQuery.isValid()).booleanValue())
         {
            hDataQuery.unwrapQuery().prepare(cQuery);
            hDataQuery.unwrapQuery().queryOpen();
            
            switch (StringHelper.safeTrimTrailing((pcPosition_1).toStringMessage()).toUpperCase())
            {
               case "FIRST":
                  {
                     hDataQuery.unwrapQuery().getFirst();
                  }
                  break;
               case "LAST":
                  {
                     hDataQuery.unwrapQuery().getLast();
                  }
                  break;
            }
            
            /* Update QueryPosition property and publish this to toolbars etc unless 
                  no positioning took place here) */
            if (_isNotEqual(pcPosition_1, ""))
            {
               ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
            }
            
            /* Some visual objects that shows more than one record may need to know 
                  that the query changed, this cannot be detected through the ordinary
                  publish "dataAvailable" from the navigation methods. 
                  The SmartSelect populates its list on this event and OCX objects
                  like lists and Tree-views may also need to subscribe to this event. */
            /* {get Prop var [handle]} */ 
            cAsDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAsDivision", targetProcedure()));
            
            if (_isEqual(cAsDivision, "CLIENT"))
            {
               NamedEventManager.publish("queryOpened", targetProcedure());
            }
         }
         /* valid hDataquery */
         returnNormal((hDataQuery.isValid()).booleanValue() ? hDataQuery.unwrapQuery().isOpen() : new logical(false));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical openQuery()
   {
      /*------------------------------------------------------------------------------
        Purpose:     Opens the SmartDataObject's database query based on the current 
                     WHERE clause.
        
        Parameters:  <none>
      ------------------------------------------------------------------------------*/
      character cAsdivision = TypeFactory.character();
      character cDataQueryString = TypeFactory.character();
      handle hDataQuery = TypeFactory.handle();
      handle hDataContainer = TypeFactory.handle();
      character cObjectName = TypeFactory.character();
      
      return function("openQuery", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         
         if ((hDataQuery.isValid()).booleanValue())
         {
            if ((hDataQuery.unwrapQuery().isOpen()).booleanValue())
            {
               /* {fn <func-name> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionIn(logical.class, "closeQuery", targetProcedure());
            }
            else
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DataQueryString"));
               cDataQueryString.assign(ghProp.unwrapBufferField().value());
               
               if (_isNotEqual(cDataQueryString, hDataQuery.unwrapQuery().prepareString()))
               {
                  /* {fnarg <func-name> <arg> [handle] */ 
                  hDataQuery.unwrapQuery().prepare(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "fixQueryString", targetProcedure(), "I", cDataQueryString));
               }
            }
         }
         /* if valid hDataQuery */
         /* If this object can use a DataContainer then we run fetchContainedRows 
             in that in order to retrieve this objects data together with all child 
             objects data. */
         hDataContainer /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "dataContainerHandle", targetProcedure()));
         
         if ((hDataContainer.isValid()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
            cObjectName.assign(ghProp.unwrapBufferField().value());
            ControlFlowOps.invokeInWithMode("fetchContainedData", hDataContainer, "I", cObjectName);
            returnNormal(isNotEqual(ControlFlowOps.getReturnValue(), "adm-error"));
         }
         else
         {
            /* If this is the client half of a divided DataObject, fetchFirst will
                  retrieve the Temp-table across the connection. */
            /* {get Prop var [handle]} */ 
            cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
            
            if (_isEqual(cAsdivision, "Client"))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
               ghProp.unwrapBufferField().changeValue(new unknown());
               /* keep connected until the actual data request in case the appserver 
                       is called during this call */
               /* {set Prop value [handle]} */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setBindScope", targetProcedure(), "I", "Data");
               ControlFlowOps.invokeIn("fetchFirst", targetProcedure());
               /* unbind in case the datarequest did not happen  */
               ControlFlowOps.invokeInWithMode("unbindServer", targetProcedure(), "I", new unknown());
               returnNormal(true);
            }
            else
            {
 /* This is not the client */
               returnNormal((logical) ControlFlowOps.runSuper("openQuery"));
            }
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical prepareColumnsFromRepos()
   {
      /*------------------------------------------------------------------------------
        Purpose: Prepares columns from repository with label, columnlabel and format
          Notes: Only called for static objects.  
                 Does not prepare calculated fields 
      ------------------------------------------------------------------------------*/
      handle hRowObjectTable = TypeFactory.handle();
      character cDataColumns = TypeFactory.character();
      character cDataColumnsByTable = TypeFactory.character();
      character cAssignList = TypeFactory.character();
      character cPhysicalTables = TypeFactory.character();
      logical lDynamicData = TypeFactory.logical();
      logical lOk = TypeFactory.logical();
      character cSchemaLocation = TypeFactory.character();
      
      return function("prepareColumnsFromRepos", logical.class, new Block((Body) () -> 
      {
         if ((gshRepositoryManager.isValid()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DynamicData"));
            lDynamicData.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("PhysicalTables"));
            cPhysicalTables.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataColumnsByTable"));
            cDataColumnsByTable.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataColumns"));
            cDataColumns.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("AssignList"));
            cAssignList.assign(ghProp.unwrapBufferField().value());
            /* {get Prop var [handle]} */ 
            hRowObjectTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", targetProcedure()));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("SchemaLocation"));
            cSchemaLocation.assign(ghProp.unwrapBufferField().value());
            
            /* Static objects will NOT to be copied from repository if the  
                  SchemaLocation is 'DLP' or 'BUF' (which then really means use the 
                  include as-is)  */
            if (_and(not(isEqual(cSchemaLocation, "DLP")), () -> not(isEqual(cSchemaLocation, "BUF"))))
            {
               lOk.assign(ControlFlowOps.invokeDynamicFunctionInWithMode("prepareRowObjectColumns", gshRepositoryManager, "IIIII", hRowObjectTable, cPhysicalTables, cDataColumns, cDataColumnsByTable, cAssignList));
            }
            else
            {
               lOk.assign(true);
            }
            
            /* An error from Repman is fatal for dynamic data 
                   (We currently don't call this for Dynamic Data though, as 
                    createRowObjectTable calls the repman API directly, because it need
                    to pass an unprepared TT to it */
            if ((lDynamicData).booleanValue())
            {
               returnNormal(lOk);
            }
            
            returnNormal(true);
         }
         returnNormal(false);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character prepareForFetch(final character _pcOptions_1)
   {
      character pcOptions_1 = TypeFactory.initInput(_pcOptions_1);
      /*------------------------------------------------------------------------------
        Purpose: prepares the query before a fetch of a temp table from the server  
      Parameters: pcOptions - char
                    Comma separated list of options 
                    - Batch - Specifes that this is part of fetching another 
                              batch and the temp-table and batch properties need to
                              remain.  
                    - Child - Specifies that this is a child of the request initiator.
                              This currently results in a removal of ForeignFields                                  
          Notes:  This is used when more than one table is being fetched and has been 
                  separated for code reuse in the different scenarios. It should only
                  be used in loops where the 
                  caller need to know the order of the 
                  SDOs and their relation ships in order to pass the right options.
      ------------------------------------------------------------------------------*/
      character cQuery = TypeFactory.character();
      character cBaseQuery = TypeFactory.character();
      character cQueryWhere = TypeFactory.character();
      character cForeignFields = TypeFactory.character();
      handle hContainer = TypeFactory.handle();
      
      return function("prepareForFetch", character.class, new Block((Body) () -> 
      {
         /* pcOptions = 'Batch' is used when batching in order to keep the temp-table
              and the batch properties  */
         if (_not(matchesList(pcOptions_1, "Batch")))
         {
            if (_not(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUpdateFromSource", targetProcedure()))))
            {
               /* {fnarg <func-name> <arg> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "emptyRowObject", targetProcedure(), "I", "reset");
            }
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryString"));
         cQuery.assign(ghProp.unwrapBufferField().value());
         
         /* A blank QueryString may indicate that QueryWhere has been set.
              The QueryWhere is stored on the client (also for state-aware objects),
              so we must ensure that it is sent to server if it has been set.*/
         if (_isEqual(cQuery, ""))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("BaseQuery"));
            cBaseQuery.assign(ghProp.unwrapBufferField().value());
            /* {get Prop var [handle]} */ 
            cQueryWhere.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryWhere", targetProcedure()));
            
            /* We only need this if QueryWhere is different from the base, since a 
                   blank entry tells the server to use the base anyway */
            if (_and(isNotEqual(cBaseQuery, cQueryWhere), () -> notUnknown(cQueryWhere)))
            {
               cQuery.assign(cQueryWhere);
            }
         }
         else
         {
            if ((matchesList(pcOptions_1, "CHILD")).booleanValue())
            {
               /* The QueryString Foreign Fields criteria are removed for every SDO 
                      that are 'below' the one we are requesting, as these SDOs will 
                      apply Foreign Fields on the server.  
                     (We cannot trust that dataAvailable will replace the FF as the 
                      positional info about criteria in QueryString is stored 
                      in QueryColumns, and the server's QueryColumns may not match.) */
               /* {fn <func-name> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionIn(logical.class, "removeForeignKey", targetProcedure());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryString"));
               cQuery.assign(ghProp.unwrapBufferField().value());
            }
            else
            {
               /* Even if this is the upper SDO (parent) in this request, it may actually
                      be a child, in which case it is possible that the ForeignFields may 
                      not yet have been appplied to the client's QueryString.
                      So we compare the QueryString with the BaseQuery to see if it just has 
                      been set to avoid problems with FFs returned from server. If that's
                      the case we must use the QueryWhere, which will include potential
                      ForeignField criteria as applied on the server. (We know this is correct
                      since this only can occur if the parent is the same as it was on the 
                      server) */
               /* {get Prop var [handle]} */ 
               cForeignFields.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getForeignFields", targetProcedure()));
               
               if (_isEqual(cForeignFields, ""))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
                  hContainer.assign(ghProp.unwrapBufferField().value());
                  /* {get Prop var [handle]} */
                  silent(() -> cForeignFields.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getForeignFields", hContainer)));
               }
               
               if (_and(isNotEqual(cForeignFields, ""), () -> notUnknown(cForeignFields)))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("BaseQuery"));
                  cBaseQuery.assign(ghProp.unwrapBufferField().value());
                  
                  if (_isEqual(cBaseQuery, cQuery))
                  {
                     /* {get Prop var [handle]} */ 
                     cQuery.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryWhere", targetProcedure()));
                  }
               }
            }
         }
         /* iSDO = iSDONum */
         returnNormal(cQuery);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical prepareQuery(final character _pcQuery_1)
   {
      character pcQuery_1 = TypeFactory.initInput(_pcQuery_1);
      /*------------------------------------------------------------------------------
        Purpose:  Prepare the SmartDataObject's database query based with the
                  passed parameter  
                  The main purpose of this procedure is to isolate the query 
                  preparation for client server, thus keeping that away from the 
                  logic needed to clean up and keep track of the QueryString property.
      Parameters: Complete query expression. 
           Notes: History of client and server query manipulation:            
                  9.0A setQueryWhere    - prepares immediately   (data and query)
                       setQuerySort     - prepares immediately   (data and query
                       openQuery        - just open              (data and query)
                  9.0B addQueryWhere    - stored in queryString prop on client (query)
                       assignQueryWhere - stored in queryString prop on client (query)
                       openQuery        - prepares if queryString is set, open
                  
                  Although the 'client' logic is kept this is no longer part of the 
                  normal client - server operation. The Query is passed as part of 
                  the context.               
      ------------------------------------------------------------------------------*/
      character cAsdivision = TypeFactory.character();
      character cOperatingMode = TypeFactory.character();
      handle hAppServer = TypeFactory.handle();
      logical lOk = TypeFactory.logical();
      
      return function("prepareQuery", logical.class, new Block((Body) () -> 
      {
         /* If this is the client half of a divided DataObject prepare the query
               on the server. */
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         
         if (_isEqual(cAsdivision, "Client"))
         {
            /* {get Prop var [handle]} */ 
            hAppServer.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getASHandle", targetProcedure()));
            
            if ((hAppServer.isValid()).booleanValue())
            {
               lOk /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "prepareQuery", hAppServer, "I", pcQuery_1));
               
               /* If the prepare was a success we must ensure that the new queryWhere 
                         is set in stateless SDOs, which depends on QueryContext both to keep 
                         context and to return the current query in getQueryWhere. */
               if ((lOk).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ServerOperatingMode"));
                  cOperatingMode.assign(ghProp.unwrapBufferField().value());
                  
                  if (_isEqual(cOperatingMode, "STATELESS"))
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryContext"));
                     ghProp.unwrapBufferField().changeValue(pcQuery_1);
                  }
               }
               /* if lOk */
               returnNormal(lOk);
            }
            else
            {
               returnNormal(false);
            }
         }
         else
         {
 /* This is not the client */
            returnNormal((logical) ControlFlowOps.runSuper("prepareQuery", pcQuery_1));
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical prepareRowObject(final handle _phTable_1)
   {
      handle phTable_1 = TypeFactory.initInput(_phTable_1);
      /*------------------------------------------------------------------------------
         Purpose: Prepare a rowObject table from the existing definition 
      Parameters: phHandle created, but unprepared temp-table 
           Notes: This is used to define a dynamic TT FROM another TT, which may be
                  a static one.
      ------------------------------------------------------------------------------*/
      handle hRowObjectTable = TypeFactory.handle();
      
      return function("prepareRowObject", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         hRowObjectTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", targetProcedure()));
         phTable_1.unwrapTempTable().createTableLike(hRowObjectTable.unwrapTempTable().defaultBufferHandle());
         phTable_1.unwrapTempTable().tempTablePrepare(hRowObjectTable.unwrap().name());
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectTable", targetProcedure(), "I", phTable_1);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical repositionRowObject(final character _pcRowIdent_4)
   {
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      /*------------------------------------------------------------------------------
        Purpose:     Procedure to reposition the current rowobject record
                     to the correct one. Used during updates to get around issues
                     where the user has navigated to a different record in the
                     SDO prior to pressing save.
        Parameters:  input rowident
        Notes:       We need to use entry 1 of the rowident which is the rowid of
                     the rowobject temp-table record.
                     This is NOT using reposition because we do not want the browser
                     to reposition.
                     Could only not work if the query has been reopened and the
                     rowobject temp-table has been rebuilt - therefore changing the
                     rowids. This should not happen (hopefully).
      ------------------------------------------------------------------------------*/
      handle hRowObject = TypeFactory.handle();
      rowid rRowid = TypeFactory.rowid();
      
      return function("repositionRowObject", logical.class, new Block((Body) () -> 
      {
         rRowid.assign(new rowid(entry(1, pcRowIdent_4)));
         
         if (_notUnknown(rRowid))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
            hRowObject.assign(ghProp.unwrapBufferField().value());
            silent(() -> hRowObject.unwrapBuffer().findByRowID(rRowid));
         }
         
         returnNormal(and(hRowObject.isValid(), () -> hRowObject.unwrapBuffer().available()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical resetRow(final character _pcRowident_2)
   {
      character pcRowident_2 = TypeFactory.initInput(_pcRowident_2);
      /*------------------------------------------------------------------------------
        Purpose: Reset (undo) the specified rowobject record   
      Parameter: pcRowident 
                     - Rowobject rowid 
                     - ?  will reset current.    
          Notes: This is normally used to reset current row from a visual object's 
                 resetRecord. The rowident parameter allows the same API for SBOs 
                 without the dreaded ghTargetProcedure workaround to identify which 
                 SDO to reset.
      ------------------------------------------------------------------------------*/
      logical lAutoCommit = TypeFactory.logical();
      handle hContainerSource = TypeFactory.handle();
      
      return function("resetRow", logical.class, new Block((Body) () -> 
      {
         if ((new logical( /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "repositionRowobject", targetProcedure(), "I", pcRowident_2))).booleanValue())
         {
            /* {get Prop var [handle]} */ 
            lAutoCommit.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAutoCommit", targetProcedure()));
            
            if (_not(lAutoCommit))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
               hContainerSource.assign(ghProp.unwrapBufferField().value());
               /* {get Prop var [handle]} */
               silent(() -> lAutoCommit.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAutoCommit", hContainerSource)));
               
               /* Reset must reset the RowObjectState for Autocommit SBOs  */
               if ((lAutoCommit).booleanValue())
               {
                  /* {set Prop value [handle]} */ 
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectState", targetProcedure(), "I", "NoUpdates");
               }
            }
            
            /* if Reset in autocommit or inside an SBO with autocommit ensure that 
                   a potential rowObjUpd record left over from a failed save is rolled 
                   back and deleted.  */
            if ((lAutoCommit).booleanValue())
            {
               ControlFlowOps.invokeIn("doUndoRow", targetProcedure());
            }
            
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setDataModified", targetProcedure(), "I", false);
         }
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical resortQuery(final character _pcSort_1)
   {
      character pcSort_1 = TypeFactory.initInput(_pcSort_1);
      /*------------------------------------------------------------------------------
        Purpose: Resorts the current query  
      Parameter: pcSort - sort expression 
                          (see setQuerySort for details)
                        - Blank is remove all sort 
                        - ?  reset to default (BaseQuery).  
          Notes: if the query is closed the passed sort expression will be stored
                 in the QueryString.    
                - SOrts locally,..... 
      ------------------------------------------------------------------------------*/
      logical lOpen = TypeFactory.logical();
      character cRowIdent = TypeFactory.character();
      character cTargets = TypeFactory.character();
      handle hTarget = TypeFactory.handle();
      integer iTarget = TypeFactory.integer();
      character cDisabled = TypeFactory.character();
      character cOldSort = TypeFactory.character();
      character cNewSort = TypeFactory.character();
      logical lQueryObject = TypeFactory.logical();
      logical lSort = TypeFactory.logical();
      integer iRowsToBatch = TypeFactory.integer();
      character cOldDataString = TypeFactory.character();
      character cNewDataString = TypeFactory.character();
      
      return function("resortQuery", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         lOpen.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getQueryOpen", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("RowsToBatch"));
         iRowsToBatch.assign(ghProp.unwrapBufferField().value());
         
         /* if the query is open open we check the current sort to avoid resorting if 
              the same sort is applied (the sdo is literally bombarded by sort requests 
              on open... ) */
         if ((lOpen).booleanValue())
         {
            /* {get Prop var [handle]} */ 
            cOldSort.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQuerySort", targetProcedure()));
         }
         
         /* Store the new sort (also if not opened) */
         lSort /* {set Prop value [handle]} */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQuerySort", targetProcedure(), "I", pcSort_1));
         
         if (_and(lSort, lOpen))
         {
            /* {get Prop var [handle]} */ 
            cNewSort.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQuerySort", targetProcedure()));
            /* {get Prop var [handle]} */ 
            cRowIdent.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowident", targetProcedure()));
            
            if (_and(isNotEqual(cNewSort, cOldSort), () -> isGreaterThan(cRowIdent, "")))
            {
               /* Sort locally if all data on client */
               if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "isDataQueryComplete", targetProcedure()))).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("DataQueryString"));
                  cOldDataString.assign(ghProp.unwrapBufferField().value());
                  
                  /* if this is the first apply of local sorting we apply the oldsort 
                             first, so that toggling can happen immediately */
                  if (_and(isNotEqual(cOldSort, ""), () -> isEqual( /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "sortExpression", targetProcedure(), "I", cOldDataString), "")))
                  {
                     cOldDataString.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "newQuerySort", targetProcedure(), "III", cOldDataString, cOldSort, false));
                     
                     /* if sort failed (i.e. db fields not in SDO) get the string again.. */
                     if (_isUnknown(cOldDataString))
                     {
                        ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("DataQueryString"));
                        cOldDataString.assign(ghProp.unwrapBufferField().value());
                     }
                     /* {get Prop var [handle]} */ 
                  }
                  cNewDataString.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "newQuerySort", targetProcedure(), "III", cOldDataString, pcSort_1, false));
                  
                  if (_and(isGreaterThan(cNewDataString, ""), () -> isNotEqual(cNewDataString, cOldDataString)))
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("DataQueryString"));
                     ghProp.unwrapBufferField().changeValue(cNewDataString);
                     ControlFlowOps.invokeInWithMode("reopenToRowid", targetProcedure(), "I", new unknown());
                  }
               }
               else
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
                  cTargets.assign(ghProp.unwrapBufferField().value());
                  
                  IntegerExpression resExpr18 = new IntegerExpression()
                  {
                     public integer execute()
                     {
                        return numEntries(cTargets);
                     }
                  };
                  ToClause toClause19 = new ToClause(iTarget, 1, resExpr18);
                  
                  doTo("loopLabel50", toClause19, new Block((Body) () -> 
                  {
                     hTarget.assign(handle.fromString(entry(iTarget, cTargets)));
                     
                     if ((hTarget.isValid()).booleanValue())
                     {
                        ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                        lQueryObject.assign(ghProp.unwrapBufferField().value());
                        
                        if ((lQueryObject).booleanValue())
                        {
                           ControlFlowOps.invokeInWithMode("linkStateHandler", hTarget, "III", new character("inactive"), targetProcedure(), new character("DataSource"));
                           cDisabled.assign(concat(cDisabled, (_isEqual(iTarget, 1) ? new character("") : new character(",")), valueOf(hTarget)));
                        }
                     }
                  }));
                  
                  /* Do iTarget = 1 to NUM-ENTRIES(cTargets) */
                  /* {fn <func-name> [handle] */ 
                  ControlFlowOps.invokeDynamicFunctionIn(logical.class, "closeQuery", targetProcedure());
                  /* {fnarg <func-name> <arg> [handle] */ 
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "fetchRowWhere", targetProcedure(), "I", cRowIdent);
                  ControlFlowOps.invokeIn("updateQueryPosition", targetProcedure());
                  /* ideally this is not necessary, but we have retrieved new data 
                             from server, so as of current we ensure visual objects is in 
                             synch (dataobject targets are still disabled) */
                  NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
                  {
                     "reset"
                  });
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("NewBatchInfo"));
                  ghProp.unwrapBufferField().changeValue(new character(""));
                  
                  IntegerExpression resExpr19 = new IntegerExpression()
                  {
                     public integer execute()
                     {
                        return numEntries(cDisabled);
                     }
                  };
                  ToClause toClause20 = new ToClause(iTarget, 1, resExpr19);
                  
                  doTo("loopLabel51", toClause20, new Block((Body) () -> 
                  {
                     hTarget.assign(handle.fromString(entry(iTarget, cDisabled)));
                     
                     if ((hTarget.isValid()).booleanValue())
                     {
                        ControlFlowOps.invokeInWithMode("linkStateHandler", hTarget, "III", new character("active"), targetProcedure(), new character("DataSource"));
                     }
                  }));
               }
            }
         }
         /* if open */
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical rowAvailable(final character _pcDirection_1)
   {
      character pcDirection_1 = TypeFactory.initInput(_pcDirection_1);
      /*------------------------------------------------------------------------------
         Purpose: Check RowObject availability. 
                  Encapsulates the different queryposition alternatives required to
                  check for availability.
      Parameters: pcDirection 
                         NEXT              Is there a next record available
                         PREV              Is there a prev record available
                         '', ?, or CURRENT Current record.
           Notes: This can be used in loops to simplify logic when navigating. 
                  Simplifed example without dynamic-func and handles:
                  -----------------------------------------                                          
                  if rowAvailable('') then 
                  do while true 
                    run fetchNext.
                    if not rowAvailable('next') then leave.  
                  end.            
                  ----------------------------------------
      ------------------------------------------------------------------------------*/
      character cQueryPosition = TypeFactory.character();
      character xcOneOrNone = TypeFactory.character("OnlyRecord,NoRecordAvailable,NoRecordAvailableExt");
      
      return function("rowAvailable", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cQueryPosition.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryPosition", targetProcedure()));
         
         switch (StringHelper.safeTrimTrailing((pcDirection_1).toStringMessage()).toUpperCase())
         {
            case "NEXT":
               {
                  returnNormal(not(matchesList(concat("LastRecord,", xcOneOrNone), cQueryPosition)));
               }
            case "PREV":
               {
                  returnNormal(not(matchesList(concat("FirstRecord,", xcOneOrNone), cQueryPosition)));
               }
            case "":
            case "CURRENT":
            case "?":
               {
                  returnNormal(not(begins(cQueryPosition, "NoRecord")));
               }
         }
         
         returnNormal(false);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character rowValues(final character _pcColumns_6, final character _pcFormat_1, final character _pcDelimiter_1)
   {
      character pcColumns_6 = TypeFactory.initInput(_pcColumns_6);
      character pcFormat_1 = TypeFactory.initInput(_pcFormat_1);
      character pcDelimiter_1 = TypeFactory.initInput(_pcDelimiter_1);
      /*------------------------------------------------------------------------------
        Purpose: Retrieve a list of data from ALL rows in the dataobject.     
        Parameters: 
          pcColumns - Comma separated list of RowObject column names.
          pcFormat  - Formatting option
                       blank or ?   - unformatted: columnValue()  
                      'Formatted'   - Formatted without trailing blanks                                     
                      'TrimNumeric' - Formatted without leading spaces for
                                      numeric data (left justified).     
                      'NoTrim'      - Formatted with leading and trailing blanks. 
                      ' &1 &2 '     - &n, where the number references the column 
                                      in pcColumns order, indicates that the column 
                                      values should be substituted as specified 
                                      instead of returned as delimiter separated
                                      values. This allows formatting data to be mixed
                                      with the returned values; f.ex: '&2 (&1)', 
                                      '&2 / &1'  etc.. 
                                      In order to build a list-item-pair list just 
                                      ensure that the delimiter is in the format;
                                      F. ex: '&2 (&1)' + ',' + '&1' where ',' also 
                                      is passed as delimiter would return a paired
                                      list where the second item of the pair is the 
                                      column number one.   
                    pcDelimiter     - Single char delimiter 
                                       ?      = chr(1) ! 
                                       blank  = single space !         
                    
        Notes: - This function reads all data without publishing dataAvailable to its 
                 data-targets. However, if the query is browsed that will still happen 
                 when reposition-to-rowid is executed to get back to the current record.                             
               - This is intended for use by the SmartSelect or other non-browser
                 widgets that need to show all rows of the SDO.   
               - Should only be used with smaller amounts of records/data, as all data 
                 need to fit in the character return value. The limit is in theory 32K,
                 in reality somewhat smaller. The concatination of the data is 
                 currently wrapped in an on stop block using no-error and a hard-coded
                 message will be shown if the limit is encountered.
               - Maximum 9 columns can be passed when a substitute format is specified   
      ------------------------------------------------------------------------------*/
      handle hDataQuery = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      rowid rRowid = TypeFactory.rowid();
      integer iLastRowNum = TypeFactory.integer();
      integer iCol = TypeFactory.integer();
      character cValue = TypeFactory.character();
      character cList = TypeFactory.character();
      integer iReturnRows = TypeFactory.integer();
      integer iLoop = TypeFactory.integer();
      handle[] hColumnExt = TypeFactory.handleExtent(9);
      handle hColumn = TypeFactory.handle();
      logical lSizeError = TypeFactory.logical();
      /* if bfx size error was detected */
      integer iNumCols = TypeFactory.integer();
      logical lSubstitute = TypeFactory.logical();
      character cMessage = TypeFactory.character();
      character[] cColValue = TypeFactory.characterExtent(9);
      
      return function("rowValues", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataHandle"));
         hDataQuery.assign(ghProp.unwrapBufferField().value());
         
         /* We are not opening the query from here .. */
         if ((hDataQuery.unwrapQuery().isOpen()).booleanValue())
         {
            /* ? is CHR(1) */
            if (_isUnknown(pcDelimiter_1))
            {
               pcDelimiter_1.assign(chr(1));
            }
            else
            {
               if (_isEqual(pcDelimiter_1, ""))
               {
                  pcDelimiter_1.assign(" ");
               }
            }
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("RowObject"));
            hRowObject.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LastRowNum"));
            iLastRowNum.assign(ghProp.unwrapBufferField().value());
             /* if then else used as ? is allowed in format */lSubstitute.assign(_isGreaterThan(indexOf(pcFormat_1, "&"), 0) ? new logical(true) : new logical(false));
            /* Used in WHEN, so must be set BEFORE Assign statement! */
            iNumCols.assign(numEntries(pcColumns_6));
            
            if (_and(lSubstitute, () -> isGreaterThan(iNumCols, 9)))
            {
               messageBox("The maximum number of columns that can be passed to rowValues() with a substitute format is 9.", ALERT_ERROR, BTN_OK, (String) null);
               returnNormal(new character());
            }
            
            silent(() -> 
            {
               rRowid.assign(hRowObject.unwrapBuffer().rowID());
               /* allow dashes, but don't mess with substitute format */
               pcFormat_1.assign(_not(lSubstitute) ? replaceAll(pcFormat_1, "-", "") : pcFormat_1);
               
               if (_isGreaterThanOrEqual(iNumCols, 1))
               {
                  /* Maximize performance, avoid regetting dynamic buffer fields in loop.*/
                  assignSingle(hColumnExt, 1, hRowObject.unwrapBuffer().bufferField(entry(1, pcColumns_6)));
               }
               
               if (_isGreaterThanOrEqual(iNumCols, 2))
               {
                  assignSingle(hColumnExt, 2, hRowObject.unwrapBuffer().bufferField(entry(2, pcColumns_6)));
               }
               
               if (_isGreaterThanOrEqual(iNumCols, 3))
               {
                  assignSingle(hColumnExt, 3, hRowObject.unwrapBuffer().bufferField(entry(3, pcColumns_6)));
               }
               
               if (_isGreaterThanOrEqual(iNumCols, 4))
               {
                  assignSingle(hColumnExt, 4, hRowObject.unwrapBuffer().bufferField(entry(4, pcColumns_6)));
               }
               
               if (_isGreaterThanOrEqual(iNumCols, 5))
               {
                  assignSingle(hColumnExt, 5, hRowObject.unwrapBuffer().bufferField(entry(5, pcColumns_6)));
               }
               
               if (_isGreaterThanOrEqual(iNumCols, 6))
               {
                  assignSingle(hColumnExt, 6, hRowObject.unwrapBuffer().bufferField(entry(6, pcColumns_6)));
               }
               
               if (_isGreaterThanOrEqual(iNumCols, 7))
               {
                  assignSingle(hColumnExt, 7, hRowObject.unwrapBuffer().bufferField(entry(7, pcColumns_6)));
               }
               
               if (_isGreaterThanOrEqual(iNumCols, 8))
               {
                  assignSingle(hColumnExt, 8, hRowObject.unwrapBuffer().bufferField(entry(8, pcColumns_6)));
               }
               
               if (_isGreaterThanOrEqual(iNumCols, 9))
               {
                  assignSingle(hColumnExt, 9, hRowObject.unwrapBuffer().bufferField(entry(9, pcColumns_6)));
               }
            });
            /* Just in case the SDO is browsed, ensure refreshable is turned off */
            NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
            {
               "BatchStart"
            });
            hDataQuery.unwrapQuery().getFirst();
            
            if ((hRowObject.unwrapBuffer().available()).booleanValue())
            {
               IntegerExpression resExpr20 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return _isUnknown(iLastRowNum) ? new integer(2) : new integer(1);
                  }
               };
               ToClause toClause21 = new ToClause(iLoop, 1, resExpr20);
               
               doTo("buildBlock", toClause21, new Block((Body) () -> 
               {
                  /* need two loops if batching */
                  if (_isEqual(iLoop, 2))
                  {
                     ControlFlowOps.invokeInWithMode("sendRows", targetProcedure(), "IIIIO", new unknown(), new unknown(), new logical(true /* Jump to next row */), new integer(0), iReturnRows);
                     
                     if (_isGreaterThan(iReturnRows, 0))
                     {
                        if (_not(hRowObject.unwrapBuffer().available()))
                        {
                           hDataQuery.unwrapQuery().getNext();
                        }
                     }
                  }
                  
                  loopLabel52:
                  while (_isEqual(hDataQuery.unwrapQuery().isOffEnd(), false))
                  {
                     loopLabel53:
                     for (iCol.assign(1); _isLessThanOrEqual(iCol, numEntries(pcColumns_6)); iCol.increment())
                     {
                        /* We preset uptil 9 column handles in the extent, so use the extent
                                     if applicable. */
                        silent(() -> hColumn.assign(_isLessThanOrEqual(iCol, 9) ? subscript(hColumnExt, iCol) : hRowObject.unwrapBuffer().bufferField(entry(iCol, pcColumns_6))));
                        
                        if (_not(hColumn.isValid()))
                        {
                           messageBox(concat("The column '", entry(iCol, pcColumns_6), "' passed to rowValues()", new character(" was not found in the data object.")), ALERT_ERROR, BTN_OK, (String) null);
                           returnNormal(new character());
                        }
                        
                        switch (StringHelper.safeTrimTrailing((pcFormat_1).toStringMessage()).toUpperCase())
                        {
                           case "":
                           case "?":
                              {
                                 cValue.assign(hColumn.unwrapBufferField().value());
                              }
                              break;
                           case "FORMATTED":
                              {
                                 cValue.assign(rightTrim(hColumn.unwrapBufferField().stringValue()));
                              }
                              break;
                           case "TRIMNUMERIC":
                              {
                                 cValue.assign((matchesList("Decimal,Integer", hColumn.unwrapCommonField().getDataType())).booleanValue() ? trim(hColumn.unwrapBufferField().stringValue()) : rightTrim(hColumn.unwrapBufferField().stringValue()));
                              }
                              break;
                           case "NOTRIM":
                              {
                                 cValue.assign(hColumn.unwrapBufferField().stringValue());
                              }
                              break;
                           default:
                              {
                                 assignSingle( /* Substitute format, collect all values in extent  */cColValue, iCol, hColumn.unwrapBufferField().value());
                              }
                              break;
                        }
                        
                        if (_isUnknown(cValue))
                        {
                           cValue.assign("?");
                        }
                        
                        if (_not(lSubstitute))
                        {
                           OnPhrase[] onPhrase3 = new OnPhrase[]
                           {
                              new OnPhrase(Condition.STOP, Action.LEAVE, "blockLabel6")
                           };
                           
                           doBlock(TransactionType.SUB, "blockLabel6", onPhrase3, new Block((Body) () -> 
                           {
                              silent(() -> cList.assign(concat(cList, pcDelimiter_1, cValue)));
                           }));
                           
                           /* end assign block */
                           if ((ErrorManager.isError()).booleanValue())
                           {
                              lSizeError.assign(true);
                              cMessage.assign(ErrorManager.getErrorText(1));
                              leave("buildBlock");
                           }
                        }
                     }
                     
                     /* do iCol = 1 to num-entries */
                     if ((lSubstitute).booleanValue())
                     {
                        OnPhrase[] onPhrase4 = new OnPhrase[]
                        {
                           new OnPhrase(Condition.STOP, Action.LEAVE, "blockLabel7")
                        };
                        
                        doBlock(TransactionType.SUB, "blockLabel7", onPhrase4, new Block((Body) () -> 
                        {
                           silent(() -> cList.assign(concat(cList, pcDelimiter_1, substitute(pcFormat_1, subscript(cColValue, 1), subscript(cColValue, 2), subscript(cColValue, 3), subscript(cColValue, 4), subscript(cColValue, 5), subscript(cColValue, 6), subscript(cColValue, 7), subscript(cColValue, 8), subscript(cColValue, 9)))));
                        }));
                        
                        /* end assign block */
                        if ((ErrorManager.isError()).booleanValue())
                        {
                           lSizeError.assign(true);
                           cMessage.assign(ErrorManager.getErrorText(1));
                           leave("buildBlock");
                        }
                     }
                     /* Subst */
                     hDataQuery.unwrapQuery().getNext();
                  }
               }));
            }
            
            /* if hRowObject:avail do iLoop   */
            if (_notUnknown(rRowid))
            {
               hDataQuery.unwrapQuery().queryRepositionByID(rRowid);
               
               if (_not(hRowObject.unwrapBuffer().available()))
               {
                  hDataQuery.unwrapQuery().getNext();
               }
            }
            /* In case the SDO is browsed, ensure refreshable is turned back on */
            NamedEventManager.publish("fetchDataSet", targetProcedure(), "I", new Object[]
            {
               "BatchEnd"
            });
         }
         
         /* queryopen */
         /* More than 32K in string error... */
         if ((lSizeError).booleanValue())
         {
            messageBox(new Object[]
            {
               cMessage,
               new SkipEntity(true)
            }, ALERT_WARNING, BTN_OK, (String) null);
            returnNormal(new character());
         }
         
         /* Ensure that only the first delimiter is removed; as opposed to the 
              left-trim(...,Separator). We may have space as delimiter and prepend the 
              delimiter above */
         returnNormal(substring(cList, 2));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical submitRow(final character _pcRowIdent_4, final character _pcValueList_3)
   {
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      character pcValueList_3 = TypeFactory.initInput(_pcValueList_3);
      /*------------------------------------------------------------------------------
        Purpose:     Accepts a list of changed values for a row and ASSIGNs them,
                     returning FALSE if any errors occur. 
                     This is done only to the RowObject Temp-Table; 
                     committing the changes back to the database is 
                     a separate step, which will be invoked from here if 
                     AutoCommit is set on.
       
        Parameters:
          INPUT pcRowIdent  - "key" with row number to update, plus a list of the 
                              ROWID(s) of the db record(s) the RowObject is derived 
                              from.
          INPUT pcValueList - CHR(1) delimited list of alternating column names 
                              and values to be assigned.
      ------------------------------------------------------------------------------*/
      logical lReopen = TypeFactory.logical();
      character cErrorMessages = TypeFactory.character("");
      character cUpdColumns = TypeFactory.character();
      
      return function("submitRow", logical.class, new Block((Body) () -> 
      {
         /* NOTE: check here to make sure that the RowIdent passed in 
              matched the current ROWID or could be repositioned to removed in 9.1B.
              There is no supported case where repositioning should be necessary,
              and the new SBO does not always have the correct RowIdent. */
         /* {get Prop var [handle]} */ 
         cUpdColumns.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdatableColumns", targetProcedure()));
         /* Assign Foreign Key values if needed for new records. */
         ControlFlowOps.invokeInWithMode("submitForeignKey", targetProcedure(), "IUU", pcRowIdent_4, pcValueList_3, cUpdColumns);
         /* Create a "before" row in the Update table for an Update, or create a new
              row in the RowObject table for an Add/Copy. */
         ControlFlowOps.invokeInWithMode("doCreateUpdate", targetProcedure(), "IIOO", pcRowIdent_4, pcValueList_3, lReopen, cErrorMessages);
         
         if (_isNotEqual(cErrorMessages, ""))
         {
            returnNormal(false);
         }
         
         /* Perform any validation on individual columns. */
         ControlFlowOps.invokeInWithMode("submitValidation", targetProcedure(), "II", pcValueList_3, cUpdColumns);
         /* Undo the update if there are errors; else commit if AutoCommit. */
         ControlFlowOps.invokeInWithMode("submitCommit", targetProcedure(), "II", pcRowIdent_4, lReopen);
         returnNormal(isNotEqual(ControlFlowOps.getReturnValue(), "ADM-ERROR"));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical updateRow(final character _pcKeyValues_2, final character _pcValueList_3)
   {
      character pcKeyValues_2 = TypeFactory.initInput(_pcKeyValues_2);
      character pcValueList_3 = TypeFactory.initInput(_pcValueList_3);
      /*------------------------------------------------------------------------------
         Purpose: Update an existing row 
      Parameters: pcKeyValues - comma separated or chr(1) separated list of keyvalues
                                ? - update current row
                  pcValueList - CHR(1) delimited list of alternating column names 
                                and values to be assigned.
           Notes:  
      ------------------------------------------------------------------------------*/
      logical lOk = TypeFactory.logical();
      character cRowIdent = TypeFactory.character();
      logical lNewRow = TypeFactory.logical();
      
      return function("updateRow", logical.class, new Block((Body) () -> 
      {
         if (_notUnknown(pcKeyValues_2))
         {
            lOk.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRow", targetProcedure(), "I", pcKeyValues_2));
            
            if (_not(lOk))
            {
               returnNormal(false);
            }
         }
         cRowIdent.assign(entry(1, ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", targetProcedure(), "I", ""), chr(1)));
         
         if (_isUnknown(cRowIdent))
         {
            returnNormal(false);
         }
         
         /* {get Prop var [handle]} */ 
         lNewRow.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getNewRow", targetProcedure()));
         lOk.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "submitRow", targetProcedure(), "II", cRowIdent, pcValueList_3));
         
         if (_and(lNewRow, not(lOk)))
         {
            ControlFlowOps.invokeDynamicFunctionIn(character.class, "cancelRow", targetProcedure());
         }
         
         returnNormal(lOk);
      }));
   }

   public character fwdGetAdmversion()
   {
      return function("fwdGetADMVersion", character.class, new Block((Body) () -> 
      {
         returnNormal("ADM2.2");
      }));
   }
}
