/*--------------------------------------------------------------------------
    File        : Sbo.java
    Purpose     : Super procedure for sbo class.

    Syntax      : RUN start-super-proc("adm2/sbo.p":U).

    Modified    : December 8, 2000 -- Version 9.1B+
    Modified    : 16/11/2001    Mark Davies (MIP)
                  Added new property FilterAvailable
  ------------------------------------------------------------------------*/

package com.goldencode.hotel.common.adm2;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.util.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.logical.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.ProcedureManager.*;
import static com.goldencode.p2j.util.ArrayAssigner.*;
import static com.goldencode.p2j.util.OutputParameter.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;
import static com.goldencode.p2j.util.ErrorManager.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in common/adm2/sbo.p).
 */
public class Sbo
{
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   handle ghTargetProcedure = TypeFactory.handle();

   /* _UIB-CODE-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Procedure
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: CODE-ONLY COMPILE
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Procedure ASSIGN
            HEIGHT             = 19.91
            WIDTH              = 57.2.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ************************* Included-Libraries *********************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Progress Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.sourcepro.org/PPL/                                      *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : sboprop.i
       Purpose     : Defines basic properties.
       Syntax      : {src/adm2/sboprop.i}
   
       Description :
   
       Modified    : October 25, 2000 -- Version 9.1C
       Modified    : 16/11/2001    Mark Davies (MIP)
                     Added new property FilterAvailable
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* Define the maximum number of SDOs the SBO can handle. 
        This corresponds to the number of TABLE-HANDLE parameters
        passed to the server, and is used as an array extent in sbo.p. */   
   /* This is the procedure to execute to set InstanceProperties at design time. */   
   /* Custom instance definition file */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : sbodefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {adm2/custom/sbodefscustom.i}
   
       Modified    : 02/16/2000
       
       Notes       : Referenced in {adm2/sboprop.i}
     ------------------------------------------------------------------------*/   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 8
            WIDTH              = 60.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Include the file which defines prototypes for all of the super
        procedure's entry points. 
        And skip including the prototypes if we are *any* super procedure. */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : cntnprop.i
       Purpose     : Starts containr.p super procedure and defines general
                     SmartContainer properties and other values.
       Syntax      : {src/adm2/cntnprop.i}
   
       Description :
   
       Modified    : August 1, 2000 -- Version 9.1B
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : containrdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/containrdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/cntnprop.i}
     ------------------------------------------------------------------------*/   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 4.52
            WIDTH              = 66.6.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Include the file which defines prototypes for all of the super
        procedure's entry points. Also, start or attach to the super procedure.
        Skip start-super-proc if we *are* the super procedure. 
        And skip including the prototypes if we are *any* super procedure. */   
   /* Preprocs to identify to compiler which properties are in the temp-table.*/   
   /* comma delimited list of pages to construct at startup or * for all or empty for just start page and page 0 */   
   /* for support of Layout Managers */   
   /* for support Navigation as Pass-Through link */   
   /* List of pages that must be initialised together with a specific page. */   
   /* Now include the next-level-up property include file. This builds up
        the property temp-table definition, which we will then add our 
        field definitions to. If this is a non-visual ('virtual') container,
        then skip the visual properties */   
   /* visprop has the same conditional inclusion of appserver as above */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : visprop.i
       Purpose     : Starts Super procedure visual.p and defines basic properties
                     for visual SmartObjects in V9
       Syntax      : {src/adm2/visprop.i}
   
       Description :
   
       Modified    : May 19, 1999 Version 9.1A
       Modified    : 10/23/2001          Mark Davies (MIP)
                     Added two new fields for ResizeHorizontal and ResizeVertical
       Modified    : 11/02/2001          Mark Davies (MIP)
                     Replaced properties for FrameMinHeightChars and FrameMinWidthChars with MinHeight and MinWidth
       Modified    : 11/14/2001          Mark Davies (MIP)
                     Renamed property 'DisplayFieldsSecurity' to 'FieldSecurity'
       Modified    : 02/27/2003          Neil Bell (MIP)
                     Added property 'SecuredTokens'                  
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : visualdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/visualdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/visprop.i}
     ------------------------------------------------------------------------*/   
   /* This is the procedure to execute to set InstanceProperties at design time. */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 8
            WIDTH              = 60.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Include the file which defines prototypes for all of the super
        procedure's entry points. Also, start or attach to the super procedure.
        Skip start-super-proc if we *are* the super procedure. 
        And skip including the prototypes if we are *any* super procedure. */   
   /* These preprocessors tell at compile time which properties can be
        retrieved directly from the temp-table. */   
   /* This property contains the security for all objects found in the AllFieldHandles Property */    
   /* Include the next property file up the chain (in this case, the top
        of the chain); it starts the property temp-table definition and we
        add our field definitions to it. */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smrtprop.i
       Purpose     : Starts smart.p super procedure and defines general
                     SmartObject properties and other values.
       Syntax      : {src/adm2/smrtprop.i}
   
       Description :
   
       Modified    : February 4, 2000 - Version 9.1B
     ------------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress UIB.             */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*--------------------------------------------------------------------------
       File        : smartdefscustom.i
       Purpose     : Entry point to define:
                       New definitions
                       {&xcInstanceProperties}
                       {&ADM-PROPERTY-DLG}
       Syntax      : {src/adm2/custom/smartdefscustom.i}
   
       Modified    : 06/03/1999
       
       Notes       : Referenced in {src/adm2/smrtprop.i}
     ------------------------------------------------------------------------*/   
   /* Service Managers */   
   /*********************************************************************
   * Copyright (C) 2000-2002 by Progress Software Corporation ("PSC"),  *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*---------------------------------------------------------------------------------
     File: globals.i
   
     Description:  ICF Global Shared Variables
   
     Purpose:      ICF Global Shared Variables
                   The global shared variables available within the Dynamics environment.
                   
                   NOTE: (Dynamic Only )
                   Shared variables do not span the client / server boundary. On the
                   client these are set-up in afstartupp.p and on the server in the agent
                   as_startup.p
                   Also note if we include the guts of a procedure as an internal
                   procedure for shared client/server code, we sometime need to
                   ensure the shared variables are not redefined.
   
     Parameters:   <none>
   
     History:
     --------
   
     Modified: 11/08/2001 - Mark Davies (MIP)
               Copied code for ICF afglobals.i and added here to allow
               ICF changed adm code to compile. afglobals.i now includes
               this file for definitions.
               Any ADM code will now reference globals.i which excludes any other
               ICF specific includes.
   -----------------------------------------------------------*/   
   /*                   This .W file was created with the Progress UIB.             */   
   /*-------------------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* ********************  Preprocessor Definitions  ******************** */   
   /* _UIB-PREPROCESSOR-BLOCK-END */   
   /* *********************** Procedure Settings ************************ */   
   /* Settings for THIS-PROCEDURE
      Type: Include
      Allow: 
      Frames: 0
      Add Fields to: Neither
      Other Settings: INCLUDE-ONLY
    */   
   /* *************************  Create Window  ************************** */   
   /* DESIGN Window definition (used by the UIB) 
     CREATE WINDOW Include ASSIGN
            HEIGHT             = 5.57
            WIDTH              = 64.4.
   _* END WINDOW DEFINITION *_
                                                                           */   
   /* ***************************  Main Block  *************************** */   
   /* Used whereever Crystal is used and when defining the tt_datasource temp-table 
      to define the maximum columns supported when printing to crystal.
      See browsercustom.p and afcrpplip2p.p for example uses
   */   
   /* Used for filter checks */   
   /* The table delimiter used in assignlist, *ColumnsByTable props */   
   handle gshAstraAppserver /* quick access to all handles on object, e.g. viewer, whether enabled or not */  /* quick access to all fields on object, e.g. viewer, whether enabled or not */ = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshastraappserver", true, new handle());

   /* Handle to Astra Application Server Partition */   
   handle gshSessionManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsessionmanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshRimanager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrimanager", true, new handle());

   /* Handle Astra Session Manager */   
   handle gshSecurityManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshsecuritymanager", true, new handle());

   /* Handle Astra Security Manager */   
   handle gshProfileManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshprofilemanager", true, new handle());

   /* Handle Astra Profile Manager */   
   handle gshRepositoryManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshrepositorymanager", true, new handle());

   /* Handle Astra Repository Manager */   
   handle gshTranslationManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshtranslationmanager", true, new handle());

   /* Handle Astra Translation Manager */   
   handle gshWebManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshwebmanager", true, new handle());

   /* Handle Astra Web Manager */   
   character gscSessionId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gscsessionid", true, new character(""));

   /* Unique session id */   
   decimal gsdSessionObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionobj", true, new decimal(0));

   /* Unique session id */   
   handle gshFinManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshfinmanager", true, new handle());

   /* Handle AstraFin Generic Manager */   
   handle gshGenManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshgenmanager", true, new handle());

   /* Handle AstraFramework Generic Manager */   
   handle gshAgnManager = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gshagnmanager", true, new handle());

   /* Handle AstraGen Generic Manager */   
   decimal gsdTempUniqueId = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdtempuniqueid", true, new decimal(0));

   /* A number for unique objects */   
   decimal gsdUserObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsduserobj", true, new decimal(0));

   /* User Object ID */   
   decimal gsdRenderTypeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdrendertypeobj", true, new decimal(0));

   /* Render Type Object ID */   
   decimal gsdSessionScopeObj = SharedVariableManager.addVariable(ScopeLevel.GLOBAL, "gsdsessionscopeobj", true, new decimal(0));

   /* Render Type Object ID */   
   /*********************************************************************
   * Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
   * 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
   * below.  All Rights Reserved.                                       *
   *                                                                    *
   * The Initial Developer of the Original Code is PSC.  The Original   *
   * Code is Progress IDE code released to open source December 1, 2000.*
   *                                                                    *
   * The contents of this file are subject to the Possenet Public       *
   * License Version 1.0 (the "License"); you may not use this file     *
   * except in compliance with the License.  A copy of the License is   *
   * available as of the date of this notice at                         *
   * http://www.possenet.org/license.html                               *
   *                                                                    *
   * Software distributed under the License is distributed on an "AS IS"*
   * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
   * should refer to the License for the specific language governing    *
   * rights and limitations under the License.                          *
   *                                                                    *
   * Contributors:                                                      *
   *                                                                    *
   *********************************************************************/   
   /*------------------------------------------------------------------------
       File        : globalscustom.i
       Purpose     : The developer can create his own version of this to 
                     allow 'global' definitions to be added to the 
                     framework.   
       Syntax      : {src/adm2/custom/globalscustom.i}
   
       Description :
   
       Created     : 06/03/1999
       Notes       : Referenced in {src/adm2/globals.i}
     ----------------------------------------------------------------------*/   
   /*          This .W file was created with the Progress AppBuilder.      */   
   /*----------------------------------------------------------------------*/   
   /* ***************************  Definitions  ************************** */   
   /* _UIB-CODE-BLOCK-END */   
   /* define the ADM Version and broker handle for all SmartObjects */   
   /* Note that adm-props-from-repository is documented as possible to define
        as a variable for flexible override, so it cannot be used for conditional 
        compile.  */   
   /* adm-props-from-repository is supported to be defined as a variable,
       so it is not used for conditional compile */   
   handle ghProp = TypeFactory.handle();

   /**
    * External procedure (converted to Java from the 4GL source code
    * in common/adm2/sbo.p).
    */
   public void execute()
   {
      externalProcedure(Sbo.this, new Block((Init) () -> 
      {
         gsdSessionObj.setPrecision(9);
         gsdTempUniqueId.setPrecision(9);
         gsdUserObj.setPrecision(9);
         gsdRenderTypeObj.setPrecision(9);
         gsdSessionScopeObj.setPrecision(9);
      }, 
      (Body) () -> 
      {
         /* _UIB-CODE-BLOCK-END */
         /* *********************** Procedure Settings ************************ */
         /* Settings for THIS-PROCEDURE
            Type: Method-Library
            Allow: 
            Frames: 0
            Add Fields to: Neither
            Other Settings: INCLUDE-ONLY
          */
         /* *************************  Create Window  ************************** */
         /* DESIGN Window definition (used by the UIB) 
           CREATE WINDOW Method-Library ASSIGN
                  HEIGHT             = 14.86
                  WIDTH              = 57.2.
         _* END WINDOW DEFINITION *_
                                                                                 */
         /* ***************************  Main Block  *************************** */
         /* Include the file which defines prototypes for all of the super
              procedure's entry points. Also, start or attach to the super procedure.
              Skip start-super-proc if we *are* the super procedure. 
              And skip including the prototypes if we are *any* super procedure. */
         /* These preprocessors let the get and set methods know at compile time
             which property values are located in the temp-table and which must
             be accessed through the property functions.
          */
         /* for support of dynamic objects */
         /* physical name - no path */
         /* for support of runtime parameters passed from the menus */
         /* Properties for super procedure management */
         /* The name of the super procedure; can be a CSV list */ 
 /* STATELESS, STATEFUL; the mode that all supers for the object will be launched in */ 
 /* Runtime property storing handles to the object's super procedures, defined in SuperProcedure. */
         /* Layout support for dynamic objects */
         /* contains a layout position that allows an object to be laid out correctly. */
         /* determine if we need to create the prop fields here or from the */
         /* repository (if ICF is running ) */
         /* COMMENT THE FOLLOWING LINE TO USE THE "<class>prop.i" DEFINITIONS */
         /* This temp-table defines all the propertt fields for an object.
             This include file contributes the DEFINE statement header and
             all basic smart object properties. Each other property class include file
             adds its own fields and then the parent object ends the statement.
             Define the fields for smart objects only, not for their super procedures.
          */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
         
         /* _UIB-CODE-BLOCK-END */
         /* else if appserver aware (adecomm/appserv.i) include appserver props */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
         
         /* _UIB-CODE-BLOCK-END */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
         
         /* _UIB-CODE-BLOCK-END */
         if (_not(handle.fromString(entry(1, thisProcedure().unwrapADMData().getADMData(), chr(1))).isValid()))
         {
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public character getObjectType()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Returns the Type of the SmartObject, such as "SmartDataObject", etc.
                  For an ADM Super procedure, this function returns "SUPER".
         Params:  <none>
      ------------------------------------------------------------------------------*/
      character cType = TypeFactory.character();
      
      return function("getObjectType", character.class, new Block((Body) () -> 
      {
         cType.assign("SUPER");
         returnNormal(cType);
      }));
   }

   /** *********************  Internal Procedures ********************** */
   /**
    * Purpose:  Update the ObjectMapping property that are used to broker messages<br>
    *           between contained objects and objects linked to the SBO and also <br>
    *           set DataSourceNames and UpdateTargetNames in the dataTarges.                <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:    Called from registerObject, which are subscribed as DataTargetEvent <br>
    *           and published from the DataTarget's initializeObject. <br>
    *         - DataSourceNames may be specified by the user in which case it <br>
    *           actually specifies how to generate the ObjectMapping. <br>
    *           If it's not set, we ensure that both it and UpdateTargetNames <br>
    *           is ALWAYS set here so that colValues, addRow, deleteRow and <br>
    *           updateRow etc. can identify the intended target or source without <br>
    *           looping through all the fields again and again.<br>
    *         - Objects buildt against RowObject must find ALL columns in ONE<br>
    *           of the ContainedDataObjects in order to become mapped. <br>
    *         - Only this procedure is allowed to add datatargets to the <br>
    *           ObjectMapping property.  <br>
    *         - ObjectMapping versus DataSourceNames. Thee is some overlap here and<br>
    *           we could certainly have managed add-, copy- and deleteRow with <br>
    *           ObjectMapping instead of DataSourceNames. But since both cases <br>
    *           requires that we know the requester anyways, there's not much <br>
    *           advantage of just using the ObjectMapping. We also do need a way to <br>
    *           distinguish between UpdateTargets and DataSources and having them <br>
    *           implemented the same ways makes it a bit easier to use. <br>
    *           Ideally (??) the SBO should be more transparent and have an API that<br>
    *           makes it unnecessary for the SBO to have this mapping and instead <br>
    *           make the visual objects responsible of telling the SBO what to <br>
    *           update and for this reason the properties in the visual object seems<br>
    *           to have a more certain future .. ()
    */
   public void addDataTarget(final handle _phTarget_1)
   {
      handle phTarget_1 = TypeFactory.initInput(_phTarget_1);
      /* These are the variables we are going to set the properties with */
      character cMapping = TypeFactory.character();
      character cUpdateTargetNames = TypeFactory.character();
      character cDataSourceNames = TypeFactory.character();
      logical lSourceSpecified = TypeFactory.logical();
      handle hMaster = TypeFactory.handle();
      character cSource = TypeFactory.character();
      handle hSource = TypeFactory.handle();
      handle hUpdateTarget = TypeFactory.handle();
      character cTarget = TypeFactory.character();
      integer iSource = TypeFactory.integer();
      character cObjectList = TypeFactory.character();
      character cObjectName = TypeFactory.character();
      handle hTarget = TypeFactory.handle();
      character cDataColumns = TypeFactory.character();
      character cEnabledColumns = TypeFactory.character();
      logical lUpdate = TypeFactory.logical();
      character cContainedColumns = TypeFactory.character();
      character cContainedObjects = TypeFactory.character();
      character cSdocolumns = TypeFactory.character();
      character cColumn = TypeFactory.character();
      integer iColumn = TypeFactory.integer();
      logical lSourceFound = TypeFactory.logical();
      logical lSbotarget = TypeFactory.logical();
      character cDataObjectNames = TypeFactory.character();
      character cForeignFields = TypeFactory.character();
      integer iUpdLoop = TypeFactory.integer();
      handle hUpd = TypeFactory.handle();
      logical lOneToOne = TypeFactory.logical();
      character cObjectType = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         cTarget.assign(valueOf(phTarget_1));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         
         /* Don't add if its already in the list */
         if (_isEqual(lookup(cTarget, cMapping), 0))
         {
            hTarget.assign(handle.fromString(cTarget));
            
            if ((hTarget.isValid()).booleanValue())
            {
               /* We also support SDOs/SBOs as data-targets */
               cObjectType /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getObjectType", hTarget));
               
               if (_or(isEqual(cObjectType, "SmartDataObject"), () -> isEqual(cObjectType, "SmartBusinessObject")))
               {
                  ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignFields"));
                  cForeignFields.assign(ghProp.unwrapBufferField().value());
                  
                  if (_isNotEqual(cForeignFields, ""))
                  {
                     IntegerExpression resExpr0 = new IntegerExpression()
                     {
                        public integer execute()
                        {
                           return numEntries(cForeignFields);
                        }
                     };
                     ToClause toClause0 = new ToClause(iColumn, 1, resExpr0, new integer(2));
                     
                     doTo("loopLabel0", toClause0, new Block((Body) () -> 
                     {
                        silent(() -> 
                        {
                            /* 2nd of pair is source RowObject fld */cColumn.assign(entry(plus(iColumn, 1), cForeignFields));
                           cObjectName.assign(entry(1, cColumn, "."));
                           hSource /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", cObjectName));
                        });
                        
                        /* If this is truly one of the SBO's DataObjects 
                                        and not already in the DataSourceNames list then update the 
                                        mapping and the DataSourceNames */
                        if (_and(hSource.isValid(), () -> isEqual(lookup(cObjectName, cDataSourceNames), 0)))
                        {
                           cMapping.assign(concat(cMapping, (_isEqual(cMapping, "") ? new character("") : new character(",")), valueOf(hTarget), ",", valueOf(hSource)));
                           cDataSourceNames.assign(concat(cDataSourceNames, (_isEqual(cDataSourceNames, "") ? new character("") : new character(",")), (_isUnknown(cObjectName) ? new character("?") : cObjectName)));
                        }
                     }));
                  }
                  else
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterdataObject"));
                     hMaster.assign(ghProp.unwrapBufferField().value());
                     ghProp.assign(handle.fromString(entry(1, hMaster.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
                     cObjectName.assign(ghProp.unwrapBufferField().value());
                     cMapping.assign(concat(cMapping, (_isEqual(cMapping, "") ? new character("") : new character(",")), valueOf(hTarget), ",", valueOf(hMaster)));
                     cDataSourceNames.assign(concat(cDataSourceNames, (_isEqual(cDataSourceNames, "") ? new character("") : new character(",")), (_isUnknown(cObjectName) ? new character("?") : cObjectName)));
                  }
                  ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
                  ghProp.unwrapBufferField().changeValue(cDataSourceNames);
               }
               else
               {
                  silent(() -> 
                  {
                     ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
                     cObjectList.assign(ghProp.unwrapBufferField().value());
                  });
                  lSourceSpecified.assign(and(notUnknown(cObjectList), () -> isNotEqual(cObjectList, "")));
                  lSourceFound.assign(false);
                  
                  /* if the Instance property dataSourceNames isn't defined see if 
                               the 'Master' property DisplayedTables can be used or if it is 
                               'RowObject' and all fields must be checked. (The term 'Master' 
                               property refers to the fact that the property is defined at build
                               time and not at instance design time)*/
                  if (_not(lSourceSpecified))
                  {
                     /* {get Prop var [handle]} */
                     silent(() -> cObjectList.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDisplayedTables", hTarget)));
                  }
                  
                  /* This is probably a container with no displayedTables prop, but 
                               we set it to blank and leave the decision to return after the 
                               DisplayedFields check just below */
                  if (_isUnknown(cObjectList))
                  {
                     cObjectList.assign("");
                  }
                  
                  /* We want to update UpdateTargetNames according to which fields 
                               that actually are enabled. */
                  /* {get Prop var [handle]} */
                  silent(() -> cEnabledColumns.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getEnabledFields", hTarget)));
                  
                  /* If the target was built with RowObject, we check each field in the 
                              target for a complete match in one of the ContainedObjects. 
                              The ObjectList = '' also for dynBrowsers built before 
                              and for objects build against an SBO with all fields disabled 
                              due to an AppBuilder bug */
                  if (_or(isEqual(cObjectList, "RowObject"), () -> isEqual(cObjectList, "")))
                  {
                     /* {get Prop var [handle]} */
                     silent(() -> cDataColumns.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDisplayedFields", hTarget)));
                     
                     if (_or(isEqual(cDataColumns, ""), () -> isUnknown(cDataColumns)))
                     {
                        returnNormal();
                     }
                     
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
                     cContainedObjects.assign(ghProp.unwrapBufferField().value());
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataColumns"));
                     cContainedColumns.assign(ghProp.unwrapBufferField().value());
                     /* If the first column is qualifed this is built against an SBO */
                     lSbotarget.assign(isGreaterThan(numEntries(entry(1, cDataColumns), "."), 1));
                     
                     if ((lSbotarget).booleanValue())
                     {
                        /* {get Prop var [handle]} */ 
                        cDataObjectNames.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectNames", targetProcedure()));
                        
                        sbocolumnSearch:
                        for (iColumn.assign(1); _isLessThanOrEqual(iColumn, numEntries(cDataColumns)); iColumn.increment())
                        {
                           cColumn.assign(entry(iColumn, cDataColumns));
                           /* If we haven't already found a matching enabled column,
                                                check if this one is */
                           lUpdate.assign(isGreaterThan(lookup(cColumn, cEnabledColumns), 0));
                           cObjectName.assign(entry(1, cColumn, "."));
                           cColumn.assign(entry(numEntries(cColumn, "."), cColumn, "."));
                           iSource.assign(lookup(cObjectName, cDataObjectNames));
                           
                           /* The qualifier does not match any SDO */
                           if (_isEqual(iSource, 0))
                           {
                              lSourceFound.assign(false);
                              break sbocolumnSearch;
                           }
                           
                           /*                   lUpdate     = FALSE  */
                           cSdocolumns.assign(entry(iSource, cContainedColumns, ";"));
                           
                           /*  The Column does not match */
                           if (_isEqual(lookup(cColumn, cSdocolumns), 0))
                           {
                              lSourceFound.assign(false);
                              break sbocolumnSearch;
                           }
                           
                           if (_isEqual(lookup(cObjectName, cDataSourceNames), 0))
                           {
                              lSourceFound.assign(true);
                              cSource.assign(entry(iSource, cContainedObjects));
                              cMapping.assign(concat(cMapping, (_isEqual(cMapping, "") ? new character("") : new character(",")), valueOf(hTarget), ",", cSource));
                              cDataSourceNames.assign(concat(cDataSourceNames, (_isEqual(cDataSourceNames, "") ? new character("") : new character(",")), (_isUnknown(cObjectName) ? new character("?") : cObjectName)));
                              
                              /* Add this as an update target if the field is enabled */
                              if ((lUpdate).booleanValue())
                              {
                                 cUpdateTargetNames.assign(concat(cUpdateTargetNames, (_isEqual(cUpdateTargetNames, "") ? new character("") : new character(",")), (_isUnknown(cObjectName) ? new character("?") : cObjectName)));
                              }
                           }
                        }
                     }
                     else
                     {
                        containedObjectSearch:
                        for (iSource.assign(1); _isLessThanOrEqual(iSource, numEntries(cContainedObjects)); iSource.increment())
                        {
                           lUpdate.assign(false);
                           cSdocolumns.assign(entry(iSource, cContainedColumns, ";"));
                           
                           loopLabel1:
                           for (iColumn.assign(1); _isLessThanOrEqual(iColumn, numEntries(cDataColumns)); iColumn.increment())
                           {
                              cColumn.assign(entry(iColumn, cDataColumns));
                              /* remove object qualifier e.g. dynlookup */
                              cColumn.assign(entry(numEntries(cColumn, "."), cColumn, "."));
                              
                              if (_isEqual(lookup(cColumn, cSdocolumns), 0))
                              {
                                 continue containedObjectSearch;
                              }
                              
                              /* If we haven't already found a matching enabled column,
                                                 check if this one is */
                              if (_not(lUpdate))
                              {
                                 lUpdate.assign(isGreaterThan(lookup(cColumn, cEnabledColumns), 0));
                              }
                           }
                           
                           lSourceFound.assign(true);
                           cSource.assign(entry(iSource, cContainedObjects));
                           hSource.assign(handle.fromString(cSource));
                           silent(() -> 
                           {
                              ghProp.assign(handle.fromString(entry(1, hSource.unwrapADMData().getADMData(), chr(1))));
                              ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
                              cObjectName.assign(ghProp.unwrapBufferField().value());
                           });
                           cMapping.assign(concat(cMapping, (_isEqual(cMapping, "") ? new character("") : new character(",")), valueOf(hTarget), ",", cSource));
                           cDataSourceNames.assign(concat(cDataSourceNames, (_isEqual(cDataSourceNames, "") ? new character("") : new character(",")), (_isUnknown(cObjectName) ? new character("?") : cObjectName)));
                           
                           /* Let's also avoid the need to loop in addRows, colValues etc.*/
                           if ((lUpdate).booleanValue())
                           {
                              cUpdateTargetNames.assign(concat(cUpdateTargetNames, (_isEqual(cUpdateTargetNames, "") ? new character("") : new character(",")), (_isUnknown(cObjectName) ? new character("?") : cObjectName)));
                           }
                           
                           /* No need to search anymore */
                           break containedObjectSearch;
                        }
                     }
                     
                     /* DO iSource = 1 */
                     if (_not(lSourceFound))
                     {
                        /* {fnarg <func-name> <arg> [handle] */ 
                        ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", substitute(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 76), hTarget.unwrapFile().getFileName(), (lSbotarget).booleanValue() ? new character("") : new character(" ONE of")));
                     }
                  }
                  else
                  {
                     IntegerExpression resExpr1 = new IntegerExpression()
                     {
                        public integer execute()
                        {
                           return numEntries(cObjectList);
                        }
                     };
                     ToClause toClause1 = new ToClause(iSource, 1, resExpr1);
                     
                     doTo("loopLabel2", toClause1, new Block((Body) () -> 
                     {
                        silent(() -> 
                        {
                           cObjectName.assign(entry(iSource, cObjectList));
                           hSource /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", cObjectName));
                        });
                        
                        /* Add the two objects to the list with the outside object first */
                        if ((hSource.isValid()).booleanValue())
                        {
                           cMapping.assign(concat(cMapping, (_isNotEqual(cMapping, "") ? new character(",") : new character("")), valueOf(hTarget), ",", valueOf(hSource)));
                           
                           if (_not(lSourceSpecified))
                           {
                              cDataSourceNames.assign(concat(cDataSourceNames, (_isEqual(cDataSourceNames, "") ? new character("") : new character(",")), cObjectName));
                              
                              /* if the Object is a qualifier in enabledFields also 
                                                  the dataSource is also an UpdateTarget */
                              if (_or(begins(cEnabledColumns, concat(cObjectName, ".")), () -> isGreaterThan(indexOf(cEnabledColumns, concat(",", cObjectName, ".")), 0)))
                              {
                                 cUpdateTargetNames.assign(concat(cUpdateTargetNames, (_isEqual(cUpdateTargetNames, "") ? new character("") : new character(",")), cObjectName));
                              }
                           }
                        }
                     }));
                  }
                  
                  /* if cObjectList <> RowObject do iSource = 1 to  */
                  /* Let's avoid the need to loop in getDataHandle and other methods */
                  if (_isGreaterThan(numEntries(cUpdateTargetNames), 1))
                  {
                     IntegerExpression resExpr2 = new IntegerExpression()
                     {
                        public integer execute()
                        {
                           return numEntries(cUpdateTargetNames);
                        }
                     };
                     ToClause toClause2 = new ToClause(iUpdLoop, 1, resExpr2);
                     
                     doTo("loopLabel3", toClause2, new Block((Body) () -> 
                     {
                        cObjectName.assign(entry(iUpdLoop, cUpdateTargetNames));
                        hUpd /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", cObjectName));
                        lOneToOne.assign(or(new logical( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasOneToOneTarget", hUpd)), () -> new logical(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUpdateFromSource", hUpd))));
                        /* {fn <func-name> [handle] */
                        
                        if (_not(lOneToOne))
                        {
                           /* {fnarg <func-name> <arg> [handle] */ 
                           ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", substitute(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 77), targetProcedure().unwrapFile().getFileName(), replaceAll(cUpdateTargetNames, ",", " and ")));
                           /* {set Prop value [handle]} */
                           ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setEnabledFields", hTarget, "I", "");
                           /* {set Prop value [handle]} */
                           ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setUpdateTargetNames", hTarget, "I", "");
                           ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                           ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
                           ghProp.unwrapBufferField().changeValue(new unknown());
                           leave("loopLabel3");
                        }
                     }));
                  }
                  
                  /* num-entries(update targets ) > 1 then loop */
                  if (_not(lSourceSpecified))
                  {
                     ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
                     ghProp.unwrapBufferField().changeValue(cDataSourceNames);
                     /* {set Prop value [handle]} */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setUpdateTargetNames", hTarget, "I", cUpdateTargetNames);
                  }
                  
                  /* if not source specified  */
                  /* In support of browsers with no enabled fields we do 
                               a final check to see if we are the object's updateTarget 
                               and use the DataSourceNames as UpdateTargetNames. 
                               We reread both properties in case Source was specified. */
                  /* {get Prop var [handle]} */
                  cUpdateTargetNames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdateTargetNames", hTarget));
                  
                  if (_isEqual(cUpdateTargetNames, ""))
                  {
                     ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTarget"));
                     hUpdateTarget.assign(ghProp.unwrapBufferField().value());
                     ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
                     cDataSourceNames.assign(ghProp.unwrapBufferField().value());
                     
                     if (_and(isEqual(hUpdateTarget, targetProcedure()), () -> isEqual(numEntries(cDataSourceNames), 1)))
                     {
                        /* {set Prop value [handle]} */
                        ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setUpdateTargetNames", hTarget, "I", cDataSourceNames);
                     }
                  }
               }
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
               ghProp.unwrapBufferField().changeValue(cMapping);
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Update the ObjectMapping property that are used to broker messages<br>
    *           between contained objects and objects linked to the SBO.       <br>
    * Parameters: phSource - the handle of the Source<br>
    * Notes:    Called from registerObject, which are subscribed as <br>
    *           NavigationSourceEvent and published from the NavigationSource's <br>
    *           initializeObject.
    */
   public void addNavigationSource(final handle _phSource)
   {
      handle phSource = TypeFactory.initInput(_phSource);
      handle hSource = TypeFactory.handle();
      character cSource = TypeFactory.character();
      character cMapping = TypeFactory.character();
      handle hMaster = TypeFactory.handle();
      character cObjectName = TypeFactory.character();
      handle hTarget = TypeFactory.handle();
      character cPosition = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
         hMaster.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         hSource.assign(phSource);
         cSource.assign(valueOf(hSource));
         
         if (_isEqual(lookup(cSource, cMapping), 0))
         {
            /* {get Prop var [handle]} */
            silent(() -> cObjectName.assign(ControlFlowOps.invokeDynamicFunctionIn("getNavigationTargetName", hSource)));
            
            if (_and(notUnknown(cObjectName), () -> isNotEqual(cObjectName, "")))
            {
               silent(() -> hTarget /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", cObjectName)));
            }
            else
            {
               hTarget.assign(hMaster);
            }
            
            /* Use MasterDataObject as a default. */
            if ((hTarget.isValid()).booleanValue())
            {
               /* Send the current queryPosition to the NavigationSource */
               /* {get Prop var [handle]} */ 
               cPosition.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryPosition", targetProcedure()));
               /*
                      ghTargetProcedure = TARGET-PROCEDURE.
                      RUN queryPosition IN hSource (cPosition).
                      ghTargetProcedure = ?. 
                      */
               /* Add the two objects to the list with the outside object first */
               cMapping.assign(concat(cMapping, (_isNotEqual(cMapping, "") ? new character(",") : new character("")), valueOf(hSource), ",", valueOf(hTarget)));
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
               ghProp.unwrapBufferField().changeValue(cMapping);
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Receives the assignMaxGuess event from a contained SDO and <br>
    *              passes it on to the appropriate DATA-TARGET<br>
    * Parameters:  piMaxGuess AS INTEGER<br>
    * Notes:
    */
   public void assignMaxGuess(final integer _piMaxGuess)
   {
      integer piMaxGuess = TypeFactory.initInput(_piMaxGuess);
      character cMapping = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      integer iObject = TypeFactory.integer();
      character cHandle = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         cHandle.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", valueOf(sourceProcedure()), cMapping, false, ","));
         
         IntegerExpression resExpr3 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cHandle);
            }
         };
         ToClause toClause3 = new ToClause(iObject, 1, resExpr3);
         
         doTo("loopLabel4", toClause3, new Block((Body) () -> 
         {
            hObject.assign(handle.fromString(entry(iObject, cHandle)));
            silent(() -> ControlFlowOps.invokeInWithMode("assignMaxGuess", hObject, "I", piMaxGuess));
         }));
         
         /* END DO iObject */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     database-side part of CommitTransaction to save all RowObjUpd <br>
    *              table updates and store them thru the server-side SDOs.<br>
    * Parameters:  OUTPUT pcMessages AS CHARACTER  error messages<br>
    *              OUTPUT pcUndoIds  AS CHARACTER  rowids of error'd rows <br>
    *      Notes:  Intended for internal use by other APIs that manages the buffers<br>
    *              for example received as table parameters like <br>
    *              serverCommitTransaction, remoteCommitTransaction
    */
   public void bufferCommitTransaction(final character pcMessages, final character pcUndoIds)
   {
      character cContained = TypeFactory.character();
      integer iDo = TypeFactory.integer();
      handle hDo = TypeFactory.handle();
      handle hTable = TypeFactory.handle();
      character cOrdering = TypeFactory.character();
      integer iEntry = TypeFactory.integer();
      character cAsdivision = TypeFactory.character();
      /* These vars are for foreign field assignment. */
      handle hBuf = TypeFactory.handle();
      handle hQry = TypeFactory.handle();
      handle hSaveDo = TypeFactory.handle();
      handle hSaveTable = TypeFactory.handle();
      handle hSource = TypeFactory.handle();
      character cForeignFields = TypeFactory.character();
      character cForeignValues = TypeFactory.character();
      handle hSaveBuf = TypeFactory.handle();
      handle hSaveQry = TypeFactory.handle();
      handle hSaveCol = TypeFactory.handle();
      integer iCol = TypeFactory.integer();
      handle hCol = TypeFactory.handle();
      handle hRowMod = TypeFactory.handle();
      character cFld = TypeFactory.character();
      character cUndoIds = TypeFactory.character();
      character cUpdateTables = TypeFactory.character();
      logical lDynamicData = TypeFactory.logical();
      handle hLogicObject = TypeFactory.handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcMessages);
         TypeFactory.initOutput(pcUndoIds);
      }, 
      (Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cContained.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataObjectOrdering"));
         cOrdering.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTables"));
         cUpdateTables.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DynamicData"));
         lDynamicData.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLogicObject"));
         hLogicObject.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(cOrdering, ""))
         {
            /* We need to do this here to account for any dynamic SDOs that were just 
                   started up. Any static SDOs are alreday processed */
            cOrdering /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "initDataObjectOrdering", targetProcedure()));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataObjectOrdering"));
            ghProp.unwrapBufferField().changeValue(cOrdering);
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTables"));
            cUpdateTables.assign(ghProp.unwrapBufferField().value());
         }
         
         /* First do any validation the SBO needs to do at the very outset. */
         ControlFlowOps.invokeInWithMode("bufferValidate", targetProcedure(), "I", new character("pre"));
         
         if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
         {
            ControlFlowOps.invokeInWithMode("prepareErrorsForReturn", targetProcedure(), "IIU", ControlFlowOps.getReturnValue(), cAsdivision, pcMessages);
            returnNormal();
         }
         
         IntegerExpression resExpr4 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cContained);
            }
         };
         ToClause toClause4 = new ToClause(iDo, 1, resExpr4);
         
         doTo("loopLabel5", toClause4, new Block((Body) () -> 
         {
            hDo.assign(handle.fromString(entry(iDo, cContained)));
            iEntry.assign(lookup(valueOf(iDo), cOrdering));
            hTable.setUnknown();
            silent(() -> hTable.assign(handle.fromString(entry(iEntry, cUpdateTables))));
            
            /* rowObjUpd may just have been created  */
            if (_not(hTable.isValid()))
            {
               /* {get Prop var [handle]} */
               hTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjUpdTable", hDo));
               
               if ((hTable.isValid()).booleanValue())
               {
                  cUpdateTables.replaceEntry(iEntry, valueOf(hTable));
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTables"));
                  ghProp.unwrapBufferField().changeValue(cUpdateTables);
               }
            }
            
            if (_and(hTable.isValid(), () -> hTable.unwrapTempTable().hasRecords()))
            {
               if ((lDynamicData).booleanValue())
               {
 /* dynamic object, we're sharing tables */
                  ControlFlowOps.invokeInWithMode("bufferValidate", hDo, "I", new character("Pre"));
               }
               else
               {
                  ControlFlowOps.invokeInWithMode("pushTableAndValidate", hDo, "IU", new character("Pre"), new TableParameter(hTable));
               }
            }
            
            if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
            {
               ControlFlowOps.invokeInWithMode("prepareErrorsForReturn", targetProcedure(), "IIU", ControlFlowOps.getReturnValue(), cAsdivision, pcMessages);
               returnNormal();
            }
         }));
         
         OnPhrase[] onPhrase0 = new OnPhrase[]
         {
            new OnPhrase(Condition.ERROR, Action.LEAVE, "blockLabel0")
         };
         
         doBlock(TransactionType.FULL, "blockLabel0", onPhrase0, new Block((Body) () -> 
         {
            /* First run any SBO specific logic for the transaction start. */
            ControlFlowOps.invokeInWithMode("bufferValidate", targetProcedure(), "I", new character("begin"));
            
            if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
            {
               ControlFlowOps.invokeInWithMode("prepareErrorsForReturn", targetProcedure(), "IIU", ControlFlowOps.getReturnValue(), cAsdivision, pcMessages);
               undoReturnNormal("blockLabel0");
            }
            
            IntegerExpression resExpr5 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cContained);
               }
            };
            ToClause toClause5 = new ToClause(iDo, 1, resExpr5);
            
            doTo("loopLabel6", toClause5, new Block((Body) () -> 
            {
               hDo.assign(handle.fromString(entry(iDo, cContained)));
               iEntry.assign(lookup(valueOf(iDo), cOrdering));
               hTable.setUnknown();
               silent(() -> hTable.assign(handle.fromString(entry(iEntry, cUpdateTables))));
               
               if (_and(hTable.isValid(), () -> hTable.unwrapTempTable().hasRecords()))
               {
                  /* In this section we look to see if a parent and one or more child
                               rows are being Added at the same time. If so, we copy ForeignField
                               key values from the parent rec to all newly added child recs,
                               *after* running serverCommit in the parent (so that the key values
                               will have been assigned for it), and *before* running it for
                               the child SDO. */
                  if ((hSaveDo.isValid()).booleanValue())
                  {
                     /* We have saved off keys from the previous table. See if that's
                                  a Data-Source for the current table. */
                     /* {get Prop var [handle]} */
                     hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hDo));
                     
                     if (_isEqual(hSource, hSaveDo))
                     {
                        ghProp.assign(handle.fromString(entry(1, hDo.unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignFields"));
                        cForeignFields.assign(ghProp.unwrapBufferField().value());
                        
                        if (_isNotEqual(cForeignFields, ""))
                        {
                           hSaveBuf.assign(hSaveTable.unwrapTempTable().defaultBufferHandle());
                           QueryWrapper.createQuery(hSaveQry);
                           hSaveQry.unwrapQuery().setBuffers(hSaveBuf);
                           hSaveQry.unwrapQuery().prepare(concat("For each ", hSaveTable.unwrap().name(), " WHERE ", hSaveTable.unwrap().name(), ".RowMod = \"A\""));
                           hSaveQry.unwrapQuery().queryOpen();
                           hSaveQry.unwrapQuery().getFirst();
                           hBuf.assign(hTable.unwrapTempTable().defaultBufferHandle());
                           hRowMod.assign(hBuf.unwrapBuffer().bufferField("RowMod"));
                           QueryWrapper.createQuery(hQry);
                           hQry.unwrapQuery().setBuffers(hBuf);
                           hQry.unwrapQuery().prepare(concat("For each ", hTable.unwrap().name(), " WHERE ", hTable.unwrap().name(), ".RowMod = \"A\""));
                           hQry.unwrapQuery().queryOpen();
                           hQry.unwrapQuery().getFirst();
                           
                           loopLabel7:
                           while ((hBuf.unwrapBuffer().available()).booleanValue())
                           {
                              cForeignValues.assign("");
                              
                              loopLabel8:
                              for (iCol.assign(1); _isLessThanOrEqual(iCol, numEntries(cForeignFields)); iCol.assign(plus(iCol, 2)))
                              {
                                  /* This is the parent */hSaveCol.assign(hSaveBuf.unwrapBuffer().bufferField(entry(plus(iCol, 1), cForeignFields)));
                                 /* remove the ObjectName qualifier from the
                                                               field name for the child SDO. */
                                 cFld.assign(entry(iCol, cForeignFields));
                                 /* This is the child */
                                 hCol.assign(hBuf.unwrapBuffer().bufferField(entry(numEntries(cFld, "."), cFld, ".")));
                                 hCol.unwrapBufferField().changeValue(hSaveCol.unwrapBufferField().value());
                                 cForeignValues.assign(concat(cForeignValues, (_isEqual(iCol, 1) ? new character("") : chr(1)), _isUnknown(hSaveCol.unwrapBufferField().value()) ? new character("?") : hSaveCol.unwrapBufferField().value()));
                              }
                              
                              ghProp.assign(handle.fromString(entry(1, hDo.unwrapADMData().getADMData(), chr(1))));
                              ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
                              ghProp.unwrapBufferField().changeValue(cForeignValues);
                              hQry.unwrapQuery().getNext();
                           }
                           
                           /* END DO WHILE AVAIL == for each child. */
                           hQry.unwrapQuery().queryClose();
                           hSaveQry.unwrapQuery().queryClose();
                           HandleOps.delete(hQry);
                           HandleOps.delete(hSaveQry);
                        }
                     }
                  }
                  
                  /* END DO IF ValidHandle SaveDO */
                  /* no need to copy the table if DynSBO */
                  if ((lDynamicData).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("bufferCommit", hDo, "OO", pcMessages, cUndoIds);
                  }
                  else
                  {
                     ControlFlowOps.invokeInWithMode("serverCommit", hDo, "UOO", new TableParameter(hTable), pcMessages, cUndoIds);
                  }
                  
                  if (_isNotEqual(cUndoIds, ""))
                  {
                     /* Make the UndoIds into a semicolon separated list, in order to 
                                    identify which of the SDOs the UndoIds (RowNumCHR(3)text) belongs
                                    to. The intention is not to create another completely confusing 
                                    internal format, the semicolon separator is almost an SBO 
                                    standard used to identify SDO also in other parameters... OK? */
                     if (_isEqual(pcUndoIds, ""))
                     {
                        pcUndoIds.assign(fill(";", minus(numEntries(cContained), 1)));
                     }
                     
                     pcUndoIds.replaceEntry(iDo, ";", cUndoIds);
                  }
                  
                  /* if we're on the Server-side of a divided SBO, serverCommit for
                               the SDO will have put any error messages into pcMessages.
                               Otherwise it will simply have logged them with addMessage. */
                  if (_or(and(isEqual(cAsdivision, "Server"), () -> isNotEqual(pcMessages, "")), () -> new logical(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))))
                  {
                     undoReturnNormal("blockLabel0");
                  }
                  
                  /* Now that we're back from the commit, check to see if it
                               was an Add. If so, save the DO and Table handles to use to
                               create keys for the next table if appropriate. */
                  hBuf.assign(hTable.unwrapTempTable().defaultBufferHandle());
                  QueryWrapper.createQuery(hQry);
                  hQry.unwrapQuery().setBuffers(hBuf);
                  hQry.unwrapQuery().prepare(concat("For each ", hTable.unwrap().name(), " WHERE ", hTable.unwrap().name(), ".RowMod = \"A\""));
                  hQry.unwrapQuery().queryOpen();
                  hQry.unwrapQuery().getFirst();
                  hSaveDo.setUnknown();
                  hSaveTable.setUnknown();
                  
                  if ((hBuf.unwrapBuffer().available()).booleanValue())
                  {
                     hCol.assign(hBuf.unwrapBuffer().bufferField("RowMod"));
                     hQry.unwrapQuery().getNext();
                     
                     /* Only if one 'A' add record  */
                     if ((hQry.unwrapQuery().isOffEnd()).booleanValue())
                     {
                        hSaveDo.assign(hDo);
                        hSaveTable.assign(hTable);
                     }
                  }
                  hQry.unwrapQuery().queryClose();
                  HandleOps.delete(hQry);
               }
            }));
            
            /* END DO iDO -- serverCommit for each SDO */
            /* Finally do any validation the SBO needs to do at the very end
                     of the transaction. */
            ControlFlowOps.invokeInWithMode("bufferValidate", targetProcedure(), "I", new character("end"));
            
            if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
            {
               ControlFlowOps.invokeInWithMode("prepareErrorsForReturn", targetProcedure(), "IIU", ControlFlowOps.getReturnValue(), cAsdivision, pcMessages);
               undoReturnNormal("blockLabel0");
            }
         }));
         
         IntegerExpression resExpr6 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cContained);
            }
         };
         ToClause toClause6 = new ToClause(iDo, 1, resExpr6);
         
         doTo("loopLabel9", toClause6, new Block((Body) () -> 
         {
            hDo.assign(handle.fromString(entry(iDo, cContained)));
            iEntry.assign(lookup(valueOf(iDo), cOrdering));
            hTable.setUnknown();
            silent(() -> hTable.assign(handle.fromString(entry(iEntry, cUpdateTables))));
            
            if (_and(hTable.isValid(), () -> hTable.unwrapTempTable().hasRecords()))
            {
               if ((lDynamicData).booleanValue())
               {
 /* we're sharing tables */
                  ControlFlowOps.invokeInWithMode("bufferValidate", hDo, "I", new character("Post"));
               }
               else
               {
                  ControlFlowOps.invokeInWithMode("pushTableAndValidate", hDo, "IU", new character("Post"), new TableParameter(hTable));
               }
            }
            
            if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
            {
               ControlFlowOps.invokeInWithMode("prepareErrorsForReturn", targetProcedure(), "IIU", ControlFlowOps.getReturnValue(), cAsdivision, pcMessages);
               returnNormal();
            }
         }));
         
         /* END DO iDO -- for each contained SDO */
         /* Finally do any validation the SBO needs to do at the very end. */
         ControlFlowOps.invokeInWithMode("bufferValidate", targetProcedure(), "I", new character("post"));
         
         if (_isNotEqual(ControlFlowOps.getReturnValue(), ""))
         {
            ControlFlowOps.invokeInWithMode("prepareErrorsForReturn", targetProcedure(), "IIU", ControlFlowOps.getReturnValue(), cAsdivision, pcMessages);
            returnNormal();
         }
         
         /* END DO IF error return */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     server-side procedure to prepare and open a query on all<br>
    *              the SDOs (rowObject buffers). <br>
    *              Overrides container because it can use assignQueries<br>
    * Parameters:  pcQueries AS CHARACTER  CHR(1)-delimited-list of <br>
    *                 QueryString properties of the SDOs;<br>
    *              pcPositions AS CHARACTER  reserved for future use to<br>
    *                 provide information on positioning each of the queries perhaps<br>
    *   Notes:  This is the internal buffer logic used on the server side of <br>
    *           fetchContainedData and is called thru one of several <br>
    *          fetchContainedData APIs that has output parameters for the table <br>
    *           handles.<br>
    *       -   (it may actually also be called on the client, since openQuery<br>
    *           will call fetchContainedData on client, but this is not tested... )
    */
   public void bufferFetchContainedData(final character _pcQueries, final character _pcPositions)
   {
      character pcQueries = TypeFactory.initInput(_pcQueries);
      character pcPositions = TypeFactory.initInput(_pcPositions);
      handle hFirstSdo = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         hFirstSdo /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "assignQueries", targetProcedure(), "I", pcQueries));
         /* {fn <func-name> [handle] */
         ControlFlowOps.invokeDynamicFunctionIn(logical.class, "openQuery", hFirstSdo);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     SBO implementation of 'bufferValidate'<br>
    * Parameters:  INPUT pcValType AS CHARACTER  "Pre", "Begin", "End", "Post"<br>
    * Notes:
    */
   public void bufferValidate(final character _pcValType)
   {
      character pcValType = TypeFactory.initInput(_pcValType);
      logical lLogicHook = TypeFactory.logical();
      logical lLocalHook = TypeFactory.logical();
      character cHook = TypeFactory.character();
      handle hLogicObject = TypeFactory.handle();
      character cReturn = TypeFactory.character();
      character cUpdateTables = TypeFactory.character();
      integer iCount = TypeFactory.integer();
      handle hTable = TypeFactory.handle();
      handle hTable1 = TypeFactory.handle();
      handle hTable2 = TypeFactory.handle();
      handle hTable3 = TypeFactory.handle();
      handle hTable4 = TypeFactory.handle();
      handle hTable5 = TypeFactory.handle();
      handle hTable6 = TypeFactory.handle();
      handle hTable7 = TypeFactory.handle();
      handle hTable8 = TypeFactory.handle();
      handle hTable9 = TypeFactory.handle();
      handle hTable10 = TypeFactory.handle();
      handle hTable11 = TypeFactory.handle();
      handle hTable12 = TypeFactory.handle();
      handle hTable13 = TypeFactory.handle();
      handle hTable14 = TypeFactory.handle();
      handle hTable15 = TypeFactory.handle();
      handle hTable16 = TypeFactory.handle();
      handle hTable17 = TypeFactory.handle();
      handle hTable18 = TypeFactory.handle();
      handle hTable19 = TypeFactory.handle();
      handle hTable20 = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLogicObject"));
         hLogicObject.assign(ghProp.unwrapBufferField().value());
         cHook.assign(concat(pcValType, "TransactionValidate"));
         lLocalHook.assign(isGreaterThan(lookup(cHook, targetProcedure().unwrapProcedure().internalEntries()), 0));
         lLogicHook.assign(and(hLogicObject.isValid(), () -> isGreaterThan(lookup(cHook, hLogicObject.unwrapProcedure().internalEntries()), 0)));
         
         /* We need to identify where the hook is because if the hook is ONLY in 
               the Logical Object then the TT need to be transfered back and forth.
               If the hook is local then we cannot transfer here asa th elocal then would
               change a different TT. It there for some reason should be hooks both
               locally and in the logic procedure the local hook would be a complete 
               overrride or it would need to do the transfer itself  */
         if (_and(not(lLocalHook), lLogicHook))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTables"));
            cUpdateTables.assign(ghProp.unwrapBufferField().value());
            
            loopLabel10:
            for (iCount.assign(1); _isLessThanOrEqual(iCount, numEntries(cUpdateTables)); iCount.increment())
            {
               hTable.setUnknown();
               silent(() -> hTable.assign(handle.fromString(entry(iCount, cUpdateTables))));
               
               if ((hTable.isValid()).booleanValue())
               {
                  switch (StringHelper.safeTrimTrailing((iCount).toStringMessage()))
                  {
                     case "1":
                        {
                           hTable1.assign(hTable);
                        }
                        break;
                     case "2":
                        {
                           hTable2.assign(hTable);
                        }
                        break;
                     case "3":
                        {
                           hTable3.assign(hTable);
                        }
                        break;
                     case "4":
                        {
                           hTable4.assign(hTable);
                        }
                        break;
                     case "5":
                        {
                           hTable5.assign(hTable);
                        }
                        break;
                     case "6":
                        {
                           hTable6.assign(hTable);
                        }
                        break;
                     case "7":
                        {
                           hTable7.assign(hTable);
                        }
                        break;
                     case "8":
                        {
                           hTable8.assign(hTable);
                        }
                        break;
                     case "9":
                        {
                           hTable9.assign(hTable);
                        }
                        break;
                     case "10":
                        {
                           hTable10.assign(hTable);
                        }
                        break;
                     case "11":
                        {
                           hTable11.assign(hTable);
                        }
                        break;
                     case "12":
                        {
                           hTable12.assign(hTable);
                        }
                        break;
                     case "13":
                        {
                           hTable13.assign(hTable);
                        }
                        break;
                     case "14":
                        {
                           hTable14.assign(hTable);
                        }
                        break;
                     case "15":
                        {
                           hTable15.assign(hTable);
                        }
                        break;
                     case "16":
                        {
                           hTable16.assign(hTable);
                        }
                        break;
                     case "17":
                        {
                           hTable17.assign(hTable);
                        }
                        break;
                     case "18":
                        {
                           hTable18.assign(hTable);
                        }
                        break;
                     case "19":
                        {
                           hTable19.assign(hTable);
                        }
                        break;
                     case "20":
                        {
                           hTable20.assign(hTable);
                        }
                        break;
                  }
               }
            }
            
            ControlFlowOps.invokeInWithMode("setLogicRows", targetProcedure(), "IIIIIIIIIIIIIIIIIIII", new TableParameter(hTable1), new TableParameter(hTable2), new TableParameter(hTable3), new TableParameter(hTable4), new TableParameter(hTable5), new TableParameter(hTable6), new TableParameter(hTable7), new TableParameter(hTable8), new TableParameter(hTable9), new TableParameter(hTable10), new TableParameter(hTable11), new TableParameter(hTable12), new TableParameter(hTable13), new TableParameter(hTable14), new TableParameter(hTable15), new TableParameter(hTable16), new TableParameter(hTable17), new TableParameter(hTable18), new TableParameter(hTable19), new TableParameter(hTable20));
         }
         silent(() -> ControlFlowOps.invokeIn((cHook).toStringMessage(), targetProcedure()));
         cReturn.assign(ControlFlowOps.getReturnValue());
         
         /* if the hook was in a DL procedure, we need to get the tables back */
         if (_and(not(lLocalHook), lLogicHook))
         {
            ControlFlowOps.invokeInWithMode("getLogicRows", targetProcedure(), "OOOOOOOOOOOOOOOOOOOO", new TableParameter(hTable1), new TableParameter(hTable2), new TableParameter(hTable3), new TableParameter(hTable4), new TableParameter(hTable5), new TableParameter(hTable6), new TableParameter(hTable7), new TableParameter(hTable8), new TableParameter(hTable9), new TableParameter(hTable10), new TableParameter(hTable11), new TableParameter(hTable12), new TableParameter(hTable13), new TableParameter(hTable14), new TableParameter(hTable15), new TableParameter(hTable16), new TableParameter(hTable17), new TableParameter(hTable18), new TableParameter(hTable19), new TableParameter(hTable20));
         }
         
         returnNormal(cReturn);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Receives the cancelNew event from a contained SDO and <br>
    *              passes it on to the appropriate DATA-TARGET<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void cancelNew()
   {
      character cMapping = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      integer iObject = TypeFactory.integer();
      character cHandle = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         cHandle.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", valueOf(sourceProcedure()), cMapping, false, ","));
         
         IntegerExpression resExpr7 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cHandle);
            }
         };
         ToClause toClause7 = new ToClause(iObject, 1, resExpr7);
         
         doTo("loopLabel11", toClause7, new Block((Body) () -> 
         {
            hObject.assign(handle.fromString(entry(iObject, cHandle)));
            silent(() -> ControlFlowOps.invokeIn("cancelNew", hObject));
         }));
         
         /* END DO iObject */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void commitData(final character pcError)
   {
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcError);
      }, 
      (Body) () -> 
      {
         ControlFlowOps.invokeIn("commitTransaction", targetProcedure());
         
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
         {
            pcError /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()));
            /* clean-up temp tables to be ready for next request */
            ControlFlowOps.invokeIn("undoTransaction", targetProcedure());
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     client-side event procedure to receive the Commit event,<br>
    *              gather up the updates from contained SDOs, and pass then<br>
    *              on to the server.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:      Repositioning with error: <br>
    *              We roll back the last SDO first. As soon as we find an SDO with <br>
    *              uncommitted changes after rollback, we change Undoids for all its <br>
    *              dataSources (rowNum of '?'). This will in turn be passed to <br>
    *              doReturnUpd, which will use this as a signal that it has<br>
    *              to keep the current position and disregard the undoIds which it <br>
    *              normally would reposition to. We know the parents current <br>
    *              position is ok because you cannot navigate parents that has <br>
    *              changes in children.  <br>
    *          -   We always publish dataavailable 'RESET', because this always<br>
    *              resets panels, visual targets and ForeignValues and is changed<br>
    *              to 'different' if hasForeignKeyChanged, except if any uncommitted <br>
    *              changes are found.
    */
   public void commitTransaction()
   {
      handle hAsHandle = TypeFactory.handle();
      handle hAppService = TypeFactory.handle();
      character cAsdivision = TypeFactory.character();
      character cServerFileName = TypeFactory.character();
      character cContext = TypeFactory.character();
      character cContained = TypeFactory.character();
      integer iDo = TypeFactory.integer();
      handle hDo = TypeFactory.handle();
      handle hTable = TypeFactory.handle();
      handle hTable1 = TypeFactory.handle();
      handle hTable2 = TypeFactory.handle();
      handle hTable3 = TypeFactory.handle();
      handle hTable4 = TypeFactory.handle();
      handle hTable5 = TypeFactory.handle();
      handle hTable6 = TypeFactory.handle();
      handle hTable7 = TypeFactory.handle();
      handle hTable8 = TypeFactory.handle();
      handle hTable9 = TypeFactory.handle();
      handle hTable10 = TypeFactory.handle();
      handle hTable11 = TypeFactory.handle();
      handle hTable12 = TypeFactory.handle();
      handle hTable13 = TypeFactory.handle();
      handle hTable14 = TypeFactory.handle();
      handle hTable15 = TypeFactory.handle();
      handle hTable16 = TypeFactory.handle();
      handle hTable17 = TypeFactory.handle();
      handle hTable18 = TypeFactory.handle();
      handle hTable19 = TypeFactory.handle();
      handle hTable20 = TypeFactory.handle();
      character cMessages = TypeFactory.character();
      character cUndoIds = TypeFactory.character();
      character cOrdering = TypeFactory.character();
      character cHasrecords = TypeFactory.character("");
      character cHasNewRecords = TypeFactory.character("");
      character cHandle = TypeFactory.character();
      handle hSource = TypeFactory.handle();
      logical lAutoCommit = TypeFactory.logical();
      logical lCommitOk = TypeFactory.logical();
      logical lCancel = TypeFactory.logical();
      logical lError = TypeFactory.logical();
      handle hTopDo = TypeFactory.handle();
      logical lHasNewRow = TypeFactory.logical();
      integer iSource = TypeFactory.integer();
      logical lRowUpdated = TypeFactory.logical();
      character cRowObjectState = TypeFactory.character();
      handle hRowObject = TypeFactory.handle();
      rowid[] rRowid = TypeFactory.rowidExtent(20);
      character cErrorKeys = TypeFactory.character();
      character cErrorType = TypeFactory.character();
      character cErrorTypeList = TypeFactory.character();
      character cErrorKeyList = TypeFactory.character();
      /* process the erro here */
      character cDummy = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("AutoCommit"));
         lAutoCommit.assign(ghProp.unwrapBufferField().value());
         
         if (_not(lAutoCommit))
         {
            /* Visual dataTargets subscribes to this */
            NamedEventManager.publish("confirmCommit", targetProcedure(), "U", new Object[]
            {
               lCancel
            });
            
            if ((lCancel).booleanValue())
            {
               returnNormal();
            }
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cContained.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataObjectOrdering"));
         cOrdering.assign(ghProp.unwrapBufferField().value());
         
         if (_isEqual(cOrdering, ""))
         {
            /* We need to do this here to account for any dynamic SDOs that were just 
                   started up. Any static SDOs are alreday processed */
            cOrdering /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "initDataObjectOrdering", targetProcedure()));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataObjectOrdering"));
            ghProp.unwrapBufferField().changeValue(cOrdering);
         }
         
         IntegerExpression resExpr8 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cOrdering);
            }
         };
         ToClause toClause8 = new ToClause(iDo, 1, resExpr8);
         
         doTo("loopLabel12", toClause8, new Block((Body) () -> 
         {
            hDo.assign(handle.fromString(entry(new integer(entry(iDo, cOrdering)), cContained)));
            /* {get Prop var [handle]} */
            hTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjUpdTable", hDo));
            /* {get Prop var [handle]} */
            hRowObject.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObject", hDo));
            
            /* Skip SDOs that have no updates, and keep track of them for use
                     after the server transaction. */
            if (_and(hTable.isValid(), () -> hTable.unwrapTempTable().hasRecords()))
            {
               cHasrecords.assign(concat(cHasrecords, (_isEqual(cHasrecords, "") ? new character("") : new character(",")), entry(iDo, cOrdering)));
               /* keep track of NEW records in the SDOs so that we can reposition */
               /* the DataQuery - if necessary */
               /* {get Prop var [handle]} */
               lHasNewRow.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getHasNewRow", hDo));
               
               if ((lHasNewRow).booleanValue())
               {
                  cHasNewRecords.assign(concat(cHasNewRecords, (_isEqual(cHasNewRecords, "") ? new character("") : new character(",")), entry(iDo, cOrdering)));
               }
               
               assignSingle(rRowid, iDo, hRowObject.unwrapBuffer().rowID());
               ControlFlowOps.invokeIn("doBuildUpd", hDo);
            }
            
            /* END DO IF HAS-RECORDS */
            switch (StringHelper.safeTrimTrailing((iDo).toStringMessage()))
            {
               case "1":
                  {
                     hTable1.assign(hTable);
                  }
                  break;
               case "2":
                  {
                     hTable2.assign(hTable);
                  }
                  break;
               case "3":
                  {
                     hTable3.assign(hTable);
                  }
                  break;
               case "4":
                  {
                     hTable4.assign(hTable);
                  }
                  break;
               case "5":
                  {
                     hTable5.assign(hTable);
                  }
                  break;
               case "6":
                  {
                     hTable6.assign(hTable);
                  }
                  break;
               case "7":
                  {
                     hTable7.assign(hTable);
                  }
                  break;
               case "8":
                  {
                     hTable8.assign(hTable);
                  }
                  break;
               case "9":
                  {
                     hTable9.assign(hTable);
                  }
                  break;
               case "10":
                  {
                     hTable10.assign(hTable);
                  }
                  break;
               case "11":
                  {
                     hTable11.assign(hTable);
                  }
                  break;
               case "12":
                  {
                     hTable12.assign(hTable);
                  }
                  break;
               case "13":
                  {
                     hTable13.assign(hTable);
                  }
                  break;
               case "14":
                  {
                     hTable14.assign(hTable);
                  }
                  break;
               case "15":
                  {
                     hTable15.assign(hTable);
                  }
                  break;
               case "16":
                  {
                     hTable16.assign(hTable);
                  }
                  break;
               case "17":
                  {
                     hTable17.assign(hTable);
                  }
                  break;
               case "18":
                  {
                     hTable18.assign(hTable);
                  }
                  break;
               case "19":
                  {
                     hTable19.assign(hTable);
                  }
                  break;
               case "20":
                  {
                     hTable20.assign(hTable);
                  }
                  break;
            }
         }));
         
         /* END DO iDO */
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         
         if (_isEqual(cAsdivision, "Client"))
         {
            /* Checks AppServer properties to see if the object has no current or future 
                   server bindings and is using a stateless operating mode.*/
            if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasNoServerBinding", targetProcedure()))).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("connectServer", targetProcedure(), "O", hAppService);
               
               if (_isUnknown(hAppService))
               {
                  returnNormal("ADM-ERROR");
               }
            }
            else
            {
               /* {get Prop var [handle]} */ 
               hAsHandle.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getASHandle", targetProcedure()));
            }
            cContext /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForServer", targetProcedure()));
         }
         
         if ((hAppService.isValid()).booleanValue())
         {
            /* {get Prop var [handle]} */ 
            cServerFileName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getServerFileName", targetProcedure()));
            ControlFlowOps.invokeRemoteWithMode("adm2/committransaction", (handle) null, hAppService, false, "IUUUUUUUUUUUUUUUUUUUUUOO", cServerFileName, cContext, new TableParameter(hTable1), new TableParameter(hTable2), new TableParameter(hTable3), new TableParameter(hTable4), new TableParameter(hTable5), new TableParameter(hTable6), new TableParameter(hTable7), new TableParameter(hTable8), new TableParameter(hTable9), new TableParameter(hTable10), new TableParameter(hTable11), new TableParameter(hTable12), new TableParameter(hTable13), new TableParameter(hTable14), new TableParameter(hTable15), new TableParameter(hTable16), new TableParameter(hTable17), new TableParameter(hTable18), new TableParameter(hTable19), new TableParameter(hTable20), cMessages, cUndoIds);
            /* {fnarg <func-name> <arg> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "applyContextFromServer", targetProcedure(), "I", cContext);
         }
         else
         {
            if ((hAsHandle.isValid()).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("remoteCommitTransaction", hAsHandle, "UUUUUUUUUUUUUUUUUUUUUOO", cContext, new TableParameter(hTable1), new TableParameter(hTable2), new TableParameter(hTable3), new TableParameter(hTable4), new TableParameter(hTable5), new TableParameter(hTable6), new TableParameter(hTable7), new TableParameter(hTable8), new TableParameter(hTable9), new TableParameter(hTable10), new TableParameter(hTable11), new TableParameter(hTable12), new TableParameter(hTable13), new TableParameter(hTable14), new TableParameter(hTable15), new TableParameter(hTable16), new TableParameter(hTable17), new TableParameter(hTable18), new TableParameter(hTable19), new TableParameter(hTable20), cMessages, cUndoIds);
               /* {fnarg <func-name> <arg> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "applyContextFromServer", targetProcedure(), "I", cContext);
               ControlFlowOps.invokeIn("endClientDataRequest", targetProcedure());
            }
            else
            {
               if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getDynamicData", targetProcedure()))).booleanValue())
               {
                  /* A dynamic SBO simply points to the SDO tables */
                  /* since custom logic is in the DataLogic Procedure */
                  ControlFlowOps.invokeInWithMode("bufferCommitTransaction", targetProcedure(), "OO", cMessages, cUndoIds);
               }
               else
               {
                  /* ..but a static SBO must transfer the SDO tables since */
                  /* it maintains a static copy for support of custom hooks */
                  ControlFlowOps.invokeInWithMode("serverCommitTransaction", targetProcedure(), "UUUUUUUUUUUUUUUUUUUUOO", new TableParameter(hTable1), new TableParameter(hTable2), new TableParameter(hTable3), new TableParameter(hTable4), new TableParameter(hTable5), new TableParameter(hTable6), new TableParameter(hTable7), new TableParameter(hTable8), new TableParameter(hTable9), new TableParameter(hTable10), new TableParameter(hTable11), new TableParameter(hTable12), new TableParameter(hTable13), new TableParameter(hTable14), new TableParameter(hTable15), new TableParameter(hTable16), new TableParameter(hTable17), new TableParameter(hTable18), new TableParameter(hTable19), new TableParameter(hTable20), cMessages, cUndoIds);
                  
                  IntegerExpression resExpr9 = new IntegerExpression()
                  {
                     public integer execute()
                     {
                        return numEntries(cOrdering);
                     }
                  };
                  ToClause toClause9 = new ToClause(iDo, 1, resExpr9);
                  
                  doTo("loopLabel13", toClause9, new Block((Body) () -> 
                  {
                     hDo.assign(handle.fromString(entry(new integer(entry(iDo, cOrdering)), cContained)));
                     
                     switch (StringHelper.safeTrimTrailing((iDo).toStringMessage()))
                     {
                        case "1":
                           {
                              hTable.assign(hTable1);
                           }
                           break;
                        case "2":
                           {
                              hTable.assign(hTable2);
                           }
                           break;
                        case "3":
                           {
                              hTable.assign(hTable3);
                           }
                           break;
                        case "4":
                           {
                              hTable.assign(hTable4);
                           }
                           break;
                        case "5":
                           {
                              hTable.assign(hTable5);
                           }
                           break;
                        case "6":
                           {
                              hTable.assign(hTable6);
                           }
                           break;
                        case "7":
                           {
                              hTable.assign(hTable7);
                           }
                           break;
                        case "8":
                           {
                              hTable.assign(hTable8);
                           }
                           break;
                        case "9":
                           {
                              hTable.assign(hTable9);
                           }
                           break;
                        case "10":
                           {
                              hTable.assign(hTable10);
                           }
                           break;
                        case "11":
                           {
                              hTable.assign(hTable11);
                           }
                           break;
                        case "12":
                           {
                              hTable.assign(hTable12);
                           }
                           break;
                        case "13":
                           {
                              hTable.assign(hTable13);
                           }
                           break;
                        case "14":
                           {
                              hTable.assign(hTable14);
                           }
                           break;
                        case "15":
                           {
                              hTable.assign(hTable15);
                           }
                           break;
                        case "16":
                           {
                              hTable.assign(hTable16);
                           }
                           break;
                        case "17":
                           {
                              hTable.assign(hTable17);
                           }
                           break;
                        case "18":
                           {
                              hTable.assign(hTable18);
                           }
                           break;
                        case "19":
                           {
                              hTable.assign(hTable19);
                           }
                           break;
                        case "20":
                           {
                              hTable.assign(hTable20);
                           }
                           break;
                     }
                     
                     /* {set Prop value [handle]} */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjUpdTable", hDo, "I", hTable);
                     /* {get Prop var [handle]} */
                     hRowObject.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObject", hDo));
                     
                     if (_and(notUnknown(subscript(rRowid, iDo)), () -> isNotEqual(subscript(rRowid, iDo), hRowObject.unwrapBuffer().rowID())))
                     {
                        hRowObject.unwrapBuffer().findByRowID(subscript(rRowid, iDo));
                     }
                  }));
               }
            }
         }
         
         /* If we're running standalone (not divided), then errors are logged
              via addMessage. Otherwise, if we're the client of a divided SBO,
              messages will have been returned from the server and we log them here. */
         if (_and(isEqual(cAsdivision, "Client"), () -> isNotEqual(cMessages, "")))
         {
            ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", cMessages, new unknown(), new unknown());
         }
         
         lCommitOk.assign(and(not(new logical(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))), () -> isEqual(cUndoIds, "")));
         
         /* We currently do this before we disconnect in case foreignKey 
              has changed, which will make dataAvailable call openquery */
         if ((lCommitOk).booleanValue())
         {
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectState", targetProcedure(), "I", "NoUpdates");
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LastCommitErrorType"));
            ghProp.unwrapBufferField().changeValue(new character(""));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LastCommitErrorKeys"));
            ghProp.unwrapBufferField().changeValue(new character(""));
            
            IntegerExpression resExpr10 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cContained);
               }
            };
            ToClause toClause10 = new ToClause(iDo, 1, resExpr10);
            
            doTo("loopLabel14", toClause10, new Block((Body) () -> 
            {
               hDo.assign(handle.fromString(entry(iDo, cContained)));
               ControlFlowOps.invokeInWithMode("doReturnUpd", hDo, "I", new character(""));
               
               if (_isNotEqual(lookup(valueOf(iDo), cHasrecords), 0))
               {
                  if (_isUnknown(hTopDo))
                  {
                     hTopDo.assign(hDo);
                  }
                  
                  if (_and(lAutoCommit, () -> isNotEqual(lookup(valueOf(iDo), cHasNewRecords), 0)))
                  {
                     ControlFlowOps.invokeInWithMode("reopenToRowid", hDo, "I", new unknown());
                  }
               }
            }));
            
            /* DO iDO doReturnUpd in all SDOs. */
            if ((hTopDo.isValid()).booleanValue())
            {
               NamedEventManager.publish("DataAvailable", hTopDo, "I", new Object[]
               {
                  "RESET"
               });
            }
         }
         else
         {
            lRowUpdated.setUnknown();
            
            ToClause toClause11 = new ToClause(iDo, numEntries(cContained), 1, new integer(-1));
            
            doTo("loopLabel15", toClause11, new Block((Body) () -> 
            {
               hDo.assign(handle.fromString(entry(iDo, cContained)));
               ControlFlowOps.invokeInWithMode("doReturnUpd", hDo, "I", _isNotEqual(cUndoIds, "") ? entry(iDo, cUndoIds, ";") : new character(""));
               
               if (_isNotEqual(lookup(valueOf(iDo), cHasrecords), 0))
               {
                  hTopDo.assign(hDo);
                  
                  /* we started from bottom so the last will be top */
                  if (_and(lAutoCommit, () -> isNotEqual(lookup(valueOf(iDo), cHasNewRecords), 0)))
                  {
                     ControlFlowOps.invokeIn("doReturnToaddMode", hDo);
                  }
                  
                  /* Keep track of state, if all changes was delete everything is rolled
                             back in doReturnUpd */
                  /* {get Prop var [handle]} */
                  cRowObjectState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", hDo));
                  
                  if (_and(isNotEqual(lRowUpdated, true), () -> isEqual(cRowObjectState, "NoUpdates")))
                  {
                     lRowUpdated.assign(false);
                  }
                  else
                  {
                     /* Ensure that ALL parents of this SDO stays in position */
                     lRowUpdated.assign(true);
                     /* {get Prop var [handle]} */
                     hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hDo));
                     
                     LogicalOp whileClause0 = () -> hSource.isValid();
                     
                     doWhile("loopLabel16", whileClause0, new Block((Body) () -> 
                     {
                        iSource.assign(lookup(valueOf(hSource), cContained));
                        
                        if (_isGreaterThan(iSource, 0))
                        {
                           if (_isEqual(cUndoIds, ""))
                           {
                              cUndoIds.assign(fill(";", minus(numEntries(cContained), 1)));
                           }
                           
                           /* Just add a new entry with '?' as RowNum to the current undoId
                                           list for the source. DoReturnUpd only uses the first entry,
                                           but we keep the whole list just in case  */
                           cUndoIds.replaceEntry(iSource, ";", concat("?", chr(3), ",", entry(iSource, cUndoIds, ";")));
                        }
                        /* {get Prop var [handle]} */
                        hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hSource));
                     }));
                  }
               }
               ghProp.assign(handle.fromString(entry(1, hDo.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("LastCommitErrorKeys"));
               cErrorKeys.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, hDo.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("LastCommitErrorType"));
               cErrorType.assign(ghProp.unwrapBufferField().value());
               cErrorTypeList.assign(concat(cErrorType, (_isEqual(iDo, numEntries(cContained)) ? new character("") : new character(";")), cErrorTypeList));
               cErrorKeyList.assign(concat(cErrorKeys, (_isEqual(iDo, numEntries(cContained)) ? new character("") : new character(";")), cErrorKeyList));
            }));
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LastCommitErrorType"));
            ghProp.unwrapBufferField().changeValue(cErrorTypeList);
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("LastCommitErrorKeys"));
            ghProp.unwrapBufferField().changeValue(cErrorKeyList);
            
            if (_not(lRowUpdated))
            {
               /* {set Prop value [handle]} */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectState", targetProcedure(), "I", "NoUpdates");
            }
            
            if ((new logical(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
            {
               /* {get Prop var [handle]} */ 
               hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getCommitSource", targetProcedure()));
               
               if (_isEqual(hSource, sourceProcedure()))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateSource"));
                  cHandle.assign(ghProp.unwrapBufferField().value());
                  /* There may be more than one. */
                  hSource.assign(handle.fromString(entry(1, cHandle)));
                  
                  if ((hSource.isValid()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("showDataMessagesProcedure", hSource, "O", cDummy);
                  }
               }
 /* coming from commit panel */;
               lError.assign(true);
            }
            /* END DO if there are error messages */
            /* Now let external client objects know we might have changed data.*/
            NamedEventManager.publish("dataAvailable", hTopDo, "I", new Object[]
            {
               "RESET"
            });
         }
         /* if not lCommitOk */
         returnNormal((lError).booleanValue() ? new character("ADM-ERROR") : new character(""));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Check for pending updates in data targets and ask if it is <br>
    *           ok to continue.    <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void confirmContinue(final logical pioCancel)
   {
      internalProcedure(new Block((Body) () -> 
      {
         /* don't ask data-targets if already cancelled */
         if (_not(pioCancel))
         {
            NamedEventManager.publish("confirmContinue", targetProcedure(), "U", new Object[]
            {
               pioCancel
            });
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void createData(final character _pcColumnNames_1, final character pcNewValues, final character pcError)
   {
      character pcColumnNames_1 = TypeFactory.initInput(_pcColumnNames_1);
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcError);
      }, 
      (Body) () -> 
      {
         ControlFlowOps.invokeInWithMode("processOpenCall", targetProcedure(), "IIIUO", new character("CREATE"), pcColumnNames_1, new character(""), pcNewValues, pcError);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Override to ensure SDOs are created and prepared    <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void createObjects()
   {
      logical lInitialized = TypeFactory.logical();
      logical lCreated = TypeFactory.logical();
      character cAsdivision = TypeFactory.character();
      character cBindScope = TypeFactory.character();
      handle hContainer = TypeFactory.handle();
      character cSdos = TypeFactory.character();
      handle hSdo = TypeFactory.handle();
      integer iSdo = TypeFactory.integer();
      logical lFetchDefs = TypeFactory.logical();
      logical lCheckDefs = TypeFactory.logical();
      handle hRowObjectTable = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitialized.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectsCreated"));
         lCreated.assign(ghProp.unwrapBufferField().value());
         
         if (_or(lCreated, lInitialized))
         {
            returnNormal();
         }
         
         ControlFlowOps.runSuper("createObjects");
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAsDivision", targetProcedure()));
         
         if (_isNotEqual(cAsdivision, "SERVER"))
         {
            /* In design mode where the SBO is running standalone we may need to 
                    fetch definitions from server. This can only happen if we are not 
                    running in a container. The check for BindScope <> 'data' avoids this 
                    if running standalone, when initializeObject is called, except in the 
                    case where OpenOnInit is false, but in that case we may as well do the 
                    fetch here. */
            /* {get Prop var [handle]} */ 
            cBindScope.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getBindScope", targetProcedure()));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
            hContainer.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
            cSdos.assign(ghProp.unwrapBufferField().value());
            
            if (_and(isNotEqual(cBindScope, "Data"), () -> not(hContainer.isValid())))
            {
               if (_isEqual(cAsdivision, "CLIENT"))
               {
                  lCheckDefs.assign(true);
               }
            }
            
            IntegerExpression resExpr11 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cSdos);
               }
            };
            ToClause toClause12 = new ToClause(iSdo, 1, resExpr11);
            
            doTo("loopLabel17", toClause12, new Block((Body) () -> 
            {
               hSdo.assign(handle.fromString(entry(iSdo, cSdos)));
               silent(() -> ControlFlowOps.invokeIn("createObjects", hSdo));
               
               if (_or(ErrorManager.isError(), () -> isNotEqual(ControlFlowOps.getReturnValue(), "")))
               {
                  returnError("ADM-ERROR");
               }
               
               /* An SDO that does not have a TT after createObjects is relying on 
                         the container to get the defintions. See logic to set CheckDefs above */
               if ((lCheckDefs).booleanValue())
               {
                  /* {get Prop var [handle]} */
                  hRowObjectTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                  
                  if (_and(not(hRowObjectTable.isValid()), not(lFetchDefs)))
                  {
                     lFetchDefs.assign(true);
                  }
               }
            }));
            
            /* See logic above, for setting of FetchDefs.   
                    This will be handled in initializeObject or by the DataContainer
                    in normal run time scenarios */
            if ((lFetchDefs).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("fetchContainedData", targetProcedure(), "I", new character("DEFINE"));
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     This version of dataAvailable basically just notifies other<br>
    *              objects (Data-Targets) that the current row has been changed.<br>
    *              Or if the DataSource is an external object, use the Foreign<br>
    *              Fields property to get the key field values to use to reopen<br>
    *              the Master object's query.<br>
    * Parameters:  pcRelative AS CHARACTER (see data.p for details)
    */
   public void dataAvailable(final character _pcRelative)
   {
      character pcRelative = TypeFactory.initInput(_pcRelative);
      handle hSource = TypeFactory.handle();
      character cForeignFields = TypeFactory.character();
      logical lNewSource = TypeFactory.logical();
      integer iField = TypeFactory.integer();
      character cLocalFields = TypeFactory.character();
      character cSourceFields = TypeFactory.character();
      character cLocalField = TypeFactory.character();
      character cValues = TypeFactory.character();
      handle hMaster = TypeFactory.handle();
      integer iEntry = TypeFactory.integer();
      handle hDo = TypeFactory.handle();
      character cMapping = TypeFactory.character();
      character cHandles = TypeFactory.character();
      logical lInitted = TypeFactory.logical();
      character cDataTargets = TypeFactory.character();
      logical lBlockDataAvailable = TypeFactory.logical();
      logical lOpen = TypeFactory.logical();
      handle hContainer = TypeFactory.handle();
      character cRowObjectState = TypeFactory.character();
      logical lDataIsFetched = TypeFactory.logical();
      logical lIsFetchPending = TypeFactory.logical();
      character cAsDivision = TypeFactory.character();
      character cContained = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitted.assign(ghProp.unwrapBufferField().value());
         
         /* Let the SBO call this later*/
         if (_not(lInitted))
         {
            returnNormal();
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cContained.assign(ghProp.unwrapBufferField().value());
         
         if (_isGreaterThan(lookup(valueOf(sourceProcedure()), cContained), 0))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
            cMapping.assign(ghProp.unwrapBufferField().value());
            cHandles.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", valueOf(sourceProcedure()), cMapping, false, ","));
            
            /* Allow for the possibility of more than one match. */
            if (_notUnknown(cHandles))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("BlockDataAvailable"));
               lBlockDataAvailable.assign(ghProp.unwrapBufferField().value());
               
               if (_not(lBlockDataAvailable))
               {
                  IntegerExpression resExpr12 = new IntegerExpression()
                  {
                     public integer execute()
                     {
                        return numEntries(cHandles);
                     }
                  };
                  ToClause toClause13 = new ToClause(iEntry, 1, resExpr12);
                  
                  doTo("loopLabel18", toClause13, new Block((Body) () -> 
                  {
                     hDo.assign(handle.fromString(entry(iEntry, cHandles)));
                     
                     /* child SBO will need to know who the parent is */
                     if (_isEqual( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(character.class, "getObjectType", hDo), "smartBusinessObject"))
                     {
                        ghTargetProcedure.assign(targetProcedure());
                     }
                     
                     silent(() -> ControlFlowOps.invokeInWithMode("dataAvailable", hDo, "I", pcRelative));
                     ghTargetProcedure.setUnknown();
                  }));
               }
            }
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
            cDataTargets.assign(ghProp.unwrapBufferField().value());
            
            if (_isGreaterThan(lookup(valueOf(sourceProcedure()), cDataTargets), 0))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
               cMapping.assign(ghProp.unwrapBufferField().value());
               cHandles.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", valueOf(sourceProcedure()), cMapping, true, ","));
               
               if (_notUnknown(cHandles))
               {
                  IntegerExpression resExpr13 = new IntegerExpression()
                  {
                     public integer execute()
                     {
                        return numEntries(cHandles);
                     }
                  };
                  ToClause toClause14 = new ToClause(iEntry, 1, resExpr13);
                  
                  doTo("loopLabel19", toClause14, new Block((Body) () -> 
                  {
                     hDo.assign(handle.fromString(entry(iEntry, cHandles)));
                     /* Allow for the possibility of more than one match.  
                     
                                   The SDO (9.1C) must receive 'value-changed' to just pass the 
                                   event on without applying ForeignFields and reopen the query 
                                   (This is the future event that any object can pass without 
                                   the SDO/SBO requiring to know who the caller is, but we still 
                                   support 'different' and 9.1C browsers still passes that, so check
                                   whether the caller is a target) */
                     silent(() -> ControlFlowOps.invokeInWithMode("dataAvailable", hDo, "I", _and(isEqual(pcRelative, "DIFFERENT"), () -> matchesList(cDataTargets, valueOf(sourceProcedure()))) ? new character("VALUE-CHANGED") : pcRelative));
                  }));
               }
            }
            else
            {
               /* It did come from an external DataSource. If it's not just the
                        SAME row as before, get the foreign fields and prepare the Query
                        for the Master DataObject using those values. */
               /* {get Prop var [handle]} */ 
               hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignFields"));
               cForeignFields.assign(ghProp.unwrapBufferField().value());
               
               if (_or(isEqual(cForeignFields, ""), () -> isEqual(pcRelative, "SAME")))
               {
                  returnNormal();
               }
               
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DataIsFetched"));
               lDataIsFetched.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
               hContainer.assign(ghProp.unwrapBufferField().value());
               
               if ((hContainer.isValid()).booleanValue())
               {
                  lIsFetchPending /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "isFetchPending", hContainer));
               }
               
               if (_and(isEqual(pcRelative, "RESET"), not(lDataIsFetched)))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("OpenOnInit"));
                  lOpen.assign(ghProp.unwrapBufferField().value());
                  
                  if (_not(lOpen))
                  {
                     if ((hContainer.isValid()).booleanValue())
                     {
                        lOpen.assign(not(lIsFetchPending));
                     }
                     else
                     {
                        lOpen.assign(true);
                     }
                  }
                  
                  if ((lOpen).booleanValue())
                  {
                     /* {get Prop var [handle]} */ 
                     cRowObjectState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", targetProcedure()));
                     
                     /* there are logic in query.p that makes this into 'reset' again 
                                  if the source is in newMode or not available */
                     if (_and(isEqual(cRowObjectState, "NoUpdates"), () -> new logical(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasForeignKeyChanged", targetProcedure()))) /* {fn <func-name> [handle] */)
                     {
                        pcRelative.assign("DIFFERENT");
                     }
                  }
               }
               /* reset */
               /* Don't deal with a row that's just being created. */
               /* {get Prop var [handle]} */
               lNewSource.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getNewMode", hSource));
               
               if (_not(lNewSource))
               {
                  loopLabel20:
                  for (iField.assign(1); _isLessThanOrEqual(iField, numEntries(cForeignFields)); iField.assign(plus(iField, 2)))
                  {
                      /* 1st of each pair is SDO fld  */cLocalField.assign(entry(iField, cForeignFields));
                     cLocalFields.assign(concat(cLocalFields, (_isNotEqual(cLocalFields, "") ? new character(",") : new character("")), cLocalField));
                     cSourceFields.assign(concat(cSourceFields, (_isNotEqual(cSourceFields, "") ? new character(",") : new character("")), entry(plus(iField, 1), cForeignFields)));
                  }
                  
                  /* END DO iField */
                  silent(() -> cValues /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", hSource, "I", cSourceFields)));
                  
                  /* Throw away the RowIdent entry returned by colValues*/
                  if (_notUnknown(cValues))
                  {
                     cValues.assign(substring(cValues, plus(indexOf(cValues, chr(1)), 1)));
                  }
               }
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
               hMaster.assign(ghProp.unwrapBufferField().value());
               
               /* NOTE: NOT (lNewSource = FALSE) because lNewSource = ? when 
                        source closed */
               if (_or(not(isEqual(lNewSource, false)), () -> isUnknown(cValues)))
               {
                  /* No row available in the Source. */
                  /* {fn <func-name> [handle] */
                  ControlFlowOps.invokeDynamicFunctionIn(logical.class, "closeQuery", hMaster);
                  /* Close the previous query. */
                  returnNormal();
               }
               
               /* The ForeignValues of the SBO is not retrieved from the server 
                        so we need to store it also when DataIsFetched. 
                        DataIsFetched is the flag set by the DataContainer to avoid reopen */
               if (_or(isNotEqual(pcRelative, "RESET"), lDataIsFetched))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
                  ghProp.unwrapBufferField().changeValue(cValues);
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
                  hMaster.assign(ghProp.unwrapBufferField().value());
                  
                  if ((hMaster.isValid()).booleanValue())
                  {
                     ghProp.assign(handle.fromString(entry(1, hMaster.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
                     ghProp.unwrapBufferField().changeValue(cValues);
                  }
                  /* {set Prop value [handle]} */ 
                  
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("DataIsFetched"));
                  ghProp.unwrapBufferField().changeValue(new logical(false));
               }
               /* {get Prop var [handle]} */ 
               cAsDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAsDivision", targetProcedure()));
               
               if (_or(isEqual(pcRelative, "RESET"), lDataIsFetched))
               {
                  ControlFlowOps.invokeInWithMode("dataAvailable", hMaster, "I", new character("RESET"));
               }
               else
               {
                  if (_and(and(and(and(lIsFetchPending, () -> isEqual(cAsDivision, "Client")), () -> isEqual(pcRelative, "initialize")), () -> hSource.isValid()), () -> new logical(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getObjectInitialized", hSource))) /* {fn <func-name> [handle] */)
                  {
                     /* If called from initializeObject and IsFetchPending we need to ensure 
                                that ForeignFields are applied if the DataSource is not part of the 
                                pending request */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignQuerySelection", targetProcedure(), "III", cLocalFields, cValues, "");
                  }
                  else
                  {
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignQuerySelection", targetProcedure(), "III", cLocalFields, cValues, "");
                     
                     /* when the SBO is a child object in a Dyn Web container with an external */
                     /* DataSource, we need to run fetchFirstBatch so that any batching */
                     /* properties are reset */
                     if (_isEqual(pcRelative, "TRANSFER"))
                     {
                        ControlFlowOps.invokeIn("fetchFirstBatch", hMaster);
                     }
                     else
                     {
                        /* {fn <func-name> [handle] */ 
                        ControlFlowOps.invokeDynamicFunctionIn(logical.class, "openQuery", targetProcedure());
                     }
                  }
               }
            }
         }
         /* END ELSE DO (if not from a data-target) */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Receives the deleteComplete event from a contained SDO and <br>
    *              passes it on to the appropriate DATA-TARGET<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void deleteComplete()
   {
      character cMapping = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      integer iObject = TypeFactory.integer();
      character cHandle = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         cHandle.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", valueOf(sourceProcedure()), cMapping, false, ","));
         
         IntegerExpression resExpr14 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cHandle);
            }
         };
         ToClause toClause15 = new ToClause(iObject, 1, resExpr14);
         
         doTo("loopLabel21", toClause15, new Block((Body) () -> 
         {
            hObject.assign(handle.fromString(entry(iObject, cHandle)));
            silent(() -> ControlFlowOps.invokeIn("deleteComplete", hObject));
         }));
         
         /* END DO iObject */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void deleteData(final character _pcColumnNames_1, final character _pcOldValues, final character pcError)
   {
      character pcColumnNames_1 = TypeFactory.initInput(_pcColumnNames_1);
      character pcOldValues = TypeFactory.initInput(_pcOldValues);
      character dummy = TypeFactory.character();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcError);
      }, 
      (Body) () -> 
      {
         ControlFlowOps.invokeInWithMode("processOpenCall", targetProcedure(), "IIIUO", new character("DELETE"), pcColumnNames_1, pcOldValues, dummy, pcError);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void destroyObject()
   {
      handle hObject = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         NamedEventManager.publish("unRegisterObject", targetProcedure());
         silent(() -> 
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLogicObject"));
            hObject.assign(ghProp.unwrapBufferField().value());
         });
         
         if ((hObject.isValid()).booleanValue())
         {
            HandleOps.delete(hObject);
         }
         
         ControlFlowOps.runSuper("destroyObject");
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Returns the next batch of rows to a browse object, communicating<br>
    *              with its SDO.<br>
    * Parameters:<br>
    *   INPUT plForwards - TRUE if we should retrieve a batch of rows after <br>
    *                      the current rows,<br>
    *                      FALSE if before.  Notes:
    */
   public void fetchBatch(final logical _plForwards)
   {
      logical plForwards = TypeFactory.initInput(_plForwards);
      character cMapping = TypeFactory.character();
      integer iEntry = TypeFactory.integer();
      handle hSdo = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         iEntry.assign(lookup(valueOf(sourceProcedure()), cMapping));
         
         if (_isNotEqual(iEntry, 0))
         {
            hSdo.assign(handle.fromString(entry(plus(iEntry, 1), cMapping)));
            ControlFlowOps.invokeInWithMode("fetchBatch", hSdo, "I", plForwards);
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     client-side procedure to get a set of data back from the<br>
    *              server.<br>
    * Parameters:  pcObject AS CHARACTER <br>
    *              - Blank - openQuery request to retireve data for all SDOs<br>
    *              - if specified, then fetch data sets from that Object down only.<br>
    *              - 'DEFINE' - Special not-open , but get defs case for SDOs with<br>
    *                           dynamic SDOs running on a client
    */
   public void fetchContainedData(final character _pcObject_2)
   {
      character pcObject_2 = TypeFactory.initInput(_pcObject_2);
      character cAsdivision = TypeFactory.character();
      character cAllQueries = TypeFactory.character("");
      character cContext = TypeFactory.character();
      character cServerFileName = TypeFactory.character();
      handle hAsHandle = TypeFactory.handle();
      handle hAppServer = TypeFactory.handle();
      handle hRowObject1 = TypeFactory.handle();
      handle hRowObject2 = TypeFactory.handle();
      handle hRowObject3 = TypeFactory.handle();
      handle hRowObject4 = TypeFactory.handle();
      handle hRowObject5 = TypeFactory.handle();
      handle hRowObject6 = TypeFactory.handle();
      handle hRowObject7 = TypeFactory.handle();
      handle hRowObject8 = TypeFactory.handle();
      handle hRowObject9 = TypeFactory.handle();
      handle hRowObject10 = TypeFactory.handle();
      handle hRowObject11 = TypeFactory.handle();
      handle hRowObject12 = TypeFactory.handle();
      handle hRowObject13 = TypeFactory.handle();
      handle hRowObject14 = TypeFactory.handle();
      handle hRowObject15 = TypeFactory.handle();
      handle hRowObject16 = TypeFactory.handle();
      handle hRowObject17 = TypeFactory.handle();
      handle hRowObject18 = TypeFactory.handle();
      handle hRowObject19 = TypeFactory.handle();
      handle hRowObject20 = TypeFactory.handle();
      handle hFirstSdo = TypeFactory.handle();
      handle hMaster = TypeFactory.handle();
      character cSdos = TypeFactory.character();
      character cSdonames = TypeFactory.character();
      character cForeignValues = TypeFactory.character();
      integer iSdo = TypeFactory.integer();
      handle hSdo = TypeFactory.handle();
      integer iSdonum = TypeFactory.integer();
      character cTtlist = TypeFactory.character();
      character cError = TypeFactory.character();
      handle hRowObjectTt = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character("WAIT"));
         
         if (_isEqual(cAsdivision, "Client"))
         {
            /* Special case.. retrieve definitions when OpenOnInit is false */
            if (_isEqual(pcObject_2, "DEFINE"))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
               cSdos.assign(ghProp.unwrapBufferField().value());
               
               IntegerExpression resExpr15 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(cSdos);
                  }
               };
               ToClause toClause16 = new ToClause(iSdo, 1, resExpr15);
               
               doTo("loopLabel22", toClause16, new Block((Body) () -> 
               {
                  hSdo.assign(handle.fromString(entry(iSdo, cSdos)));
                  /* {get Prop var [handle]} */
                  hRowObjectTt.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                  cAllQueries.assign(concat(cAllQueries, (_isEqual(iSdo, 1) ? new character("") : chr(1)), "SKIP"));
                  cTtlist.assign(concat(cTtlist, (_isEqual(iSdo, 1) ? new character("") : new character(",")), ((hRowObjectTt.isValid()).booleanValue() ? valueOf(hRowObjectTt) : new character("?"))));
               }));
            }
            else
            {
               ControlFlowOps.invokeInWithMode("prepareQueriesForFetch", targetProcedure(), "IIOO", pcObject_2, new character(""), cAllQueries, cTtlist);
               
               if (_begins(ControlFlowOps.getReturnValue(), "ADM-ERROR"))
               {
                  returnNormal(ControlFlowOps.getReturnValue());
               }
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 1))
            {
               hRowObject1.assign(handle.fromString(entry(1, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 2))
            {
               hRowObject2.assign(handle.fromString(entry(2, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 3))
            {
               hRowObject3.assign(handle.fromString(entry(3, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 4))
            {
               hRowObject4.assign(handle.fromString(entry(4, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 5))
            {
               hRowObject5.assign(handle.fromString(entry(5, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 6))
            {
               hRowObject6.assign(handle.fromString(entry(6, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 7))
            {
               hRowObject7.assign(handle.fromString(entry(7, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 8))
            {
               hRowObject8.assign(handle.fromString(entry(8, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 9))
            {
               hRowObject9.assign(handle.fromString(entry(9, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 10))
            {
               hRowObject10.assign(handle.fromString(entry(10, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 11))
            {
               hRowObject11.assign(handle.fromString(entry(11, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 12))
            {
               hRowObject12.assign(handle.fromString(entry(12, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 13))
            {
               hRowObject13.assign(handle.fromString(entry(13, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 14))
            {
               hRowObject14.assign(handle.fromString(entry(14, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 15))
            {
               hRowObject15.assign(handle.fromString(entry(15, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 16))
            {
               hRowObject16.assign(handle.fromString(entry(16, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 17))
            {
               hRowObject17.assign(handle.fromString(entry(17, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 18))
            {
               hRowObject18.assign(handle.fromString(entry(18, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 19))
            {
               hRowObject19.assign(handle.fromString(entry(19, cTtlist)));
            }
            
            if (_isGreaterThanOrEqual(numEntries(cTtlist), 20))
            {
               hRowObject20.assign(handle.fromString(entry(20, cTtlist)));
            }
            
            /* {get Prop var [handle]} */ 
            cSdonames.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectNames", targetProcedure()));
            
            /* prepareQueriesForFetch will give error if not valid objectname */
            if (_or(isUnknown(pcObject_2), () -> isEqual(pcObject_2, "DEFINE")))
            {
               iSdonum.assign(1);
            }
            else
            {
               iSdonum.assign(lookup(pcObject_2, cSdonames));
            }
            
            /* The ForeignValues passed as part of context for the table that 
                   is on top is correct on the client, while the value returned from 
                   the server is wrong, so let's log the current value so that we can
                   reapply it further down */
            hFirstSdo /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "DataObjectHandle", targetProcedure(), "I", entry(iSdonum, cSdonames)));
            cContext /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForServer", targetProcedure()));
            ghProp.assign(handle.fromString(entry(1, hFirstSdo.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
            cForeignValues.assign(ghProp.unwrapBufferField().value());
            
            /* Check AppServer properties to see if the object has no current or future 
                   server bindings and is using a stateless operating mode.*/
            if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasNoServerBinding", targetProcedure()))).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("connectServer", targetProcedure(), "O", hAppServer);
               /* {get Prop var [handle]} */ 
               cServerFileName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getServerFileName", targetProcedure()));
               ControlFlowOps.invokeRemoteWithMode("adm2/fetchcontaineddata.p", (handle) null, hAppServer, false, "IUIIOOOOOOOOOOOOOOOOOOOOO", cServerFileName, cContext, cAllQueries, new character(""), new TableParameter(hRowObject1), new TableParameter(hRowObject2), new TableParameter(hRowObject3), new TableParameter(hRowObject4), new TableParameter(hRowObject5), new TableParameter(hRowObject6), new TableParameter(hRowObject7), new TableParameter(hRowObject8), new TableParameter(hRowObject9), new TableParameter(hRowObject10), new TableParameter(hRowObject11), new TableParameter(hRowObject12), new TableParameter(hRowObject13), new TableParameter(hRowObject14), new TableParameter(hRowObject15), new TableParameter(hRowObject16), new TableParameter(hRowObject17), new TableParameter(hRowObject18), new TableParameter(hRowObject19), new TableParameter(hRowObject20), cError);
               /* not used yet */
               /* {fnarg <func-name> <arg> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "applyContextFromServer", targetProcedure(), "I", cContext);
            }
            else
            {
               /* {get Prop var [handle]} */ 
               hAsHandle.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getASHandle", targetProcedure()));
               ControlFlowOps.invokeInWithMode("remoteFetchContainedData", hAsHandle, "UIIOOOOOOOOOOOOOOOOOOOOO", cContext, cAllQueries, new character(""), new TableParameter(hRowObject1), new TableParameter(hRowObject2), new TableParameter(hRowObject3), new TableParameter(hRowObject4), new TableParameter(hRowObject5), new TableParameter(hRowObject6), new TableParameter(hRowObject7), new TableParameter(hRowObject8), new TableParameter(hRowObject9), new TableParameter(hRowObject10), new TableParameter(hRowObject11), new TableParameter(hRowObject12), new TableParameter(hRowObject13), new TableParameter(hRowObject14), new TableParameter(hRowObject15), new TableParameter(hRowObject16), new TableParameter(hRowObject17), new TableParameter(hRowObject18), new TableParameter(hRowObject19), new TableParameter(hRowObject20), cError);
               /* not used yet */
               /* {fnarg <func-name> <arg> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "applyContextFromServer", targetProcedure(), "I", cContext);
               /* Unbind  from AppServer if bound here or bindScope =data  */
               ControlFlowOps.invokeIn("endClientDataRequest", targetProcedure());
            }
            
            ghProp.assign(handle.fromString(entry(1, hFirstSdo.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
            ghProp.unwrapBufferField().changeValue(cForeignValues);
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
            cSdos.assign(ghProp.unwrapBufferField().value());
            
            IntegerExpression resExpr16 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cSdos);
               }
            };
            ToClause toClause17 = new ToClause(iSdo, iSdonum, resExpr16);
            
            doTo("loopLabel23", toClause17, new Block((Body) () -> 
            {
               hSdo.assign(handle.fromString(entry(iSdo, cSdos)));
               /* {set Prop value [handle]} */
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setAsHasStarted", hSdo, "I", true);
               
               /* A dynamic dataobject may have gotten its table def here */
               if (_isEqual(entry(iSdo, cTtlist), "?"))
               {
                  switch (StringHelper.safeTrimTrailing((iSdo).toStringMessage()))
                  {
                     case "1":
                        {
                           hRowObjectTt.assign(hRowObject1);
                        }
                        break;
                     case "2":
                        {
                           hRowObjectTt.assign(hRowObject2);
                        }
                        break;
                     case "3":
                        {
                           hRowObjectTt.assign(hRowObject3);
                        }
                        break;
                     case "4":
                        {
                           hRowObjectTt.assign(hRowObject4);
                        }
                        break;
                     case "5":
                        {
                           hRowObjectTt.assign(hRowObject5);
                        }
                        break;
                     case "6":
                        {
                           hRowObjectTt.assign(hRowObject6);
                        }
                        break;
                     case "7":
                        {
                           hRowObjectTt.assign(hRowObject7);
                        }
                        break;
                     case "8":
                        {
                           hRowObjectTt.assign(hRowObject8);
                        }
                        break;
                     case "9":
                        {
                           hRowObjectTt.assign(hRowObject9);
                        }
                        break;
                     case "10":
                        {
                           hRowObjectTt.assign(hRowObject10);
                        }
                        break;
                     case "11":
                        {
                           hRowObjectTt.assign(hRowObject11);
                        }
                        break;
                     case "12":
                        {
                           hRowObjectTt.assign(hRowObject12);
                        }
                        break;
                     case "13":
                        {
                           hRowObjectTt.assign(hRowObject13);
                        }
                        break;
                     case "14":
                        {
                           hRowObjectTt.assign(hRowObject14);
                        }
                        break;
                     case "15":
                        {
                           hRowObjectTt.assign(hRowObject15);
                        }
                        break;
                     case "16":
                        {
                           hRowObjectTt.assign(hRowObject16);
                        }
                        break;
                     case "17":
                        {
                           hRowObjectTt.assign(hRowObject17);
                        }
                        break;
                     case "18":
                        {
                           hRowObjectTt.assign(hRowObject18);
                        }
                        break;
                     case "19":
                        {
                           hRowObjectTt.assign(hRowObject19);
                        }
                        break;
                     case "20":
                        {
                           hRowObjectTt.assign(hRowObject20);
                        }
                        break;
                  }
                  
                  /* A dynamic dataobject may have gotten its table def here */
                  if (_isEqual(entry(iSdo, cTtlist), "?"))
                  {
                     /* {set Prop value [handle]} */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectTable", hSdo, "I", hRowObjectTt);
                  }
               }
               
               /* Now reopen the RowObject query for each SDO, unless this was empty 
                        definitions. */
               if (_isNotEqual(entry(iSdo, cAllQueries, chr(1)), "SKIP"))
               {
                  /* {fnarg <func-name> <arg> [handle] */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "openDataQuery", hSdo, "I", "FIRST");
               }
            }));
            
            /* END DO iSDO */
            /* Publish dataavailble from the top most sdo so all child sdos are reset 
                  without reopening queries, this will also reach all affected client 
                  objects */
            if (_isNotEqual(pcObject_2, "DEFINE"))
            {
               NamedEventManager.publish("dataAvailable", hFirstSdo, "I", new Object[]
               {
                  "RESET"
               });
            }
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
            hMaster.assign(ghProp.unwrapBufferField().value());
            
            if (_notUnknown(pcObject_2))
            {
               silent(() -> hFirstSdo /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "DataObjectHandle", targetProcedure(), "I", pcObject_2)));
            }
            
            if (_or(isUnknown(pcObject_2), () -> isEqual(hFirstSdo, hMaster)))
            {
               /* {fn <func-name> [handle] */
               silent(() -> ControlFlowOps.invokeDynamicFunctionIn(logical.class, "openQuery", hMaster));
            }
            else
            {
               ControlFlowOps.invokeInWithMode("dataAvailable", hFirstSdo, "I", new unknown());
            }
         }
         /* This is the Client half of a divided SBO; get the server to
              apply the where clause, open the server-side queries, and
              return the resulting temp-tables. */
         /* not client */
         ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character(""));
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     client-side procedure to get a batch of data from one <br>
    *              SDO and all tables from SDOs below in the data-link chain/tree .<br>
    *              <br>
    * Parameters:  pcObject AS CHARACTER  if specified, then fetch data sets<br>
    *              from that Object down only.<br>
    *              Intended for Internal use. <br>
    *              Called from clientSendRows in the contained SDO.<br>
    *              The caller is responsible for publish of dataAvailable.
    */
   public void fetchContainedRows(final character _pcObject_2, final integer _piStartRow, final character _pcRowIdent_4, final logical _plNext, final integer _piRowsToReturn, final integer piRowsReturned)
   {
      character pcObject_2 = TypeFactory.initInput(_pcObject_2);
      integer piStartRow = TypeFactory.initInput(_piStartRow);
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      logical plNext = TypeFactory.initInput(_plNext);
      integer piRowsToReturn = TypeFactory.initInput(_piRowsToReturn);
      character cAsdivision = TypeFactory.character();
      character cAllQueries = TypeFactory.character("");
      handle hAsHandle = TypeFactory.handle();
      handle hAppServer = TypeFactory.handle();
      character cContext = TypeFactory.character();
      character cServerFileName = TypeFactory.character();
      handle hRowObject1 = TypeFactory.handle();
      handle hRowObject2 = TypeFactory.handle();
      handle hRowObject3 = TypeFactory.handle();
      handle hRowObject4 = TypeFactory.handle();
      handle hRowObject5 = TypeFactory.handle();
      handle hRowObject6 = TypeFactory.handle();
      handle hRowObject7 = TypeFactory.handle();
      handle hRowObject8 = TypeFactory.handle();
      handle hRowObject9 = TypeFactory.handle();
      handle hRowObject10 = TypeFactory.handle();
      handle hRowObject11 = TypeFactory.handle();
      handle hRowObject12 = TypeFactory.handle();
      handle hRowObject13 = TypeFactory.handle();
      handle hRowObject14 = TypeFactory.handle();
      handle hRowObject15 = TypeFactory.handle();
      handle hRowObject16 = TypeFactory.handle();
      handle hRowObject17 = TypeFactory.handle();
      handle hRowObject18 = TypeFactory.handle();
      handle hRowObject19 = TypeFactory.handle();
      handle hRowObject20 = TypeFactory.handle();
      character cSdonames = TypeFactory.character();
      character cSdos = TypeFactory.character();
      handle hMaster = TypeFactory.handle();
      integer iSdo = TypeFactory.integer();
      handle hSdo = TypeFactory.handle();
      integer iSdonum = TypeFactory.integer();
      character cTtlist = TypeFactory.character();
      character cForeignValues = TypeFactory.character();
      character cError = TypeFactory.character();
      handle hDataContainer = TypeFactory.handle();
      character cObjectName = TypeFactory.character();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(piRowsReturned);
      }, 
      (Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", targetProcedure()));
         
         if (_isNotEqual(cAsdivision, "client"))
         {
            /* {fnarg <func-name> <arg> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", substitute(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 69), "fetchContainedRows", "SBO"));
            returnNormal("ADM-ERROR");
         }
         
         /* {get Prop var [handle]} */ 
         cSdonames.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectNames", targetProcedure()));
         
         /* prepareQueriesForFetch handles the error if not valid objectname */
         if (_isUnknown(pcObject_2))
         {
            iSdonum.assign(1);
         }
         else
         {
            iSdonum.assign(lookup(pcObject_2, cSdonames));
         }
         
         /* Check if a data Container can handle the request 
             (we currently only do this for the master object) */
         if (_isEqual(iSdonum, 1))
         {
            hDataContainer /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "dataContainerHandle", targetProcedure()));
            
            if ((hDataContainer.isValid()).booleanValue())
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
               cObjectName.assign(ghProp.unwrapBufferField().value());
               ControlFlowOps.invokeInWithMode("fetchContainedRows", hDataContainer, "IIIIIO", cObjectName, piStartRow, pcRowIdent_4, plNext, piRowsToReturn, piRowsReturned);
               returnNormal();
            }
         }
         ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character("WAIT"));
         ControlFlowOps.invokeInWithMode("prepareQueriesForFetch", targetProcedure(), "IIOO", pcObject_2, new character("EmptyChildren"), cAllQueries, cTtlist);
         
         if (_begins(ControlFlowOps.getReturnValue(), "ADM-ERROR"))
         {
            returnNormal(ControlFlowOps.getReturnValue());
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 1))
         {
            hRowObject1.assign(handle.fromString(entry(1, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 2))
         {
            hRowObject2.assign(handle.fromString(entry(2, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 3))
         {
            hRowObject3.assign(handle.fromString(entry(3, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 4))
         {
            hRowObject4.assign(handle.fromString(entry(4, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 5))
         {
            hRowObject5.assign(handle.fromString(entry(5, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 6))
         {
            hRowObject6.assign(handle.fromString(entry(6, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 7))
         {
            hRowObject7.assign(handle.fromString(entry(7, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 8))
         {
            hRowObject8.assign(handle.fromString(entry(8, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 9))
         {
            hRowObject9.assign(handle.fromString(entry(9, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 10))
         {
            hRowObject10.assign(handle.fromString(entry(10, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 11))
         {
            hRowObject11.assign(handle.fromString(entry(11, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 12))
         {
            hRowObject12.assign(handle.fromString(entry(12, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 13))
         {
            hRowObject13.assign(handle.fromString(entry(13, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 14))
         {
            hRowObject14.assign(handle.fromString(entry(14, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 15))
         {
            hRowObject15.assign(handle.fromString(entry(15, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 16))
         {
            hRowObject16.assign(handle.fromString(entry(16, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 17))
         {
            hRowObject17.assign(handle.fromString(entry(17, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 18))
         {
            hRowObject18.assign(handle.fromString(entry(18, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 19))
         {
            hRowObject19.assign(handle.fromString(entry(19, cTtlist)));
         }
         
         if (_isGreaterThanOrEqual(numEntries(cTtlist), 20))
         {
            hRowObject20.assign(handle.fromString(entry(20, cTtlist)));
         }
         
         /* The ForeignValues passed as part of context for the table that 
              is on top is correct on the client, while the value returned from 
              the server is wrong, so let's log the current value so that we can
              reapply it further down */
         hMaster /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "DataObjectHandle", targetProcedure(), "I", entry(iSdonum, cSdonames)));
         ghProp.assign(handle.fromString(entry(1, hMaster.unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
         cForeignValues.assign(ghProp.unwrapBufferField().value());
         cContext /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForServer", targetProcedure()));
         
         /* Check AppServer properties to see if the object has no current or future 
               server bindings and is using a stateless operating mode.*/
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasNoServerBinding", targetProcedure()))).booleanValue())
         {
            ControlFlowOps.invokeInWithMode("connectServer", targetProcedure(), "O", hAppServer);
            /* {get Prop var [handle]} */ 
            cServerFileName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getServerFileName", targetProcedure()));
            ControlFlowOps.invokeRemoteWithMode("adm2/fetchcontainedrows.p", (handle) null, hAppServer, false, "IUIIIIIOOOOOOOOOOOOOOOOOOOOOO", cServerFileName, cContext, cAllQueries, piStartRow, pcRowIdent_4, plNext, piRowsToReturn, piRowsReturned, new TableParameter(hRowObject1, true), new TableParameter(hRowObject2, true), new TableParameter(hRowObject3, true), new TableParameter(hRowObject4, true), new TableParameter(hRowObject5, true), new TableParameter(hRowObject6, true), new TableParameter(hRowObject7, true), new TableParameter(hRowObject8, true), new TableParameter(hRowObject9, true), new TableParameter(hRowObject10, true), new TableParameter(hRowObject11, true), new TableParameter(hRowObject12, true), new TableParameter(hRowObject13, true), new TableParameter(hRowObject14, true), new TableParameter(hRowObject15, true), new TableParameter(hRowObject16, true), new TableParameter(hRowObject17, true), new TableParameter(hRowObject18, true), new TableParameter(hRowObject19, true), new TableParameter(hRowObject20, true), cError);
            /* not used yet */
            /* {fnarg <func-name> <arg> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "applyContextFromServer", targetProcedure(), "I", cContext);
         }
         else
         {
            /* {get Prop var [handle]} */ 
            hAsHandle.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getASHandle", targetProcedure()));
            ControlFlowOps.invokeInWithMode("remoteFetchContainedRows", hAsHandle, "UIIIIIOOOOOOOOOOOOOOOOOOOOOO", cContext, cAllQueries, piStartRow, pcRowIdent_4, plNext, piRowsToReturn, piRowsReturned, new TableParameter(hRowObject1, true), new TableParameter(hRowObject2, true), new TableParameter(hRowObject3, true), new TableParameter(hRowObject4, true), new TableParameter(hRowObject5, true), new TableParameter(hRowObject6, true), new TableParameter(hRowObject7, true), new TableParameter(hRowObject8, true), new TableParameter(hRowObject9, true), new TableParameter(hRowObject10, true), new TableParameter(hRowObject11, true), new TableParameter(hRowObject12, true), new TableParameter(hRowObject13, true), new TableParameter(hRowObject14, true), new TableParameter(hRowObject15, true), new TableParameter(hRowObject16, true), new TableParameter(hRowObject17, true), new TableParameter(hRowObject18, true), new TableParameter(hRowObject19, true), new TableParameter(hRowObject20, true), cError);
            /* not used yet */
            /* {fnarg <func-name> <arg> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "applyContextFromServer", targetProcedure(), "I", cContext);
            /* Unbind or read data properties from appserver */
            ControlFlowOps.invokeIn("endClientDataRequest", targetProcedure());
         }
         
         ghProp.assign(handle.fromString(entry(1, hMaster.unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
         ghProp.unwrapBufferField().changeValue(cForeignValues);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cSdos.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr17 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cSdos);
            }
         };
         ToClause toClause18 = new ToClause(iSdo, iSdonum, resExpr17);
         
         doTo("loopLabel24", toClause18, new Block((Body) () -> 
         {
            hSdo.assign(handle.fromString(entry(iSdo, cSdos)));
            
            /* Now reopen the RowObject query for child SDOs 
                   clientSendRows takes care of the first  */
            if (_isGreaterThan(iSdo, iSdonum))
            {
               /* {fnarg <func-name> <arg> [handle] */
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "openDataQuery", hSdo, "I", "FIRST");
               ghProp.assign(handle.fromString(entry(1, hSdo.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DataIsFetched"));
               ghProp.unwrapBufferField().changeValue(new logical(true));
            }
         }));
         
         /* END DO iSDO */
         ControlFlowOps.invokeInWithMode("changeCursor", targetProcedure(), "I", new character(""));
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Retrieves any properties from the server-side SBO and its SDOs<br>
    *              and sets them in the contained SDOs on the client.<br>
    * Parameters:  &lt;none&gt;<br>
    * Note:        In 9.1C this was always called from postCreateObjects, but<br>
    *              now this is only called at the first call in the case we do a <br>
    *              connection (getAsHandle or bindserver) before the actual data <br>
    *              request.<br>
    *           -  This means that this is not a guaranteed to be called and should <br>
    *              not be used as an override event to capture first-time connections<br>
    *           -  We try to avoid using this altogether as we try to postpone the <br>
    *              connection until we do the actual data request in which case <br>
    *              the 'first-time' context comes back as part of that call instead <br>
    *              of here. But we run this from initializeServerObject if <br>
    *              AsHasStarted is false, in order to provide an optional backwards <br>
    *              compatibilty, but it will require a forced connection before the <br>
    *              data request to ensure that this is called.
    */
   public void fetchDoproperties()
   {
      character cContext = TypeFactory.character();
      handle hAppServer = TypeFactory.handle();
      character cAsDivision = TypeFactory.character();
      logical lAsbound = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cAsDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAsDivision", targetProcedure()));
         /* {get Prop var [handle]} */ 
         lAsbound.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getASBound", targetProcedure()));
         
         /* We cannot call this when unbound since it may be part of the startup
              from getashandle */
         if (_and(isEqual(cAsDivision, "Client"), lAsbound))
         {
            /* {get Prop var [handle]} */ 
            hAppServer.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getASHandle", targetProcedure()));
            ControlFlowOps.invokeInWithMode("serverFetchDOProperties", hAppServer, "O", cContext);
            /* {fnarg <func-name> <arg> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "applyContextFromServer", targetProcedure(), "I", cContext);
            /* Unbind just in case.... 
                   Although this currently is (and always have been) called when bound 
                   we don't want to enforce it since it can be used to retrieve properties 
                   at an early stage under other circumstances for example if openoninit 
                   is false.. */
            ControlFlowOps.invokeInWithMode("unbindServer", targetProcedure(), "I", new unknown());
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     SBO version of the event procedure to retrieve the first row<br>
    *              in one of the ContainedDataObjects. It uses the ObjectMapping<br>
    *              SBO property to match the caller to its Target, or uses<br>
    *              the MasterDataObject by default.<br>
    * Parameters:  &lt;none&gt;<br>
    *    Notes:    Uses the MasterDataObject by default.
    */
   public void fetchFirst()
   {
      handle hObject = TypeFactory.handle();
      character cMapping = TypeFactory.character();
      integer iObject = TypeFactory.integer();
      handle hRequester = TypeFactory.handle();
      character cNavSource = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NavigationSource"));
         cNavSource.assign(ghProp.unwrapBufferField().value());
         
         /* A browser target may run fetchFirst and have to set the Target to
               be identified */
         if (_isEqual(lookup(valueOf(sourceProcedure()), cNavSource), 0))
         {
            /* {get Prop var [handle]} */
            silent(() -> hRequester.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getTargetProcedure", sourceProcedure())));
            
            if (_not(hRequester.isValid()))
            {
               hRequester.assign(sourceProcedure());
            }
         }
         else
         {
            hRequester.assign(sourceProcedure());
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         iObject.assign(lookup(valueOf(hRequester), cMapping));
         
         if (_isNotEqual(iObject, 0))
         {
            hObject.assign(handle.fromString(entry(plus(iObject, 1), cMapping)));
         }
         
         if (_not(hObject.isValid()))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
            hObject.assign(ghProp.unwrapBufferField().value());
         }
         /* {get Prop var [handle]} */ 
         
         ControlFlowOps.invokeIn("fetchFirst", hObject);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     SBO version of the event procedure to retrieve the last row<br>
    *              in one of the ContainedDataObjects. It uses the ObjectMapping<br>
    *              SBO property to match the caller to its Target, or uses<br>
    *              the MasterDataObject by default.<br>
    * Parameters:  &lt;none&gt;<br>
    *    Notes:    Uses the MasterDataObject by default.
    */
   public void fetchLast()
   {
      handle hObject = TypeFactory.handle();
      character cMapping = TypeFactory.character();
      integer iObject = TypeFactory.integer();
      handle hRequester = TypeFactory.handle();
      character cNavSource = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NavigationSource"));
         cNavSource.assign(ghProp.unwrapBufferField().value());
         
         /* A browser target may run fetchLast and have to set the Target to
               be identified */
         if (_isEqual(lookup(valueOf(sourceProcedure()), cNavSource), 0))
         {
            /* {get Prop var [handle]} */
            silent(() -> hRequester.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getTargetProcedure", sourceProcedure())));
            
            if (_not(hRequester.isValid()))
            {
               hRequester.assign(sourceProcedure());
            }
         }
         else
         {
            hRequester.assign(sourceProcedure());
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         iObject.assign(lookup(valueOf(hRequester), cMapping));
         
         if (_isNotEqual(iObject, 0))
         {
            hObject.assign(handle.fromString(entry(plus(iObject, 1), cMapping)));
         }
         
         if (_not(hObject.isValid()))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
            hObject.assign(ghProp.unwrapBufferField().value());
         }
         /* {get Prop var [handle]} */ 
         
         ControlFlowOps.invokeIn("fetchLast", hObject);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     SBO version of the event procedure to retrieve the next row<br>
    *              in one of the ContainedDataObjects. It uses the ObjectMapping<br>
    *              SBO property to match the caller to its Target, or uses<br>
    *              the MasterDataObject by default.<br>
    * Parameters:  &lt;none&gt;<br>
    *    Notes:    Uses the MasterDataObject by default.
    */
   public void fetchNext()
   {
      handle hObject = TypeFactory.handle();
      character cMapping = TypeFactory.character();
      integer iObject = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         iObject.assign(lookup(valueOf(sourceProcedure()), cMapping));
         
         if (_isNotEqual(iObject, 0))
         {
            hObject.assign(handle.fromString(entry(plus(iObject, 1), cMapping)));
         }
         
         if (_not(hObject.isValid()))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
            hObject.assign(ghProp.unwrapBufferField().value());
         }
         /* {get Prop var [handle]} */ 
         
         ControlFlowOps.invokeIn("fetchNext", hObject);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     SBO version of the event procedure to retrieve the previous row<br>
    *              in one of the ContainedDataObjects. It uses the ObjectMapping<br>
    *              SBO property to match the caller to its Target, or uses<br>
    *              the MasterDataObject by default.<br>
    * Parameters:  &lt;none&gt;<br>
    *    Notes:    Uses the MasterDataObject by default.
    */
   public void fetchPrev()
   {
      handle hObject = TypeFactory.handle();
      character cMapping = TypeFactory.character();
      integer iObject = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         iObject.assign(lookup(valueOf(sourceProcedure()), cMapping));
         
         if (_isNotEqual(iObject, 0))
         {
            hObject.assign(handle.fromString(entry(plus(iObject, 1), cMapping)));
         }
         
         if (_not(hObject.isValid()))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
            hObject.assign(ghProp.unwrapBufferField().value());
         }
         /* {get Prop var [handle]} */ 
         
         ControlFlowOps.invokeIn("fetchPrev", hObject);
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Adds the Filter link between itself and a Filter container.  <br>
    *              Called from startFilter after the Filter container is <br>
    *              contructed.  <br>
    * Parameters:  phFilterContainer AS HANDLE - handle of the Filter container<br>
    * Notes:       The code to add the Filter link has been separated from <br>
    *              startFilter so that filterContainerHandler can be overridden<br>
    *              to add other links between this object and the Filter container.
    */
   public void filterContainerHandler(final handle _phFilterContainer)
   {
      handle phFilterContainer = TypeFactory.initInput(_phFilterContainer);
      
      internalProcedure(new Block((Body) () -> 
      {
         ControlFlowOps.invokeInWithMode("addLink", targetProcedure(), "III", phFilterContainer, new character("Filter"), targetProcedure());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Start the logic procedure for the data object<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       The Logic Procedure is an optional object that can contain <br>
    *              validation and business logic for a particular table.  <br>
    *              Rules: <br>
    *              - The RUN is ALWAYS executed with (or without) the extension that <br>
    *                is defined in DataLogicProcedure property <br>
    *                ( this ensures that program-name and :file-name behave as expected)<br>
    *              - follows Progress core run rules:       <br>
    *               1. ANY extention will run r-code if found <br>
    *               2. will run .r if NO period in run name
    */
   public void initializeLogicObject()
   {
      character cLogicProc = TypeFactory.character();
      character cDummy = TypeFactory.character();
      character cDotRfile = TypeFactory.character();
      character cMemberFile = TypeFactory.character();
      character cDbList = TypeFactory.character();
      integer iDb = TypeFactory.integer();
      logical lUseProxy = TypeFactory.logical();
      integer iExt = TypeFactory.integer();
      character cProxyName = TypeFactory.character();
      character cProxyDotR = TypeFactory.character();
      character cExtension = TypeFactory.character();
      character cFile = TypeFactory.character();
      character cRunName = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      logical lWebClient = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cLogicProc.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDataLogicProcedure", targetProcedure()));
         
         if (_isEqual(cLogicProc, ""))
         {
            returnNormal();
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLogicObject"));
         hObject.assign(ghProp.unwrapBufferField().value());
         
         if ((hObject.isValid()).booleanValue())
         {
            returnNormal();
         }
         
         iExt.assign(lastIndexOf(cLogicProc, "."));
         
         if (_isGreaterThan(iExt, 1))
         {
            cFile.assign(substring(cLogicProc, 1, minus(iExt, 1)));
            cExtension.assign(substring(cLogicProc, iExt));
         }
         else
         {
            cFile.assign(cLogicProc);
         }
         
         lWebClient.assign(isEqual(LogicalTerminal.getClientType(), "WEBCLIENT"));
         
         /* If not web client and any db connections find r-code for inspection */
         if (_and(not(lWebClient), () -> isGreaterThan(ConnectionManager.numDBs(), 0)))
         {
            FileSystemOps.initFileInfo(concat(cFile, ".r"));
            cDotRfile.assign(FileSystemOps.fileInfoGetFullPath());
            /* If .r in proc lib, get the member name (ie, filename). */
            cMemberFile.assign(FileSystemOps.member(cDotRfile));
            
            if (_notUnknown(cMemberFile))
            {
               cDotRfile.assign(cMemberFile);
            }
         }
         else
         {
            lUseProxy.assign(true);
         }
         
         /* We have found the base .r */
         if (_notUnknown(cDotRfile))
         {
            RcodeInfoOps.initFileInfo(cDotRfile);
            cDbList.assign(RcodeInfoOps.getDbReferences());
            
            loopLabel25:
            for (iDb.assign(1); _isLessThanOrEqual(iDb, numEntries(trim(cDbList))); iDb.increment())
            {
               /* Remove blank when no db */
               if (_not(ConnectionManager.connected(entry(iDb, cDbList))))
               {
                  lUseProxy.assign(true);
                  /* Flag that we can't use the base file. */
                  break loopLabel25;
               }
            }
            
            /* Do for each required DB */
            if (_not(lUseProxy))
            {
               cRunName.assign(concat(cFile, cExtension));
            }
         }
         
         /* if not connected or no r-code found check if there is proxy r-code */
         if (_isEqual(cRunName, ""))
         {
            cProxyName.assign(concat(cFile, "_cl"));
            cProxyDotR.assign(concat(cProxyName, ".r"));
            
            /* if no proxy r-code, check if we have source code */
            if (_isUnknown(FileSystemOps.searchPath(cProxyDotR)))
            {
               if (_isGreaterThan(cExtension, ""))
               {
                  if ((lUseProxy).booleanValue())
                  {
                     cRunName.assign(concat(cProxyName, cExtension));
                  }
                  else
                  {
                     cRunName.assign(concat(cFile, cExtension));
                  }
                  
                  if (_isUnknown(FileSystemOps.searchPath(cRunName)))
                  {
                     cRunName.assign("");
                  }
               }
            }
            else
            {
               cRunName.assign(concat(cProxyName, cExtension));
            }
 /* NOT lWebClient AND*/ 
         }
         
         if (_isGreaterThan(cRunName, ""))
         {
            OnPhrase[] onPhrase1 = new OnPhrase[]
            {
               new OnPhrase(Condition.STOP, Action.LEAVE, "blockLabel1")
            };
            
            doBlock(TransactionType.SUB, "blockLabel1", onPhrase1, new Block((Body) () -> 
            {
               ControlFlowOps.invokePersistentSet((cRunName).toStringMessage(), hObject);
               targetProcedure().unwrapCommonProcedure().addSuperProcedure(hObject, ProcedureManager.SEARCH_TARGET);
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DataLogicObject"));
               ghProp.unwrapBufferField().changeValue(hObject);
            }));
            
            /* Cannot run without the specified data logic */
            if (_not(hObject.isValid()))
            {
               ControlFlowOps.invokeIn("destroyObject", targetProcedure());
            }
         }
         else
         {
            if (_not(lUseProxy))
            {
               ControlFlowOps.invokeInWithMode("showMessageProcedure", targetProcedure(), "IO", concat("33,", cLogicProc), cDummy);
               ControlFlowOps.invokeIn("destroyObject", targetProcedure());
            }
         }
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     SBO-specific code for initializeObject. <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       This procedure establishes the AppServer connection.
    */
   public void initializeObject()
   {
      character cAppService = TypeFactory.character();
      handle hAppservice = TypeFactory.handle();
      character cSvrFileName = TypeFactory.character();
      character cUibmode = TypeFactory.character();
      handle hDataSource = TypeFactory.handle();
      logical lOpenOnInit = TypeFactory.logical();
      logical lFetchPending = TypeFactory.logical();
      character cValues = TypeFactory.character();
      handle hMaster = TypeFactory.handle();
      handle hContainerSource = TypeFactory.handle();
      logical lInitialized = TypeFactory.logical();
      character cAsDivision = TypeFactory.character();
      character cSdos = TypeFactory.character();
      integer iSdo = TypeFactory.integer();
      handle hSdo = TypeFactory.handle();
      handle hRowObjectTable = TypeFactory.handle();
      logical lFetchDefs = TypeFactory.logical();
      character cDataTargets = TypeFactory.character();
      character cMapping = TypeFactory.character();
      handle hDataObject = TypeFactory.handle();
      handle hDataTarget = TypeFactory.handle();
      handle hToolbarSource = TypeFactory.handle();
      integer iMappedEntry = TypeFactory.integer();
      integer iNumTarget = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UIBMode"));
         cUibmode.assign(ghProp.unwrapBufferField().value());
         
         /* If the object has a Partition name, then connect */
         if (_isEqual(cUibmode, ""))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
            lInitialized.assign(ghProp.unwrapBufferField().value());
            
            if ((lInitialized).booleanValue())
            {
               returnNormal();
            }
            
            /* {get Prop var [handle]} */ 
            cAppService.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAppService", targetProcedure()));
            
            if (_isNotEqual(cAppService, ""))
            {
               ControlFlowOps.invokeInWithMode("connectServer", targetProcedure(), "O", hAppservice);
               
               if (_isUnknown(hAppservice))
               {
                  returnError("ADM-ERROR");
               }
               
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
               hContainerSource.assign(ghProp.unwrapBufferField().value());
               /* {fnarg <func-name> <arg> [handle] */
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "registerAppService", hContainerSource, "I", cAppService);
            }
            else
            {
               /* If no AppService defined, check if the user is running the client
                        proxy. If so, there can't be any required databases connected for
                        the object to show data. Probably an AppServer setup problem. */
               if (_or(matches(targetProcedure().unwrapFile().getFileName(), ".*_cl.w"), () -> matches(targetProcedure().unwrapFile().getFileName(), ".*_cl.r")))
               {
                  cSvrFileName.assign(replaceAll(targetProcedure().unwrapFile().getFileName(), "_cl.w", ".w"));
                  
                  if (_isEqual(cSvrFileName, targetProcedure().unwrapFile().getFileName()))
                  {
                     cSvrFileName.assign(replaceAll(targetProcedure().unwrapFile().getFileName(), "_cl.r", ".w"));
                  }
                  
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", concat(cSvrFileName, " ", ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 70)) /* {fnarg <func-name> <arg> [handle] */);
                  returnNormal("ADM-ERROR");
               }
            }
         }
         /* END DO IF UIBMode ne "" */
         /* SDOs publishes queryPosition to the toolbar as soon as they are 
              initialized and the toolbars activeTarget check requires a non-hidden 
              object */
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setObjectHidden", targetProcedure(), "I", false);
         NamedEventManager.publish("registerObject", targetProcedure());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
         hContainerSource.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("OpenOnInit"));
         lOpenOnInit.assign(ghProp.unwrapBufferField().value());
         
         /* we set openOninit false if fetchPending below since all the logic 
              after this is similar if OpenOnInit is false Or fetchIsPending */
         if (_and(and(hContainerSource.isValid(), () -> hAppservice.isValid()), () -> isNotEqual(hAppservice, SessionUtils.asHandle())))
         {
            /* Check AppServer properties to see if the object has no current or future 
                   server bindings and is using a stateless operating mode. */
            if (_and(new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasNoServerBinding", targetProcedure())), () -> new logical(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "IsFetchPending", hContainerSource))) /* {fn <func-name> [handle] */)
            {
               lFetchPending.assign(true);
            }
         }
         
         /* Set BindScope before SUPER as createObjects will use it to identify 
              that this a data request is pending also when no container */
         if (_and(lOpenOnInit, not(lFetchPending)))
         {
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setBindScope", targetProcedure(), "I", "Data");
         }
         
         /* Continue with std container initialization. This will start-up the 
              contained SDOs */
         ControlFlowOps.runSuper("initializeObject");
         
         /* if we have failed to initialize our contents do not 
              attempt to 'openQuery' etc. to avoid ugly errors */
         if (_or(isEqual(ControlFlowOps.getReturnValue(), "ADM-ERROR"), () -> isGreaterThan( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()), "")))
         {
            returnNormal("ADM-ERROR");
         }
         
         ControlFlowOps.invokeIn("registerLinkedObjects", targetProcedure());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
         cDataTargets.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr18 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cDataTargets);
            }
         };
         ToClause toClause19 = new ToClause(iNumTarget, 1, resExpr18);
         
         doTo("loopLabel26", toClause19, new Block((Body) () -> 
         {
            hDataTarget.assign(handle.fromString(entry(iNumTarget, cDataTargets)));
            
            if (_isGreaterThan(lookup("Toolbar-target", ControlFlowOps.invokeDynamicFunctionIn(character.class, "getSupportedLinks", hDataTarget)), 0))
            {
               /* {get Prop var [handle]} */
               hToolbarSource.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getToolbarSource", hDataTarget));
               
               if ((hToolbarSource.isValid()).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
                  cMapping.assign(ghProp.unwrapBufferField().value());
                  iMappedEntry.assign(lookup(valueOf(hDataTarget), cMapping));
                  
                  if (_isNotEqual(iMappedEntry, 0))
                  {
                     hDataObject.assign(handle.fromString(entry(plus(iMappedEntry, 1), cMapping)));
                     /* {set Prop value [handle]} */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setFetchHasAudit", hDataObject, "I", true);
                     /* {set Prop value [handle]} */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setFetchHasComment", hDataObject, "I", true);
                     /* {set Prop value [handle]} */
                     ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setFetchAutoComment", hDataObject, "I", true);
                  }
               }
            }
         }));
         
         /* do iNumTarget to number of data targets */
         if (_isEqual(cUibmode, ""))
         {
            /* {get Prop var [handle]} */ 
            cAsDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAsDivision", targetProcedure()));
            /* {get Prop var [handle]} */ 
            hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
            
            if (_and(lOpenOnInit, not(lFetchPending)))
            {
               if ((hDataSource.isValid()).booleanValue())
               {
                  ControlFlowOps.invokeInWithMode("dataAvailable", targetProcedure(), "I", new character("initialize"));
               }
               else
               {
                  /* {fn <func-name> [handle] */ 
                  ControlFlowOps.invokeDynamicFunctionIn(logical.class, "openQuery", targetProcedure());
               }
            }
            else
            {
               if (_and(and(isEqual(cAsDivision, "CLIENT"), () -> hDataSource.isValid()), () -> new logical(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getObjectInitialized", hDataSource))) /* {fn <func-name> [handle] */)
               {
                  ControlFlowOps.invokeInWithMode("dataAvailable", targetProcedure(), "I", new character("initialize"));
               }
            }
            
            /* If we are not managed by a datacontainer check if any definitions 
                   are missing. This is typically if openOnInit is false, but we need to 
                   check when we have a valid source as definitions may still be invalid 
                   also if the source's OpenOnInit is false */
            if (_and(and(isEqual(cAsDivision, "CLIENT"), () -> or(not(lOpenOnInit), () -> hDataSource.isValid())), not(lFetchPending)))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
               cSdos.assign(ghProp.unwrapBufferField().value());
               
               IntegerExpression resExpr19 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(cSdos);
                  }
               };
               ToClause toClause20 = new ToClause(iSdo, 1, resExpr19);
               
               doTo("loopLabel27", toClause20, new Block((Body) () -> 
               {
                  hSdo.assign(handle.fromString(entry(iSdo, cSdos)));
                  /* {get Prop var [handle]} */
                  hRowObjectTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                  
                  if (_not(hRowObjectTable.isValid()))
                  {
                     lFetchDefs.assign(true);
                     leave("loopLabel27");
                  }
               }));
               
               if ((lFetchDefs).booleanValue())
               {
                  ControlFlowOps.invokeInWithMode("fetchContainedData", targetProcedure(), "I", new character("DEFINE"));
               }
            }
            ControlFlowOps.invokeInWithMode("unbindServer", targetProcedure(), "I", new character("unconditionally"));
            
            if ((hDataSource.isValid()).booleanValue())
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
               cValues.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
               hMaster.assign(ghProp.unwrapBufferField().value());
               
               if ((hMaster.isValid()).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, hMaster.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
                  ghProp.unwrapBufferField().changeValue(cValues);
               }
               /* {set Prop value [handle]} */ 
            }
         }
         /* if cuibmode = ''  */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:   Set context and initialize the server object   <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:    This procedure is not considered to be part of the public API. It <br>
    *           is part of the start of the server object called from: <br>
    *          (bindServer -&gt;) getAsHandle -&gt; restartServerObject -&gt; runServerObject.
    */
   public void initializeServerObject()
   {
      handle hAsHandle = TypeFactory.handle();
      logical lAsbound = TypeFactory.logical();
      logical lAsHasStarted = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         lAsbound.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getASBound", targetProcedure()));
         
         if ((lAsbound).booleanValue())
         {
            /* {get Prop var [handle]} */ 
            hAsHandle.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getAsHandle", targetProcedure()));
            /* {get Prop var [handle]} */ 
            lAsHasStarted.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAsHasStarted", targetProcedure()));
            
            /* FetchDoProperties is not really needed anymore, it is only used here 
                   and it's not even guaranteed to be called as we try to avoid a 
                   connection until we do the actual data request in which case the 
                   'first-time' context comes back as part of that call 
                  But we keep it since it does provide some sort of backwards compatibilty
                  although it would require a forced connection before the data request */
            if (_not(lAsHasStarted))
            {
               ControlFlowOps.invokeIn("FetchDOProperties", targetProcedure());
            }
            else
            {
               ControlFlowOps.runSuper("initializeServerObject");
            }
         }
         /* if bound */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Published through data-targets to check if any updates are pending.<br>
    *           This SBO version of the event turns around and RUNS it in <br>
    *           the SDO to which the caller is mapped. <br>
    *           If no pending updates found it publishes isUpdatePending <br>
    *           to its targets     <br>
    * Parameters: input-output plUpdate <br>
    *             Returns TRUE and stops the publishing if update is pending. <br>
    * Notes:      New is included as a pending update. <br>
    *             Called from canNavigate, which is used by navigating objects to <br>
    *             check if they can trust an updateState('updatecomplete') message
    */
   public void isUpdatePending(final logical plUpdate)
   {
      character cMapping = TypeFactory.character();
      integer iObject = TypeFactory.integer();
      handle hObject = TypeFactory.handle();
      character cHandles = TypeFactory.character();
      character cSubscribed = TypeFactory.character();
      character cTargets = TypeFactory.character();
      character cContained = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_not(plUpdate))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
            cMapping.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
            cMapping.assign(ghProp.unwrapBufferField().value());
            cHandles.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", valueOf(sourceProcedure()), cMapping, true, ","));
            
            if (_notUnknown(cHandles))
            {
               IntegerExpression resExpr20 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(cHandles);
                  }
               };
               ToClause toClause21 = new ToClause(iObject, 1, resExpr20);
               
               doTo("loopLabel28", toClause21, new Block((Body) () -> 
               {
                  hObject.assign(handle.fromString(entry(iObject, cHandles)));
                  
                  if ((hObject.isValid()).booleanValue())
                  {
                     ControlFlowOps.invokeInWithMode("isUpdatePending", hObject, "U", plUpdate);
                     
                     if ((plUpdate).booleanValue())
                     {
                        returnNormal();
                     }
                  }
               }));
            }
            else
            {
               /* Check if this is from an inside SDO and run the event in its 
                       the targets that are mapped */
               cHandles.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", valueOf(sourceProcedure()), cMapping, false, ","));
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
               cTargets.assign(ghProp.unwrapBufferField().value());
               
               if (_notUnknown(cHandles))
               {
                  IntegerExpression resExpr21 = new IntegerExpression()
                  {
                     public integer execute()
                     {
                        return numEntries(cHandles);
                     }
                  };
                  ToClause toClause22 = new ToClause(iObject, 1, resExpr21);
                  
                  doTo("loopLabel29", toClause22, new Block((Body) () -> 
                  {
                     hObject.assign(handle.fromString(entry(iObject, cHandles)));
                     
                     if (_and(hObject.isValid(), () -> isGreaterThan(lookup(valueOf(hObject), cTargets), 0)))
                     {
                        ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceEvents"));
                        cSubscribed.assign(ghProp.unwrapBufferField().value());
                        
                        if (_isGreaterThan(lookup("isUpdatePending", cSubscribed), 0))
                        {
                           silent(() -> ControlFlowOps.invokeInWithMode("isUpdatePending", hObject, "U", plUpdate));
                           
                           if ((plUpdate).booleanValue())
                           {
                              returnNormal();
                           }
                        }
                     }
                  }));
               }
               else
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
                  cContained.assign(ghProp.unwrapBufferField().value());
                  
                  if (_isEqual(lookup(valueOf(sourceProcedure()), cContained), 0))
                  {
                     silent(() -> 
                     {
                        ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
                        hObject.assign(ghProp.unwrapBufferField().value());
                     });
                     
                     if ((hObject.isValid()).booleanValue())
                     {
                        ControlFlowOps.invokeInWithMode("isUpdatePending", hObject, "U", plUpdate);
                     }
                  }
               }
            }
         }
         /* not plUpdate */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Handle linkstate form data targets   <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:    We currently handle linkstate from visual targets only.<br>
    *           1. Use it to swap the NavigationSourceName so that one toolbar<br>
    *              can navigate the 'active' target given by the 'active' visual <br>
    *              object. We do this by simply running resetNavigation after the switch                <br>
    *           2. Republish when linkState is 'inactive'. <br>
    *              Even if the SBO does not support inactivate/activate of its <br>
    *              targets it does publish linksstate ('inactive') by itself and<br>
    *              may be inactivated by its source, so we need to make sure that <br>
    *              visual objects that are activated also activates source links.
    */
   public void linkState(final character _pcState)
   {
      character pcState = TypeFactory.initInput(_pcState);
      character cNavSource = TypeFactory.character();
      handle hNavSource = TypeFactory.handle();
      character cObjectName = TypeFactory.character();
      handle hNavTarget = TypeFactory.handle();
      character cMapping = TypeFactory.character();
      logical lOnHide = TypeFactory.logical();
      character cHandle = TypeFactory.character();
      logical lQueryObject = TypeFactory.logical();
      character cNavTarget = TypeFactory.character();
      character cNavDataTargets = TypeFactory.character();
      integer iNumTargets = TypeFactory.integer();
      handle hDataTarget = TypeFactory.handle();
      integer iPage = TypeFactory.integer();
      character cPageList = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         /* Check if it's from the outside */
         cHandle.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", valueOf(sourceProcedure()), cMapping, true, ","));
         
         /* delimiter */
         /*
           _* Check if we are supposed to toggle DataTarget links active/inactive *_ 
             {get ToggleDataTargets lToggleTargets}.
             IF NOT lTofggleTargerts THEN RETURN.
             DEFINE VARIABLE lToggleTargets   AS LOGICAL    NO-UNDO.
              */
         /* Outside caller */
         if (_isNotEqual(cHandle, ""))
         {
            ghProp.assign(handle.fromString(entry(1, sourceProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
            lQueryObject.assign(ghProp.unwrapBufferField().value());
            
            if (_not(lQueryObject))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("NavigationSource"));
               cNavSource.assign(ghProp.unwrapBufferField().value());
               
               if (_isEqual(numEntries(cNavSource), 1))
               {
                  /* Get the object the NavigationSource is mapped to in order to 
                             get that object's DataTargets to keep track of their pages. 
                             The mapping of the NavigationSource is not replaced down 
                             below if the DataTargets of the replacement are on the same page 
                             as this object's DataTargets. */
                  cNavTarget.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", cNavSource, cMapping, true, ","));
                  /* Get the mapped objects for the Navigation Target */
                  cNavDataTargets.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", cNavTarget, cMapping, false, ","));
                  
                  loopLabel30:
                  for (iNumTargets.assign(1); _isLessThanOrEqual(iNumTargets, numEntries(cNavDataTargets)); iNumTargets.increment())
                  {
                     /* Skip the NavigationSource mapped entry, it is not a data target */
                     if (_isEqual(entry(iNumTargets, cNavDataTargets), cNavSource))
                     {
                        continue loopLabel30;
                     }
                     
                     hDataTarget.assign(handle.fromString(entry(iNumTargets, cNavDataTargets)));
                     ghProp.assign(handle.fromString(entry(1, hDataTarget.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectPage"));
                     iPage.assign(ghProp.unwrapBufferField().value());
                     cPageList.assign(concat(cPageList, (_isGreaterThan(numEntries(cPageList), 0) ? new character(",") : new character("")), valueOf(iPage)));
                  }
                  
                  /* do iNumTargets 1 to number of targets */
                  hNavSource.assign(handle.fromString(cNavSource));
                  /* {get Prop var [handle]} */
                  cObjectName.assign(ControlFlowOps.invokeDynamicFunctionIn("getNavigationTargetName", hNavSource));
                  /* {get Prop var [handle]} */
                  lOnHide.assign(ControlFlowOps.invokeDynamicFunctionIn("getDeactivateTargetOnHide", hNavSource));
                  
                  if (_and(or(isEqual(pcState, "active"), lOnHide), () -> or(isEqual(cObjectName, ""), () -> isUnknown(cObjectName))))
                  {
                     /* use no-error, since a pass-thru container may get here */
                     /* {get Prop var [handle]} */
                     silent(() -> cObjectName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdateTargetNames", sourceProcedure())));
                     
                     if (_or(isEqual(cObjectName, ""), () -> isUnknown(cObjectName)))
                     {
                        silent(() -> 
                        {
                           ghProp.assign(handle.fromString(entry(1, sourceProcedure().unwrapADMData().getADMData(), chr(1))));
                           ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
                           cObjectName.assign(ghProp.unwrapBufferField().value());
                        });
                     }
                     /* {get Prop var [handle]} */ 
                     
                     if (_isGreaterThan(cObjectName, ""))
                     {
                        cObjectName.assign(entry(1, cObjectName));
                        hNavTarget /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", cObjectName));
                        /* Get the data targets of the object about to be mapped to 
                                       the NavigationSource, only change the mapping if one of the
                                       data target objects is on a different page than the data target
                                       objects of the object that is already mapped */
                        cNavDataTargets.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", valueOf(hNavTarget), cMapping, false, ","));
                        
                        IntegerExpression resExpr22 = new IntegerExpression()
                        {
                           public integer execute()
                           {
                              return numEntries(cNavDataTargets);
                           }
                        };
                        ToClause toClause23 = new ToClause(iNumTargets, 1, resExpr22);
                        
                        doTo("loopLabel31", toClause23, new Block((Body) () -> 
                        {
                           if (_isEqual(entry(iNumTargets, cNavDataTargets), cNavSource))
                           {
                              next("loopLabel31");
                           }
                           
                           hDataTarget.assign(handle.fromString(entry(iNumTargets, cNavDataTargets)));
                           ghProp.assign(handle.fromString(entry(1, hDataTarget.unwrapADMData().getADMData(), chr(1))));
                           ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectPage"));
                           iPage.assign(ghProp.unwrapBufferField().value());
                           
                           if (_isEqual(lookup(valueOf(iPage), cPageList), 0))
                           {
                              cMapping.replaceEntry(plus(lookup(valueOf(hNavSource), cMapping), 1), valueOf(hNavTarget));
                              ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                              ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
                              ghProp.unwrapBufferField().changeValue(cMapping);
                              ControlFlowOps.invokeIn("resetNavigation", hNavSource);
                           }
                        }));
                     }
                  }
               }
            }
            
            /* not queryobject */
            if (_isEqual(pcState, "active"))
            {
               NamedEventManager.publish("linkState", targetProcedure(), "I", new Object[]
               {
                  "active"
               });
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void linkStateHandler(final character _pcState, final handle _phObject_1, final character _pcLink)
   {
      character pcState = TypeFactory.initInput(_pcState);
      handle phObject_1 = TypeFactory.initInput(_phObject_1);
      character pcLink = TypeFactory.initInput(_pcLink);
      character cInactiveLinks = TypeFactory.character();
      logical lDataInactive = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_and(isEqual(pcState, "active"), () -> isEqual(pcLink, "DataSource")))
         {
            ghProp.assign(handle.fromString(entry(1, phObject_1.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("InactiveLinks"));
            cInactiveLinks.assign(ghProp.unwrapBufferField().value());
            
            if (_not(matchesList(cInactiveLinks, "DataSource")))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("InactiveLinks"));
               cInactiveLinks.assign(ghProp.unwrapBufferField().value());
               lDataInactive.assign(matchesList(cInactiveLinks, "DataSource"));
            }
         }
         ControlFlowOps.runSuper("linkStateHandler", pcState, phObject_1, pcLink);
         
         if ((lDataInactive).booleanValue())
         {
            ghTargetProcedure.assign(phObject_1);
            ControlFlowOps.invokeInWithMode("dataAvailable", targetProcedure(), "I", new character("RESET"));
            ghTargetProcedure.setUnknown();
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     This procedure is run at the end of createObjects, after all<br>
    *              contained Objects have been created (but not initialized).<br>
    *              It sets various properties that are dependent on knowing<br>
    *              the handles and Instance Properties of all contained objects,<br>
    *              and also fetches property settings from the server-side SBO.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:       This is a new "hook" as of 9.1B, run from createObjects<br>
    *              after adm-create-objects.
    */
   public void postCreateObjects()
   {
      character cTargets = TypeFactory.character();
      integer iTarget = TypeFactory.integer();
      handle hTarget = TypeFactory.handle();
      logical lQuery = TypeFactory.logical();
      character cDataColumns = TypeFactory.character();
      character cContainedColumns = TypeFactory.character();
      character cContainedObjects = TypeFactory.character("");
      character cObjectName = TypeFactory.character();
      character cDonames = TypeFactory.character();
      character cSbodataColumns = TypeFactory.character();
      integer iColumn = TypeFactory.integer();
      handle hSource = TypeFactory.handle();
      handle hMdo = TypeFactory.handle();
      character cDoname = TypeFactory.character();
      integer iEntry = TypeFactory.integer();
      character cOrdering = TypeFactory.character();
      character cAsDivision = TypeFactory.character();
      logical lOpenOnInit = TypeFactory.logical();
      logical lDynamicData = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
         cTargets.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         cDonames.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectNames", targetProcedure()));
         
         /* This is the Instance Property */
         /* if it's been explicitly set, then build the list of handles in the
              same order; the master is the first SDO in the list. */
         if (_isNotEqual(cDonames, ""))
         {
            loopLabel32:
            for (iEntry.assign(1); _isLessThanOrEqual(iEntry, numEntries(cDonames)); iEntry.increment())
            {
               cDoname.assign(entry(iEntry, cDonames));
               
               loopLabel33:
               for (iTarget.assign(1); _isLessThanOrEqual(iTarget, numEntries(cTargets)); iTarget.increment())
               {
                  hTarget.assign(handle.fromString(entry(iTarget, cTargets)));
                  ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
                  cObjectName.assign(ghProp.unwrapBufferField().value());
                  
                  if (_isEqual(cObjectName, cDoname))
                  {
                     break loopLabel33;
                  }
               }
               
               /* END DO iTarget -- searching for ObjectName match */
               if (_isEqual(iEntry, 1))
               {
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
                  ghProp.unwrapBufferField().changeValue(hTarget);
               }
               /* {set Prop value [handle]} */ 
               
               cContainedObjects.assign(concat(cContainedObjects, (_isEqual(cContainedObjects, "") ? new character("") : new character(",")), valueOf(hTarget)));
            }
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerTarget"));
            cTargets.assign(ghProp.unwrapBufferField().value());
            
            IntegerExpression resExpr23 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cTargets);
               }
            };
            ToClause toClause24 = new ToClause(iTarget, 1, resExpr23);
            
            doTo("loopLabel34", toClause24, new Block((Body) () -> 
            {
               hTarget.assign(handle.fromString(entry(iTarget, cTargets)));
               silent(() -> 
               {
                  ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                  lQuery.assign(ghProp.unwrapBufferField().value());
               });
               
               if ((lQuery).booleanValue())
               {
                  /* First locate the 'master' -- with no Data-Source. */
                  /* {get Prop var [handle]} */
                  hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hTarget));
                  
                  if (_isUnknown(hSource))
                  {
                     hMdo.assign(hTarget);
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
                     ghProp.unwrapBufferField().changeValue(hMdo);
                     leave("loopLabel34");
                  }
 /* This one has no Data-Source. */;
               }
               /* QueryObject is considered the definition of an SDO. */
            }));
            
            /* END DO iTarget -- initial search for Master DO */
            /* Now start with the Master DataObject and built a list of its 
                   DataTargets, recursing as necessary. */
            if ((hMdo.isValid()).booleanValue())
            {
                /* Could be ? if no SDOs at all */appendContainedObjects(wrap(cContainedObjects, true), hMdo);
            }
            
            IntegerExpression resExpr24 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cTargets);
               }
            };
            ToClause toClause25 = new ToClause(iTarget, 1, resExpr24);
            
            doTo("loopLabel35", toClause25, new Block((Body) () -> 
            {
               hTarget.assign(handle.fromString(entry(iTarget, cTargets)));
               silent(() -> 
               {
                  ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                  lQuery.assign(ghProp.unwrapBufferField().value());
               });
               
               if (_and(lQuery, () -> isEqual(lookup(valueOf(hTarget), cContainedObjects), 0)))
               {
                  appendContainedObjects(wrap(cContainedObjects, true), hTarget);
               }
            }));
            
            loopLabel36:
            for (iTarget.assign(1); _isLessThanOrEqual(iTarget, numEntries(cContainedObjects)); iTarget.increment())
            {
               hTarget.assign(handle.fromString(entry(iTarget, cContainedObjects)));
               ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
               cDoname.assign(ghProp.unwrapBufferField().value());
               cDonames.assign(concat(cDonames, (_isEqual(cDonames, "") ? new character("") : new character(",")), cDoname));
            }
            
            /* END DO iTarget == each contained object */
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode("setDataObjectNames", targetProcedure(), "I", cDonames);
         }
         /* END ELSE DO If ObjectNames not yet set. */
         /* Subscribe the SBO to all SDO events that are intended for objects linked
              to the SBO. 
              Also ensure that AppServer properties are correct */
         /* {get Prop var [handle]} */ 
         cAsDivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAsDivision", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("OpenOnInit"));
         lOpenOnInit.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr25 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cContainedObjects);
            }
         };
         ToClause toClause26 = new ToClause(iTarget, 1, resExpr25);
         
         doTo("loopLabel37", toClause26, new Block((Body) () -> 
         {
            cObjectName.assign(entry(iTarget, cDonames));
            hTarget.assign(handle.fromString(entry(iTarget, cContainedObjects)));
            cDataColumns.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDataColumns", hTarget));
            cContainedColumns.assign(concat(cContainedColumns, (_isNotEqual(cContainedColumns, "") ? new character(";") : new character("")), cDataColumns));
            
            loopLabel38:
            for (iColumn.assign(1); _isLessThanOrEqual(iColumn, numEntries(cDataColumns)); iColumn.increment())
            {
               cSbodataColumns.assign(concat(cSbodataColumns, (_isNotEqual(cSbodataColumns, "") ? new character(",") : new character("")), cObjectName, ".", entry(iColumn, cDataColumns)));
            }
            
            ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("OpenOnInit"));
            ghProp.unwrapBufferField().changeValue(lOpenOnInit);
            /* No AppService for contained SDOs */
            /* {set Prop value [handle]} */
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setAppService", hTarget, "I", "");
            /* The logic in data.i that sets 'server' when source-procedure = ? is 
                     not correct when the SDOs are started from this SBO object, so we copy 
                     AsDivision to the SDOs. */
            /* {set Prop value [handle]} */
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setAsDivision", hTarget, "I", cAsDivision);
            ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("AutoCommit"));
            ghProp.unwrapBufferField().changeValue(new logical(false));
            NamedEventManager.subscribe(targetProcedure(), "dataAvailable", hTarget);
            NamedEventManager.subscribe(targetProcedure(), "queryPosition", hTarget);
            NamedEventManager.subscribe(targetProcedure(), "updateState", hTarget);
            NamedEventManager.subscribe(targetProcedure(), "assignMaxGuess", hTarget);
            NamedEventManager.subscribe(targetProcedure(), "deleteComplete", hTarget);
            NamedEventManager.subscribe(targetProcedure(), "refreshBrowse", hTarget);
            NamedEventManager.subscribe(targetProcedure(), "cancelNew", hTarget);
            NamedEventManager.subscribe(targetProcedure(), "linkState", hTarget);
            NamedEventManager.subscribe(targetProcedure(), "isUpdatePending", hTarget);
         }));
         
         /* END DO iTarget */
         /* Set the SBO's property based on whether there's a CommitSource, 
              just as an SDO would do.  */
         /* {get Prop var [handle]} */ 
         hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getCommitSource", targetProcedure()));
         
         if (_isUnknown(hSource))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("AutoCommit"));
            ghProp.unwrapBufferField().changeValue(new logical(true));
         }
         /* {set Prop value [handle]} */ 
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         ghProp.unwrapBufferField().changeValue(cContainedObjects);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataColumns"));
         ghProp.unwrapBufferField().changeValue(cContainedColumns);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataColumns"));
         ghProp.unwrapBufferField().changeValue(cSbodataColumns);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DynamicData"));
         lDynamicData.assign(ghProp.unwrapBufferField().value());
         
         if (_not(lDynamicData))
         {
            cOrdering.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "initDataObjectOrdering", targetProcedure()));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataObjectOrdering"));
            ghProp.unwrapBufferField().changeValue(cOrdering);
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    *   Purpose:    Prepare the object and retrieve all info for a stateless server<br>
    *               request.     <br>
    *   Parameters: <br>
    *     phTopContainer Handle of the container that manages the request <br>
    *     pcAppService   AppService of this request      <br>
    *     pcSourceName   Qualified DataSource name<br>
    *                    Blank if this is the top level in this request.<br>
    *                    For a 'POSITION' request the position information is <br>
    *                    appended. <br>
    *                    <br>
    *     pcOptions      Options for this request         <br>
    *                    - 'INIT', initialization, used to skip DataObjects where <br>
    *                       OpenOnInit is false.<br>
    *                    - 'BATCH', request for another batch, tells prepareForFetch<br>
    *                      to keep the temp-table.        <br>
    *                    - 'POSITION', Not supported for SBOs<br>
    *                                  (cannot be source for an SDF)<br>
    * i-o pcHandles      Data object handle, comma-separated <br>
    * i-o pcRunNames     Name that the server can use to start the object, comma-separated. Currently the physical name only.<br>
    * i-o pcQualNames    [ContainerName: [Containername:].. InstanceName, comma-separated<br>
    *                    Passed to server to be able to set context in correct objects<br>
    * i-o pcQueryFields  Contains ForeignField information and position information<br>
    * i-o pcQueries      QueryString, chr(1)-separated.<br>
    * i-o pcTempTables   Temp-table handles. comma-separated                     <br>
    *   Notes:
    */
   public void prepareDataForFetch(final handle _phTopContainer, final character _pcAppService, final character _pcSourceName, final character _pcOptions, final character pcHandles, final character pcPhysicalNames, final character pcQualNames, final character pcForeignFields, final character pcQueries, final character pcTables)
   {
      handle phTopContainer = TypeFactory.initInput(_phTopContainer);
      character pcAppService = TypeFactory.initInput(_pcAppService);
      character pcSourceName = TypeFactory.initInput(_pcSourceName);
      character pcOptions = TypeFactory.initInput(_pcOptions);
      character cContained = TypeFactory.character();
      character cObjectName = TypeFactory.character();
      character cAllQueries = TypeFactory.character();
      character cTtList = TypeFactory.character();
      handle hContainerSource = TypeFactory.handle();
      character cContainerName = TypeFactory.character();
      character cQualName = TypeFactory.character();
      character cForeignFields = TypeFactory.character();
      character cPhysicalName = TypeFactory.character();
      logical lFirst = TypeFactory.logical();
      character cTargets = TypeFactory.character();
      handle hTarget = TypeFactory.handle();
      integer iTarget = TypeFactory.integer();
      logical lQuery = TypeFactory.logical();
      character cAppService = TypeFactory.character();
      logical lOpenOnInit = TypeFactory.logical();
      character cInactiveLinks = TypeFactory.character();
      character cContainerType = TypeFactory.character();
      logical lVisualTargets = TypeFactory.logical();
      logical lInit = TypeFactory.logical();
      handle hSdo = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      integer iLoop = TypeFactory.integer();
      logical lSkip = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cAppService.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getAppService", targetProcedure()));
         
         if (_and(notUnknown(pcAppService), () -> isNotEqual(cAppService, pcAppService)))
         {
            returnNormal();
         }
         
         /* An SBO cannot be source for a SmartSelect, so there should not be a 
             position request, but just in case ) */
         if (_isGreaterThan(lookup("POSITION", pcOptions), 0))
         {
            returnNormal();
         }
         
         lInit.assign(isGreaterThan(lookup("INIT", pcOptions), 0));
         lVisualTargets.assign(isGreaterThan(lookup("VISUALTARGETS", pcOptions), 0));
         
         /* Return or set Skip flag if this is initialization and OpenOnInit is false 
             (the skip falg is set if we need to get the rowObject defintion from server)*/
         if ((lInit).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("OpenOnInit"));
            lOpenOnInit.assign(ghProp.unwrapBufferField().value());
            
            if (_not(lOpenOnInit))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
               cContained.assign(ghProp.unwrapBufferField().value());
               
               IntegerExpression resExpr26 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(cContained);
                  }
               };
               ToClause toClause27 = new ToClause(iLoop, 1, resExpr26);
               
               doTo("loopLabel39", toClause27, new Block((Body) () -> 
               {
                  hSdo.assign(handle.fromString(entry(iLoop, cContained)));
                  
                  if ((hSdo.isValid()).booleanValue())
                  {
                     /* {get Prop var [handle]} */
                     hRowObject.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObject", hSdo));
                  }
                  
                  if (_not(hRowObject.isValid()))
                  {
                     lSkip.assign(true);
                     leave("loopLabel39");
                  }
               }));
               
               if (_not(lSkip))
               {
                  returnNormal();
               }
            }
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("Inactivelinks"));
         cInactiveLinks.assign(ghProp.unwrapBufferField().value());
         
         if (_and(isGreaterThan(lookup("DataSource", cInactiveLinks), 0), not(lSkip)))
         {
            returnNormal();
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
         hContainerSource.assign(ghProp.unwrapBufferField().value());
         
         loopLabel40:
         while (_isNotEqual(hContainerSource, phTopContainer))
         {
            ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
            cContainerName.assign(ghProp.unwrapBufferField().value());
            cQualName.assign(concat(cContainerName, (_isEqual(cQualName, "") ? new character("") : new character(":")), cQualName, (_isEqual(cQualName, "") ? new character(":") : new character(""))));
            ghProp.assign(handle.fromString(entry(1, hContainerSource.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
            hContainerSource.assign(ghProp.unwrapBufferField().value());
            
            if (_isUnknown(hContainerSource))
            {
               returnNormal();
            }
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
         cObjectName.assign(ghProp.unwrapBufferField().value());
         cQualName.assign(concat(cQualName, cObjectName));
         
         if (_not(lVisualTargets))
         {
            ControlFlowOps.invokeInWithMode("prepareQueriesForFetch", targetProcedure(), "IIOO", new unknown(), _isGreaterThan(pcSourceName, "") ? new character("ParentIsChild") : _isGreaterThan(lookup("BATCH", pcOptions), 0) ? new character("EmptyChildren") : new character(""), cAllQueries, cTtList);
            
            /* Set query entries to 'skip' if openoninit false, but undefined dynsdo
                  found */
            if ((lSkip).booleanValue())
            {
               loopLabel41:
               for (iLoop.assign(1); _isLessThanOrEqual(iLoop, numEntries(cAllQueries, chr(1))); iLoop.increment())
               {
                  cAllQueries.replaceEntry(iLoop, chr(1), "SKIP");
               }
            }
            
            if (_begins(ControlFlowOps.getReturnValue(), "ADM-ERROR"))
            {
               returnNormal(ControlFlowOps.getReturnValue());
            }
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
            cContained.assign(ghProp.unwrapBufferField().value());
            
            if (_and(notUnknown(pcSourceName), () -> isNotEqual(pcSourceName, "")))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignFields"));
               cForeignFields.assign(ghProp.unwrapBufferField().value());
               cForeignFields.assign(concat(pcSourceName, ",", cForeignFields));
            }
            
            /* Will use LogicalObjectName for repository objectws in the future */
            /* {get Prop var [handle]} */ 
            cPhysicalName.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getServerFileName", targetProcedure()));
            lFirst.assign(isEqual(pcHandles, ""));
            pcHandles.assign(concat(pcHandles, ((lFirst).booleanValue() ? new character("") : new character(",")), cContained));
            pcQueries.assign(concat(pcQueries, ((lFirst).booleanValue() ? new character("") : chr(1)), cAllQueries));
            pcTables.assign(concat(pcTables, ((lFirst).booleanValue() ? new character("") : new character(",")), cTtList));
            pcQualNames.assign(concat(pcQualNames, ((lFirst).booleanValue() ? new character("") : new character(",")), cQualName, fill(",", minus(numEntries(cContained), 1))));
            pcPhysicalNames.assign(concat(pcPhysicalNames, ((lFirst).booleanValue() ? new character("") : new character(",")), cPhysicalName, fill(",", minus(numEntries(cContained), 1))));
            pcForeignFields.assign(concat(pcForeignFields, ((lFirst).booleanValue() ? new character("") : chr(1)), cForeignFields, fill(chr(1), minus(numEntries(cContained), 1))));
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
         cTargets.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr27 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cTargets);
            }
         };
         ToClause toClause28 = new ToClause(iTarget, 1, resExpr27);
         
         doTo("loopLabel42", toClause28, new Block((Body) () -> 
         {
            hTarget.assign(handle.fromString(entry(iTarget, cTargets)));
            lQuery.assign(false);
            ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
            lQuery.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, hTarget.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerType"));
            cContainerType.assign(ghProp.unwrapBufferField().value());
            
            if ((lQuery).booleanValue())
            {
               /* prepare data object data targets */
               ControlFlowOps.invokeInWithMode("prepareDataForFetch", hTarget, "IIIIUUUUUU", phTopContainer, _isUnknown(pcAppService) ? cAppService : pcAppService, cQualName, pcOptions, pcHandles, pcPhysicalNames, pcQualNames, pcForeignFields, pcQueries, pcTables);
            }
            else
            {
               if (_and(lVisualTargets, () -> isGreaterThan(cContainerType, "")))
               {
                  /* prepare Visual container targets 
                             -> prepare position info for their SDF data Sources    */
                  ControlFlowOps.invokeInWithMode("prepareDataForFetch", hTarget, "IIIIUUUUUU", phTopContainer, _isUnknown(pcAppService) ? cAppService : pcAppService, cQualName, concat("POSITION", (lInit).booleanValue() ? new character(",INIT") : new character("")), pcHandles, pcPhysicalNames, pcQualNames, pcForeignFields, pcQueries, pcTables);
               }
            }
         }));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  This appends the RETURN-VALUE from the user-defined transaction<br>
    *           validation procedure or other update-related error to the list<br>
    *           of any errors already in the log, and formats this string to<br>
    *           prepare for returning it to the client.<br>
    *   Notes:  invoked internally from serverCommitTransaction.
    */
   public void prepareErrorsForReturn(final character _pcReturnValue, final character _pcAsdivision, final character pcMessages)
   {
      character pcReturnValue = TypeFactory.initInput(_pcReturnValue);
      character pcAsdivision = TypeFactory.initInput(_pcAsdivision);
      
      internalProcedure(new Block((Body) () -> 
      {
         if (_isNotEqual(pcReturnValue, ""))
         {
            ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III", pcReturnValue, new unknown(), new unknown());
         }
         
         if (_isEqual(pcAsdivision, "Server"))
         {
            pcMessages.assign(leftTrim(concat(pcMessages, chr(3), ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure())), chr(3)));
         }
         
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    *    Purpose: Prepare the Queries in the SDOs for a fetch of data from the <br>
    *             server.   <br>
    * Parameters: <br>
    *     INPUT pcOptions char <br>
    *           Option. <br>
    *           - 'EmptyChildren' - empty temp-tables for chidren.<br>
    *           -  Note that the default behavior has been changed to empty temp-tables<br>
    *              for all SDOs. (as this is more efficient than the implicit delete<br>
    *              that happens in output table-handle).   <br>
    *              So the 'EmptyChildren' now really means keep the parent temp-table.                                <br>
    *     OUTPUT pocQueries <br>
    *             A CHR(1) delimited list that corrsponds to ContainedDataObjects with<br>
    *             the Query expressions to pass to the server in the call to fetch new <br>
    *             temp-tables. A 'SKIP' is used as the entry for the objects that are <br>
    *             not part of this request, while a blank entry indicates that the <br>
    *             server should use the base query. <br>
    *     OUTPUT pocTempTables <br>
    *             A comma separatedf list The temp-table handle. '?' for objects that are not part <br>
    *             of the fetch we are preparing for.  <br>
    *     Notes:  This procedure exists in order to have common logic for <br>
    *             fetchContainedData and fetchContainedRows. This logic is a bit <br>
    *             complex and are also very likely to change. <br>
    *          -  A manually changed setQueryWhere is always used. This may have <br>
    *             very weird results if done for a new batch ..... It is considered <br>
    *             to be a user error to setQueryWhere without an immediate openQuery <br>
    *             if the object is batched. <br>
    * Note date: 2002/02/14
    */
   public void prepareQueriesForFetch(final character _pcObjectName_2, final character _pcOptions, final character pocQueries, final character poctempTables)
   {
      character pcObjectName_2 = TypeFactory.initInput(_pcObjectName_2);
      character pcOptions = TypeFactory.initInput(_pcOptions);
      character cDataObjectHandles = TypeFactory.character();
      integer iStartOnSdo = TypeFactory.integer();
      character cSdonames = TypeFactory.character();
      integer iSdo = TypeFactory.integer();
      handle hSdo = TypeFactory.handle();
      character cQuery = TypeFactory.character();
      handle hTempTable = TypeFactory.handle();
      character cMode = TypeFactory.character();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pocQueries);
         TypeFactory.initOutput(poctempTables);
      }, 
      (Body) () -> 
      {
         if (_and(isNotEqual(pcObjectName_2, ""), () -> notUnknown(pcObjectName_2)))
         {
            /* {get Prop var [handle]} */ 
            cSdonames.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectNames", targetProcedure()));
            iStartOnSdo.assign(lookup(pcObjectName_2, cSdonames));
            
            if (_isEqual(iStartOnSdo, 0))
            {
               /* {fnarg <func-name> <arg> [handle] */ 
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", substitute(new character(ControlFlowOps.invokeDynamicFunctionInWithMode("mesageNumber", targetProcedure(), "I", 71)), pcObjectName_2, "prepareQueriesforFetch"));
               returnNormal("ADM-ERROR");
            }
         }
         else
         {
            iStartOnSdo.assign(1);
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cDataObjectHandles.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr28 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cDataObjectHandles);
            }
         };
         ToClause toClause29 = new ToClause(iSdo, 1, resExpr28);
         
         doTo("loopLabel43", toClause29, new Block((Body) () -> 
         {
            /* If the caller requested to start at a specific SDO, then set
                   all prior handles to ? and signal not to use them. */
            if (_isGreaterThan(iStartOnSdo, iSdo))
            {
               hTempTable.setUnknown();
               cQuery.assign("SKIP");
            }
            else
            {
               hSdo.assign(handle.fromString(entry(iSdo, cDataObjectHandles)));
               
               /* If 'EmptyChildren' and we're not yet at a child then pass 'Batch' 
                       (keep TT and batch properties) */
               if (_and(matchesList(pcOptions, "EmptyChildren"), () -> isEqual(iSdo, iStartOnSdo)))
               {
                  cMode.assign("Batch");
               }
               else
               {
                  if (_or(matchesList(pcOptions, "ParentIsChild"), () -> isGreaterThan(iSdo, iStartOnSdo)))
                  {
                     cMode.assign("Child");
                  }
                  else
                  {
                     cMode.assign("");
                  }
               }
               cQuery /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "prepareForFetch", hSdo, "I", cMode));
               /* {get Prop var [handle]} */
               hTempTable.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
            }
            pocQueries.assign(concat(pocQueries, (_isGreaterThan(iSdo, 1) ? chr(1) : new character("")), cQuery));
            poctempTables.assign(concat(poctempTables, (_isGreaterThan(iSdo, 1) ? new character(",") : new character("")), ((hTempTable.isValid()).booleanValue() ? valueOf(hTempTable) : new character("?"))));
         }));
         
         /* do iSDO = 1 to  */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void processOpenCall(final character _pcMode_1, final character _pcColumnNames_1, final character _pcOldValues, final character pcNewValues, final character pcError)
   {
      character pcMode_1 = TypeFactory.initInput(_pcMode_1);
      character pcColumnNames_1 = TypeFactory.initInput(_pcColumnNames_1);
      character pcOldValues = TypeFactory.initInput(_pcOldValues);
      integer iCount = TypeFactory.integer();
      integer iCount2 = TypeFactory.integer();
      logical lAutoCommit = TypeFactory.logical();
      character cSdonames = TypeFactory.character();
      character cDataDelimiter = TypeFactory.character();
      handle hSdo = TypeFactory.handle();
      character cSdo = TypeFactory.character();
      character cColumn = TypeFactory.character();
      character cColumnList = TypeFactory.character();
      character cNewList = TypeFactory.character();
      character cOldList = TypeFactory.character();
      character cError = TypeFactory.character();
      character cPosList = TypeFactory.character();
      logical lErrors = TypeFactory.logical();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcError);
      }, 
      (Body) () -> 
      {
         /* Make sure that column names are properly qualified. This means that */
         /* either the first column ONLY is qualified or ALL are qualified */
         if (_isEqual(isColumnListQualified(pcColumnNames_1), false))
         {
            pcError.assign("Column Names are not properly qualified with SDO name");
            returnNormal();
         }
         
         /* if all columns are qualified then process one SDO at a time  */
         if (_isGreaterThan(numEntries(pcColumnNames_1, "."), 2))
         {
            /* {get Prop var [handle]} */ 
            cSdonames.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectNames", targetProcedure()));
            
            IntegerExpression resExpr29 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cSdonames);
               }
            };
            ToClause toClause30 = new ToClause(iCount, 1, resExpr29);
            
            doTo("loopLabel44", toClause30, new Block((Body) () -> 
            {
               cSdo.assign(entry(iCount, cSdonames));
               hSdo /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", cSdo));
               cColumnList.assign("");
               cNewList.assign("");
               cOldList.assign("");
               cPosList.assign("");
               /* {get Prop var [handle]} */
               cDataDelimiter.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDataDelimiter", hSdo));
               
               loopLabel45:
               for (iCount2.assign(1); _isLessThanOrEqual(iCount2, numEntries(pcColumnNames_1)); iCount2.increment())
               {
                  cColumn.assign(entry(iCount2, pcColumnNames_1));
                  
                  if (_isEqual(entry(1, cColumn, "."), cSdo))
                  {
                     cColumnList.assign(concat(cColumnList, (_isEqual(cColumnList, "") ? new character("") : new character(",")), entry(2, cColumn, ".")));
                     
                     switch (StringHelper.safeTrimTrailing((pcMode_1).toStringMessage()).toUpperCase())
                     {
                        case "CREATE":
                           {
                              cNewList.assign(concat(cNewList, (_isEqual(numEntries(cNewList, cDataDelimiter), 0) ? new character("") : cDataDelimiter), entry(iCount2, pcNewValues, cDataDelimiter)));
                              cPosList.assign(concat(cPosList, (_isEqual(numEntries(cPosList, cDataDelimiter), 0) ? new character("") : new character(",")), valueOf(iCount2)));
                           }
                           break;
                        case "DELETE":
                           {
                              cOldList.assign(concat(cOldList, (_isEqual(numEntries(cOldList, cDataDelimiter), 0) ? new character("") : cDataDelimiter), entry(iCount2, pcOldValues, cDataDelimiter)));
                           }
                           break;
                        case "UPDATE":
                           {
                              cNewList.assign(concat(cNewList, (_isEqual(numEntries(cNewList, cDataDelimiter), 0) ? new character("") : cDataDelimiter), entry(iCount2, pcNewValues, cDataDelimiter)));
                              cPosList.assign(concat(cPosList, (_isEqual(numEntries(cPosList, cDataDelimiter), 0) ? new character("") : new character(",")), valueOf(iCount2)));
                              cOldList.assign(concat(cOldList, (_isEqual(numEntries(cOldList, cDataDelimiter), 0) ? new character("") : cDataDelimiter), entry(iCount2, pcOldValues, cDataDelimiter)));
                           }
                           break;
                     }
                  }
               }
               
               /* DO iCount2 */
               if (_isGreaterThan(cColumnList, ""))
               {
 /* post data if we have columns for current sdo */
                  switch (StringHelper.safeTrimTrailing((pcMode_1).toStringMessage()).toUpperCase())
                  {
                     case "CREATE":
                        {
                           ControlFlowOps.invokeInWithMode("createData", hSdo, "IUO", cColumnList, cNewList, cError);
                           
                           loopLabel46:
                           for (iCount2.assign(1); _isLessThanOrEqual(iCount2, numEntries(cPosList)); iCount2.increment())
                           {
                              pcNewValues.replaceEntry(new integer(entry(iCount2, cPosList)), cDataDelimiter, entry(iCount2, cNewList, cDataDelimiter));
                           }
                        }
                        break;
                     case "DELETE":
                        {
                           ControlFlowOps.invokeInWithMode("deleteData", hSdo, "IIO", cColumnList, cOldList, cError);
                        }
                        break;
                     case "UPDATE":
                        {
                           ControlFlowOps.invokeInWithMode("updateData", hSdo, "IIUO", cColumnList, cOldList, cNewList, cError);
                           
                           loopLabel47:
                           for (iCount2.assign(1); _isLessThanOrEqual(iCount2, numEntries(cPosList)); iCount2.increment())
                           {
                              pcNewValues.replaceEntry(new integer(entry(iCount2, cPosList)), cDataDelimiter, entry(iCount2, cNewList, cDataDelimiter));
                           }
                        }
                        break;
                  }
               }
               lErrors.assign(or(lErrors, () -> isGreaterThan(cError, "")));
               
               if (_isEqual(iCount, 1))
               {
                  pcError.assign(cError);
               }
               else
               {
                  pcError.assign(concat(pcError, ";", cError));
               }
            }));
            
            /* DO iCount1 */
            if (_not(lErrors))
            {
               pcError.assign("");
            }
         }
         else
         {
            cSdo.assign(entry(1, pcColumnNames_1, "."));
            hSdo /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", cSdo));
            pcColumnNames_1.assign(entry(2, pcColumnNames_1, "."));
            
            switch (StringHelper.safeTrimTrailing((pcMode_1).toStringMessage()).toUpperCase())
            {
               case "CREATE":
                  {
                     ControlFlowOps.invokeInWithMode("createData", hSdo, "IUO", pcColumnNames_1, pcNewValues, pcError);
                  }
                  break;
               case "DELETE":
                  {
                     ControlFlowOps.invokeInWithMode("deleteData", hSdo, "IIO", pcColumnNames_1, pcOldValues, pcError);
                  }
                  break;
               case "UPDATE":
                  {
                     ControlFlowOps.invokeInWithMode("updateData", hSdo, "IIUO", pcColumnNames_1, pcOldValues, pcNewValues, pcError);
                  }
                  break;
            }
         }
         
         if (_isGreaterThan(pcError, ""))
         {
            returnNormal();
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("AutoCommit"));
         lAutoCommit.assign(ghProp.unwrapBufferField().value());
         
         if ((lAutoCommit).booleanValue())
         {
            ControlFlowOps.invokeIn("commitTransaction", targetProcedure());
            
            if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
            {
               pcError /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()));
               /* clean-up temp tables to be ready for next request */
               ControlFlowOps.invokeIn("undoTransaction", targetProcedure());
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:    Receives the queryPosition event from a contained SDO and<br>
    *             passes it on to the appropriate Navigation-Source or other<br>
    *             object.<br>
    * Parameters: pcPosition AS CHARACTER<br>
    * Notes:      Sets the ghTargetProcedure so that the toolbar can recognize the <br>
    *             actual target instance .
    */
   public void queryPosition(final character _pcPosition)
   {
      character pcPosition = TypeFactory.initInput(_pcPosition);
      character cMapping = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      integer iObject = TypeFactory.integer();
      character cHandle = TypeFactory.character();
      character cSdonames = TypeFactory.character();
      character cSourceName = TypeFactory.character();
      character cSubscribed = TypeFactory.character();
      handle hNavTarget = TypeFactory.handle();
      handle hDataSource = TypeFactory.handle();
      logical lBlockQueryPosition = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("BlockQueryPosition"));
         lBlockQueryPosition.assign(ghProp.unwrapBufferField().value());
         
         if (_not(lBlockQueryPosition))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
            cMapping.assign(ghProp.unwrapBufferField().value());
            /* may be more than one match */
            cHandle.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", valueOf(sourceProcedure()), cMapping, false, ","));
            
            IntegerExpression resExpr30 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cHandle);
               }
            };
            ToClause toClause31 = new ToClause(iObject, 1, resExpr30);
            
            doTo("loopLabel48", toClause31, new Block((Body) () -> 
            {
               hObject.assign(handle.fromString(entry(iObject, cHandle)));
               
               if ((hObject.isValid()).booleanValue())
               {
                  hNavTarget.setUnknown();
                  hDataSource.setUnknown();
                  cSubscribed.assign("");
                  silent(() -> 
                  {
                     ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("NavigationTarget"));
                     hNavTarget.assign(ghProp.unwrapBufferField().value());
                  });
                  
                  if ((hNavTarget.isValid()).booleanValue())
                  {
                     if (_isEqual(hNavTarget, targetProcedure()))
                     {
                        /* {get Prop var [handle]} */
                        cSubscribed.assign(ControlFlowOps.invokeDynamicFunctionIn("getNavigationTargetEvents", hObject));
                     }
                  }
                  else
                  {
                     /* {get Prop var [handle]} */
                     silent(() -> hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hObject)));
                     
                     if (_and(hDataSource.isValid(), () -> isEqual(hDataSource, targetProcedure())))
                     {
                        ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceEvents"));
                        cSubscribed.assign(ghProp.unwrapBufferField().value());
                     }
                     /* {get Prop var [handle]} */ 
                  }
                  
                  if ((matchesList(cSubscribed, "queryPosition")).booleanValue())
                  {
                     cSdonames.assign("");
                     /* Currently we avoid passing QueryPosition to secondary or 
                                   not updatable tables in visual objects. Note that in the future 
                                   this will probably be dealt with in the visual object */
                     /* {get Prop var [handle]} */
                     silent(() -> cSdonames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdateTargetNames", hObject)));
                     
                     if (_or(isUnknown(cSdonames), () -> isEqual(cSdonames, "")))
                     {
                        silent(() -> 
                        {
                           ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                           ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
                           cSdonames.assign(ghProp.unwrapBufferField().value());
                        });
                     }
                     /* {get Prop var [handle]} */ 
                     
                     if (_and(notUnknown(cSdonames), () -> isNotEqual(cSdonames, "")))
                     {
                        ghProp.assign(handle.fromString(entry(1, sourceProcedure().unwrapADMData().getADMData(), chr(1))));
                        ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
                        cSourceName.assign(ghProp.unwrapBufferField().value());
                        
                        if (_isNotEqual(cSourceName, entry(1, cSdonames)))
                        {
                           next("loopLabel48");
                        }
                     }
                     /* cSDONames <> ? or <> ''  */
                     ghTargetProcedure.assign(targetProcedure());
                     silent(() -> ControlFlowOps.invokeInWithMode("queryPosition", hObject, "I", pcPosition));
                     ghTargetProcedure.setUnknown();
                  }
               }
            }));
         }
         /* END BlockQueryPosition */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:    Receives the refreshBrowse event from a contained SDO and<br>
    *             passes it on to the appropriate DataTarget.<br>
    * Notes:
    */
   public void refreshBrowse(final character _pcPosition)
   {
      character pcPosition = TypeFactory.initInput(_pcPosition);
      character cMapping = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      integer iObject = TypeFactory.integer();
      character cHandle = TypeFactory.character();
      character cSubscribed = TypeFactory.character();
      handle hDataSource = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         /* may be more than one match */
         cHandle.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", valueOf(sourceProcedure()), cMapping, false, ","));
         
         IntegerExpression resExpr31 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cHandle);
            }
         };
         ToClause toClause32 = new ToClause(iObject, 1, resExpr31);
         
         doTo("loopLabel49", toClause32, new Block((Body) () -> 
         {
            hObject.assign(handle.fromString(entry(iObject, cHandle)));
            
            if ((hObject.isValid()).booleanValue())
            {
               hDataSource.setUnknown();
               cSubscribed.assign("");
               /* {get Prop var [handle]} */
               silent(() -> hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hObject)));
               
               if (_and(hDataSource.isValid(), () -> isEqual(hDataSource, targetProcedure())))
               {
                  ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceEvents"));
                  cSubscribed.assign(ghProp.unwrapBufferField().value());
               }
               /* {get Prop var [handle]} */ 
               
               if ((matchesList(cSubscribed, "refreshBrowse")).booleanValue())
               {
                  silent(() -> ControlFlowOps.invokeIn("refreshBrowse", hObject));
               }
            }
         }));
         
         /* END DO iObject */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: Register objects in the ObjectMapping and other properties.            <br>
    *          This currently applies to navigationSources and Datatargets <br>
    *         (Currently we assume that updateSources also are DataTargets)          <br>
    * Notes:   This procedure is used to register objects that already were <br>
    *          initialized when the sbo is initialized. The sbo also subscribes <br>
    *          to 'registerObject' in these objects, which they publish at <br>
    *          initialization.
    */
   public void registerLinkedObjects()
   {
      character cObjects = TypeFactory.character();
      integer i = TypeFactory.integer();
      handle hObject = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NavigationSource"));
         cObjects.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr32 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cObjects);
            }
         };
         ToClause toClause33 = new ToClause(i, 1, resExpr32);
         
         doTo("loopLabel50", toClause33, new Block((Body) () -> 
         {
            hObject.assign(handle.fromString(entry(i, cObjects)));
            
            if ((hObject.isValid()).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("addNavigationSource", targetProcedure(), "I", hObject);
            }
         }));
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
         cObjects.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr33 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cObjects);
            }
         };
         ToClause toClause34 = new ToClause(i, 1, resExpr33);
         
         doTo("loopLabel51", toClause34, new Block((Body) () -> 
         {
            hObject.assign(handle.fromString(entry(i, cObjects)));
            
            if ((hObject.isValid()).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("addDataTarget", targetProcedure(), "I", hObject);
            }
         }));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: General purpose 'register' event published from objects at <br>
    *          initialization. This object defines this as navigationSourceEvent <br>
    *          and dataTargetEvent. The event is used to register objects in the <br>
    *          ObjectMapping and other properties. <br>
    *         (Currently we assume that updateSources also are DataTargets)<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void registerObject()
   {
      character cSource = TypeFactory.character();
      character cTarget = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NavigationSource"));
         cSource.assign(ghProp.unwrapBufferField().value());
         
         /* If this is a NavigationSource add it as such */
         if ((matchesList(cSource, valueOf(sourceProcedure()))).booleanValue())
         {
            ControlFlowOps.invokeInWithMode("addNavigationSource", targetProcedure(), "I", sourceProcedure());
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
            cTarget.assign(ghProp.unwrapBufferField().value());
            
            if ((matchesList(cTarget, valueOf(sourceProcedure()))).booleanValue())
            {
               ControlFlowOps.invokeInWithMode("addDataTarget", targetProcedure(), "I", sourceProcedure());
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void remoteCommitTransaction(final character pccontext, final TableParameter _phRowObjUpd1, final TableParameter _phRowObjUpd2, final TableParameter _phRowObjUpd3, final TableParameter _phRowObjUpd4, final TableParameter _phRowObjUpd5, final TableParameter _phRowObjUpd6, final TableParameter _phRowObjUpd7, final TableParameter _phRowObjUpd8, final TableParameter _phRowObjUpd9, final TableParameter _phRowObjUpd10, final TableParameter _phRowObjUpd11, final TableParameter _phRowObjUpd12, final TableParameter _phRowObjUpd13, final TableParameter _phRowObjUpd14, final TableParameter _phRowObjUpd15, final TableParameter _phRowObjUpd16, final TableParameter _phRowObjUpd17, final TableParameter _phRowObjUpd18, final TableParameter _phRowObjUpd19, final TableParameter _phRowObjUpd20, final character pcMessages, final character pcUndoIds)
   {
      handle phRowObjUpd1 = new handle();
      handle phRowObjUpd2 = new handle();
      handle phRowObjUpd3 = new handle();
      handle phRowObjUpd4 = new handle();
      handle phRowObjUpd5 = new handle();
      handle phRowObjUpd6 = new handle();
      handle phRowObjUpd7 = new handle();
      handle phRowObjUpd8 = new handle();
      handle phRowObjUpd9 = new handle();
      handle phRowObjUpd10 = new handle();
      handle phRowObjUpd11 = new handle();
      handle phRowObjUpd12 = new handle();
      handle phRowObjUpd13 = new handle();
      handle phRowObjUpd14 = new handle();
      handle phRowObjUpd15 = new handle();
      handle phRowObjUpd16 = new handle();
      handle phRowObjUpd17 = new handle();
      handle phRowObjUpd18 = new handle();
      handle phRowObjUpd19 = new handle();
      handle phRowObjUpd20 = new handle();
      character cUpdateTables = TypeFactory.character();
      integer iCount = TypeFactory.integer();
      
      internalProcedure(new Block((Init) () -> 
      {
         UndoableFactory.initInputOutput(phRowObjUpd1);
         UndoableFactory.initInputOutput(phRowObjUpd2);
         UndoableFactory.initInputOutput(phRowObjUpd3);
         UndoableFactory.initInputOutput(phRowObjUpd4);
         UndoableFactory.initInputOutput(phRowObjUpd5);
         UndoableFactory.initInputOutput(phRowObjUpd6);
         UndoableFactory.initInputOutput(phRowObjUpd7);
         UndoableFactory.initInputOutput(phRowObjUpd8);
         UndoableFactory.initInputOutput(phRowObjUpd9);
         UndoableFactory.initInputOutput(phRowObjUpd10);
         UndoableFactory.initInputOutput(phRowObjUpd11);
         UndoableFactory.initInputOutput(phRowObjUpd12);
         UndoableFactory.initInputOutput(phRowObjUpd13);
         UndoableFactory.initInputOutput(phRowObjUpd14);
         UndoableFactory.initInputOutput(phRowObjUpd15);
         UndoableFactory.initInputOutput(phRowObjUpd16);
         UndoableFactory.initInputOutput(phRowObjUpd17);
         UndoableFactory.initInputOutput(phRowObjUpd18);
         UndoableFactory.initInputOutput(phRowObjUpd19);
         UndoableFactory.initInputOutput(phRowObjUpd20);
         TypeFactory.initOutput(pcMessages);
         TypeFactory.initOutput(pcUndoIds);
      }, 
      (Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_phRowObjUpd1, phRowObjUpd1, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd2, phRowObjUpd2, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd3, phRowObjUpd3, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd4, phRowObjUpd4, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd5, phRowObjUpd5, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd6, phRowObjUpd6, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd7, phRowObjUpd7, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd8, phRowObjUpd8, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd9, phRowObjUpd9, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd10, phRowObjUpd10, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd11, phRowObjUpd11, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd12, phRowObjUpd12, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd13, phRowObjUpd13, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd14, phRowObjUpd14, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd15, phRowObjUpd15, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd16, phRowObjUpd16, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd17, phRowObjUpd17, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd18, phRowObjUpd18, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd19, phRowObjUpd19, true, true);
         TemporaryBuffer.createDynamicTable(_phRowObjUpd20, phRowObjUpd20, true, true);
         ControlFlowOps.invokeInWithMode("setContextAndInitialize", targetProcedure(), "I", pccontext);
         
         loopLabel52:
         for (iCount.assign(1); _isLessThanOrEqual(iCount, 20); iCount.increment())
         {
            switch (StringHelper.safeTrimTrailing((iCount).toStringMessage()))
            {
               case "1":
                  {
                     if ((phRowObjUpd1.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(valueOf(phRowObjUpd1));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "2":
                  {
                     if ((phRowObjUpd2.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd2)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "3":
                  {
                     if ((phRowObjUpd3.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd3)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "4":
                  {
                     if ((phRowObjUpd4.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd4)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "5":
                  {
                     if ((phRowObjUpd5.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd5)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "6":
                  {
                     if ((phRowObjUpd6.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd6)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "7":
                  {
                     if ((phRowObjUpd7.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd7)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "8":
                  {
                     if ((phRowObjUpd8.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd8)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "9":
                  {
                     if ((phRowObjUpd9.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd9)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "10":
                  {
                     if ((phRowObjUpd10.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd10)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "11":
                  {
                     if ((phRowObjUpd11.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd11)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "12":
                  {
                     if ((phRowObjUpd12.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd12)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "13":
                  {
                     if ((phRowObjUpd13.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd13)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "14":
                  {
                     if ((phRowObjUpd14.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd14)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "15":
                  {
                     if ((phRowObjUpd15.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd15)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "16":
                  {
                     if ((phRowObjUpd16.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd16)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "17":
                  {
                     if ((phRowObjUpd17.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd17)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "18":
                  {
                     if ((phRowObjUpd18.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd18)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "19":
                  {
                     if ((phRowObjUpd19.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd19)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
               case "20":
                  {
                     if ((phRowObjUpd20.isValid()).booleanValue())
                     {
                        cUpdateTables.assign(concat(cUpdateTables, ",", valueOf(phRowObjUpd20)));
                     }
                     else
                     {
                        break loopLabel52;
                     }
                  }
                  break;
            }
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTables"));
         ghProp.unwrapBufferField().changeValue(cUpdateTables);
         ControlFlowOps.invokeInWithMode("bufferCommitTransaction", targetProcedure(), "OO", pcMessages, pcUndoIds);
         pccontext /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForClient", targetProcedure()));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     server-side procedure to prepare and open a query<br>
    *              and return all the resulting data to the client side.<br>
    * Parameters:  pcContext - input-output context from-to client  <br>
    *              pcQueries AS CHARACTER  CHR(1)-delimited-list of <br>
    *                 QueryString properties of the SDOs;<br>
    *              pcPositions AS CHARACTER  reserved for future use to<br>
    *                 provide information on positioning each of the queries perhaps;<br>
    *              phRowObject1-20 AS HANDLE  temp-table handle of each SDO<br>
    *              pocMessages - Errors
    */
   public void remoteFetchContainedData(final character pcContext_1, final character _pcQueries, final character _pcPositions, final TableParameter _phRowObject1, final TableParameter _phRowObject2, final TableParameter _phRowObject3, final TableParameter _phRowObject4, final TableParameter _phRowObject5, final TableParameter _phRowObject6, final TableParameter _phRowObject7, final TableParameter _phRowObject8, final TableParameter _phRowObject9, final TableParameter _phRowObject10, final TableParameter _phRowObject11, final TableParameter _phRowObject12, final TableParameter _phRowObject13, final TableParameter _phRowObject14, final TableParameter _phRowObject15, final TableParameter _phRowObject16, final TableParameter _phRowObject17, final TableParameter _phRowObject18, final TableParameter _phRowObject19, final TableParameter _phRowObject20, final character pocMessages)
   {
      character pcQueries = TypeFactory.initInput(_pcQueries);
      character pcPositions = TypeFactory.initInput(_pcPositions);
      handle phRowObject1 = new handle();
      handle phRowObject2 = new handle();
      handle phRowObject3 = new handle();
      handle phRowObject4 = new handle();
      handle phRowObject5 = new handle();
      handle phRowObject6 = new handle();
      handle phRowObject7 = new handle();
      handle phRowObject8 = new handle();
      handle phRowObject9 = new handle();
      handle phRowObject10 = new handle();
      handle phRowObject11 = new handle();
      handle phRowObject12 = new handle();
      handle phRowObject13 = new handle();
      handle phRowObject14 = new handle();
      handle phRowObject15 = new handle();
      handle phRowObject16 = new handle();
      handle phRowObject17 = new handle();
      handle phRowObject18 = new handle();
      handle phRowObject19 = new handle();
      handle phRowObject20 = new handle();
      character cSdos = TypeFactory.character();
      integer iSdo = TypeFactory.integer();
      handle hSdo = TypeFactory.handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         UndoableFactory.initOutput(phRowObject1);
         UndoableFactory.initOutput(phRowObject2);
         UndoableFactory.initOutput(phRowObject3);
         UndoableFactory.initOutput(phRowObject4);
         UndoableFactory.initOutput(phRowObject5);
         UndoableFactory.initOutput(phRowObject6);
         UndoableFactory.initOutput(phRowObject7);
         UndoableFactory.initOutput(phRowObject8);
         UndoableFactory.initOutput(phRowObject9);
         UndoableFactory.initOutput(phRowObject10);
         UndoableFactory.initOutput(phRowObject11);
         UndoableFactory.initOutput(phRowObject12);
         UndoableFactory.initOutput(phRowObject13);
         UndoableFactory.initOutput(phRowObject14);
         UndoableFactory.initOutput(phRowObject15);
         UndoableFactory.initOutput(phRowObject16);
         UndoableFactory.initOutput(phRowObject17);
         UndoableFactory.initOutput(phRowObject18);
         UndoableFactory.initOutput(phRowObject19);
         UndoableFactory.initOutput(phRowObject20);
         TypeFactory.initOutput(pocMessages);
      }, 
      (Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_phRowObject1, phRowObject1, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject2, phRowObject2, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject3, phRowObject3, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject4, phRowObject4, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject5, phRowObject5, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject6, phRowObject6, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject7, phRowObject7, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject8, phRowObject8, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject9, phRowObject9, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject10, phRowObject10, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject11, phRowObject11, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject12, phRowObject12, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject13, phRowObject13, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject14, phRowObject14, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject15, phRowObject15, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject16, phRowObject16, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject17, phRowObject17, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject18, phRowObject18, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject19, phRowObject19, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject20, phRowObject20, false, true);
         ControlFlowOps.invokeInWithMode("setContextAndInitialize", targetProcedure(), "I", pcContext_1);
         ControlFlowOps.invokeInWithMode("bufferFetchContainedData", targetProcedure(), "II", pcQueries, pcPositions);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cSdos.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr34 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cSdos);
            }
         };
         ToClause toClause35 = new ToClause(iSdo, 1, resExpr34);
         
         doTo("loopLabel53", toClause35, new Block((Body) () -> 
         {
            if (_isNotEqual(entry(iSdo, pcQueries, chr(1)), "SKIP"))
            {
               hSdo.assign(handle.fromString(entry(iSdo, cSdos)));
               
               switch (StringHelper.safeTrimTrailing((iSdo).toStringMessage()))
               {
                  case "1":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject1.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "2":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject2.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "3":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject3.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "4":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject4.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "5":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject5.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "6":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject6.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "7":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject7.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "8":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject8.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "9":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject9.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "10":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject10.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "11":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject11.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "12":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject12.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "13":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject13.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "14":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject14.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "15":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject15.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "16":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject16.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "17":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject17.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "18":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject18.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "19":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject19.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "20":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject20.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
               }
            }
         }));
         
         /* Do iSDO */
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
         {
            pocMessages /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()));
         }
         
         pcContext_1 /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForClient", targetProcedure()));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     server-side procedure to prepare and open a query<br>
    *              and return all the resulting data to the client side.<br>
    * Parameters:  pcContext - input-output context from-to client  <br>
    *              pcQueries AS CHARACTER  CHR(1)-delimited-list of <br>
    *                 QueryString properties of the SDOs;<br>
    *              pcPositions AS CHARACTER  reserved for future use to<br>
    *                 provide information on positioning each of the queries perhaps;<br>
    *              phRowObject1-20 AS HANDLE  temp-table handle of each SDO<br>
    *              pocMessages - Errors (not in use)
    */
   public void remoteFetchContainedRows(final character pcContext_1, final character _pcQueries, final character _piStartRow, final character _pcRowIdent_4, final character _plNext, final integer _piRowsToReturn, final integer piRowsReturned, final TableParameter _phRowObject1, final TableParameter _phRowObject2, final TableParameter _phRowObject3, final TableParameter _phRowObject4, final TableParameter _phRowObject5, final TableParameter _phRowObject6, final TableParameter _phRowObject7, final TableParameter _phRowObject8, final TableParameter _phRowObject9, final TableParameter _phRowObject10, final TableParameter _phRowObject11, final TableParameter _phRowObject12, final TableParameter _phRowObject13, final TableParameter _phRowObject14, final TableParameter _phRowObject15, final TableParameter _phRowObject16, final TableParameter _phRowObject17, final TableParameter _phRowObject18, final TableParameter _phRowObject19, final TableParameter _phRowObject20, final character pocMessages)
   {
      character pcQueries = TypeFactory.initInput(_pcQueries);
      character piStartRow = TypeFactory.initInput(_piStartRow);
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      character plNext = TypeFactory.initInput(_plNext);
      integer piRowsToReturn = TypeFactory.initInput(_piRowsToReturn);
      handle phRowObject1 = new handle();
      handle phRowObject2 = new handle();
      handle phRowObject3 = new handle();
      handle phRowObject4 = new handle();
      handle phRowObject5 = new handle();
      handle phRowObject6 = new handle();
      handle phRowObject7 = new handle();
      handle phRowObject8 = new handle();
      handle phRowObject9 = new handle();
      handle phRowObject10 = new handle();
      handle phRowObject11 = new handle();
      handle phRowObject12 = new handle();
      handle phRowObject13 = new handle();
      handle phRowObject14 = new handle();
      handle phRowObject15 = new handle();
      handle phRowObject16 = new handle();
      handle phRowObject17 = new handle();
      handle phRowObject18 = new handle();
      handle phRowObject19 = new handle();
      handle phRowObject20 = new handle();
      character cSdos = TypeFactory.character();
      integer iSdo = TypeFactory.integer();
      handle hSdo = TypeFactory.handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(piRowsReturned);
         UndoableFactory.initOutput(phRowObject1);
         UndoableFactory.initOutput(phRowObject2);
         UndoableFactory.initOutput(phRowObject3);
         UndoableFactory.initOutput(phRowObject4);
         UndoableFactory.initOutput(phRowObject5);
         UndoableFactory.initOutput(phRowObject6);
         UndoableFactory.initOutput(phRowObject7);
         UndoableFactory.initOutput(phRowObject8);
         UndoableFactory.initOutput(phRowObject9);
         UndoableFactory.initOutput(phRowObject10);
         UndoableFactory.initOutput(phRowObject11);
         UndoableFactory.initOutput(phRowObject12);
         UndoableFactory.initOutput(phRowObject13);
         UndoableFactory.initOutput(phRowObject14);
         UndoableFactory.initOutput(phRowObject15);
         UndoableFactory.initOutput(phRowObject16);
         UndoableFactory.initOutput(phRowObject17);
         UndoableFactory.initOutput(phRowObject18);
         UndoableFactory.initOutput(phRowObject19);
         UndoableFactory.initOutput(phRowObject20);
         TypeFactory.initOutput(pocMessages);
      }, 
      (Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_phRowObject1, phRowObject1, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject2, phRowObject2, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject3, phRowObject3, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject4, phRowObject4, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject5, phRowObject5, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject6, phRowObject6, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject7, phRowObject7, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject8, phRowObject8, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject9, phRowObject9, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject10, phRowObject10, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject11, phRowObject11, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject12, phRowObject12, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject13, phRowObject13, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject14, phRowObject14, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject15, phRowObject15, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject16, phRowObject16, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject17, phRowObject17, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject18, phRowObject18, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject19, phRowObject19, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject20, phRowObject20, false, true);
         ControlFlowOps.invokeInWithMode("setContextAndInitialize", targetProcedure(), "I", pcContext_1);
         ControlFlowOps.invokeInWithMode("bufferFetchContainedRows", targetProcedure(), "IIIIIO", pcQueries, piStartRow, pcRowIdent_4, plNext, piRowsToReturn, piRowsReturned);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cSdos.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr35 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cSdos);
            }
         };
         ToClause toClause36 = new ToClause(iSdo, 1, resExpr35);
         
         doTo("loopLabel54", toClause36, new Block((Body) () -> 
         {
            if (_isNotEqual(entry(iSdo, pcQueries, chr(1)), "SKIP"))
            {
               hSdo.assign(handle.fromString(entry(iSdo, cSdos)));
               
               switch (StringHelper.safeTrimTrailing((iSdo).toStringMessage()))
               {
                  case "1":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject1.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "2":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject2.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "3":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject3.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "4":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject4.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "5":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject5.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "6":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject6.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "7":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject7.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "8":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject8.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "9":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject9.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "10":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject10.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "11":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject11.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "12":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject12.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "13":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject13.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "14":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject14.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "15":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject15.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "16":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject16.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "17":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject17.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "18":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject18.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "19":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject19.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "20":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject20.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
               }
            }
         }));
         
         /* Do iSDO */
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
         {
            pocMessages /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()));
         }
         
         pcContext_1 /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForClient", targetProcedure()));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:    When a SmartBusinessObject is split and running Statelessly on an<br>
    *             AppServer, it is shutdown after each use and then restarted for<br>
    *             the next.  restartServerObject is run on the client to restart<br>
    *             the SmartBusinessObject on the server. <br>
    * Notes:      This override is for error handling to show error message and<br>
    *             return 'adm-error'.
    */
   public void restartServerObject()
   {
      character cMsg = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         silent(() -> ControlFlowOps.runSuper("restartServerObject"));
         
         /* Handles only one message, which is sufficent with the current appserver 
             class */
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
         {
            cMsg.assign(entry(1, ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()), chr(4)));
            /* {fnarg <func-name> <arg> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", cMsg);
            returnError("ADM-ERROR");
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: OBSOLETE!  use fetchContainedRows &gt; containedRows  <br>
    *            Server-side SBO version of serverSendRows.<br>
    *              Receives the SDO Object Name and runs SendRows in that,<br>
    *              returning the RowObject table.<br>
    *          <br>
    *          OBSOLETE !!! <br>
    *                             <br>
    *  Parameters:  <br>
    *   INPUT  piStartRow     - The RowNum value of the record to start the batch<br>
    *                           to return.  Typically piStartRow is ? as a flag to <br>
    *                           use pcRowIdent instead of piStartRow.<br>
    *   INPUT  pcRowIdent     - The RowIdent of the first record of the batch to<br>
    *                           to return.  Can also be "FIRST" or "LAST" to force<br>
    *                           the retrieval of the first (or last) batch of <br>
    *                           RowObject records.<br>
    *   INPUT  plNext         - True if serverSendRows is to start on the "next"<br>
    *                           record from what is indicated by piStartRow or<br>
    *                           piRowIdent.<br>
    *   INPUT  piRowsToReturn - The number of rows in a batch.<br>
    *   INPUT  pcObjectName   - the ObjectName of the SDO to get data from.<br>
    *   OUTPUT piRowsReturned - The actual number of rows returned. This number<br>
    *                           will either be the same as piRowsToReturn or<br>
    *                           less when there are not enough records to fill<br>
    *                           up the batch.<br>
    *   OUTPUT TABLE-HANDLE   - The batch of rows in the RowObject table.
    */
   public void serverContainedSendRows(final integer _piStartRow, final character _pcRowIdent_4, final logical _plNext, final integer _piRowsToReturn, final character _pcObjectName_2, final integer piRowsReturned, final TableParameter _phRowObject)
   {
      integer piStartRow = TypeFactory.initInput(_piStartRow);
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      logical plNext = TypeFactory.initInput(_plNext);
      integer piRowsToReturn = TypeFactory.initInput(_piRowsToReturn);
      character pcObjectName_2 = TypeFactory.initInput(_pcObjectName_2);
      handle phRowObject = new handle();
      character cContained = TypeFactory.character();
      integer iObject = TypeFactory.integer();
      handle hObject = TypeFactory.handle();
      character cObjectName = TypeFactory.character();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(piRowsReturned);
         UndoableFactory.initOutput(phRowObject);
      }, 
      (Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_phRowObject, phRowObject, false, true);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cContained.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr36 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cContained);
            }
         };
         ToClause toClause37 = new ToClause(iObject, 1, resExpr36);
         
         doTo("loopLabel55", toClause37, new Block((Body) () -> 
         {
            hObject.assign(handle.fromString(entry(iObject, cContained)));
            ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
            cObjectName.assign(ghProp.unwrapBufferField().value());
            
            if (_isEqual(cObjectName, pcObjectName_2))
            {
               /* sendRows will populate the temp-table, and we can get its
                            handle directly afterwards, so we can just call sendRows
                            directly and *then* get the table as a simple handle. */
               ControlFlowOps.invokeInWithMode("sendRows", hObject, "IIIIO", piStartRow, pcRowIdent_4, plNext, piRowsToReturn, piRowsReturned);
               /* {get Prop var [handle]} */
               phRowObject.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hObject));
            }
         }));
         
         /* END DO iObject -- match ObjectNames */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     server-side procedure to prepare and open a query<br>
    *              and return all the resulting data to the client side.<br>
    * Parameters:  pcQueries AS CHARACTER  CHR(1)-delimited-list of <br>
    *                 QueryString properties of the SDOs;<br>
    *              pcPositions AS CHARACTER  reserved for future use to<br>
    *                 provide information on positioning each of the queries perhaps;<br>
    *              phRowObject1-20 AS HANDLE  temp-table handle of each SDO
    */
   public void serverFetchContainedData(final character _pcQueries, final character _pcPositions, final TableParameter _phRowObject1, final TableParameter _phRowObject2, final TableParameter _phRowObject3, final TableParameter _phRowObject4, final TableParameter _phRowObject5, final TableParameter _phRowObject6, final TableParameter _phRowObject7, final TableParameter _phRowObject8, final TableParameter _phRowObject9, final TableParameter _phRowObject10, final TableParameter _phRowObject11, final TableParameter _phRowObject12, final TableParameter _phRowObject13, final TableParameter _phRowObject14, final TableParameter _phRowObject15, final TableParameter _phRowObject16, final TableParameter _phRowObject17, final TableParameter _phRowObject18, final TableParameter _phRowObject19, final TableParameter _phRowObject20)
   {
      character pcQueries = TypeFactory.initInput(_pcQueries);
      character pcPositions = TypeFactory.initInput(_pcPositions);
      handle phRowObject1 = new handle();
      handle phRowObject2 = new handle();
      handle phRowObject3 = new handle();
      handle phRowObject4 = new handle();
      handle phRowObject5 = new handle();
      handle phRowObject6 = new handle();
      handle phRowObject7 = new handle();
      handle phRowObject8 = new handle();
      handle phRowObject9 = new handle();
      handle phRowObject10 = new handle();
      handle phRowObject11 = new handle();
      handle phRowObject12 = new handle();
      handle phRowObject13 = new handle();
      handle phRowObject14 = new handle();
      handle phRowObject15 = new handle();
      handle phRowObject16 = new handle();
      handle phRowObject17 = new handle();
      handle phRowObject18 = new handle();
      handle phRowObject19 = new handle();
      handle phRowObject20 = new handle();
      character cSdos = TypeFactory.character();
      integer iSdo = TypeFactory.integer();
      handle hSdo = TypeFactory.handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         UndoableFactory.initOutput(phRowObject1);
         UndoableFactory.initOutput(phRowObject2);
         UndoableFactory.initOutput(phRowObject3);
         UndoableFactory.initOutput(phRowObject4);
         UndoableFactory.initOutput(phRowObject5);
         UndoableFactory.initOutput(phRowObject6);
         UndoableFactory.initOutput(phRowObject7);
         UndoableFactory.initOutput(phRowObject8);
         UndoableFactory.initOutput(phRowObject9);
         UndoableFactory.initOutput(phRowObject10);
         UndoableFactory.initOutput(phRowObject11);
         UndoableFactory.initOutput(phRowObject12);
         UndoableFactory.initOutput(phRowObject13);
         UndoableFactory.initOutput(phRowObject14);
         UndoableFactory.initOutput(phRowObject15);
         UndoableFactory.initOutput(phRowObject16);
         UndoableFactory.initOutput(phRowObject17);
         UndoableFactory.initOutput(phRowObject18);
         UndoableFactory.initOutput(phRowObject19);
         UndoableFactory.initOutput(phRowObject20);
      }, 
      (Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_phRowObject1, phRowObject1, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject2, phRowObject2, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject3, phRowObject3, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject4, phRowObject4, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject5, phRowObject5, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject6, phRowObject6, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject7, phRowObject7, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject8, phRowObject8, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject9, phRowObject9, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject10, phRowObject10, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject11, phRowObject11, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject12, phRowObject12, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject13, phRowObject13, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject14, phRowObject14, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject15, phRowObject15, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject16, phRowObject16, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject17, phRowObject17, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject18, phRowObject18, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject19, phRowObject19, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject20, phRowObject20, false, true);
         ControlFlowOps.invokeInWithMode("bufferFetchContainedData", targetProcedure(), "II", pcQueries, pcPositions);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cSdos.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr37 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cSdos);
            }
         };
         ToClause toClause38 = new ToClause(iSdo, 1, resExpr37);
         
         doTo("loopLabel56", toClause38, new Block((Body) () -> 
         {
            if (_isNotEqual(entry(iSdo, pcQueries, chr(1)), "SKIP"))
            {
               hSdo.assign(handle.fromString(entry(iSdo, cSdos)));
               
               switch (StringHelper.safeTrimTrailing((iSdo).toStringMessage()))
               {
                  case "1":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject1.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "2":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject2.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "3":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject3.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "4":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject4.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "5":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject5.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "6":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject6.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "7":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject7.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "8":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject8.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "9":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject9.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "10":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject10.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "11":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject11.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "12":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject12.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "13":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject13.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "14":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject14.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "15":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject15.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "16":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject16.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "17":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject17.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "18":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject18.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "19":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject19.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "20":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject20.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
               }
            }
         }));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     server-side procedure that retrieves a batch of data <br>
    *              in one of the contained SDOs and returns all the resulting <br>
    *              data to the client side.<br>
    * Parameters:  <br>
    *   INPUT  pcQueries     -  CHR(1)-delimited-list of QueryString properties of <br>
    *                           the SDOs. SKIP indicates <br>
    *   INPUT  pcObject      -  The object to retrieve the batch from (? = Master)      <br>
    *   INPUT  piStartRow    -  The RowNum value of the record to start the batch<br>
    *                           to return.  Typically piStartRow is ? as a flag to <br>
    *                           use pcRowIdent instead of piStartRow.<br>
    *   INPUT  pcRowIdent     - The RowIdent of the first record of the batch to<br>
    *                           to return.  Can also be "FIRST" or "LAST" to force<br>
    *                           the retrieval of the first (or last) batch of <br>
    *                           RowObject records.<br>
    *   INPUT  plNext         - True if serverSendRows is to start on the "next"<br>
    *                           record from what is indicated by piStartRow or<br>
    *                           piRowIdent.<br>
    *   INPUT  piRowsToReturn - The number of rows in a batch.<br>
    *   OUTPUT piRowsReturned - The actual number of rows returned. This number<br>
    *                           will either be the same as piRowsToReturn or<br>
    *                           less when there are not enough records to fill<br>
    *                           up the batch.<br>
    *   <br>
    *   OUTPUT TABLE-HANDLE phRowObject1-20 AS HANDLE <br>
    *                          - temp-table handle of each SDO
    */
   public void serverFetchContainedRows(final character _pcQueries, final character _piStartRow, final character _pcRowIdent_4, final character _plNext, final integer _piRowsToReturn, final integer piRowsReturned, final TableParameter _phRowObject1, final TableParameter _phRowObject2, final TableParameter _phRowObject3, final TableParameter _phRowObject4, final TableParameter _phRowObject5, final TableParameter _phRowObject6, final TableParameter _phRowObject7, final TableParameter _phRowObject8, final TableParameter _phRowObject9, final TableParameter _phRowObject10, final TableParameter _phRowObject11, final TableParameter _phRowObject12, final TableParameter _phRowObject13, final TableParameter _phRowObject14, final TableParameter _phRowObject15, final TableParameter _phRowObject16, final TableParameter _phRowObject17, final TableParameter _phRowObject18, final TableParameter _phRowObject19, final TableParameter _phRowObject20)
   {
      character pcQueries = TypeFactory.initInput(_pcQueries);
      character piStartRow = TypeFactory.initInput(_piStartRow);
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      character plNext = TypeFactory.initInput(_plNext);
      integer piRowsToReturn = TypeFactory.initInput(_piRowsToReturn);
      handle phRowObject1 = new handle();
      handle phRowObject2 = new handle();
      handle phRowObject3 = new handle();
      handle phRowObject4 = new handle();
      handle phRowObject5 = new handle();
      handle phRowObject6 = new handle();
      handle phRowObject7 = new handle();
      handle phRowObject8 = new handle();
      handle phRowObject9 = new handle();
      handle phRowObject10 = new handle();
      handle phRowObject11 = new handle();
      handle phRowObject12 = new handle();
      handle phRowObject13 = new handle();
      handle phRowObject14 = new handle();
      handle phRowObject15 = new handle();
      handle phRowObject16 = new handle();
      handle phRowObject17 = new handle();
      handle phRowObject18 = new handle();
      handle phRowObject19 = new handle();
      handle phRowObject20 = new handle();
      character cSdos = TypeFactory.character();
      integer iSdo = TypeFactory.integer();
      handle hSdo = TypeFactory.handle();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(piRowsReturned);
         UndoableFactory.initOutput(phRowObject1);
         UndoableFactory.initOutput(phRowObject2);
         UndoableFactory.initOutput(phRowObject3);
         UndoableFactory.initOutput(phRowObject4);
         UndoableFactory.initOutput(phRowObject5);
         UndoableFactory.initOutput(phRowObject6);
         UndoableFactory.initOutput(phRowObject7);
         UndoableFactory.initOutput(phRowObject8);
         UndoableFactory.initOutput(phRowObject9);
         UndoableFactory.initOutput(phRowObject10);
         UndoableFactory.initOutput(phRowObject11);
         UndoableFactory.initOutput(phRowObject12);
         UndoableFactory.initOutput(phRowObject13);
         UndoableFactory.initOutput(phRowObject14);
         UndoableFactory.initOutput(phRowObject15);
         UndoableFactory.initOutput(phRowObject16);
         UndoableFactory.initOutput(phRowObject17);
         UndoableFactory.initOutput(phRowObject18);
         UndoableFactory.initOutput(phRowObject19);
         UndoableFactory.initOutput(phRowObject20);
      }, 
      (Body) () -> 
      {
         TemporaryBuffer.createDynamicTable(_phRowObject1, phRowObject1, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject2, phRowObject2, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject3, phRowObject3, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject4, phRowObject4, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject5, phRowObject5, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject6, phRowObject6, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject7, phRowObject7, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject8, phRowObject8, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject9, phRowObject9, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject10, phRowObject10, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject11, phRowObject11, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject12, phRowObject12, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject13, phRowObject13, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject14, phRowObject14, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject15, phRowObject15, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject16, phRowObject16, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject17, phRowObject17, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject18, phRowObject18, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject19, phRowObject19, false, true);
         TemporaryBuffer.createDynamicTable(_phRowObject20, phRowObject20, false, true);
         ControlFlowOps.invokeInWithMode("bufferFetchContainedRows", targetProcedure(), "IIIIIO", pcQueries, piStartRow, pcRowIdent_4, plNext, piRowsToReturn, piRowsReturned);
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cSdos.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr38 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cSdos);
            }
         };
         ToClause toClause39 = new ToClause(iSdo, 1, resExpr38);
         
         doTo("loopLabel57", toClause39, new Block((Body) () -> 
         {
            if (_isNotEqual(entry(iSdo, pcQueries, chr(1)), "SKIP"))
            {
               hSdo.assign(handle.fromString(entry(iSdo, cSdos)));
               
               switch (StringHelper.safeTrimTrailing((iSdo).toStringMessage()))
               {
                  case "1":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject1.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "2":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject2.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "3":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject3.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "4":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject4.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "5":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject5.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "6":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject6.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "7":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject7.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "8":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject8.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "9":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject9.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "10":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject10.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "11":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject11.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "12":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject12.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "13":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject13.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "14":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject14.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "15":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject15.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "16":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject16.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "17":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject17.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "18":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject18.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "19":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject19.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
                  case "20":
                     {
                        /* {get Prop var [handle]} */
                        phRowObject20.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjectTable", hSdo));
                     }
                     break;
               }
            }
         }));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Server-side procedure run at startup to return property values<br>
    *              needed on the client.<br>
    * Parameters:  OUTPUT pcPropList AS CHARACTER<br>
    *                Properties and Values in internal format that can be <br>
    *                used to assign <br>
    * Notes:       Currently returns the OpenQuery and IndexInformation property of <br>
    *              each SDO. <br>
    *              There's no need to do a call to initializeObject before calling<br>
    *              this as it is initialized here if required.  <br>
    *            - See FetchDOProperties about usage.
    */
   public void serverFetchDoproperties(final character pcContext_1)
   {
      logical lInitialized = TypeFactory.logical();
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcContext_1);
      }, 
      (Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectInitialized"));
         lInitialized.assign(ghProp.unwrapBufferField().value());
         
         if (_not(lInitialized))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("OpenOnInit"));
            ghProp.unwrapBufferField().changeValue(new logical(false));
            ControlFlowOps.invokeIn("initializeObject", targetProcedure());
         }
         
         /* if not initialized */
         /* This is a dedicated 'first time' call, so set ServerFirstCall = true*/
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setServerFirstCall", targetProcedure(), "I", true);
         pcContext_1 /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "obtainContextForClient", targetProcedure()));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:  Reset context and initialize this server side object   <br>
    * Parameters:  pcContext <br>
    *              Properties in the format returned from <br>
    *              containedProperties to be passed to assignContainedProperties <br>
    * Notes:    Called from a stateless client before a request.<br>
    *           The format is subject to change<br>
    *        -  This overrides the containr class in order to set OpenOnInit, which<br>
    *           the container does not have.
    */
   public void setContextAndInitialize(final character _pcContext_1)
   {
      character pcContext_1 = TypeFactory.initInput(_pcContext_1);
      integer iEntry = TypeFactory.integer();
      integer iPos = TypeFactory.integer();
      character cPropList = TypeFactory.character();
      character cPropValue = TypeFactory.character();
      logical lCreated = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectsCreated"));
         lCreated.assign(ghProp.unwrapBufferField().value());
         
         if (_not(lCreated))
         {
            cPropList.assign(entry(1, pcContext_1, chr(3)));
            iEntry.assign(lookup("THIS", cPropList, ";"));
            
            if (_isGreaterThan(iEntry, 0))
            {
               /* Get the 'LogicalObjectName' and set it in the newly created object */
               /* This is necessary so that a DynSBO object can get and instantiate its */
               /* contents from the repository */
               iPos.assign(lookup("LogicalObjectName", entry(plus(iEntry, 1), cPropList, ";")));
               
               if (_isGreaterThan(iPos, 0))
               {
                  cPropValue.assign(entry(iPos, entry(plus(iEntry, 2), pcContext_1, chr(3)), chr(4)));
                  ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("LogicalObjectName"));
                  ghProp.unwrapBufferField().changeValue(cPropValue);
               }
            }
            ControlFlowOps.invokeIn("createObjects", targetProcedure());
         }
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignContainedProperties", targetProcedure(), "II", pcContext_1, "");
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("OpenOnInit"));
         ghProp.unwrapBufferField().changeValue(new logical(false));
         ControlFlowOps.invokeIn("initializeObject", targetProcedure());
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     To set a list of properties taken from a CHR(3) delimitted list<br>
    *              of "propCHR(4)value" pairs.<br>
    * <p>
    * Parameters:  <br>
    *   INPUT pcProperties - the CHR(3) delimitted list of "propCHR(4)value" pairs<br>
    *                        to be set.<br>
    * <p>
    * Notes:      COPY of data.p ()
    */
   public void setPropertyList(final character _pcProperties)
   {
      character pcProperties = TypeFactory.initInput(_pcProperties);
      integer iProp = TypeFactory.integer();
      character cProp = TypeFactory.character();
      character cValue = TypeFactory.character();
      integer iCnt = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         iCnt.assign(numEntries(pcProperties, chr(3)));
         
         ToClause toClause40 = new ToClause(iProp, 1, iCnt);
         
         doTo("loopLabel58", toClause40, new Block((Body) () -> 
         {
            cProp.assign(entry(iProp, pcProperties, chr(3)));
            cValue.assign(entry(2, cProp, chr(4)));
            cValue.assign(_isEqual(cValue, "?") ? new character() : cValue);
            cProp.assign(entry(1, cProp, chr(4)));
            /** The call to the signature function has been removed to improve performance
                  and because it was unnecessary as character values will be converted to the 
                  correct data-type implicitly. (Issuezilla #11489)
                
                  Message code removed to avoid issues with attributes being set which are not 
                  available as properties in the object. Objects may conditionally 
                  inherit from classes (Issuezilla # 11481) 
              **/
            silent(() -> ControlFlowOps.invokeDynamicFunctionInWithMode(concat("set", cProp), targetProcedure(), "I", cValue));
         }));
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     View/Start the filter-source<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void startFilter()
   {
      handle hFilterSource = TypeFactory.handle();
      handle hWindow = TypeFactory.handle();
      logical lHide = TypeFactory.logical();
      handle hFilterContainer = TypeFactory.handle();
      handle hMyContainer = TypeFactory.handle();
      character cFilterWindow = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FilterSource"));
         hFilterSource.assign(ghProp.unwrapBufferField().value());
         
         if ((hFilterSource.isValid()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, hFilterSource.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
            hFilterContainer.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
            hMyContainer.assign(ghProp.unwrapBufferField().value());
            
            if (_isNotEqual(hMyContainer, hFilterContainer))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("FilterWindow"));
               ghProp.unwrapBufferField().changeValue(hFilterContainer.unwrapFile().getFileName());
               ghProp.assign(handle.fromString(entry(1, hFilterContainer.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("HideOnInit"));
               lHide.assign(ghProp.unwrapBufferField().value());
               
               /* Workaround to make it visible if it's hideoninit */
               if ((lHide).booleanValue())
               {
                  ControlFlowOps.invokeIn("destroyObject", hFilterContainer);
               }
            }
         }
         
         if (_not(hFilterContainer.isValid()))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("FilterWindow"));
            cFilterWindow.assign(ghProp.unwrapBufferField().value());
            
            if (_isNotEqual(cFilterWindow, ""))
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
               hMyContainer.assign(ghProp.unwrapBufferField().value());
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerHandle"));
               hWindow.assign(ghProp.unwrapBufferField().value());
               ControlFlowOps.invokeInWithMode("constructObject", hMyContainer, "IIIO", cFilterWindow, hWindow, concat("HideOnInit", chr(4), "no", chr(3), "DisableOnInit", chr(4), "no", chr(3), "ObjectLayout", chr(4)), hFilterContainer);
               /* filterContainerHandler adds the Filter link between this object
                        and the Filter container */
               ControlFlowOps.invokeInWithMode("filterContainerHandler", targetProcedure(), "I", hFilterContainer);
               ControlFlowOps.invokeIn("initializeObject", hFilterContainer);
            }
         }
         ControlFlowOps.invokeIn("viewObject", hFilterContainer);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:    When a SmartBusinessObject is split and running Statelessly on an<br>
    *             AppServer, startServerObject is run on the client to start<br>
    *             the SmartBusinessObject on the server.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:      This override is for error handling to show error message and<br>
    *             return 'adm-error'.
    */
   public void startServerObject()
   {
      character cMsg = TypeFactory.character();
      
      internalProcedure(new Block((Body) () -> 
      {
         silent(() -> ControlFlowOps.runSuper("startServerObject"));
         
         /* Handles only one message, which is sufficent with the current appserver 
             class */
         if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "anyMessage", targetProcedure()))).booleanValue())
         {
            cMsg.assign(entry(1, ControlFlowOps.invokeDynamicFunctionIn(character.class, "fetchMessages", targetProcedure()), chr(4)));
            /* {fnarg <func-name> <arg> [handle] */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", cMsg);
            returnError("ADM-ERROR");
         }
         else
         {
            if ((ErrorManager.isError()).booleanValue())
            {
               returnError(ControlFlowOps.getReturnValue());
            }
         }
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     Passes the undoTransaction event on to each contained<br>
    *              DataObject that has any uncommitted changes.<br>
    * Parameters:  &lt;none&gt;
    */
   public void undoTransaction()
   {
      integer iDo = TypeFactory.integer();
      character cContained = TypeFactory.character();
      handle hDo = TypeFactory.handle();
      character cCurRowident = TypeFactory.character();
      character cNewRowident = TypeFactory.character();
      character cRefresh = TypeFactory.character();
      handle hSource = TypeFactory.handle();
      integer iSource = TypeFactory.integer();
      logical lCancel = TypeFactory.logical();
      
      internalProcedure(new Block((Body) () -> 
      {
         /* Visual dataTargets subscribes to this */
         NamedEventManager.publish("confirmUndo", targetProcedure(), "U", new Object[]
         {
            lCancel
         });
         
         if ((lCancel).booleanValue())
         {
            returnNormal();
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cContained.assign(ghProp.unwrapBufferField().value());
         cRefresh.assign(fill(",", numEntries(cContained)));
         
         IntegerExpression resExpr39 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cContained);
            }
         };
         ToClause toClause41 = new ToClause(iDo, 1, resExpr39);
         
         doTo("sdoloop", toClause41, new Block((Body) () -> 
         {
            hDo.assign(handle.fromString(entry(iDo, cContained)));
            /* {get Prop var [handle]} */
            cCurRowident.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowident", hDo));
            ControlFlowOps.invokeIn("undoTransaction", hDo);
            /* {get Prop var [handle]} */
            cNewRowident.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowident", hDo));
            
            /* The undo changed position, so we need to publish to SDO datatargets */
            if (_isNotEqual(cCurRowident, cNewRowident))
            {
               /* Check if we have changed position of any source, which means that we 
                       will receive a dataAvailable from that and don't need to mark this 
                       to be refresh */
               hSource.assign(hDo);
               
               LogicalOp whileClause1 = () -> hSource.isValid();
               
               doWhile("loopLabel59", whileClause1, new Block((Body) () -> 
               {
                  /* {get Prop var [handle]} */
                  hSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hSource));
                  iSource.assign(lookup(valueOf(hSource), cContained));
                  
                  /* we have a parent that will be refreshed, so undo the next SDO */
                  if (_and(isGreaterThan(iSource, 0), () -> isNotEqual(entry(iSource, cRefresh), "")))
                  {
                     next("sdoloop");
                  }
               }));
               
               /* Set the refresh flag */
               cRefresh.replaceEntry(iDo, "1");
            }
         }));
         
         /* END DO iDO */
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectState", targetProcedure(), "I", "NoUpdates");
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("BlockDataAvailable"));
         ghProp.unwrapBufferField().changeValue(new logical(true));
         
         loopLabel60:
         for (iDo.assign(1); _isLessThanOrEqual(iDo, numEntries(cContained)); iDo.increment())
         {
            hDo.assign(handle.fromString(entry(iDo, cContained)));
            
            /* The popsition changed during undo so publish */
            if (_isNotEqual(entry(iDo, cRefresh), ""))
            {
               NamedEventManager.publish("dataAvailable", hDo, "I", new Object[]
               {
                  "DIFFERENT"
               });
            }
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("BlockDataAvailable"));
         ghProp.unwrapBufferField().changeValue(new logical(false));
         /* Now let external client objects know we might have changed data. */
         NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
         {
            "DIFFERENT"
         });
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose: General purpose 'unregister' event that can be published from objects <br>
    *          when they are destroyed. Deletes entries from object mapping:<br>
    *          nav source, nav target pair <br>
    *          data target, data source pair <br>
    *          Note: the first object in the pair is the one that publishes the msg<br>
    *          and it is the one this routine looks for to identify the pairs to<br>
    *          delete from object mapping.<br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void unRegisterObject()
   {
      character cMapping = TypeFactory.character();
      character cTmp = TypeFactory.character();
      character cSource = TypeFactory.character();
      integer i = TypeFactory.integer();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         cTmp.assign(cMapping);
         cSource.assign(valueOf(sourceProcedure()));
         /* the object that published the msg */
         i.assign(lookup(cSource, cTmp, ","));
         
         LogicalOp whileClause2 = () -> isNotEqual(i, 0);
         
         doWhile("loopLabel61", whileClause2, new Block((Body) () -> 
         {
            /* make sure the match we found is the first part of the pair*/
            if (_isEqual(modulo(i, 2), 1))
            {
               /* delete the first part of the pair */
               cTmp.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "deleteEntry", targetProcedure(), "III", i, cTmp, ","));
               /* delete the 2nd part of the pair but it has the same index
                                now because of the previous delete */
               cTmp.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "deleteEntry", targetProcedure(), "III", i, cTmp, ","));
            }
            
            /* end if modulo*/
            i.assign(lookup(cSource, cTmp, ","));
         }));
         
         /* end do while*/
         if (_isNotEqual(cTmp, cMapping))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
            ghProp.unwrapBufferField().changeValue(cTmp);
         }
         /* {set Prop value [handle]} */ 
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * Purpose:     <br>
    * Parameters:  &lt;none&gt;<br>
    * Notes:
    */
   public void updateData(final character _pcUpdateColumnNames, final character _pcOldValues, final character pcNewValues, final character pcError)
   {
      character pcUpdateColumnNames = TypeFactory.initInput(_pcUpdateColumnNames);
      character pcOldValues = TypeFactory.initInput(_pcOldValues);
      
      internalProcedure(new Block((Init) () -> 
      {
         TypeFactory.initOutput(pcError);
      }, 
      (Body) () -> 
      {
         ControlFlowOps.invokeInWithMode("processOpenCall", targetProcedure(), "IIIUO", new character("UPDATE"), pcUpdateColumnNames, pcOldValues, pcNewValues, pcError);
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    *  Purpose:  Republishes any updateState event messages received from a<br>
    *            Data-Target, to get them e.g. to Navigation Panel / Toolbar. <br>
    *   Params:  INPUT pcState AS CHARACTER   <br>
    *    Notes:  For Visual objects the updateState is both a DataSourceEvent <br>
    *            and DataTargetEvent. We set the CurrentUpdateSource if the <br>
    *            publisher is an outside UpdateSoruce so the UpdateSource/DataTarget <br>
    *            can use this to recognize that it receives an updateState that it <br>
    *            self originated. <br>
    * Note date: 2002/02/08
    */
   public void updateState(final character _pcState)
   {
      character pcState = TypeFactory.initInput(_pcState);
      character cMapping = TypeFactory.character();
      logical lInProcess = TypeFactory.logical();
      character cContained = TypeFactory.character();
      character cObjects = TypeFactory.character();
      integer iObject = TypeFactory.integer();
      handle hObject = TypeFactory.handle();
      character cTargets = TypeFactory.character();
      character cEvents = TypeFactory.character();
      character cUpdateSources = TypeFactory.character();
      handle hDataSource = TypeFactory.handle();
      handle hMaster = TypeFactory.handle();
      character cSourceType = TypeFactory.character();
      handle hTargetObject = TypeFactory.handle();
      
      internalProcedure(new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cContained.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         cSourceType /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getObjectType", sourceProcedure()));
         
         if (_isEqual(cSourceType, "SUPER"))
         {
            hTargetObject /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getTargetProcedure", sourceProcedure()));
         }
         
         if (_not(hTargetObject.isValid()))
         {
            hTargetObject.assign(sourceProcedure());
         }
         
         /* If the event did NOT come from one of our ContainedDataObjects, 
               we have reason to believe that it came from the outside */
         if (_not(matchesList(cContained, valueOf(hTargetObject))))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateStateInProcess"));
            lInProcess.assign(ghProp.unwrapBufferField().value());
            
            if ((lInProcess).booleanValue())
            {
               returnNormal();
            }
            
            /* Get all internal objects linked to this */
            cObjects.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", valueOf(hTargetObject), cMapping, true, ","));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateStateInProcess"));
            ghProp.unwrapBufferField().changeValue(new logical(true));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateSource"));
            cUpdateSources.assign(ghProp.unwrapBufferField().value());
            
            if ((matchesList(cUpdateSources, valueOf(hTargetObject))).booleanValue())
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentUpdateSource"));
               ghProp.unwrapBufferField().changeValue(hTargetObject);
            }
            /* {set Prop value [handle]} */ 
            
            IntegerExpression resExpr40 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cObjects);
               }
            };
            ToClause toClause42 = new ToClause(iObject, 1, resExpr40);
            
            doTo("loopLabel62", toClause42, new Block((Body) () -> 
            {
               hObject.assign(handle.fromString(entry(iObject, cObjects)));
               ghTargetProcedure.assign(targetProcedure());
               silent(() -> ControlFlowOps.invokeInWithMode("updateState", hObject, "I", pcState));
               ghTargetProcedure.setUnknown();
            }));
            
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("CurrentUpdateSource"));
            ghProp.unwrapBufferField().changeValue(new unknown());
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateStateInProcess"));
            ghProp.unwrapBufferField().changeValue(new logical(false));
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
            hMaster.assign(ghProp.unwrapBufferField().value());
            
            if (_isEqual(hMaster, hTargetObject))
            {
               /* {get Prop var [handle]} */ 
               hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
               
               if ((hDataSource.isValid()).booleanValue())
               {
                  ghTargetProcedure.assign(targetProcedure());
                  silent(() -> ControlFlowOps.invokeInWithMode("updateState", hDataSource, "I", pcState));
                  ghTargetProcedure.setUnknown();
               }
            }
            cObjects.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", valueOf(hTargetObject), cMapping, false, ","));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
            cTargets.assign(ghProp.unwrapBufferField().value());
            
            IntegerExpression resExpr41 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cObjects);
               }
            };
            ToClause toClause43 = new ToClause(iObject, 1, resExpr41);
            
            doTo("loopLabel63", toClause43, new Block((Body) () -> 
            {
               hObject.assign(handle.fromString(entry(iObject, cObjects)));
               cEvents.setUnknown();
               
               if ((matchesList(cTargets, valueOf(hObject))).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceEvents"));
                  cEvents.assign(ghProp.unwrapBufferField().value());
               }
               /* {get Prop var [handle]} */ 
               
               if (_or(matchesList(cEvents, "updateState"), () -> isUnknown(cEvents)))
               {
                  ghTargetProcedure.assign(targetProcedure());
                  silent(() -> ControlFlowOps.invokeInWithMode("updateState", hObject, "I", pcState));
                  ghTargetProcedure.setUnknown();
               }
            }));
         }
         /* outgoing events */
         returnNormal();
      }));
   }

   /** _UIB-CODE-BLOCK-END */
   /**
    * ***********************  Function Implementations****************
    */
   public logical addQueryWhere(final character _pcWhere_1, final character _pcObject_2, final character _pcAndOr_1)
   {
      character pcWhere_1 = TypeFactory.initInput(_pcWhere_1);
      character pcObject_2 = TypeFactory.initInput(_pcObject_2);
      character pcAndOr_1 = TypeFactory.initInput(_pcAndOr_1);
      /*------------------------------------------------------------------------------
        Purpose:  SBO version of this where-clause function, which simply passes
                  the parameters on to the SDO named in the pcObject argument.
         Params:  pcWhere AS CHAR (as for query.p function addQueyrWhere),
                  pcBuffer AS CHAR (must be an SDO ObjectName),
                  pcAndOr AS CHAR as for query.p fn)
          Notes:  Currently the pcObject argument must be specified.
      ------------------------------------------------------------------------------*/
      handle hObject = TypeFactory.handle();
      
      return function("addQueryWhere", logical.class, new Block((Body) () -> 
      {
         hObject.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", pcObject_2));
         
         if ((hObject.isValid()).booleanValue())
         {
            returnNormal(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "addQueryWhere", hObject, "III", pcWhere_1, "", pcAndOr_1));
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character addRow(final character _pcViewColList_3)
   {
      character pcViewColList_3 = TypeFactory.initInput(_pcViewColList_3);
      /*------------------------------------------------------------------------------
        Purpose: SBO version of this function, which passes the column list on to the
                 contained DataObject which manages that data.
                 Returns a chr(1) separated list of RowIdent(s) (separated with 
                 semicolon for each object) and values corresponding to the passed 
                 list.  
         Params: pcViewColList AS CHARACTER
                 - List of columns qualifed with ObjectName or unqualified. 
          Notes: ALL or NONE columns must be qualified! 
      ------------------------------------------------------------------------------*/
      handle hRequester = TypeFactory.handle();
      character cTargetNames = TypeFactory.character();
      
      return function("addRow", character.class, new Block((Body) () -> 
      {
         /* NOTE: AT least temporarily, we may need to get this value to get at
              the real calling object. */
         /* {get Prop var [handle]} */
         hRequester.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getTargetProcedure", sourceProcedure()));
         
         if (_not(hRequester.isValid()))
         {
            hRequester.assign(sourceProcedure());
         }
         
         /* {get Prop var [handle]} */
         cTargetNames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdateTargetNames", hRequester));
         returnNormal(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "newDataObjectRow", targetProcedure(), "III", "add", cTargetNames, pcViewColList_3));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   private logical appendContainedObjects(final character pcObjects_1, final handle _phObject_1)
   {
      handle phObject_1 = TypeFactory.initInput(_phObject_1);
      /*------------------------------------------------------------------------------
        Purpose:  internal function to build the list of ContainedObjects
                   in top-down Data-link order.
          Notes:  private function
      ------------------------------------------------------------------------------*/
      integer iTarget = TypeFactory.integer();
      character cTargets = TypeFactory.character();
      
      return function("appendContainedObjects", logical.class, new Block((Body) () -> 
      {
         pcObjects_1.assign(concat(pcObjects_1, (_isEqual(pcObjects_1, "") ? new character("") : new character(",")), valueOf(phObject_1)));
         ghProp.assign(handle.fromString(entry(1, phObject_1.unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
         cTargets.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr42 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cTargets);
            }
         };
         ToClause toClause44 = new ToClause(iTarget, 1, resExpr42);
         
         doTo("loopLabel64", toClause44, new Block((Body) () -> 
         {
            appendContainedObjects(wrap(pcObjects_1, true), handle.fromString(entry(iTarget, cTargets)));
         }));
         
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical applyContextFromServer(final character _pcContext_1)
   {
      character pcContext_1 = TypeFactory.initInput(_pcContext_1);
      /*------------------------------------------------------------------------------
        Purpose: Apply context returned from server after a server call
          Notes: 
             Typical usage:    
                 cContext = obtainContextForServer()
                 run <statelesscall>.p (object,
                                        input-output cContext). 
                 applyContextFromServer(cContext)               
      ------------------------------------------------------------------------------*/
      character cContainedObjects = TypeFactory.character();
      integer iObject = TypeFactory.integer();
      character cQueryString = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      logical lAsHasStarted = TypeFactory.logical();
      
      return function("applyContextFromServer", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         lAsHasStarted.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getAsHasStarted", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cContainedObjects.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr43 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cContainedObjects);
            }
         };
         ToClause toClause45 = new ToClause(iObject, 2, resExpr43);
         
         doTo("loopLabel65", toClause45, new Block((Body) () -> 
         {
            hObject.assign(handle.fromString(entry(iObject, cContainedObjects)));
            /* {get Prop var [handle]} */
            cQueryString.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryString", hObject));
            
            if (_isEqual(cQueryString, ""))
            {
               /* QueryWhere should normally be ? at this stage, but it might
                          have been set from an external call */
               /* {get Prop var [handle]} */
               cQueryString.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryWhere", hObject));
               
               if (_and(notUnknown(cQueryString), () -> isNotEqual(cQueryString, "")))
               {
                  /* {set Prop value [handle]} */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryString", hObject, "I", cQueryString);
               }
            }
         }));
         
         /* Do iObject = 1 to num-entries(cContainedObjects) */
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignContainedProperties", targetProcedure(), "II", pcContext_1, "QueryWhere,QueryContext,OpenQuery,BaseQuery");
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cContainedObjects.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr44 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cContainedObjects);
            }
         };
         ToClause toClause46 = new ToClause(iObject, 2, resExpr44);
         
         doTo("loopLabel66", toClause46, new Block((Body) () -> 
         {
            hObject.assign(handle.fromString(entry(iObject, cContainedObjects)));
            /* {get Prop var [handle]} */
            cQueryString.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getQueryString", hObject));
            
            if (_isEqual(cQueryString, ""))
            {
               /* {get Prop var [handle]} */
               cQueryString.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getBaseQuery", hObject));
               /* {set Prop value [handle]} */
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryString", hObject, "I", cQueryString);
            }
         }));
         
         /* Do iObject = 1 to num-entries(cContainedObjects) */
         /* {set Prop value [handle]} */ 
         ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setAsHasStarted", targetProcedure(), "I", true);
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical assignCurrentMappedObject(final handle _phRequester_2, final character _pcObjectName_2)
   {
      handle phRequester_2 = TypeFactory.initInput(_phRequester_2);
      character pcObjectName_2 = TypeFactory.initInput(_pcObjectName_2);
      /*------------------------------------------------------------------------------
        Purpose:  Identifies the "current" contained Data Object for purposes of 
                  Navigation or other access by the caller.
         Params:  phRequester AS HANDLE, pcObjectName AS CHARACTER
          Notes:  This function maps the caller to the specified DataObject using the
                  ObjectMapping property.
      ------------------------------------------------------------------------------*/
      handle hObject = TypeFactory.handle();
      character cMapping = TypeFactory.character();
      integer iObject = TypeFactory.integer();
      character cTargets = TypeFactory.character();
      
      return function("assignCurrentMappedObject", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         hObject /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", pcObjectName_2));
         
         if ((hObject.isValid()).booleanValue())
         {
            iObject.assign(lookup(valueOf(phRequester_2), cMapping));
            
            if (_isNotEqual(iObject, 0))
            {
 /* Change the mapping if the source is there */
               cMapping.replaceEntry(plus(iObject, 1), valueOf(hObject));
            }
            else
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
               cTargets.assign(ghProp.unwrapBufferField().value());
               
               if ((matchesList(cTargets, valueOf(phRequester_2))).booleanValue())
               {
                  ControlFlowOps.invokeInWithMode("addDataTarget", targetProcedure(), "I", phRequester_2);
               }
            }
            returnNormal(true);
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical assignQuerySelection(final character _pcColumns_4, final character _pcValues_2, final character _pcOperators_3)
   {
      character pcColumns_4 = TypeFactory.initInput(_pcColumns_4);
      character pcValues_2 = TypeFactory.initInput(_pcValues_2);
      character pcOperators_3 = TypeFactory.initInput(_pcOperators_3);
      /*------------------------------------------------------------------------------
        Purpose:  SBO version of this where-clause function, which separates the
                  Columns by SDO and passes columns, values, and operators on to
                  the appropriate SDO(s).
         Params:  pcColumns AS CHAR, pcValues AS CHAR, pcOperators AS CHAR --
                  all as for the query.p assignQuerySelection function
          Notes:  All columns must be qualified by their SDO Objectname as TableName;
                  this will be replaced with RowObject when the columns are passed
                  on to the SDO.
      ------------------------------------------------------------------------------*/
      integer iColumn = TypeFactory.integer();
      character cCols = TypeFactory.character("");
      character cVals = TypeFactory.character("");
      character cOps = TypeFactory.character("");
      character cObjectNames = TypeFactory.character();
      character cColumn = TypeFactory.character();
      integer iName = TypeFactory.integer();
      character cString = TypeFactory.character();
      logical lSuccess = TypeFactory.logical();
      handle hObject = TypeFactory.handle();
      
      return function("assignQuerySelection", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cObjectNames.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectNames", targetProcedure()));
         
         loopLabel67:
         for (iColumn.assign(1); _isLessThanOrEqual(iColumn, numEntries(cObjectNames)); iColumn.increment())
         {
            /* Initialize these to hold the cols, values, and ops for each SDO. 
                     Use a delimiter of CHR(2) between groups for each SDO. */
            cCols.assign(concat(cCols, (_isEqual(iColumn, 1) ? new character("") : chr(2))));
         }
         
         /* END DO iColumn -- initialization of delimiters */
         cVals.assign(cCols);
         
         /* If the request specified an operator per column, then initialize
              accordingly; otherwise just store the one entry passed in to us. */
         if (_isGreaterThan(numEntries(pcOperators_3), 1))
         {
            cOps.assign(cCols);
         }
         else
         {
            cOps.assign(pcOperators_3);
         }
         
         loopLabel68:
         for (iColumn.assign(1); _isLessThanOrEqual(iColumn, numEntries(pcColumns_4)); iColumn.increment())
         {
            cColumn.assign(entry(iColumn, pcColumns_4));
            
            if (_isNotEqual(numEntries(cColumn, "."), 2))
            {
               returnNormal(false);
            }
            
            /* Must be qualified by ObjectName */
            iName.assign(lookup(entry(1, cColumn, "."), cObjectNames));
            
            if (_isEqual(iName, 0))
            {
               returnNormal(false);
            }
            
            cString.assign(entry(iName, cCols, chr(2)));
            cString.assign(concat(cString, (_isEqual(cString, "") ? new character("") : new character(",")), "RowObject.", entry(2, cColumn, ".")));
            cCols.replaceEntry(iName, chr(2), cString);
            /* Now add the corresponding value to its list. */
            cString.assign(entry(iName, cVals, chr(2)));
            cString.assign(concat(cString, (_isEqual(cString, "") ? new character("") : chr(1)), entry(iColumn, pcValues_2, chr(1))));
            cVals.replaceEntry(iName, chr(2), cString);
            
            /* Finally put the operator in its list, unless there's only one
                      (or none) for the whole list). */
            if (_isGreaterThan(numEntries(pcOperators_3), 1))
            {
               cString.assign(entry(iName, cOps, chr(2)));
               cString.assign(concat(cString, (_isEqual(cString, "") ? new character("") : new character(",")), entry(iColumn, pcOperators_3)));
               cOps.replaceEntry(iName, chr(2), cString);
            }
         }
         
         IntegerExpression resExpr45 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cObjectNames);
            }
         };
         ToClause toClause47 = new ToClause(iName, 1, resExpr45);
         
         doTo("loopLabel69", toClause47, new Block((Body) () -> 
         {
            cColumn.assign(entry(iName, cCols, chr(2)));
            
            if (_isNotEqual(cColumn, ""))
            {
               hObject.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", entry(iName, cObjectNames)));
               lSuccess.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "assignQuerySelection", hObject, "III", entry(iName, cCols, chr(2)), entry(iName, cVals, chr(2)), _isLessThanOrEqual(numEntries(pcOperators_3), 1) ? pcOperators_3 : entry(iName, cOps, chr(2))));
               
               if (_not(lSuccess))
               {
                  returnNormal(false);
               }
            }
         }));
         
         /* END DO iName */
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character cancelRow()
   {
      /*------------------------------------------------------------------------------
        Purpose:  SBO version of this function, which passes the request
                  on to the contained DataObject which manages that data.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      handle hRequester = TypeFactory.handle();
      integer iEntry = TypeFactory.integer();
      handle hTarget = TypeFactory.handle();
      character cTargetNames = TypeFactory.character();
      character cTargetName = TypeFactory.character();
      logical lAutoCommit = TypeFactory.logical();
      character cHandleList = TypeFactory.character();
      
      return function("cancelRow", character.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */
         hRequester.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getTargetProcedure", sourceProcedure()));
         
         /* NOTE: AT least temporarily, we may need to get this value to get at
              the real calling object. */
         if (_not(hRequester.isValid()))
         {
            hRequester.assign(sourceProcedure());
         }
         
         /* The UpdatTargetNames property is set in the caller and identifies the 
              intended target for the add. The user may specify it to solve cases 
              where fieldname recognition is not sufficient to find the correct target. 
              If not defined by the user it is updated in updateObjectMapping. */
         /* {get Prop var [handle]} */
         cTargetNames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdateTargetNames", hRequester));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("AutoCommit"));
         lAutoCommit.assign(ghProp.unwrapBufferField().value());
         
         if ((lAutoCommit).booleanValue())
         {
            IntegerExpression resExpr46 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cTargetNames);
               }
            };
            ToClause toClause48 = new ToClause(iEntry, 1, resExpr46);
            
            doTo("loopLabel70", toClause48, new Block((Body) () -> 
            {
               cTargetName.assign(entry(iEntry, cTargetNames));
               hTarget /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "DataObjectHandle", targetProcedure(), "I", cTargetName));
               
               if ((hTarget.isValid()).booleanValue())
               {
                  /* {set Prop value [handle]} */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectState", hTarget, "I", "NoUpdates");
               }
            }));
         }
         
         IntegerExpression resExpr47 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cTargetNames);
            }
         };
         ToClause toClause49 = new ToClause(iEntry, 1, resExpr47);
         
         doTo("loopLabel71", toClause49, new Block((Body) () -> 
         {
            cTargetName.assign(entry(iEntry, cTargetNames));
            hTarget /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "DataObjectHandle", targetProcedure(), "I", cTargetName));
            
            if ((hTarget.isValid()).booleanValue())
            {
               cHandleList.assign(concat(cHandleList, (_isEqual(cHandleList, "") ? new character("") : new character(",")), valueOf(hTarget)));
               /* {fn <func-name> [handle] */
               ControlFlowOps.invokeDynamicFunctionIn(character.class, "cancelRow", hTarget);
            }
         }));
         
         loopLabel72:
         for (iEntry.assign(1); _isLessThanOrEqual(iEntry, numEntries(cHandleList)); iEntry.increment())
         {
            hTarget.assign(handle.fromString(entry(iEntry, cHandleList)));
            NamedEventManager.publish("dataAvailable", hTarget, "I", new Object[]
            {
               "RESET"
            });
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical canNavigate()
   {
      /*------------------------------------------------------------------------------
        Purpose: Check if this object or its children has any updates.   
                 This SBO version of the function turns around and returns 
                 canNavigate from the SDO to which the caller is mapped.
                 Otherwise it publishes isUpdatePending to its targets
          Notes: This returns true if we can navigate while isUpdatePending is the 
                 opposite and returns true if update is pending. 
                (The real reason: It's easier to have default false for i-o params)   
               - See data.p for details.   
      ----------------------------------------------------------------------------*/
      character cMapping = TypeFactory.character();
      integer iObject = TypeFactory.integer();
      handle hObject = TypeFactory.handle();
      handle hRequester = TypeFactory.handle();
      logical lCanNavigate = TypeFactory.logical();
      
      return function("canNavigate", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */
         silent(() -> hRequester.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getTargetProcedure", sourceProcedure())));
         
         if (_not(hRequester.isValid()))
         {
            hRequester.assign(sourceProcedure());
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         iObject.assign(lookup(valueOf(hRequester), cMapping));
         
         if (_isEqual(iObject, 0))
         {
            silent(() -> 
            {
               ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
               hObject.assign(ghProp.unwrapBufferField().value());
            });
         }
         else
         {
            hObject.assign(handle.fromString(entry(plus(iObject, 1), cMapping)));
         }
         /* {get Prop var [handle]} */ 
         
         silent(() -> lCanNavigate /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "canNavigate", hObject)));
         returnNormal(_isEqual(lCanNavigate, false) ? new logical(false) : new logical(true));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnColumnLabel(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnColumnLabel", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its Column Label by passing the
                     request along to the appropriate Data Object.  
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
             Notes:  The SDO columnDataType option of permitting a name qualified by
                     database table name is not supported.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("ColumnLabel"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnDataType(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnDataType", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its data-type by passing the
                     request along to the appropriate Data Object.  
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
             Notes:  The SDO columnDataType option of permitting a name qualified by
                     database table name is not supported.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("DataType"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnDbColumn(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnDbColumn", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its DB column name by passing the
                     request along to the appropriate Data Object. 
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("DbColumn"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnExtent(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnExtent", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its Extent by passing the
                     request along to the appropriate Data Object.  
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
             Notes:  The SDO columnDataType option of permitting a name qualified by
                     database table name is not supported.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("Extent"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnFormat(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnFormat", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its Format by passing the
                     request along to the appropriate Data Object.  
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
             Notes:  The SDO columnDataType option of permitting a name qualified by
                     database table name is not supported.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("Format"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnHelp(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnHelp", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its help string by passing the
                     request along to the appropriate Data Object.  
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
             Notes:  The SDO columnDataType option of permitting a name qualified by
                     database table name is not supported.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("Help"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnInitial(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnInitial", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its initial value by passing the
                     request along to the appropriate Data Object.  
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
             Notes:  The SDO columnDataType option of permitting a name qualified by
                     database table name is not supported.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("Initial"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnLabel(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnLabel", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its Label by passing the
                     request along to the appropriate Data Object. 
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("Label"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical columnMandatory(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      /*------------------------------------------------------------------------------
        Purpose:  Takes a column name, either unqualified or qualified by
                  the SDO ObjectName, and returns its Mandatory setting by passing the
                  request along to the appropriate Data Object.  
         Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                  qualified by SDO ObjectName.
          Notes:  The SDO columnDataType option of permitting a name qualified by
                  database table name is not supported.
      ------------------------------------------------------------------------------*/
      character cMandatory = TypeFactory.character();
      
      return function("columnMandatory", logical.class, new Block((Body) () -> 
      {
         /* This fn does the work. */
         cMandatory.assign(columnProperty(pcColumn_23, new character("Mandatory"), targetProcedure()));
         
         if (_or(isEqual(cMandatory, "YES"), () -> isEqual(cMandatory, "TRUE")))
         {
            returnNormal(true);
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical columnModified(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      /*------------------------------------------------------------------------------
        Purpose:  Takes a column name, either unqualified or qualified by
                  the SDO ObjectName, and returns its Modified setting by passing the
                  request along to the appropriate Data Object.  
         Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                  qualified by SDO ObjectName.
          Notes:  The SDO columnDataType option of permitting a name qualified by
                  database table name is not supported.
      ------------------------------------------------------------------------------*/
      character cModified = TypeFactory.character();
      
      return function("columnModified", logical.class, new Block((Body) () -> 
      {
         /* This fn does the work. */
         cModified.assign(columnProperty(pcColumn_23, new character("Modified"), targetProcedure()));
         
         if (_or(isEqual(cModified, "YES"), () -> isEqual(cModified, "TRUE")))
         {
            returnNormal(true);
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle columnObjectHandle(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      /*------------------------------------------------------------------------------
        Purpose: Takes an unqualified SDO column name and returns the procedure
                 handle of the first SDO in this SBO that has that column name.
         Params: pcColumn AS CHARACTER 
          Notes: Column Name requests for SBOs should normally be qualified by
                 their SDO ObjectName. This function is called is there is no
                 qualifier to return the handle of the SDO, used by other functions. 
      ------------------------------------------------------------------------------*/
      character cColumns = TypeFactory.character();
      integer iDo = TypeFactory.integer();
      character cObjects = TypeFactory.character();
      
      return function("columnObjectHandle", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataColumns"));
         cColumns.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cObjects.assign(ghProp.unwrapBufferField().value());
         
         loopLabel73:
         for (iDo.assign(1); _isLessThanOrEqual(iDo, numEntries(cColumns, ";")); iDo.increment())
         {
            /* Extract each SDO list. */
            if (_isNotEqual(lookup(pcColumn_23, entry(iDo, cColumns, ";")), 0))
            {
               returnNormal(handle.fromString(entry(iDo, cObjects)));
            }
         }
         
         /* END DO iDO */
         returnNormal(new handle());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnPhysicalColumn(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnPhysicalColumn", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its Physical column name by passing the
                     request along to the appropriate Data Object. 
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("PhysicalColumn"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnPhysicalTable(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnPhysicalTable", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its PhysicalTable name by passing the
                     request along to the appropriate Data Object. 
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("PhysicalTable"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnPrivateData(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnPrivateData", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its PRIVATE-DATA by passing the
                     request along to the appropriate Data Object. 
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("PrivateData"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   private character columnProperty(final character _pcColumn_23, final character _pcProperty_1, final handle _phTarget_1)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      character pcProperty_1 = TypeFactory.initInput(_pcProperty_1);
      handle phTarget_1 = TypeFactory.initInput(_phTarget_1);
      /*------------------------------------------------------------------------------
        Purpose:  General purpose function used internally to identify the
                  SDO in which one of the column<property> functions should be
                  run and to run it and return the value.
                  Takes a column name, either unqualified or qualified by
                  the SDO ObjectName, and returns its property value by passing the
                  request along to the appropriate Data Object. If the column name
                  is not qualified by the SDO ObjectName, the first matching column
                  name is used to identify which SDO to pass the request along to.
                  
         Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                  qualified by SDO ObjectName;
                  pcProperty AS CHARACTER -- the property name to retrieve;
                  phTarget AS HANDLE -- Target procedure handle
      ------------------------------------------------------------------------------*/
      character cColumn = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      character cObject = TypeFactory.character();
      
      return function("columnProperty", character.class, new Block((Body) () -> 
      {
         if (_isEqual(numEntries(pcColumn_23, "."), 2))
         {
            cColumn.assign(entry(2, pcColumn_23, "."));
            cObject.assign(entry(1, pcColumn_23, "."));
            hObject.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", phTarget_1, "I", cObject));
         }
 /* Use ObjectName qualifier */         else
         {
            cColumn.assign(pcColumn_23);
             /* Use the unqualified name */hObject.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "columnObjectHandle", phTarget_1, "I", cColumn));
         }
         
         if ((hObject.isValid()).booleanValue())
         {
            returnNormal(ControlFlowOps.invokeDynamicFunctionInWithMode(concat("column", pcProperty_1), hObject, "I", cColumn));
         }
         else
         {
            returnNormal(new character());
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnQuerySelection(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnQuerySelection", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its QuerySelection by passing the
                     request along to the appropriate Data Object. 
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("QuerySelection"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical columnReadOnly(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      /*------------------------------------------------------------------------------
        Purpose:  Takes a column name, either unqualified or qualified by
                  the SDO ObjectName, and returns its ReadOnly setting by passing the
                  request along to the appropriate Data Object.  
         Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                  qualified by SDO ObjectName.
          Notes:  The SDO columnDataType option of permitting a name qualified by
                  database table name is not supported.
      ------------------------------------------------------------------------------*/
      character cReadOnly = TypeFactory.character();
      
      return function("columnReadOnly", logical.class, new Block((Body) () -> 
      {
         /* This fn does the work. */
         cReadOnly.assign(columnProperty(pcColumn_23, new character("ReadOnly"), targetProcedure()));
         
         if (_or(isEqual(cReadOnly, "YES"), () -> isEqual(cReadOnly, "TRUE")))
         {
            returnNormal(true);
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnStringValue(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnStringValue", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its String-Value by passing the
                     request along to the appropriate Data Object. 
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("StringValue"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnTable(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnTable", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its Table name by passing the
                     request along to the appropriate Data Object. 
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("Table"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnValExp(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnValExp", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its Validation Expression by passing the
                     request along to the appropriate Data Object. 
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("ValExp"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnValMsg(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnValMsg", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its ValMsg by passing the
                     request along to the appropriate Data Object. 
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("ValMsg"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character columnValue(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnValue", character.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its Value by passing the
                     request along to the appropriate Data Object. 
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(columnProperty(pcColumn_23, new character("Value"), targetProcedure()));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public decimal columnWidth(final character _pcColumn_23)
   {
      character pcColumn_23 = TypeFactory.initInput(_pcColumn_23);
      
      return function("columnWidth", decimal.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Takes a column name, either unqualified or qualified by
                     the SDO ObjectName, and returns its Width by passing the
                     request along to the appropriate Data Object. 
            Params:  pcColumn AS CHARACTER -- RowObject column name, optionally
                     qualified by SDO ObjectName.
         ------------------------------------------------------------------------------*/
         /* This fn does the work. */
         returnNormal(new decimal(columnProperty(pcColumn_23, new character("Width"), targetProcedure())));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character colValues(final character _pcColumns_4)
   {
      character pcColumns_4 = TypeFactory.initInput(_pcColumns_4);
      /*------------------------------------------------------------------------------
        Purpose:  SBO version of colValues to locate requested columns in contained
                  Data Objects and assemble a list of their values.
         Params:  pcColumns AS CHARACTER -- comma-separated list of requested cols.
                  - All qualified with objectname
                  - One objectname qualified column will direct the call 
                    to that SDO. 
                  - unqualifed columns will use the value of the first column 
                    encountered. (no ambiguity check)                
                  The 'Rowident' will be a ; separated list of RowIdents 
                  for all contained SDOs, also if only one SDO was encountered.
                  The entry for SDOs for which no fields are requested will be blank.
                  if pcColumns is blank then ALL SDOs rowids will be returned.
                  For calls where one or more 
      ------------------------------------------------------------------------------*/
      character cColValues = TypeFactory.character();
      character cDonames = TypeFactory.character();
      character cContainedDataColumns = TypeFactory.character();
      character cContainedDataObjects = TypeFactory.character();
      character cColumn = TypeFactory.character();
      integer iCol = TypeFactory.integer();
      integer iDo = TypeFactory.integer();
      handle hDo = TypeFactory.handle();
      character cValue = TypeFactory.character();
      logical lColFound = TypeFactory.logical();
      character cColumnNames = TypeFactory.character();
      character cObjectName = TypeFactory.character();
      character cRowids = TypeFactory.character();
      handle hRowObject = TypeFactory.handle();
      
      return function("colValues", character.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cDonames.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectNames", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cContainedDataObjects.assign(ghProp.unwrapBufferField().value());
         /* List of contained Data Objects */
         /* We return a ; separated list of rowids as the first entry,
             we leave the entries blank if no fields were requested from the object
             but if no fields were requested at all we return all , */
         cRowids.assign(fill(";", minus(numEntries(cDonames), 1)));
         
         if (_isEqual(pcColumns_4, ""))
         {
            IntegerExpression resExpr48 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cContainedDataObjects);
               }
            };
            ToClause toClause50 = new ToClause(iDo, 1, resExpr48);
            
            doTo("loopLabel74", toClause50, new Block((Body) () -> 
            {
               hDo.assign(handle.fromString(entry(iDo, cContainedDataObjects)));
               
               if (_not(hDo.isValid()))
               {
                  returnNormal(new character());
               }
               
               /* Haven't been initialized yet. */
               /* {get Prop var [handle]} */
               hRowObject.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObject", hDo));
               cRowids.replaceEntry(iDo, ";", _notUnknown(hRowObject.unwrapBuffer().rowID()) ? valueOf(hRowObject.unwrapBuffer().rowID()) : new character("?"));
            }));
            
            returnNormal(concat(cRowids, chr(1)));
         }
         
         /* no columns requested */
         /* One qualified column qualifies all */
         if (_isGreaterThan(indexOf(pcColumns_4, "."), 0))
         {
            IntegerExpression resExpr49 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cDonames);
               }
            };
            ToClause toClause51 = new ToClause(iDo, 1, resExpr49);
            
            doTo("loopLabel75", toClause51, new Block((Body) () -> 
            {
               cObjectName.assign(entry(iDo, cDonames));
               cColumnNames.assign(leftTrim(replaceAll(concat(",", pcColumns_4), concat(",", cObjectName, "."), ","), ","));
               
               if (_isEqual(indexOf(cColumnNames, "."), 0))
               {
                  hDo /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", cObjectName));
                  
                  /* Haven't been initialized yet  */
                  if (_not(hDo.isValid()))
                  {
                     returnNormal(new character());
                  }
                  
                  cColValues /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", hDo, "I", cColumnNames));
                  /* Put the rowid part of the returned colvalues in the rowid list*/
                  cRowids.replaceEntry(iDo, ";", entry(1, cColValues));
                  /* then replace this list with the rowid part */
                  cColValues.replaceEntry(1, chr(1), cRowids);
                  returnNormal(cColValues);
               }
            }));
            
            cObjectName.assign("");
            hDo.setUnknown();
            
            IntegerExpression resExpr50 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(pcColumns_4);
               }
            };
            ToClause toClause52 = new ToClause(iCol, 1, resExpr50);
            
            doTo("loopLabel76", toClause52, new Block((Body) () -> 
            {
               cColumn.assign(entry(iCol, pcColumns_4));
               
               /* All columns must be qualified. We might probably get here if not 
                       initialized if the logic above failed (?) */
               if (_isNotEqual(numEntries(cColumn, "."), 2))
               {
                  returnNormal(new character());
               }
               
               /* We don't need to keep regetting the SDO handle. */
               if (_isNotEqual(cObjectName, entry(1, cColumn, ".")))
               {
                  cObjectName.assign(entry(1, cColumn, "."));
                  hDo /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", cObjectName));
                  iDo.assign(lookup(cObjectName, cDonames));
                  
                  /* Haven't been initialized  */
                  if (_not(hDo.isValid()))
                  {
                     returnNormal(new character());
                  }
                  
                  /* if this is the first time this object was encountered get the ROWID */
                  if (_isEqual(entry(iDo, cRowids, ";"), ""))
                  {
                     /* {get Prop var [handle]} */
                     hRowObject.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObject", hDo));
                     cRowids.replaceEntry(iDo, ";", _notUnknown(hRowObject.unwrapBuffer().rowID()) ? valueOf(hRowObject.unwrapBuffer().rowID()) : new character("?"));
                  }
               }
               cValue.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnValue", hDo, "I", entry(2, cColumn, ".")));
               cColValues.assign(concat(cColValues, chr(1), _isUnknown(cValue) ? new character("?") : cValue));
            }));
         }
         else
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataColumns"));
            cContainedDataColumns.assign(ghProp.unwrapBufferField().value());
            
            loopLabel77:
            for (iCol.assign(1); _isLessThanOrEqual(iCol, numEntries(pcColumns_4)); iCol.increment())
            {
               cColumn.assign(entry(iCol, pcColumns_4));
               lColFound.assign(false);
               
               IntegerExpression resExpr51 = new IntegerExpression()
               {
                  public integer execute()
                  {
                     return numEntries(cContainedDataColumns, ";");
                  }
               };
               ToClause toClause53 = new ToClause(iDo, 1, resExpr51);
               
               doTo("loopLabel78", toClause53, new Block((Body) () -> 
               {
                  if ((matchesList(entry(iDo, cContainedDataColumns, ";"), cColumn)).booleanValue())
                  {
                     hDo.assign(handle.fromString(entry(iDo, cContainedDataObjects)));
                     
                     /* Haven't been initialized yet or not available  */
                     if (_not(hDo.isValid()))
                     {
                        returnNormal(new character());
                     }
                     
                     cValue.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnValue", hDo, "I", cColumn));
                     cColValues.assign(concat(cColValues, chr(1), _isUnknown(cValue) ? new character("?") : cValue));
                     lColFound.assign(true);
                     
                     /* if this is the first time this object was requested get the ROWID  */
                     if (_isEqual(entry(iDo, cRowids, ";"), ""))
                     {
                        /* {get Prop var [handle]} */
                        hRowObject.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObject", hDo));
                        cRowids.replaceEntry(iDo, ";", _notUnknown(hRowObject.unwrapBuffer().rowID()) ? valueOf(hRowObject.unwrapBuffer().rowID()) : new character("?"));
                     }
                     
                     /* first object encounter */
                     leave("loopLabel78");
                  }
               }));
               
               /* do iDo */
               if (_not(lColFound))
               {
                  returnNormal(new character());
               }
            }
         }
         /* cColValues is prepended with chr(1) already */
         returnNormal(concat(cRowids, cColValues));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character copyRow(final character _pcViewColList_3)
   {
      character pcViewColList_3 = TypeFactory.initInput(_pcViewColList_3);
      /*------------------------------------------------------------------------------
        Purpose: SBO version of this function, which passes the column list on to the
                 contained DataObject which manages that data.
                 Returns a chr(1) separated list of RowIdent(s) (separated with 
                 semicolon for each object) and values corresponding to the passed 
                 list.  
         Params: pcViewColList AS CHARACTER
                 - List of columns qualifed with ObjectName or unqualified. 
          Notes: ALL or NONE columns must be qualified! 
      ------------------------------------------------------------------------------*/
      handle hRequester = TypeFactory.handle();
      character cTargetNames = TypeFactory.character();
      
      return function("copyRow", character.class, new Block((Body) () -> 
      {
         /* NOTE: AT least temporarily, we may need to get this value to get at
              the real calling object. */
         /* {get Prop var [handle]} */
         hRequester.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getTargetProcedure", sourceProcedure()));
         
         if (_not(hRequester.isValid()))
         {
            hRequester.assign(sourceProcedure());
         }
         
         /* {get Prop var [handle]} */
         cTargetNames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdateTargetNames", hRequester));
         returnNormal(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "newDataObjectRow", targetProcedure(), "III", "copy", cTargetNames, pcViewColList_3));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character currentMappedObject(final handle _phRequester_2)
   {
      handle phRequester_2 = TypeFactory.initInput(_phRequester_2);
      /*------------------------------------------------------------------------------
        Purpose:  Returns the object name which is currently mapped to this caller.
         Params:  input phRequester AS HANDLE
          Notes:  The value is derived from the ObjectMapping property in the SDO.
      ------------------------------------------------------------------------------*/
      character cMapping = TypeFactory.character();
      integer iObject = TypeFactory.integer();
      handle hObject = TypeFactory.handle();
      character cObjectName = TypeFactory.character();
      
      return function("currentMappedObject", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         iObject.assign(lookup(valueOf(phRequester_2), cMapping));
         
         if (_isGreaterThan(iObject, 0))
         {
            hObject.assign(handle.fromString(entry(plus(iObject, 1), cMapping)));
            silent(() -> 
            {
               ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
               ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
               cObjectName.assign(ghProp.unwrapBufferField().value());
            });
            returnNormal(cObjectName);
         }
         else
         {
            returnNormal(new character());
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle dataContainerHandle()
   {
      /*------------------------------------------------------------------------------
        Purpose: The DataContainer handle is an appserver aware container that can 
                 handle data requests and also is the container of this object. 
                 This can be a standard container or an sbo. This function also 
                 encapsulates the required checks of this object's AppServer properties
                 and only returns the handle if the current or permanent state allows 
                 it to be part of a stateless request handled by another object. 
          Notes: It is rather likely that the DataContainer role and client container
                 role will be in separate objects in the future.      
               - Currently duplicated in data.p.  
               - Used in openQuery and fetchContainedRows 
      ------------------------------------------------------------------------------*/
      character cAsdivision = TypeFactory.character();
      handle hSource = TypeFactory.handle();
      logical lDataContainer = TypeFactory.logical();
      logical lSbo = TypeFactory.logical();
      
      return function("dataContainerHandle", handle.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainerSource"));
         hSource.assign(ghProp.unwrapBufferField().value());
         
         if ((hSource.isValid()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, hSource.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataContainer"));
            lDataContainer.assign(ghProp.unwrapBufferField().value());
            ghProp.assign(handle.fromString(entry(1, hSource.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
            lSbo.assign(ghProp.unwrapBufferField().value());
            
            if (_and(lDataContainer, not(lSbo)))
            {
               /* Check AppServer properties to see if the object has no current or future 
                       server bindings and is using a stateless operating mode.*/
               if ((new logical( /* {fn <func-name> [handle] */ ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasNoServerBinding", targetProcedure()))).booleanValue())
               {
                  returnNormal(hSource);
               }
            }
            else
            {
               /* {get Prop var [handle]} */
               silent(() -> cAsdivision.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getASDivision", hSource)));
               
               if (_isEqual(cAsdivision, "Client"))
               {
                  returnNormal(hSource);
               }
            }
         }
         returnNormal(new handle());
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle dataObjectHandle(final character _pcObjectName_2)
   {
      character pcObjectName_2 = TypeFactory.initInput(_pcObjectName_2);
      /*------------------------------------------------------------------------------
        Purpose: Given the ObjectName (logical name) of a contained SDO,
                 returns the handle of that SDO. 
         Params: INPUT pcObjectName AS CHARACTER
      ------------------------------------------------------------------------------*/
      character cObjectNames = TypeFactory.character();
      character cDataHandles = TypeFactory.character();
      integer iName = TypeFactory.integer();
      
      return function("dataObjectHandle", handle.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cObjectNames.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectNames", targetProcedure()));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cDataHandles.assign(ghProp.unwrapBufferField().value());
         iName.assign(lookup(pcObjectName_2, cObjectNames));
         
         if (_isNotEqual(iName, 0))
         {
            returnNormal(handle.fromString(entry(iName, cDataHandles)));
         }
         else
         {
            returnNormal(new handle());
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical deleteRow(final character _pcRowIdent_4)
   {
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      integer iDo = TypeFactory.integer();
      integer iDo2 = TypeFactory.integer();
      character cRowIdent = TypeFactory.character();
      character cRowIdent2 = TypeFactory.character();
      handle hDataObject = TypeFactory.handle();
      handle hDataObject2 = TypeFactory.handle();
      logical lAutoCommit = TypeFactory.logical();
      logical lSuccess = TypeFactory.logical();
      character cObjectHandles = TypeFactory.character();
      handle hParent = TypeFactory.handle();
      
      return function("deleteRow", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cObjectHandles.assign(ghProp.unwrapBufferField().value());
         
         /* Something is wrong, this is NOT allowed  */
         if (_isUnknown(pcRowIdent_4))
         {
            returnNormal(false);
         }
         
         loopLabel79:
         for (iDo.assign(1); _isLessThanOrEqual(iDo, minus(numEntries(cObjectHandles), 1)); iDo.increment())
         {
            cRowIdent.assign(entry(iDo, pcRowIdent_4, ";"));
            
            /* we also sort unavailable rowident '?', probably not necessary, but   */
            if (_isNotEqual(cRowIdent, ""))
            {
               hDataObject.assign(handle.fromString(entry(iDo, cObjectHandles)));
               
               if ((hDataObject.isValid()).booleanValue())
               {
                  IntegerExpression resExpr52 = new IntegerExpression()
                  {
                     public integer execute()
                     {
                        return numEntries(cObjectHandles);
                     }
                  };
                  ToClause toClause54 = new ToClause(iDo2, plus(iDo, 1), resExpr52);
                  
                  doTo("loopLabel80", toClause54, new Block((Body) () -> 
                  {
                     cRowIdent2.assign(entry(iDo2, pcRowIdent_4, ";"));
                     
                     if (_isNotEqual(cRowIdent2, ""))
                     {
                        hDataObject2.assign(handle.fromString(entry(iDo2, cObjectHandles)));
                        
                        if ((hDataObject2.isValid()).booleanValue())
                        {
                           /* {get Prop var [handle]} */
                           hParent.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hDataObject2));
                           
                           /* if this object's DataSource is the object of the outer loop 
                                            then swap them, so the child gets first in the list. */
                           if (_isEqual(hParent, hDataObject))
                           {
                              cObjectHandles.replaceEntry(iDo2, valueOf(hDataObject));
                              pcRowIdent_4.replaceEntry(iDo2, ";", cRowIdent);
                              hDataObject.assign(hDataObject2);
                              cRowIdent.assign(cRowIdent2);
                              cObjectHandles.replaceEntry(iDo, valueOf(hDataObject2));
                              pcRowIdent_4.replaceEntry(iDo, ";", cRowIdent2);
                           }
                        }
                        else
                        {
                           returnNormal(false);
                        }
                     }
                  }));
               }
               else
               {
                  returnNormal(false);
               }
            }
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("AutoCommit"));
         lAutoCommit.assign(ghProp.unwrapBufferField().value());
         
         if ((lAutoCommit).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("BlockDataAvailable"));
            ghProp.unwrapBufferField().changeValue(new logical(true));
         }
         /* {set Prop value [handle]} */ 
         
         IntegerExpression resExpr53 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cObjectHandles);
            }
         };
         ToClause toClause55 = new ToClause(iDo, 1, resExpr53);
         
         doTo("loopLabel81", toClause55, new Block((Body) () -> 
         {
            cRowIdent.assign(entry(iDo, pcRowIdent_4, ";"));
            hDataObject.assign(handle.fromString(entry(iDo, cObjectHandles)));
            
            if (_and(isNotEqual(cRowIdent, ""), () -> isNotEqual(cRowIdent, "?")))
            {
               lSuccess.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "deleteRow", hDataObject, "I", cRowIdent));
               
               if (_not(lSuccess))
               {
                  returnNormal(false);
               }
            }
         }));
         
         /* do ido to num-entries(objects) - 1 */
         /* We disabled outgoing dataAvailable messages while deleting if autocommit
              so set it back.  */
         if ((lAutoCommit).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("BlockDataAvailable"));
            ghProp.unwrapBufferField().changeValue(new logical(false));
         }
         /* {set Prop value [handle]} */ 
         
         if (_isEqual(lSuccess, true))
         {
            if ((lAutoCommit).booleanValue())
            {
               ControlFlowOps.invokeIn("commitTransaction", targetProcedure());
               returnNormal(isNotEqual(ControlFlowOps.getReturnValue(), "ADM-ERROR"));
            }
            else
            {
                /* {set Prop value [handle]} */ ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectState", targetProcedure(), "I", "RowUpdated");
            }
            /* if there's no Commit-Source the changes will be committed now. */
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical findRowWhere(final character _pcColumns_4, final character _pcValues_2, final character _pcOperators_3)
   {
      character pcColumns_4 = TypeFactory.initInput(_pcColumns_4);
      character pcValues_2 = TypeFactory.initInput(_pcValues_2);
      character pcOperators_3 = TypeFactory.initInput(_pcOperators_3);
      /*------------------------------------------------------------------------------   
      Purpose: Find and reposition to a row 
      Parameters: 
             pcColumns   - Column names (Comma separated)                    
                           Fieldname of a table in the query in the form of 
                           TBL.FLDNM or DB.TBL.FLDNM (only if qualified with db is specified),
                           (RowObject.FLDNM should be used for SDO's)  
                           If the fieldname isn't qualified it checks the tables in 
                           the TABLES property and assumes the first with a match.
      
             pcValues    - corresponding Values (CHR(1) separated)
             pcOperators - Operator - one for all columns
                                      - blank - defaults to (EQ)  
                                      - Use slash to define alternative string operator
                                        EQ/BEGINS etc..
                                    - comma separated for each column/value
                                                              
      ---------------------------------------------------------------------------*/
      handle hSdo = TypeFactory.handle();
      character cSdoname = TypeFactory.character();
      
      return function("findRowWhere", logical.class, new Block((Body) () -> 
      {
         /* If the SDO name is specified, use it. Otherwise assume MasterSDO */
         cSdoname.assign(entry(1, entry(1, pcColumns_4), "."));
         hSdo /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "DataObjectHandle", targetProcedure(), "I", cSdoname));
         
         if (_not(hSdo.isValid()))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("MasterDataObject"));
            hSdo.assign(ghProp.unwrapBufferField().value());
         }
         else
         {
            pcColumns_4.replaceEntry(1, replaceAll(entry(1, pcColumns_4), concat(cSdoname, "."), ""));
         }
         /* {get Prop var [handle]} */ 
         
         returnNormal(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowWhere", hSdo, "III", pcColumns_4, pcValues_2, pcOperators_3));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical getFilterAvailable()
   {
      /*------------------------------------------------------------------------------
        Purpose: Return whether a filter is available. 
          Notes: 
      ------------------------------------------------------------------------------*/
      logical lFilterAvailable = TypeFactory.logical();
      
      return function("getFilterAvailable", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("FilterAvailable"));
         lFilterAvailable.assign(ghProp.unwrapBufferField().value());
         returnNormal(lFilterAvailable);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public handle getTargetProcedure()
   {
      return function("getTargetProcedure", handle.class, new Block((Body) () -> 
      {
         /*------------------------------------------------------------------------------
           Purpose:  Needed by toolbar to provide the actual caller object handle.
             Notes:  
         ------------------------------------------------------------------------------*/
         returnNormal(ghTargetProcedure);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character getUpdateSiblings(final handle _phDataObject_1)
   {
      handle phDataObject_1 = TypeFactory.initInput(_phDataObject_1);
      /*------------------------------------------------------------------------------
        Purpose:  Accepts the handle of an SDO and returns the ObjectNames of
                  all 1-to-1 siblings
          Notes:  
      ------------------------------------------------------------------------------*/
      character cDataTargetList = TypeFactory.character();
      handle hDataTarget = TypeFactory.handle();
      character cDataTarget = TypeFactory.character();
      character cSiblings = TypeFactory.character();
      integer iCount = TypeFactory.integer();
      
      return function("getUpdateSiblings", character.class, new Block((Body) () -> 
      {
         cSiblings /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getObjectName", phDataObject_1));
         cDataTargetList /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getDataTarget", phDataObject_1));
         
         IntegerExpression resExpr54 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cDataTargetList);
            }
         };
         ToClause toClause56 = new ToClause(iCount, 1, resExpr54);
         
         doTo("loopLabel82", toClause56, new Block((Body) () -> 
         {
            cDataTarget.assign(entry(iCount, cDataTargetList));
            hDataTarget.assign(handle.fromString(cDataTarget));
            
            if ((new logical( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUpdateFromSource", hDataTarget))).booleanValue())
            {
               cSiblings.assign(concat(cSiblings, ",", getUpdateSiblings(hDataTarget)));
            }
         }));
         
         returnNormal(cSiblings);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical hasActiveAudit()
   {
      /*------------------------------------------------------------------------------
        Purpose: SBO version of this property function, which checks the property 
                 in the SDO to which the caller is mapped.
         Params: 
           Note: Requires a unique SDO mapping. If caller has no property that stores
                 SDO name we assume the master.
                 
                 Currently used by the browser's hasActiveAudit.   
      ------------------------------------------------------------------------------*/
      character cDataSourceNames = TypeFactory.character();
      character cUpdateTargetNames = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      handle hRequester = TypeFactory.handle();
      
      return function("hasActiveAudit", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */
         silent(() -> hRequester.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getTargetProcedure", sourceProcedure())));
         
         if (_not(hRequester.isValid()))
         {
            hRequester.assign(sourceProcedure());
         }
         
         silent(() -> 
         {
            ghProp.assign(handle.fromString(entry(1, hRequester.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
            cDataSourceNames.assign(ghProp.unwrapBufferField().value());
         });
         
         if (_isEqual(numEntries(cDataSourceNames), 1))
         {
            hObject /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", cDataSourceNames));
         }
         else
         {
            /* {get Prop var [handle]} */
            silent(() -> cUpdateTargetNames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdateTargetNames", hRequester)));
            
            if (_isEqual(numEntries(cUpdateTargetNames), 1))
            {
               hObject /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", cUpdateTargetNames));
            }
         }
         
         /* else do */
         if ((hObject.isValid()).booleanValue())
         {
            returnNormal( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasActiveAudit", hObject));
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical hasActiveComments()
   {
      /*------------------------------------------------------------------------------
        Purpose: SBO version of this property function, which checks the property 
                 in the SDO to which the caller is mapped.
         Params: 
           Note: Requires a unique SDO mapping. If caller has no property that stores
                 SDO name we assume the master.
                 
                 Currently used by the browser's hasActiveComments.   
      ------------------------------------------------------------------------------*/
      character cDataSourceNames = TypeFactory.character();
      character cUpdateTargetNames = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      handle hRequester = TypeFactory.handle();
      
      return function("hasActiveComments", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */
         silent(() -> hRequester.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getTargetProcedure", sourceProcedure())));
         
         if (_not(hRequester.isValid()))
         {
            hRequester.assign(sourceProcedure());
         }
         
         silent(() -> 
         {
            ghProp.assign(handle.fromString(entry(1, hRequester.unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("DataSourceNames"));
            cDataSourceNames.assign(ghProp.unwrapBufferField().value());
         });
         
         if (_isEqual(numEntries(cDataSourceNames), 1))
         {
            hObject /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", cDataSourceNames));
         }
         else
         {
            /* {get Prop var [handle]} */
            silent(() -> cUpdateTargetNames.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getUpdateTargetNames", hRequester)));
            
            if (_isEqual(numEntries(cUpdateTargetNames), 1))
            {
               hObject /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", cUpdateTargetNames));
            }
         }
         
         /* else do */
         if ((hObject.isValid()).booleanValue())
         {
            returnNormal( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(logical.class, "hasActiveComments", hObject));
         }
         else
         {
            returnNormal(false);
         }
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical hasActiveTargets(final handle _phHandle_1, final logical _plCheckchild_1)
   {
      handle phHandle_1 = TypeFactory.initInput(_phHandle_1);
      logical plCheckchild_1 = TypeFactory.initInput(_plCheckchild_1);
      character cDataTargets = TypeFactory.character();
      character cDataSources = TypeFactory.character();
      character cInactiveLinks = TypeFactory.character();
      handle hGaSource = TypeFactory.handle();
      character cHandle = TypeFactory.character();
      character cMapping = TypeFactory.character();
      character cNavSource = TypeFactory.character();
      logical lHidden = TypeFactory.logical();
      integer iMap = TypeFactory.integer();
      character cObject = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      logical lQueryObject = TypeFactory.logical();
      character cChildSdos = TypeFactory.character();
      integer iChild = TypeFactory.integer();
      
      return function("hasActiveTargets", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectMapping"));
         cMapping.assign(ghProp.unwrapBufferField().value());
         cHandle.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "mappedEntry", targetProcedure(), "IIII", valueOf(phHandle_1), cMapping, false, ","));
         
         /* delimiter */
         if (_isEqual(cHandle, ""))
         {
            returnNormal(false);
         }
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("NavigationSource"));
         cNavSource.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("DataTarget"));
         cDataTargets.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         cDataSources.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         
         IntegerExpression resExpr55 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cHandle);
            }
         };
         ToClause toClause57 = new ToClause(iMap, 1, resExpr55);
         
         doTo("loopLabel83", toClause57, new Block((Body) () -> 
         {
            cObject.assign(entry(iMap, cHandle));
            
            if (_not(matchesList(cNavSource, cObject)))
            {
               hObject.assign(handle.fromString(cObject));
               
               if ((matchesList(cDataTargets, cObject)).booleanValue())
               {
                  ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                  ghProp.assign(ghProp.unwrapBuffer().bufferField("QueryObject"));
                  lQueryObject.assign(ghProp.unwrapBufferField().value());
                  
                  if ((lQueryObject).booleanValue())
                  {
                     ghProp.assign(handle.fromString(entry(1, hObject.unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("inactiveLinks"));
                     cInactiveLinks.assign(ghProp.unwrapBufferField().value());
                     
                     if (_not(matchesList(cInactiveLinks, "DataSource")))
                     {
                        returnNormal(true);
                     }
                  }
                  else
                  {
                     /* {get Prop var [handle]} */
                     hGaSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getGroupAssignSource", hObject));
                     
                     if (_not(hGaSource.isValid()))
                     {
                        /* {get Prop var [handle]} */
                        lHidden.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getGroupAssignHidden", hObject));
                        
                        if (_not(lHidden))
                        {
                           returnNormal(true);
                        }
                     }
                  }
               }
            }
         }));
         
         /* {get Prop var [handle]} */
         cChildSdos.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataTargets", hObject));
         
         IntegerExpression resExpr56 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cChildSdos);
            }
         };
         ToClause toClause58 = new ToClause(iChild, 1, resExpr56);
         
         doTo("loopLabel84", toClause58, new Block((Body) () -> 
         {
            cObject.assign(entry(iChild, cHandle));
            hObject.assign(handle.fromString(cObject));
            
            if ((new logical( /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "hasActiveTargets", targetProcedure(), "I", hObject))).booleanValue())
            {
               returnNormal(true);
            }
         }));
         
         returnNormal(false);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical hasForeignKeyChanged()
   {
      /*------------------------------------------------------------------------------
        Purpose: Returns true if the dataSource Foreignfields are different 
                 from the current ForeignValues  
          Notes: DataAvailable has a 'RESET' mode that indicates that the query only 
                 should be opened if necessary. This function is an imporetant part of 
                 that logic. If it returns TRUE the query need to be reopened.  
              -  Uncommitted values are currently not considered to be a change, so 
                 the DataSource's before-image values is checked if 
                 RowObjectState = 'ROwUpdated'.
      Note date: 2002/02/01            
      -----------------------------------------------------------------------------*/
      character cForeignFields = TypeFactory.character();
      character cCurrentValues = TypeFactory.character();
      character cParentValues = TypeFactory.character();
      character cSourceFields = TypeFactory.character();
      integer iField = TypeFactory.integer();
      handle hField = TypeFactory.handle();
      handle hDataSource = TypeFactory.handle();
      character cRowObjectState = TypeFactory.character();
      handle hRowObjUpd = TypeFactory.handle();
      handle hRowObject = TypeFactory.handle();
      logical lNew = TypeFactory.logical();
      
      return function("hasForeignKeyChanged", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignFields"));
         cForeignFields.assign(ghProp.unwrapBufferField().value());
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ForeignValues"));
         cCurrentValues.assign(ghProp.unwrapBufferField().value());
         /* {get Prop var [handle]} */ 
         hDataSource.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", targetProcedure()));
         
         if (_not(hDataSource.isValid()))
         {
            returnNormal(false);
         }
         
         loopLabel85:
         for (iField.assign(1); _isLessThanOrEqual(iField, numEntries(cForeignFields)); iField.assign(plus(iField, 2)))
         {
            /* 2nd of pair is source RowObject fld */
            cSourceFields.assign(concat(cSourceFields, (_isEqual(iField, 1) ? new character("") : new character(",")), entry(plus(iField, 1), cForeignFields)));
         }
         
         /* If the DataSource has uncommitted changes, check the before image of the 
             data source (This is admittedly somewhat dirty, but we do not want an API 
             yet...) 
             The intention here is to ensure that this function returns true
             if the parent really is pointing to a different record, but returns 
             false if we still are on the original parent, disregarding changed 
             keyvalues, we also want to disregard uncommitted new records */
         /* {get Prop var [handle]} */
         cRowObjectState.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getRowObjectState", hDataSource));
         
         if (_isEqual(cRowObjectState, "RowUpdated"))
         {
            /* New uncommitted does not constitute a change, but would fail the check 
                  below */
            /* {get Prop var [handle]} */ 
            lNew.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getNewRow", targetProcedure()));
            
            if ((lNew).booleanValue())
            {
               returnNormal(false);
            }
            
            /* {get Prop var [handle]} */
            hRowObject.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObject", hDataSource));
            /* {get Prop var [handle]} */
            hRowObjUpd.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjUpd", hDataSource));
            
            /* find the corresponding rowObjUpd -- (really synchronize the buffers) 
                  Check the before image values and RETURN this finding. 
                 if no RowObjUpd record is available then the current parent has not 
                 changed and we will use the general logic below   */
            if ((new logical(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "findRowObjUpd", hDataSource, "II", hRowObject, hRowObjUpd))).booleanValue())
            {
               loopLabel86:
               for (iField.assign(1); _isLessThanOrEqual(iField, numEntries(cSourceFields)); iField.increment())
               {
                  hField.assign(hRowObjUpd.unwrapBuffer().bufferField(entry(iField, cSourceFields)));
                  cParentValues.assign(concat(cParentValues, ",", hField.unwrapBufferField().value()));
               }
               
               cParentValues.assign(leftTrim(cParentValues, ","));
               /* Return immediately */
               returnNormal(isNotEqual(cParentValues, cCurrentValues));
            }
         }
         silent(() -> cParentValues /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "colValues", hDataSource, "I", cSourceFields)));
         /* Throw away the RowIdent entry returned by colValues*/
         cParentValues.replaceEntry(1, chr(1), "");
         /* Remove the chr(1).. DON'T TRIM it may cause a problem if the first 
               value(s) in the list is blank */
         cParentValues.assign(substring(cParentValues, 2));
         returnNormal(isNotEqual(cParentValues, cCurrentValues));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character initDataObjectOrdering()
   {
      /*------------------------------------------------------------------------------
        Purpose:  Adjust the "DataOrdering" and "UpdateTables" properties for SBOs
                  that contain dynamic SDOs.
          Notes:  This version of the function is called from 'initializeObject' 
                  to accomodate the late RowObjUpd table creation of dynamic SDOs
      ------------------------------------------------------------------------------*/
      character cOrdering = TypeFactory.character("");
      integer iCount = TypeFactory.integer();
      integer iEntry = TypeFactory.integer();
      character cTableList = TypeFactory.character();
      handle hRou = TypeFactory.handle();
      character cDolist = TypeFactory.character();
      handle hDo = TypeFactory.handle();
      character cObjectName = TypeFactory.character();
      
      return function("initDataObjectOrdering", character.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cDolist.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr57 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cDolist);
            }
         };
         ToClause toClause59 = new ToClause(iCount, 1, resExpr57);
         
         doTo("loopLabel87", toClause59, new Block((Body) () -> 
         {
            hDo.assign(handle.fromString(entry(iCount, cDolist)));
            cObjectName /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(character.class, "getObjectName", hDo));
            cOrdering.assign(concat(cOrdering, (_isEqual(cOrdering, "") ? new character("") : new character(",")), valueOf(iCount)));
            /* A valid RowObjUpd table may not exist yet (ie passed as external  
                     or not created yet), so insert a placeholder  which will be replaced  
                     with the actual table handle when it's known */
            cTableList.assign(concat(cTableList, (_isEqual(cTableList, "") ? new character("") : new character(",")), cObjectName));
            
            /* placeholder */
            if ((hDo.isValid()).booleanValue())
            {
               /* {get Prop var [handle]} */
               hRou.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObjUpdTable", hDo));
               
               if ((hRou.isValid()).booleanValue())
               {
                  iEntry.assign(lookup(cObjectName, cTableList));
                  
                  if (_isGreaterThan(iEntry, 0))
                  {
                     cTableList.replaceEntry(iEntry, valueOf(hRou));
                  }
               }
            }
         }));
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("UpdateTables"));
         ghProp.unwrapBufferField().changeValue(cTableList);
         returnNormal(cOrdering);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical isColumnListQualified(final character _pcColumnNames_1)
   {
      character pcColumnNames_1 = TypeFactory.initInput(_pcColumnNames_1);
      /*------------------------------------------------------------------------------
        Purpose:  
          Notes:  
      ------------------------------------------------------------------------------*/
      integer iCount = TypeFactory.integer();
      
      return function("IsColumnListQualified", logical.class, new Block((Body) () -> 
      {
         /* At least the first column MUST be qualified */
         if (_isLessThanOrEqual(numEntries(entry(1, pcColumnNames_1), "."), 1))
         {
            returnNormal(false);
         }
         
         /* Either ALL columns must be individually qualified with the SDO name or */
         /* NONE (except the first one, of course) */
         iCount.assign(numEntries(pcColumnNames_1, "."));
         
         /* more than one cols are qualified ...*/
         if (_and(isGreaterThan(iCount, 2), () /* more than one cols are qualified ...*/ -> isNotEqual(iCount, plus(numEntries(pcColumnNames_1), 1))) /* ... but not ALL */)
         {
            returnNormal(false);
         }
         
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character newDataObjectRow(final character _pcMode_1, final character _pcTargetNames_1, final character _pcViewColList_3)
   {
      character pcMode_1 = TypeFactory.initInput(_pcMode_1);
      character pcTargetNames_1 = TypeFactory.initInput(_pcTargetNames_1);
      character pcViewColList_3 = TypeFactory.initInput(_pcViewColList_3);
      /*------------------------------------------------------------------------------
        Purpose: Set one or more the SDOs in New (copy or add) mode.  
        Purpose: Returns a chr(1) separated list of RowIdent(s) (separated with 
                 semicolon for each object) and values corresponding to the passed 
                 list.  
         Params:  pcObjectNames 
                            - List of object names to set in add/copy mode  
                  pcViewColList 
                            - List of columns qualifed with ObjectName or unqualified.
                  pcMode    = Add / Copy                 
         Notes:  Columns must match the objects and be qualified with the correct object 
                 name if they are qualified.
                 Called from addRow and copyRow.   
      ------------------------------------------------------------------------------*/
      integer iEntry = TypeFactory.integer();
      handle hTarget = TypeFactory.handle();
      character cObjectName = TypeFactory.character();
      character cRowids = TypeFactory.character();
      character cValueList = TypeFactory.character();
      character cColumn = TypeFactory.character();
      integer iColumn = TypeFactory.integer();
      character cValue = TypeFactory.character();
      character cObjectNames = TypeFactory.character();
      logical lError = TypeFactory.logical();
      character cFunction = TypeFactory.character();
      logical lOne2One = TypeFactory.logical();
      handle hQuery = TypeFactory.handle();
      handle hRow = TypeFactory.handle();
      character cExpandedTargetNames = TypeFactory.character();
      integer iCount = TypeFactory.integer();
      handle hEntry = TypeFactory.handle();
      character cEntry = TypeFactory.character();
      
      return function("newDataObjectRow", character.class, new Block((Body) () -> 
      {
         if (_not(matchesList("Add,Copy", pcMode_1)))
         {
            /* {fnarg <func-name> <arg> [handle] */ 
            messageBox(substitute(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 58), new character("newDataObjectRow()"), pcMode_1), ALERT_INFO, BTN_OK, (String) null);
            returnNormal(new character());
         }
         
         cFunction.assign(concat(pcMode_1, "Row"));
         cExpandedTargetNames.assign(pcTargetNames_1);
         
         IntegerExpression resExpr58 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(pcTargetNames_1);
            }
         };
         ToClause toClause60 = new ToClause(iCount, 1, resExpr58);
         
         doTo("loopLabel88", toClause60, new Block((Body) () -> 
         {
            cEntry.assign(entry(iCount, pcTargetNames_1));
            hEntry /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "DataObjectHandle", targetProcedure(), "I", cEntry));
            
            /* ...if the Update Target is already in our expanded list, skip it... */
            if (_isGreaterThan(lookup(cEntry, cExpandedTargetNames), 0))
            {
               next("loopLabel88");
            }
            else
            {
               LogicalOp whileClause3 = () -> new logical( /* {fn <func-name> [handle] */ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUpdateFromSource", hEntry));
               
               repeatWhile("loopLabel89", whileClause3, new Block((Body) () -> 
               {
                  hEntry /* {fn <func-name> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataSource", hEntry));
               }));
            }
            /* ...otherwise get to the top of the 1-to-1 chain... */
            
            /* ...then get any 1-to-1 siblings of this UpdateTarget (multi-level)*/
            cExpandedTargetNames.assign(concat(cExpandedTargetNames, (_isEqual(cExpandedTargetNames, "") ? new character("") : new character(",")), getUpdateSiblings(hEntry)));
         }));
         
         pcTargetNames_1.assign(cExpandedTargetNames);
         /* We add in the SBOs object order, this also enablkes us to return the rowident 
             in submitRow order */
         /* {get Prop var [handle]} */ 
         cObjectNames.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectNames", targetProcedure()));
         
         IntegerExpression resExpr59 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cObjectNames);
            }
         };
         ToClause toClause61 = new ToClause(iEntry, 1, resExpr59);
         
         doTo("loopLabel90", toClause61, new Block((Body) () -> 
         {
            cObjectName.assign(entry(iEntry, cObjectNames));
            
            /* Is this an updateTarget  */
            if ((matchesList(pcTargetNames_1, cObjectName)).booleanValue())
            {
               hTarget /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "DataObjectHandle", targetProcedure(), "I", cObjectName));
               
               if ((hTarget.isValid()).booleanValue())
               {
                  /* {get Prop var [handle]} */
                  hRow.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getRowObject", hTarget));
                  
                  if (_not(hRow.unwrapBuffer().available()))
                  {
                     /* {get Prop var [handle]} */
                     hQuery.assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "getDataHandle", hTarget));
                     
                     if ((hQuery.unwrapQuery().isOpen()).booleanValue())
                     {
                        /* {get Prop var [handle]} */
                        lOne2One.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getUpdateFromSource", hTarget));
                        
                        /* check for 1to1 */
                        if ((lOne2One).booleanValue())
                        {
                           /* {fn <func-name> [handle] */
                           ControlFlowOps.invokeInWithMode("addMessage", targetProcedure(), "III",  /* {fnarg <func-name> <arg> [handle] */ ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 73), new unknown(), ControlFlowOps.invokeDynamicFunctionIn(character.class, "getTables", hTarget));
                           returnNormal(new character());
                        }
                     }
 /* ... and the query is open */;
                  }
 /* no RowObject record... */;
               }
            }
         }));
         
         /* If we are in a 1-to-1 situation all involved SDOs should be treated as one. */
         /* Therefore block individual 'dataAvailable' and 'queryPosition' messages from */
         /* SDOs participating in the 1-to-1 relationship */
         if (_isGreaterThan(numEntries(pcTargetNames_1), 1))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("BlockDataAvailable"));
            ghProp.unwrapBufferField().changeValue(new logical(true));
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("BlockQueryPosition"));
            ghProp.unwrapBufferField().changeValue(new logical(true));
         }
         
         cRowids.assign(fill(";", minus(numEntries(cObjectNames), 1)));
         
         IntegerExpression resExpr60 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cObjectNames);
            }
         };
         ToClause toClause62 = new ToClause(iEntry, 1, resExpr60);
         
         doTo("loopLabel91", toClause62, new Block((Body) () -> 
         {
            cObjectName.assign(entry(iEntry, cObjectNames));
            
            /* Is this an updateTarget  */
            if ((matchesList(pcTargetNames_1, cObjectName)).booleanValue())
            {
               hTarget /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "DataObjectHandle", targetProcedure(), "I", cObjectName));
               
               if (_not(hTarget.isValid()))
               {
                  lError.assign(true);
                  leave("loopLabel91");
               }
               
               cRowids.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(cFunction, hTarget, "I", ""));
               cValueList.assign(concat(cValueList, (_isEqual(iEntry, 1) ? new character("") : new character(";")), entry(1, cRowids)));
            }
            else
            {
               cValueList.assign(concat(cValueList, (_isEqual(iEntry, 1) ? new character("") : new character(";")), "?"));
            }
         }));
         
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("BlockDataAvailable"));
         ghProp.unwrapBufferField().changeValue(new logical(false));
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("BlockQueryPosition"));
         ghProp.unwrapBufferField().changeValue(new logical(false));
         
         if ((lError).booleanValue())
         {
            returnNormal(new character());
         }
         
         IntegerExpression resExpr61 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(pcViewColList_3);
            }
         };
         ToClause toClause63 = new ToClause(iColumn, 1, resExpr61);
         
         doTo("loopLabel92", toClause63, new Block((Body) () -> 
         {
            cColumn.assign(entry(iColumn, pcViewColList_3));
            cObjectName.assign(entry(1, cColumn, "."));
            cColumn.assign(entry(2, cColumn, "."));
            hTarget /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "DataObjectHandle", targetProcedure(), "I", cObjectName));
            cValue /* {fnarg <func-name> <arg> [handle] */.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "columnValue", hTarget, "I", cColumn));
            cValueList.assign(concat(cValueList, chr(1), (_notUnknown(cValue) ? cValue : new character("?"))));
         }));
         
         /* do iColumn = 1 to */
         /* We need to ensure that potential GroupAssigntargets also get the new record
              so we cannot just run in requester. We cannot publish from SDOs either here
              because then add mode will be lost in datatargets if more than one is in addmode */
         NamedEventManager.publish("dataAvailable", targetProcedure(), "I", new Object[]
         {
            "DIFFERENT"
         });
         returnNormal(cValueList);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public character obtainContextForClient()
   {
      /*------------------------------------------------------------------------------
        Purpose: Obtain context properties to return to the client after or as part 
                 of a server request.   
          Notes: See containr.p 
               - Overridden because:
                 - a data request also can be save/commit which is identified with 
                   RowObjUpdTable:has-records.
                 - Does not currently use Deep in containedProperties 
                   (this does not really matter since an SBO does not have other
                    containers.) 
      Note date: 2002/02/12                
      ------------------------------------------------------------------------------*/
      logical lFirst = TypeFactory.logical();
      character cPropRequest = TypeFactory.character();
      
      return function("obtainContextForClient", character.class, new Block((Body) () -> 
      {
         /* This is passed from the client to identify the first call */
         /* {get Prop var [handle]} */ 
         lFirst.assign(ControlFlowOps.invokeDynamicFunctionIn(logical.class, "getServerFirstCall", targetProcedure()));
         
         if ((lFirst).booleanValue())
         {
            /* ServerFirstCall need to be false if state-aware 
                   (We also return it to the client as a handshake that the first call has 
                    completed) */
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setServerFirstCall", targetProcedure(), "I", false);
            /* Property from this SBO instance */
            cPropRequest.assign("THIS;ServerOperatingMode,ServerFirstCall;SmartDataObject;OpenQuery,DBNames,IndexInformation,KeyFields,KeyTableID,EntityFields");
         }
         
         /* First */
         cPropRequest.assign(concat(((lFirst).booleanValue() ? concat(cPropRequest, ",") : new character("")), "FirstResultRow,LastResultRow,FirstRowNum,LastRowNum,QueryWhere,QueryRowident,ForeignValues,PositionForClient"));
         
         if (_isEqual(LogicalTerminal.getClientType(), "WEBSPEED"))
         {
            cPropRequest.assign(concat(cPropRequest, ",QueryColumns"));
         }
         
         returnNormal(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "containedProperties", targetProcedure(), "II", cPropRequest, false));
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical openQuery()
   {
      /*------------------------------------------------------------------------------
        Purpose:  This is just a wrapper for fetchContainedData, to allow the
                  familiar SDO calling pattern to be used.
         Params:  <none>
      ------------------------------------------------------------------------------*/
      handle hDataContainer = TypeFactory.handle();
      character cObjectName = TypeFactory.character();
      logical lok = TypeFactory.logical();
      
      return function("openQuery", logical.class, new Block((Body) () -> 
      {
         /* can we use a data container */
         hDataContainer /* {fn <func-name> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionIn(handle.class, "dataContainerHandle", targetProcedure()));
         
         if ((hDataContainer.isValid()).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ObjectName"));
            cObjectName.assign(ghProp.unwrapBufferField().value());
            ControlFlowOps.invokeInWithMode("fetchContainedData", hDataContainer, "I", cObjectName);
            lok.assign(isNotEqual(ControlFlowOps.getReturnValue(), "adm-error"));
         }
         else
         {
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setBindScope", targetProcedure(), "I", "data");
            ControlFlowOps.invokeInWithMode("fetchContainedData", targetProcedure(), "I", new unknown());
            lok.assign(isNotEqual(ControlFlowOps.getReturnValue(), "adm-error"));
            /* Just in case nothing happened make sure the bindscope is blank */
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setBindScope", targetProcedure(), "I", "");
         }
         
         returnNormal(lok);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical removeQuerySelection(final character _pcColumns_4, final character _pcOperators_3)
   {
      character pcColumns_4 = TypeFactory.initInput(_pcColumns_4);
      character pcOperators_3 = TypeFactory.initInput(_pcOperators_3);
      /*------------------------------------------------------------------------------
        Purpose:  SBO version of this where-clause function, which separates the
                  Columns by SDO and passes columns and operators on to
                  the appropriate SDO(s).
         Params:  pcColumns   AS CHAR,
                  pcOperators AS CHAR 
                  -- both as for the query.p removeQuerySelection function
          Notes:  All columns must be qualified by their SDO Objectname as TableName;
                  this will be replaced with RowObject when the columns are passed
                  on to the SDO.
      ------------------------------------------------------------------------------*/
      integer iColumn = TypeFactory.integer();
      character cCols = TypeFactory.character("");
      character cOps = TypeFactory.character("");
      character cObjectNames = TypeFactory.character();
      character cColumn = TypeFactory.character();
      integer iName = TypeFactory.integer();
      character cString = TypeFactory.character();
      logical lSuccess = TypeFactory.logical();
      handle hObject = TypeFactory.handle();
      
      return function("removeQuerySelection", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cObjectNames.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectNames", targetProcedure()));
         
         loopLabel93:
         for (iColumn.assign(1); _isLessThanOrEqual(iColumn, numEntries(cObjectNames)); iColumn.increment())
         {
            /* Initialize these to hold the cols, values, and ops for each SDO. 
                     Use a delimiter of CHR(2) between groups for each SDO. */
            cCols.assign(concat(cCols, (_isEqual(iColumn, 1) ? new character("") : chr(2))));
         }
         
         /* END DO iColumn -- initialization of delimiters */
         /* If the request specified an operator per column, then initialize
              accordingly; otherwise just store the one entry passed in to us. */
         if (_isGreaterThan(numEntries(pcOperators_3), 1))
         {
            cOps.assign(cCols);
         }
         else
         {
            cOps.assign(pcOperators_3);
         }
         
         loopLabel94:
         for (iColumn.assign(1); _isLessThanOrEqual(iColumn, numEntries(pcColumns_4)); iColumn.increment())
         {
            cColumn.assign(entry(iColumn, pcColumns_4));
            
            if (_isNotEqual(numEntries(cColumn, "."), 2))
            {
               returnNormal(false);
            }
            
            /* Must be qualified by ObjectName */
            iName.assign(lookup(entry(1, cColumn, "."), cObjectNames));
            
            if (_isEqual(iName, 0))
            {
               returnNormal(false);
            }
            
            cString.assign(entry(iName, cCols, chr(2)));
            cString.assign(concat(cString, (_isEqual(cString, "") ? new character("") : new character(",")), "RowObject.", entry(2, cColumn, ".")));
            cCols.replaceEntry(iName, chr(2), cString);
            
            /* Now put the operator in its list, unless there's only one
                      (or none) for the whole list). */
            if (_isGreaterThan(numEntries(pcOperators_3), 1))
            {
               cString.assign(entry(iName, cOps, chr(2)));
               cString.assign(concat(cString, (_isEqual(cString, "") ? new character("") : new character(",")), entry(iColumn, pcOperators_3)));
               cOps.replaceEntry(iName, chr(2), cString);
            }
         }
         
         IntegerExpression resExpr62 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cObjectNames);
            }
         };
         ToClause toClause64 = new ToClause(iName, 1, resExpr62);
         
         doTo("loopLabel95", toClause64, new Block((Body) () -> 
         {
            cColumn.assign(entry(iName, cCols, chr(2)));
            
            if (_isNotEqual(cColumn, ""))
            {
               hObject.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", entry(iName, cObjectNames)));
               lSuccess.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "removeQuerySelection", hObject, "II", entry(iName, cCols, chr(2)), _isLessThanOrEqual(numEntries(pcOperators_3), 1) ? pcOperators_3 : entry(iName, cOps, chr(2))));
               
               if (_not(lSuccess))
               {
                  returnNormal(false);
               }
            }
         }));
         
         /* END DO iName */
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical repositionRowObject(final character _pcRowIdent_4)
   {
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      integer iDo = TypeFactory.integer();
      character cRowIdent = TypeFactory.character();
      handle hDataObject = TypeFactory.handle();
      character cObjectHandles = TypeFactory.character();
      
      return function("repositionRowObject", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cObjectHandles.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr63 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cObjectHandles);
            }
         };
         ToClause toClause65 = new ToClause(iDo, 1, resExpr63);
         
         doTo("loopLabel96", toClause65, new Block((Body) () -> 
         {
            cRowIdent.assign(entry(iDo, pcRowIdent_4, ";"));
            
            /* we also sort unavailable rowident '?', probably not necessary, but   */
            if (_and(isNotEqual(cRowIdent, ""), () -> isNotEqual(cRowIdent, "?")))
            {
               hDataObject.assign(handle.fromString(entry(iDo, cObjectHandles)));
               
               if ((hDataObject.isValid()).booleanValue())
               {
                  if (_not(new logical( /* {fnarg <func-name> <arg> [handle] */ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "repositionRowObject", hDataObject, "I", cRowIdent))))
                  {
                     returnNormal(false);
                  }
               }
            }
         }));
         
         /* do i to num-entries(objects) - 1 */
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical resetQuery(final character _pcObject_2)
   {
      character pcObject_2 = TypeFactory.initInput(_pcObject_2);
      /*------------------------------------------------------------------------------
        Purpose:  Resets the Query for all Contained SDOs, or if the pcObject
                  parameter is specified, for that one SDO, to its original state
         Params:  pcObject AS CHARACTER -- SDO ObjectName
          Notes:  This function is here because setQueryWhere is not supported for
                  SBOs, and running setQueryWhere('') would be the way to do it
                  otherwise.
      ------------------------------------------------------------------------------*/
      character cContained = TypeFactory.character();
      handle hObject = TypeFactory.handle();
      integer iObject = TypeFactory.integer();
      
      return function("resetQuery", logical.class, new Block((Body) () -> 
      {
         if (_or(isEqual(pcObject_2, ""), () -> isUnknown(pcObject_2)))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
            cContained.assign(ghProp.unwrapBufferField().value());
            
            IntegerExpression resExpr64 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(cContained);
               }
            };
            ToClause toClause66 = new ToClause(iObject, 1, resExpr64);
            
            doTo("loopLabel97", toClause66, new Block((Body) () -> 
            {
               hObject.assign(handle.fromString(entry(iObject, cContained)));
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryWhere", hObject, "I", "");
            }));
         }
         else
         {
            hObject.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "dataObjectHandle", targetProcedure(), "I", pcObject_2));
            
            if ((hObject.isValid()).booleanValue())
            {
               ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setQueryWhere", hObject, "I", "");
            }
            else
            {
               returnNormal(false);
            }
         }
         /* END ELSE DO IF pcObject specified. */
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical resetRow(final character _pcRowIdent_4)
   {
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      integer iDo = TypeFactory.integer();
      character cRowIdent = TypeFactory.character();
      handle hDataObject = TypeFactory.handle();
      character cObjectHandles = TypeFactory.character();
      
      return function("resetRow", logical.class, new Block((Body) () -> 
      {
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("ContainedDataObjects"));
         cObjectHandles.assign(ghProp.unwrapBufferField().value());
         
         IntegerExpression resExpr65 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(cObjectHandles);
            }
         };
         ToClause toClause67 = new ToClause(iDo, 1, resExpr65);
         
         doTo("loopLabel98", toClause67, new Block((Body) () -> 
         {
            cRowIdent.assign(entry(iDo, pcRowIdent_4, ";"));
            cRowIdent.assign(_isEqual(cRowIdent, "?") ? new character() : cRowIdent);
            
            /* we also sort unavailable rowident '?', probably not necessary, but   */
            if (_isNotEqual(cRowIdent, ""))
            {
               hDataObject.assign(handle.fromString(entry(iDo, cObjectHandles)));
               
               if ((hDataObject.isValid()).booleanValue())
               {
                  /* {fnarg <func-name> <arg> [handle] */
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "resetRow", hDataObject, "I", cRowIdent);
               }
            }
         }));
         
         /* do i to num-entries(objects) - 1 */
         returnNormal(true);
      }));
   }

   /**
    * _UIB-CODE-BLOCK-END
    */
   public logical submitRow(final character _pcRowIdent_4, final character _pcValueList_1)
   {
      character pcRowIdent_4 = TypeFactory.initInput(_pcRowIdent_4);
      character pcValueList_1 = TypeFactory.initInput(_pcValueList_1);
      /*------------------------------------------------------------------------------
        Purpose:     Accepts a list of changed values for a row and passes them
                     on to the SDOs from which they came.
        Parameters:
          INPUT pcRowIdent  - "key" with RowObject rowid to update, plus a list of 
                              the ROWID(s) of the db record(s) the RowObject is 
                              derived from.
          INPUT pcValueList - CHR(1) delimited list of alternating column names 
                              and values to be assigned.             
      ------------------------------------------------------------------------------*/
      integer iSdo = TypeFactory.integer();
      handle hSdo = TypeFactory.handle();
      logical lSuccess = TypeFactory.logical();
      character[] cValueList = TypeFactory.characterExtent(20);
      integer iCol = TypeFactory.integer();
      character cColumn = TypeFactory.character();
      character cObjectName = TypeFactory.character();
      logical lAutoCommit = TypeFactory.logical();
      character cRowIdent = TypeFactory.character();
      character cObjectNames = TypeFactory.character();
      
      return function("submitRow", logical.class, new Block((Body) () -> 
      {
         /* {get Prop var [handle]} */ 
         cObjectNames.assign(ControlFlowOps.invokeDynamicFunctionIn("getDataObjectNames", targetProcedure()));
         
         /* If trim('') removes all then we have only ONE rowid */
         if (_isEqual(numEntries(trim(pcRowIdent_4, ";"), ";"), 1))
         {
            /* If one target and the columns are qualified, remove the qualifier.*/
            if (_isEqual(numEntries(entry(1, pcValueList_1, chr(1)), "."), 2))
            {
               loopLabel99:
               for (iCol.assign(1); _isLessThanOrEqual(iCol, numEntries(pcValueList_1, chr(1))); iCol.assign(plus(iCol, 2)))
               {
                  cColumn.assign(entry(iCol, pcValueList_1, chr(1)));
                  cColumn.assign(entry(2, cColumn, "."));
                  pcValueList_1.replaceEntry(iCol, chr(1), cColumn);
               }
            }
         }
         else
         {
            IntegerExpression resExpr66 = new IntegerExpression()
            {
               public integer execute()
               {
                  return numEntries(pcValueList_1, chr(1));
               }
            };
            ToClause toClause68 = new ToClause(iCol, 1, resExpr66, new integer(2));
            
            doTo("loopLabel100", toClause68, new Block((Body) () -> 
            {
               cColumn.assign(entry(iCol, pcValueList_1, chr(1)));
               silent(() -> 
               {
                  cObjectName.assign(entry(1, cColumn, "."));
                  iSdo.assign(lookup(cObjectName, cObjectNames));
                  cColumn.assign(entry(2, cColumn, "."));
               });
               
               if (_isGreaterThan(iSdo, 0))
               {
                  /* Found a match. Add the name/value pair to the list for that SDO. */
                  assignSingle(cValueList, iSdo, concat(subscript(cValueList, iSdo), (_isNotEqual(subscript(cValueList, iSdo), "") ? chr(1) : new character("")), cColumn, chr(1), entry(plus(iCol, 1), pcValueList_1, chr(1))));
               }
               else
               {
                  /* {fnarg <func-name> <arg> [handle] */ 
                  ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "showMessage", targetProcedure(), "I", substitute(ControlFlowOps.invokeDynamicFunctionInWithMode(character.class, "messageNumber", targetProcedure(), "I", 74), concat(cObjectName, ".", cColumn), cObjectName));
                  returnNormal(false);
               }
            }));
         }
         ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
         ghProp.assign(ghProp.unwrapBuffer().bufferField("AutoCommit"));
         lAutoCommit.assign(ghProp.unwrapBufferField().value());
         
         /* if autocommit commitTransaction will run dataavailable in targets 
              so just block outgoing */
         /* setting 'BlockDataAvailable=TRUE' here is probably not needed since all */
         /* child SDOs have 'Autocommit=FALSE', so no 'commitTransaction' will happen there */
         if ((lAutoCommit).booleanValue())
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("BlockDataAvailable"));
            ghProp.unwrapBufferField().changeValue(new logical(true));
         }
         /* {set Prop value [handle]} */ 
         
         IntegerExpression resExpr67 = new IntegerExpression()
         {
            public integer execute()
            {
               return numEntries(pcRowIdent_4, ";");
            }
         };
         ToClause toClause69 = new ToClause(iSdo, 1, resExpr67);
         
         doTo("loopLabel101", toClause69, new Block((Body) () -> 
         {
            cRowIdent.assign(entry(iSdo, pcRowIdent_4, ";"));
            
            if (_isNotEqual(cRowIdent, ""))
            {
               cObjectName.assign(entry(iSdo, cObjectNames));
               hSdo /* {fnarg <func-name> <arg> [handle] */ .assign(ControlFlowOps.invokeDynamicFunctionInWithMode(handle.class, "DataObjectHandle", targetProcedure(), "I", cObjectName));
               
               if (_not(hSdo.isValid()))
               {
                  if (_isEqual(lAutoCommit, true))
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("BlockDataAvailable"));
                     ghProp.unwrapBufferField().changeValue(new logical(false));
                  }
                  /* {set Prop value [handle]} */ 
                  
                  returnNormal(false);
               }
               
               /* If one target the data are still in the input parameter 
                        (qualifiers were removed further up)*/
               if (_isEqual(numEntries(trim(pcRowIdent_4, ";"), ";"), 1))
               {
                  lSuccess.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "submitRow", hSdo, "II", cRowIdent, pcValueList_1));
                  leave("loopLabel101");
               }
               else
               {
                  /* Multiple targets */
                  if (_isNotEqual(cRowIdent, "?"))
                  {
                     lSuccess.assign(ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "submitRow", hSdo, "II", cRowIdent, subscript(cValueList, iSdo)));
                  }
                  
                  if (_isEqual(lAutoCommit, true))
                  {
                     ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
                     ghProp.assign(ghProp.unwrapBuffer().bufferField("BlockDataAvailable"));
                     ghProp.unwrapBufferField().changeValue(new logical(false));
                  }
                  /* {set Prop value [handle]} */ 
                  
                  if (_not(lSuccess))
                  {
                     returnNormal(false);
                  }
               }
            }
         }));
         
         /* do iSDO  */
         /* We disabled outgoing messages while updating if autocommit so set 
              it back */
         if (_isEqual(lAutoCommit, true))
         {
            ghProp.assign(handle.fromString(entry(1, targetProcedure().unwrapADMData().getADMData(), chr(1))));
            ghProp.assign(ghProp.unwrapBuffer().bufferField("BlockDataAvailable"));
            ghProp.unwrapBufferField().changeValue(new logical(false));
         }
         /* {set Prop value [handle]} */ 
         
         if (_not(lSuccess))
         {
            returnNormal(false);
         }
         
         if (_isEqual(lAutoCommit, true))
         {
            ControlFlowOps.invokeIn("commitTransaction", targetProcedure());
            returnNormal(isNotEqual(ControlFlowOps.getReturnValue(), "ADM-ERROR"));
         }
         else
         {
            /* {set Prop value [handle]} */ 
            ControlFlowOps.invokeDynamicFunctionInWithMode(logical.class, "setRowObjectState", targetProcedure(), "I", "RowUpdated");
         }
         /* if there's no Commit-Source the changes will be committed now. */
         
         returnNormal(lSuccess);
      }));
   }

   public character fwdGetAdmversion()
   {
      return function("fwdGetADMVersion", character.class, new Block((Body) () -> 
      {
         returnNormal("ADM2.2");
      }));
   }
}
